/****************************************************************************** 
 * Job:           ACC_DEF_EVENT_CURR_LKP                    A5V75JN3.BN0001JM * 
 * Description:                                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: TIME_DIM - dim.TIME_DIM                   A5V75JN3.BE0000LU * 
 *                ACC_DEF_EVENT_CURR_EXT -                  A5V75JN3.BE0001JL * 
 *                 abtscr.ACC_DEF_EVENT_CURR_EXT                              * 
 *                TIME_DIM - dim.TIME_DIM                   A5V75JN3.BE0000LU * 
 * Target Table:  ACC_DEF_EVENT_CURR_LKP -                  A5V75JN3.BE0001JM * 
 *                 abtscr.ACC_DEF_EVENT_CURR_LKP                              * 
 *                                                                            * 
 * Generated on:  Tuesday, December 16, 2008 12:27:47 PM GMT+05:30            * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_DEF_EVENT_CURR_LKP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Join with time dimension on               A5V75JN3.BO0001JN * 
 *                 LOAD_ABT_USER_INPUT_DATE                                   * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Join with time dimension to derive variables like           * 
 *                BACK_3M_TIME_SK, BACK_6M_TIME_SK based on                   * 
 *                 LOAD_ABT_USER_INPUT_DATE.                                  * 
 *                                                                            * 
 * Source Tables: ACC_DEF_EVENT_CURR_EXT -                  A5V75JN3.BE0001JL * 
 *                 abtscr.ACC_DEF_EVENT_CURR_EXT                              * 
 *                TIME_DIM - dim.TIME_DIM                   A5V75JN3.BE0000LU * 
 * Target Table:  SQL Target -                              A5V75JN3.BP0001JM * 
 *                 abtscr.ACC_DEF_EVENT_CURR_LKP_TMP1                         * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_DEF_EVENT_CURR_LKP_TMP1;
quit;

proc sql;
   create table abtscr.ACC_DEF_EVENT_CURR_LKP_TMP1 as
      select
         ACC_DEF_EVENT_CURR_EXT.ACCOUNT_RK length = 8
                                           format = 12.
                                           informat = 12.
                                           label = "_RKorSK",
         ACC_DEF_EVENT_CURR_EXT.DEFAULT_DT length = 8
                                           label = "_DT",
         ACC_DEF_EVENT_CURR_EXT.EXPOSURE_AT_DEFAULT_AMT length = 8
                                                        format = NLNUM18.5
                                                        informat = NLNUM18.5
                                                        label = "_AMT",
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_USER_INPUT_DTTM length = 8
                                                         format = NLDATM21.
                                                         informat = NLDATM21.,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_USER_INPUT_DATE length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_12M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_12M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_24M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_24M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_3M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_3M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_6M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_6M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_EXT.OUTCOME_START_DTTM length = 8,
         ACC_DEF_EVENT_CURR_EXT.OUTCOME_END_DTTM length = 8,
         ACC_DEF_EVENT_CURR_EXT.OUTCOME_START_DATE length = 8,
         ACC_DEF_EVENT_CURR_EXT.OUTCOME_END_DATE length = 8,
         TIME_DIM.TIME_SK - 3 as BACK_3M_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 6 as BACK_6M_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 12 as BACK_12M_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 24 as BACK_24M_TIME_SK length = 8,
         TIME_DIM.TIME_SK as CURR_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 1 as PRV_TIME_SK length = 8
      from
         abtscr.ACC_DEF_EVENT_CURR_EXT, 
         dim.TIME_DIM
      where
         ACC_DEF_EVENT_CURR_EXT.LOAD_ABT_USER_INPUT_DATE = TIME_DIM.CAL_MONTH_FIRST_DT
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Join with time dimension on               A5V75JN3.BO0001JO * 
 *                 OUTCOME_END_DATE                                           * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Join with time dimension to derive variables like           * 
 *                OTE_BACK_3M_TIME_SK, OTE_BACK_3M_TIME_SK based on           * 
 *                 OUTCOME_END_DATE.                                          * 
 *                                                                            * 
 * Source Tables: TIME_DIM - dim.TIME_DIM                   A5V75JN3.BE0000LU * 
 *                SQL Target -                              A5V75JN3.BP0001JM * 
 *                 abtscr.ACC_DEF_EVENT_CURR_LKP_TMP1                         * 
 * Target Table:  SQL Target -                              A5V75JN3.BP0001JN * 
 *                 abtscr.ACC_DEF_EVENT_CURR_LKP                              * 
 *============================================================================*/ 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_DEF_EVENT_CURR_LKP;
quit;

proc sql;
   create table abtscr.ACC_DEF_EVENT_CURR_LKP as
      select
         ACC_DEF_EVENT_CURR_LKP_TMP1.ACCOUNT_RK length = 8
                                                format = 12.
                                                informat = 12.
                                                label = "_RKorSK",
         ACC_DEF_EVENT_CURR_LKP_TMP1.DEFAULT_DT length = 8
                                                label = "_DT",
         ACC_DEF_EVENT_CURR_LKP_TMP1.EXPOSURE_AT_DEFAULT_AMT length = 8
                                                             format = NLNUM18.5
                                                             informat = NLNUM18.5
                                                             label = "_AMT",
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_USER_INPUT_DTTM length = 8
                                                              format = NLDATM21.
                                                              informat = NLDATM21.,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_USER_INPUT_DATE length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_12M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_12M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_24M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_24M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_3M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_3M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_6M_BCK_DTTM length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.LOAD_ABT_6M_BCK_DATE length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.OUTCOME_START_DTTM length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.OUTCOME_END_DTTM length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.OUTCOME_START_DATE length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.OUTCOME_END_DATE length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.BACK_3M_TIME_SK length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.BACK_6M_TIME_SK length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.BACK_12M_TIME_SK length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.BACK_24M_TIME_SK length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.CURR_TIME_SK length = 8,
         ACC_DEF_EVENT_CURR_LKP_TMP1.PRV_TIME_SK length = 8,
         TIME_DIM.TIME_SK as OTE_CURR_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 1 as OTE_BACK_1M_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 2 as OTE_BACK_2M_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 3 as OTE_BACK_3M_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 6 as OTE_BACK_6M_TIME_SK length = 8,
         TIME_DIM.TIME_SK - 12 as OTE_BACK_12M_TIME_SK length = 8
      from
         abtscr.ACC_DEF_EVENT_CURR_LKP_TMP1, 
         dim.TIME_DIM
      where
         ACC_DEF_EVENT_CURR_LKP_TMP1.OUTCOME_END_DATE = TIME_DIM.CAL_MONTH_LAST_DT
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0001JP * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A5V75JN3.BP0001JN * 
 *                 abtscr.ACC_DEF_EVENT_CURR_LKP                              * 
 * Target Table:  ACC_DEF_EVENT_CURR_LKP -                  A5V75JN3.BE0001JM * 
 *                 abtscr.ACC_DEF_EVENT_CURR_LKP                              * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

