/****************************************************************************** 
 * Job:           ACC_DEF_EVENT_X_ACC_DIM                   A5V75JN3.BN0001JN * 
 * Description:                                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  ACCOUNT_DIM - dim.account_dim             A5V75JN3.BE0000LI * 
 * Target Table:  ACC_DEF_EVENT_X_ACC_DIM -                 A5V75JN3.BE0001JN * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                                                                            * 
 * Generated on:  Thursday, December 11, 2008 3:36:49 PM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_DEF_EVENT_X_ACC_DIM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0003ZG * 
 *                                                                            * 
 * User Written:  Globalizing abt_category parameter        A5V75JN3.AF000MBN * 
 *                Globalizing abt_category parameter                          * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

%global abt_category;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          User Written: Join ACCOUNT_DIM with       A5V75JN3.BO0005KU * 
 *                 ACC_DEF_EVENT_CURR_LKP                                     * 
 * Transform:     User Written Code                                           * 
 * Description:   Left Join ACCOUNT_DIM with ACC_DEF_EVENT_CURR_LKP. Pick     * 
 *                the datetime related fields (like                           * 
 *                LOAD_ABT_USER_INPUT_DTTM) from ACC_DEF_EVENT_CURR_LKP if    * 
 *                 account has defaulted, else pick it from ACCOUNT_DIM.      * 
 *                                                                            * 
 * Source Table:  ACCOUNT_DIM - dim.account_dim             A5V75JN3.BE0000LI * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP0004QH * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                                                                            * 
 * User Written:  call the macro decide_code                A5V75JN3.AF000MBM * 
 *                This code extracts account_dim.                             * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(dim.account_dim); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(abtscr.ACC_DEF_EVENT_X_ACC_DIM); 

/*---- Start of User Written Code  ----*/ 

%macro decide_code;

%GLOBAL BACK_3M_TIME_SK BACK_6M_TIME_SK BACK_12M_TIME_SK BACK_24M_TIME_SK CURR_TIME_SK PRV_TIME_SK;
	
/* %LET LOAD_ABT_USER_INPUT_DTTM = '31OCT2006:23:59:59'DT; */

DATA _NULL_;
	IF KLEFT(KRIGHT("&LOAD_ABT_USER_INPUT_DTTM")) EQ '' THEN 
		CALL SYMPUT('LOAD_ABT_USER_INPUT_DTTM','01MAY2005:00:00:00'DT);
RUN;

DATA _NULL_;
	LOAD_ABT_DTTM = &LOAD_ABT_USER_INPUT_DTTM;
	LOAD_ABT_DT = DATEPART(LOAD_ABT_DTTM);
	CALL SYMPUT('LOAD_ABT_USER_INPUT_DATE',LOAD_ABT_DT);
RUN;

%GLOBAL LOAD_ABT_12M_BCK_DTTM LOAD_ABT_12M_BCK_DATE LOAD_ABT_24M_BCK_DTTM LOAD_ABT_24M_BCK_DATE
	LOAD_ABT_3M_BCK_DTTM LOAD_ABT_3M_BCK_DATE LOAD_ABT_6M_BCK_DTTM LOAD_ABT_6M_BCK_DATE;

%LET BACK_3M_TIME_SK = 1;
%LET BACK_6M_TIME_SK = 1;
%LET BACK_12M_TIME_SK = 1;
%LET BACK_24M_TIME_SK = 1;
%LET CURR_TIME_SK = 1;
%LET PRV_TIME_SK = 1;

DATA _NULL_;
	LOAD_12M_BCK_DTTM = INTNX('DTMONTH',&LOAD_ABT_USER_INPUT_DTTM,-12,'BEG');
	LOAD_12M_BCK_DATE = DATEPART(LOAD_12M_BCK_DTTM);
	CALL SYMPUT('LOAD_ABT_12M_BCK_DTTM',PUT(LOAD_12M_BCK_DTTM,NLDATM21.));
	CALL SYMPUT('LOAD_ABT_12M_BCK_DATE',LOAD_12M_BCK_DATE);

	LOAD_24M_BCK_DTTM = INTNX('DTMONTH',&LOAD_ABT_USER_INPUT_DTTM,-24,'BEG');
	LOAD_24M_BCK_DATE = DATEPART(LOAD_24M_BCK_DTTM);
	CALL SYMPUT('LOAD_ABT_24M_BCK_DTTM',PUT(LOAD_24M_BCK_DTTM,NLDATM21.));
	CALL SYMPUT('LOAD_ABT_24M_BCK_DATE',LOAD_24M_BCK_DATE);

	LOAD_3M_BCK_DTTM = INTNX('DTMONTH',&LOAD_ABT_USER_INPUT_DTTM,-3,'BEG');
	LOAD_3M_BCK_DATE = DATEPART(LOAD_3M_BCK_DTTM);
	CALL SYMPUT('LOAD_ABT_3M_BCK_DTTM',PUT(LOAD_3M_BCK_DTTM,NLDATM21.));
	CALL SYMPUT('LOAD_ABT_3M_BCK_DATE',LOAD_3M_BCK_DATE);

	LOAD_6M_BCK_DTTM = INTNX('DTMONTH',&LOAD_ABT_USER_INPUT_DTTM,-6,'BEG');
	LOAD_6M_BCK_DATE = DATEPART(LOAD_6M_BCK_DTTM);
	CALL SYMPUT('LOAD_ABT_6M_BCK_DTTM',PUT(LOAD_6M_BCK_DTTM,NLDATM21.));
	CALL SYMPUT('LOAD_ABT_6M_BCK_DATE',LOAD_6M_BCK_DATE);
RUN;

*Parameters to set date the load date for ABT for outcome variables;
%GLOBAL OUTCOME_START_DTTM OUTCOME_END_DTTM OUTCOME_START_DATE OUTCOME_END_DATE;
/*Added for the CS Hot Fix*/
%GLOBAL OUTCOME_PERIOD;
DATA _NULL_;
	IF KLEFT(KRIGHT("&OUTCOME_PERIOD")) EQ '' THEN 
		CALL SYMPUT('OUTCOME_PERIOD',3);
RUN;
/*End of Hot Fix*/
DATA _NULL_;
	/* CALL SYMPUT('OUTCOME_START_DTTM',"&LOAD_ABT_USER_INPUT_DTTM"); */

   OUTCOME_START_DTTM = INTNX('DTMONTH',&LOAD_ABT_USER_INPUT_DTTM,0,'BEG');
	CALL SYMPUT('OUTCOME_START_DTTM',kleft(kright("'")) ||kleft(kright(PUT(OUTCOME_START_DTTM,NLDATM21.)))||kleft(kright("'DT")));

	LOAD_OUTCOME_END_DTTM = INTNX('DTMONTH',&LOAD_ABT_USER_INPUT_DTTM,&OUTCOME_PERIOD-1,'END');
	CALL SYMPUT('OUTCOME_END_DTTM',KLEFT(KRIGHT("'")) || KLEFT(KRIGHT(PUT(LOAD_OUTCOME_END_DTTM,NLDATM21.))) || KLEFT(KRIGHT("'DT")));

	LOAD_OUTCOME_START_DTTM = &LOAD_ABT_USER_INPUT_DTTM;
	LOAD_OUTCOME_START_DATE = DATEPART(LOAD_OUTCOME_START_DTTM);
	CALL SYMPUT('OUTCOME_START_DATE',LOAD_OUTCOME_START_DATE);

	LOAD_OUTCOME_END_DATE = DATEPART(LOAD_OUTCOME_END_DTTM);
	CALL SYMPUT('OUTCOME_END_DATE',LOAD_OUTCOME_END_DATE);
RUN;

%GLOBAL OTE_CURR_TIME_SK OTE_BACK_1M_TIME_SK OTE_BACK_2M_TIME_SK OTE_BACK_3M_TIME_SK 
		OTE_BACK_6M_TIME_SK OTE_BACK_12M_TIME_SK;

%LET OTE_CURR_TIME_SK = 1;
%LET OTE_BACK_1M_TIME_SK = 1;
%LET OTE_BACK_2M_TIME_SK = 1;
%LET OTE_BACK_3M_TIME_SK = 1;
%LET OTE_BACK_6M_TIME_SK = 1;
%LET OTE_BACK_12M_TIME_SK = 1;

%GLOBAL OTE_6M_BCK_DTTM;

DATA _NULL_;
	LOAD_OTE_6M_BCK_DTTM = INTNX('DTMONTH',&OUTCOME_END_DTTM,-6,'BEG');
	CALL SYMPUT('OTE_6M_BCK_DTTM',LOAD_OTE_6M_BCK_DTTM);
RUN;

PROC SQL NOPRINT;

	SELECT TIME_SK INTO :CURR_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE,0,'BEGINNING');

	SELECT TIME_SK INTO :PRV_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE,-1,'BEGINNING');
	
	SELECT TIME_SK INTO :BACK_3M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE,-3,'BEGINNING');
	
	SELECT TIME_SK INTO :BACK_6M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE,-6,'BEGINNING');
	
	
	SELECT TIME_SK INTO :BACK_12M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE,-12,'BEGINNING');

	SELECT TIME_SK INTO :BACK_24M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE,-24,'BEGINNING');

	SELECT TIME_SK INTO :OTE_CURR_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&OUTCOME_END_DATE,0,'BEGINNING');

	SELECT TIME_SK INTO :OTE_BACK_1M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&OUTCOME_END_DATE,-1,'BEGINNING');

	SELECT TIME_SK INTO :OTE_BACK_2M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&OUTCOME_END_DATE,-2,'BEGINNING');

	SELECT TIME_SK INTO :OTE_BACK_3M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&OUTCOME_END_DATE,-3,'BEGINNING');
	
	SELECT TIME_SK INTO :OTE_BACK_6M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&OUTCOME_END_DATE,-6,'BEGINNING');
	
	
	SELECT TIME_SK INTO :OTE_BACK_12M_TIME_SK
	FROM DIM.TIME_DIM
	WHERE 
	CAL_MONTH_FIRST_DT = INTNX('MONTH',&OUTCOME_END_DATE,-12,'BEGINNING');

QUIT;

 proc sql;
 create table abtscr.ACC_DEF_EVENT_X_ACC_DIM_TMP2 as 
 select account_rk, account_sk, . AS DEFAULT_DT,
 . AS EXPOSURE_AT_DEFAULT_AMT,
 ACCOUNT_DIM.PRIMARY_PRODUCT_RK as PRODUCT_RK,
   ACCOUNT_DIM.CURRENT_LIMIT_AMT as DEFAULT_CURRENT_LIMIT_AMT,
 &LOAD_ABT_USER_INPUT_DTTM. AS LOAD_ABT_USER_INPUT_DTTM,
 &LOAD_ABT_USER_INPUT_DATE. AS LOAD_ABT_USER_INPUT_DATE,
 "&LOAD_ABT_12M_BCK_DTTM."DT AS LOAD_ABT_12M_BCK_DTTM,
 &LOAD_ABT_12M_BCK_DATE. AS LOAD_ABT_12M_BCK_DATE,
 "&LOAD_ABT_24M_BCK_DTTM."DT AS LOAD_ABT_24M_BCK_DTTM,
 &LOAD_ABT_24M_BCK_DATE. AS LOAD_ABT_24M_BCK_DATE,
 "&LOAD_ABT_3M_BCK_DTTM."DT AS LOAD_ABT_3M_BCK_DTTM,
 &LOAD_ABT_3M_BCK_DATE. AS LOAD_ABT_3M_BCK_DATE,
 "&LOAD_ABT_6M_BCK_DTTM."DT AS LOAD_ABT_6M_BCK_DTTM,
 &LOAD_ABT_6M_BCK_DATE. AS LOAD_ABT_6M_BCK_DATE,
 &BACK_3M_TIME_SK. AS BACK_3M_TIME_SK,
 &BACK_6M_TIME_SK. AS BACK_6M_TIME_SK,
 &BACK_12M_TIME_SK. AS BACK_12M_TIME_SK,
 &BACK_24M_TIME_SK. AS BACK_24M_TIME_SK,
 &CURR_TIME_SK. AS CURR_TIME_SK,
 &PRV_TIME_SK. AS PRV_TIME_SK,
 &OUTCOME_START_DTTM. AS OUTCOME_START_DTTM,
 &OUTCOME_END_DTTM. AS OUTCOME_END_DTTM,
 &OUTCOME_START_DATE. AS OUTCOME_START_DATE,
 &OUTCOME_END_DATE. AS OUTCOME_END_DATE,
 &OTE_CURR_TIME_SK. AS OTE_CURR_TIME_SK,
 &OTE_BACK_1M_TIME_SK. AS OTE_BACK_1M_TIME_SK,
 &OTE_BACK_2M_TIME_SK. AS OTE_BACK_2M_TIME_SK,
 &OTE_BACK_3M_TIME_SK. AS OTE_BACK_3M_TIME_SK,
 &OTE_BACK_6M_TIME_SK. AS OTE_BACK_6M_TIME_SK,
 &OTE_BACK_12M_TIME_SK. AS OTE_BACK_12M_TIME_SK,
 &OTE_6M_BCK_DTTM. as OTE_6M_BCK_DTTM
 from dim.account_dim
 where &load_abt_user_input_dttm >= account_dim.valid_start_dttm
 and &load_abt_user_input_dttm <= account_dim.valid_end_dttm
 and ACCOUNT_STATUS_CD IN (&ACCT_STATUS_ACT)
 ORDER BY account_dim.ACCOUNT_RK;
 quit;

/* Start of CS4.3 HF2 */
/* The following SQL creates table ACC_DEF_EVENT_X_ACC_DIM_TMP3 by removing the accounts that are already bad */
/* Only the accounts which are having Days_Payment_Past_due_cnt <= Parameter ACTUAL_DLQ_DAYS are considered
for building the ABT */
	proc sql;
		Create table abtscr.ACC_DEF_EVENT_X_ACC_DIM_TMP3 as 
		select account_rk, 
		ACC_DEF_EVENT_X_ACC_DIM_TMP2.account_sk, 
		DEFAULT_DT,
		EXPOSURE_AT_DEFAULT_AMT,
 		PRODUCT_RK,
		DEFAULT_CURRENT_LIMIT_AMT,
		LOAD_ABT_USER_INPUT_DTTM,
		LOAD_ABT_USER_INPUT_DATE,
		LOAD_ABT_12M_BCK_DTTM,
		LOAD_ABT_12M_BCK_DATE,
		LOAD_ABT_24M_BCK_DTTM,
		LOAD_ABT_24M_BCK_DATE,
		LOAD_ABT_3M_BCK_DTTM,
		LOAD_ABT_3M_BCK_DATE,
		LOAD_ABT_6M_BCK_DTTM,
		LOAD_ABT_6M_BCK_DATE,
		BACK_3M_TIME_SK,
		BACK_6M_TIME_SK,
		BACK_12M_TIME_SK,
		BACK_24M_TIME_SK,
		CURR_TIME_SK,
		PRV_TIME_SK,
		OUTCOME_START_DTTM,
		OUTCOME_END_DTTM,
		OUTCOME_START_DATE,
		OUTCOME_END_DATE,
		OTE_CURR_TIME_SK,
		OTE_BACK_1M_TIME_SK,
		OTE_BACK_2M_TIME_SK,
		OTE_BACK_3M_TIME_SK,
		OTE_BACK_6M_TIME_SK,
		OTE_BACK_12M_TIME_SK,
		OTE_6M_BCK_DTTM
		from abtscr.ACC_DEF_EVENT_X_ACC_DIM_TMP2, fact.account_snapshot
		where ACC_DEF_EVENT_X_ACC_DIM_TMP2.account_sk = account_snapshot.account_sk
		and CURR_TIME_SK = account_snapshot.time_sk
		and DAYS_PAYMENT_PAST_DUE_CNT <= &ACTUAL_DLQ_DAYS;
	quit;

/* End of CS4.3 HF2 */

 %if %str(%'&abt_category.%') EQ &LGD_MODEL. or %str(%'&abt_category.%') EQ &CCF_MODEL. %then
  %do;
  proc sql;
  create table abtscr.ACC_DEF_EVENT_X_ACC_DIM_TMP1 as select
  ACC_DEF_EVENT_CURR_LKP.*, ACCOUNT_DIM.ACCOUNT_SK,
  ACCOUNT_DIM.PRIMARY_PRODUCT_RK as PRODUCT_RK,
  ACCOUNT_DIM.CURRENT_LIMIT_AMT as DEFAULT_CURRENT_LIMIT_AMT 
  from dim.ACCOUNT_DIM inner join abtscr.ACC_DEF_EVENT_CURR_LKP
  on (ACCOUNT_DIM.ACCOUNT_RK = ACC_DEF_EVENT_CURR_LKP.ACCOUNT_RK)
  WHERE ACC_DEF_EVENT_CURR_LKP.LOAD_ABT_USER_INPUT_DTTM >= ACCOUNT_DIM.VALID_START_DTTM 
  AND
  ACC_DEF_EVENT_CURR_LKP.LOAD_ABT_USER_INPUT_DTTM <= ACCOUNT_DIM.VALID_END_DTTM
  ORDER BY ACC_DEF_EVENT_CURR_LKP.ACCOUNT_RK;  
  quit;
 
  DATA abtscr.ACC_DEF_EVENT_X_ACC_DIM;
   merge abtscr.ACC_DEF_EVENT_X_ACC_DIM_TMP2 (IN = B) 
    abtscr.ACC_DEF_EVENT_X_ACC_DIM_TMP1 (IN = A);
   by ACCOUNT_RK;
   IF A or B THEN
    OUTPUT;
  run;

  %end;
 %else
  %do; 
  DATA abtscr.ACC_DEF_EVENT_X_ACC_DIM; 
  set abtscr.ACC_DEF_EVENT_X_ACC_DIM_TMP3;
  run;
  %end;   
%mend;
%decide_code;

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005KT * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP0004QH * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 * Target Table:  ACC_DEF_EVENT_X_ACC_DIM -                 A5V75JN3.BE0001JN * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

