/****************************************************************************** 
 * Job:           AM_POOLSCHEME_CAS_TRANSPOSED              A5V75JN3.BN0000UV * 
 * Description:   This job transposes the AM_POOL_SCHEME_CAS table to create  * 
 *                 the AM_POOLSCHEME_CAS_TRANSPOSED table.                    * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  AM_POOL_SCHEME_CAS -                      A5V75JN3.BE0000UU * 
 *                 martscr.AM_POOL_SCHEME_CAS                                 * 
 * Target Table:  AM_POOLSCHEME_CAS_TRANSPOSED -            A5V75JN3.BE0000UV * 
 *                 martscr.AM_POOLSCHEME_CAS_TRANSPOSED                       * 
 *                                                                            * 
 * Generated on:  Tuesday, December 16, 2008 2:10:48 PM IST                   * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = AM_POOLSCHEME_CAS_TRANSPOSED;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          User Written Code to transpose            A5V75JN3.BO0000YO * 
 *                 ESTIMATED_RT, SCORE_POINTS_NO                              * 
 * Transform:     User Written Code                                           * 
 * Description:   Transpose the input dataset. Transpose the ESTIMATED_RT,    * 
 *                 SCORE_POINTS_NO                                            * 
 *                                                                            * 
 * Source Table:  AM_POOL_SCHEME_CAS -                      A5V75JN3.BE0000UU * 
 *                 martscr.AM_POOL_SCHEME_CAS                                 * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP0000VR * 
 *                 martscr.AM_POOLSCHEME_CAS_TRANSPOSED                       * 
 *                                                                            * 
 * User Written:  Code to transpose                         A5V75JN3.AF000AG5 * 
 *                Transpose ESTIMATED_RT and SCORE_POINTS_NO                  * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.AM_POOL_SCHEME_CAS); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.AM_POOLSCHEME_CAS_TRANSPOSED); 

/*---- Start of User Written Code  ----*/ 

/* Sort the input dataset by the variables used for by-group
in the subsequent code */
proc sort data=martscr.AM_POOL_SCHEME_CAS;
by ACCOUNT_RK POOL_SCHEME_SK POOL_SCHEME_TYPE_CD;
run;

data martscr.AM_POOLSCHEME_CAS_TRANSPOSED;
set martscr.AM_POOL_SCHEME_CAS;
by ACCOUNT_RK POOL_SCHEME_SK POOL_SCHEME_TYPE_CD;

retain ESTIMATED_SCORE ESTIMATED_PD ESTIMATED_LGD ESTIMATED_CCF;

if POOL_SCHEME_TYPE_CD = &SCORE_RANGE_TYPE. then do;
 	ESTIMATED_SCORE=SCORE_POINTS_NO;
end;

/* Start of CS4.3 HF2 */ 
/* The following if loops were earlier if - else if loops */
/* This is changed for supporting the Pool scheme type based on
PD, LGD and CCF. */

else do;
	if MODEL_TYPE_CD = &PD_ONG_MODEL. then do;
		ESTIMATED_PD=ESTIMATED_RT;
	end;
	if MODEL_TYPE_CD = &LGD_MODEL. then do;
		ESTIMATED_LGD=ESTIMATED_RT;
	end;
	if MODEL_TYPE_CD = &CCF_MODEL. then do;
		ESTIMATED_CCF=ESTIMATED_RT;
	end;
end;

/* End of CS4.3 HF2 */

if last.POOL_SCHEME_TYPE_CD then
do;
	output;
	ESTIMATED_SCORE=.;
 	ESTIMATED_LGD=.;
	ESTIMATED_PD=.;
	ESTIMATED_CCF=.;
end;

keep ACCOUNT_RK POOL_SCHEME_SK POOL_SCHEME_TYPE_CD ESTIMATED_SCORE ESTIMATED_PD ESTIMATED_LGD ESTIMATED_CCF;
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0000YN * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP0000VR * 
 *                 martscr.AM_POOLSCHEME_CAS_TRANSPOSED                       * 
 * Target Table:  AM_POOLSCHEME_CAS_TRANSPOSED -            A5V75JN3.BE0000UV * 
 *                 martscr.AM_POOLSCHEME_CAS_TRANSPOSED                       * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

