/****************************************************************************** 
 * Job:           APPLICATION_ANALYSIS_FACT                 A5V75JN3.BN0000U5 * 
 * Description:   This job contains data extracted from table                 * 
 *                APP_LOW_HIGH_SIDE and POOL_DIM and build                    * 
 *                 APPLICATION_ANALYSIS_FACT.                                 * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: APP_LOW_HIGH_SIDE -                       A5V75JN3.BE0000TS * 
 *                 martscr.APP_LOW_HIGH_SIDE                                  * 
 *                APPLICATION_PD_APP -                      A5V75JN3.BE0000U9 * 
 *                 martscr.APPLICATION_PD_APP                                 * 
 * Target Table:  APPLICATION_ANALYSIS_FACT -               A5V75JN3.BE0000U3 * 
 *                 fact.APPLICATION_ANALYSIS_FACT                             * 
 *                                                                            * 
 * Generated on:  Tuesday, December 16, 2008 12:32:51 PM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APPLICATION_ANALYSIS_FACT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Extracting the data to load               A5V75JN3.BO0000X0 * 
 *                 APPLICATION_ANALYSIS_FACT                                  * 
 * Transform:     SQL Join                                                    * 
 * Description:   Extracting the data for pool_sk from inner joining table    * 
 *                POOL_DIM and APP_LOW_HIGH_SIDE on POOL_SCHEME_SK and        * 
 *                SCORE_POINTS_NO between PD_FROM_SCORE_NO,and                * 
 *                 POOL_DIM.PD_TO_SCORE_NO.                                   * 
 *                                                                            * 
 * Source Tables: APP_LOW_HIGH_SIDE -                       A5V75JN3.BE0000TS * 
 *                 martscr.APP_LOW_HIGH_SIDE                                  * 
 *                APPLICATION_PD_APP -                      A5V75JN3.BE0000U9 * 
 *                 martscr.APPLICATION_PD_APP                                 * 
 * Target Table:  SQL Join Target -                         A5V75JN3.BP0000UU * 
 *                 martscr.APPLICATION_ANALYSIS_FACT_T                        * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete APPLICATION_ANALYSIS_FACT_T;
quit;

proc sql;
   create table martscr.APPLICATION_ANALYSIS_FACT_T as
   select APP_LOW_HIGH_SIDE.INTERNAL_ORG_SK,
       APP_LOW_HIGH_SIDE.CHANNEL_SK,
       APP_LOW_HIGH_SIDE.PRODUCT_SK,
       APP_LOW_HIGH_SIDE.APPLIED_AMT,
       APP_LOW_HIGH_SIDE.APPROVE_CNT,
       APP_LOW_HIGH_SIDE.APPLICATION_SK,
       APP_LOW_HIGH_SIDE.APPLICANT_SK,
       APP_LOW_HIGH_SIDE.APPROVED_AMT,
       APP_LOW_HIGH_SIDE.DISBURSED_AMT,
       APP_LOW_HIGH_SIDE.MODEL_SK,
       APP_LOW_HIGH_SIDE.APPLICATION_SCORE_NO,
       APP_LOW_HIGH_SIDE.SCORE_POINTS_NO,
       APP_LOW_HIGH_SIDE.SCORE_TIME_SK,
       APP_LOW_HIGH_SIDE.REJECT_CNT format=8. AS REJECT_CNT,
       APP_LOW_HIGH_SIDE.ACCOUNT_CNT,
       APP_LOW_HIGH_SIDE.LOW_SIDE format=8. AS LOW_SIDE,
       APP_LOW_HIGH_SIDE.HIGH_SIDE,
       APPLICATION_PD_APP.POOL_SK,
       1 format=8. AS APPLICATION_CNT,
       APP_LOW_HIGH_SIDE.POOL_SCHEME_SK,
       APPLICATION_PD_APP.FINANCIAL_APPLICATION_RK,
       APPLICATION_PD_APP.ESTIMATED_PD,
       APPLICATION_PD_APP.POOL_SCHEME_TYPE_CD,
       APPLICATION_PD_APP.ESTIMATED_SCORE
   from martscr.APP_LOW_HIGH_SIDE 
       INNER JOIN martscr.APPLICATION_PD_APP
        ON (APP_LOW_HIGH_SIDE.POOL_SCHEME_SK = APPLICATION_PD_APP.POOL_SCHEME_SK
        AND APP_LOW_HIGH_SIDE.APPLICATION_RK = APPLICATION_PD_APP.FINANCIAL_APPLICATION_RK) ;
quit;

%rcset(&sqlrc);

/*============================================================================* 
 * Step:          Appending data with new set of data       A5V75JN3.BO0000X1 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target -                         A5V75JN3.BP0000UU * 
 *                 martscr.APPLICATION_ANALYSIS_FACT_T                        * 
 * Target Table:  APPLICATION_ANALYSIS_FACT -               A5V75JN3.BE0000U3 * 
 *                 fact.APPLICATION_ANALYSIS_FACT                             * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.APPLICATION_ANALYSIS_FACT_T); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(fact.APPLICATION_ANALYSIS_FACT, DATA)) or 
         %sysfunc(exist(fact.APPLICATION_ANALYSIS_FACT, VIEW))); 
   
   %if (&etls_tableExist gt 0) %then 
   %do;  /* if table exists  */ 
   
      /*---- Drop indexes from a table  ----*/ 
      %put %str(NOTE: Dropping indexes ...);
      proc datasets lib = work nolist nowarn memtype = (data view);
         delete etls_CIList;
      quit;
      
      proc sql; 
      
         reset noprint; 
         
         create table etls_CIList as 
            select tabname length=100, 
                   idxname length=200 
            from 
            ( 
               select distinct indxname as idxname, 
                      "fact.APPLICATION_ANALYSIS_FACT" as tabname 
                  from dictionary.indexes 
                     where upcase(libname) eq "FACT" and upcase(memname) eq "APPLICATION_ANALYSIS_FACT" 
            ); 
         %let etls_numIndex = &sqlObs; 
         
         %let etls_deleteList= etls_CIList; 
         
         %put %str(NOTE: Number of Indexes to be dropped: &etls_numIndex);
         
         %do etls_indexCount = 1 %to &etls_numIndex; 
         
            select idxname, tabname into :etls_indexName , :etls_indexTable 
               from &etls_deleteList 
                       (firstobs = &etls_indexCount 
                        obs = &etls_indexCount); 
               
            %put NOTE: Dropping Index &etls_indexCount: %bquote(&etls_indexName) ...;
            
            drop index &etls_indexName on &etls_indexTable 
            ; 
            
         %end;  /* do loop through indexes  */ 
         
      quit; 
      
      %rcSet(&sqlrc); 
      
      proc datasets lib = work nolist nowarn memtype = (data view);
         delete etls_CIList etls_CIList2;
      quit;
      
   %end;  /* if table exists  */ 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data fact.APPLICATION_ANALYSIS_FACT
              (label = 'APPLICATION_ANALYSIS_FACT');
         attrib PRODUCT_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib POOL_SCHEME_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib APPLICANT_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib MODEL_SK length = 8 format = 12. informat = 12.
                   label = 'Surrogate key for the analytical model dimension.'; 
         attrib INTERNAL_ORG_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib CHANNEL_SK length = 8 format = 12. informat = 12.
                   label = 'Surrogate key for the channel dimension.'; 
         attrib APPLICATION_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib SCORE_TIME_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib SCORE_POINTS_NO length = 8; 
         attrib APPLICATION_SCORE_NO length = 8; 
         attrib APPLICATION_CNT length = 8; 
         attrib APPROVE_CNT length = 8; 
         attrib ACCOUNT_CNT length = 8; 
         attrib REJECT_CNT length = 8; 
         attrib LOW_SIDE length = 8; 
         attrib HIGH_SIDE length = 8; 
         attrib APPLIED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib APPROVED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib DISBURSED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib POOL_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         stop;
      run;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete mapped;
   quit;
   
   %put %str(NOTE: Mapping columns ...);
   proc sql; 
      create view work.mapped as 
         select PRODUCT_SK length = 8,
                POOL_SCHEME_SK length = 8 format = 12. informat = 12.,
                APPLICANT_SK length = 8,
                MODEL_SK length = 8,
                INTERNAL_ORG_SK length = 8,
                CHANNEL_SK length = 8 format = 12. informat = 12.,
                APPLICATION_SK length = 8,
                SCORE_TIME_SK length = 8 format = 12. informat = 12.,
                SCORE_POINTS_NO length = 8,
                APPLICATION_SCORE_NO length = 8,
                APPLICATION_CNT length = 8,
                APPROVE_CNT length = 8,
                ACCOUNT_CNT length = 8,
                REJECT_CNT length = 8,
                LOW_SIDE length = 8,
                HIGH_SIDE length = 8,
                APPLIED_AMT length = 8,
                APPROVED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
                DISBURSED_AMT length = 8,
                POOL_SK length = 8 format = 12. informat = 12.
            from &etls_lastTable; 
   quit;
   
   %let SYSLAST = work.mapped; 
   
   %let etls_lastTable = &SYSLAST; 
   %let SYSOPT = ; 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(fact.APPLICATION_ANALYSIS_FACT, DATA)) or 
            %sysfunc(exist(fact.APPLICATION_ANALYSIS_FACT, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = fact.APPLICATION_ANALYSIS_FACT out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(APPLICATION_ANALYSIS_FACT);
   %let etls_lib   = %nrquote(Facts);
   
   proc append base = fact.APPLICATION_ANALYSIS_FACT 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(fact.APPLICATION_ANALYSIS_FACT, DATA)) or 
            %sysfunc(exist(fact.APPLICATION_ANALYSIS_FACT, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = fact.APPLICATION_ANALYSIS_FACT out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   
   /*---- Create the indexes for a table  ----*/ 
   %if ((&etls_tableExist eq 0) or 
        (&etls_numIndex ne -1)) %then 
   %do;  /* if table did not exist or there are indexes to create  */ 
   
      /*---- Create the indexes for a table  ----*/ 
      %put %str(NOTE: Creating indexes ...);
      proc datasets lib = fact nolist; 
         modify APPLICATION_ANALYSIS_FACT; 
            index create XPKAPPLICATION_ANALYSIS_FACT = (SCORE_TIME_SK MODEL_SK POOL_SCHEME_SK CHANNEL_SK 
                            APPLICATION_SK APPLICANT_SK PRODUCT_SK 
                            INTERNAL_ORG_SK POOL_SK)
               / unique;
      quit; 
      
      %rcSet(&syserr); 
      
   %end;  /* if table did not exist or there are indexes to create  */ 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete mapped;
   quit;
   
%mend etls_loader;
%etls_loader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
