/****************************************************************************** 
 * Job:           APPLICATION_ANALYSIS_LOOK_UP              A5V75JN3.BN0000TW * 
 * Description:   This job look up the data from the table                    * 
 *                APPLICATION_DIM_EXT                                         * 
 *                ,INTERNAL_ORG_DIM_EXT,APPLICANT_DIM,ANALYTICAL_MODEL_DIM    * 
 *                _EXT,CHANNEL_DIM_EXT From FIN_APP_SCR_AMT.                  * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FIN_APP_SCR_AMT - martscr.FIN_APP_SCR_AMT A5V75JN3.BE0000U0 * 
 *                APPLICATION_DIM_EXT -                     A5V75JN3.BE0000MJ * 
 *                 martscr.APPLICATION_DIM_EXT                                * 
 *                INTERNAL_ORG_DIM_EXT -                    A5V75JN3.BE0000MW * 
 *                 martscr.INTERNAL_ORG_DIM_EXT                               * 
 *                ANALYTICAL_MODEL_DIM_EXT -                A5V75JN3.BE0000MI * 
 *                 martscr.ANALYTICAL_MODEL_DIM_EXT                           * 
 *                CHANNEL_DIM_EXT - martscr.CHANNEL_DIM_EXT A5V75JN3.BE0000MK * 
 *                APPLICANT_DIM - dim.APPLICANT_DIM         A5V75JN3.BE0000LK * 
 *                FINANCIAL_PRODUCT_DIM_EXT -               A5V75JN3.BE0000MR * 
 *                 martscr.FINANCIAL_PRODUCT_DIM_EXT                          * 
 * Target Tables: APPLICATION_ANALYSIS_LOOK_UP_EXP -        A5V75JN3.BE0000TU * 
 *                 facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP                   * 
 *                APPLICATION_ANALYSIS_LOOK_UP -            A5V75JN3.BE0000TT * 
 *                 martscr.APPLICATION_ANALYSIS_LOOK_UP                       * 
 *                                                                            * 
 * Generated on:  Tuesday, December 16, 2008 11:49:53 AM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APPLICATION_ANALYSIS_LOOK_UP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          APPLICATION_ANALYSIS_LOOK_UP Lookup       A5V75JN3.BO0005NC * 
 * Transform:     Lookup                                                      * 
 * Description:   Look for the Sks in respective dimension tables and         * 
 *                 measures are picked from table FIN_APP_SCR_AMT.            * 
 *                                                                            * 
 * Source Tables: FIN_APP_SCR_AMT - martscr.FIN_APP_SCR_AMT A5V75JN3.BE0000U0 * 
 *                APPLICATION_DIM_EXT -                     A5V75JN3.BE0000MJ * 
 *                 martscr.APPLICATION_DIM_EXT                                * 
 *                INTERNAL_ORG_DIM_EXT -                    A5V75JN3.BE0000MW * 
 *                 martscr.INTERNAL_ORG_DIM_EXT                               * 
 *                ANALYTICAL_MODEL_DIM_EXT -                A5V75JN3.BE0000MI * 
 *                 martscr.ANALYTICAL_MODEL_DIM_EXT                           * 
 *                CHANNEL_DIM_EXT - martscr.CHANNEL_DIM_EXT A5V75JN3.BE0000MK * 
 *                APPLICANT_DIM - dim.APPLICANT_DIM         A5V75JN3.BE0000LK * 
 *                FINANCIAL_PRODUCT_DIM_EXT -               A5V75JN3.BE0000MR * 
 *                 martscr.FINANCIAL_PRODUCT_DIM_EXT                          * 
 * Target Tables: Lookup Target -                           A5V75JN3.BP0004S5 * 
 *                 martscr.APPLICATION_ANALYSIS_LOOK_UP                       * 
 *                Exception WorkTable -                     A5V75JN3.BP0004S6 * 
 *                 work.APPLICATION_ANALYSIS_LOOK_UP_EXP                      * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete APPLICATION_ANALYSIS_LOOK_UP;
quit;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete APPLICATION_ANALYSIS_LOOK_UP_EXP;
quit;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete etls_temp_lookupview4;
quit;

proc sql; create view etls_temp_lookupview4 as 
   select * from dim.APPLICANT_DIM
   where (VALID_START_DTTM  <= &LOAD_STAR_USER_INPUT_DTTM)  and 
   (&LOAD_STAR_USER_INPUT_DTTM  <= VALID_END_DTTM);
quit;
/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.APPLICATION_ANALYSIS_LOOK_UP
         (keep = INTERNAL_ORG_SK APPLICATION_RK CHANNEL_SK PRODUCT_SK 
                 APPLIED_AMT APPROVE_CNT APPLICATION_SK APPLICANT_SK 
                 APPROVED_AMT DISBURSED_AMT MODEL_SK APPLICATION_SCORE_NO 
                 SCORE_POINTS_NO SCORE_TIME_SK REJECT_CNT ACCOUNT_CNT 
                 CUT_OFF_SCORE POOL_SCHEME_SK)
      work.APPLICATION_ANALYSIS_LOOK_UP_EXP 
         (keep = etls_source_row etls_lookup_table etls_exception_cond 
                 etls_exception_action APPLIED_AMT APPROVE_CNT APPROVED_AMT 
                 DISBURSED_AMT APPLICATION_SCORE_NO SCORE_POINTS_NO SCORE_TIME_SK 
                 REJECT_CNT ACCOUNT_CNT PRODUCT_RK APPLICANT_RK INTERNAL_ORG_RK 
                 CHANNEL_CD APPLICATION_RK MODEL_RK)
      ; 
   
   attrib INTERNAL_ORG_SK length=8 format=12. label="Internal Organization Key"
          APPLICATION_RK length=8 format=12. label="_RKorSK"
          CHANNEL_SK length=8 label="Channel key"
          PRODUCT_SK length=8 format=12. label="Product Key"
          APPLIED_AMT length=8 format=NLNUM18.5 label="Applied Amount"
          APPROVE_CNT length=8 label="Outcome Code"
          APPLICATION_SK length=8 format=12. label="Financial Application Key"
          APPLICANT_SK length=8 format=12. label="Applicant Key"
          APPROVED_AMT length=8
          DISBURSED_AMT length=8 format=NLNUM18.5 label="Actual Advance Amount"
          MODEL_SK length=8 format=12. label="Model Key"
          APPLICATION_SCORE_NO length=8 format=NLNUM12.8 label="Application Score No"
          SCORE_POINTS_NO length=8 label="Score Points No"
          SCORE_TIME_SK length=8
          REJECT_CNT length=8
          ACCOUNT_CNT length=8
          CUT_OFF_SCORE length=8
          POOL_SCHEME_SK length=8
          ; 
   
   length etls_lookup_table $41 etls_exception_cond etls_exception_action $32 
   MODEL_RK 8 CHANNEL_CD $3 INTERNAL_ORG_RK 8 APPLICANT_RK 8 PRODUCT_RK 8 ; 
   
   retain missing0 0 missing1 0 missing2 0 missing3 0 missing4 0 missing5 0 ; 
   
   /* Assign variables used for error/exception handling  */ 
   etls_source_row      = _n_;
   request_write_target = 0; 
   request_write_error  = 0; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table martscr.ANALYTICAL_MODEL_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.ANALYTICAL_MODEL_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "martscr.ANALYTICAL_MODEL_DIM_EXT", hashexp: exponent);
            h0.defineKey( "MODEL_RK");
            h0.defineData( "MODEL_SK",
                           "POOL_SCHEME_SK",
                           "CUT_OFF_SCORE");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.ANALYTICAL_MODEL_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.ANALYTICAL_MODEL_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.ANALYTICAL_MODEL_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.ANALYTICAL_MODEL_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.ANALYTICAL_MODEL_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.ANALYTICAL_MODEL_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table martscr.CHANNEL_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.CHANNEL_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "martscr.CHANNEL_DIM_EXT", hashexp: exponent);
            h1.defineKey( "CHANNEL_CD");
            h1.defineData( "CHANNEL_SK");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.CHANNEL_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.CHANNEL_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.CHANNEL_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.CHANNEL_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.CHANNEL_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.CHANNEL_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h2 from lookup table martscr.INTERNAL_ORG_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.INTERNAL_ORG_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h2(dataset: "martscr.INTERNAL_ORG_DIM_EXT", hashexp: exponent);
            h2.defineKey( "INTERNAL_ORG_RK");
            h2.defineData( "INTERNAL_ORG_SK");
            h2.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h2.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.INTERNAL_ORG_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.INTERNAL_ORG_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.INTERNAL_ORG_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.INTERNAL_ORG_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.INTERNAL_ORG_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.INTERNAL_ORG_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h3 from lookup table martscr.APPLICATION_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.APPLICATION_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h3(dataset: "martscr.APPLICATION_DIM_EXT", hashexp: exponent);
            h3.defineKey( "APPLICATION_RK");
            h3.defineData( "APPLICATION_SK");
            h3.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h3.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.APPLICATION_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.APPLICATION_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.APPLICATION_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.APPLICATION_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.APPLICATION_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.APPLICATION_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h4 from lookup table etls_temp_lookupview4 */ 
      nlobs = .; 
      dsid = open("etls_temp_lookupview4"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h4(dataset: "etls_temp_lookupview4", hashexp: exponent);
            h4.defineKey( "APPLICANT_RK");
            h4.defineData( "APPLICANT_SK");
            h4.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h4.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: etls_temp_lookupview4";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " etls_temp_lookupview4";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: etls_temp_lookupview4";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " etls_temp_lookupview4";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " etls_temp_lookupview4";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " etls_temp_lookupview4";
         
         abort 3; 
      end; 
      
      /* Build hash h5 from lookup table martscr.FINANCIAL_PRODUCT_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.FINANCIAL_PRODUCT_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h5(dataset: "martscr.FINANCIAL_PRODUCT_DIM_EXT", hashexp: exponent);
            h5.defineKey( "PRODUCT_RK");
            h5.defineData( "PRODUCT_SK");
            h5.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h5.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.FINANCIAL_PRODUCT_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.FINANCIAL_PRODUCT_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.FINANCIAL_PRODUCT_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.FINANCIAL_PRODUCT_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.FINANCIAL_PRODUCT_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.FINANCIAL_PRODUCT_DIM_EXT";
         
         abort 3; 
      end; 
      
      call missing (MODEL_RK, MODEL_SK, POOL_SCHEME_SK, CUT_OFF_SCORE, 
                    CHANNEL_CD, CHANNEL_SK, INTERNAL_ORG_RK, INTERNAL_ORG_SK, 
                    APPLICATION_RK, APPLICATION_SK, APPLICANT_RK, APPLICANT_SK, 
                    PRODUCT_RK, PRODUCT_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.FIN_APP_SCR_AMT end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find();
   
   /* Is the current key value stored in hash h1?  */ 
   rc1 = h1.find();
   
   /* Is the current key value stored in hash h2?  */ 
   rc2 = h2.find();
   
   /* Is the current key value stored in hash h3?  */ 
   rc3 = h3.find();
   
   /* Is the current key value stored in hash h4?  */ 
   rc4 = h4.find();
   
   /* Is the current key value stored in hash h5?  */ 
   rc5 = h5.find();
   
   /* Examine success of lookups  */ 
   if (rc0=0 and rc1=0and rc2=0and rc3=0and rc4=0and rc5=0) then 
   do; 
      /* Write row to target  */ 
      output martscr.APPLICATION_ANALYSIS_LOOK_UP; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.ANALYTICAL_MODEL_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.APPLICATION_ANALYSIS_LOOK_UP_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.CHANNEL_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.APPLICATION_ANALYSIS_LOOK_UP_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc2 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.INTERNAL_ORG_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.APPLICATION_ANALYSIS_LOOK_UP_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc3 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.APPLICATION_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.APPLICATION_ANALYSIS_LOOK_UP_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc4 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "etls_temp_lookupview4"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.APPLICATION_ANALYSIS_LOOK_UP_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc5 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.FINANCIAL_PRODUCT_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.APPLICATION_ANALYSIS_LOOK_UP_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005NB * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Lookup Target -                           A5V75JN3.BP0004S5 * 
 *                 martscr.APPLICATION_ANALYSIS_LOOK_UP                       * 
 * Target Table:  APPLICATION_ANALYSIS_LOOK_UP -            A5V75JN3.BE0000TT * 
 *                 martscr.APPLICATION_ANALYSIS_LOOK_UP                       * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

/*============================================================================* 
 * Step:          Loader                                    A5V75JN3.BO0005ND * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Exception WorkTable -                     A5V75JN3.BP0004S6 * 
 *                 work.APPLICATION_ANALYSIS_LOOK_UP_EXP                      * 
 * Target Table:  APPLICATION_ANALYSIS_LOOK_UP_EXP -        A5V75JN3.BE0000TU * 
 *                 facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP                   * 
 *============================================================================*/ 

/* Access the data for Lookup Error Tables  */ 
LIBNAME facterr BASE "Data/bisdata/error" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(work.APPLICATION_ANALYSIS_LOOK_UP_EXP); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP, DATA)) or 
            %sysfunc(exist(facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(APPLICATION_ANALYSIS_LOOK_UP_EXP);
   %let etls_lib   = %nrquote(Lookup Error Tables);
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP, DATA)) or 
         %sysfunc(exist(facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP, VIEW))); 
   
   /*---- Drop a table  ----*/ 
   %put %str(NOTE: Dropping table ...);
   proc datasets lib = facterr nolist nodetails;
        delete APPLICATION_ANALYSIS_LOOK_UP_EXP;
   quit;
   
   %rcSet(&syserr); 
   
   %let etls_tableExist = 0;
   
   /*---- Create a new table  ----*/ 
   data facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP
           (label = 'APPLICATION_ANALYSIS_LOOK_UP_EXP');
      attrib etls_source_row length = 8
                label = 'The row number in the source table'; 
      attrib etls_lookup_table length = $41
                label = 'The name of the lookup table'; 
      attrib etls_exception_cond length = $32
                label = 'The name of the condition that caused this exception'; 
      attrib etls_exception_action length = $32
                label = 'The name of the action to take for this exception'; 
      attrib APPLIED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                label = 'Applied Amount'; 
      attrib APPROVE_CNT length = 8
                label = 'Outcome Code'; 
      attrib APPROVED_AMT length = 8; 
      attrib DISBURSED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                label = 'Actual Advance Amount'; 
      attrib APPLICATION_SCORE_NO length = 8 format = NLNUM12.8 informat = NLNUM12.8
                label = 'Application Score No'; 
      attrib SCORE_POINTS_NO length = 8
                label = 'Score Points No'; 
      attrib SCORE_TIME_SK length = 8; 
      attrib REJECT_CNT length = 8; 
      attrib ACCOUNT_CNT length = 8; 
      attrib PRODUCT_RK length = 8 format = 12. informat = 12.
                label = 'Product Key'; 
      attrib APPLICANT_RK length = 8 format = 12. informat = 12.
                label = 'Applicant Key'; 
      attrib INTERNAL_ORG_RK length = 8 format = 12. informat = 12.
                label = 'Internal Organization Key'; 
      attrib CHANNEL_CD length = $3
                label = 'Channel Code'; 
      attrib APPLICATION_RK length = 8 format = 12. informat = 12.
                label = 'Financial Application Key'; 
      attrib MODEL_RK length = 8 format = 12. informat = 12.
                label = 'Model Key'; 
      stop;
   run;
   
   %rcSet(&syserr); 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   proc append base = facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP, DATA)) or 
            %sysfunc(exist(facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.APPLICATION_ANALYSIS_LOOK_UP_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

