/****************************************************************************** 
 * Job:           APPLICATION_PD_RK                         A5V75JN3.BN0000UC * 
 * Description:   This job picks up the data from APPLICATION_DIM_EXT and     * 
 *                 APPLICATION_SCR_TRG_DT.                                    * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: APPLICATION_DIM - dim.APPLICATION_DIM     A5V75JN3.BE0000LL * 
 *                APPLICATION_PD_FACT_EXT -                 A5V75JN3.BE0000UN * 
 *                 martscr.APPLICATION_PD_FACT_EXT                            * 
 * Target Table:  APPLICATION_PD_RK -                       A5V75JN3.BE0000UA * 
 *                 martscr.APPLICATION_PD_RK                                  * 
 *                                                                            * 
 * Generated on:  Wednesday, December 24, 2008 3:51:27 PM IST                 * 
 * Generated by:  D108INA4\sasadm                                             * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APPLICATION_PD_RK;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Finding the application rk for the        A5V75JN3.BO0000XE * 
 *                 application sk.                                            * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Finding the application rk for the application sk by left   * 
 *                joing table  APPLICATION_DIM_EXT and                        * 
 *                 APPLICATION_SCR_TRG_DT on application_sk.                  * 
 *                                                                            * 
 * Source Tables: APPLICATION_DIM - dim.APPLICATION_DIM     A5V75JN3.BE0000LL * 
 *                APPLICATION_PD_FACT_EXT -                 A5V75JN3.BE0000UN * 
 *                 martscr.APPLICATION_PD_FACT_EXT                            * 
 * Target Table:  SQL Target - martscr.APPLICATION_PD_RK    A5V75JN3.BP0000V1 * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete APPLICATION_PD_RK;
quit;

proc sql;
   create table martscr.APPLICATION_PD_RK as
      select
         APPLICATION_PD_FACT_EXT.APPLICATION_SK length = 8
                                                format = 12.
                                                informat = 12.
                                                label = "Financial Application Key",
         APPLICATION_PD_FACT_EXT.PRODUCT_SK length = 8,
         APPLICATION_PD_FACT_EXT.APPLICANT_SK length = 8,
         APPLICATION_PD_FACT_EXT.INTERNAL_ORG_SK length = 8
                                                 format = 12.
                                                 informat = 12.
                                                 label = "Internal Organization Key",
         APPLICATION_PD_FACT_EXT.POOL_SK length = 8,
         APPLICATION_PD_FACT_EXT.MODEL_SK length = 8,
         APPLICATION_PD_FACT_EXT.SCORE_TIME_SK length = 8,
         APPLICATION_DIM.APPLICATION_RK length = 8
      from
         martscr.APPLICATION_PD_FACT_EXT left join 
         dim.APPLICATION_DIM
            on
            (
               APPLICATION_DIM.APPLICATION_SK = APPLICATION_PD_FACT_EXT.APPLICATION_SK
               and datepart(APPLICATION_DIM.VALID_START_DTTM) BETWEEN intnx('month',APPLICATION_PD_FACT_EXT.SCORE_DT,0,'b') 
                AND APPLICATION_PD_FACT_EXT.TARGET_TIME_DT
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify APPLICATION_PD_RK;
         ic create not null (APPLICATION_SK);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy  Loader                             A5V75JN3.BO0000XF * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.APPLICATION_PD_RK    A5V75JN3.BP0000V1 * 
 * Target Table:  APPLICATION_PD_RK -                       A5V75JN3.BE0000UA * 
 *                 martscr.APPLICATION_PD_RK                                  * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0001L9 * 
 *                                                                            * 
 * User Written:  Creating index on APPLICATION_RK  column  A5V75JN3.AF000ADK * 
 *                Creating index on APPLICATION_RK  column                    * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on APPLICATION_RK  column */
PROC SQL NOPRINT;
           CREATE INDEX APPLICATION_RK 
            ON martscr.APPLICATION_PD_RK(APPLICATION_RK );
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

