/****************************************************************************** 
 * Job:           APPL_BASIC_ABT                            A5V75JN3.BN0001OG * 
 * Description:   This job picks up the data from APPLICATION_DIM.            * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  APPLICATION_DIM - dim.APPLICATION_DIM     A5V75JN3.BE0000LL * 
 * Target Table:  APPL_BASIC_ABT - abtagg.APPL_BASIC_ABT    A5V75JN3.BE0001QU * 
 *                                                                            * 
 * Generated on:  Thursday, December 11, 2008 3:36:49 PM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APPL_BASIC_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Extraction and Loading of  data as per    A5V75JN3.BO0005LI * 
 *                 the load datetime                                          * 
 * Transform:     Extract                                                     * 
 * Description:   Extract and load data based on user defined                 * 
 *                 parameterLOAD_STAR_USER_INPUT_DTTM.                        * 
 *                                                                            * 
 * Source Table:  APPLICATION_DIM - dim.APPLICATION_DIM     A5V75JN3.BE0000LL * 
 * Target Table:  Extract Target - abtagg.APPL_BASIC_ABT    A5V75JN3.BP0004QT * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(dim.APPLICATION_DIM); 

%let trans_rc = 0; 

proc datasets lib = abtagg nolist nowarn memtype = (data view);
   delete APPL_BASIC_ABT;
quit;

proc sql; 
   create table abtagg.APPL_BASIC_ABT as 
      select APPLICATION_RK length = 8,
             APPLICATION_ID as APPL_ID length = 32,
             APPLICATION_DT as APPL_DT length = 8,
             APPLICANTS_CNT as APPL_APPT_CNT length = 8,
             LINKED_ACCOUNT_FLG as APPL_LNK_ACC_FLG length = 8,
             LINKED_DEPOSIT_ACCOUNT_FLG as APPL_LNK_DEP_ACC_FLG length = 8,
             SIGNATORIES_CNT as APPL_DIST_SGY_CNT length = 8,
             PURPOSE_CD as APPL_PRP_CD length = 8,
             APPLIED_AMT as APPL_AMT length = 8,
             LOAN_SECURED_FLG as APPL_SRTY_LON_FLG length = 8,
             CHANNEL_CD as APPL_SLS_CHNL_CD length = 8 format = $3. informat = $3.,
             COLLATERAL_CD as APPL_PCL_TYP_CD length = 8,
             CLLTRL_MTHLY_INS_PREM_AMT as APPL_PCL_INS_MTH_AMT length = 8,
             (CASE WHEN CLLTRL_INS_END_DT NE .  AND CLLTRL_INS_END_DT > &LOAD_ABT_USER_INPUT_DATE THEN  INTCK('MONTH', &LOAD_ABT_USER_INPUT_DATE, CLLTRL_INS_END_DT) ELSE . END) as APPL_PCL_INS_LEFT_MTH_CNT length = 8,
             OUTCOME_CD as APPL_OUTCM_CD length = 8,
             OVERRIDE_REASON_CD as APPL_OVRD_RSN_CD length = 8,
             (CASE WHEN DECISION_CD IN (&REF_DECISION) THEN &FLAG_TRUE ELSE &FLAG_FALSE END) as APPL_REFD_FLG length = 8 format = $1. informat = $1.,
             DECISION_CD as APPL_DCS_CD length = 8,
             CREDIT_CARD_CONSOLIDATION_AMT as APPL_CCD_CONS_AMT length = 8,
             MORTGAGE_CONSOLIDATION_AMT as APPL_MTG_CONS_AMT length = 8,
             LOAN_CONSOLIDATION_AMT as APPL_OTH_LON_CONS_AMT length = 8,
             CREDIT_CARD_CONSOLIDATION_CNT as APPL_CCD_CONS_CNT length = 8,
             MORTGAGE_CONSOLIDATION_CNT as APPL_MTG_CONS_CNT length = 8,
             LOAN_CONSOLIDATION_CNT as APPL_OTH_LON_CONS_CNT length = 8,
             (SUM(CREDIT_CARD_CONSOLIDATION_AMT , MORTGAGE_CONSOLIDATION_AMT , LOAN_CONSOLIDATION_AMT )) as APPL_TOT_BAL_CONS_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             SAVINGS_IN_CONSOLIDATION_AMT as APPL_TOT_SVD_CONS_AMT length = 8,
             PROCESSING_CHARGES_AMT as APPL_PROC_FEE_AMT length = 8,
             PRODUCT_RK length = 8 label = '_RKorSK',
             CUSTOMER_RK length = 8 label = 'Customer Key',
             OUTCOME_DT length = 8 label = '_DT',
             CLLTRL_ONE_TIME_INS_PREM_AMT as APPL_PCL_OTIME_INS_PAID_AMT length = 8,
             (DHMS(APPLICATION_DT,00,00,00)) as LOAD_ABT_USER_INPUT_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (APPLICATION_DT) as LOAD_ABT_USER_INPUT_DATE length = 8 format = NLDATE10. informat = NLDATE10.,
             (INTNX('MONTH',APPLICATION_DT,-12,'BEG')) as LOAD_ABT_12M_BCK_DATE length = 8 format = NLDATE10. informat = NLDATE10.,
             (INTNX('MONTH',APPLICATION_DT,-24,'BEG')) as LOAD_ABT_24M_BCK_DATE length = 8 format = NLDATE10. informat = NLDATE10.,
             (INTNX('MONTH',APPLICATION_DT,-3,'BEG')) as LOAD_ABT_3M_BCK_DATE length = 8 format = NLDATE10. informat = NLDATE10.,
             (INTNX('MONTH',APPLICATION_DT,-6,'BEG')) as LOAD_ABT_6M_BCK_DATE length = 8 format = NLDATE10. informat = NLDATE10.,
             (INPUT(PUT(INTNX('MONTH',APPLICATION_DT,0,'END'),TIME_KEY.),12.)) as CURR_TIME_SK length = 8 format = 12. informat = 12.,
             (INPUT(PUT(INTNX('MONTH', APPLICATION_DT,&OUTCOME_PERIOD-1,'END'),TIME_KEY.),12.)) as OTE_CURR_TIME_SK length = 8 format = 12. informat = 12.,
             (DHMS(INTNX('MONTH',APPLICATION_DT,0,'BEG'),00,00,00)) as OUTCOME_START_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (DHMS(INTNX('MONTH',APPLICATION_DT,&OUTCOME_PERIOD-1,'END'),23,59,59)) as OUTCOME_END_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
         from &SYSLAST
            where (&LOAD_ABT_USER_INPUT_DTTM  >= VALID_START_DTTM and &LOAD_ABT_USER_INPUT_DTTM <= VALID_END_DTTM) and (APPLICATION_DT >= INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE, -&APPL_CAPTURE_PERIOD,'END') and APPLICATION_DT <= &LOAD_ABT_USER_INPUT_DATE); 
quit;

%let SYSLAST = abtagg.APPL_BASIC_ABT; 

%rcSet(&sqlrc); 

/*---- Create the indexes for a table  ----*/ 
%put %str(NOTE: Creating indexes ...);
proc datasets lib = abtagg nolist; 
   modify APPL_BASIC_ABT; 
      index create APPLICATION_RK;
quit; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005LH * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract Target - abtagg.APPL_BASIC_ABT    A5V75JN3.BP0004QT * 
 * Target Table:  APPL_BASIC_ABT - abtagg.APPL_BASIC_ABT    A5V75JN3.BE0001QU * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

