/****************************************************************************** 
 * Job:           APPL_REJ                                  A5V75JN3.BN0003UX * 
 * Description:   This job picks up the data from APPLICATION_DIM.            * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  APPL_BASIC_ABT - abtagg.APPL_BASIC_ABT    A5V75JN3.BE0001QU * 
 * Target Table:  APPL_REJ - abtscr.APPL_REJ                A5V75JN3.BE0004MP * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 12:40:21 PM IST                * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APPL_REJ;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Extraction and Loading of  data as per    A5V75JN3.BO0005LL * 
 *                 the load datetime                                          * 
 * Transform:     Extract                                                     * 
 * Description:   Extract and load data based on user defined                 * 
 *                 parameterLOAD_STAR_USER_INPUT_DTTM.                        * 
 *                                                                            * 
 * Source Table:  APPL_BASIC_ABT - abtagg.APPL_BASIC_ABT    A5V75JN3.BE0001QU * 
 * Target Table:  Extract Target - abtscr.APPL_REJ          A5V75JN3.BP0004QV * 
 *============================================================================*/ 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(abtagg.APPL_BASIC_ABT); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete APPL_REJ;
quit;

proc sql; 
   create table abtscr.APPL_REJ as 
      select APPLICATION_RK length = 8 label = '_RKorSK',
             (.) as ACCOUNT_RK length = 8,
             (.) as APPL_REJ_OUTCM_FLG length = 8
         from &SYSLAST
            where APPL_OUTCM_CD IN (&OUTCOME_REJECT); 
quit;

%let SYSLAST = abtscr.APPL_REJ; 

%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005LM * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract Target - abtscr.APPL_REJ          A5V75JN3.BP0004QV * 
 * Target Table:  APPL_REJ - abtscr.APPL_REJ                A5V75JN3.BE0004MP * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

