/****************************************************************************** 
 * Job:           APP_LOW_HIGH_SIDE                         A5V75JN3.BN0000TV * 
 * Description:   This job pick up the data from                              * 
 *                 APPLICATION_ANALYSIS_LOOK_UP                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  APPLICATION_ANALYSIS_LOOK_UP -            A5V75JN3.BE0000TT * 
 *                 martscr.APPLICATION_ANALYSIS_LOOK_UP                       * 
 * Target Table:  APP_LOW_HIGH_SIDE -                       A5V75JN3.BE0000TS * 
 *                 martscr.APP_LOW_HIGH_SIDE                                  * 
 *                                                                            * 
 * Generated on:  Tuesday, December 16, 2008 11:49:55 AM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APP_LOW_HIGH_SIDE;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Calculating Low and High side from        A5V75JN3.BO0005NA * 
 *                 score_points                                               * 
 * Transform:     Extract                                                     * 
 * Description:   Calculating Low and High side from score_points from table  * 
 *                 APLLICATION_ANALYSIS_LOOK_UP                               * 
 *                                                                            * 
 * Source Table:  APPLICATION_ANALYSIS_LOOK_UP -            A5V75JN3.BE0000TT * 
 *                 martscr.APPLICATION_ANALYSIS_LOOK_UP                       * 
 * Target Table:  Extract Target -                          A5V75JN3.BP0004S4 * 
 *                 martscr.APP_LOW_HIGH_SIDE                                  * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.APPLICATION_ANALYSIS_LOOK_UP); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete APP_LOW_HIGH_SIDE;
quit;

proc sql; 
   create table martscr.APP_LOW_HIGH_SIDE as 
      select INTERNAL_ORG_SK length = 8 label = 'Internal Organization Key',
             APPLICATION_RK length = 8 label = '_RKorSK',
             CHANNEL_SK length = 8 label = 'Channel Code',
             PRODUCT_SK length = 8 label = 'Product Key',
             APPLIED_AMT length = 8 label = 'Applied Amount',
             APPROVE_CNT length = 8 label = 'Outcome Code',
             APPLICATION_SK length = 8 label = 'Financial Application Key',
             APPLICANT_SK length = 8 label = 'Applicant Key',
             APPROVED_AMT length = 8,
             DISBURSED_AMT length = 8 label = 'Actual Advance Amount',
             MODEL_SK length = 8 label = 'Model Key',
             APPLICATION_SCORE_NO length = 8 label = 'Application Score No',
             SCORE_POINTS_NO length = 8 label = 'Score Points No',
             SCORE_TIME_SK length = 8,
             REJECT_CNT length = 8,
             ACCOUNT_CNT length = 8,
             CUT_OFF_SCORE length = 8,
             (CASE WHEN CUT_OFF_SCORE  < SCORE_POINTS_NO AND APPROVE_CNT  = 1 
             THEN  
             1 
             ELSE  
             0 
             END) as LOW_SIDE length = 8,
             (CASE WHEN CUT_OFF_SCORE  >  SCORE_POINTS_NO AND REJECT_CNT  =1 
             THEN 
             1 
             ELSE  
             0 
             END) as HIGH_SIDE length = 8,
             POOL_SCHEME_SK length = 8
         from &SYSLAST; 
quit;

%let SYSLAST = martscr.APP_LOW_HIGH_SIDE; 

%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005N9 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract Target -                          A5V75JN3.BP0004S4 * 
 *                 martscr.APP_LOW_HIGH_SIDE                                  * 
 * Target Table:  APP_LOW_HIGH_SIDE -                       A5V75JN3.BE0000TS * 
 *                 martscr.APP_LOW_HIGH_SIDE                                  * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00041D * 
 *                                                                            * 
 * User Written:  creating index on POOL_SCHEME_SK column   A5V75JN3.AF000MMB * 
 *                creating index on POOL_SCHEME_SK column                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on POOL_SCHEME_SK column */
PROC SQL NOPRINT;
     CREATE INDEX POOL_SCHEME_SK
      ON martscr.APP_LOW_HIGH_SIDE(POOL_SCHEME_SK);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

