/****************************************************************************** 
 * Job:           APS_AM                                    A5V75JN3.BN0000TX * 
 * Description:   This job picks up the data from APS_EXT and AM_EXT          * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: APS_EXT - martscr.APS_EXT                 A5V75JN3.BE0000IG * 
 *                AM_EXT - martscr.AM_EXT                   A5V75JN3.BE0000I8 * 
 * Target Table:  APS_AM - martscr.APS_AM                   A5V75JN3.BE0000TV * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 12:42:32 PM IST                * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APS_AM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Loading  data for score point & score num A5V75JN3.BO0005NF * 
 *                 for appl. model                                            * 
 * Transform:     SQL Join                                                    * 
 * Description:   Loading  data for score point & score num for appl. model   * 
 *                by joining tables APS_EXT and AM_EXT on model_rk and        * 
 *                 score_date                                                 * 
 *                                                                            * 
 * Source Tables: APS_EXT - martscr.APS_EXT                 A5V75JN3.BE0000IG * 
 *                AM_EXT - martscr.AM_EXT                   A5V75JN3.BE0000I8 * 
 * Target Table:  SQL Join Target - martscr.APS_AM          A5V75JN3.BP0004S7 * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete APS_AM;
quit;

proc sql;
   create table martscr.APS_AM as
   select APS_EXT.MODEL_RK,
       APS_EXT.FINANCIAL_APPLICATION_RK,
       APS_EXT.APPLICATION_SCORE_NO,
       APS_EXT.SCORE_POINTS_NO,
       &LOAD_STAR_USER_INPUT_DATE format=8. AS CURRENT_LOAD_DATE
   from martscr.APS_EXT 
       INNER JOIN martscr.AM_EXT
        ON (APS_EXT.MODEL_RK = AM_EXT.MODEL_RK) 
   where MODEL_DEPLOYMENT_CD in (&PRD_MODEL_DEPLOYMENT, &DEV_MODEL_DEPLOYMENT) and AM_EXT.MODEL_TYPE_CD in (&APP_MODEL)
   group by APS_EXT.MODEL_RK, APS_EXT.FINANCIAL_APPLICATION_RK, 5
   having APS_EXT.SCORE_DT = MAX(APS_EXT.SCORE_DT);
quit;

%rcset(&sqlrc);

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005NE * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target - martscr.APS_AM          A5V75JN3.BP0004S7 * 
 * Target Table:  APS_AM - martscr.APS_AM                   A5V75JN3.BE0000TV * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

