/****************************************************************************** 
 * Job:           BC_EXT                                    A5V75JN3.BN00000K * 
 * Description:   This job extracts data from BANK_CARD table to build the    * 
 *                 BC_EXT table.                                              * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                BANK_CARD - DDS.BANK_CARD                 A5V75JN3.BE00000F * 
 * Target Table:  BC_EXT - martscr.BC_EXT                   A5V75JN3.BE0000II * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 12:43:08 PM IST                * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * BC_EXT                                                                     * 
 * Job Name: BC_EXTJob Desc Pre Process: NoneMain:Extract and load data from  * 
 * BANK_CARD using SQL join with LOAD_CONTROL table based on following        * 
 * conditionsLOAD_CONTROL.LOAD_FLG = CHECK_FLAG_TRUEand                       * 
 * LOAD_CONTROL.RUN_STATUS = RUNNING_STATUSand BANK_CARD.ISSUE_DT between     * 
 * datepart(LOAD_CONTROL.LOAD_START_DTTM) and                                 * 
 * datepart(LOAD_CONTROL.LOAD_END_DTTM)or BANK_CARD.EXPIRATION_DT between     * 
 * datepart(LOAD_CONTROL.LOAD_START_DTTM) and                                 * 
 * datepart(LOAD_CONTROL.LOAD_END_DTTM)or BANK_CARD.CANCEL_DT between         * 
 * datepart(LOAD_CONTROL.LOAD_START_DTTM) and                                 * 
 * datepart(LOAD_CONTROL.LOAD_END_DTTM)or BANK_CARD.LOSS_DT between           * 
 * datepart(LOAD_CONTROL.LOAD_START_DTTM) and                                 * 
 * datepart(LOAD_CONTROL.LOAD_END_DTTM)Post Process: Index created on         * 
 * ACCOUNT_RK and LOAD_END_DTTM columnParameters: CHECK_FLAG_TRUE and         * 
 * RUNNING_STATUS are the user defined parameters. CHECK_FLAG_TRUE is set     * 
 * to 'Y' and RUNNING_STATUS is to 'Running' for each month of data           * 
 *  load.Developed by: singupReviewed by:Tested by:                           * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00000K);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = BC_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004N2 * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PJ7 * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=DDS.BANK_CARD out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Extraction of data as per the loading     A5V75JN3.BO0006YA * 
 *                 period                                                     * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Extract and load data based on load period mentioned in     * 
 *                 LOAD_CONTROL table                                         * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                BANK_CARD - DDS.BANK_CARD                 A5V75JN3.BE00000F * 
 * Target Table:  SQL Target - martscr.BC_EXT               A5V75JN3.BP00066D * 
 *============================================================================*/ 

/* Access the data for Control  */ 
LIBNAME control BASE "Data/bisdata/control" ;
%rcSet(&syslibrc); 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0006YA); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete BC_EXT;
quit;

proc sql;
   create table martscr.BC_EXT as
      select
         BANK_CARD.ACCOUNT_RK length = 8
                              format = 12.
                              informat = 12.
                              label = "Account Key",
         LOAD_CONTROL.LOAD_END_DTTM length = 8
                                    format = NLDATM21.
                                    informat = NLDATM21.
                                    label = "Load End Datetime",
         BANK_CARD.BANK_CARD_TYPE_CD length = 3
                                     label = "Bank Card Type Code",
         CASE symget('mEngine')  
                          WHEN "ORACLE" THEN datepart(BANK_CARD.ISSUE_DT)
                          ELSE BANK_CARD.ISSUE_DT
                  END as ISSUE_DT length = 8
                                  format = NLDATE10.
                                  informat = NLDATE10.
                                  label = "Issue Date",
         CASE symget('mEngine')   
                   WHEN "ORACLE" THEN datepart(BANK_CARD.EXPIRATION_DT) 
                          ELSE BANK_CARD.EXPIRATION_DT 
                  END as EXPIRATION_DT length = 8
                                       format = NLDATE10.
                                       informat = NLDATE10.
                                       label = "Expiration Date",
         CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.CANCEL_DT)
                 ELSE BANK_CARD.CANCEL_DT
         END as CANCEL_DT length = 8
                          format = NLDATE10.
                          informat = NLDATE10.
                          label = "Cancel Date",
         BANK_CARD.CANCEL_REASON_CD length = 3
                                    label = "Card Cancel Reason Code",
         BANK_CARD.LOSS_AMT length = 8
                            format = NLNUM18.5
                            informat = NLNUM18.5
                            label = "Loss Amount",
         CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.LOSS_DT)
                 ELSE BANK_CARD.LOSS_DT
         END as LOSS_DT length = 8
                        format = NLDATE10.
                        informat = NLDATE10.
                        label = "Loss Date"
      from
         control.LOAD_CONTROL, 
         DDS.BANK_CARD
      where
         (CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.ISSUE_DT)
                 ELSE BANK_CARD.ISSUE_DT
         END >= datepart(LOAD_CONTROL.LOAD_START_DTTM)
         and CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.ISSUE_DT)
                 ELSE BANK_CARD.ISSUE_DT
         END <= datepart(LOAD_CONTROL.LOAD_END_DTTM))
         or (CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.EXPIRATION_DT)
                 ELSE BANK_CARD.EXPIRATION_DT
         END >= datepart(LOAD_CONTROL.LOAD_START_DTTM)
         and CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.EXPIRATION_DT)
                 ELSE BANK_CARD.EXPIRATION_DT
         END <= datepart(LOAD_CONTROL.LOAD_END_DTTM))
         or (CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.CANCEL_DT)
                 ELSE BANK_CARD.CANCEL_DT
         END >= datepart(LOAD_CONTROL.LOAD_START_DTTM)
         and CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.CANCEL_DT)
                 ELSE BANK_CARD.CANCEL_DT
         END <= datepart(LOAD_CONTROL.LOAD_END_DTTM))
         or (CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.LOSS_DT)
                 ELSE BANK_CARD.LOSS_DT
         END >= datepart(LOAD_CONTROL.LOAD_START_DTTM)
         and CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(BANK_CARD.LOSS_DT)
                 ELSE BANK_CARD.LOSS_DT
         END <= datepart(LOAD_CONTROL.LOAD_END_DTTM))
         and LOAD_CONTROL.LOAD_FLG IN (&CHECK_FLAG_TRUE)
         and LOAD_CONTROL.RUN_STATUS IN (&RUNNING_STATUS)
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006Y9 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.BC_EXT               A5V75JN3.BP00066D * 
 * Target Table:  BC_EXT - martscr.BC_EXT                   A5V75JN3.BE0000II * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
