/****************************************************************************** 
 * Job:           CAS_EXT_CSAM                              A5V75JN3.BN0003V4 * 
 * Description:   This job picks up data from CUSTOMER_ACCOUNT_SCORE          * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  CUSTOMER_ACCOUNT_SCORE -                  A5V75JN3.BE00001X * 
 *                 DDS.CUSTOMER_ACCOUNT_SCORE                                 * 
 * Target Table:  CAS_EXT - martscr.CAS_EXT                 A5V75JN3.BE0000IL * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 12:45:25 PM IST                * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN0003V4);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CAS_EXT_CSAM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004NB * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PK2 * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=DDS.CUSTOMER_ACCOUNT_SCORE out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Extraction of data as per the loading     A5V75JN3.BO0006YE * 
 *                 period                                                     * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Extract and load data based on load period mentioned in     * 
 *                 LOAD_CONTROL table                                         * 
 *                                                                            * 
 * Source Table:  CUSTOMER_ACCOUNT_SCORE -                  A5V75JN3.BE00001X * 
 *                 DDS.CUSTOMER_ACCOUNT_SCORE                                 * 
 * Target Table:  SQL Target - martscr.CAS_EXT              A5V75JN3.BP00066F * 
 *============================================================================*/ 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(DDS.CUSTOMER_ACCOUNT_SCORE); 

%let transformID = %quote(A5V75JN3.BO0006YE); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CAS_EXT;
quit;

proc sql;
   create table martscr.CAS_EXT as
      select
         CUSTOMER_ACCOUNT_SCORE.ACCOUNT_RK length = 8
                                           format = 12.
                                           informat = 12.
                                           label = "Account Key",
         &LOAD_STAR_USER_INPUT_DTTM as LOAD_END_DTTM length = 8
                                                     format = NLDATM21.
                                                     informat = NLDATM21.
                                                     label = "Load End Datetime",
         CASE symget('mEngine')           WHEN "ORACLE" THEN datepart(CUSTOMER_ACCOUNT_SCORE.SCORE_DT)         ELSE CUSTOMER_ACCOUNT_SCORE.SCORE_DT END as SCORE_DT length = 8
                                                                                                                                                                    format = NLDATE10.
                                                                                                                                                                    informat = NLDATE10.
                                                                                                                                                                    label = "Score Date",
         CUSTOMER_ACCOUNT_SCORE.MODEL_RK length = 8
                                         format = 12.
                                         informat = 12.
                                         label = "Model Key",
         CUSTOMER_ACCOUNT_SCORE.CUSTOMER_ACCOUNT_SCORE_NO length = 8
                                                          format = NLNUM12.8
                                                          informat = NLNUM12.8
                                                          label = "Customer Account Score No",
         CUSTOMER_ACCOUNT_SCORE.SCORE_POINTS_NO length = 8
                                                label = "Score Points No",
         CUSTOMER_ACCOUNT_SCORE.CR_MITIGANT_ADJUSTED_FLG length = 1
                                                         label = "Cr Mitigant Adjusted Flag",
         CUSTOMER_ACCOUNT_SCORE.PRINCIPAL_ONLY_FLG length = 1
                                                   label = "Principal Only Flag",
         CUSTOMER_ACCOUNT_SCORE.ESTIMATED_RT length = 8
                                             format = NLNUM9.4
                                             informat = NLNUM9.4
                                             label = "Estimated Rate"
      from
         DDS.CUSTOMER_ACCOUNT_SCORE
      where
         CASE symget('mEngine')           WHEN "ORACLE" THEN datepart(CUSTOMER_ACCOUNT_SCORE.SCORE_DT)         ELSE CUSTOMER_ACCOUNT_SCORE.SCORE_DT END >= INTNX('MONTH',&LOAD_STAR_USER_INPUT_DATE,0,'BEGINNING')
         and CASE symget('mEngine')           WHEN "ORACLE" THEN datepart(CUSTOMER_ACCOUNT_SCORE.SCORE_DT)         ELSE CUSTOMER_ACCOUNT_SCORE.SCORE_DT END <= INTNX('MONTH',&LOAD_STAR_USER_INPUT_DATE,0,'END')
      group by
         CUSTOMER_ACCOUNT_SCORE.ACCOUNT_RK, 
         CUSTOMER_ACCOUNT_SCORE.MODEL_RK
      having
         CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(CUSTOMER_ACCOUNT_SCORE.SCORE_DT)
                 ELSE CUSTOMER_ACCOUNT_SCORE.SCORE_DT
         END = MAX(CASE symget('mEngine')  
                 WHEN "ORACLE" THEN datepart(CUSTOMER_ACCOUNT_SCORE.SCORE_DT)
                 ELSE CUSTOMER_ACCOUNT_SCORE.SCORE_DT
         END)
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006YD * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.CAS_EXT              A5V75JN3.BP00066F * 
 * Target Table:  CAS_EXT - martscr.CAS_EXT                 A5V75JN3.BE0000IL * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0004NC * 
 *                                                                            * 
 * User Written:  Creating index on MODEL_RK &              A5V75JN3.AF000PK3 * 
 *                 LOAD_END_DTTM column .                                     * 
 *                Creating index on MODEL_RK & LOAD_END_DTTM column .         * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*Creating index on MODEL_RK and on LOAD_END_DTTM column */
PROC SQL NOPRINT;
  CREATE INDEX  MODEL_RK_LOAD_END_DTTM
   ON martscr.CAS_EXT(MODEL_RK,LOAD_END_DTTM);

QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

