/****************************************************************************** 
 * Job:           CBAC_EXT                                  A5V75JN3.BN00000Q * 
 * Description:   This job picks up data from CORE_BANKING_ACCOUNT_CHNG.      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                CORE_BANKING_ACCOUNT_CHNG -               A5V75JN3.BE00000Z * 
 *                 DDS.CORE_BANKING_ACCOUNT_CHNG                              * 
 * Target Table:  CBAC_EXT - martscr.CBAC_EXT               A5V75JN3.BE0000IO * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 12:45:26 PM IST                * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CBAC_EXT                                                                   * 
 * Job Name: CBAC_EXTJob Desc Pre Process: NoneMain: a) Extract and load      * 
 * data from CORE_BANKING_ACCOUNT_CHNG using SQL join with LOAD_CONTROL       * 
 * table based on conditionsLOAD_CONTROL.LOAD_FLG = CHECK_FLAG_TRUEand        * 
 * LOAD_CONTROL.RUN_STATUS = RUNNING_STATUSand LOAD_CONTROL.LOAD_END_DTTM     * 
 * between CORE_BANKING_ACCOUNT_CHNG.VALID_FROM_DTTM and                      * 
 * CORE_BANKING_ACCOUNT_CHNG.VALID_TO_DTTMPost Process: Creating index on     * 
 * ACCOUNT_RK and LOAD_END_DTTM.Parameters: CHECK_FLAG_TRUE and               * 
 * RUNNING_STATUS are the user defined parameters. CHECK_FLAG_TRUE is set     * 
 * to 'Y' and RUNNING_STATUS is to 'Running' for each month of data           * 
 *  load.Developed by: singupReviewed by:Tested by:                           * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00000Q);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CBAC_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004NF * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PKZ * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=dds.core_banking_account_chng out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Extraction of data as per the loading     A5V75JN3.BO0006YI * 
 *                 period                                                     * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Extract and load data based on load period mentioned in     * 
 *                 LOAD_CONTROL table                                         * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                CORE_BANKING_ACCOUNT_CHNG -               A5V75JN3.BE00000Z * 
 *                 DDS.CORE_BANKING_ACCOUNT_CHNG                              * 
 * Target Table:  SQL Target - martscr.CBAC_EXT             A5V75JN3.BP00066H * 
 *============================================================================*/ 

/* Access the data for Control  */ 
LIBNAME control BASE "Data/bisdata/control" ;
%rcSet(&syslibrc); 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0006YI); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CBAC_EXT;
quit;

proc sql;
   create table martscr.CBAC_EXT as
      select
         CORE_BANKING_ACCOUNT_CHNG.ACCOUNT_RK length = 8
                                              format = 12.
                                              informat = 12.
                                              label = "Account Key",
         LOAD_CONTROL.LOAD_END_DTTM length = 8
                                    format = NLDATM21.
                                    informat = NLDATM21.
                                    label = "Load End Datetime",
         CORE_BANKING_ACCOUNT_CHNG.CLEARED_BALANCE_AMT length = 8
                                                       format = NLNUM18.5
                                                       informat = NLNUM18.5
                                                       label = "Cleared Balance Amount",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(CORE_BANKING_ACCOUNT_CHNG.NEXT_INTEREST_PAID_DT)
         	ELSE CORE_BANKING_ACCOUNT_CHNG.NEXT_INTEREST_PAID_DT
         END as NEXT_INTEREST_PAYMENT_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Next Interest Paid Date"
      from
         control.LOAD_CONTROL, 
         DDS.CORE_BANKING_ACCOUNT_CHNG
      where
         LOAD_CONTROL.LOAD_FLG IN (&CHECK_FLAG_TRUE)
         and LOAD_CONTROL.RUN_STATUS IN (&RUNNING_STATUS)
         and LOAD_CONTROL.LOAD_END_DTTM >= CORE_BANKING_ACCOUNT_CHNG.VALID_FROM_DTTM
         and LOAD_CONTROL.LOAD_END_DTTM <= CORE_BANKING_ACCOUNT_CHNG.VALID_TO_DTTM
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify CBAC_EXT;
         ic create not null (ACCOUNT_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006YH * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.CBAC_EXT             A5V75JN3.BP00066H * 
 * Target Table:  CBAC_EXT - martscr.CBAC_EXT               A5V75JN3.BE0000IO * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0004NG * 
 *                                                                            * 
 * User Written:  Index creation on ACCOUNT_RK and          A5V75JN3.AF000PL0 * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on ACCOUNT_RK and LOAD_END_DTTM              * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on ACCOUNT_RK and LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX ACCOUNT_RK_LOAD_END_DTTM
      ON martscr.CBAC_EXT(ACCOUNT_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

