/****************************************************************************** 
 * Job:           CREDIT_BUREAU_PRE_DETAIL                  A5V75JN3.BN00003G * 
 * Description:   This job picks up the data from BU_EXT and CBI_EXT by       * 
 *                 creating (inner) join on the BUREAU_CD and LOAD_END_DTTM   * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: CBI_EXT - martscr.CBI_EXT                 A5V75JN3.BE0000IP * 
 *                BU_EXT - martscr.BU_EXT                   A5V75JN3.BE0000IJ * 
 * Target Table:  CREDIT_BUREAU_PRE_DETAIL -                A5V75JN3.BE0000LE * 
 *                 martscr.CREDIT_BUREAU_PRE_DETAIL                           * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 12:48:18 PM IST                * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CREDIT_BUREAU_PRE_DETAIL                                                   * 
 * Job Name: CREDIT_BUREAU_PRE_DETAILJob Desc Pre Process: NoneMain: a) This  * 
 * job picks up the data from BU_EXT and CBI_EXT by creating inner join on    * 
 * BUREAU_CD and LOAD_END_DTTMb) Preparing the data for populating the        * 
 * CORPORATE_FINANCIAL_PRE_DETAIL table by inner joining table BU_EXT and     * 
 * CBI_EXT on BUREAU_CD and LOAD_END_DTTM.Post Process: NoneParameters:       * 
 *  NoneDeveloped by: sinabcReviewed by: sinabcTested by:                     * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00003G);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CREDIT_BUREAU_PRE_DETAIL;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          CREDIT BUREAU PRE DETAIL                  A5V75JN3.BO00006V * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   inner joining   table BU_EXT and CBI_EXT  on BUREAU_CD and  * 
 *                 LOAD_END_DTTM to populate CREDIT_BUREAU_PRE_DETAIL         * 
 *                                                                            * 
 * Source Tables: CBI_EXT - martscr.CBI_EXT                 A5V75JN3.BE0000IP * 
 *                BU_EXT - martscr.BU_EXT                   A5V75JN3.BE0000IJ * 
 * Target Table:  SQL Target -                              A5V75JN3.BP00003J * 
 *                 martscr.CREDIT_BUREAU_BEFORE_PRE_DETAIL                    * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO00006V); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CREDIT_BUREAU_BEFORE_PRE_DETAIL;
quit;

proc sql;
   create table martscr.CREDIT_BUREAU_BEFORE_PRE_DETAIL as
      select
         CBI_EXT.BUREAU_INFO_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "Bureau Info Key",
         BU_EXT.LOAD_END_DTTM length = 8
                              format = NLDATM21.
                              informat = NLDATM21.
                              label = "Load End Datetime",
         CBI_EXT.FINANCIAL_APPLICATION_RK length = 8
                                          format = 12.
                                          informat = 12.
                                          label = "Financial Application Key",
         CBI_EXT.CUSTOMER_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "Customer Key",
         CBI_EXT.OWNER_RK length = 8
                          format = 12.
                          informat = 12.
                          label = "Owner Key",
         CBI_EXT.APPLICANT_RK length = 8
                              format = 12.
                              informat = 12.
                              label = "Applicant Key",
         CBI_EXT.REQUEST_DT length = 8
                            format = NLDATE10.
                            informat = NLDATE10.
                            label = "Request Date",
         CBI_EXT.SCORE_NO length = 8
                          format = NLNUM6.2
                          informat = NLNUM6.2
                          label = "Score No",
         CBI_EXT.SCORE_DT length = 8
                          format = NLDATE10.
                          informat = NLDATE10.
                          label = "Score Date",
         CBI_EXT.BUREAU_CLASS_CD length = 3
                                 label = "Bureau Class Code",
         CBI_EXT.TOTAL_BALANCE_AMT length = 8
                                   format = NLNUM18.5
                                   informat = NLNUM18.5
                                   label = "Total Balance Amount",
         CBI_EXT.TOT_MTH_PAYMENT_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Total Monthly Payment Amount",
         CBI_EXT.OPEN_ACCT_CNT length = 8
                               label = "Open Account Count",
         CBI_EXT.CLOSED_ACCT_CNT length = 8
                                 label = "Closed Account count",
         CBI_EXT.DELINQUENT_ACCT_CNT length = 8
                                     label = "Delinquent Account Count",
         CBI_EXT.DEROGATORY_ACCT_CNT length = 8
                                     label = "Derogatory Account Count",
         CBI_EXT.GOOD_ACCT_CNT length = 8
                               label = "Good Account Count",
         CBI_EXT.CREDIT_ACTIVE_DT length = 8
                                  format = NLDATE10.
                                  informat = NLDATE10.
                                  label = "Credit Active Date",
         CBI_EXT.CURRENT_CREDIT_PCT length = 8
                                    format = NLNUM9.4
                                    informat = NLNUM9.4
                                    label = "Current Credit Percentage",
         CBI_EXT.REVOLVING_DEBT_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Revolving Debt Amount",
         CBI_EXT.REAL_ESTATE_DEBT_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Real Estate Debt Amount",
         CBI_EXT.INSTALLMENT_DEBT_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Installment Debt Amount",
         CBI_EXT.OTHER_DEBT_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Other Debt Amount",
         CBI_EXT.COLLECTION_DEBT_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Collection Debt Amount",
         CBI_EXT.TOT_PAST_DUE_SLOW_30_AMT length = 8
                                          format = NLNUM18.5
                                          informat = NLNUM18.5
                                          label = "Total Amount Past Due for 30 days",
         CBI_EXT.TOT_PAST_DUE_SLOW_90_AMT length = 8
                                          format = NLNUM18.5
                                          informat = NLNUM18.5
                                          label = "Total Amount Past Due for 90 days",
         CBI_EXT.HIGHEST_CREDIT_LIMIT_AMT length = 8
                                          format = NLNUM18.5
                                          informat = NLNUM18.5
                                          label = "Highest Credit Limit Amount",
         CBI_EXT.CURRENT_CREDIT_LIMIT_AMT length = 8
                                          format = NLNUM18.5
                                          informat = NLNUM18.5
                                          label = "Current Credit Limit Amount",
         CBI_EXT.OTHER_INQUIRY_BUREAU_CNT length = 8
                                          label = "No of Inquiries by Other Bureaus",
         CBI_EXT.OTHER_LAST_INQUIRY_DT length = 8
                                       format = NLDATE10.
                                       informat = NLDATE10.
                                       label = "Last Inquiry Date by other Bureau",
         CBI_EXT.MONTHS_SINCE_AT_BUREAU length = 8
                                        format = NLNUM6.2
                                        informat = NLNUM6.2
                                        label = "No of Months At Bureau",
         CBI_EXT.EVER_IN_COLLECTION_FLG length = 1
                                        label = "Ever Into Collection Flag",
         CBI_EXT.CHARGE_OFF_CNT length = 8
                                label = "Charge Off Count",
         CBI_EXT.LIENS_CNT length = 8
                           label = "Liens Count",
         CBI_EXT.LAST_LIEN_DT length = 8
                              format = NLDATE10.
                              informat = NLDATE10.
                              label = "Last Lien Date",
         CBI_EXT.BANKRUPTCY_FILED_DT length = 8
                                     format = NLDATE10.
                                     informat = NLDATE10.
                                     label = "Bankruptcy Filed Date",
         CBI_EXT.BANKRUPTCY_STATUS_CD length = 3
                                      label = "Bankruptcy Status Code",
         CBI_EXT.BANKRUPTCY_CNT length = 8
                                label = "Bankruptcy Count",
         CBI_EXT.WORST_RATING_12_MTH_NO length = 8
                                        label = "Worst Rating No in Last 12 Months",
         CBI_EXT.FRAUD_FLG length = 1
                           label = "Fraud Flag",
         CBI_EXT.JUDGEMENTS_CNT length = 8
                                label = "Judgements Count",
         CBI_EXT.LAST_JUDGEMENT_DT length = 8
                                   format = NLDATE10.
                                   informat = NLDATE10.
                                   label = "Last Judgement Date",
         CBI_EXT.PUBLIC_RECORD_CNT length = 8
                                   label = "Public Records Count",
         BU_EXT.BUREAU_DESC length = 100
                            label = "Bureau Description",
         BU_EXT.BUREAU_SRL_NO length = 8
                              format = NLNUM6.2
                              informat = NLNUM6.2
                              label = "Bureau Serial No",
         CBI_EXT.BUREAU_CD length = 3
                           label = "Bureau Code"
      from
         martscr.CBI_EXT, 
         martscr.BU_EXT
      where
         CBI_EXT.LOAD_END_DTTM = BU_EXT.LOAD_END_DTTM
         and CBI_EXT.BUREAU_CD = BU_EXT.BUREAU_CD
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify CREDIT_BUREAU_BEFORE_PRE_DETAIL;
         ic create not null (BUREAU_INFO_RK);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Code to Generate Credit Bureau Pre        A5V75JN3.BO00006X * 
 *                 Details                                                    * 
 * Transform:     User Written Code                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A5V75JN3.BP00003J * 
 *                 martscr.CREDIT_BUREAU_BEFORE_PRE_DETAIL                    * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP00003K * 
 *                 martscr.CREDIT_BUREAU_PRE_DETAIL                           * 
 *                                                                            * 
 * User Written:  Code to Generate Credit Bureau Details    A5V75JN3.AF0008TQ * 
 *                Code to Generate Credit Bureau Details before SCD2          * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(martscr.CREDIT_BUREAU_BEFORE_PRE_DETAIL); 

%let transformID = %quote(A5V75JN3.BO00006X); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.CREDIT_BUREAU_PRE_DETAIL); 

/*---- Start of User Written Code  ----*/ 

%let sort_col=BUREAU_INFO_RK CUSTOMER_RK OWNER_RK APPLICANT_RK FINANCIAL_APPLICATION_RK LOAD_END_DTTM;
/* CS4.3 HF2 */
/* BUREAU_INFO_RK is added to the stl_str. This will correctly find out the duplicates. */

%let etl_str=KTRIM(KLEFT(BUREAU_INFO_RK))|| KTRIM(KLEFT(BUREAU_DESC)) || KTRIM(KLEFT(BUREAU_SRL_NO)) 
|| KTRIM(KLEFT(APPLICANT_RK)) || KTRIM(KLEFT(BANKRUPTCY_CNT)) || KTRIM(KLEFT(BANKRUPTCY_FILED_DT)) 
|| KTRIM(KLEFT(BANKRUPTCY_STATUS_CD)) || KTRIM(KLEFT(BUREAU_CD)) || KTRIM(KLEFT(BUREAU_CLASS_CD)) 
|| KTRIM(KLEFT(CHARGE_OFF_CNT)) || KTRIM(KLEFT(CLOSED_ACCOUNT_CNT)) || KTRIM(KLEFT(COLLECTION_DEBT_AMT)) 
|| KTRIM(KLEFT(CREDIT_ACTIVE_DT)) || KTRIM(KLEFT(CURRENT_CREDIT_LIMIT_AMT)) || KTRIM(KLEFT(CURRENT_CREDIT_PCT))
|| KTRIM(KLEFT(CUSTOMER_RK)) || KTRIM(KLEFT(DELINQUENT_ACCT_CNT)) || KTRIM(KLEFT(DEROGATORY_ACCT_CNT)) 
|| KTRIM(KLEFT(EVER_IN_COLLECTION_FLG)) || KTRIM(KLEFT(FINANCIAL_APPLICATION_RK)) || KTRIM(KLEFT(FRAUD_FLG))
|| KTRIM(KLEFT(FINANCIAL_APPLICATION_RK)) || KTRIM(KLEFT(GOOD_ACCT_CNT)) || KTRIM(KLEFT(GOOD_ACCT_CNT)) 
|| KTRIM(KLEFT(HIGHEST_CREDIT_LIMIT_AMT)) || KTRIM(KLEFT(INSTALLMENT_DEBT_AMT)) || KTRIM(KLEFT(JUDGEMENT_CNT))
|| KTRIM(KLEFT(LAST_JUDGEMENT_DT)) || KTRIM(KLEFT(LAST_LIEN_DT)) || KTRIM(KLEFT(LIEN_CNT)) 
|| KTRIM(KLEFT(MONTHS_SINCE_AT_BUREAU)) || KTRIM(KLEFT(LIEN_CNT)) || KTRIM(KLEFT(OPEN_ACCT_CNT)) 
|| KTRIM(KLEFT(LIEN_CNT)) || KTRIM(KLEFT(LIEN_CNT)) || KTRIM(KLEFT(OPEN_ACCT_CNT)) || KTRIM(KLEFT(OTHER_DEBT_AMT)) 
|| KTRIM(KLEFT(OTHER_INQUIRY_BUREAU_CNT)) || KTRIM(KLEFT(OTHER_LAST_INQUIRY_DT)) || KTRIM(KLEFT(OWNER_RK)) 
|| KTRIM(KLEFT(PUBLIC_RECORD_CNT)) || KTRIM(KLEFT(REQUEST_DT)) || KTRIM(KLEFT(REVOLVING_DEBT_AMT)) 
|| KTRIM(KLEFT(SCORE_DT)) || KTRIM(KLEFT(SCORE_NO)) || KTRIM(KLEFT(TOT_PAST_DUE_SLOW_30_AMT)) 
|| KTRIM(KLEFT(TOT_MTH_PAYMENT_AMT)) || KTRIM(KLEFT(TOT_PAST_DUE_SLOW_90_AMT)) || KTRIM(KLEFT(TOTAL_BALANCE_AMT))
|| KTRIM(KLEFT(WORST_RATING_12_MTH_NO));    
%deduplicate(in_table=&SYSLAST,sort_col=&sort_col,out_table=&_OUTPUT,etls_str_in=&etl_str)
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO00006W * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP00003K * 
 *                 martscr.CREDIT_BUREAU_PRE_DETAIL                           * 
 * Target Table:  CREDIT_BUREAU_PRE_DETAIL -                A5V75JN3.BE0000LE * 
 *                 martscr.CREDIT_BUREAU_PRE_DETAIL                           * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
