/****************************************************************************** 
 * Job:           CS_SCORING_INPUT                          A5V75JN3.BN0000VS * 
 * Description:   This job picks up information for model_input table and     * 
 *                 builds the staging area for scoring models.                * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Generated on:  Friday, December 26, 2008 10:24:56 AM IST                   * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

%let jobID = %quote(A5V75JN3.BN0000VS);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CS_SCORING_INPUT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Creating input dataset for scoring models A5V75JN3.BO0005NV * 
 * Transform:     User Written Code                                           * 
 * Description:   Creating input dataset for scoring models                   * 
 *                                                                            * 
 * Target Table:  User Written Code Target - work.          A5V75JN3.BP0004SG * 
 *                                                                            * 
 * User Written:  Creating input dataset for scoring models A5V75JN3.AF000MNB * 
 *                Creating input dataset for scoring models                   * 
 *============================================================================*/ 

%let transformID = %quote(A5V75JN3.BO0005NV); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.A5V75JN3_BP0004SG); 

/*---- Start of User Written Code  ----*/ 

/* 
1. The total count of models are obtained from MODEL_INPUT table where the STATUS is
 as given by the parameter CS_MODEL_STATUS and ABT_TYPE is as given by CS_ABT_TYPE_SCR
 or CS_ABT_TYPE_MODEL, this parameter denotes that the type is scoring or modelling.
2. The table names are picked up from the MODEL_INPUT table for each model.
3. Check whether the dataset MODEL_INPUT contains all information for each model.
 If for a model all the tables, that is SCR_CARD_EXP_TABLE_NM, SCR_CARD_ODDS_TABLE_NM
 and SCR_CARD_RANGE_TABLE_NM are not provided, or if the given datasets do not exist
 then information for that model is not included in the output dataset, and a message
 is written to the log.
4. Only the PDO model i.e. ongoing PD model is considered. Currently the application PD Models are not
considered.
5. If all information is provided and all dataset exist for a given model then,
 a) If the ABT_TYPE is score then
  1) The dataset ACCOUNT_SCORE is created, containing the information provided in the
   dataset given by SCR_CARD_ODDS_TABLE_NM for each model, by first transposing the
   given dataset(SCR_CARD_ODDS_TABLE_NM) and obtaining the group variable and then
   appending the data for all the models provided.
  2) The dataset SCORE_CARD_RANGE is created, containing the information provided in
   the dataset given by SCR_CARD_RNG_TABLE_NM for each model, by first obtaining the 
   FROM_SCORE and TO_SCORE from the _CUTOFF_SCORE_ as given in the dataset
   (SCR_CARD_RNG_TABLE_NM), and then appending the data for all the models provided.
 b) If the ABT_TYPE is model then
  1) The dataset VARIABLE_GROUPS_MODEL is created, containing the information provided
   in the dataset given by SCR_CARD_EXP_TABLE_NM for each model, by appending the
   data for all the models provided.
  2) The dataset ACCOUNT_MODEL_SCORE is created, containing the information provided in the
   dataset given by SCR_CARD_ODDS_TABLE_NM for each model, by first transposing the
   given dataset(SCR_CARD_ODDS_TABLE_NM) and obtaining the group variable and then
   appending the data for all the models provided.
*/

%let inlib = mdlmart;/* 
1. The total count of models are obtained from MODEL_INPUT table where the STATUS is
 as given by the parameter CS_MODEL_STATUS and ABT_TYPE is as given by CS_ABT_TYPE_SCR
 or CS_ABT_TYPE_MODEL, this parameter denotes that the type is scoring or modelling.
2. The table names are picked up from the MODEL_INPUT table for each model.
3. Check whether the dataset MODEL_INPUT contains all information for each model.
 If for a model all the tables, that is SCR_CARD_EXP_TABLE_NM, SCR_CARD_ODDS_TABLE_NM
 and SCR_CARD_RANGE_TABLE_NM are not provided, or if the given datasets do not exist
 then information for that model is not included in the output dataset, and a message
 is written to the log.
4. Only the PDO model i.e. ongoing PD model is considered.
5. If all information is provided and all dataset exist for a given model then,
 a) If the ABT_TYPE is score then
  1) The dataset ACCOUNT_SCORE is created, containing the information provided in the
   dataset given by SCR_CARD_ODDS_TABLE_NM for each model, by first transposing the
   given dataset(SCR_CARD_ODDS_TABLE_NM) and obtaining the group variable and then
   appending the data for all the models provided.
  2) The dataset SCORE_CARD_RANGE is created, containing the information provided in
   the dataset given by SCR_CARD_RNG_TABLE_NM for each model, by first obtaining the 
   FROM_SCORE and TO_SCORE from the _CUTOFF_SCORE_ as given in the dataset
   (SCR_CARD_RNG_TABLE_NM), and then appending the data for all the models provided.
 b) If the ABT_TYPE is model then
  1) The dataset VARIABLE_GROUPS_MODEL is created, containing the information provided
   in the dataset given by SCR_CARD_EXP_TABLE_NM for each model, by appending the
   data for all the models provided.
  2) The dataset ACCOUNT_MODEL_SCORE is created, containing the information provided in the
   dataset given by SCR_CARD_ODDS_TABLE_NM for each model, by first transposing the
   given dataset(SCR_CARD_ODDS_TABLE_NM) and obtaining the group variable and then
   appending the data for all the models provided.
*/

%let inlib = mdlmart;

%macro scorecard;
 %let tot_tbl = .;
 /* To obtain the count of models, where the status is as given by the parameter
  CS_MODEL_STATUS */
 data martscr.variable_groups_model;
  attrib VARIABLE_NAME length = $100 format = $100. informat = $100.;
  attrib VARIABLE_GROUP_NO length = 8;
  attrib VARIABLE_GROUP_LABEL length = $100 format = $100. informat = $100.;
  attrib SCORE_CARD_POINTS length = 8;
  attrib MODEL_SK length = 8 format = 12. informat = 12.;
  stop;
 run;

 data martscr.account_score;
  attrib MODEL_sk length = 8 format = 12. informat = 12.;
  attrib ACCOUNT_RK length = 8 format = 12. informat = 12.;
  attrib VARIABLE_NAME length = $100 format = $100. informat = $100.;
  attrib VARIABLE_GROUP_NO length = 8;
  attrib SCORE_POINTS length = 8;
  attrib TARGET_PERIOD_MTHS_CNT length = 8;
  attrib CUT_OFF_SCORE length = 8;
  stop;
 run;

 data martscr.account_model_score;
  attrib MODEL_SK length = 8 format = 12. informat = 12.;
  attrib ACCOUNT_RK length = 8 format = 12. informat = 12.;
  attrib VARIABLE_NAME length = $100 format = $100. informat = $100.;
  attrib VARIABLE_GROUP_NO length = 8;
  attrib SCORE_POINTS length = 8;
  attrib CUT_OFF_SCORE length = 8;
  attrib TGT_VAR length = 8;
  stop;
 run;

 data martscr.score_card_range;
  attrib MODEL_SK length = 8 format = 12. informat = 12.;
  attrib FROM_SCORE length = 8;
  attrib TO_SCORE length = 8;
  stop;
 run;

 proc sql noprint;
  select count(*) into :tot_tbl from &inlib..model_input
  where kupcase(status) IN (%sysfunc(kupcase(&CS_MODEL_STATUS)))
   and kupcase(ABT_TYPE) IN (%sysfunc(kupcase(&CS_ABT_TYPE_SCR)),%sysfunc(kupcase(&CS_ABT_TYPE_MDL)));
 quit;
 %let tot_tbl = %sysfunc(ktrim(%sysfunc(kleft(&tot_tbl))));

 %if (&tot_tbl > 0) %then %do;
  %do tbl_no=1 %to &tot_tbl;
   %let exp_tbl_nm&tbl_no = .;
   %let mdl_nm&tbl_no = .;
   %let odds_tbl_nm&tbl_no = .;
   %let rng_tbl_nm&tbl_no = .;
   %let abt_type&tbl_no = .;
  %end; 
 
  /* To obtain the table names and model names in array of macros, where the status is
   as given by the parameter CS_MODEL_STATUS */
  proc sql noprint;
   select SCR_CARD_EXP_TABLE_NM, MODEL_NM, SCR_CARD_ODDS_TABLE_NM,
      SCR_CARD_RANGE_TABLE_NM, ABT_TYPE
     into :exp_tbl_nm1 - :exp_tbl_nm&tot_tbl,
      :mdl_nm1 - :mdl_nm&tot_tbl,
      :odds_tbl_nm1 - :odds_tbl_nm&tot_tbl,
      :rng_tbl_nm1 - :rng_tbl_nm&tot_tbl,
      :abt_type1 - :abt_type&tot_tbl
   from &inlib..model_input
   where kupcase(status) IN (%sysfunc(kupcase(&CS_MODEL_STATUS)))
    and kupcase(ABT_TYPE) IN (%sysfunc(kupcase(&CS_ABT_TYPE_SCR)),%sysfunc(kupcase(&CS_ABT_TYPE_MDL)));
  quit;
 
  %do tbl_no=1 %to &tot_tbl;
   %let exp_tbl_nm&tbl_no = %sysfunc(ktrim(%sysfunc(kleft(&&exp_tbl_nm&tbl_no))));
   %let mdl_nm&tbl_no = %sysfunc(ktrim(%sysfunc(kleft(&&mdl_nm&tbl_no))));
   %let odds_tbl_nm&tbl_no = %sysfunc(ktrim(%sysfunc(kleft(&&odds_tbl_nm&tbl_no))));
   %let rng_tbl_nm&tbl_no = %sysfunc(ktrim(%sysfunc(kleft(&&rng_tbl_nm&tbl_no))));
   %let abt_type&tbl_no = %quote(%'%sysfunc(ktrim(%sysfunc(kleft(&&abt_type&tbl_no))))%');

   %if (&&mdl_nm&tbl_no eq %str()) %then %do;
    %put "ERROR: Provide MODEL_NM for Model&tbl_no";

    proc sql noprint;
     update &inlib..model_input
     set status = 'ERROR'
     where MODEL_NM = "&&mdl_nm&tbl_no"
      and ABT_TYPE = %unquote(&&abt_type&tbl_no);
    quit;
   %end;
   %else %do;
    %let mdl_sk = .;
    %let mdl_type_cd =;
    %let cut_off = .;
    %let tgt_mths_cnt = .;

    proc sql noprint;
     select model_sk, model_type_cd, cut_off_score,
       target_period_mths_cnt
       into :mdl_sk, :mdl_type_cd, :cut_off, :tgt_mths_cnt
     from martscr.ANALYTICAL_MODEL_DIM_EXT
     where ANALYTICAL_MODEL_DIM_EXT.model_nm = "&&mdl_nm&tbl_no";
    quit;

    %let mdl_sk = %sysfunc(ktrim(%sysfunc(kleft(&mdl_sk))));
    %let mdl_type_cd = %quote(%'%sysfunc(ktrim(%sysfunc(kleft(&mdl_type_cd))))%');
    %let cut_off = %sysfunc(ktrim(%sysfunc(kleft(&cut_off))));
    %let tgt_mths_cnt = %sysfunc(ktrim(%sysfunc(kleft(&tgt_mths_cnt))));

    %if (%sysfunc(kupcase(&mdl_type_cd)) eq %sysfunc(kupcase(&PD_ONG_MODEL)) or 
			%sysfunc(kupcase(&mdl_type_cd)) eq %sysfunc(kupcase(&PD_APP_MODEL))) %then %do; 
     %if (&&abt_type&tbl_no eq &CS_ABT_TYPE_SCR) %then %do; 
      %if (&&odds_tbl_nm&tbl_no eq %str() or
        &&rng_tbl_nm&tbl_no eq %str()) %then %do;
       %if (&&odds_tbl_nm&tbl_no eq %str()) %then %do;
        %put "ERROR: Provide SCR_CARD_ODDS_TABLE_NM for Model&tbl_no";
       %end;
       %if (&&rng_tbl_nm&tbl_no eq %str()) %then %do;
        %put "ERROR: Provide SCR_CARD_RANGE_TABLE_NM for Model&tbl_no";
       %end;

        proc sql noprint;
        update &inlib..model_input
        set status = 'ERROR'
        where MODEL_NM = "&&mdl_nm&tbl_no"
         and ABT_TYPE = %unquote(&&abt_type&tbl_no);
        quit;

      %end;
      %else %do;
       %if (%sysfunc(exist(&inlib..&&odds_tbl_nm&tbl_no)) eq 0 or
           %sysfunc(exist(&inlib..&&rng_tbl_nm&tbl_no)) eq 0) %then %do;
        %if(%sysfunc(exist(&inlib..&&odds_tbl_nm&tbl_no)) eq 0) %then %do;
         %put "ERROR: The dataset &inlib..&&odds_tbl_nm&tbl_no does not exist";
        %end;
        %if(%sysfunc(exist(&inlib..&&rng_tbl_nm&tbl_no)) eq 0) %then %do;
         %put "ERROR: The dataset &inlib..&&rng_tbl_nm&tbl_no does not exist";
        %end;

        proc sql noprint;
        update &inlib..model_input
        set status = 'ERROR'
        where MODEL_NM = "&&mdl_nm&tbl_no"
         and ABT_TYPE = %unquote(&&abt_type&tbl_no);
        quit;

       %end;
       %else %do;
			
		  proc sort data=&inlib..&&odds_tbl_nm&tbl_no force;
         by account_rk scorecard_points;
        run;
    
        proc transpose data=&inlib..&&odds_tbl_nm&tbl_no
          out = work.odds_table&tbl_no(rename=(scorecard_points=SCORE_POINTS 
                    col1 = VARIABLE_GROUP_NO
                  _name_ = VARIABLE_NAME) drop=_LABEL_);
         var GRP_:;
         by account_rk scorecard_points;
        run;
    
        data work.odds_table&tbl_no;
         length VARIABLE_NAME $100;
         set work.odds_table&tbl_no;
         MODEL_SK = &mdl_sk;
         VARIABLE_NAME = ksubstr(VARIABLE_NAME,5);
         TARGET_PERIOD_MTHS_CNT = &tgt_mths_cnt;
         CUT_OFF_SCORE = &cut_off;
        run;
/* Start of CS4.3 HF2 */     
/* Sorting on _cutoff_score_. 
One (and only one) row having _cutoff_score_ = . (Missing) is expected to be present in the eminer dataset */
		  %let max_scr = .;

/* Note that the where clause present in the following proc sort has been removed
as a part of CS4.3 HF2 */
/* End of CS4.3 HF2 */

		  proc sort data=&inlib..&&rng_tbl_nm&tbl_no  
                   out=work.range_sorted&tbl_no NODUPKEY force;
         by _cutoff_score_;
        run;
    
        data work.range_table&tbl_no;
         set work.range_sorted&tbl_no;
         MODEL_SK = &mdl_sk;
         retain FROM_SCORE TO_SCORE;
/* Start of CS4.3 HF2 */  
/* The FROM_SCORE, TO_SCORE values have been changed as a part of CS4.3 HF2*/
         if _N_ = 1 then do;
          FROM_SCORE = _cutoff_score_;
          TO_SCORE = 0;
			 max_v = 0;
         end;
         else do;
          FROM_SCORE = TO_SCORE;
          TO_SCORE = _cutoff_score_;
/* CS4.3 HF2 */
/* The following line is added as a part of CS4.3 HF2 */
			 max_v = MAX(max_v, _cutoff_score_);
         end;
/* CS4.3 HF2 */
/* The following line is added as a part of CS4.3 HF2 */
			call symput ('max_scr',max_v);
         keep FROM_SCORE TO_SCORE MODEL_SK;
        run;
    
/* Inserting a row of max_score and parameter MAX_VALUE in the table. 
This is added for CS4.3 HF2 */

		  proc sql;
				insert into work.range_table&tbl_no
				values (&mdl_sk,&max_scr,&MAX_VALUE);
  		  quit;

/* The if else condition - %if &tbl_no = 1 is removed from the code as a part of CS4.3 HF2 */


         proc append base=martscr.account_score data=work.odds_table&tbl_no force;
         run;
         proc append base=martscr.score_card_range data=work.range_table&tbl_no force;
         run;

/* End of CS4.3 HF2 */

       %end;
      %end;
     %end;
     %if (&&abt_type&tbl_no eq &CS_ABT_TYPE_MDL) %then %do; 
      %if (&&exp_tbl_nm&tbl_no eq %str() or
        &&odds_tbl_nm&tbl_no eq %str()) %then %do;
       %if (&&exp_tbl_nm&tbl_no eq %str()) %then %do;
        %put "ERROR: Provide SCR_CARD_EXP_TABLE_NM for Model&tbl_no";
       %end;
       %if (&&odds_tbl_nm&tbl_no eq %str()) %then %do;
        %put "ERROR: Provide SCR_CARD_ODDS_TABLE_NM for Model&tbl_no";
       %end;

        proc sql noprint;
        update &inlib..model_input
        set status = 'ERROR'
        where MODEL_NM = "&&mdl_nm&tbl_no"
         and ABT_TYPE = %unquote(&&abt_type&tbl_no);
        quit;

      %end;
      %else %do;
       %if (%sysfunc(exist(&inlib..&&exp_tbl_nm&tbl_no)) eq 0 or
          %sysfunc(exist(&inlib..&&odds_tbl_nm&tbl_no)) eq 0) %then %do;
        %if(%sysfunc(exist(&inlib..&&exp_tbl_nm&tbl_no)) eq 0) %then %do;
         %put "ERROR: The dataset &inlib..&&exp_tbl_nm&tbl_no does not exist";

        %end;
        %if(%sysfunc(exist(&inlib..&&odds_tbl_nm&tbl_no)) eq 0) %then %do;
         %put "ERROR: The dataset &inlib..&&odds_tbl_nm&tbl_no does not exist";
        %end;

        proc sql noprint;
        update &inlib..model_input
        set status = 'ERROR'
        where MODEL_NM = "&&mdl_nm&tbl_no"
         and ABT_TYPE = %unquote(&&abt_type&tbl_no);
        quit;

       %end;
       %else %do;
		 
		 proc sql noprint;
				create table work.temp_exp_Table as
				select * from &inlib..&&exp_tbl_nm&tbl_no 
				where _group_ ne -2;
			quit;
			
			proc sql noprint;
				update work.temp_exp_Table
				set _label_ =  ktrim(kleft(_variable_))||"="||ktrim(kleft(_label_))
				where index(ktrim(kleft(_label_)),ktrim(kleft(_variable_))) = 0;
			quit;
			data work.exp_table&tbl_no(keep = VARIABLE_NAME VARIABLE_GROUP_NO
               VARIABLE_GROUP_LABEL SCORE_CARD_POINTS MODEL_SK);
         length VARIABLE_NAME VARIABLE_GROUP_LABEL $100;
         set work.temp_exp_Table(rename = (_variable_ = VARIABLE_NAME
                   _group_ = VARIABLE_GROUP_NO 
                   _label_ = VARIABLE_GROUP_LABEL
                  scorecard_points = SCORE_CARD_POINTS)
                 );
         MODEL_SK = &mdl_sk;
        run;
        /* To obtain the variable information */
/*        data work.exp_table&tbl_no(keep = VARIABLE_NAME VARIABLE_GROUP_NO*/
/*               VARIABLE_GROUP_LABEL SCORE_CARD_POINTS MODEL_SK);*/
/*         length VARIABLE_NAME VARIABLE_GROUP_LABEL $100;*/
/*         set &inlib..&&exp_tbl_nm&tbl_no(rename = (_variable_ = VARIABLE_NAME*/
/*                   _group_ = VARIABLE_GROUP_NO */
/*                   _label_ = VARIABLE_GROUP_LABEL*/
/*                  scorecard_points = SCORE_CARD_POINTS)*/
/*                 );*/
/*         MODEL_SK = &mdl_sk;*/
/*        run;*/
    
        proc sort data=&inlib..&&odds_tbl_nm&tbl_no force;
         by account_rk scorecard_points;
        run;
    
        proc transpose data=&inlib..&&odds_tbl_nm&tbl_no
          out = work.odds_table&tbl_no(rename=(scorecard_points=SCORE_POINTS 
                    col1 = VARIABLE_GROUP_NO
                  _name_ = VARIABLE_NAME) drop=_LABEL_);
         var GRP_:;
         by account_rk scorecard_points tgt_var; /* CS4.3 HF2 - added tgt_var*/
        run;
    
        data work.odds_table&tbl_no;
         length VARIABLE_NAME $100;
         set work.odds_table&tbl_no;
         MODEL_SK = &mdl_sk;
         CUT_OFF_SCORE = &cut_off;
         VARIABLE_NAME = ksubstr(VARIABLE_NAME,5);
        run;

/* Start of CS4.3 HF2 */ 
/* The if else condition - %if &tbl_no = 1 is removed from the code as a part of CS4.3 HF2 */  

         proc append base=martscr.variable_groups_model data=work.exp_table&tbl_no force;
         run;
         proc append base=martscr.account_model_score data=work.odds_table&tbl_no force;
         run;

/* End of CS4.3 HF2 */

       %end;
      %end;
     %end;
    %end;
   %end;
  %end;
 %end;
%mend scorecard;
%scorecard;


/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

