/****************************************************************************** 
 * Job:           CUSTOMER_PRE_DIM                          A5V75JN3.BN00007O * 
 * Description:   This job picks up data from CUS_FU_L and CUS_MONTHLY_DATA   * 
 *                by performing left join on CUS_FU_L for the CUSTOMER        * 
 *                 pre-dimension table.                                       * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: CA_EXT - martscr.CA_EXT                   A5V75JN3.BE0000IK * 
 *                CT_EXT - martscr.CT_EXT                   A5V75JN3.BE0000J6 * 
 *                CUS_MONTHLY_DATA -                        A5V75JN3.BE0000J8 * 
 *                 martscr.CUS_MONTHLY_DATA                                   * 
 *                CUS_FU_L - martscr.CUS_FU_L               A5V75JN3.BE0000PB * 
 * Target Table:  CUSTOMER_PRE_DIM -                        A5V75JN3.BE0000QB * 
 *                 martscr.CUSTOMER_PRE_DIM                                   * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 4:48:29 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CUSTOMER_PRE_DIM                                                           * 
 * Job Name: CUSTOMER_PRE_DIMJob DescPre Process: NoneMain: a) Monthly        * 
 * Income and Expense Information obtained by joining CUS_FU_L and            * 
 * CUS_MONTHLY_DATA on CUSTOMER_RK by performing LEFT JOIN on                 * 
 * CUS_FU_L.EMPLYOEE_FLG is obtained by applying the condition that if        * 
 * EMPLOYEE_RK is missing then the flag is set to the user defined            * 
 * parameter FLAG_FALSE, else is set to the user defined parameter            * 
 * FLAG_TRUE.SELF_EMPLOYMENT_FLG is obtained by applying the condition that   * 
 * if EMPLOYMENT_STATUS_CD has value as in the user defined parameter         * 
 * CUS_EMPLOY_STATUS_SELF then the flag is set to FLAG_TRUE, else it is set   * 
 * to FLAG_FALSE.OTHER_BANK_CLIENT_FLG is obtained by applying the            * 
 * condition that if the value of OTHER_INST_CLIENT_CNT is greater than 0     * 
 * then the flag is set to FLAG_TRUE, else it is set to                       * 
 * FLAG_FALSE.OWN_RESIDENCE_PROPERTY_FLG is obtained by applying the          * 
 * condition that if RESIDENCE_STATUS_CD has value as in the user defined     * 
 * parameter CUS_RESIDENCE_STATUS_SELF then the flag is set to FLAG_TRUE,     * 
 * else it is set to FLAG_FALSE.This information is stored in the dataset     * 
 * CUSTOMER_PRE_DIM.Post Process: Creating index on CUSTOMER_RK and           * 
 * LOAD_END_DTTMParameters: a) FLAG_FALSE: This parameter is used to assign   * 
 * the flag to false.b) FLAG_TRUE: This parameter is used to assign the       * 
 * flag to true.c) CUS_EMPLOY_STATUS_SELF: This parameter specifies whether   * 
 * the customer is self employed or not. If EMPLOYMENT_STATUS_CD has value    * 
 * as in this parameter then the SELF_EMPLOYMENT_FLG is set to FLAG_TRUE      * 
 * else it is set to FLAG_FALSE.d) CUS_RESIDENCE_STATUS_SELF: This            * 
 * parameter specifies whether the customer owns a residence property or      * 
 * not. If RESIDENCE_STATUS_CD has value as in this parameter then the        * 
 * OWN_RESIDENCE_PROPERTY_FLG is set to FLAG_TRUE, else it is set to          * 
 *  FLAG_FALSEDeveloped by: singupReviewed by: Tested by:                     * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00007O);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CUSTOMER_PRE_DIM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Monthly Income and Expense Information    A5V75JN3.BO0005R0 * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Monthly Income and Expense Information obtained by joining  * 
 *                CUS_FU_L and CUS_MONTHLY_DATA on CUSTOMER_RK by             * 
 *                 performing LEFT JOIN on CUS_FU_L                           * 
 *                                                                            * 
 * Source Tables: CUS_MONTHLY_DATA -                        A5V75JN3.BE0000J8 * 
 *                 martscr.CUS_MONTHLY_DATA                                   * 
 *                CUS_FU_L - martscr.CUS_FU_L               A5V75JN3.BE0000PB * 
 * Target Table:  SQL Join Target -                         A5V75JN3.BP0004U5 * 
 *                 martscr.MONTHLY_DATA_CUSTOMER                              * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005R0); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete MONTHLY_DATA_CUSTOMER;
quit;

data _null_; 
   put "NOTE: The following column(s) do not have a column mapping, so the"
        " value(s) will be set to missing: CUSTOMER_TYPE_DESC,"
        " CUSTOMER_ACTIVE_DESC";
run; 

proc sql;
   create table martscr.MONTHLY_DATA_CUSTOMER as
      select
         CUS_FU_L.CUSTOMER_RK length = 8
                              format = 12.
                              informat = 12.
                              label = "Customer Key",
         CUS_FU_L.LOAD_END_DTTM length = 8
                                format = NLDATM21.
                                informat = NLDATM21.
                                label = "Load End Datetime",
         CUS_MONTHLY_DATA.MONTHLY_SALARY_INCOME_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_BUSINESS_INCOME_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_RENTAL_INCOME_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_REPLACEMENT_INCOME_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_OTHER_INCOME_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_CHILD_ALLOW_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_RENTAL_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_ALIMONY_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_CHILD_SUPPORT_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_REPAYMENT_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_REPAYMENT_OTHERS_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_OTHER_CHARGE_AMT length = 8,
         CUS_MONTHLY_DATA.MONTHLY_INVESTMENT_AMT length = 8
                                                 format = NLNUM18.5
                                                 informat = NLNUM18.5
                                                 label = "_AMT",
         CUS_FU_L.CUSTOMER_ID length = 32
                              label = "Customer Id",
         CUS_FU_L.SOURCE_SYSTEM_CD length = 3
                                   label = "Source System Code",
         CUS_FU_L.TAX_ID length = 32
                         label = "Tax Id",
         CUS_FU_L.TAX_ID_TYPE_CD length = 3
                                 label = "Tax Id Type Code",
         CUS_FU_L.CUSTOMER_TYPE_CD length = 3
                                   label = "Customer Type Code",
         CUS_FU_L.CUSTOMER_ACTIVE_CD length = 3
                                     label = "Customer Active Code",
         CUS_FU_L.CUSTOMER_LIFECYCLE_CD length = 3
                                        label = "Customer Lifecycle Code",
         CUS_FU_L.PREFERRED_CHANNEL_CD length = 3
                                       label = "Preferred Channel Code",
         CUS_FU_L.BANKRUPTCY_STATUS_CD length = 3
                                       label = "Bankruptcy Status Code",
         CUS_FU_L.BANKRUPTCY_FILED_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Bankruptcy Filed Date",
         CUS_FU_L.PENDING_LAWSUIT_FLG length = 1
                                      label = "Pending Lawsuit Flag",
         CUS_FU_L.LEGAL_JUDGEMENT_FLG length = 1
                                      label = "Legal Judgement Flag",
         CUS_FU_L.FIRST_ACCOUNT_TYPE_CD length = 3
                                        label = "First Financial Acct Type Code",
         CUS_FU_L.FIRST_ACCOUNT_OPEN_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "First Financial Account Date",
         CUS_FU_L.CUSTOMER_CLASS_CD length = 3
                                    label = "Customer Class Code",
         CUS_FU_L.EVER_IN_COLLECTION_FLG length = 1
                                         label = "Ever In Collection Flag",
         CUS_FU_L.EXTERNAL_ORG_RK length = 8
                                  format = 12.
                                  informat = 12.
                                  label = "External Organization Key",
         CUS_FU_L.INCORPORATION_DT length = 8
                                   format = NLDATE10.
                                   informat = NLDATE10.
                                   label = "Incorporation Date",
         CUS_FU_L.OWNERSHIP_CNT length = 8
                                label = "Ownership Count",
         CUS_FU_L.NUM_OFFICES_CNT length = 8
                                  label = "Number of Offices",
         CUS_FU_L.NUM_EMPLOYEES_CNT length = 8
                                    label = "Number of Employees",
         CUS_FU_L.INTERNAL_CREDIT_RATING_CD length = 20
                                            label = "Internal Credit Rating Code",
         CUS_FU_L.EXTERNAL_CREDIT_RATING1_CD length = 4
                                             label = "External Credit Rating Code 1",
         CUS_FU_L.EXTERNAL_CREDIT_RATING2_CD length = 4
                                             label = "External Credit Rating Code 2",
         CUS_FU_L.OWNERSHIP_CD length = 3
                               label = "Ownership Code",
         CUS_FU_L.BUSINESS_NATURE_CD length = 3
                                     label = "Business Nature Code",
         CUS_FU_L.ORGANIZATION_NM length = 40
                                  label = "Organization Code",
         CUS_FU_L.ORGANIZATION_TYPE_CD length = 3
                                       label = "Organization Type Code",
         CUS_FU_L.BUSINESS_ESTABLISHED_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Business Established Date",
         CUS_FU_L.BUSINESS_COMMENCED_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Business Commenced Date",
         CUS_FU_L.INDUSTRY_CD length = 10
                              label = "Industry Code",
         CUS_FU_L.CUSTOMER_CITY_NM length = 100
                                   label = "City name",
         CUS_FU_L.CUSTOMER_STATE_REGION_CD length = 4
                                           label = "State/Region code",
         CUS_FU_L.CUSTOMER_POSTAL_CD length = 20
                                     label = "Postal Code",
         CUS_FU_L.CUSTOMER_COUNTRY_CD length = 3
                                      label = "Country Code",
         CUS_FU_L.CUSTOMER_NM length = 100
                              format = $100.,
         CUS_FU_L.BIRTH_DT length = 8
                           format = NLDATE10.
                           informat = NLDATE10.
                           label = "Birth Date",
         CUS_FU_L.GENDER_CD length = 3
                            label = "Gender Code",
         CUS_FU_L.MARITAL_STATUS_CD length = 3
                                    label = "Marital Status Code",
         CUS_FU_L.PASSPORT_ISSUE_COUNTRY_CD length = 3
                                            label = "Country Code",
         CUS_FU_L.PRIMARY_CITIZENSHIP_COUNTRY_CD length = 3
                                                 label = "Country Code",
         CUS_FU_L.SECNDRY_CITIZENSHIP_COUNTRY_CD length = 3
                                                 label = "Country Code",
         CUS_FU_L.EDUCATION_LEVEL_CD length = 10
                                     label = "Education Level Code",
         CUS_FU_L.STD_OCCUPATION_CD length = 3
                                    label = "Standard Occupation Code",
         CUS_FU_L.EMPLOYMENT_STATUS_CD length = 3
                                       label = "Employment Status Code",
         CUS_FU_L.EMPLOYMENT_YEARS_CNT length = 8
                                       format = NLNUM6.2
                                       informat = NLNUM6.2
                                       label = "Employment Years Count",
         CUS_FU_L.TOTAL_EMPLOYMENT_YEARS_CNT length = 8
                                             format = NLNUM6.2
                                             informat = NLNUM6.2
                                             label = "Total Employment Years Count",
         CUS_FU_L.ANNUAL_INCOME_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Annual Income Amount",
         CUS_FU_L.TAX_BRACKET_CD length = 3
                                 label = "Tax Bracket Code",
         CUS_FU_L.TOTAL_ASSET_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Total Asset Amount",
         CUS_FU_L.TOTAL_LIABILITY_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Total Liability Amount",
         CUS_FU_L.LIQUID_NET_WORTH_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "Liquid Net Worth Amount",
         CUS_FU_L.TOTAL_DEPENDENTS_CNT length = 8
                                       label = "Total Dependents Count",
         CUS_FU_L.RESIDENCE_STATUS_CD length = 3
                                      label = "Resident Status Code",
         CUS_FU_L.PREFERRED_TELEPHONE_NO length = 20
                                         label = "Preferred Telephone No",
         CUS_FU_L.YOUNGEST_CHILD_BIRTH_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Youngest Child Birth Date",
         CUS_FU_L.EMPLOYEE_RK length = 8
                              format = 12.
                              informat = 12.
                              label = "Employee Key",
         CUS_FU_L.EMPLOYERS_CNT length = 8
                                label = "No Of Employers Count",
         CUS_FU_L.OTHER_CREDIT_CARDS_CNT length = 8
                                         label = "Other Credit Cards Count",
         CUS_FU_L.LIQUID_ASSETS_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Liquid Assets Amount",
         CUS_FU_L.REAL_ESTATE_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Real Estate Amount",
         CUS_FU_L.ASSET_OTHER_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Asset Other Amount",
         CUS_FU_L.LIABILITY_REAL_ESTATE_AMT length = 8
                                            format = NLNUM18.5
                                            informat = NLNUM18.5
                                            label = "Liability Real Estate Amount",
         CUS_FU_L.LIABILITY_OTHER_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Liability Other Amount",
         CUS_FU_L.NET_WORTH_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Net Worth Amount",
         CUS_FU_L.OTHER_INST_CLIENT_CNT length = 8
                                        label = "Other Institute Client Count",
         CUS_FU_L.OCCUPATION_START_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Occupation Start Date",
         CUS_FU_L.CURRENT_EMP_START_DT length = 8
                                       format = NLDATE10.
                                       informat = NLDATE10.
                                       label = "Current Employment Start Date",
         CUS_FU_L.CURRENT_COUNTRY_START_DT length = 8
                                           format = NLDATE10.
                                           informat = NLDATE10.
                                           label = "Current Country Start Date",
         CUS_FU_L.EMPLOYMENT_START_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Employment Start Date",
         CUS_FU_L.EMPLOYMENT_POSITION_STATUS_CD length = 3,
         CUS_FU_L.TEMPORARY_EMPLOYMENT_END_DT length = 8
                                              format = NLDATE10.
                                              informat = NLDATE10.,
         CUS_FU_L.CHILDREN_CNT length = 8,
         CUS_FU_L.ELDEST_CHILD_BIRTH_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.,
         CUS_FU_L.OWN_AUTOMOBILE_FLG length = 1,
         CUS_FU_L.OWN_MOTORCYCLE_FLG length = 1,
         CUS_FU_L.MONTHLY_PRI_INCOME_SOURCE_CD length = 10,
         CUS_FU_L.BILL_PAY_SERVICE_FLG length = 1
                                       label = "Bill Pay Service Flag",
         CUS_FU_L.INCOME_CATEGORY_CD length = 3
                                     label = "Income Category Code",
         CUS_FU_L.HHOLD_RK length = 8
                           format = 12.
                           informat = 12.
                           label = "Household Key",
         CUS_FU_L.CURRENT_ADDRESS_START_DT length = 8
                                           format = NLDATE10.
                                           informat = NLDATE10.
                                           label = "Current Address Start Date",
         CUS_FU_L.RESIDENCE_STATUS_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Residence Status Date",
         CUS_FU_L.PRIMARY_INTERNAL_ORG_RK length = 8
                                          format = 12.
                                          informat = 12.
                                          label = "Internal Organization Key",
         "" as CUSTOMER_TYPE_DESC length = 100,
         "" as CUSTOMER_ACTIVE_DESC length = 100,
         CASE  WHEN CUS_FU_L.EMPLOYEE_RK  = . THEN &FLAG_FALSE ELSE &FLAG_TRUE END as EMPLOYEE_FLG length = 1,
         CASE  WHEN CUS_FU_L.EMPLOYMENT_STATUS_CD IN (&CUS_EMPLOY_STATUS_SELF)  THEN &FLAG_TRUE ELSE &FLAG_FALSE END as SELF_EMPLOYMENT_FLG length = 1,
         CASE  WHEN CUS_FU_L.OTHER_INST_CLIENT_CNT  > 0 THEN &FLAG_TRUE ELSE &FLAG_FALSE END as OTHER_BANK_CLIENT_FLG length = 1,
         CASE  WHEN CUS_FU_L.RESIDENCE_STATUS_CD IN (&CUS_RESIDENCE_STATUS_SELF) THEN &FLAG_TRUE ELSE &FLAG_FALSE END as OWN_RESIDENCE_PROPERTY_FLG length = 1
      from
         martscr.CUS_FU_L left join 
         martscr.CUS_MONTHLY_DATA
            on
            (
               CUS_MONTHLY_DATA.CUSTOMER_RK = CUS_FU_L.CUSTOMER_RK
               and CUS_MONTHLY_DATA.LOAD_END_DTTM = CUS_FU_L.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify MONTHLY_DATA_CUSTOMER;
         ic create not null (CUSTOMER_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Lookup                                    A5V75JN3.BO0005QY * 
 * Transform:     Lookup                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: SQL Join Target -                         A5V75JN3.BP0004U5 * 
 *                 martscr.MONTHLY_DATA_CUSTOMER                              * 
 *                CA_EXT - martscr.CA_EXT                   A5V75JN3.BE0000IK * 
 *                CT_EXT - martscr.CT_EXT                   A5V75JN3.BE0000J6 * 
 * Target Table:  Lookup Target -                           A5V75JN3.BP0004U6 * 
 *                 martscr.CUSTOMER_BEFORE_PRE_DIM                            * 
 *============================================================================*/ 

%let transformID = %quote(A5V75JN3.BO0005QY); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CUSTOMER_BEFORE_PRE_DIM;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.CUSTOMER_BEFORE_PRE_DIM
         (keep = CUSTOMER_RK LOAD_END_DTTM MONTHLY_SALARY_INCOME_AMT 
                 MONTHLY_BUSINESS_INCOME_AMT MONTHLY_RENTAL_INCOME_AMT 
                 MONTHLY_REPLACEMENT_INCOME_AMT MONTHLY_OTHER_INCOME_AMT 
                 MONTHLY_CHILD_ALLOW_AMT MONTHLY_RENTAL_AMT MONTHLY_ALIMONY_AMT 
                 MONTHLY_CHILD_SUPPORT_AMT MONTHLY_REPAYMENT_AMT 
                 MONTHLY_REPAYMENT_OTHERS_AMT MONTHLY_OTHER_CHARGE_AMT 
                 MONTHLY_INVESTMENT_AMT CUSTOMER_ID SOURCE_SYSTEM_CD TAX_ID 
                 TAX_ID_TYPE_CD CUSTOMER_TYPE_CD CUSTOMER_ACTIVE_CD 
                 CUSTOMER_LIFECYCLE_CD PREFERRED_CHANNEL_CD BANKRUPTCY_STATUS_CD 
                 BANKRUPTCY_FILED_DT PENDING_LAWSUIT_FLG LEGAL_JUDGEMENT_FLG 
                 FIRST_ACCOUNT_TYPE_CD FIRST_ACCOUNT_OPEN_DT CUSTOMER_CLASS_CD 
                 EVER_IN_COLLECTION_FLG EXTERNAL_ORG_RK INCORPORATION_DT 
                 OWNERSHIP_CNT NUM_OFFICES_CNT NUM_EMPLOYEES_CNT 
                 INTERNAL_CREDIT_RATING_CD EXTERNAL_CREDIT_RATING1_CD 
                 EXTERNAL_CREDIT_RATING2_CD OWNERSHIP_CD BUSINESS_NATURE_CD 
                 ORGANIZATION_NM ORGANIZATION_TYPE_CD BUSINESS_ESTABLISHED_DT 
                 BUSINESS_COMMENCED_DT INDUSTRY_CD CUSTOMER_CITY_NM 
                 CUSTOMER_STATE_REGION_CD CUSTOMER_POSTAL_CD CUSTOMER_COUNTRY_CD 
                 CUSTOMER_NM BIRTH_DT GENDER_CD MARITAL_STATUS_CD 
                 PASSPORT_ISSUE_COUNTRY_CD PRIMARY_CITIZENSHIP_COUNTRY_CD 
                 SECNDRY_CITIZENSHIP_COUNTRY_CD EDUCATION_LEVEL_CD 
                 STD_OCCUPATION_CD EMPLOYMENT_STATUS_CD EMPLOYMENT_YEARS_CNT 
                 TOTAL_EMPLOYMENT_YEARS_CNT ANNUAL_INCOME_AMT TAX_BRACKET_CD 
                 TOTAL_ASSET_AMT TOTAL_LIABILITY_AMT LIQUID_NET_WORTH_AMT 
                 TOTAL_DEPENDENTS_CNT RESIDENCE_STATUS_CD PREFERRED_TELEPHONE_NO 
                 YOUNGEST_CHILD_BIRTH_DT EMPLOYEE_RK EMPLOYERS_CNT 
                 OTHER_CREDIT_CARDS_CNT LIQUID_ASSETS_AMT REAL_ESTATE_AMT 
                 ASSET_OTHER_AMT LIABILITY_REAL_ESTATE_AMT LIABILITY_OTHER_AMT 
                 NET_WORTH_AMT OTHER_INST_CLIENT_CNT OCCUPATION_START_DT 
                 CURRENT_EMP_START_DT CURRENT_COUNTRY_START_DT 
                 EMPLOYMENT_START_DT EMPLOYMENT_POSITION_STATUS_CD 
                 TEMPORARY_EMPLOYMENT_END_DT CHILDREN_CNT ELDEST_CHILD_BIRTH_DT 
                 OWN_AUTOMOBILE_FLG OWN_MOTORCYCLE_FLG 
                 MONTHLY_PRI_INCOME_SOURCE_CD BILL_PAY_SERVICE_FLG 
                 INCOME_CATEGORY_CD HHOLD_RK CURRENT_ADDRESS_START_DT 
                 RESIDENCE_STATUS_DT PRIMARY_INTERNAL_ORG_RK CUSTOMER_TYPE_DESC 
                 CUSTOMER_ACTIVE_DESC EMPLOYEE_FLG SELF_EMPLOYMENT_FLG 
                 OTHER_BANK_CLIENT_FLG OWN_RESIDENCE_PROPERTY_FLG)
      ; 
   
   attrib CUSTOMER_RK length=8 format=12. label="Customer Key"
          LOAD_END_DTTM length=8 format=NLDATM21. label="Load End Datetime"
          MONTHLY_SALARY_INCOME_AMT length=8
          MONTHLY_BUSINESS_INCOME_AMT length=8
          MONTHLY_RENTAL_INCOME_AMT length=8
          MONTHLY_REPLACEMENT_INCOME_AMT length=8
          MONTHLY_OTHER_INCOME_AMT length=8
          MONTHLY_CHILD_ALLOW_AMT length=8
          MONTHLY_RENTAL_AMT length=8
          MONTHLY_ALIMONY_AMT length=8
          MONTHLY_CHILD_SUPPORT_AMT length=8
          MONTHLY_REPAYMENT_AMT length=8
          MONTHLY_REPAYMENT_OTHERS_AMT length=8
          MONTHLY_OTHER_CHARGE_AMT length=8
          MONTHLY_INVESTMENT_AMT length=8 format=NLNUM18.5 label="_AMT"
          CUSTOMER_ID length=$32 label="Customer Id"
          SOURCE_SYSTEM_CD length=$3 label="Source System Code"
          TAX_ID length=$32 label="Tax Id"
          TAX_ID_TYPE_CD length=$3 label="Tax Id Type Code"
          CUSTOMER_TYPE_CD length=$3 label="Customer Type Code"
          CUSTOMER_ACTIVE_CD length=$3 label="Customer Active Code"
          CUSTOMER_LIFECYCLE_CD length=$3 label="Customer Lifecycle Code"
          PREFERRED_CHANNEL_CD length=$3 label="Preferred Channel Code"
          BANKRUPTCY_STATUS_CD length=$3 label="Bankruptcy Status Code"
          BANKRUPTCY_FILED_DT length=8 format=NLDATE10. label="Bankruptcy Filed Date"
          PENDING_LAWSUIT_FLG length=$1 label="Pending Lawsuit Flag"
          LEGAL_JUDGEMENT_FLG length=$1 label="Legal Judgement Flag"
          FIRST_ACCOUNT_TYPE_CD length=$3 label="First Financial Acct Type Code"
          FIRST_ACCOUNT_OPEN_DT length=8 format=NLDATE10. label="First Financial Account Date"
          CUSTOMER_CLASS_CD length=$3 label="Customer Class Code"
          EVER_IN_COLLECTION_FLG length=$1 label="Ever In Collection Flag"
          EXTERNAL_ORG_RK length=8 format=12. label="External Organization Key"
          INCORPORATION_DT length=8 format=NLDATE10. label="Incorporation Date"
          OWNERSHIP_CNT length=8 label="Ownership Count"
          NUM_OFFICES_CNT length=8 label="Number of Offices"
          NUM_EMPLOYEES_CNT length=8 label="Number of Employees"
          INTERNAL_CREDIT_RATING_CD length=$20 label="Internal Credit Rating Code"
          EXTERNAL_CREDIT_RATING1_CD length=$4 label="External Credit Rating Code 1"
          EXTERNAL_CREDIT_RATING2_CD length=$4 label="External Credit Rating Code 2"
          OWNERSHIP_CD length=$3 label="Ownership Code"
          BUSINESS_NATURE_CD length=$3 label="Business Nature Code"
          ORGANIZATION_NM length=$40 label="Organization Code"
          ORGANIZATION_TYPE_CD length=$3 label="Organization Type Code"
          BUSINESS_ESTABLISHED_DT length=8 format=NLDATE10. label="Business Established Date"
          BUSINESS_COMMENCED_DT length=8 format=NLDATE10. label="Business Commenced Date"
          INDUSTRY_CD length=$10 label="Industry Code"
          CUSTOMER_CITY_NM length=$100 label="City name"
          CUSTOMER_STATE_REGION_CD length=$4 label="State/Region code"
          CUSTOMER_POSTAL_CD length=$20 label="Postal Code"
          CUSTOMER_COUNTRY_CD length=$3 label="Country Code"
          CUSTOMER_NM length=$100 format=$100.
          BIRTH_DT length=8 format=NLDATE10. label="Birth Date"
          GENDER_CD length=$3 label="Gender Code"
          MARITAL_STATUS_CD length=$3 label="Marital Status Code"
          PASSPORT_ISSUE_COUNTRY_CD length=$3 label="Country Code"
          PRIMARY_CITIZENSHIP_COUNTRY_CD length=$3 label="Country Code"
          SECNDRY_CITIZENSHIP_COUNTRY_CD length=$3 label="Country Code"
          EDUCATION_LEVEL_CD length=$10 label="Education Level Code"
          STD_OCCUPATION_CD length=$3 label="Standard Occupation Code"
          EMPLOYMENT_STATUS_CD length=$3 label="Employment Status Code"
          EMPLOYMENT_YEARS_CNT length=8 format=NLNUM6.2 label="Employment Years Count"
          TOTAL_EMPLOYMENT_YEARS_CNT length=8 format=NLNUM6.2 label="Total Employment Years Count"
          ANNUAL_INCOME_AMT length=8 format=NLNUM18.5 label="Annual Income Amount"
          TAX_BRACKET_CD length=$3 label="Tax Bracket Code"
          TOTAL_ASSET_AMT length=8 format=NLNUM18.5 label="Total Asset Amount"
          TOTAL_LIABILITY_AMT length=8 format=NLNUM18.5 label="Total Liability Amount"
          LIQUID_NET_WORTH_AMT length=8 format=NLNUM18.5 label="Liquid Net Worth Amount"
          TOTAL_DEPENDENTS_CNT length=8 label="Total Dependents Count"
          RESIDENCE_STATUS_CD length=$3 label="Resident Status Code"
          PREFERRED_TELEPHONE_NO length=$20 label="Preferred Telephone No"
          YOUNGEST_CHILD_BIRTH_DT length=8 format=NLDATE10. label="Youngest Child Birth Date"
          EMPLOYEE_RK length=8 format=12. label="Employee Key"
          EMPLOYERS_CNT length=8 label="No Of Employers Count"
          OTHER_CREDIT_CARDS_CNT length=8 label="Other Credit Cards Count"
          LIQUID_ASSETS_AMT length=8 format=NLNUM18.5 label="Liquid Assets Amount"
          REAL_ESTATE_AMT length=8 format=NLNUM18.5 label="Real Estate Amount"
          ASSET_OTHER_AMT length=8 format=NLNUM18.5 label="Asset Other Amount"
          LIABILITY_REAL_ESTATE_AMT length=8 format=NLNUM18.5 label="Liability Real Estate Amount"
          LIABILITY_OTHER_AMT length=8 format=NLNUM18.5 label="Liability Other Amount"
          NET_WORTH_AMT length=8 format=NLNUM18.5 label="Net Worth Amount"
          OTHER_INST_CLIENT_CNT length=8 label="Other Institute Client Count"
          OCCUPATION_START_DT length=8 format=NLDATE10. label="Occupation Start Date"
          CURRENT_EMP_START_DT length=8 format=NLDATE10. label="Current Employment Start Date"
          CURRENT_COUNTRY_START_DT length=8 format=NLDATE10. label="Current Country Start Date"
          EMPLOYMENT_START_DT length=8 format=NLDATE10. label="Employment Start Date"
          EMPLOYMENT_POSITION_STATUS_CD length=$3
          TEMPORARY_EMPLOYMENT_END_DT length=8 format=NLDATE10.
          CHILDREN_CNT length=8
          ELDEST_CHILD_BIRTH_DT length=8 format=NLDATE10.
          OWN_AUTOMOBILE_FLG length=$1
          OWN_MOTORCYCLE_FLG length=$1
          MONTHLY_PRI_INCOME_SOURCE_CD length=$10
          BILL_PAY_SERVICE_FLG length=$1 label="Bill Pay Service Flag"
          INCOME_CATEGORY_CD length=$3 label="Income Category Code"
          HHOLD_RK length=8 format=12. label="Household Key"
          CURRENT_ADDRESS_START_DT length=8 format=NLDATE10. label="Current Address Start Date"
          RESIDENCE_STATUS_DT length=8 format=NLDATE10. label="Residence Status Date"
          PRIMARY_INTERNAL_ORG_RK length=8 format=12. label="Internal Organization Key"
          CUSTOMER_TYPE_DESC length=$100
          CUSTOMER_ACTIVE_DESC length=$100
          EMPLOYEE_FLG length=$1
          SELF_EMPLOYMENT_FLG length=$1
          OTHER_BANK_CLIENT_FLG length=$1
          OWN_RESIDENCE_PROPERTY_FLG length=$1
          ; 
   
   length ; 
   
   retain missing0 0 missing1 0 ; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table martscr.CA_EXT */ 
      nlobs = .; 
      dsid = open("martscr.CA_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "martscr.CA_EXT", hashexp: exponent);
            h0.defineKey( "CUSTOMER_ACTIVE_CD",
                           "LOAD_END_DTTM");
            h0.defineData( "CUSTOMER_ACTIVE_DESC");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.CA_EXT";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.CA_EXT";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: martscr.CA_EXT";
         
         missing0 = 99; 
      end; 
      
      /* Build hash h1 from lookup table martscr.CT_EXT */ 
      nlobs = .; 
      dsid = open("martscr.CT_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "martscr.CT_EXT", hashexp: exponent);
            h1.defineKey( "CUSTOMER_TYPE_CD",
                           "LOAD_END_DTTM");
            h1.defineData( "CUSTOMER_TYPE_DESC");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.CT_EXT";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.CT_EXT";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: martscr.CT_EXT";
         
         missing1 = 99; 
      end; 
      
      call missing (CUSTOMER_ACTIVE_CD, LOAD_END_DTTM, CUSTOMER_ACTIVE_DESC, 
                    CUSTOMER_TYPE_CD, CUSTOMER_TYPE_DESC); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.MONTHLY_DATA_CUSTOMER end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      rc1 = h1.find();
   end; 
   else 
      rc1 = missing1; 
      
   
   /* Examine success of lookups  */ 
   if (rc0=0 and rc1=0) then 
   do; 
      /* Write row to target  */ 
      output martscr.CUSTOMER_BEFORE_PRE_DIM; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 99) then 
         do; 
            /* Check: Lookup table missing-Write exception row  */ 
            /* Check: Lookup table missing-Set target columns to value  */ 
         end; 
         
         else if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (CUSTOMER_ACTIVE_DESC); 
            request_write_target = 1; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 99) then 
         do; 
            /* Check: Lookup table missing-Write exception row  */ 
            /* Check: Lookup table missing-Set target columns to value  */ 
         end; 
         
         else if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Set target columns to missing  */ 
            call missing (CUSTOMER_TYPE_DESC); 
            request_write_target = 1; 
         end; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (request_write_target eq 1) then 
         /* Write row to target  */ 
         output martscr.CUSTOMER_BEFORE_PRE_DIM; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          User Written Code                         A5V75JN3.BO0005QZ * 
 * Transform:     User Written Code                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: SQL Join Target -                         A5V75JN3.BP0004U5 * 
 *                 martscr.MONTHLY_DATA_CUSTOMER                              * 
 *                Lookup Target -                           A5V75JN3.BP0004U6 * 
 *                 martscr.CUSTOMER_BEFORE_PRE_DIM                            * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP0004U4 * 
 *                 martscr.CUSTOMER_PRE_DIM                                   * 
 *                                                                            * 
 * User Written:  Code to deduplicate Customers             A5V75JN3.AF000N06 * 
 *                Code to deduplicate Customers before SCD2                   * 
 *============================================================================*/ 

%let transformID = %quote(A5V75JN3.BO0005QZ); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.CUSTOMER_PRE_DIM); 

/*---- Start of User Written Code  ----*/ 

%let sort_col=CUSTOMER_RK LOAD_END_DTTM;

%let etl_str=KTRIM(KLEFT(ANNUAL_INCOME_AMT)) ||
KTRIM(KLEFT(ASSET_OTHER_AMT)) ||
KTRIM(KLEFT(BANKRUPTCY_FILED_DT)) ||
KTRIM(KLEFT(BANKRUPTCY_STATUS_CD)) ||
KTRIM(KLEFT(BILL_PAY_SERVICE_FLG)) ||
KTRIM(KLEFT(BIRTH_DT)) ||
KTRIM(KLEFT(BUSINESS_COMMENCED_DT)) ||
KTRIM(KLEFT(BUSINESS_ESTABLISHED_DT)) ||
KTRIM(KLEFT(BUSINESS_NATURE_CD)) ||
KTRIM(KLEFT(CHILDREN_CNT)) ||
KTRIM(KLEFT(CURRENT_ADDRESS_START_DT)) ||
KTRIM(KLEFT(CURRENT_COUNTRY_START_DT)) ||
KTRIM(KLEFT(CURRENT_EMP_START_DT)) ||
KTRIM(KLEFT(CUSTOMER_ACTIVE_CD)) ||
KTRIM(KLEFT(CUSTOMER_ACTIVE_DESC)) ||
KTRIM(KLEFT(CUSTOMER_CITY_NM)) ||
KTRIM(KLEFT(CUSTOMER_CLASS_CD)) ||
KTRIM(KLEFT(CUSTOMER_COUNTRY_CD)) ||
KTRIM(KLEFT(CUSTOMER_LIFECYCLE_CD)) ||
KTRIM(KLEFT(CUSTOMER_NM)) ||
KTRIM(KLEFT(CUSTOMER_POSTAL_CD)) ||
KTRIM(KLEFT(CUSTOMER_RK)) ||
KTRIM(KLEFT(CUSTOMER_STATE_REGION_CD)) ||
KTRIM(KLEFT(CUSTOMER_TYPE_CD)) ||
KTRIM(KLEFT(CUSTOMER_TYPE_DESC)) ||
KTRIM(KLEFT(EDUCATION_LEVEL_CD)) ||
KTRIM(KLEFT(ELDEST_CHILD_BIRTH_DT)) ||
KTRIM(KLEFT(EMPLOYEE_FLG)) ||
KTRIM(KLEFT(EMPLOYEE_RK)) ||
KTRIM(KLEFT(EMPLOYERS_CNT)) ||
KTRIM(KLEFT(EMPLOYMENT_POSITION_STATUS_CD)) ||
KTRIM(KLEFT(EMPLOYMENT_START_DT)) ||
KTRIM(KLEFT(EMPLOYMENT_STATUS_CD)) ||
KTRIM(KLEFT(EMPLOYMENT_YEARS_CNT)) ||
KTRIM(KLEFT(EVER_IN_COLLECTION_FLG)) ||
KTRIM(KLEFT(EXTERNAL_CREDIT_RATING1_CD)) ||
KTRIM(KLEFT(EXTERNAL_CREDIT_RATING2_CD)) ||
KTRIM(KLEFT(EXTERNAL_ORG_RK)) ||
KTRIM(KLEFT(FIRST_ACCOUNT_OPEN_DT)) ||
KTRIM(KLEFT(FIRST_ACCOUNT_TYPE_CD)) ||
KTRIM(KLEFT(GENDER_CD)) ||
KTRIM(KLEFT(HHOLD_RK)) ||
KTRIM(KLEFT(INCOME_CATEGORY_CD)) ||
KTRIM(KLEFT(INCORPORATION_DT)) ||
KTRIM(KLEFT(INDUSTRY_CD)) ||
KTRIM(KLEFT(INTERNAL_CREDIT_RATING_CD)) ||
KTRIM(KLEFT(LEGAL_JUDGEMENT_FLG)) ||
KTRIM(KLEFT(LIABILITY_OTHER_AMT)) ||
KTRIM(KLEFT(LIABILITY_REAL_ESTATE_AMT)) ||
KTRIM(KLEFT(LIQUID_ASSETS_AMT)) ||
KTRIM(KLEFT(LIQUID_NET_WORTH_AMT)) ||
KTRIM(KLEFT(MARITAL_STATUS_CD)) ||
KTRIM(KLEFT(MONTHLY_ALIMONY_AMT)) ||
KTRIM(KLEFT(MONTHLY_BUSINESS_INCOME_AMT)) ||
KTRIM(KLEFT(MONTHLY_CHILD_ALLOW_AMT)) ||
KTRIM(KLEFT(MONTHLY_CHILD_SUPPORT_AMT)) ||
KTRIM(KLEFT(MONTHLY_INVESTMENT_AMT)) ||
KTRIM(KLEFT(MONTHLY_OTHER_CHARGE_AMT)) ||
KTRIM(KLEFT(MONTHLY_OTHER_INCOME_AMT)) ||
KTRIM(KLEFT(MONTHLY_PRI_INCOME_SOURCE_CD)) ||
KTRIM(KLEFT(MONTHLY_RENTAL_AMT)) ||
KTRIM(KLEFT(MONTHLY_RENTAL_INCOME_AMT)) ||
KTRIM(KLEFT(MONTHLY_REPAYMENT_AMT)) ||
KTRIM(KLEFT(MONTHLY_REPAYMENT_OTHERS_AMT)) ||
KTRIM(KLEFT(MONTHLY_REPLACEMENT_INCOME_AMT)) ||
KTRIM(KLEFT(MONTHLY_SALARY_INCOME_AMT)) ||
KTRIM(KLEFT(NET_WORTH_AMT)) ||
KTRIM(KLEFT(NUM_EMPLOYEES_CNT)) ||
KTRIM(KLEFT(NUM_OFFICES_CNT)) ||
KTRIM(KLEFT(OCCUPATION_START_DT)) ||
KTRIM(KLEFT(ORGANIZATION_NM)) ||
KTRIM(KLEFT(ORGANIZATION_TYPE_CD)) ||
KTRIM(KLEFT(OTHER_CREDIT_CARDS_CNT)) ||
KTRIM(KLEFT(OTHER_INST_CLIENT_CNT)) ||
KTRIM(KLEFT(OWN_AUTOMOBILE_FLG)) ||
KTRIM(KLEFT(OWN_MOTORCYCLE_FLG)) ||
KTRIM(KLEFT(OWNERSHIP_CD)) ||
KTRIM(KLEFT(OWNERSHIP_CNT)) ||
KTRIM(KLEFT(OWNIDENCE_PROPERTY_FLG)) ||
KTRIM(KLEFT(PASSPORT_ISSUE_COUNTRY_CD)) ||
KTRIM(KLEFT(PENDING_LAWSUIT_FLG)) ||
KTRIM(KLEFT(PREFERRED_CHANNEL_CD)) ||
KTRIM(KLEFT(PREFERRED_TELEPHONE_NO)) ||
KTRIM(KLEFT(PRIMARY_CITIZENSHIP_COUNTRY_CD)) ||
KTRIM(KLEFT(PRIMARY_INTERNAL_ORG_RK)) ||
KTRIM(KLEFT(REAL_ESTATE_AMT)) ||
KTRIM(KLEFT(RESIDENCE_STATUS_CD)) ||
KTRIM(KLEFT(RESIDENCE_STATUS_DT)) ||
KTRIM(KLEFT(SECNDRY_CITIZENSHIP_COUNTRY_CD)) ||
KTRIM(KLEFT(SOURCE_SYSTEM_CD)) ||
KTRIM(KLEFT(STD_OCCUPATION_CD)) ||
KTRIM(KLEFT(TAX_BRACKET_CD)) ||
KTRIM(KLEFT(TAX_ID)) ||
KTRIM(KLEFT(TAX_ID_TYPE_CD)) ||
KTRIM(KLEFT(TEMPORARY_EMPLOYMENT_END_DT)) ||
KTRIM(KLEFT(TOTAL_ASSET_AMT)) ||
KTRIM(KLEFT(TOTAL_DEPENDENTS_CNT)) ||
KTRIM(KLEFT(TOTAL_EMPLOYMENT_YEARS_CNT)) ||
KTRIM(KLEFT(TOTAL_LIABILITY_AMT)) ||
KTRIM(KLEFT(OTHER_BANK_CLIENT_FLG)) ||
KTRIM(KLEFT(SELF_EMPLOYMENT_FLG)) ||
KTRIM(KLEFT(YOUNGEST_CHILD_BIRTH_DT))
;

%deduplicate(in_table=&SYSLAST,sort_col=&sort_col,out_table=&_OUTPUT,etls_str_in=&etl_str)
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QX * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP0004U4 * 
 *                 martscr.CUSTOMER_PRE_DIM                                   * 
 * Target Table:  CUSTOMER_PRE_DIM -                        A5V75JN3.BE0000QB * 
 *                 martscr.CUSTOMER_PRE_DIM                                   * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043W * 
 *                                                                            * 
 * User Written:  Index creation  CUSTOMER_RK &             A5V75JN3.AF000N0I * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation  CUSTOMER_RK  & LOAD_END_DTTM                * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on CUSTOMER_RK & LOAD_END_DTTM  */
PROC SQL NOPRINT;
           CREATE INDEX  CUSTOMER_RK_LOAD_END_DTTM
            ON martscr.CUSTOMER_PRE_DIM(CUSTOMER_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

