/****************************************************************************** 
 * Job:           CUSTOMER_SCORE_DETAIL                     A5V75JN3.BN00003H * 
 * Description:   This job builds the CUSTOMER_SCORE_DETAIL detail table      * 
 *                 from CUSTOMER_SCORE_PRE_DETAIL using SCD2 algorithm        * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  CUSTOMER_SCORE_PRE_DETAIL -               A5V75JN3.BE0000LG * 
 *                 martscr.CUSTOMER_SCORE_PRE_DETAIL                          * 
 * Target Table:  CUSTOMER_SCORE_DETAIL -                   A5V75JN3.BE0000LF * 
 *                 detail.CUSTOMER_SCORE_DETAIL                               * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 3:11:02 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CUSTOMER_SCORE_DETAIL                                                      * 
 * Job Name: CUSTOMER_SCORE_DETAILJob Desc Please note that this dimension    * 
 * has no SK, since this is not used for reporting.Pre Process: NoneMain:     * 
 * a) This job builds the CUSTOMER_SCORE_DETAIL detail table from             * 
 * CUSTOMER_SCORE_PRE_DETAIL.b) The business key is CUSTOMER_RK, MODEL_RKc)   * 
 * In the SCD 2 LOADER, we are detecting changes in all variables except      * 
 * CREATED_BY and CREATED_DTTM.d) The value for column VALID_START_DTTM       * 
 * will be calculated from the LOAD_END_DTTM in the source table.e) Column    * 
 * VALID_END_DTTM is set according to value in parameter VALID_HIGH_DTTM      * 
 * which is the exceptionally high datetime value. For eg. if                 * 
 * VALID_HIGH_DTTM = '31DEC4747:23:59:59'DT then VALID_END_DTTM =             * 
 * '31DEC4747:23:59:59'DT.f) Column CREATED_DTTM is set to the value of the   * 
 * macro variable ETLS_LOADTIME. This variable has a value of "sysdate"       * 
 * appended with "systime".g) PROCESSED_DTTM is automatically set to the      * 
 * value of ETLS_LOADTIMEPost Process: NoneParameters:a) VALID_HIGH_DTTM:     * 
 * User defined parameter having date time '31DEC4747:23:59:59' which is      * 
 * the exceptionally high datetime value.b) SYSUSERID - Contains the userid   * 
 * or login of the current SAS process.Developed by: sinabcReviewed           * 
 *  by:Tested by: sinabc                                                      * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00003H);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CUSTOMER_SCORE_DETAIL;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SCD Type 2 Loader with CUSTOMER_RK,       A5V75JN3.BO00006Y * 
 *                 MODEL_RK                                                   * 
 * Transform:     SCD Type 2 Loader                                           * 
 * Description:   SCD Type 2 Loader with business keys as CUSTOMER_RK,        * 
 *                 MODEL_RK                                                   * 
 *                                                                            * 
 * Source Table:  CUSTOMER_SCORE_PRE_DETAIL -               A5V75JN3.BE0000LG * 
 *                 martscr.CUSTOMER_SCORE_PRE_DETAIL                          * 
 * Target Table:  CUSTOMER_SCORE_DETAIL -                   A5V75JN3.BE0000LF * 
 *                 detail.CUSTOMER_SCORE_DETAIL                               * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

/* Access the data for Detail Tables  */ 
LIBNAME detail BASE "Data/bisdata/detail" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.CUSTOMER_SCORE_PRE_DETAIL); 

%let transformID = %quote(A5V75JN3.BO00006Y); 

%let trans_rc = 0; 

%macro etls_scdloader;

   /*---- Create miscellaneous loader macros   ----*/ 
   %global etls_tableExist;
   %global etls_numIndex;
   %global etls_lastTable;
   %global etls_loadtime;
   %global etls_debug;
   %let etls_tableExist = -1;
   %let etls_numIndex = -1;
   %let etls_lastTable = &SYSLAST;
   
   /*---- If the macro etls_debug is missing, then set it to the default  ----*/ 
   /*----  value of zero.                                                 ----*/ 
   %if &etls_debug eq %str() %then
      %let etls_debug = 0;
      
   /*---- Set the Load Time column  ----*/ 
   %let etls_loadtime = &sysdate9:&systime;
   %put %str(NOTE: The load time for PROCESSED_DTTM is &etls_loadtime );
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(detail.CUSTOMER_SCORE_DETAIL, DATA)) or 
         %sysfunc(exist(detail.CUSTOMER_SCORE_DETAIL, VIEW))); 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data detail.CUSTOMER_SCORE_DETAIL
              (label = 'CUSTOMER_SCORE_DETAIL');
         attrib CUSTOMER_RK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib MODEL_RK length = 8 format = 12. informat = 12.; 
         attrib LATEST_SCORE_DT length = 8 format = NLDATE10. informat = NLDATE10.
                   label = '_DT'; 
         attrib LATEST_SCORE_NO length = 8; 
         attrib LATEST_SCORE_POINTS_NO length = 8; 
         attrib VALID_START_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         attrib VALID_END_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         attrib CREATED_BY length = $20 format = $20. informat = $20.; 
         attrib CREATED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         attrib PROCESSED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         stop;
      run;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   
   /*---- Create the indexes for a table  ----*/ 
   %if ((&etls_tableExist eq 0) or 
        (&etls_numIndex ne -1)) %then 
   %do;  /* if table did not exist or there are indexes to create  */ 
   
      /*---- Create the indexes for a table  ----*/ 
      %put %str(NOTE: Creating indexes ...);
      proc datasets lib = detail nolist; 
         modify CUSTOMER_SCORE_DETAIL; 
            index create XPKCUSTOMER_SCORE_DETAIL = (CUSTOMER_RK MODEL_RK VALID_START_DTTM)
               / unique;
      quit; 
      
      %rcSet(&syserr); 
      
   %end;  /* if table did not exist or there are indexes to create  */ 
   
   /*---- Temporary cross-reference table being used  ----*/ 
   /* Remove any existing temporary cross reference file  */ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_sortedxref;
   quit;
   
   /* Sort target table  */ 
   proc sort data = detail.CUSTOMER_SCORE_DETAIL   
      out = work.etls_sortedxref;
      by CUSTOMER_RK MODEL_RK VALID_END_DTTM;
   run;
   
   %rcSet(&syserr); 
   
   /* Get the last key variable in each set of keys  */ 
   data work.etls_sortedxref; 
      set work.etls_sortedxref;
      by CUSTOMER_RK MODEL_RK;
      if last.MODEL_RK;
         output;
   run;
   
   %rcSet(&syserr); 
   
   /* Generate the MD5 value and append it to the dataset  */ 
   data work.etls_sortedxref(drop=etls_str etls_md5);
      set work.etls_sortedxref;
      length etls_md5 $16.;
      length DIGEST_VALUE $32.;
      etls_str = '"' ||TRIM(LEFT(LATEST_SCORE_DT)) || '"';
      etls_md5 = MD5(etls_str);
      DIGEST_VALUE=put(etls_md5, hex32.);
   run;
   
   %rcSet(&syserr); 
   
   /* Sort the temporary cross reference table by primary key  */ 
   proc sort data= work.etls_sortedxref
      (KEEP =  CUSTOMER_RK MODEL_RK
       VALID_START_DTTM
      VALID_END_DTTM DIGEST_VALUE) nodupkey;
      by CUSTOMER_RK MODEL_RK VALID_START_DTTM;
   run; 
   
   %rcSet(&syserr); 
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete mapped;
   quit;
   
   data _null_; 
      put "NOTE: The following column(s) do not have a column mapping, so the"
           " value(s) will be set to missing: VALID_END_DTTM, PROCESSED_DTTM";
   run; 
   
   %put %str(NOTE: Mapping columns ...);
   proc sql; 
      create view work.mapped as 
         select CUSTOMER_RK length = 8,
                MODEL_RK length = 8,
                LATEST_SCORE_DT length = 8,
                LATEST_SCORE_NO length = 8,
                LATEST_SCORE_POINTS_NO length = 8,
                (INTNX('DTMONTH',LOAD_END_DTTM,0,'BEGINNING')) as VALID_START_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
                . as VALID_END_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
                (STRIP("&SYSUSERID")) as CREATED_BY length = 20 format = $20. informat = $20.,
                ("&ETLS_LOADTIME"DT) as CREATED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
                . as PROCESSED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
            from martscr.CUSTOMER_SCORE_PRE_DETAIL; 
   quit;
   
   %let SYSLAST = work.mapped; 
   
   %rcSet(&sqlrc); 
   
   /* Generate the MD5 value and append it to the dataset  */ 
   data work.etls_source(drop=etls_str etls_md5);
      set &syslast;
      length etls_md5 $16.;
      length DIGEST_VALUE $32.;
      etls_str = '"' ||TRIM(LEFT(LATEST_SCORE_DT)) || '"';
      etls_md5 = MD5(etls_str);
      DIGEST_VALUE=put(etls_md5, hex32.);
   run;
   
   %rcSet(&syserr); 
   
   /* Generate the default from date expression  */ 
   %let etls_begdate = VALID_START_DTTM;
   /* Generate the default to date expression  */ 
   %let etls_enddate = &VALID_HIGH_DTTM;
   
   /* Sort the source table by business key and beginning/from date columns.  */ 
   proc sort data=work.etls_source;
      by CUSTOMER_RK MODEL_RK VALID_START_DTTM;
   run;
   
   %rcSet(&syserr); 
   
   /*---- Set beginning dates and close out any history records   ----*/ 
   data work.etls_source (drop = etls_sameday etls_cnt etls_closedate);
   
      set work.etls_source;
      by CUSTOMER_RK MODEL_RK;
      
      /* Set beginning dates if null  */ 
      if VALID_START_DTTM eq . then
         VALID_START_DTTM = &etls_begdate;
         
      if first.MODEL_RK then
         etls_cnt = 0;
      else
         etls_cnt + 1;
         
      /* Close out any history records if they exist  */ 
      if not last.MODEL_RK then
      do;
      
         obsnum = _n_ + 1;
         set work.etls_source(keep = VALID_START_DTTM
                  rename = (VALID_START_DTTM = etls_closedate))
                  point = obsnum;
                  
         if etls_closedate eq . then
            etls_closedate = &etls_begdate;
            
         if VALID_START_DTTM eq etls_closedate then
            etls_closedate = etls_closedate + (etls_cnt + 1);
            
         if VALID_END_DTTM eq . then
            VALID_END_DTTM = etls_closedate - 1;
            
      end;
      
      /* Fix the beginning dates if needed  */ 
      etls_sameday = lag1(VALID_START_DTTM);
      if not first.MODEL_RK and etls_sameday eq VALID_START_DTTM then
         VALID_START_DTTM = VALID_START_DTTM + etls_cnt;
         
   run;
   
   %rcSet(&syserr); 
   
   /*---- Slowly Changing Dimension Type 2 Beginning/End Date Method  ----*/ 
   /* Data merge the cross-reference and source tables  */ 
   data work.etls_newrcds
          (drop = ETLS_STGDIGEST DIGEST_VALUE ETLS_FROMDATE ETLS_CLSDATE 
                     ETLS_TODATE ETLS_LOADTIME)
      work.etls_match
          (drop = ETLS_STGDIGEST DIGEST_VALUE ETLS_FROMDATE ETLS_CLSDATE 
                     ETLS_TODATE ETLS_LOADTIME)
      work.etls_close
          (keep = CUSTOMER_RK MODEL_RK ETLS_FROMDATE ETLS_CLSDATE ETLS_LOADTIME);
         
      merge work.etls_source(in=inSort rename=(DIGEST_VALUE = ETLS_STGDIGEST))
         work.etls_sortedxref (in=inXref rename=(
               VALID_START_DTTM = ETLS_FROMDATE
               VALID_END_DTTM = ETLS_TODATE));
      by CUSTOMER_RK MODEL_RK;
      
      attrib ETLS_CLSDATE length=8 format = NLDATM21. informat = NLDATM21.;
      attrib ETLS_LOADTIME length=8 format = NLDATM21. informat = NLDATM21.;
      
      /* Process changes made to existing records  */ 
      if inSort and inXref then
      do;
      
         if ETLS_STGDIGEST NE DIGEST_VALUE then
         do;
         
            if VALID_START_DTTM eq . then
               VALID_START_DTTM = &etls_begdate;
               
            /* Ignore history records, only accept changes where the cross reference  */ 
            /*  beginning date is less than the source beginning date                 */ 
            if ETLS_FROMDATE < VALID_START_DTTM then
            do;
            
               if VALID_END_DTTM eq . then
                  VALID_END_DTTM = &etls_enddate;
                  
               /* Save off the close date  */ 
               ETLS_CLSDATE = VALID_START_DTTM - 1;
               
               PROCESSED_DTTM = input("&etls_loadtime", NLDATM21.);
               ETLS_LOADTIME = input("&etls_loadtime", NLDATM21.);
               
               output work.etls_close;
               
               /* Update the cross-reference varaibles to the new current values  */ 
               DIGEST_VALUE = ETLS_STGDIGEST;
               ETLS_FROMDATE = VALID_START_DTTM;
               ETLS_TODATE = VALID_END_DTTM;
               
               output work.etls_match;
               
            end;
            
         end;
         
         else do;
         
            if VALID_END_DTTM ne . then
            do;
            
               /* If the cross-reference end date is greater then the source end date then  */ 
               /*  close out the target record with the source end date                     */ 
               if last.MODEL_RK then
                  if ETLS_TODATE gt VALID_END_DTTM then
                  do;
                  
                     ETLS_CLSDATE = VALID_END_DTTM;
                     ETLS_LOADTIME = input("&etls_loadtime", NLDATM21.);
                     
                     output work.etls_close;
                     
                  end;
                  
            end;
            
            else do;
            
               /* if the source beginning date is greater then both the cross-reference  */ 
               /*  beginning and end date, then reactivate the closed out record         */ 
               if VALID_START_DTTM gt ETLS_FROMDATE and
                  VALID_START_DTTM gt ETLS_TODATE then
               do;
               
                  VALID_END_DTTM = &etls_enddate;
                  
                  PROCESSED_DTTM = input("&etls_loadtime", NLDATM21.);
                  /* Update the cross-reference varaibles to the new current values  */ 
                  DIGEST_VALUE = ETLS_STGDIGEST;
                  ETLS_FROMDATE = VALID_START_DTTM;
                  ETLS_TODATE = VALID_END_DTTM;
                  
                  output work.etls_match;
                  
               end;
               
            end;
            
         end;
         
      end;
      /* Process new records  */ 
      else if inSort and not inXref then 
      do;
      
         if VALID_START_DTTM eq . then
            VALID_START_DTTM = &etls_begdate;
         if VALID_END_DTTM eq . then 
            VALID_END_DTTM = &etls_enddate;
            
         PROCESSED_DTTM = input("&etls_loadtime", NLDATM21.);
         
         output work.etls_newrcds;
         
      end;
      
   run;
   
   %rcSet(&syserr); 
   
   /* Sort the output from the data merge step  */ 
   proc sort data=work.etls_close nodupkey;
      by CUSTOMER_RK MODEL_RK descending ETLS_FROMDATE;
   run;
   %rcSet(&syserr); 
   
   proc sort data=work.etls_match nodupkey;
      by CUSTOMER_RK MODEL_RK descending VALID_START_DTTM;
   run;
   %rcSet(&syserr); 
   
   /* Save record counts into macros  */ 
   %let etls_updatecnt = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(work.etls_close, DATA)) or 
            %sysfunc(exist(work.etls_close, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = work.etls_close out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_updatecnt", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %rcSet(&syserr); 
   
   %let etls_matchcnt = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(work.etls_match, DATA)) or 
            %sysfunc(exist(work.etls_match, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = work.etls_match out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_matchcnt", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %rcSet(&syserr); 
   
   %let etls_newcnt = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(work.etls_newrcds, DATA)) or 
            %sysfunc(exist(work.etls_newrcds, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = work.etls_newrcds out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_newcnt", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(detail.CUSTOMER_SCORE_DETAIL, DATA)) or 
            %sysfunc(exist(detail.CUSTOMER_SCORE_DETAIL, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = detail.CUSTOMER_SCORE_DETAIL out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(CUSTOMER_SCORE_DETAIL);
   %let etls_lib   = %nrquote(Detail Tables);
   
   /* Check to see if the update counts are greater than zero  */ 
   %if &etls_updatecnt le 0 and &etls_matchcnt le 0 and &etls_newcnt le 0
      %then %goto scdldout;
      
   /*---- Start of target table update  ----*/ 
   %if &etls_updatecnt gt 0 %then
   %do;
   
      data detail.CUSTOMER_SCORE_DETAIL;
      
         set work.etls_close
          (rename = (ETLS_FROMDATE = VALID_START_DTTM));
         
         modify detail.CUSTOMER_SCORE_DETAIL
            key = XPKCUSTOMER_SCORE_DETAIL / unique;
            
         VALID_END_DTTM = ETLS_CLSDATE;
         
         PROCESSED_DTTM = ETLS_LOADTIME;
         
         if %sysrc(_SOK) eq _iorc_ then 
            replace;
            
         _iorc_ = 0; 
         _error_ = 0;
         
      run;
      
      %rcSet(&syserr); 
      
   %end;
   %else %do;
   
      %put %str(NOTE: No target table update records were found. The target table was not
            modified.);
      
   %end;
   
   /*---- Append the new records and matching datasets  ----*/ 
   %if &etls_matchcnt gt 0 %then
   %do;
   
      proc append base = detail.CUSTOMER_SCORE_DETAIL
         data = work.etls_match force;
      run;
      
      %rcSet(&syserr); 
      
   %end;
   %if &etls_newcnt gt 0 %then
   %do;
   
      proc append base = detail.CUSTOMER_SCORE_DETAIL
         data = work.etls_newrcds force;
      run;
      
      %rcSet(&syserr); 
      
   %end;
   %else %do;
   
      %put %str(NOTE: No new dimensions were found. The target table was not modified.);
      
   %end;
   
   /* Delete the work tables  */ 
   %if &etls_debug eq 0 %then
   %do;
   
      proc datasets lib=work nolist nowarn memtype = (data view);
         delete etls_newrcds;
         delete etls_match;
         delete etls_close;
      quit;
      
   %end;
   
   %let etls_lastTable = %nrquote(detail.CUSTOMER_SCORE_DETAIL);
   
   %if &etls_debug lt 2 %then
   %do;
   
      proc datasets lib=work nolist nowarn memtype = (data view);
         delete etls_sortedxref;
         delete etls_source;
      quit;
      
   %end;
   
   %goto scdldout;
   %error:
      %let sysrc = 9999;
      %rcSet(sysrc); 
      
   %scdldout:
      /* Get number of records in table  */ 
      %let etls_recordsAfter = 0; 
      %macro etls_recordCheck; 
         %let etls_recCheckExist = %eval(%sysfunc(exist(detail.CUSTOMER_SCORE_DETAIL, DATA)) or 
               %sysfunc(exist(detail.CUSTOMER_SCORE_DETAIL, VIEW))); 
         
         %if (&etls_recCheckExist) %then
         %do;
            proc contents data = detail.CUSTOMER_SCORE_DETAIL out = work.etls_contents(keep = nobs) noprint; 
            run; 
            
            data _null_; 
               set work.etls_contents (obs = 1); 
               call symput("etls_recordsAfter", left(put(nobs,32.))); 
            run;
            
            proc datasets lib = work nolist nowarn memtype = (data view);
               delete etls_contents;
            quit;
            
         %end;
      %mend etls_recordCheck;
      %etls_recordCheck;
      
%mend etls_scdloader;

/* Execute the SCD Type 2 Loader  */ 
%etls_scdloader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
