/****************************************************************************** 
 * Job:           CUS_CC_L                                  A5V75JN3.BN00006K * 
 * Description:   This job picks up data from CUS_EXT and CUS_CC by           * 
 *                 performing left join on CUS_EXT                            * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: CUS_CC - martscr.CUS_CC                   A5V75JN3.BE0000P4 * 
 *                CUS_EXT - martscr.CUS_EXT                 A5V75JN3.BE0000J7 * 
 * Target Table:  CUS_CC_L - martscr.CUS_CC_L               A5V75JN3.BE0000P7 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 4:40:48 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CUS_CC_L                                                                   * 
 * Job Name: CUS_CC_LJob DescPre Process: NoneMain: a) Corporate Customer     * 
 * Information obtained by joining CUS_EXT and CUS_CC on CUSTOMER_RK by       * 
 * performing LEFT JOIN on CUS_EXT. This information is stored in the         * 
 * dataset CUS_CC_L.Post Process: Creating simple index on CUSTOMER_RK &      * 
 *  LOAD_END_DTTMParameters: NoneDeveloped by: singupReviewed by:Tested by:   * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00006K);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CUS_CC_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Corporate Customer Information            A5V75JN3.BO0005QG * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Corporate Customer Information                              * 
 *                                                                            * 
 * Source Tables: CUS_CC - martscr.CUS_CC                   A5V75JN3.BE0000P4 * 
 *                CUS_EXT - martscr.CUS_EXT                 A5V75JN3.BE0000J7 * 
 * Target Table:  SQL Join Target - martscr.CUS_CC_L        A5V75JN3.BP0004TV * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005QG); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CUS_CC_L;
quit;

proc sql;
   create table martscr.CUS_CC_L as
      select
         CUS_EXT.CUSTOMER_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "Customer Key",
         CUS_EXT.LOAD_END_DTTM length = 8
                               format = NLDATM21.
                               informat = NLDATM21.
                               label = "Load End Datetime",
         CUS_CC.EXTERNAL_ORG_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "External Organization Key",
         CUS_CC.INCORPORATION_DT length = 8
                                 format = NLDATE10.
                                 informat = NLDATE10.
                                 label = "Incorporation Date",
         CUS_CC.OWNERSHIP_CNT length = 8
                              label = "Ownership Count",
         CUS_CC.NUM_OFFICES_CNT length = 8
                                label = "Number of Offices",
         CUS_CC.NUM_EMPLOYEES_CNT length = 8
                                  label = "Number of Employees",
         CUS_CC.INTERNAL_CREDIT_RATING_CD length = 20
                                          label = "Internal Credit Rating Code",
         CUS_CC.EXTERNAL_CREDIT_RATING1_CD length = 4
                                           label = "External Credit Rating Code 1",
         CUS_CC.EXTERNAL_CREDIT_RATING2_CD length = 4
                                           label = "External Credit Rating Code 2",
         CUS_CC.OWNERSHIP_CD length = 3
                             label = "Ownership Code",
         CUS_CC.BUSINESS_NATURE_CD length = 3
                                   label = "Business Nature Code",
         CUS_EXT.CUSTOMER_ID length = 32
                             label = "Customer Id",
         CUS_EXT.SOURCE_SYSTEM_CD length = 3
                                  label = "Source System Code",
         CUS_EXT.TAX_ID length = 32
                        label = "Tax Id",
         CUS_EXT.TAX_ID_TYPE_CD length = 3
                                label = "Tax Id Type Code",
         CUS_EXT.CUSTOMER_TYPE_CD length = 3
                                  label = "Customer Type Code",
         CUS_EXT.CUSTOMER_ACTIVE_CD length = 3
                                    label = "Customer Active Code",
         CUS_EXT.CUSTOMER_LIFECYCLE_CD length = 3
                                       label = "Customer Lifecycle Code",
         CUS_EXT.PREFERRED_CHANNEL_CD length = 3
                                      label = "Preferred Channel Code",
         CUS_EXT.BANKRUPTCY_STATUS_CD length = 3
                                      label = "Bankruptcy Status Code",
         CUS_EXT.BANKRUPTCY_FILED_DT length = 8
                                     format = NLDATE10.
                                     informat = NLDATE10.
                                     label = "Bankruptcy Filed Date",
         CUS_EXT.PENDING_LAWSUIT_FLG length = 1
                                     label = "Pending Lawsuit Flag",
         CUS_EXT.LEGAL_JUDGEMENT_FLG length = 1
                                     label = "Legal Judgement Flag",
         CUS_EXT.FIRST_ACCOUNT_TYPE_CD length = 3
                                       label = "First Financial Acct Type Code",
         CUS_EXT.FIRST_ACCOUNT_OPEN_DT length = 8
                                       format = NLDATE10.
                                       informat = NLDATE10.
                                       label = "First Financial Account Date",
         CUS_EXT.CUSTOMER_CLASS_CD length = 3
                                   label = "Customer Class Code",
         CUS_EXT.EVER_IN_COLLECTION_FLG length = 1
                                        label = "Ever In Collection Flag"
      from
         martscr.CUS_EXT left join 
         martscr.CUS_CC
            on
            (
               CUS_CC.CUSTOMER_RK = CUS_EXT.CUSTOMER_RK
               and CUS_CC.LOAD_END_DTTM = CUS_EXT.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify CUS_CC_L;
         ic create not null (CUSTOMER_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QF * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target - martscr.CUS_CC_L        A5V75JN3.BP0004TV * 
 * Target Table:  CUS_CC_L - martscr.CUS_CC_L               A5V75JN3.BE0000P7 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043J * 
 *                                                                            * 
 * User Written:  Index creation on CUSTOMER_RK &           A5V75JN3.AF000MYU * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on CUSTOMER_RK & LOAD_END_DTTM               * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on CUSTOMER_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX CUSTOMER_RK_LOAD_END_DTTM
      ON martscr.CUS_CC_L(CUSTOMER_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

