/****************************************************************************** 
 * Job:           CUS_CUS_BASIC_CURR_ABT                    A5V75JN3.BN0001OM * 
 * Description:   This job picks up the data from CUSTOMER_DIM.               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  CUSTOMER_DIM - dim.CUSTOMER_DIM           A5V75JN3.BE0000LO * 
 * Target Table:  CUS_CUS_BASIC_CURR_ABT -                  A5V75JN3.BE0001R6 * 
 *                 abtagg.CUS_CUS_BASIC_CURR_ABT                              * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 12:50:30 PM IST                * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CUS_CUS_BASIC_CURR_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Finding the generalize customer           A5V75JN3.BO0005LJ * 
 *                 information.                                               * 
 * Transform:     Extract                                                     * 
 * Description:   Finding the generalize customer information and             * 
 *                calculating the variables                                   * 
 *                CUS_SNC_FST_ACC_OPN_DAY_CNT,CUS_NET_MTHLY_INC_AMT           * 
 *                 CUS_TNR_MTH_CNT.                                           * 
 *                                                                            * 
 * Source Table:  CUSTOMER_DIM - dim.CUSTOMER_DIM           A5V75JN3.BE0000LO * 
 * Target Table:  Extract Target -                          A5V75JN3.BP0004QU * 
 *                 abtagg.CUS_CUS_BASIC_CURR_ABT                              * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(dim.CUSTOMER_DIM); 

%let trans_rc = 0; 

proc datasets lib = abtagg nolist nowarn memtype = (data view);
   delete CUS_CUS_BASIC_CURR_ABT;
quit;

proc sql; 
   create table abtagg.CUS_CUS_BASIC_CURR_ABT as 
      select CUSTOMER_RK length = 8 label = '_RKorSK',
             (SUM(MONTHLY_SALARY_INCOME_AMT , MONTHLY_BUSINESS_INCOME_AMT ,
              MONTHLY_RENTAL_INCOME_AMT , MONTHLY_REPLACEMENT_INCOME_AMT ,
              MONTHLY_OTHER_INCOME_AMT , MONTHLY_CHILD_ALLOW_AMT ,
              MONTHLY_RENTAL_AMT , -MONTHLY_ALIMONY_AMT , -MONTHLY_CHILD_SUPPORT_AMT , -MONTHLY_REPAYMENT_AMT ,
              -MONTHLY_REPAYMENT_OTHERS_AMT , -MONTHLY_OTHER_CHARGE_AMT )) as CUS_NET_MTHLY_INC_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             EVER_IN_COLLECTION_FLG as CUS_EVER_IN_COLL_FLG length = 8,
             CUSTOMER_LIFECYCLE_CD as CUS_LIFE_CYC_CD length = 8,
             FIRST_ACCOUNT_OPEN_DT as CUS_FST_ACC_OPN_DT length = 8,
             PREFERRED_CHANNEL_CD as CUS_PREF_CHNL_CD length = 8,
             (INTCK('MONTH', FIRST_ACCOUNT_OPEN_DT , &LOAD_ABT_USER_INPUT_DATE)) as CUS_TNR_MTH_CNT length = 8,
             FIRST_ACCOUNT_TYPE_CD as CUS_FST_ACC_TYP_CD length = 3,
             BILL_PAY_SERVICE_FLG as CUS_AUTO_PAY_FACY_FLG length = 1,
             (INTCK('DAY', FIRST_ACCOUNT_OPEN_DT , &LOAD_ABT_USER_INPUT_DATE)) as CUS_SNC_FST_ACC_OPN_DAY_CNT length = 8,
             CUSTOMER_ACTIVE_CD length = 3 label = '_CD',
             BANKRUPTCY_FILED_DT length = 8 label = '_DT',
             ELDEST_CHILD_BIRTH_DT length = 8 label = '_DT',
             ORGANIZATION_TYPE_CD length = 3 label = '_CD',
             CUSTOMER_TYPE_CD length = 3 label = '_CD',
             EMPLOYMENT_STATUS_CD length = 3 label = '_CD',
             CURRENT_EMP_START_DT length = 8 label = '_DT',
             LEGAL_JUDGEMENT_FLG length = 1 label = 'Flags',
             SECNDRY_CITIZENSHIP_COUNTRY_CD length = 3 label = '_CD',
             STD_OCCUPATION_CD length = 3 label = '_CD',
             PASSPORT_ISSUE_COUNTRY_CD length = 3 label = '_CD',
             EMPLOYMENT_YEARS_CNT length = 8,
             CUSTOMER_COUNTRY_CD length = 3 label = '_CD',
             PRIMARY_CITIZENSHIP_COUNTRY_CD length = 3 label = '_CD',
             TOTAL_EMPLOYMENT_YEARS_CNT length = 8,
             CUSTOMER_STATE_REGION_CD length = 4 label = 'State_Region_Cd',
             CUSTOMER_ACTIVE_DESC length = 100,
             TAX_ID_TYPE_CD length = 3 label = '_CD',
             TAX_BRACKET_CD length = 3 label = '_CD',
             RESIDENCE_STATUS_CD length = 3 label = '_CD',
             ORGANIZATION_NM length = 40,
             CUSTOMER_TYPE_DESC length = 100,
             TEMPORARY_EMPLOYMENT_END_DT length = 8 label = '_DT',
             EMPLOYEE_FLG length = 1 label = 'Flags',
             CUSTOMER_CITY_NM length = 100,
             PREFERRED_TELEPHONE_NO length = 20,
             CUSTOMER_POSTAL_CD length = 20,
             GENDER_CD length = 3 label = '_CD',
             TAX_ID length = 32 label = '_Id',
             BANKRUPTCY_STATUS_CD length = 3 label = '_CD',
             CHILDREN_CNT length = 8,
             EDUCATION_LEVEL_CD length = 10 label = 'String',
             EMPLOYMENT_POSITION_STATUS_CD length = 3 label = '_CD',
             SELF_EMPLOYMENT_FLG length = 1 label = 'Flags',
             BIRTH_DT length = 8 label = '_DT',
             CURRENT_COUNTRY_START_DT length = 8 label = '_DT',
             EMPLOYMENT_START_DT length = 8 label = '_DT',
             PENDING_LAWSUIT_FLG length = 1 label = 'Flags',
             EMPLOYERS_CNT length = 8,
             TOTAL_DEPENDENTS_CNT length = 8,
             MARITAL_STATUS_CD length = 3 label = '_CD',
             YOUNGEST_CHILD_BIRTH_DT length = 8 label = '_DT',
             OCCUPATION_START_DT length = 8 label = '_DT',
             LIQUID_ASSETS_AMT length = 8 label = '_AMT',
             LIQUID_NET_WORTH_AMT length = 8 label = '_AMT',
             OWN_AUTOMOBILE_FLG length = 1 label = 'Flags',
             LIABILITY_OTHER_AMT length = 8 label = '_AMT',
             REAL_ESTATE_AMT length = 8 label = '_AMT',
             OWN_RESIDENCE_PROPERTY_FLG length = 1 label = 'Flags',
             OWN_MOTORCYCLE_FLG length = 1 label = 'Flags',
             ASSET_OTHER_AMT length = 8 label = '_AMT',
             TOTAL_LIABILITY_AMT length = 8 label = '_AMT',
             TOTAL_ASSET_AMT length = 8 label = '_AMT',
             OTHER_BANK_CLIENT_FLG length = 1 label = 'Flags',
             NET_WORTH_AMT length = 8 label = '_AMT',
             LIABILITY_REAL_ESTATE_AMT length = 8 label = '_AMT',
             ANNUAL_INCOME_AMT length = 8 label = '_AMT',
             MONTHLY_PRI_INCOME_SOURCE_CD length = 3 format = $3. informat = $3. label = '_CD',
             MONTHLY_SALARY_INCOME_AMT length = 8 label = '_AMT',
             MONTHLY_BUSINESS_INCOME_AMT length = 8 label = '_AMT',
             MONTHLY_RENTAL_INCOME_AMT length = 8 label = '_AMT',
             MONTHLY_REPLACEMENT_INCOME_AMT length = 8 label = '_AMT',
             MONTHLY_OTHER_INCOME_AMT length = 8 label = '_AMT',
             MONTHLY_CHILD_ALLOW_AMT length = 8 label = '_AMT',
             MONTHLY_RENTAL_AMT length = 8 label = '_AMT',
             MONTHLY_ALIMONY_AMT length = 8 label = '_AMT',
             MONTHLY_CHILD_SUPPORT_AMT length = 8 label = '_AMT',
             MONTHLY_REPAYMENT_AMT length = 8 label = '_AMT',
             MONTHLY_REPAYMENT_OTHERS_AMT length = 8 label = '_AMT',
             MONTHLY_OTHER_CHARGE_AMT length = 8 label = '_AMT',
             BILL_PAY_SERVICE_FLG length = 1 label = 'Flags',
             INCOME_CATEGORY_CD length = 3 label = '_CD',
             INTERNAL_CREDIT_RATING_CD length = 20,
             INDUSTRY_CD length = 10 label = 'String',
             INCORPORATION_DT length = 8 label = '_DT',
             BUSINESS_ESTABLISHED_DT length = 8 label = '_DT',
             NUM_EMPLOYEES_CNT length = 8,
             BUSINESS_COMMENCED_DT length = 8 label = '_DT',
             EXTERNAL_CREDIT_RATING1_CD length = 4 label = 'State_Region_Cd',
             NUM_OFFICES_CNT length = 8,
             EXTERNAL_CREDIT_RATING2_CD length = 4 label = 'State_Region_Cd',
             OWNERSHIP_CNT length = 8,
             CUSTOMER_CLASS_CD length = 3 label = '_CD',
             OWNERSHIP_CD length = 3 label = '_CD',
             BUSINESS_NATURE_CD length = 3 label = '_CD'
         from &SYSLAST
            where (&LOAD_ABT_USER_INPUT_DTTM >= VALID_START_DTTM AND 
                  &LOAD_ABT_USER_INPUT_DTTM <= VALID_END_DTTM ); 
quit;

%let SYSLAST = abtagg.CUS_CUS_BASIC_CURR_ABT; 

%rcSet(&sqlrc); 

/*---- Create the indexes for a table  ----*/ 
%put %str(NOTE: Creating indexes ...);
proc datasets lib = abtagg nolist; 
   modify CUS_CUS_BASIC_CURR_ABT; 
      index create CUSTOMER_RK;
quit; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005LK * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract Target -                          A5V75JN3.BP0004QU * 
 *                 abtagg.CUS_CUS_BASIC_CURR_ABT                              * 
 * Target Table:  CUS_CUS_BASIC_CURR_ABT -                  A5V75JN3.BE0001R6 * 
 *                 abtagg.CUS_CUS_BASIC_CURR_ABT                              * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

