/****************************************************************************** 
 * Job:           CUS_EOAD_L                                A5V75JN3.BN00006M * 
 * Description:   This job picks up data from CUS_EO_L and CUS_CC_EOAD by     * 
 *                 performing left join on CUS_EO_L.                          * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: CUS_CC_EO_EOAD - martscr.CUS_CC_EO_EOAD   A5V75JN3.BE0000P6 * 
 *                CUS_EO_L - martscr.CUS_EO_L               A5V75JN3.BE0000P8 * 
 * Target Table:  CUS_EOAD_L - martscr.CUS_EOAD_L           A5V75JN3.BE0000P9 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 4:42:52 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CUS_EOAD_L                                                                 * 
 * Job Name: CUS_EOAD_LJob DescPre Process: NoneMain: a) Corporate Customer   * 
 * Address Information obtained by joining CUS_EO_L and CUS_CC_EOAD on        * 
 * CUSTOMER_RK by performing LEFT JOIN on CUS_EO_L. This information is       * 
 * stored in the dataset CUS_EOAD_L.Post Process: Creating index on           * 
 * CUSTOMER_RK and LOAD_END_DTTMParameters: NoneDeveloped by:                 * 
 *  singupReviewed by:Tested by:                                              * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00006M);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CUS_EOAD_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SQL Join                                  A5V75JN3.BO0005QK * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: CUS_CC_EO_EOAD - martscr.CUS_CC_EO_EOAD   A5V75JN3.BE0000P6 * 
 *                CUS_EO_L - martscr.CUS_EO_L               A5V75JN3.BE0000P8 * 
 * Target Table:  SQL Join Target - martscr.CUS_EOAD_L      A5V75JN3.BP0004TX * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005QK); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CUS_EOAD_L;
quit;

proc sql;
   create table martscr.CUS_EOAD_L as
      select
         CUS_EO_L.CUSTOMER_RK length = 8
                              format = 12.
                              informat = 12.
                              label = "Customer Key",
         CUS_EO_L.LOAD_END_DTTM length = 8
                                format = NLDATM21.
                                informat = NLDATM21.
                                label = "Load End Datetime",
         CUS_EO_L.CUSTOMER_ID length = 32
                              label = "Customer Id",
         CUS_EO_L.SOURCE_SYSTEM_CD length = 3
                                   label = "Source System Code",
         CUS_EO_L.TAX_ID_TYPE_CD length = 3
                                 label = "Tax Id Type Code",
         CUS_EO_L.TAX_ID length = 32
                         label = "Tax Id",
         CUS_EO_L.CUSTOMER_TYPE_CD length = 3
                                   label = "Customer Type Code",
         CUS_EO_L.CUSTOMER_ACTIVE_CD length = 3
                                     label = "Customer Active Code",
         CUS_EO_L.CUSTOMER_LIFECYCLE_CD length = 3
                                        label = "Customer Lifecycle Code",
         CUS_EO_L.PREFERRED_CHANNEL_CD length = 3
                                       label = "Preferred Channel Code",
         CUS_EO_L.BANKRUPTCY_STATUS_CD length = 3
                                       label = "Bankruptcy Status Code",
         CUS_EO_L.BANKRUPTCY_FILED_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Bankruptcy Filed Date",
         CUS_EO_L.PENDING_LAWSUIT_FLG length = 1
                                      label = "Pending Lawsuit Flag",
         CUS_EO_L.LEGAL_JUDGEMENT_FLG length = 1
                                      label = "Legal Judgement Flag",
         CUS_EO_L.FIRST_ACCOUNT_TYPE_CD length = 3
                                        label = "First Financial Acct Type Code",
         CUS_EO_L.FIRST_ACCOUNT_OPEN_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "First Financial Account Date",
         CUS_EO_L.CUSTOMER_CLASS_CD length = 3
                                    label = "Customer Class Code",
         CUS_EO_L.EVER_IN_COLLECTION_FLG length = 1
                                         label = "Ever In Collection Flag",
         CUS_EO_L.EXTERNAL_ORG_RK length = 8
                                  format = 12.
                                  informat = 12.
                                  label = "External Organization Key",
         CUS_EO_L.INCORPORATION_DT length = 8
                                   format = NLDATE10.
                                   informat = NLDATE10.
                                   label = "Incorporation Date",
         CUS_EO_L.OWNERSHIP_CNT length = 8
                                label = "Ownership Count",
         CUS_EO_L.NUM_OFFICES_CNT length = 8
                                  label = "Number of Offices",
         CUS_EO_L.NUM_EMPLOYEES_CNT length = 8
                                    label = "Number of Employees",
         CUS_EO_L.INTERNAL_CREDIT_RATING_CD length = 20
                                            label = "Internal Credit Rating Code",
         CUS_EO_L.EXTERNAL_CREDIT_RATING1_CD length = 4
                                             label = "External Credit Rating Code 1",
         CUS_EO_L.EXTERNAL_CREDIT_RATING2_CD length = 4
                                             label = "External Credit Rating Code 2",
         CUS_EO_L.OWNERSHIP_CD length = 3
                               label = "Ownership Code",
         CUS_EO_L.BUSINESS_NATURE_CD length = 3
                                     label = "Business Nature Code",
         CUS_EO_L.ORGANIZATION_NM length = 40
                                  label = "Organization Code",
         CUS_EO_L.ORGANIZATION_TYPE_CD length = 3
                                       label = "Organization Type Code",
         CUS_EO_L.BUSINESS_ESTABLISHED_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Business Established Date",
         CUS_EO_L.BUSINESS_COMMENCED_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Business Commenced Date",
         CUS_EO_L.INDUSTRY_CD length = 10
                              label = "Industry Code",
         CUS_CC_EO_EOAD.CUSTOMER_CITY_NM length = 100
                                         label = "City name",
         CUS_CC_EO_EOAD.CUSTOMER_STATE_REGION_CD length = 4
                                                 label = "State/Region code",
         CUS_CC_EO_EOAD.CUSTOMER_POSTAL_CD length = 20
                                           label = "Postal Code",
         CUS_CC_EO_EOAD.CUSTOMER_COUNTRY_CD length = 3
                                            label = "Country Code"
      from
         martscr.CUS_EO_L left join 
         martscr.CUS_CC_EO_EOAD
            on
            (
               CUS_CC_EO_EOAD.CUSTOMER_RK = CUS_EO_L.CUSTOMER_RK
               and CUS_CC_EO_EOAD.LOAD_END_DTTM = CUS_EO_L.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify CUS_EOAD_L;
         ic create not null (CUSTOMER_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QJ * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target - martscr.CUS_EOAD_L      A5V75JN3.BP0004TX * 
 * Target Table:  CUS_EOAD_L - martscr.CUS_EOAD_L           A5V75JN3.BE0000P9 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043L * 
 *                                                                            * 
 * User Written:  Index creation on CUSTOMER_RK and         A5V75JN3.AF000MZ8 * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on CUSTOMER_RK and LOAD_END_DTTM             * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on CUSTOMER_RK and LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX CUSTOMER_RK_LOAD_END_DTTM
      ON martscr.CUS_EOAD_L(CUSTOMER_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

