/****************************************************************************** 
 * Job:           CUS_FU_L                                  A5V75JN3.BN00006O * 
 * Description:   This job picks up data from CUS_ICAD_L and CUS_FU by        * 
 *                 performing left join on CUS_ICAD_L                         * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: CUS_FU - martscr.CUS_FU                   A5V75JN3.BE0000PA * 
 *                CUS_ICAD_L - martscr.CUS_ICAD_L           A5V75JN3.BE0000PF * 
 * Target Table:  CUS_FU_L - martscr.CUS_FU_L               A5V75JN3.BE0000PB * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 4:46:32 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CUS_FU_L                                                                   * 
 * Job Name: CUS_FU_LJob DescPre Process: NoneMain: a) Primary internal       * 
 * organization key obtained by joining CUS_ICAD_L and CUS_FU on              * 
 * CUSTOMER_RK by performing LEFT JOIN on CUS_ICAD_L. This information is     * 
 * stored in the dataset CUS_FU_L.Post Process: Creating index on             * 
 * CUSTOMER_RK and LOAD_END_DTTMParameters: NoneDeveloped by:                 * 
 *  singupReviewed by:Tested by:                                              * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00006O);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CUS_FU_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Primary internal organization key         A5V75JN3.BO0005QM * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Primary internal organization key obtained by joining       * 
 *                CUS_ICAD_L and CUS_FU on CUSTOMER_RK by performing LEFT     * 
 *                 JOIN on CUS_ICAD_L.                                        * 
 *                                                                            * 
 * Source Tables: CUS_FU - martscr.CUS_FU                   A5V75JN3.BE0000PA * 
 *                CUS_ICAD_L - martscr.CUS_ICAD_L           A5V75JN3.BE0000PF * 
 * Target Table:  SQL Target - martscr.CUS_FU_L             A5V75JN3.BP0004TY * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005QM); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CUS_FU_L;
quit;

proc sql;
   create table martscr.CUS_FU_L as
      select
         CUS_ICAD_L.CUSTOMER_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "Customer Key",
         CUS_ICAD_L.LOAD_END_DTTM length = 8
                                  format = NLDATM21.
                                  informat = NLDATM21.
                                  label = "Load End Datetime",
         CUS_ICAD_L.CUSTOMER_ID length = 32
                                label = "Customer Id",
         CUS_ICAD_L.SOURCE_SYSTEM_CD length = 3
                                     label = "Source System Code",
         CUS_ICAD_L.TAX_ID length = 32
                           label = "Tax Id",
         CUS_ICAD_L.TAX_ID_TYPE_CD length = 3
                                   label = "Tax Id Type Code",
         CUS_ICAD_L.CUSTOMER_TYPE_CD length = 3
                                     label = "Customer Type Code",
         CUS_ICAD_L.CUSTOMER_ACTIVE_CD length = 3
                                       label = "Customer Active Code",
         CUS_ICAD_L.CUSTOMER_LIFECYCLE_CD length = 3
                                          label = "Customer Lifecycle Code",
         CUS_ICAD_L.PREFERRED_CHANNEL_CD length = 3
                                         label = "Preferred Channel Code",
         CUS_ICAD_L.BANKRUPTCY_STATUS_CD length = 3
                                         label = "Bankruptcy Status Code",
         CUS_ICAD_L.BANKRUPTCY_FILED_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Bankruptcy Filed Date",
         CUS_ICAD_L.PENDING_LAWSUIT_FLG length = 1
                                        label = "Pending Lawsuit Flag",
         CUS_ICAD_L.LEGAL_JUDGEMENT_FLG length = 1
                                        label = "Legal Judgement Flag",
         CUS_ICAD_L.FIRST_ACCOUNT_TYPE_CD length = 3
                                          label = "First Financial Acct Type Code",
         CUS_ICAD_L.FIRST_ACCOUNT_OPEN_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "First Financial Account Date",
         CUS_ICAD_L.CUSTOMER_CLASS_CD length = 3
                                      label = "Customer Class Code",
         CUS_ICAD_L.EVER_IN_COLLECTION_FLG length = 1
                                           label = "Ever In Collection Flag",
         CUS_ICAD_L.EXTERNAL_ORG_RK length = 8
                                    format = 12.
                                    informat = 12.
                                    label = "External Organization Key",
         CUS_ICAD_L.INCORPORATION_DT length = 8
                                     format = NLDATE10.
                                     informat = NLDATE10.
                                     label = "Incorporation Date",
         CUS_ICAD_L.OWNERSHIP_CNT length = 8
                                  label = "Ownership Count",
         CUS_ICAD_L.NUM_OFFICES_CNT length = 8
                                    label = "Number of Offices",
         CUS_ICAD_L.NUM_EMPLOYEES_CNT length = 8
                                      label = "Number of Employees",
         CUS_ICAD_L.INTERNAL_CREDIT_RATING_CD length = 20
                                              label = "Internal Credit Rating Code",
         CUS_ICAD_L.EXTERNAL_CREDIT_RATING1_CD length = 4
                                               label = "External Credit Rating Code 1",
         CUS_ICAD_L.EXTERNAL_CREDIT_RATING2_CD length = 4
                                               label = "External Credit Rating Code 2",
         CUS_ICAD_L.OWNERSHIP_CD length = 3
                                 label = "Ownership Code",
         CUS_ICAD_L.BUSINESS_NATURE_CD length = 3
                                       label = "Business Nature Code",
         CUS_ICAD_L.ORGANIZATION_NM length = 40
                                    label = "Organization Code",
         CUS_ICAD_L.ORGANIZATION_TYPE_CD length = 3
                                         label = "Organization Type Code",
         CUS_ICAD_L.BUSINESS_ESTABLISHED_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "Business Established Date",
         CUS_ICAD_L.BUSINESS_COMMENCED_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Business Commenced Date",
         CUS_ICAD_L.INDUSTRY_CD length = 10
                                label = "Industry Code",
         CUS_ICAD_L.CUSTOMER_CITY_NM length = 100
                                     label = "City name",
         CUS_ICAD_L.CUSTOMER_STATE_REGION_CD length = 4
                                             label = "State/Region code",
         CUS_ICAD_L.CUSTOMER_POSTAL_CD length = 20
                                       label = "Postal Code",
         CUS_ICAD_L.CUSTOMER_COUNTRY_CD length = 3
                                        label = "Country Code",
         CUS_ICAD_L.CUSTOMER_NM length = 100
                                format = $100.,
         CUS_ICAD_L.BIRTH_DT length = 8
                             format = NLDATE10.
                             informat = NLDATE10.
                             label = "Birth Date",
         CUS_ICAD_L.GENDER_CD length = 3
                              label = "Gender Code",
         CUS_ICAD_L.MARITAL_STATUS_CD length = 3
                                      label = "Marital Status Code",
         CUS_ICAD_L.PASSPORT_ISSUE_COUNTRY_CD length = 3
                                              label = "Country Code",
         CUS_ICAD_L.PRIMARY_CITIZENSHIP_COUNTRY_CD length = 3
                                                   label = "Country Code",
         CUS_ICAD_L.SECNDRY_CITIZENSHIP_COUNTRY_CD length = 3
                                                   label = "Country Code",
         CUS_ICAD_L.EDUCATION_LEVEL_CD length = 10
                                       label = "Education Level Code",
         CUS_ICAD_L.STD_OCCUPATION_CD length = 3
                                      label = "Standard Occupation Code",
         CUS_ICAD_L.EMPLOYMENT_STATUS_CD length = 3
                                         label = "Employment Status Code",
         CUS_ICAD_L.EMPLOYMENT_YEARS_CNT length = 8
                                         format = NLNUM6.2
                                         informat = NLNUM6.2
                                         label = "Employment Years Count",
         CUS_ICAD_L.TOTAL_EMPLOYMENT_YEARS_CNT length = 8
                                               format = NLNUM6.2
                                               informat = NLNUM6.2
                                               label = "Total Employment Years Count",
         CUS_ICAD_L.ANNUAL_INCOME_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Annual Income Amount",
         CUS_ICAD_L.TAX_BRACKET_CD length = 3
                                   label = "Tax Bracket Code",
         CUS_ICAD_L.TOTAL_ASSET_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Total Asset Amount",
         CUS_ICAD_L.TOTAL_LIABILITY_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Total Liability Amount",
         CUS_ICAD_L.LIQUID_NET_WORTH_AMT length = 8
                                         format = NLNUM18.5
                                         informat = NLNUM18.5
                                         label = "Liquid Net Worth Amount",
         CUS_ICAD_L.TOTAL_DEPENDENTS_CNT length = 8
                                         label = "Total Dependents Count",
         CUS_ICAD_L.RESIDENCE_STATUS_CD length = 3
                                        label = "Resident Status Code",
         CUS_ICAD_L.PREFERRED_TELEPHONE_NO length = 20
                                           label = "Preferred Telephone No",
         CUS_ICAD_L.YOUNGEST_CHILD_BIRTH_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "Youngest Child Birth Date",
         CUS_ICAD_L.EMPLOYEE_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "Employee Key",
         CUS_ICAD_L.EMPLOYERS_CNT length = 8
                                  label = "No Of Employers Count",
         CUS_ICAD_L.OTHER_CREDIT_CARDS_CNT length = 8
                                           label = "Other Credit Cards Count",
         CUS_ICAD_L.LIQUID_ASSETS_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Liquid Assets Amount",
         CUS_ICAD_L.REAL_ESTATE_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Real Estate Amount",
         CUS_ICAD_L.ASSET_OTHER_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Asset Other Amount",
         CUS_ICAD_L.LIABILITY_REAL_ESTATE_AMT length = 8
                                              format = NLNUM18.5
                                              informat = NLNUM18.5
                                              label = "Liability Real Estate Amount",
         CUS_ICAD_L.LIABILITY_OTHER_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Liability Other Amount",
         CUS_ICAD_L.NET_WORTH_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Net Worth Amount",
         CUS_ICAD_L.OTHER_INST_CLIENT_CNT length = 8
                                          label = "Other Institute Client Count",
         CUS_ICAD_L.OCCUPATION_START_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Occupation Start Date",
         CUS_ICAD_L.CURRENT_EMP_START_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Current Employment Start Date",
         CUS_ICAD_L.CURRENT_COUNTRY_START_DT length = 8
                                             format = NLDATE10.
                                             informat = NLDATE10.
                                             label = "Current Country Start Date",
         CUS_ICAD_L.EMPLOYMENT_START_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Employment Start Date",
         CUS_ICAD_L.EMPLOYMENT_POSITION_STATUS_CD length = 3,
         CUS_ICAD_L.TEMPORARY_EMPLOYMENT_END_DT length = 8
                                                format = NLDATE10.
                                                informat = NLDATE10.,
         CUS_ICAD_L.CHILDREN_CNT length = 8,
         CUS_ICAD_L.ELDEST_CHILD_BIRTH_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.,
         CUS_ICAD_L.OWN_AUTOMOBILE_FLG length = 1,
         CUS_ICAD_L.OWN_MOTORCYCLE_FLG length = 1,
         CUS_ICAD_L.MONTHLY_PRI_INCOME_SOURCE_CD length = 10,
         CUS_ICAD_L.BILL_PAY_SERVICE_FLG length = 1
                                         label = "Bill Pay Service Flag",
         CUS_ICAD_L.INCOME_CATEGORY_CD length = 3
                                       label = "Income Category Code",
         CUS_ICAD_L.HHOLD_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "Household Key",
         CUS_ICAD_L.CURRENT_ADDRESS_START_DT length = 8
                                             format = NLDATE10.
                                             informat = NLDATE10.
                                             label = "Current Address Start Date",
         CUS_ICAD_L.RESIDENCE_STATUS_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Residence Status Date",
         CUS_FU.PRIMARY_INTERNAL_ORG_RK length = 8
                                        format = 12.
                                        informat = 12.
                                        label = "Internal Organization Key"
      from
         martscr.CUS_ICAD_L left join 
         martscr.CUS_FU
            on
            (
               CUS_FU.CUSTOMER_RK = CUS_ICAD_L.CUSTOMER_RK
               and CUS_FU.LOAD_END_DTTM = CUS_ICAD_L.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify CUS_FU_L;
         ic create not null (CUSTOMER_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QL * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.CUS_FU_L             A5V75JN3.BP0004TY * 
 * Target Table:  CUS_FU_L - martscr.CUS_FU_L               A5V75JN3.BE0000PB * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043M * 
 *                                                                            * 
 * User Written:  Index Creation on CUSTOMER_RK and         A5V75JN3.AF000MZF * 
 *                 LOAD_END_DTTM                                              * 
 *                Index Creation on CUSTOMER_RK and LOAD_END_DTTM             * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on CUSTOMER_RK and LOAD_END_DTTM */
PROC SQL NOPRINT;
     CREATE INDEX  CUSTOMER_RK_LOAD_END_DTTM
      ON martscr.CUS_FU_L(CUSTOMER_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

