/****************************************************************************** 
 * Job:           CUS_IC_L                                  A5V75JN3.BN00006R * 
 * Description:   This job picks up data from CUS_EOAD_L and CUS_IC by        * 
 *                 performing left join on CUS_EOAD_L                         * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: CUS_IC - martscr.CUS_IC                   A5V75JN3.BE0000PC * 
 *                CUS_EOAD_L - martscr.CUS_EOAD_L           A5V75JN3.BE0000P9 * 
 * Target Table:  CUS_IC_L - martscr.CUS_IC_L               A5V75JN3.BE0000PE * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 4:45:01 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * CUS_IC_L                                                                   * 
 * Job Name: CUS_IC_LJob DescPre Process: NoneMain: a) Individual Customer    * 
 * Information obtained by joining CUS_EOAD_L and CUS_IC on CUSTOMER_RK by    * 
 * performing LEFT JOIN on CUS_EOAD_L. This information is stored in the      * 
 * dataset CUS_IC_L.Post Process: Creating index on CUSTOMER_RK and           * 
 *  LOAD_END_DTTMParameters: NoneDeveloped by: singupReviewed by:Tested by:   * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00006R);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = CUS_IC_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Individual Customer Information           A5V75JN3.BO0005QO * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Individual Customer Information obtained by joining         * 
 *                CUS_EOAD_L and CUS_IC on CUSTOMER_RK by performing LEFT     * 
 *                 JOIN on CUS_EOAD_L.                                        * 
 *                                                                            * 
 * Source Tables: CUS_IC - martscr.CUS_IC                   A5V75JN3.BE0000PC * 
 *                CUS_EOAD_L - martscr.CUS_EOAD_L           A5V75JN3.BE0000P9 * 
 * Target Table:  SQL Target - martscr.CUS_IC_L             A5V75JN3.BP0004TZ * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005QO); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete CUS_IC_L;
quit;

proc sql;
   create table martscr.CUS_IC_L as
      select
         CUS_EOAD_L.CUSTOMER_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "Customer Key",
         CUS_EOAD_L.LOAD_END_DTTM length = 8
                                  format = NLDATM21.
                                  informat = NLDATM21.
                                  label = "Load End Datetime",
         CUS_EOAD_L.CUSTOMER_ID length = 32
                                label = "Customer Id",
         CUS_EOAD_L.SOURCE_SYSTEM_CD length = 3
                                     label = "Source System Code",
         CUS_EOAD_L.TAX_ID length = 32
                           label = "Tax Id",
         CUS_EOAD_L.TAX_ID_TYPE_CD length = 3
                                   label = "Tax Id Type Code",
         CUS_EOAD_L.CUSTOMER_TYPE_CD length = 3
                                     label = "Customer Type Code",
         CUS_EOAD_L.CUSTOMER_ACTIVE_CD length = 3
                                       label = "Customer Active Code",
         CUS_EOAD_L.PREFERRED_CHANNEL_CD length = 3
                                         label = "Preferred Channel Code",
         CUS_EOAD_L.CUSTOMER_LIFECYCLE_CD length = 3
                                          label = "Customer Lifecycle Code",
         CUS_EOAD_L.BANKRUPTCY_STATUS_CD length = 3
                                         label = "Bankruptcy Status Code",
         CUS_EOAD_L.BANKRUPTCY_FILED_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Bankruptcy Filed Date",
         CUS_EOAD_L.PENDING_LAWSUIT_FLG length = 1
                                        label = "Pending Lawsuit Flag",
         CUS_EOAD_L.LEGAL_JUDGEMENT_FLG length = 1
                                        label = "Legal Judgement Flag",
         CUS_EOAD_L.FIRST_ACCOUNT_TYPE_CD length = 3
                                          label = "First Financial Acct Type Code",
         CUS_EOAD_L.FIRST_ACCOUNT_OPEN_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "First Financial Account Date",
         CUS_EOAD_L.CUSTOMER_CLASS_CD length = 3
                                      label = "Customer Class Code",
         CUS_EOAD_L.EVER_IN_COLLECTION_FLG length = 1
                                           label = "Ever In Collection Flag",
         CUS_EOAD_L.EXTERNAL_ORG_RK length = 8
                                    format = 12.
                                    informat = 12.
                                    label = "External Organization Key",
         CUS_EOAD_L.INCORPORATION_DT length = 8
                                     format = NLDATE10.
                                     informat = NLDATE10.
                                     label = "Incorporation Date",
         CUS_EOAD_L.OWNERSHIP_CNT length = 8
                                  label = "Ownership Count",
         CUS_EOAD_L.NUM_OFFICES_CNT length = 8
                                    label = "Number of Offices",
         CUS_EOAD_L.NUM_EMPLOYEES_CNT length = 8
                                      label = "Number of Employees",
         CUS_EOAD_L.EXTERNAL_CREDIT_RATING1_CD length = 4
                                               label = "External Credit Rating Code 1",
         CUS_EOAD_L.EXTERNAL_CREDIT_RATING2_CD length = 4
                                               label = "External Credit Rating Code 2",
         CUS_EOAD_L.OWNERSHIP_CD length = 3
                                 label = "Ownership Code",
         CUS_EOAD_L.ORGANIZATION_NM length = 40
                                    label = "Organization Code",
         CUS_EOAD_L.ORGANIZATION_TYPE_CD length = 3
                                         label = "Organization Type Code",
         CUS_EOAD_L.BUSINESS_ESTABLISHED_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "Business Established Date",
         CUS_EOAD_L.BUSINESS_COMMENCED_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Business Commenced Date",
         CUS_EOAD_L.CUSTOMER_CITY_NM length = 100
                                     label = "City name",
         CUS_EOAD_L.CUSTOMER_STATE_REGION_CD length = 4
                                             label = "State/Region code",
         CUS_EOAD_L.CUSTOMER_POSTAL_CD length = 20
                                       label = "Postal Code",
         CUS_EOAD_L.CUSTOMER_COUNTRY_CD length = 3
                                        label = "Country Code",
         CUS_IC.CUSTOMER_NM length = 100
                            format = $100.,
         CUS_IC.EMPLOYMENT_STATUS_CD length = 3
                                     label = "Employment Status Code",
         CUS_IC.BIRTH_DT length = 8
                         format = NLDATE10.
                         informat = NLDATE10.
                         label = "Birth Date",
         CUS_IC.EMPLOYMENT_YEARS_CNT length = 8
                                     format = NLNUM6.2
                                     informat = NLNUM6.2
                                     label = "Employment Years Count",
         CUS_IC.SECNDRY_CITIZENSHIP_COUNTRY_CD length = 3
                                               label = "Country Code",
         CUS_IC.PASSPORT_ISSUE_COUNTRY_CD length = 3
                                          label = "Country Code",
         CUS_IC.TOTAL_EMPLOYMENT_YEARS_CNT length = 8
                                           format = NLNUM6.2
                                           informat = NLNUM6.2
                                           label = "Total Employment Years Count",
         CUS_IC.TOTAL_ASSET_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Total Asset Amount",
         CUS_IC.PRIMARY_CITIZENSHIP_COUNTRY_CD length = 3
                                               label = "Country Code",
         CUS_IC.ANNUAL_INCOME_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Annual Income Amount",
         CUS_IC.MARITAL_STATUS_CD length = 3
                                  label = "Marital Status Code",
         CUS_IC.GENDER_CD length = 3
                          label = "Gender Code",
         CUS_IC.TAX_BRACKET_CD length = 3
                               label = "Tax Bracket Code",
         CUS_IC.STD_OCCUPATION_CD length = 3
                                  label = "Standard Occupation Code",
         CUS_IC.EDUCATION_LEVEL_CD length = 10
                                   label = "Education Level Code",
         CUS_IC.TOTAL_LIABILITY_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Total Liability Amount",
         CUS_IC.LIQUID_NET_WORTH_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Liquid Net Worth Amount",
         CUS_IC.EMPLOYEE_RK length = 8
                            format = 12.
                            informat = 12.
                            label = "Employee Key",
         CUS_IC.TEMPORARY_EMPLOYMENT_END_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.,
         CUS_IC.NET_WORTH_AMT length = 8
                              format = NLNUM18.5
                              informat = NLNUM18.5
                              label = "Net Worth Amount",
         CUS_IC.LIQUID_ASSETS_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Liquid Assets Amount",
         CUS_IC.OWN_MOTORCYCLE_FLG length = 1,
         CUS_IC.OTHER_INST_CLIENT_CNT length = 8
                                      label = "Other Institute Client Count",
         CUS_IC.ELDEST_CHILD_BIRTH_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.,
         CUS_IC.CHILDREN_CNT length = 8,
         CUS_IC.OWN_AUTOMOBILE_FLG length = 1,
         CUS_IC.REAL_ESTATE_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Real Estate Amount",
         CUS_IC.EMPLOYMENT_POSITION_STATUS_CD length = 3,
         CUS_IC.OCCUPATION_START_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Occupation Start Date",
         CUS_IC.EMPLOYMENT_START_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Employment Start Date",
         CUS_IC.PREFERRED_TELEPHONE_NO length = 20
                                       label = "Preferred Telephone No",
         CUS_IC.EMPLOYERS_CNT length = 8
                              label = "No Of Employers Count",
         CUS_IC.CURRENT_EMP_START_DT length = 8
                                     format = NLDATE10.
                                     informat = NLDATE10.
                                     label = "Current Employment Start Date",
         CUS_IC.MONTHLY_PRI_INCOME_SOURCE_CD length = 10,
         CUS_IC.CURRENT_COUNTRY_START_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Current Country Start Date",
         CUS_IC.RESIDENCE_STATUS_CD length = 3
                                    label = "Resident Status Code",
         CUS_IC.OTHER_CREDIT_CARDS_CNT length = 8
                                       label = "Other Credit Cards Count",
         CUS_IC.LIABILITY_REAL_ESTATE_AMT length = 8
                                          format = NLNUM18.5
                                          informat = NLNUM18.5
                                          label = "Liability Real Estate Amount",
         CUS_IC.LIABILITY_OTHER_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Liability Other Amount",
         CUS_IC.ASSET_OTHER_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Asset Other Amount",
         CUS_IC.TOTAL_DEPENDENTS_CNT length = 8
                                     label = "Total Dependents Count",
         CUS_IC.YOUNGEST_CHILD_BIRTH_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Youngest Child Birth Date",
         CUS_IC.BILL_PAY_SERVICE_FLG length = 1
                                     label = "Bill Pay Service Flag",
         CUS_IC.INCOME_CATEGORY_CD length = 3
                                   label = "Income Category Code",
         CUS_IC.HHOLD_RK length = 8
                         format = 12.
                         informat = 12.
                         label = "Household Key",
         CUS_IC.CURRENT_ADDRESS_START_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Current Address Start Date",
         CUS_IC.RESIDENCE_STATUS_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Residence Status Date",
         COALESCE(CUS_IC.INTERNAL_CREDIT_RATING_CD,CUS_EOAD_L.INTERNAL_CREDIT_RATING_CD) as INTERNAL_CREDIT_RATING_CD length = 20,
         COALESCE(CUS_IC.EMPLOYMENT_BUSINESS_NATURE_CD,CUS_EOAD_L.BUSINESS_NATURE_CD) as BUSINESS_NATURE_CD length = 3,
         COALESCE(CUS_IC.INDUSTRY_CD, CUS_EOAD_L.INDUSTRY_CD) as INDUSTRY_CD length = 10
      from
         martscr.CUS_EOAD_L left join 
         martscr.CUS_IC
            on
            (
               CUS_IC.CUSTOMER_RK = CUS_EOAD_L.CUSTOMER_RK
               and CUS_IC.LOAD_END_DTTM = CUS_EOAD_L.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify CUS_IC_L;
         ic create not null (CUSTOMER_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QN * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.CUS_IC_L             A5V75JN3.BP0004TZ * 
 * Target Table:  CUS_IC_L - martscr.CUS_IC_L               A5V75JN3.BE0000PE * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043N * 
 *                                                                            * 
 * User Written:  Index Creation on CUSTOMER_RK and         A5V75JN3.AF000MZP * 
 *                 LOAD_END_DTTM                                              * 
 *                Index Creation on CUSTOMER_RK and LOAD_END_DTTM             * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on CUSTOMER_RK and LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX  CUSTOMER_RK_LOAD_END_DTTM
      ON martscr.CUS_IC_L(CUSTOMER_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

