/****************************************************************************** 
 * Job:           ControlPoolingABTJob                      A5V75JN3.BN0000RW * 
 * Description:                                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Generated on:  Saturday, December 27, 2008 3:41:48 PM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Parameter default value(s) for ControlPoolingABTJob  */ 
%let job_nm = ;
%let load_abt_user_input_dttm = &load_abt_user_input_dttm;
%let status_table = &status_table;
%let level_no = ;
%let master_level_no = ;
%let load_abt_user_input_date = &load_abt_user_input_date;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY00040B * 
 *                                                                            * 
 * User Written:  Predecessor process                       A5V75JN3.AF000MIP * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

data _null_;                            
var_jb=kcompress("&job_nm",'.sas');                            
logfile="Data/bisdata/log/schedule_pooling_abt/"||var_jb; 
call symput('job_logname',ktrim(logfile));                                     
run;                                                                          
filename joblog "&job_logname..log";                                          
%put NOTE: Redirecting log to &job_logname..log;                              
proc printto log=joblog;                                                  
run;                                                                          
%put &job_logname;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          User Written Code                         A5V75JN3.BO0005MG * 
 * Transform:     User Written Code                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Target Table:  User Written Code Target - work.W5AREK3F  A5V75JN3.BP0004RI * 
 *                                                                            * 
 * User Written:  CreateTable                               A5V75JN3.AF000MII * 
 *============================================================================*/ 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.W5AREK3F); 

/*---- Start of User Written Code  ----*/ 


%put 'level_no=' &level_no;
%put 'master_level_no=' &master_level_no; 

%if &level_no EQ &master_level_no %then 
%do;

/*%trylock(member=&status_table, timeout=100000);*/
/**/
/*proc sql;*/
/*select count(job_nm) into :job_count  */
/*from &status_table*/
/*where  job_nm = "&job_nm" and level_no = &level_no and */
/*return_cd = .;*/
/*quit;*/
/**/
/*lock  &status_table clear;*/
/**/
/*%if &job_count = 1 %then*/
%include jobs (&job_nm) /LRECL= 1024;
%end;


/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00040C * 
 *                                                                            * 
 * User Written:  Post process                              A5V75JN3.AF000MIQ * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc printto log=log;                                                     
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

