/****************************************************************************** 
 * Job:           DISBRS_APRVD_AMT                          A5V75JN3.BN0000TZ * 
 * Description:   This job pick up the data for FIN_APL_FU and APP_ACT_FA_L   * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FIN_APP_FU - martscr.FIN_APP_FU           A5V75JN3.BE0000TZ * 
 *                APP_ACT_FA_L - martscr.APP_ACT_FA_L       A5V75JN3.BE0000TR * 
 * Target Table:  DISBRS_APRVD_AMT -                        A5V75JN3.BE0000TX * 
 *                 martscr.DISBRS_APRVD_AMT                                   * 
 *                                                                            * 
 * Generated on:  Saturday, December 27, 2008 11:24:41 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = DISBRS_APRVD_AMT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Data with disburse amt. and approved amt  A5V75JN3.BO0005NG * 
 * Transform:     SQL Join                                                    * 
 * Description:   Data with disburse amt. and approved amt is obtain by       * 
 *                joining the table   APP_ACT_FA and FIN_APPL_FU on           * 
 *                 APPLICATION_RK                                             * 
 *                                                                            * 
 * Source Tables: FIN_APP_FU - martscr.FIN_APP_FU           A5V75JN3.BE0000TZ * 
 *                APP_ACT_FA_L - martscr.APP_ACT_FA_L       A5V75JN3.BE0000TR * 
 * Target Table:  SQL Join Target -                         A5V75JN3.BP0004S8 * 
 *                 martscr.DISBRS_APRVD_AMT                                   * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete DISBRS_APRVD_AMT;
quit;

proc sql;
   create table martscr.DISBRS_APRVD_AMT as
   select APP_ACT_FA_L.ACCOUNT_RK,
       APP_ACT_FA_L.APPROVED_AMT,
       APP_ACT_FA_L.ACTUAL_ADVANCE_AMT AS DISBURSED_AMT,
       APP_ACT_FA_L.FINANCIAL_APPLICATION_RK,
       FIN_APP_FU.INTERNAL_ORG_RK,
       FIN_APP_FU.CHANNEL_CD,
       FIN_APP_FU.PRODUCT_RK,
       FIN_APP_FU.APPLIED_AMT,
       FIN_APP_FU.APPROVE_CNT,
       FIN_APP_FU.APPLICATION_RK,
       FIN_APP_FU.FINANCIAL_UNIT_RK,
       FIN_APP_FU.APPLICANT_RK,
       FIN_APP_FU.REJECT_CNT,
       APP_ACT_FA_L.ACCOUNT_CNT
   from martscr.FIN_APP_FU 
       LEFT JOIN martscr.APP_ACT_FA_L
        ON (FIN_APP_FU.APPLICATION_RK = APP_ACT_FA_L.FINANCIAL_APPLICATION_RK) ;
quit;

%rcset(&sqlrc);

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005NH * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target -                         A5V75JN3.BP0004S8 * 
 *                 martscr.DISBRS_APRVD_AMT                                   * 
 * Target Table:  DISBRS_APRVD_AMT -                        A5V75JN3.BE0000TX * 
 *                 martscr.DISBRS_APRVD_AMT                                   * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00041F * 
 *                                                                            * 
 * User Written:  Creating index on                         A5V75JN3.AF000MMH * 
 *                 FINANCIAL_APPLICATION_RK column.                           * 
 *                Creating index on FINANCIAL_APPLICATION_RK column.          * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*Creating index on FINANCIAL_APPLICATION_RK column */
PROC SQL NOPRINT;
  CREATE INDEX FINANCIAL_APPLICATION_RK
   ON martscr.DISBRS_APRVD_AMT(FINANCIAL_APPLICATION_RK);

QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

