/****************************************************************************** 
 * Job:           EO_EXT                                    A5V75JN3.BN00001F * 
 * Description:   This job picks up data from EXTERNAL_ORG                    * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                EXTERNAL_ORG - DDS.EXTERNAL_ORG           A5V75JN3.BE00002I * 
 * Target Table:  EO_EXT - martscr.EO_EXT                   A5V75JN3.BE0000JD * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:04:38 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * EO_EXT                                                                     * 
 * Job Name: EO_EXTJob Desc Pre Process: NoneMain:Extract and load data from  * 
 * EXTERNAL_ORG using a SQL join with table LOAD_CONTROL based on             * 
 * conditionLOAD_CONTROL.LOAD_FLG = CHECK_FLAG_TRUE                           * 
 * andLOAD_CONTROL.RUN_STATUS = RUNNING_STATUS                                * 
 * andLOAD_CONTROL.LOAD_END_DTTM betweenVALID_FROM_DTTM and                   * 
 * VALID_TO_DTTMPost Process: Index is created                                * 
 * onEXTERNAL_ORG_RK,LOAD_END_DTTMParameters: CHECK_FLAG_TRUE and             * 
 * RUNNING_STATUS are the user defined parameters. CHECK_FLAG_TRUE is set     * 
 * to 'Y' and RUNNING_STATUS is to 'Running' for each month of data           * 
 *  load.Developed by: sinahkReviewed by:Tested by:                           * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = EO_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004O2 * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PQ7 * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=dds.external_org out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Extracting and Loading of data as per the A5V75JN3.BO0006Z2 * 
 *                 load period                                                * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Join with LOAD_CONTROL table and extract appropriate data   * 
 *                 based  onVALID_FROM_DTTM and VALID_TO_DTTM                 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                EXTERNAL_ORG - DDS.EXTERNAL_ORG           A5V75JN3.BE00002I * 
 * Target Table:  SQL Target - martscr.EO_EXT               A5V75JN3.BP00066R * 
 *============================================================================*/ 

/* Access the data for Control  */ 
LIBNAME control BASE "Data/bisdata/control" ;
%rcSet(&syslibrc); 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete EO_EXT;
quit;

proc sql;
   create table martscr.EO_EXT as
      select
         LOAD_CONTROL.LOAD_END_DTTM length = 8
                                    format = NLDATM21.
                                    informat = NLDATM21.
                                    label = "Load End Datetime",
         EXTERNAL_ORG.EXTERNAL_ORG_RK length = 8
                                      format = 12.
                                      informat = 12.
                                      label = "External Organization",
         EXTERNAL_ORG.EXTERNAL_ORG_ID length = 32
                                      label = "External Organization",
         EXTERNAL_ORG.SOURCE_SYSTEM_CD length = 3
                                       label = "Source System Code",
         EXTERNAL_ORG.ORGANIZATION_NM length = 40
                                      label = "Organization Code",
         EXTERNAL_ORG.ORGANIZATION_LEGAL_NM length = 40
                                            label = "Organization Legal Name",
         EXTERNAL_ORG.DOING_BUSINESS_AS_NM length = 40
                                           label = "Doing Busines As Name",
         EXTERNAL_ORG.ORGANIZATION_DESC length = 100
                                        label = "Organization Description",
         EXTERNAL_ORG.ORGANIZATION_TYPE_CD length = 3
                                           label = "Organization Type Code",
         EXTERNAL_ORG.OWNERSHIP_CD length = 3
                                   label = "Ownership Code",
         EXTERNAL_ORG.INDUSTRY_CD length = 10
                                  label = "Industry Code",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(EXTERNAL_ORG.BUSINESS_ESTABLISHED_DT)
         	ELSE EXTERNAL_ORG.BUSINESS_ESTABLISHED_DT
         END as BUSINESS_ESTABLISHED_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Business Established Date",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(EXTERNAL_ORG.BUSINESS_COMMENCED_DT)
         	ELSE EXTERNAL_ORG.BUSINESS_COMMENCED_DT
         END as BUSINESS_COMMENCED_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Business Commenced Date",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(EXTERNAL_ORG.INCORPORATION_DT)
         	ELSE EXTERNAL_ORG.INCORPORATION_DT
         END as INCORPORATION_DT length = 8
                                 format = NLDATE10.
                                 informat = NLDATE10.
                                 label = "Incorporation Date",
         EXTERNAL_ORG.CENTRAL_GOVERNMENT_TAX_ID length = 20
                                                label = "Central Government Tax ID",
         EXTERNAL_ORG.DUNS_NO length = 20
                              label = "DUNS Number",
         EXTERNAL_ORG.EXCHANGE_SYMBOL_CD length = 10
                                         label = "Exchange Symbol Code",
         EXTERNAL_ORG.FISCAL_CALENDAR_START_DAY_MTH length = 8
                                                    label = "Fiscal Calendar Start",
         EXTERNAL_ORG.NUM_OFFICES_CNT length = 8
                                      label = "Number of Offices",
         EXTERNAL_ORG.NUM_EMPLOYEES_CNT length = 8
                                        label = "Number of Employees",
         EXTERNAL_ORG.MARKETABLE_SECURITIES_AMT length = 8
                                                format = NLNUM18.5
                                                informat = NLNUM18.5
                                                label = "Marketable Securities Amount",
         EXTERNAL_ORG.MAIN_TELEPHONE_NO length = 20
                                        label = "Main Telephone Number",
         EXTERNAL_ORG.MAIN_FAX_NO length = 20
                                  label = "Main Fax Number",
         EXTERNAL_ORG.ACCOUNT_ROLE_ID length = 32
                                      label = "Account Role Id",
         EXTERNAL_ORG.TAX_ID length = 32
                             label = "Tax Id",
         EXTERNAL_ORG.TAX_ID_TYPE_CD length = 3
                                     label = "Tax Id Type Code",
         EXTERNAL_ORG.OWNERSHIP_CNT length = 8
                                    label = "Ownership Count",
         EXTERNAL_ORG.LEGAL_JUDGEMENT_FLG length = 1
                                          label = "Legal Judgement Flag",
         EXTERNAL_ORG.PENDING_LAWSUIT_FLG length = 1
                                          label = "Pending Lawsuit Flag",
         EXTERNAL_ORG.LEGAL_ENTITY_TYPE_CD length = 3
                                           label = "Legal Entity Type Code",
         EXTERNAL_ORG.INDV_ORG_TAX_ID_FLG length = 1
                                          label = "Individual Organization Tax ID Flag"
      from
         control.LOAD_CONTROL, 
         DDS.EXTERNAL_ORG
      where
         LOAD_CONTROL.LOAD_FLG IN (&CHECK_FLAG_TRUE)
         and LOAD_CONTROL.RUN_STATUS IN (&RUNNING_STATUS)
         and LOAD_CONTROL.LOAD_END_DTTM >= EXTERNAL_ORG.VALID_FROM_DTTM
         and LOAD_CONTROL.LOAD_END_DTTM <= EXTERNAL_ORG.VALID_TO_DTTM
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify EO_EXT;
         ic create not null (EXTERNAL_ORG_ID);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006Z1 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.EO_EXT               A5V75JN3.BP00066R * 
 * Target Table:  EO_EXT - martscr.EO_EXT                   A5V75JN3.BE0000JD * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0004O3 * 
 *                                                                            * 
 * User Written:  Index creation code on                    A5V75JN3.AF000PQ8 * 
 *                 EXTERNAL_ORG_RK,LOAD_END_DTTM column                       * 
 *                Index creation code on EXTERNAL_ORG_RK,LOAD_END_DTTM        * 
 *                 column                                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on EXTERNAL_ORG_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
           CREATE INDEX EXTERNAL_ORG_RK_LOAD_END_DTTM
            ON martscr.EO_EXT(EXTERNAL_ORG_RK,LOAD_END_DTTM);

QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

