/****************************************************************************** 
 * Job:           EP_ALL_LVLS                               A5V75JN3.BN00006U * 
 * Description:   This job loads the target table with data for all levels    * 
 *                 of SUPERVISOR name.                                        * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  EOA_EXT - martscr.EOA_EXT                 A5V75JN3.BE0000JE * 
 * Target Table:  EP_ALL_LVLS - martscr.EP_ALL_LVLS         A5V75JN3.BE0000PH * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:06:12 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * EP_ALL_LVLS                                                                * 
 * Job Name: EP_ALL_LVLSJob Desc:Pre Process: NoneMain:a)This job loads the   * 
 * target table wth data for all levels of SUPERVISOR_LEV_RKExtracting data   * 
 * for all levels of SUPERVISOR_LEV_RKb) EMPLOYEE_RK is assigned as           * 
 * EMPLOYEE_RK.And PARENT_EMPLOYEE_RK is SUPERVISOR_LEV1_RKb)                 * 
 * SUPERVISOR_LEV1_RK is assigned as SUPERVISOR_LEV1_RKand                    * 
 * SUPERVISOR_LEV2_RK is obtain by applying format EMP_NM                     * 
 * onSUPERVISOR_LEV1_RKc) SUPERVISOR_LEV2_RK is assigned as                   * 
 * SUPERVISOR_LEV2_RKand SUPERVISOR_LEV3_RK is obtain by applying format      * 
 * EMP_NM onthe SUPERVISOR_LEV2_RKd) SUPERVISOR_LEV3_RK is assigned as        * 
 * SUPERVISOR_LEV3_RKand SUPERVISOR_LEV4_RK is obtain by applying format      * 
 * EMP_NM onthe SUPERVISOR_LEV3_RKe) EMPLOYEE_RK is assigned as               * 
 * SUPERVISOR_LEV4_RKand all supervisor level Rk are mapped as same.Post      * 
 * Process: creating index on EMPLOYEE_RK and LOAD_END_DTTM                   * 
 * columnsParameters:a)DIR_EMP_ASSOC_TYPE :This parameter defines             * 
 * Association type code of employees for direct reporting                    * 
 *  purpose.Developed by: sinahkReviewed by:Tested by:                        * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00006U);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = EP_ALL_LVLS;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Populating the supervisor RK values       A5V75JN3.BO0005QQ * 
 * Transform:     User Written Code                                           * 
 * Description:   Populating the supervisor RK values                         * 
 *                                                                            * 
 * Source Table:  EOA_EXT - martscr.EOA_EXT                 A5V75JN3.BE0000JE * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP0004U0 * 
 *                 martscr.EP_ALL_LVLS                                        * 
 *                                                                            * 
 * User Written:  Flatten the employee hierarchy            A5V75JN3.AF000MZQ * 
 *                Flatten the employee hierarchy                              * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.EOA_EXT); 

%let transformID = %quote(A5V75JN3.BO0005QQ); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.EP_ALL_LVLS); 

/*---- Start of User Written Code  ----*/ 

/* Start of CS4.3 HF2 */ 
/* This code has been modified as a part of CS4.3 HF2. 
The code modification is done for to take care of loading Employee dimension
even if the Employee association records i.e. the Employee hierarchy 
records are not present. */

options symbolgen mlogic mprint;

%macro create_hier;
		proc sort data=martscr.Ep_ext out=martscr.Ep_ext1(drop=EMPLOYEE_ID
										SOURCE_SYSTEM_CD
										EMPLOYEE_CITY_NM
										EMPLOYEE_STATE_REGION_CD
										EMPLOYEE_COUNTRY_CD
										EMPLOYEE_POSTAL_CD );
		 by EMPLOYEE_RK LOAD_END_DTTM;
		run;
		
		data martscr.Ep_ext1;
		   set martscr.Ep_ext1;
		   by EMPLOYEE_RK LOAD_END_DTTM;
		   retain N 1;
		   if first.EMPLOYEE_RK=1 then N=1;
		   else N+1;
		run;
		data martscr.EP_ALL_LVLS(rename=(dt=LOAD_END_DTTM node_1=employee_rk 
													SUPERVISOR_LEV5_NM=SUPERVISOR_LEV4_NM 
													SUPERVISOR_LEV4_NM=SUPERVISOR_LEV3_NM
													SUPERVISOR_LEV3_NM=SUPERVISOR_LEV2_NM
													SUPERVISOR_LEV2_NM=SUPERVISOR_LEV1_NM));
		   if 0 then set martscr.Ep_ext1;
		
		   if _N_=1 then do;
		      declare hash h(dataset:'martscr.Ep_ext1',hashexp:16);
			  h.defineKey('EMPLOYEE_RK','N');
			  h.definedata('EMPLOYEE_NM','LOAD_END_DTTM');
			  h.definedone();
			  call missing(EMPLOYEE_RK,EMPLOYEE_NM,N,LOAD_END_DTTM);
			end;
		
			set node_1;
		
			%do i=1 %to 5;
				 do N=1  to 1000;
		
						 EMPLOYEE_RK=node_%eval(&i);
			
		 		   rc=h.find();
				    if rc=0  then  
					do;
				       if LOAD_END_DTTM=dt  then  
					   do;
				  		     SUPERVISOR_LEV%eval(&i)_NM=EMPLOYEE_NM; 
					   end;
				    end;
				   else  if rc ne 0  then
				   leave;
				end;
			 %end;
		 		
		/**/
			drop 
		   	N 
		EMPLOYEE_NM
		EMPLOYEE_RK
		node_2 
		node_3 
		node_4 
		node_5
		SUPERVISOR_LEV1_NM
		   	rc  
		LOAD_END_DTTM
			;
		run;
		 
		data martscr.Ep_ext1; 
		set martscr.Ep_ext1;
			drop n;
		run;
%mend;

/* Call the macro flatten to flatten the hierarchy */
data martscr.eoa_ext1;
set martscr.eoa_ext;
run;

%macro check_create;
/* This macro checks the records in EOA_EXT1 i.e. the Employee Hierarchy
records. If there are no records in this table, the macro creates only the structure.
Else it calls the flatten macro and creates the table and populates the hierarchy data */

		proc sql;
		select count(*) into :rec_cnt from martscr.eoa_ext1;
		quit;
		
		%if &rec_cnt > 0 %then
		%do;
			%flatten(library_nm=martscr,table_nm=eoa_ext1,
			Parent_col_nm=PARENT_EMPLOYEE_RK,child_col_nm=EMPLOYEE_RK,
			filter=EMPLOYEE_ASSOC_TYPE_CD IN (&DIR_EMP_ASSOC_TYPE),
			additional_col=)
			 ;
		
			%create_hier; 
		
		%end;
		%else
		%do;
			proc sql;
				create table MARTSCR.EP_ALL_LVLS
				  (
				   EMPLOYEE_RK num,
				   LOAD_END_DTTM num format=NLDATM21. informat=NLDATM21. label='Load End Datetime',
				   SUPERVISOR_LEV1_NM char(200),
				   SUPERVISOR_LEV2_NM char(200),
				   SUPERVISOR_LEV3_NM char(200),
				   SUPERVISOR_LEV4_NM char(200)
				  );
			quit;
		%end;
%mend;

%check_create;

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy  Loader                             A5V75JN3.BO0005QP * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP0004U0 * 
 *                 martscr.EP_ALL_LVLS                                        * 
 * Target Table:  EP_ALL_LVLS - martscr.EP_ALL_LVLS         A5V75JN3.BE0000PH * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043P * 
 *                                                                            * 
 * User Written:  creating index on EMPLOYEE_RK,            A5V75JN3.AF000MZS * 
 *                 LOAD_END_DTTM columns                                      * 
 *                creating index on EMPLOYEE_RK, LOAD_END_DTTM columns        * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating indexes on EMPLOYEE_RK & LOAD_END_DTTM column */

PROC SQL NOPRINT;
           CREATE INDEX EMPLOYEE_RK_LOAD_END_DTTM
           ON martscr.EP_ALL_LVLS(EMPLOYEE_RK,LOAD_END_DTTM);          
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

