/****************************************************************************** 
 * Job:           FA_APPT_FOR_DIM_EXT                       A5V75JN3.BN00001L * 
 * Description:   This job picks up data from FINANCIAL_ACCOUNT_APPLICANT     * 
 *                based on the PROCESSED_DTTM. This job is not to be          * 
 *                 considered as other extract jobs.                          * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                FINANCIAL_ACCOUNT_APPLICANT -             A5V75JN3.BE00002Q * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICANT                            * 
 * Target Table:  FA_APPT_FOR_DIM_EXT -                     A5V75JN3.BE0000JJ * 
 *                 martscr.FA_APPT_FOR_DIM_EXT                                * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:12:07 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FA_APPT_FOR_DIM_EXT                                                        * 
 * Job Name: FA_APPT_FOR_DIM_EXTJob Desc Pre Process: NoneMain:Extract and    * 
 * load data from FINANCIAL_ACCOUNT_APPLICANT using a SQL join with table     * 
 * LOAD_CONTROL based on conditionLOAD_CONTROL.LOAD_FLG = CHECK_FLAG_TRUE     * 
 * andLOAD_CONTROL.RUN_STATUS = RUNNING_STATUS andPROCESSED_DTTM >=           * 
 * LOAD_CONTROL.LOAD_START_DTTM andPROCESSED_DTTM <=                          * 
 * LOAD_CONTROL.LOAD_END_DTTMPost Process: Index is created                   * 
 * onFINANCIAL_APPLICATION_RK,LOAD_END_DTTMParameters: CHECK_FLAG_TRUE and    * 
 * RUNNING_STATUS are the user defined parameters. CHECK_FLAG_TRUE is set     * 
 * to 'Y' and RUNNING_STATUS is to 'Running' for each month of data           * 
 *  load.Developed by: sinahkReviewed by:Tested by:                           * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00001L);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FA_APPT_FOR_DIM_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004O8 * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PRY * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=dds.FINANCIAL_ACCOUNT_APPLICANT out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Extracting and Loading of data as per the A5V75JN3.BO0006Z8 * 
 *                 load period                                                * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Join with LOAD_CONTROL table and extract appropriate data   * 
 *                 based  onLOAD_START_DTTM and LOAD_END_DTTM                 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                FINANCIAL_ACCOUNT_APPLICANT -             A5V75JN3.BE00002Q * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICANT                            * 
 * Target Table:  SQL Target - martscr.FA_APPT_FOR_DIM_EXT  A5V75JN3.BP00066U * 
 *============================================================================*/ 

/* Access the data for Control  */ 
LIBNAME control BASE "Data/bisdata/control" ;
%rcSet(&syslibrc); 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0006Z8); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FA_APPT_FOR_DIM_EXT;
quit;

proc sql;
   create table martscr.FA_APPT_FOR_DIM_EXT as
      select
         LOAD_CONTROL.LOAD_END_DTTM length = 8
                                    format = NLDATM21.
                                    informat = NLDATM21.
                                    label = "Load End Datetime",
         FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_RK length = 8
                                                  format = 12.
                                                  informat = 12.
                                                  label = "Applicant Key",
         FINANCIAL_ACCOUNT_APPLICANT.FINANCIAL_APPLICATION_RK length = 8
                                                              format = 12.
                                                              informat = 12.
                                                              label = "Financial Application Key",
         FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_ID length = 32
                                                  label = "Applicant Id",
         FINANCIAL_ACCOUNT_APPLICANT.CUSTOMER_RK length = 8
                                                 format = 12.
                                                 informat = 12.
                                                 label = "Customer Key",
         FINANCIAL_ACCOUNT_APPLICANT.RELATIONSHIP_CD length = 3
                                                     label = "Relationship Code",
         FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_TYPE_CD length = 3
                                                       label = "Applicant Type Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.BIRTH_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.BIRTH_DT 
         END as APPLICANT_BIRTH_DT length = 8
                                   format = NLDATE10.
                                   informat = NLDATE10.
                                   label = "Birth Date",
         CATX(' ',FINANCIAL_ACCOUNT_APPLICANT.FIRST_NM, FINANCIAL_ACCOUNT_APPLICANT.LAST_NM ) as APPLICANT_NM length = 100,
         FINANCIAL_ACCOUNT_APPLICANT.GENDER_CD length = 3
                                               label = "Gender Code",
         FINANCIAL_ACCOUNT_APPLICANT.MARITAL_STATUS_CD length = 3
                                                       label = "Marital Status Code",
         FINANCIAL_ACCOUNT_APPLICANT.STD_OCCUPATION_CD length = 3
                                                       label = "Standard Occupation Code",
         FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_STATUS_CD length = 3
                                                          label = "Employment Status Code",
         FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_YEARS_CNT length = 8
                                                          format = NLNUM6.2
                                                          informat = NLNUM6.2
                                                          label = "No of Employment Years",
         FINANCIAL_ACCOUNT_APPLICANT.TOTAL_EMPLOYMENT_YEARS_CNT length = 8
                                                                format = NLNUM6.2
                                                                informat = NLNUM6.2
                                                                label = "Total No of Employment Years",
         FINANCIAL_ACCOUNT_APPLICANT.EDUCATION_LEVEL_CD length = 10
                                                        label = "Education Level Code",
         FINANCIAL_ACCOUNT_APPLICANT.RESIDENT_STATUS_CD as RESIDENCE_STATUS_CD length = 3
                                                                               label = "Resident Status Code",
         FINANCIAL_ACCOUNT_APPLICANT.TIME_RESIDENCE_YEAR_CNT length = 8
                                                             format = NLNUM6.2
                                                             informat = NLNUM6.2
                                                             label = "No of Years at Residence",
         FINANCIAL_ACCOUNT_APPLICANT.DEPENDENTS_CNT length = 8
                                                    label = "No of Dependents",
         FINANCIAL_ACCOUNT_APPLICANT.PENDING_LAWSUIT_FLG length = 1
                                                         label = "Pending Lawsuit Flag",
         FINANCIAL_ACCOUNT_APPLICANT.ANNUAL_INCOME_AMT length = 8
                                                       format = NLNUM18.5
                                                       informat = NLNUM18.5
                                                       label = "Annual Income Amount",
         FINANCIAL_ACCOUNT_APPLICANT.HHOLD_INCOME_AMT length = 8
                                                      format = NLNUM18.5
                                                      informat = NLNUM18.5
                                                      label = "Household Income Amount",
         FINANCIAL_ACCOUNT_APPLICANT.MONTHLY_HOUSING_AMT length = 8
                                                         format = NLNUM18.5
                                                         informat = NLNUM18.5
                                                         label = "Monthly Rent Amount",
         FINANCIAL_ACCOUNT_APPLICANT.TOTAL_ASSET_AMT length = 8
                                                     format = NLNUM18.5
                                                     informat = NLNUM18.5
                                                     label = "Total Asset Amount",
         FINANCIAL_ACCOUNT_APPLICANT.LIQUID_ASSETS_AMT length = 8
                                                       format = NLNUM18.5
                                                       informat = NLNUM18.5
                                                       label = "Liquid Assets Amount",
         FINANCIAL_ACCOUNT_APPLICANT.ASSET_OTHER_AMT length = 8
                                                     format = NLNUM18.5
                                                     informat = NLNUM18.5
                                                     label = "Asset Other Amount",
         FINANCIAL_ACCOUNT_APPLICANT.REAL_ESTATE_AMT length = 8
                                                     format = NLNUM18.5
                                                     informat = NLNUM18.5
                                                     label = "Real Estate Amount",
         FINANCIAL_ACCOUNT_APPLICANT.TOTAL_LIABILITY_AMT length = 8
                                                         format = NLNUM18.5
                                                         informat = NLNUM18.5
                                                         label = "Total Liability Amount",
         FINANCIAL_ACCOUNT_APPLICANT.LIABILITY_REAL_ESTATE_AMT length = 8
                                                               format = NLNUM18.5
                                                               informat = NLNUM18.5
                                                               label = "Liability Real Estate Amount",
         FINANCIAL_ACCOUNT_APPLICANT.LIABILITY_OTHER_AMT length = 8
                                                         format = NLNUM18.5
                                                         informat = NLNUM18.5
                                                         label = "Liability Other Amount",
         FINANCIAL_ACCOUNT_APPLICANT.NET_WORTH_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "Net Worth Amount",
         FINANCIAL_ACCOUNT_APPLICANT.TAX_ID length = 32
                                            label = "Tax Id",
         FINANCIAL_ACCOUNT_APPLICANT.TAX_ID_TYPE_CD length = 3
                                                    label = "Tax Id Type Code",
         FINANCIAL_ACCOUNT_APPLICANT.TAX_BRACKET_CD length = 3
                                                    label = "Tax Bracket Code",
         FINANCIAL_ACCOUNT_APPLICANT.LEGAL_JUDGEMENT_FLG length = 1
                                                         label = "Legal Judgement Flag",
         FINANCIAL_ACCOUNT_APPLICANT.MAINTENANCE_FLG length = 1
                                                     label = "Maintenance Flag",
         FINANCIAL_ACCOUNT_APPLICANT.BANKRUPTCY_STATUS_CD length = 3
                                                          label = "Bankruptcy Status Code",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.BANKRUPTCY_FILED_DT)
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.BANKRUPTCY_FILED_DT
         END as BANKRUPTCY_FILED_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Bankruptcy Filed Date",
         FINANCIAL_ACCOUNT_APPLICANT.OWNERSHIP_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "Ownership Amount",
         FINANCIAL_ACCOUNT_APPLICANT.PERCENT_OWNED length = 8
                                                   format = NLNUM6.2
                                                   informat = NLNUM6.2
                                                   label = "Percent Owned",
         FINANCIAL_ACCOUNT_APPLICANT.ANNUAL_SALARY_BUSINESS_AMT length = 8
                                                                format = NLNUM18.5
                                                                informat = NLNUM18.5
                                                                label = "Annual Salary Business Amount",
         FINANCIAL_ACCOUNT_APPLICANT.OTHER_CREDIT_CARDS_CNT length = 8
                                                            label = "Other Credit Cards Count",
         FINANCIAL_ACCOUNT_APPLICANT.STATE_REGION_CD as APPLICANT_STATE_REGION_CD length = 4
                                                                                  label = "State/Region Code",
         FINANCIAL_ACCOUNT_APPLICANT.POSTAL_CD as APPLICANT_POSTAL_CD length = 20
                                                                      label = "Postal Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.LAST_APPLICATION_REFUSED_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.LAST_APPLICATION_REFUSED_DT 
         END as LAST_APPLICATION_REFUSED_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "Last Application Refused Date",
         FINANCIAL_ACCOUNT_APPLICANT.MONTHS_AT_PREVIOUS_ADDRESS_CNT length = 8
                                                                    label = "Months At Previous Address",
         FINANCIAL_ACCOUNT_APPLICANT.NO_OF_EMPLOYERS_CNT length = 8
                                                         label = "No Of Employers Count",
         FINANCIAL_ACCOUNT_APPLICANT.LIQUID_NET_WORTH_AMT length = 8
                                                          format = NLNUM18.5
                                                          informat = NLNUM18.5
                                                          label = "Liquid Net Worth Amount",
         FINANCIAL_ACCOUNT_APPLICANT.INTERNAL_CREDIT_RATING_CD length = 20
                                                               label = "Credit Rating Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_START_DT 
         END as CURRENT_EMP_START_DT length = 8
                                     format = NLDATE10.
                                     informat = NLDATE10.
                                     label = "Current Employment Start Date",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_ADDRESS_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_ADDRESS_START_DT 
         END as CURRENT_ADDRESS_START_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Current Address Start Date",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_COUNTRY_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_COUNTRY_START_DT 
         END as CURRENT_COUNTRY_START_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Current Country Start Date",
         FINANCIAL_ACCOUNT_APPLICANT.PASSPORT_ISSUE_COUNTRY_CD length = 3
                                                               label = "Country Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_START_DT 
         END as EMPLOYMENT_START_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Employment Start Date",
         COALESCE(FINANCIAL_ACCOUNT_APPLICANT.EMPLOYER_INDUSTRY_CD,FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_INDUSTRY_CD ) as INDUSTRY_CD length = 10,
         FINANCIAL_ACCOUNT_APPLICANT.CHILDREN_CNT length = 8
                                                  label = "Total number of children.",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.ELDEST_CHILD_BIRTH_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.ELDEST_CHILD_BIRTH_DT 
         END as ELDEST_CHILD_BIRTH_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Birth date of the eldest child.",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.YOUNGEST_CHILD_BIRTH_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.YOUNGEST_CHILD_BIRTH_DT 
         END as YOUNGEST_CHILD_BIRTH_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Birth date of the youngest child.",
         FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_POSITION_STATUS_CD length = 3
                                                                   format = $3.
                                                                   informat = $3.
                                                                   label = "This is the code to indicate employment position status. For example: PER (permanent), TMP (temporary), CON (contractual), PRO (probation) etc.",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.TEMPORARY_EMPLOYMENT_END_DT ) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.TEMPORARY_EMPLOYMENT_END_DT 
         END as TEMPORARY_EMPLOYMENT_END_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "Date when the temporary employment terminates",
         FINANCIAL_ACCOUNT_APPLICANT.OWN_AUTOMOBILE_FLG length = 1
                                                        label = "Flag to indicate that applicant owns automobile/vehicle",
         FINANCIAL_ACCOUNT_APPLICANT.OWN_MOTORCYCLE_FLG length = 1
                                                        label = "Flag to indicate that applicant owns motorcycle",
         FINANCIAL_ACCOUNT_APPLICANT.OWN_RESIDENCE_PROPERTY_FLG length = 1
                                                                label = "Flag to indicate owns residence property",
         FINANCIAL_ACCOUNT_APPLICANT.MONTHLY_PRI_INCOME_SOURCE_CD length = 3
                                                                  format = $3.
                                                                  informat = $3.
                                                                  label = "This is the code to indicate the source of primary income. For example: income from rent, salary, dividend, business income",
         FINANCIAL_ACCOUNT_APPLICANT.CITY_NM as APPLICANT_CITY_NM length = 100
                                                                  format = $100.
                                                                  informat = $100.
                                                                  label = "City of residence of the applicant.",
         FINANCIAL_ACCOUNT_APPLICANT.COUNTRY_CD as APPLICANT_COUNTRY_CD length = 3
                                                                        format = $3.
                                                                        informat = $3.
                                                                        label = "This is the code to indicate the country of residence of the applicant.",
         FINANCIAL_ACCOUNT_APPLICANT.PRIMARY_CITIZENSHIP_COUNTRY_CD length = 3
                                                                    format = $3.
                                                                    informat = $3.
                                                                    label = "This is the code to indicate the primary citizenship country of the applicant.",
         FINANCIAL_ACCOUNT_APPLICANT.FAMILY_MEMBER_ACCOUNT_CNT length = 8
                                                               label = "Total number of family members having account with this bank.",
         FINANCIAL_ACCOUNT_APPLICANT.HHOLD_INDIVIDUALS_CNT length = 8
                                                           label = "Number of individuals in the household.",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_TYPE_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_TYPE_START_DT 
         END as CURRENT_EMP_TYPE_START_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Date of commencement of the current employment type.",
         FINANCIAL_ACCOUNT_APPLICANT.BUSINESS_NATURE_CD length = 3
                                                        format = $3.
                                                        informat = $3.
                                                        label = "Code to indicate nature of business. For example: DIS (distribution), TRD (trading), MFG (manufacturing) , ITC (IT Consulting) etc."
      from
         control.LOAD_CONTROL, 
         DDS.FINANCIAL_ACCOUNT_APPLICANT
      where
         LOAD_CONTROL.LOAD_FLG IN (&CHECK_FLAG_TRUE)
         and LOAD_CONTROL.RUN_STATUS IN (&RUNNING_STATUS)
         and FINANCIAL_ACCOUNT_APPLICANT.PROCESSED_DTTM >= LOAD_CONTROL.LOAD_START_DTTM
         and FINANCIAL_ACCOUNT_APPLICANT.PROCESSED_DTTM <= LOAD_CONTROL.LOAD_END_DTTM
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006Z7 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.FA_APPT_FOR_DIM_EXT  A5V75JN3.BP00066U * 
 * Target Table:  FA_APPT_FOR_DIM_EXT -                     A5V75JN3.BE0000JJ * 
 *                 martscr.FA_APPT_FOR_DIM_EXT                                * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0004O9 * 
 *                                                                            * 
 * User Written:  Index creation on                         A5V75JN3.AF000PRZ * 
 *                 FINANCIAL_APPLICATION_RK & LOAD_END_DTTM                   * 
 *                Index creation on FINANCIAL_APPLICATION_RK & LOAD_END_DTTM  * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on FINANCIAL_APPLICATION_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX FINANCIAL_APPLICATION_RK_LOAD
      ON martscr.FA_APPT_FOR_DIM_EXT(FINANCIAL_APPLICATION_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

