/****************************************************************************** 
 * Job:           FA_APP_APPT                               A5V75JN3.BN00003B * 
 * Description:   This job picks up data from FA_APP_EXT and                  * 
 *                 FINANCIAL_ACCOUNT_APPLICANT                                * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FINANCIAL_ACCOUNT_APPLICANT -             A5V75JN3.BE00002Q * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICANT                            * 
 *                FA_APP_EXT - martscr.FA_APP_EXT           A5V75JN3.BE0000LA * 
 * Target Table:  FA_APP_APPT - martscr.FA_APP_APPT         A5V75JN3.BE0000L9 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:11:00 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FA_APP_APPT                                                                * 
 * Job Name: FA_APP_APPTJob Desc Pre Process: NoneMain: a) Applicant          * 
 * information obtained by joining FA_APP_EXT and                             * 
 * FINANCIAL_ACCOUNT_APPLICANT on APPLICATION_RKPost Process: a) Creating     * 
 * simple index onCUSTOMER_RK and LOAD_END_DTTM.Parameters: NoneDeveloped     * 
 *  by: sinahkReviewed by:Tested by:                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00003B);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FA_APP_APPT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004OY * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PZD * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=dds.financial_account_applicant out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Applicant information                     A5V75JN3.BO0006ZY * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Applicant information obtained by joining FA_APP_EXT and    * 
 *                 FINANCIAL_ACCOUNT_APPLICANT on APPLICATION_RK              * 
 *                                                                            * 
 * Source Tables: FINANCIAL_ACCOUNT_APPLICANT -             A5V75JN3.BE00002Q * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICANT                            * 
 *                FA_APP_EXT - martscr.FA_APP_EXT           A5V75JN3.BE0000LA * 
 * Target Table:  SQL Target - martscr.FA_APP_APPT          A5V75JN3.BP000677 * 
 *============================================================================*/ 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0006ZY); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FA_APP_APPT;
quit;

proc sql;
   create table martscr.FA_APP_APPT as
      select
         FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_RK length = 8
                                                  format = 12.
                                                  informat = 12.
                                                  label = "Applicant Key",
         FINANCIAL_ACCOUNT_APPLICANT.FINANCIAL_APPLICATION_RK as APPLICATION_RK length = 8
                                                                                format = 12.
                                                                                informat = 12.
                                                                                label = "Financial Application Key",
         FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_ID length = 32
                                                  label = "Applicant Id",
         FINANCIAL_ACCOUNT_APPLICANT.CUSTOMER_RK length = 8
                                                 format = 12.
                                                 informat = 12.
                                                 label = "Customer Key",
         FINANCIAL_ACCOUNT_APPLICANT.RELATIONSHIP_CD length = 3
                                                     label = "Relationship Code",
         FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_TYPE_CD length = 3
                                                       label = "Applicant Type Code",
         CATX(' ',FINANCIAL_ACCOUNT_APPLICANT.FIRST_NM,        FINANCIAL_ACCOUNT_APPLICANT.LAST_NM ) as APPLICANT_NM length = 100
                                                                                                                     label = "Last Name",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.BIRTH_DT)
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.BIRTH_DT
         END as APPLICANT_BIRTH_DT length = 8
                                   format = NLDATE10.
                                   informat = NLDATE10.
                                   label = "Birth Date",
         FINANCIAL_ACCOUNT_APPLICANT.GENDER_CD length = 3
                                               label = "Gender Code",
         FINANCIAL_ACCOUNT_APPLICANT.MARITAL_STATUS_CD length = 3
                                                       label = "Marital Status Code",
         FINANCIAL_ACCOUNT_APPLICANT.STD_OCCUPATION_CD length = 3
                                                       label = "Standard Occupation Code",
         FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_STATUS_CD length = 3
                                                          label = "Employment Status Code",
         FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_YEARS_CNT length = 8
                                                          format = NLNUM6.2
                                                          informat = NLNUM6.2
                                                          label = "No of Employment Years",
         FINANCIAL_ACCOUNT_APPLICANT.TOTAL_EMPLOYMENT_YEARS_CNT length = 8
                                                                format = NLNUM6.2
                                                                informat = NLNUM6.2
                                                                label = "Total No of Employment Years",
         FINANCIAL_ACCOUNT_APPLICANT.EDUCATION_LEVEL_CD length = 10
                                                        label = "Education Level Code",
         FINANCIAL_ACCOUNT_APPLICANT.RESIDENT_STATUS_CD as RESIDENCE_STATUS_CD length = 3
                                                                               label = "Resident Status Code",
         FINANCIAL_ACCOUNT_APPLICANT.TIME_RESIDENCE_YEAR_CNT length = 8
                                                             format = NLNUM6.2
                                                             informat = NLNUM6.2
                                                             label = "No of Years at Residence",
         FINANCIAL_ACCOUNT_APPLICANT.DEPENDENTS_CNT length = 8
                                                    label = "No of Dependents",
         FINANCIAL_ACCOUNT_APPLICANT.PENDING_LAWSUIT_FLG length = 1
                                                         label = "Pending Lawsuit Flag",
         FINANCIAL_ACCOUNT_APPLICANT.ANNUAL_INCOME_AMT length = 8
                                                       format = NLNUM18.5
                                                       informat = NLNUM18.5
                                                       label = "Annual Income Amount",
         FINANCIAL_ACCOUNT_APPLICANT.HHOLD_INCOME_AMT length = 8
                                                      format = NLNUM18.5
                                                      informat = NLNUM18.5
                                                      label = "Household Income Amount",
         FINANCIAL_ACCOUNT_APPLICANT.MONTHLY_HOUSING_AMT length = 8
                                                         format = NLNUM18.5
                                                         informat = NLNUM18.5
                                                         label = "Monthly Rent Amount",
         FINANCIAL_ACCOUNT_APPLICANT.TOTAL_ASSET_AMT length = 8
                                                     format = NLNUM18.5
                                                     informat = NLNUM18.5
                                                     label = "Total Asset Amount",
         FINANCIAL_ACCOUNT_APPLICANT.LIQUID_ASSETS_AMT length = 8
                                                       format = NLNUM18.5
                                                       informat = NLNUM18.5
                                                       label = "Liquid Assets Amount",
         FINANCIAL_ACCOUNT_APPLICANT.ASSET_OTHER_AMT length = 8
                                                     format = NLNUM18.5
                                                     informat = NLNUM18.5
                                                     label = "Asset Other Amount",
         FINANCIAL_ACCOUNT_APPLICANT.REAL_ESTATE_AMT length = 8
                                                     format = NLNUM18.5
                                                     informat = NLNUM18.5
                                                     label = "Real Estate Amount",
         FINANCIAL_ACCOUNT_APPLICANT.TOTAL_LIABILITY_AMT length = 8
                                                         format = NLNUM18.5
                                                         informat = NLNUM18.5
                                                         label = "Total Liability Amount",
         FINANCIAL_ACCOUNT_APPLICANT.LIABILITY_REAL_ESTATE_AMT length = 8
                                                               format = NLNUM18.5
                                                               informat = NLNUM18.5
                                                               label = "Liability Real Estate Amount",
         FINANCIAL_ACCOUNT_APPLICANT.LIABILITY_OTHER_AMT length = 8
                                                         format = NLNUM18.5
                                                         informat = NLNUM18.5
                                                         label = "Liability Other Amount",
         FINANCIAL_ACCOUNT_APPLICANT.NET_WORTH_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "Net Worth Amount",
         FINANCIAL_ACCOUNT_APPLICANT.TAX_ID length = 32
                                            label = "Tax Id",
         FINANCIAL_ACCOUNT_APPLICANT.TAX_ID_TYPE_CD length = 3
                                                    label = "Tax Id Type Code",
         FINANCIAL_ACCOUNT_APPLICANT.TAX_BRACKET_CD length = 3
                                                    label = "Tax Bracket Code",
         FINANCIAL_ACCOUNT_APPLICANT.LEGAL_JUDGEMENT_FLG length = 1
                                                         label = "Legal Judgement Flag",
         FINANCIAL_ACCOUNT_APPLICANT.MAINTENANCE_FLG length = 1
                                                     label = "Maintenance Flag",
         FINANCIAL_ACCOUNT_APPLICANT.FORECLOSED_FLG length = 1
                                                    label = "Foreclosed Flag",
         FINANCIAL_ACCOUNT_APPLICANT.BANKRUPTCY_STATUS_CD length = 3
                                                          label = "Bankruptcy Status Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.BANKRUPTCY_FILED_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.BANKRUPTCY_FILED_DT 
         END as BANKRUPTCY_FILED_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Bankruptcy Filed Date",
         FINANCIAL_ACCOUNT_APPLICANT.OWNERSHIP_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "Ownership Amount",
         FINANCIAL_ACCOUNT_APPLICANT.PERCENT_OWNED length = 8
                                                   format = NLNUM6.2
                                                   informat = NLNUM6.2
                                                   label = "Percent Owned",
         FINANCIAL_ACCOUNT_APPLICANT.ANNUAL_SALARY_BUSINESS_AMT length = 8
                                                                format = NLNUM18.5
                                                                informat = NLNUM18.5
                                                                label = "Annual Salary Business Amount",
         FINANCIAL_ACCOUNT_APPLICANT.OTHER_CREDIT_CARDS_CNT length = 8
                                                            label = "Other Credit Cards Count",
         FINANCIAL_ACCOUNT_APPLICANT.STATE_REGION_CD as APPLICANT_STATE_REGION_CD length = 4
                                                                                  label = "State/Region Code",
         FINANCIAL_ACCOUNT_APPLICANT.POSTAL_CD as APPLICANT_POSTAL_CD length = 20
                                                                      label = "Postal Code",
         FINANCIAL_ACCOUNT_APPLICANT.NO_OF_EMPLOYERS_CNT length = 8
                                                         label = "No Of Employers Count",
         FINANCIAL_ACCOUNT_APPLICANT.LIQUID_NET_WORTH_AMT length = 8
                                                          format = NLNUM18.5
                                                          informat = NLNUM18.5
                                                          label = "Liquid Net Worth Amount",
         FINANCIAL_ACCOUNT_APPLICANT.BORROWED_DOWNPAYMENT_FLG length = 1
                                                              label = "Borrowed Downpayment Flag",
         FINANCIAL_ACCOUNT_APPLICANT.INTERNAL_CREDIT_RATING_CD length = 20
                                                               label = "Credit Rating Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_START_DT 
         END as CURRENT_EMP_START_DT length = 8
                                     format = NLDATE10.
                                     informat = NLDATE10.
                                     label = "Current Employment Start Date",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_ADDRESS_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_ADDRESS_START_DT 
         END as CURRENT_ADDRESS_START_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Current Address Start Date",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_COUNTRY_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_COUNTRY_START_DT 
         END as CURRENT_COUNTRY_START_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Current Country Start Date",
         FINANCIAL_ACCOUNT_APPLICANT.PASSPORT_ISSUE_COUNTRY_CD length = 3
                                                               label = "Country Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_START_DT 
         END as EMPLOYMENT_START_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Employment Start Date",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.LAST_APPLICATION_REFUSED_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.LAST_APPLICATION_REFUSED_DT 
         END as LAST_APPLICATION_REFUSED_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "Last Application Refused Date",
         FINANCIAL_ACCOUNT_APPLICANT.SOURCE_SYSTEM_CD length = 3
                                                      label = "Source System Code",
         FINANCIAL_ACCOUNT_APPLICANT.MONTHS_AT_PREVIOUS_ADDRESS_CNT length = 8
                                                                    label = "Months At Previous Address",
         FINANCIAL_ACCOUNT_APPLICANT.CHILDREN_CNT length = 8
                                                  label = "Total number of children.",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.ELDEST_CHILD_BIRTH_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.ELDEST_CHILD_BIRTH_DT 
         END as ELDEST_CHILD_BIRTH_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Birth date of the eldest child.",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.YOUNGEST_CHILD_BIRTH_DT)
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.YOUNGEST_CHILD_BIRTH_DT
         END as YOUNGEST_CHILD_BIRTH_DT length = 8
                                        format = NLDATE10.
                                        informat = NLDATE10.
                                        label = "Birth date of the youngest child.",
         FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_POSITION_STATUS_CD length = 3
                                                                   format = $3.
                                                                   informat = $3.
                                                                   label = "This is the code to indicate employment position status. For example: PER (permanent), TMP (temporary), CON (contractual), PRO (probation) etc.",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.TEMPORARY_EMPLOYMENT_END_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.TEMPORARY_EMPLOYMENT_END_DT 
         END as TEMPORARY_EMPLOYMENT_END_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "Date when the temporary employment terminates",
         FINANCIAL_ACCOUNT_APPLICANT.OWN_AUTOMOBILE_FLG length = 1
                                                        label = "Flag to indicate that applicant owns automobile/vehicle",
         FINANCIAL_ACCOUNT_APPLICANT.OWN_MOTORCYCLE_FLG length = 1
                                                        label = "Flag to indicate that applicant owns motorcycle",
         FINANCIAL_ACCOUNT_APPLICANT.OWN_RESIDENCE_PROPERTY_FLG length = 1
                                                                label = "Flag to indicate owns residence property",
         FINANCIAL_ACCOUNT_APPLICANT.MONTHLY_PRI_INCOME_SOURCE_CD length = 3
                                                                  format = $3.
                                                                  informat = $3.
                                                                  label = "This is the code to indicate the source of primary income. For example: income from rent, salary, dividend, business income",
         FINANCIAL_ACCOUNT_APPLICANT.CITY_NM as APPLICANT_CITY_NM length = 100
                                                                  format = $100.
                                                                  informat = $100.
                                                                  label = "City of residence of the applicant.",
         FINANCIAL_ACCOUNT_APPLICANT.COUNTRY_CD as APPLICANT_COUNTRY_CD length = 3
                                                                        format = $3.
                                                                        informat = $3.
                                                                        label = "This is the code to indicate the country of residence of the applicant.",
         FINANCIAL_ACCOUNT_APPLICANT.PRIMARY_CITIZENSHIP_COUNTRY_CD length = 3
                                                                    format = $3.
                                                                    informat = $3.
                                                                    label = "This is the code to indicate the primary citizenship country of the applicant.",
         FINANCIAL_ACCOUNT_APPLICANT.FAMILY_MEMBER_ACCOUNT_CNT length = 8
                                                               label = "Total number of family members having account with this bank.",
         FINANCIAL_ACCOUNT_APPLICANT.HHOLD_INDIVIDUALS_CNT length = 8
                                                           label = "Number of individuals in the household.",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_TYPE_START_DT) 
         	ELSE FINANCIAL_ACCOUNT_APPLICANT.CURRENT_EMP_TYPE_START_DT 
         END as CURRENT_EMP_TYPE_START_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Date of commencement of the current employment type.",
         FINANCIAL_ACCOUNT_APPLICANT.BUSINESS_NATURE_CD length = 3
                                                        format = $3.
                                                        informat = $3.
                                                        label = "Code to indicate nature of business. For example: DIS (distribution), TRD (trading), MFG (manufacturing) , ITC (IT Consulting) etc.",
         FA_APP_EXT.LOAD_END_DTTM length = 8
                                  format = NLDATM21.
                                  informat = NLDATM21.
                                  label = "Load End Datetime",
         FA_APP_EXT.FINANCIAL_APPLICATION_ID as APPLICATION_ID length = 32
                                                               label = "Financial Application Id",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FA_APP_EXT.APPLICATION_DT) 
         	ELSE FA_APP_EXT.APPLICATION_DT 
         END as APPLICATION_DT length = 8
                               format = NLDATE10.
                               informat = NLDATE10.
                               label = "Application Date",
         FA_APP_EXT.CUSTOMER_TYPE_CD length = 3
                                     label = "Customer Type Code",
         FA_APP_EXT.SOURCE_CD length = 5
                              label = "Source Code",
         FA_APP_EXT.APPLIED_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Applied Amount",
         FA_APP_EXT.COLLATERAL_AMT length = 8
                                   format = NLNUM18.5
                                   informat = NLNUM18.5
                                   label = "Collateral Amount",
         FA_APP_EXT.LOAN_TERM_MTHS_CNT length = 8
                                       label = "Loan Term in Months",
         FA_APP_EXT.COLLATERAL_CD length = 3
                                  label = "Collateral Code",
         FA_APP_EXT.BORROWED_DOWNPAYMENT_PCT length = 8
                                             format = NLNUM9.4
                                             informat = NLNUM9.4
                                             label = "Borrowed Downpayment Percent",
         FA_APP_EXT.PURPOSE_CD length = 3
                               label = "Purpose Code",
         FA_APP_EXT.OUTCOME_CD length = 3
                               label = "Outcome Code",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FA_APP_EXT.OUTCOME_DT) 
         	ELSE FA_APP_EXT.OUTCOME_DT 
         END as OUTCOME_DT length = 8
                           format = NLDATE10.
                           informat = NLDATE10.
                           label = "Outcome Date",
         FA_APP_EXT.DECISION_CD length = 3
                                label = "Decision Code",
         FA_APP_EXT.DECISION_OVERRIDE_FLG length = 1
                                          label = "Decision Override Flag",
         FA_APP_EXT.OVERRIDE_REASON_CD length = 3
                                       label = "Override Reason Code",
         FA_APP_EXT.PROCESSING_CHARGES_AMT length = 8
                                           format = NLNUM18.5
                                           informat = NLNUM18.5
                                           label = "Processing Charges Amount",
         FA_APP_EXT.PRIOR_MORTGAGE_CNT length = 8
                                       label = "Prior Mortgage Count",
         FA_APP_EXT.CLLTRL_MTHLY_INS_PREM_AMT length = 8
                                              format = NLNUM18.5
                                              informat = NLNUM18.5
                                              label = "Collateral Monthly Insurance Premium Amount",
         FA_APP_EXT.CLLTRL_ONE_TIME_INS_PREM_AMT length = 8
                                                 format = NLNUM18.5
                                                 informat = NLNUM18.5
                                                 label = "Collateral One Time Insurance Premium Amount",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FA_APP_EXT.CLLTRL_INS_START_DT) 
         	ELSE FA_APP_EXT.CLLTRL_INS_START_DT 
         END as CLLTRL_INS_START_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Collateral Insurance Start Date",
         CASE symget('mEngine') 
         	WHEN "ORACLE" THEN datepart(FA_APP_EXT.CLLTRL_INS_END_DT) 
         	ELSE FA_APP_EXT.CLLTRL_INS_END_DT 
         END as CLLTRL_INS_END_DT length = 8
                                  format = NLDATE10.
                                  informat = NLDATE10.
                                  label = "Collateranl Insurance End Date",
         FA_APP_EXT.CREDIT_CARD_CONSOLIDATION_AMT length = 8
                                                  format = NLNUM18.5
                                                  informat = NLNUM18.5
                                                  label = "Credit Card Consolidation Amount",
         FA_APP_EXT.CREDIT_CARD_CONSOLIDATION_CNT length = 8
                                                  label = "Credit Card Consolidation Count",
         FA_APP_EXT.LINKED_ACCOUNT_FLG length = 1
                                       label = "Linked Account Flag",
         FA_APP_EXT.LINKED_DEPOSIT_ACCOUNT_FLG length = 1
                                               label = "Linked Deposit Account Flag",
         FA_APP_EXT.LOAN_CONSOLIDATION_AMT length = 8
                                           format = NLNUM18.5
                                           informat = NLNUM18.5
                                           label = "Loan Consolidation Amount",
         FA_APP_EXT.LOAN_CONSOLIDATION_CNT length = 8
                                           label = "Loan Consolidation Count",
         FA_APP_EXT.LOAN_SECURED_FLG length = 1
                                     label = "Loan Secured Flag",
         FA_APP_EXT.MORTGAGE_CONSOLIDATION_AMT length = 8
                                               format = NLNUM18.5
                                               informat = NLNUM18.5
                                               label = "Mortgage Consolidation Amount",
         FA_APP_EXT.MORTGAGE_CONSOLIDATION_CNT length = 8
                                               label = "Mortgage Consolidation Count",
         FA_APP_EXT.SAVINGS_IN_CONSOLIDATION_AMT length = 8
                                                 format = NLNUM18.5
                                                 informat = NLNUM18.5
                                                 label = "Savings in Consolidation Amount",
         FA_APP_EXT.EXTERNAL_ORG_RK length = 8
                                    format = 12.
                                    informat = 12.
                                    label = "External Organization",
         FA_APP_EXT.PRODUCT_RK length = 8
                               format = 12.
                               informat = 12.
                               label = "Product Key",
         COALESCE(FINANCIAL_ACCOUNT_APPLICANT.EMPLOYER_INDUSTRY_CD, 
                FINANCIAL_ACCOUNT_APPLICANT.EMPLOYMENT_INDUSTRY_CD) as INDUSTRY_CD length = 10
      from
         DDS.FINANCIAL_ACCOUNT_APPLICANT, 
         martscr.FA_APP_EXT
      where
         FINANCIAL_ACCOUNT_APPLICANT.FINANCIAL_APPLICATION_RK = FA_APP_EXT.FINANCIAL_APPLICATION_RK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify FA_APP_APPT;
         ic create not null (APPLICANT_RK);
         ic create not null (APPLICATION_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006ZX * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.FA_APP_APPT          A5V75JN3.BP000677 * 
 * Target Table:  FA_APP_APPT - martscr.FA_APP_APPT         A5V75JN3.BE0000L9 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0004OZ * 
 *                                                                            * 
 * User Written:  Index creation on CUSTOMER_RK and         A5V75JN3.AF000PZE * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on CUSTOMER_RK and  LOAD_END_DTTM            * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on CUSTOMER_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX CUSTOMER_RK_LOAD_END_DTTM
      ON martscr.FA_APP_APPT(CUSTOMER_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

