/****************************************************************************** 
 * Job:           FA_APP_EXT                                A5V75JN3.BN00003C * 
 * Description:   This job picks up data from FINANCIAL_ACCOUNT_APPLICATION   * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  FINANCIAL_ACCOUNT_APPLICATION -           A5V75JN3.BE00002R * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICATION                          * 
 * Target Table:  FA_APP_EXT - martscr.FA_APP_EXT           A5V75JN3.BE0000LA * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:11:01 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FA_APP_EXT                                                                 * 
 * Job Name: FA_APP_EXTJob Desc Pre Process: NoneMain: a)A user written code  * 
 * to extract data for latest application for each external org. This job     * 
 * is used while building CORPORATE_FINANCIAL_DETAIL table.Post Process: a)   * 
 * Creating simple index on FINANCIAL_APPLICATION_RK, LOAD_END_DTTM           * 
 *  .Parameters: None.Developed by: sinahkReviewed by:Tested by:              * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00003C);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FA_APP_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004P0 * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PZG * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=DDS.FINANCIAL_ACCOUNT_APPLICATION out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Picking up data for latest application    A5V75JN3.BO000700 * 
 *                 for each external org                                      * 
 * Transform:     User Written Code                                           * 
 * Description:   Picking up data for latest application for each external    * 
 *                 org                                                        * 
 *                                                                            * 
 * Source Table:  FINANCIAL_ACCOUNT_APPLICATION -           A5V75JN3.BE00002R * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICATION                          * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP000678 * 
 *                 martscr.FA_APP_EXT                                         * 
 *                                                                            * 
 * User Written:  Picking up data for latest application    A5V75JN3.AF000PZF * 
 *                 for each external org                                      * 
 *                Picking up data for latest application for each external    * 
 *                 org                                                        * 
 *============================================================================*/ 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(DDS.FINANCIAL_ACCOUNT_APPLICATION); 

%let transformID = %quote(A5V75JN3.BO000700); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.FA_APP_EXT); 

/*---- Start of User Written Code  ----*/ 

/* To extract latest application data the filter has been 
	been applied to the table FINANCIAL_ACCOUNT_APPLICATION.*/
PROC SQL;
CREATE TABLE WORK.FA_APP_EXT_LOAD AS 
SELECT FINANCIAL_ACCOUNT_APPLICATION.FINANCIAL_APPLICATION_RK,
FINANCIAL_ACCOUNT_APPLICATION.FINANCIAL_APPLICATION_ID,
FINANCIAL_ACCOUNT_APPLICATION.SOURCE_SYSTEM_CD,
CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.APPLICATION_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.APPLICATION_DT
END AS APPLICATION_DT,
FINANCIAL_ACCOUNT_APPLICATION.CUSTOMER_TYPE_CD,
FINANCIAL_ACCOUNT_APPLICATION.CORPORATE_APPLN_RK,
FINANCIAL_ACCOUNT_APPLICATION.CUSTOMER_RK,
CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.BIRTH_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.BIRTH_DT
END AS BIRTH_DT,
FINANCIAL_ACCOUNT_APPLICATION.GENDER_CD,
FINANCIAL_ACCOUNT_APPLICATION.MARITAL_STATUS_CD,
FINANCIAL_ACCOUNT_APPLICATION.DEPENDENTS_CNT,
FINANCIAL_ACCOUNT_APPLICATION.EDUCATION_LEVEL_CD,
FINANCIAL_ACCOUNT_APPLICATION.STD_OCCUPATION_CD,
FINANCIAL_ACCOUNT_APPLICATION.EMPLOYMENT_STATUS_CD,
FINANCIAL_ACCOUNT_APPLICATION.EMPLOYMENT_YEARS_CNT,
FINANCIAL_ACCOUNT_APPLICATION.TOTAL_EMPLOYMENT_YEARS_CNT,
FINANCIAL_ACCOUNT_APPLICATION.CURRENT_IND_YEARS_CNT,
FINANCIAL_ACCOUNT_APPLICATION.RESIDENT_STATUS_CD,
CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.RESIDENCE_STATUS_CD_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.RESIDENCE_STATUS_CD_DT
END AS RESIDENCE_STATUS_CD_DT,
FINANCIAL_ACCOUNT_APPLICATION.TIME_RESIDENCE_YEAR_CNT,
FINANCIAL_ACCOUNT_APPLICATION.SOURCE_CD,
FINANCIAL_ACCOUNT_APPLICATION.CHANNEL_CD,
FINANCIAL_ACCOUNT_APPLICATION.ANNUAL_INCOME_AMT,
FINANCIAL_ACCOUNT_APPLICATION.CURRENCY_CD,
FINANCIAL_ACCOUNT_APPLICATION.HHOLD_INCOME_AMT,
FINANCIAL_ACCOUNT_APPLICATION.MTH_HHOLD_OUTGOING_AMT,
FINANCIAL_ACCOUNT_APPLICATION.TOTAL_ASSET_AMT,
FINANCIAL_ACCOUNT_APPLICATION.TOTAL_LIABILITY_AMT,
FINANCIAL_ACCOUNT_APPLICATION.HOUSE_VALUE_AMT,
FINANCIAL_ACCOUNT_APPLICATION.APPLIED_AMT,
FINANCIAL_ACCOUNT_APPLICATION.DOWN_PAYMENT_AMT,
FINANCIAL_ACCOUNT_APPLICATION.GUARANTEE_AMT,
FINANCIAL_ACCOUNT_APPLICATION.COLLATERAL_AMT,
FINANCIAL_ACCOUNT_APPLICATION.SAVINGS_DUE_TO_ACCT_AMT,
FINANCIAL_ACCOUNT_APPLICATION.LOAN_TERM_MTHS_CNT,
FINANCIAL_ACCOUNT_APPLICATION.COURT_JUDGEMENT_CNT,
FINANCIAL_ACCOUNT_APPLICATION.PENDING_LAWSUIT_FLG,
FINANCIAL_ACCOUNT_APPLICATION.LEGAL_JUDGEMENT_FLG,
FINANCIAL_ACCOUNT_APPLICATION.BANKRUPTCY_STATUS_CD,
FINANCIAL_ACCOUNT_APPLICATION.COLLATERAL_CD,
CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.BANKRUPTCY_FILED_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.BANKRUPTCY_FILED_DT
END AS BANKRUPTCY_FILED_DT,
FINANCIAL_ACCOUNT_APPLICATION.OTHER_CREDIT_CARDS_OWNED_FLG,
FINANCIAL_ACCOUNT_APPLICATION.OTHER_CREDIT_CARDS_CNT,
FINANCIAL_ACCOUNT_APPLICATION.TAX_ID,
FINANCIAL_ACCOUNT_APPLICATION.TAX_ID_TYPE_CD,
FINANCIAL_ACCOUNT_APPLICATION.CITY_NM,
FINANCIAL_ACCOUNT_APPLICATION.POSTAL_CD,
FINANCIAL_ACCOUNT_APPLICATION.STATE_REGION_CD,
FINANCIAL_ACCOUNT_APPLICATION.COUNTRY_CD,
FINANCIAL_ACCOUNT_APPLICATION.ADDRESS_LINE_1_TXT,
FINANCIAL_ACCOUNT_APPLICATION.ADDRESS_LINE_2_TXT,
FINANCIAL_ACCOUNT_APPLICATION.ADDRESS_LINE_3_TXT,
FINANCIAL_ACCOUNT_APPLICATION.ADDRESS_LINE_4_TXT,
FINANCIAL_ACCOUNT_APPLICATION.PRODUCT_RK,
FINANCIAL_ACCOUNT_APPLICATION.PREVIOUS_BANK_EXTERNAL_ORG_RK,
FINANCIAL_ACCOUNT_APPLICATION.MAINTENANCE_FLG,
FINANCIAL_ACCOUNT_APPLICATION.FORECLOSED_FLG,
FINANCIAL_ACCOUNT_APPLICATION.BORROWED_DOWNPAYMENT_FLG,
FINANCIAL_ACCOUNT_APPLICATION.BORROWED_DOWNPAYMENT_PCT,
FINANCIAL_ACCOUNT_APPLICATION.PURPOSE_CD,
FINANCIAL_ACCOUNT_APPLICATION.INTERNAL_CREDIT_RATING_CD,
FINANCIAL_ACCOUNT_APPLICATION.SCORE_BUREAU_NO,
FINANCIAL_ACCOUNT_APPLICATION.OUTCOME_CD,
CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.OUTCOME_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.OUTCOME_DT
END AS OUTCOME_DT,
FINANCIAL_ACCOUNT_APPLICATION.DECISION_CD,
FINANCIAL_ACCOUNT_APPLICATION.DECISION_OVERRIDE_FLG,
FINANCIAL_ACCOUNT_APPLICATION.OVERRIDE_REASON_CD,
FINANCIAL_ACCOUNT_APPLICATION.RISK_CLASS_CD,
FINANCIAL_ACCOUNT_APPLICATION.PRE_CREDIT_CD,
FINANCIAL_ACCOUNT_APPLICATION.EXTERNAL_BANK_CREDIT_AMT,
FINANCIAL_ACCOUNT_APPLICATION.PROCESSING_CHARGES_AMT,
FINANCIAL_ACCOUNT_APPLICATION.FINANCIAL_UNIT_RK,
FINANCIAL_ACCOUNT_APPLICATION.PRE_CREDIT_MTHS_CNT,
FINANCIAL_ACCOUNT_APPLICATION.CREDIT_RISK_MITIGANT_RK,
FINANCIAL_ACCOUNT_APPLICATION.PRIOR_MORTGAGE_CNT,
FINANCIAL_ACCOUNT_APPLICATION.PRIOR_SIMILAR_ACCOUNT_CNT,
FINANCIAL_ACCOUNT_APPLICATION.CREDIT_CARD_CONSOLIDATION_AMT,
FINANCIAL_ACCOUNT_APPLICATION.MORTGAGE_CONSOLIDATION_AMT,
FINANCIAL_ACCOUNT_APPLICATION.LOAN_CONSOLIDATION_AMT,
FINANCIAL_ACCOUNT_APPLICATION.SAVINGS_IN_CONSOLIDATION_AMT,
FINANCIAL_ACCOUNT_APPLICATION.CREDIT_CARD_CONSOLIDATION_CNT,
FINANCIAL_ACCOUNT_APPLICATION.MORTGAGE_CONSOLIDATION_CNT,
FINANCIAL_ACCOUNT_APPLICATION.LOAN_CONSOLIDATION_CNT,
FINANCIAL_ACCOUNT_APPLICATION.LINKED_ACCOUNT_FLG,
FINANCIAL_ACCOUNT_APPLICATION.LINKED_DEPOSIT_ACCOUNT_FLG,
FINANCIAL_ACCOUNT_APPLICATION.LOAN_SECURED_FLG,
FINANCIAL_ACCOUNT_APPLICATION.CLLTRL_MTHLY_INS_PREM_AMT,
FINANCIAL_ACCOUNT_APPLICATION.CLLTRL_ONE_TIME_INS_PREM_AMT,
CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.CLLTRL_INS_START_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.CLLTRL_INS_START_DT
END AS CLLTRL_INS_START_DT,
CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.CLLTRL_INS_END_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.CLLTRL_INS_END_DT
END AS CLLTRL_INS_END_DT,
FINANCIAL_ACCOUNT_APPLICATION.PROCESSED_DTTM,
LOAD_CONTROL.LOAD_END_DTTM
FROM DDS.FINANCIAL_ACCOUNT_APPLICATION, CONTROL.LOAD_CONTROL
WHERE CASE symget('mEngine')  
        WHEN "ORACLE" THEN datepart(FINANCIAL_ACCOUNT_APPLICATION.APPLICATION_DT)
        ELSE FINANCIAL_ACCOUNT_APPLICATION.APPLICATION_DT
		END <= DATEPART(LOAD_CONTROL.LOAD_END_DTTM)
AND LOAD_CONTROL.LOAD_FLG = &CHECK_FLAG_TRUE
AND LOAD_CONTROL.RUN_STATUS = &RUNNING_STATUS;
QUIT;

PROC SORT DATA=WORK.FA_APP_EXT_LOAD
OUT= martscr.FA_APP_EXT (WHERE=(CORPORATE_APPLN_RK IS NOT NULL));
BY  CORPORATE_APPLN_RK LOAD_END_DTTM DESCENDING  APPLICATION_DT;
RUN;
DATA martscr.FA_APP_EXT (Rename=(CORPORATE_APPLN_RK=EXTERNAL_ORG_RK));
SET martscr.FA_APP_EXT (drop=PROCESSED_DTTM);
BY CORPORATE_APPLN_RK LOAD_END_DTTM DESCENDING  APPLICATION_DT;
IF FIRST.LOAD_END_DTTM  THEN OUTPUT;
RUN;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006ZZ * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP000678 * 
 *                 martscr.FA_APP_EXT                                         * 
 * Target Table:  FA_APP_EXT - martscr.FA_APP_EXT           A5V75JN3.BE0000LA * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0004P1 * 
 *                                                                            * 
 * User Written:  Index creation on                         A5V75JN3.AF000PZH * 
 *                 FINANCIAL_APPLICATION_RK, LOAD_END_DTTM                    * 
 *                Index creation on FINANCIAL_APPLICATION_RK, LOAD_END_DTTM   * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on  FINANCIAL_APPLICATION_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX APPLICATION_RK_LOAD_END_DTTM
      ON martscr.FA_APP_EXT( FINANCIAL_APPLICATION_RK, LOAD_END_DTTM );
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

