/****************************************************************************** 
 * Job:           FA_CBAC_L                                 A5V75JN3.BN00005M * 
 * Description:   This job picks up data from FA_CBA_L and FA_CBAC by         * 
 *                 performing left join on FA_CBA_L.                          * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FA_CBAC - martscr.FA_CBAC                 A5V75JN3.BE0000PM * 
 *                FA_CBA_L - martscr.FA_CBA_L               A5V75JN3.BE0000NP * 
 * Target Table:  FA_CBAC_L - martscr.FA_CBAC_L             A5V75JN3.BE0000NQ * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:23:55 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FA_CBAC_L                                                                  * 
 * Job Name: FA_CBAC_LJob Desc Pre Process: NoneMain: Core banking account    * 
 * information obtained by joining FA_CBA_L and FA_CBAC on ACCOUNT_RK by      * 
 * performing left join on FA_CBA_L.Post Process: Creating index on           * 
 * ACCOUNT_RK and LOAD_END_DTTM.Parameters: NoneDeveloped by:                 * 
 *  singupReviewed by:Tested by:                                              * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00005M);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FA_CBAC_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Core banking account information          A5V75JN3.BO0005PT * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Core banking account information obtained by joining        * 
 *                FA_CBA_L and FA_CBAC on ACCOUNT_RK by performing left       * 
 *                 join on FA_CBA_L.                                          * 
 *                                                                            * 
 * Source Tables: FA_CBAC - martscr.FA_CBAC                 A5V75JN3.BE0000PM * 
 *                FA_CBA_L - martscr.FA_CBA_L               A5V75JN3.BE0000NP * 
 * Target Table:  SQL Target - martscr.FA_CBAC_L            A5V75JN3.BP0004TK * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005PT); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FA_CBAC_L;
quit;

proc sql;
   create table martscr.FA_CBAC_L as
      select
         FA_CBA_L.ACCOUNT_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "Account Key",
         FA_CBA_L.LOAD_END_DTTM length = 8
                                format = NLDATM21.
                                informat = NLDATM21.
                                label = "Load End Datetime",
         FA_CBA_L.OWNED_BY_INTERNAL_ORG_RK length = 8
                                           format = 12.
                                           informat = 12.
                                           label = "Internal Organization Retained Key",
         FA_CBA_L.CUSTOMER_RK length = 8
                              format = 12.
                              informat = 12.
                              label = "Customer Key",
         FA_CBA_L.PRODUCT_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "Product Key",
         FA_CBA_L.EMPLOYEE_RK length = 8
                              format = 12.
                              informat = 12.
                              label = "Employee Key",
         FA_CBA_L.DEFAULT_EVENT_RK length = 8
                                   format = 12.
                                   informat = 12.
                                   label = "Default Event Retained Key",
         FA_CBA_L.BILLED_AMT length = 8
                             format = NLNUM18.5
                             informat = NLNUM18.5
                             label = "Billed Amount",
         FA_CBA_L.CURRENT_BILL_AMT length = 8
                                   format = NLNUM18.5
                                   informat = NLNUM18.5
                                   label = "Current Bill Amount",
         FA_CBA_L.BALANCE_AMT length = 8
                              format = NLNUM18.5
                              informat = NLNUM18.5
                              label = "Balance Amount",
         FA_CBA_L.INTEREST_EXPECTED_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Interest Balance Amount",
         FA_CBA_L.PRINCIPAL_BALANCE_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Principal Balance Amount",
         FA_CBA_L.PAST_DUE_AMT length = 8
                               format = NLNUM18.5
                               informat = NLNUM18.5
                               label = "Past Due Amount",
         FA_CBA_L.DAYS_PAYMENT_PAST_DUE_CNT length = 8
                                            label = "No of Days Payment Past Due",
         FA_CBA_L.AVERAGE_DAILY_BALANCE_AMT length = 8
                                            format = NLNUM18.5
                                            informat = NLNUM18.5
                                            label = "Average Daily Balance Amount",
         FA_CBA_L.MAX_ACCOUNT_VALUE_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Maximum Account Value Amount",
         FA_CBA_L.MIN_ACCOUNT_VALUE_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Minimum Account Value Amount",
         FA_CBA_L.MIN_BILLING_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Minimum Due Amount",
         FA_CBA_L.FEES_AMT length = 8
                           format = NLNUM18.5
                           informat = NLNUM18.5
                           label = "Fees Amount",
         FA_CBA_L.CURTAILMENT_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Curtailment Amount",
         FA_CBA_L.LAST_STATEMENT_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Statement Date",
         FA_CBA_L.LAST_PAYMENT_STATUS_CD length = 3,
         FA_CBA_L.ACCOUNT_STATUS_CD length = 3
                                    label = "Account Status Code",
         FA_CBA_L.OPEN_DT length = 8
                          format = NLDATE10.
                          informat = NLDATE10.
                          label = "Open Date",
         FA_CBA_L.OPENING_CHANNEL_CD length = 3
                                     label = "Opening Channel Code",
         FA_CBA_L.LATE_PAYMENT_CNT length = 8
                                   label = "Number of late payment transactions, performed by all the Sk's.",
         FA_CBA_L.CCD_TOT_POINTS_EARNED length = 8
                                        format = NLNUM6.2
                                        informat = NLNUM6.2
                                        label = "Total No Points Earned",
         FA_CBA_L.CCD_TOT_POINTS_REDEEMED length = 8
                                          format = NLNUM6.2
                                          informat = NLNUM6.2
                                          label = "Total No Points Redeemed",
         FA_CBA_L.CCD_POINTS_BALANCE length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Credit Card Points Balance",
         FA_CBA_L.CAMPAIGN_TYPE_CD length = 3,
         FA_CBA_L.ESCROW_AMT length = 8
                             format = NLNUM18.5
                             informat = NLNUM18.5
                             label = "Escrow Amount",
         FA_CBA_L.OVERDRAFT_CURRENT_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Overdraft Current Amount",
         FA_CBA_L.TOTAL_BALANCE_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Total Balance Amount",
         FA_CBA_L.DEFAULT_STATUS_CD length = 3
                                    label = "Default Status Code",
         FA_CBAC.CLEARED_BALANCE_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Cleared Balance Amount",
         FA_CBAC.NEXT_INTEREST_PAYMENT_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Next Interest Payment Date"
      from
         martscr.FA_CBA_L left join 
         martscr.FA_CBAC
            on
            (
               FA_CBAC.ACCOUNT_RK = FA_CBA_L.ACCOUNT_RK
               and FA_CBAC.LOAD_END_DTTM = FA_CBA_L.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify FA_CBAC_L;
         ic create not null (ACCOUNT_RK);
         ic create not null (LOAD_END_DTTM);
         ic create not null (OWNED_BY_INTERNAL_ORG_RK);
         ic create not null (CUSTOMER_RK);
         ic create not null (PRODUCT_RK);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005PU * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.FA_CBAC_L            A5V75JN3.BP0004TK * 
 * Target Table:  FA_CBAC_L - martscr.FA_CBAC_L             A5V75JN3.BE0000NQ * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY000438 * 
 *                                                                            * 
 * User Written:  Index creation on ACCOUNT_RK &            A5V75JN3.AF000MWK * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on ACCOUNT_RK & LOAD_END_DTTM                * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on ACCOUNT_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX ACCOUNT_RK_LOAD_END_DTTM
      ON martscr.FA_CBAC_L(ACCOUNT_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

