/****************************************************************************** 
 * Job:           FA_FAC_L                                  A5V75JN3.BN00005R * 
 * Description:   This job picks up data from FA_EXT and FA_FAC by            * 
 *                 performing left join on FA_EXT                             * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FA_EXT - martscr.FA_EXT                   A5V75JN3.BE0000JK * 
 *                FA_FAC - martscr.FA_FAC                   A5V75JN3.BE0000PT * 
 * Target Table:  FA_FAC_L - martscr.FA_FAC_L               A5V75JN3.BE0000NW * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:23:58 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FA_FAC_L                                                                   * 
 * Job Name: FA_FAC_LJob Desc Pre Process: NoneMain: a) Financial account     * 
 * change information obtained by joining FA_EXT and FA_FAC on ACCOUNT_RK     * 
 * by performing left join on FA_EXT.Post Process: Creating index on          * 
 * ACCOUNT_RK and LOAD_END_DTTM.Parameters: NoneDeveloped by:                 * 
 *  singupReviewed by:Tested by:                                              * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00005R);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FA_FAC_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Financial account change information      A5V75JN3.BO0005Q1 * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: FA_EXT - martscr.FA_EXT                   A5V75JN3.BE0000JK * 
 *                FA_FAC - martscr.FA_FAC                   A5V75JN3.BE0000PT * 
 * Target Table:  SQL Target - martscr.FA_FAC_L             A5V75JN3.BP0004TO * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005Q1); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FA_FAC_L;
quit;

proc sql;
   create table martscr.FA_FAC_L as
      select
         FA_EXT.ACCOUNT_RK length = 8
                           format = 12.
                           informat = 12.
                           label = "Account Key",
         FA_EXT.LOAD_END_DTTM length = 8
                              format = NLDATM21.
                              informat = NLDATM21.
                              label = "Load End Datetime",
         FA_EXT.EMPLOYEE_RK length = 8
                            format = 12.
                            informat = 12.
                            label = "Employee Key",
         FA_EXT.OWNED_BY_INTERNAL_ORG_RK length = 8
                                         format = 12.
                                         informat = 12.
                                         label = "Internal Organization Retained Key",
         FA_FAC.CURRENT_BILL_AMT length = 8
                                 format = NLNUM18.5
                                 informat = NLNUM18.5
                                 label = "Current Bill Amount",
         FA_FAC.MIN_ACCOUNT_VALUE_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Minimum Account Value Amount",
         FA_EXT.OPEN_DT length = 8
                        format = NLDATE10.
                        informat = NLDATE10.
                        label = "Open Date",
         FA_FAC.PRINCIPAL_BALANCE_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Principal Balance Amount",
         FA_FAC.LAST_STATEMENT_DT length = 8
                                  format = NLDATE10.
                                  informat = NLDATE10.
                                  label = "Statement Date",
         FA_EXT.OPENING_CHANNEL_CD length = 3
                                   label = "Opening Channel Code",
         FA_FAC.BALANCE_AMT length = 8
                            format = NLNUM18.5
                            informat = NLNUM18.5
                            label = "Balance Amount",
         FA_FAC.MIN_BILLING_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Minimum Due Amount",
         FA_FAC.FEES_AMT length = 8
                         format = NLNUM18.5
                         informat = NLNUM18.5
                         label = "Fees Amount",
         FA_EXT.ACCOUNT_STATUS_CD length = 3
                                  label = "Account Status Code",
         FA_FAC.DAYS_PAYMENT_PAST_DUE_CNT length = 8
                                          label = "No of Days Payment Past Due",
         FA_FAC.BILLED_AMT length = 8
                           format = NLNUM18.5
                           informat = NLNUM18.5
                           label = "Billed Amount",
         FA_FAC.CURTAILMENT_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Curtailment Amount",
         FA_FAC.INTEREST_EXPECTED_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Interest Balance Amount",
         FA_FAC.MAX_ACCOUNT_VALUE_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Maximum Account Value Amount",
         FA_FAC.PAST_DUE_AMT length = 8
                             format = NLNUM18.5
                             informat = NLNUM18.5
                             label = "Past Due Amount",
         FA_FAC.AVERAGE_DAILY_BALANCE_AMT length = 8
                                          format = NLNUM18.5
                                          informat = NLNUM18.5
                                          label = "Average Daily Balance Amount",
         FA_FAC.LAST_PAYMENT_STATUS_CD length = 3,
         FA_FAC.TOTAL_BALANCE_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Total Balance Amount"
      from
         martscr.FA_EXT left join 
         martscr.FA_FAC
            on
            (
               FA_EXT.ACCOUNT_RK = FA_FAC.ACCOUNT_RK
               and FA_EXT.LOAD_END_DTTM = FA_FAC.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify FA_FAC_L;
         ic create not null (ACCOUNT_RK);
         ic create not null (LOAD_END_DTTM);
         ic create not null (OWNED_BY_INTERNAL_ORG_RK);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005Q2 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.FA_FAC_L             A5V75JN3.BP0004TO * 
 * Target Table:  FA_FAC_L - martscr.FA_FAC_L               A5V75JN3.BE0000NW * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043C * 
 *                                                                            * 
 * User Written:  Index creation on ACCOUNT_RK &            A5V75JN3.AF000MXC * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on ACCOUNT_RK & LOAD_END_DTTM                * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on ACCOUNT_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX ACCOUNT_RK_LOAD_END_DTTM
      ON martscr.FA_FAC_L(ACCOUNT_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

