/****************************************************************************** 
 * Job:           FA_MAC_L                                  A5V75JN3.BN00005T * 
 * Description:   This job picks up data from FA_CUSXFA_FPA_FP_L and FA_MAC   * 
 *                 by performing left join on FA_CUSXFA_FPA_FP_L              * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FA_MAC - martscr.FA_MAC                   A5V75JN3.BE0000PY * 
 *                FA_CUSXFA_FPA_FP_L -                      A5V75JN3.BE0000NU * 
 *                 martscr.FA_CUSXFA_FPA_FP_L                                 * 
 * Target Table:  FA_MAC_L - martscr.FA_MAC_L               A5V75JN3.BE0000NY * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:26:26 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FA_MAC_L                                                                   * 
 * Job Name: FA_MAC_LJob Desc Pre Process: NoneMain: a) Mortgage Account      * 
 * Information obtained by joining FA_CUSXFA_FPA_FP_L and FA_MAC on           * 
 * ACCOUNT_RK by performing left join on FA_CUSXFA_FPA_FP_L.Post Process:     * 
 * Creating index on ACCOUNT_RK and LOAD_END_DTTM.Parameters: NoneDeveloped   * 
 *  by: singupReviewed by:Tested by:                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00005T);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FA_MAC_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Mortgage Account Information              A5V75JN3.BO0005Q5 * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Mortgage Account Information obtained by joining            * 
 *                FA_CUSXFA_FPA_FP_L and FA_MAC  on ACCOUNT_RK by             * 
 *                 performing left join on FA_CUSXFA_FPA_FP_L.                * 
 *                                                                            * 
 * Source Tables: FA_MAC - martscr.FA_MAC                   A5V75JN3.BE0000PY * 
 *                FA_CUSXFA_FPA_FP_L -                      A5V75JN3.BE0000NU * 
 *                 martscr.FA_CUSXFA_FPA_FP_L                                 * 
 * Target Table:  SQL Target - martscr.FA_MAC_L             A5V75JN3.BP0004TQ * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005Q5); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FA_MAC_L;
quit;

proc sql;
   create table martscr.FA_MAC_L as
      select
         FA_CUSXFA_FPA_FP_L.ACCOUNT_RK length = 8
                                       format = 12.
                                       informat = 12.
                                       label = "Account Key",
         FA_CUSXFA_FPA_FP_L.LOAD_END_DTTM length = 8
                                          format = NLDATM21.
                                          informat = NLDATM21.
                                          label = "Load End Datetime",
         FA_CUSXFA_FPA_FP_L.OWNED_BY_INTERNAL_ORG_RK length = 8
                                                     format = 12.
                                                     informat = 12.
                                                     label = "Internal Organization Retained Key",
         FA_CUSXFA_FPA_FP_L.CUSTOMER_RK length = 8
                                        format = 12.
                                        informat = 12.
                                        label = "Customer Key",
         FA_CUSXFA_FPA_FP_L.PRODUCT_RK length = 8
                                       format = 12.
                                       informat = 12.
                                       label = "Product Key",
         FA_CUSXFA_FPA_FP_L.EMPLOYEE_RK length = 8
                                        format = 12.
                                        informat = 12.
                                        label = "Employee Key",
         FA_CUSXFA_FPA_FP_L.DEFAULT_EVENT_RK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "Default Event Retained Key",
         FA_MAC.ESCROW_AMT length = 8
                           format = NLNUM18.5
                           informat = NLNUM18.5
                           label = "Escrow Amount",
         FA_CUSXFA_FPA_FP_L.BILLED_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "Billed Amount",
         FA_CUSXFA_FPA_FP_L.CURRENT_BILL_AMT length = 8
                                             format = NLNUM18.5
                                             informat = NLNUM18.5
                                             label = "Current Bill Amount",
         FA_CUSXFA_FPA_FP_L.BALANCE_AMT length = 8
                                        format = NLNUM18.5
                                        informat = NLNUM18.5
                                        label = "Balance Amount",
         FA_CUSXFA_FPA_FP_L.INTEREST_EXPECTED_AMT length = 8
                                                  format = NLNUM18.5
                                                  informat = NLNUM18.5
                                                  label = "Interest Balance Amount",
         FA_CUSXFA_FPA_FP_L.PRINCIPAL_BALANCE_AMT length = 8
                                                  format = NLNUM18.5
                                                  informat = NLNUM18.5
                                                  label = "Principal Balance Amount",
         FA_CUSXFA_FPA_FP_L.PAST_DUE_AMT length = 8
                                         format = NLNUM18.5
                                         informat = NLNUM18.5
                                         label = "Past Due Amount",
         FA_CUSXFA_FPA_FP_L.DAYS_PAYMENT_PAST_DUE_CNT length = 8
                                                      label = "No of Days Payment Past Due",
         FA_CUSXFA_FPA_FP_L.AVERAGE_DAILY_BALANCE_AMT length = 8
                                                      format = NLNUM18.5
                                                      informat = NLNUM18.5
                                                      label = "Average Daily Balance Amount",
         FA_CUSXFA_FPA_FP_L.MAX_ACCOUNT_VALUE_AMT length = 8
                                                  format = NLNUM18.5
                                                  informat = NLNUM18.5
                                                  label = "Maximum Account Value Amount",
         FA_CUSXFA_FPA_FP_L.MIN_ACCOUNT_VALUE_AMT length = 8
                                                  format = NLNUM18.5
                                                  informat = NLNUM18.5
                                                  label = "Minimum Account Value Amount",
         FA_CUSXFA_FPA_FP_L.MIN_BILLING_AMT length = 8
                                            format = NLNUM18.5
                                            informat = NLNUM18.5
                                            label = "Minimum Due Amount",
         FA_CUSXFA_FPA_FP_L.FEES_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Fees Amount",
         FA_CUSXFA_FPA_FP_L.CURTAILMENT_AMT length = 8
                                            format = NLNUM18.5
                                            informat = NLNUM18.5
                                            label = "Curtailment Amount",
         FA_CUSXFA_FPA_FP_L.LAST_STATEMENT_DT length = 8
                                              format = NLDATE10.
                                              informat = NLDATE10.
                                              label = "Statement Date",
         FA_CUSXFA_FPA_FP_L.LAST_PAYMENT_STATUS_CD length = 3,
         FA_CUSXFA_FPA_FP_L.ACCOUNT_STATUS_CD length = 3
                                              label = "Account Status Code",
         FA_CUSXFA_FPA_FP_L.OPEN_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Open Date",
         FA_CUSXFA_FPA_FP_L.OPENING_CHANNEL_CD length = 3
                                               label = "Opening Channel Code",
         FA_CUSXFA_FPA_FP_L.LATE_PAYMENT_CNT length = 8
                                             label = "Number of late payment transactions, performed by all the Sk's.",
         FA_CUSXFA_FPA_FP_L.CCD_TOT_POINTS_EARNED length = 8
                                                  format = NLNUM6.2
                                                  informat = NLNUM6.2
                                                  label = "Total No Points Earned",
         FA_CUSXFA_FPA_FP_L.CCD_TOT_POINTS_REDEEMED length = 8
                                                    format = NLNUM6.2
                                                    informat = NLNUM6.2
                                                    label = "Total No Points Redeemed",
         FA_CUSXFA_FPA_FP_L.CCD_POINTS_BALANCE length = 8
                                               format = NLNUM18.5
                                               informat = NLNUM18.5
                                               label = "Credit Card Points Balance",
         FA_CUSXFA_FPA_FP_L.CAMPAIGN_TYPE_CD length = 3,
         FA_CUSXFA_FPA_FP_L.TOTAL_BALANCE_AMT length = 8
                                              format = NLNUM18.5
                                              informat = NLNUM18.5
                                              label = "Total Balance Amount",
         FA_CUSXFA_FPA_FP_L.DEFAULT_STATUS_CD length = 3
                                              label = "Default Status Code"
      from
         martscr.FA_CUSXFA_FPA_FP_L left join 
         martscr.FA_MAC
            on
            (
               FA_MAC.ACCOUNT_RK = FA_CUSXFA_FPA_FP_L.ACCOUNT_RK
               and FA_MAC.LOAD_END_DTTM = FA_CUSXFA_FPA_FP_L.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify FA_MAC_L;
         ic create not null (ACCOUNT_RK);
         ic create not null (LOAD_END_DTTM);
         ic create not null (OWNED_BY_INTERNAL_ORG_RK);
         ic create not null (CUSTOMER_RK);
         ic create not null (PRODUCT_RK);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005Q6 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.FA_MAC_L             A5V75JN3.BP0004TQ * 
 * Target Table:  FA_MAC_L - martscr.FA_MAC_L               A5V75JN3.BE0000NY * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043E * 
 *                                                                            * 
 * User Written:  Index creation on ACCOUNT_RK &            A5V75JN3.AF000MXQ * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on ACCOUNT_RK & LOAD_END_DTTM                * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on ACCOUNT_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX ACCOUNT_RK_LOAD_END_DTTM
      ON martscr.FA_MAC_L(ACCOUNT_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

