/****************************************************************************** 
 * Job:           FA_TRANS_L                                A5V75JN3.BN00005V * 
 * Description:   This job picks up data from FA_DE_L and APP_TRANS_PYMT by   * 
 *                 performing left join on FA_DE_L.                           * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: APP_TRANS_PYMT - martscr.APP_TRANS_PYMT   A5V75JN3.BE0000ND * 
 *                FA_DE_L - martscr.FA_DE_L                 A5V75JN3.BE0000NV * 
 * Target Table:  FA_TRANS_L - martscr.FA_TRANS_L           A5V75JN3.BE0000O0 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:26:27 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FA_TRANS_L                                                                 * 
 * Job Name: FA_TRANS_LJob Desc Pre Process: NoneMain: a) Late payment        * 
 * information of account obtained by joining FA_DE_L and APP_TRANS_PYMT on   * 
 * ACCOUNT_RK by performing left join on FA_DE_L.Post Process: Creating       * 
 * index on ACCOUNT_RK and LOAD_END_DTTM.Parameters: NoneDeveloped by:        * 
 *  singupReviewed by:Tested by:                                              * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00005V);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FA_TRANS_L;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Late payment information of account       A5V75JN3.BO0005Q9 * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Late payment information of account obtained by joining     * 
 *                FA_DE_L and APP_TRANS_PYMT on ACCOUNT_RK by performing      * 
 *                 left join on FA_DE_L                                       * 
 *                                                                            * 
 * Source Tables: APP_TRANS_PYMT - martscr.APP_TRANS_PYMT   A5V75JN3.BE0000ND * 
 *                FA_DE_L - martscr.FA_DE_L                 A5V75JN3.BE0000NV * 
 * Target Table:  SQL Target - martscr.FA_TRANS_L           A5V75JN3.BP0004TS * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005Q9); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FA_TRANS_L;
quit;

proc sql;
   create table martscr.FA_TRANS_L as
      select
         FA_DE_L.ACCOUNT_RK length = 8
                            format = 12.
                            informat = 12.
                            label = "Account Key",
         FA_DE_L.LOAD_END_DTTM length = 8
                               format = NLDATM21.
                               informat = NLDATM21.
                               label = "Load End Datetime",
         FA_DE_L.OWNED_BY_INTERNAL_ORG_RK length = 8
                                          format = 12.
                                          informat = 12.
                                          label = "Internal Organization Retained Key",
         FA_DE_L.EMPLOYEE_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "Employee Key",
         FA_DE_L.DEFAULT_EVENT_RK length = 8
                                  format = 12.
                                  informat = 12.
                                  label = "Default Event Retained Key",
         FA_DE_L.DEFAULT_STATUS_CD length = 3
                                   label = "Default Status Code",
         APP_TRANS_PYMT.LATE_PAYMENT_CNT length = 8
                                         label = "Number of late payment transactions, performed by all the Sk's.",
         FA_DE_L.BILLED_AMT length = 8
                            format = NLNUM18.5
                            informat = NLNUM18.5
                            label = "Billed Amount",
         FA_DE_L.CURRENT_BILL_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Current Bill Amount",
         FA_DE_L.BALANCE_AMT length = 8
                             format = NLNUM18.5
                             informat = NLNUM18.5
                             label = "Balance Amount",
         FA_DE_L.INTEREST_EXPECTED_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "Interest Balance Amount",
         FA_DE_L.PRINCIPAL_BALANCE_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "Principal Balance Amount",
         FA_DE_L.PAST_DUE_AMT length = 8
                              format = NLNUM18.5
                              informat = NLNUM18.5
                              label = "Past Due Amount",
         FA_DE_L.DAYS_PAYMENT_PAST_DUE_CNT length = 8
                                           label = "No of Days Payment Past Due",
         FA_DE_L.AVERAGE_DAILY_BALANCE_AMT length = 8
                                           format = NLNUM18.5
                                           informat = NLNUM18.5
                                           label = "Average Daily Balance Amount",
         FA_DE_L.MAX_ACCOUNT_VALUE_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "Maximum Account Value Amount",
         FA_DE_L.MIN_ACCOUNT_VALUE_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "Minimum Account Value Amount",
         FA_DE_L.MIN_BILLING_AMT length = 8
                                 format = NLNUM18.5
                                 informat = NLNUM18.5
                                 label = "Minimum Due Amount",
         FA_DE_L.FEES_AMT length = 8
                          format = NLNUM18.5
                          informat = NLNUM18.5
                          label = "Fees Amount",
         FA_DE_L.CURTAILMENT_AMT length = 8
                                 format = NLNUM18.5
                                 informat = NLNUM18.5
                                 label = "Curtailment Amount",
         FA_DE_L.LAST_STATEMENT_DT length = 8
                                   format = NLDATE10.
                                   informat = NLDATE10.
                                   label = "Statement Date",
         FA_DE_L.LAST_PAYMENT_STATUS_CD length = 3,
         FA_DE_L.ACCOUNT_STATUS_CD length = 3
                                   label = "Account Status Code",
         FA_DE_L.OPEN_DT length = 8
                         format = NLDATE10.
                         informat = NLDATE10.
                         label = "Open Date",
         FA_DE_L.OPENING_CHANNEL_CD length = 3
                                    label = "Opening Channel Code",
         FA_DE_L.TOTAL_BALANCE_AMT length = 8
                                   format = NLNUM18.5
                                   informat = NLNUM18.5
                                   label = "Total Balance Amount"
      from
         martscr.FA_DE_L left join 
         martscr.APP_TRANS_PYMT
            on
            (
               APP_TRANS_PYMT.ACCOUNT_RK = FA_DE_L.ACCOUNT_RK
               and APP_TRANS_PYMT.LOAD_END_DTTM = FA_DE_L.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify FA_TRANS_L;
         ic create not null (ACCOUNT_RK);
         ic create not null (LOAD_END_DTTM);
         ic create not null (OWNED_BY_INTERNAL_ORG_RK);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QA * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.FA_TRANS_L           A5V75JN3.BP0004TS * 
 * Target Table:  FA_TRANS_L - martscr.FA_TRANS_L           A5V75JN3.BE0000O0 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043G * 
 *                                                                            * 
 * User Written:  Index creation on ACCOUNT_RK &            A5V75JN3.AF000MY4 * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation on ACCOUNT_RK & LOAD_END_DTTM                * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on ACCOUNT_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
     CREATE INDEX ACCOUNT_RK_LOAD_END_DTTM
      ON martscr.FA_TRANS_L(ACCOUNT_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

