/****************************************************************************** 
 * Job:           FIN_ACT_APP                               A5V75JN3.BN0000U0 * 
 * Description:   This job picks up the data from table                       * 
 *                 FINANCIAL_ACCOUNT_APPLICANT and SCORE_APPLICATION          * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FINANCIAL_ACCOUNT_APPLICANT -             A5V75JN3.BE00002Q * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICANT                            * 
 *                SCORE_APPLICATION -                       A5V75JN3.BE0000U2 * 
 *                 martscr.SCORE_APPLICATION                                  * 
 * Target Table:  FIN_ACT_APP - martscr.FIN_ACT_APP         A5V75JN3.BE0000TY * 
 *                                                                            * 
 * Generated on:  Saturday, December 27, 2008 11:24:41 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FIN_ACT_APP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Extracting the data for the application   A5V75JN3.BO0005NI * 
 *                 applied and approved                                       * 
 * Transform:     SQL Join                                                    * 
 * Description:   Extracting the data for the application applied and         * 
 *                approved by joining the tables                              * 
 *                FINANCIAL_ACCOUNT_APPLICANT and                             * 
 *                 FINANCIAL_ACCOUNT_APPLICATION on application_rk.           * 
 *                                                                            * 
 * Source Tables: FINANCIAL_ACCOUNT_APPLICANT -             A5V75JN3.BE00002Q * 
 *                 DDS.FINANCIAL_ACCOUNT_APPLICANT                            * 
 *                SCORE_APPLICATION -                       A5V75JN3.BE0000U2 * 
 *                 martscr.SCORE_APPLICATION                                  * 
 * Target Table:  SQL Join Target - martscr.FIN_ACT_APP     A5V75JN3.BP0004S9 * 
 *============================================================================*/ 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FIN_ACT_APP;
quit;

proc sql;
   create table martscr.FIN_ACT_APP as
   select SCORE_APPLICATION.CHANNEL_CD,
       SCORE_APPLICATION.PRODUCT_RK,
       SCORE_APPLICATION.APPLIED_AMT,
       CASE  WHEN  SCORE_APPLICATION.OUTCOME_CD  IN (&OUTCOME_ACCEPT)   
   THEN 1  
   ELSE 0  
   END format=8. AS APPROVE_CNT,
       FINANCIAL_ACCOUNT_APPLICANT.FINANCIAL_APPLICATION_RK AS APPLICATION_RK,
       SCORE_APPLICATION.FINANCIAL_UNIT_RK,
       FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_RK,
       CASE  WHEN  SCORE_APPLICATION.OUTCOME_CD  IN (&OUTCOME_REJECT)    
   THEN 1   
   ELSE 0   
   END format=8. AS REJECT_CNT
   from DDS.FINANCIAL_ACCOUNT_APPLICANT 
       INNER JOIN martscr.SCORE_APPLICATION
        ON (SCORE_APPLICATION.FINANCIAL_APPLICATION_RK = FINANCIAL_ACCOUNT_APPLICANT.FINANCIAL_APPLICATION_RK) 
   where FINANCIAL_ACCOUNT_APPLICANT.APPLICANT_TYPE_CD  IN (&PRI_APP_TYPE_CD);
quit;

%rcset(&sqlrc);

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005NJ * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target - martscr.FIN_ACT_APP     A5V75JN3.BP0004S9 * 
 * Target Table:  FIN_ACT_APP - martscr.FIN_ACT_APP         A5V75JN3.BE0000TY * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00041H * 
 *                                                                            * 
 * User Written:  Creating index on FINANCIAL_UNIT_RK       A5V75JN3.AF000MMM * 
 *                 column.                                                    * 
 *                Creating index on FINANCIAL_UNIT_RK column.                 * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*Creating index on FINANCIAL_UNIT_RK column */
PROC SQL NOPRINT;
  CREATE INDEX FINANCIAL_UNIT_RK 
   ON martscr.FIN_ACT_APP(FINANCIAL_UNIT_RK );

QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

