/****************************************************************************** 
 * Job:           FIN_APP_FU                                A5V75JN3.BN0000U1 * 
 * Description:   This job picks up the data from FIN_ACT_APP and FU_EXT      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FIN_ACT_APP - martscr.FIN_ACT_APP         A5V75JN3.BE0000TY * 
 *                FU_EXT - martscr.FU_EXT                   A5V75JN3.BE0000JV * 
 * Target Table:  FIN_APP_FU - martscr.FIN_APP_FU           A5V75JN3.BE0000TZ * 
 *                                                                            * 
 * Generated on:  Saturday, December 27, 2008 11:24:41 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FIN_APP_FU;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Extracting the data for the               A5V75JN3.BO0005NL * 
 *                 internal_org_rk                                            * 
 * Transform:     SQL Join                                                    * 
 * Description:   Extracting the data for the internal_org_sk  for the        * 
 *                applied account from inner joining the table FIN_ACT_APLL   * 
 *                 and FU_EXT on FINANCIAL_UNIT_RK                            * 
 *                                                                            * 
 * Source Tables: FIN_ACT_APP - martscr.FIN_ACT_APP         A5V75JN3.BE0000TY * 
 *                FU_EXT - martscr.FU_EXT                   A5V75JN3.BE0000JV * 
 * Target Table:  SQL Join Target - martscr.FIN_APP_FU      A5V75JN3.BP0004SA * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FIN_APP_FU;
quit;

proc sql;
   create table martscr.FIN_APP_FU as
   select FIN_ACT_APP.CHANNEL_CD,
       FIN_ACT_APP.PRODUCT_RK,
       FIN_ACT_APP.APPLIED_AMT,
       FIN_ACT_APP.APPROVE_CNT,
       FIN_ACT_APP.APPLICATION_RK,
       FIN_ACT_APP.FINANCIAL_UNIT_RK,
       FIN_ACT_APP.APPLICANT_RK,
       FU_EXT.INTERNAL_ORG_RK,
       FIN_ACT_APP.REJECT_CNT
   from martscr.FIN_ACT_APP 
       LEFT JOIN martscr.FU_EXT
        ON (FIN_ACT_APP.FINANCIAL_UNIT_RK = FU_EXT.FINANCIAL_UNIT_RK) ;
quit;

%rcset(&sqlrc);

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005NK * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target - martscr.FIN_APP_FU      A5V75JN3.BP0004SA * 
 * Target Table:  FIN_APP_FU - martscr.FIN_APP_FU           A5V75JN3.BE0000TZ * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00041I * 
 *                                                                            * 
 * User Written:  Creating index on APPLICATION_RK column.  A5V75JN3.AF000MMO * 
 *                Creating index on APPLICATION_RK column.                    * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*Creating index on APPLICATION_RK column */
PROC SQL NOPRINT;
  CREATE INDEX APPLICATION_RK 
   ON martscr.FIN_APP_FU(APPLICATION_RK );

QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

