/****************************************************************************** 
 * Job:           FIN_APP_SCR_AMT                           A5V75JN3.BN0000U2 * 
 * Description:   This job picks up the data from DISBRS_APRVD_AMT            * 
 *                 andAPS_AM_LKP                                              * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: APS_AM_LKP - martscr.APS_AM_LKP           A5V75JN3.BE0000TW * 
 *                DISBRS_APRVD_AMT -                        A5V75JN3.BE0000TX * 
 *                 martscr.DISBRS_APRVD_AMT                                   * 
 * Target Table:  FIN_APP_SCR_AMT - martscr.FIN_APP_SCR_AMT A5V75JN3.BE0000U0 * 
 *                                                                            * 
 * Generated on:  Saturday, December 27, 2008 11:24:42 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FIN_APP_SCR_AMT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Loading data for app. score point and     A5V75JN3.BO0005NN * 
 *                 app. amt                                                   * 
 * Transform:     SQL Join                                                    * 
 * Description:   Loading data for app. score point and app. amt  by inner    * 
 *                joining table FIN_ACT_APR_DIS_AMT and APS_AM_LKP on         * 
 *                 ACCOUNT_RK                                                 * 
 *                                                                            * 
 * Source Tables: APS_AM_LKP - martscr.APS_AM_LKP           A5V75JN3.BE0000TW * 
 *                DISBRS_APRVD_AMT -                        A5V75JN3.BE0000TX * 
 *                 martscr.DISBRS_APRVD_AMT                                   * 
 * Target Table:  SQL Join Target - martscr.FIN_APP_SCR_AMT A5V75JN3.BP0004SB * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FIN_APP_SCR_AMT;
quit;

proc sql;
   create table martscr.FIN_APP_SCR_AMT as
   select DISBRS_APRVD_AMT.INTERNAL_ORG_RK,
       DISBRS_APRVD_AMT.CHANNEL_CD,
       DISBRS_APRVD_AMT.PRODUCT_RK,
       DISBRS_APRVD_AMT.APPLIED_AMT,
       DISBRS_APRVD_AMT.APPROVE_CNT,
       DISBRS_APRVD_AMT.APPLICATION_RK,
       DISBRS_APRVD_AMT.APPLICANT_RK,
       DISBRS_APRVD_AMT.APPROVED_AMT,
       DISBRS_APRVD_AMT.DISBURSED_AMT,
       APS_AM_LKP.MODEL_RK,
       APS_AM_LKP.APPLICATION_SCORE_NO,
       APS_AM_LKP.SCORE_POINTS_NO,
       APS_AM_LKP.SCORE_TIME_SK,
       DISBRS_APRVD_AMT.REJECT_CNT,
       DISBRS_APRVD_AMT.ACCOUNT_CNT
   from martscr.APS_AM_LKP 
       INNER JOIN martscr.DISBRS_APRVD_AMT
        ON (APS_AM_LKP.FINANCIAL_APPLICATION_RK = DISBRS_APRVD_AMT.FINANCIAL_APPLICATION_RK) ;
quit;

%rcset(&sqlrc);

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005NM * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Join Target - martscr.FIN_APP_SCR_AMT A5V75JN3.BP0004SB * 
 * Target Table:  FIN_APP_SCR_AMT - martscr.FIN_APP_SCR_AMT A5V75JN3.BE0000U0 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

