/****************************************************************************** 
 * Job:           FPA_ACCT_SCR                              A5V75JN3.BN0000W6 * 
 * Description:   This job picks up data from ACCOUNT_SCORE and FPA_EXT.      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_SCORE - martscr.ACCOUNT_SCORE     A5V75JN3.BE0000W2 * 
 *                FPA_EXT - martscr.FPA_EXT                 A5V75JN3.BE0000JR * 
 * Target Tables: FPA_ACCT_SCR_EXP -                        A5V75JN3.BE0000WH * 
 *                 facterr.FPA_ACCT_SCR_EXP                                   * 
 *                FPA_ACCT_SCR - martscr.FPA_ACCT_SCR       A5V75JN3.BE0000WG * 
 *                                                                            * 
 * Generated on:  Saturday, December 27, 2008 5:29:45 PM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

%let jobID = %quote(A5V75JN3.BN0000W6);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FPA_ACCT_SCR;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Lookup to obtain product_rk               A5V75JN3.BO0005O6 * 
 * Transform:     Lookup                                                      * 
 * Description:   Lookup to obtain product_rk by looking up on the dataset    * 
 *                 FPA_EXT.                                                   * 
 *                                                                            * 
 * Source Tables: ACCOUNT_SCORE - martscr.ACCOUNT_SCORE     A5V75JN3.BE0000W2 * 
 *                FPA_EXT - martscr.FPA_EXT                 A5V75JN3.BE0000JR * 
 * Target Tables: Lookup Target - martscr.FPA_ACCT_SCR      A5V75JN3.BP0004SN * 
 *                Exception - work.FPA_ACCT_SCR_EXP         A5V75JN3.BP0004SO * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005O6); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FPA_ACCT_SCR;
quit;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete FPA_ACCT_SCR_EXP;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.FPA_ACCT_SCR
         (keep = PRODUCT_RK ACCOUNT_RK VARIABLE_NAME VARIABLE_GROUP_NO 
                 SCORE_POINTS SCORE_TIME_DT TARGET_TIME_DT MODEL_SK 
                 TARGET_PERIOD_MTHS_CNT)
      work.FPA_ACCT_SCR_EXP 
         (keep = etls_source_row etls_lookup_table etls_exception_cond 
                 etls_exception_action ACCOUNT_RK VARIABLE_GROUP_NO SCORE_POINTS 
                 MODEL_SK TARGET_PERIOD_MTHS_CNT VARIABLE_NAME CUT_OFF_SCORE)
      ; 
   
   attrib PRODUCT_RK length=8 format=12. label="Product Key"
          ACCOUNT_RK length=8
          VARIABLE_NAME length=$100
          VARIABLE_GROUP_NO length=8
          SCORE_POINTS length=8
          SCORE_TIME_DT length=8
          TARGET_TIME_DT length=8
          MODEL_SK length=8 format=12. label="Surrogate key for the analytical model dimension."
          TARGET_PERIOD_MTHS_CNT length=8 label=
          "Analytical model is developed to predict the probability of an event within a specified period. This period is called the Target period. This field stores the number of months of this period."
          ; 
   
   length etls_lookup_table $41 etls_exception_cond etls_exception_action $32 
   ; 
   
   retain missing0 0 ; 
   
   /* Assign variables used for error/exception handling  */ 
   etls_source_row      = _n_;
   request_write_target = 0; 
   request_write_error  = 0; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table martscr.FPA_EXT */ 
      nlobs = .; 
      dsid = open("martscr.FPA_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "martscr.FPA_EXT", hashexp: exponent);
            h0.defineKey( "ACCOUNT_RK");
            h0.defineData( "PRODUCT_RK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.FPA_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.FPA_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.FPA_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.FPA_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: martscr.FPA_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.FPA_EXT";
         
         abort 3; 
      end; 
      
      call missing (ACCOUNT_RK, PRODUCT_RK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.ACCOUNT_SCORE end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find();
   
   /* Examine success of lookups  */ 
   if (rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output martscr.FPA_ACCT_SCR; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.FPA_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.FPA_ACCT_SCR_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete mapped;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.mapped as 
      select PRODUCT_RK,
             ACCOUNT_RK length = 8,
             VARIABLE_NAME length = 100,
             VARIABLE_GROUP_NO length = 8,
             SCORE_POINTS length = 8,
             (&LOAD_STAR_USER_INPUT_DATE) as SCORE_TIME_DT length = 8,
             (INTNX('MONTH',&LOAD_STAR_USER_INPUT_DATE, TARGET_PERIOD_MTHS_CNT  ,'END')) as TARGET_TIME_DT length = 8,
             MODEL_SK length = 8,
             TARGET_PERIOD_MTHS_CNT length = 8
         from martscr.FPA_ACCT_SCR; 
quit;

%let SYSLAST = work.mapped; 

data martscr.FPA_ACCT_SCR; 
   set work.mapped; 
run; 

proc datasets lib=work nolist nowarn memtype = VIEW;
   delete mapped;
quit;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005O8 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Lookup Target - martscr.FPA_ACCT_SCR      A5V75JN3.BP0004SN * 
 * Target Table:  FPA_ACCT_SCR - martscr.FPA_ACCT_SCR       A5V75JN3.BE0000WG * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

/*============================================================================* 
 * Step:          Table Loader                              A5V75JN3.BO0005O7 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Exception - work.FPA_ACCT_SCR_EXP         A5V75JN3.BP0004SO * 
 * Target Table:  FPA_ACCT_SCR_EXP -                        A5V75JN3.BE0000WH * 
 *                 facterr.FPA_ACCT_SCR_EXP                                   * 
 *============================================================================*/ 

/* Access the data for Lookup Error Tables  */ 
LIBNAME facterr BASE "Data/bisdata/error" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(work.FPA_ACCT_SCR_EXP); 

%let transformID = %quote(A5V75JN3.BO0005O7); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.FPA_ACCT_SCR_EXP, DATA)) or 
            %sysfunc(exist(facterr.FPA_ACCT_SCR_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.FPA_ACCT_SCR_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(FPA_ACCT_SCR_EXP);
   %let etls_lib   = %nrquote(Lookup Error Tables);
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(facterr.FPA_ACCT_SCR_EXP, DATA)) or 
         %sysfunc(exist(facterr.FPA_ACCT_SCR_EXP, VIEW))); 
   
   /* Check for and remove foreign keys before deleting table */ 
   %if &etls_tableExist %then 
   %do; /* table exists */
      %macro etls_CIContents(table=,workTableOut=);
         %put NOTE: Building table listing Constraints and Indexes for: &table;
         proc datasets lib=work nolist; delete &workTableOut; quit;
         proc contents data=&table noprint out2=&workTableOut; run;
         data &workTableOut;
            length name $60 type $20 icown idxUnique idxNoMiss $3 recreate $600;
            set &workTableOut;
            if ICOwn ne 'YES';
         run;
         %rcSet(&syserr); 
         
      %mend etls_CIContents;
      
      %etls_CIContents(table=facterr.FPA_ACCT_SCR_EXP, workTableOut=etls_commands);
      
      data etls_commands; 
         set etls_commands(where=(upcase(type)="FOREIGN KEY")) end=eof; 
         command='ic delete '||trim(name)||';';
      run; 
      
      data _null_;
         set etls_commands(where=(1)) end=eof;
         if _n_=1 then 
            call execute('proc datasets nolist lib=facterr;modify FPA_ACCT_SCR_EXP;');
         call execute(command);
         if eof then call execute('; quit;');
      run;
      %rcSet(&syserr); 
      
   %end; /* table exists */ 
   
   /*---- Drop a table  ----*/ 
   %put %str(NOTE: Dropping table ...);
   proc datasets lib = facterr nolist nodetails;
        delete FPA_ACCT_SCR_EXP;
   quit;
   
   %rcSet(&syserr); 
   
   %let etls_tableExist = 0;
   
   /*---- Create a new table  ----*/ 
   data facterr.FPA_ACCT_SCR_EXP
           (label = 'FPA_ACCT_SCR_EXP');
      attrib etls_source_row length = 8
                label = 'The row number in the source table'; 
      attrib etls_lookup_table length = $41
                label = 'The name of the lookup table'; 
      attrib etls_exception_cond length = $32
                label = 'The name of the condition that caused this exception'; 
      attrib etls_exception_action length = $32
                label = 'The name of the action to take for this exception'; 
      attrib ACCOUNT_RK length = 8; 
      attrib VARIABLE_GROUP_NO length = 8; 
      attrib SCORE_POINTS length = 8; 
      attrib MODEL_SK length = 8 format = 12. informat = 12.
                label = 'Surrogate key for the analytical model dimension.'; 
      attrib TARGET_PERIOD_MTHS_CNT length = 8
                label = 'Analytical model is developed to predict the probability of an event within a specified period. This period is called the Target period. This field stores the number of months of this period.'; 
      attrib VARIABLE_NAME length = $100; 
      attrib CUT_OFF_SCORE length = 8; 
      stop;
   run;
   
   %rcSet(&syserr); 
   
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=facterr nolist;
      modify FPA_ACCT_SCR_EXP;
         ic create not null (etls_source_row);
         ic create not null (etls_lookup_table);
         ic create not null (etls_exception_cond);
         ic create not null (etls_exception_action);
   quit;
   
   %rcSet(&syserr); 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   proc append base = facterr.FPA_ACCT_SCR_EXP 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.FPA_ACCT_SCR_EXP, DATA)) or 
            %sysfunc(exist(facterr.FPA_ACCT_SCR_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.FPA_ACCT_SCR_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

