/****************************************************************************** 
 * Job:           FP_ALL_LVLS                               A5V75JN3.BN00007J * 
 * Description:   This job loads the target table wth data for all levels of  * 
 *                  product code.                                             * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  PCA_EXT - martscr.PCA_EXT                 A5V75JN3.BE0000KO * 
 * Target Table:  FP_ALL_LVLS - martscr.FP_ALL_LVLS         A5V75JN3.BE0000Q2 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:34:55 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FP_ALL_LVLS                                                                * 
 * Job Name: FP_ALL_LVLSJob Desc: This job loads the target table with data   * 
 * for all levels of product code.Pre Process: Creating format to obtain      * 
 * product category code.parameter Two parameter is been used while           * 
 * creating formats in the where clause of the fmt_gen macro are1.            * 
 * PR_ASSOC_TYPE_REPMain: Extracting data for all product levela) Parent      * 
 * category code of the product is assigned as level one product type         * 
 * code.b) Level one product category code is assigned as level one product   * 
 * category codeand level two product category code is obtain by applying     * 
 * format RP_DESC onthe level one product category code.c) Level two          * 
 * product category code is assigned as level two product category code and   * 
 * level three product category code is obtain by applying format RP_DESC     * 
 * onthe level two product category code.d) Level three product category      * 
 * code is assigned as level three product category code and level four       * 
 * product category code is obtain by applying format RP_DESC on the level    * 
 * three product category code.e) Level four product category code is         * 
 * assigned as level four product category code and level five product        * 
 * category code is obtain by applying format RP_DESC onthe level four        * 
 * product category code.f)Left join is done to get all the reporting data    * 
 * and the product class code and sub class codefrom the association type     * 
 * asset or liability.g) User written code is written for Adjusting the       * 
 * values of columns PRODUCT_CAT_LEVEL_1_CD,                                  * 
 * PRODUCT_CAT_LEVEL_2_CD,PRODUCT_CAT_LEVEL_3_                                * 
 * CD,PRODUCT_CAT_LEVEL_4_CD,PRODUCT_CAT_LEVEL_5_CD in the dataset            * 
 * "FP_ALL_LVLS" to support proper drill down in reporting.h)For class code   * 
 * and sub class code a fixed hierarchy is needed.Product association type    * 
 * code must be asset & liability.parent product --product category           * 
 * --product assoc type.NRV --PC0-- AOLREV-- PC1-- AOLTDP-- PC2-- AOLDDP--    * 
 * PC3-- AOLE.g. NRV: Non revolving, REV: Revolving, TDP: Term Liability,     * 
 * DDP: Demand Liability.Here parent product category code has the product    * 
 * sub class code and depending upon the Values in parent product category    * 
 * code the product class code Asset (For: NRV, REV) or Liability (For:       * 
 * TDP, DDP) is assigned.E.g. product category code viz. for product          * 
 * category code PC0 and PC1 product class code is Asset and for product      * 
 * category code PC2 and PC3 product class code is Liability.*Here            * 
 * PRODUCT_CAT_LEVEL_1_CD is mapped to PRODUCT_CATEGORY_CD so the index is    * 
 * created on the column PRODUCT_CAT_LEVEL_1_CD.Post Process: creating        * 
 * index on PRODUCT_CAT_LEVEL_1_CD                                            * 
 * column.Parameters:a)PR_ASSOC_TYPE_REP:Parameter to specify which           * 
 * association to be selected for Reporting while creating Financial          * 
 * Product Dimension.b)REV_ASSET_PRD_CAT_TYPE: Parameter specifies            * 
 * revolving type asset. Default value is 'REV'.c)NRV_ASSET_PRD_CAT_TYPE:     * 
 * Parameter specifies Non revolving type asset. Default value is             * 
 * 'NRV'.d)TDL_LIABILITY_PRD_CAT_TYPE: Parameter specifies term deposit       * 
 * type liability. Default value is 'TDP'.e)DDL_LIABILITY_PRD_CAT_TYPE:       * 
 * Parameter specifies demand deposit type liability. Default value is        * 
 * 'DDP'.f)PRODUCT_CLASS_ASSET :Parameter to specify the value for asset      * 
 * product class code.g)PRODUCT_CLASS_LIABILITY :Parameter to specify the     * 
 * value for liability product class code.Developed by: sinharReviewed by:    * 
 *  sinpepTested by:                                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00007J);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FP_ALL_LVLS;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Adjusting the values of columns           A5V75JN3.BO0005QS * 
 * Transform:     User Written Code                                           * 
 * Description:   Adjusting the values of columns to support proper           * 
 *                 drilldown in reporting.                                    * 
 *                                                                            * 
 * Source Table:  PCA_EXT - martscr.PCA_EXT                 A5V75JN3.BE0000KO * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP0004U1 * 
 *                 martscr.FP_ALL_LVLS                                        * 
 *                                                                            * 
 * User Written:  Adjusting the values of columns           A5V75JN3.AF000MZT * 
 *                Adjusting the values of columns                             * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.PCA_EXT); 

%let transformID = %quote(A5V75JN3.BO0005QS); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.FP_ALL_LVLS); 

/*---- Start of User Written Code  ----*/ 

/* Start of CS4.3 HF2 */ 
/* This code has been modified as a part of CS4.3 HF2. 
The code modification is done for to take care of loading Financial Product dimension
even if the Financial Product association records i.e. the Financial Product hierarchy 
records are not present. */

options mlogic mprint;


%macro create_hier;
			proc sort data=martscr.Fpc_ext out=martscr.Fpc_ext1(Drop=
																INTERNAL_PRODUCT_CATEGORY_CD
																INVEST_THRESHOLD_AMT
															);
			 by PRODUCT_CATEGORY_CD LOAD_END_DTTM;
			run;
			
			data martscr.Fpc_ext1;
			   set martscr.Fpc_ext1;
			   by PRODUCT_CATEGORY_CD LOAD_END_DTTM;
			   retain N 1;
			   if first.PRODUCT_CATEGORY_CD=1 then N=1;
			   else N+1;
			run;
			
			 
			
			data martscr.FP_ALL_LVLS(rename=(dt=LOAD_END_DTTM ));
			   if 0 then set martscr.Fpc_ext1;
			
			   if _N_=1 then do;
			      declare hash h(dataset:"martscr.Fpc_ext1",hashexp:16);
				  h.defineKey("PRODUCT_CATEGORY_CD",'N');
				  h.definedata("PRODUCT_CATEGORY_DESC","LOAD_END_DTTM");
				  h.definedone();
				  call missing(PRODUCT_CATEGORY_CD,PRODUCT_CATEGORY_DESC,N,LOAD_END_DTTM);
				end;
			
				set node_1;
				
					%do i=1 %to 5;
						 do N=1  to 1000;
							 PRODUCT_CATEGORY_CD=node_%eval(&i);
				
			 		   rc=h.find();
					    if rc=0  then  
						do;
					       if LOAD_END_DTTM=dt  then  
						   do;
						   		node_%eval(&i)_desc=PRODUCT_CATEGORY_DESC;
			 			   end;
					    end;
					   else  if rc ne 0  then
					   leave;
						 end;
			   %end;
			drop 
			N 
			rc  
			LOAD_END_DTTM
			;
			run;
			 
			data martscr.Fpc_ext1; 
			set martscr.Fpc_ext1;
				drop n;
			run;

%mend;

proc sql noprint;
		create table martscr.pca_ext1 as select *, 
		CASE WHEN PCA_EXT.PARENT_PRODUCT_CATEGORY_CD   
		IN(&REV_ASSET_PRD_CAT_TYPE,&NRV_ASSET_PRD_CAT_TYPE) 
		THEN &PRODUCT_CLASS_ASSET  WHEN 
		PCA_EXT.PARENT_PRODUCT_CATEGORY_CD  
		IN  (&TDL_LIABILITY_PRD_CAT_TYPE,&DDL_LIABILITY_PRD_CAT_TYPE) 
		THEN &PRODUCT_CLASS_LIABILITY  
		ELSE  '' END as PRODUCT_CLASS_CD
		from martscr.pca_ext
		;
quit;

%macro check_create;
/* This macro checks the records in PCA_EXT1 i.e. the Product Category Hierarchy
records. If there are no records in this table, the macro creates only the structure.
Else it calls the flatten macro and creates the table and populates the hierarchy data */

proc sql;
select count(*) into :rec_cnt from martscr.pca_ext1;
quit;

%if &rec_cnt > 0 %then
%do;
		%flatten(
		library_nm=martscr,
		table_nm=pca_ext1,
		Parent_col_nm=PARENT_PRODUCT_CATEGORY_CD,
		child_col_nm=PRODUCT_CATEGORY_CD,
		filter=PRODUCT_CATEGORY_ASSOC_TYPE_CD in (&PR_ASSOC_TYPE_REP.),
		additional_col=PRODUCT_CATEGORY_ASSOC_TYPE_CD#PRODUCT_CLASS_CD#PARENT_PRODUCT_CATEGORY_CD
		);

		%create_hier; 

		data  martscr.FP_ALL_LVLS ;
		set martscr.FP_ALL_LVLS;
		rename  
		node_1=PRODUCT_CAT_LEVEL_1_CD
		node_2=PRODUCT_CAT_LEVEL_2_CD
		node_3=PRODUCT_CAT_LEVEL_3_CD
		node_4=PRODUCT_CAT_LEVEL_4_CD
		node_5=PRODUCT_CAT_LEVEL_5_CD
		node_1_desc=PRODUCT_CAT_LEVEL_1_DESC
		node_2_desc=PRODUCT_CAT_LEVEL_2_DESC
		node_3_desc=PRODUCT_CAT_LEVEL_3_DESC
		node_4_desc=PRODUCT_CAT_LEVEL_4_DESC
		node_5_desc=PRODUCT_CAT_LEVEL_5_DESC
		PARENT_PRODUCT_CATEGORY_CD=PRODUCT_SUB_CLASS_CD
		;
		run;
%end;
%else
	%do;
			proc sql;
				create table MARTSCR.FP_ALL_LVLS
				  (
				   PRODUCT_CAT_LEVEL_1_CD char(3) label='Parent Product Category Code',
				   LOAD_END_DTTM num format=NLDATM21. informat=NLDATM21.,
				   PRODUCT_CAT_LEVEL_1_DESC char(100) label='Product Category Description',
				   PRODUCT_CAT_LEVEL_2_CD char(3) label='Parent Product Category Code',
				   PRODUCT_CAT_LEVEL_2_DESC char(100) label='Product Category Description',
				   PRODUCT_CAT_LEVEL_3_CD char(3) format=$8. label='Parent Product Category Code',
				   PRODUCT_CAT_LEVEL_3_DESC char(100) label='Product Category Description',
				   PRODUCT_CAT_LEVEL_4_CD char(3) label='Parent Product Category Code',
				   PRODUCT_CAT_LEVEL_4_DESC char(100) label='Product Category Description',
				   PRODUCT_CAT_LEVEL_5_CD char(3) label='Parent Product Category Code',
				   PRODUCT_CAT_LEVEL_5_DESC char(100) label='Product Category Description',
				   PRODUCT_CLASS_CD char(3),
				   PRODUCT_SUB_CLASS_CD char(3)
				  );
			quit;
	%end;
%mend;

%check_create;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QR * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP0004U1 * 
 *                 martscr.FP_ALL_LVLS                                        * 
 * Target Table:  FP_ALL_LVLS - martscr.FP_ALL_LVLS         A5V75JN3.BE0000Q2 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043R * 
 *                                                                            * 
 * User Written:  index PRODUCT_CATEGORY_CD &               A5V75JN3.AF000MZV * 
 *                 LOAD_END_DTTM                                              * 
 *                 index PRODUCT_CATEGORY_CD & LOAD_END_DTTM                  * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 


/*creating index on PRODUCT_CAT_LEVEL_1_CD  & LOAD_END_DTTM column */
PROC SQL NOPRINT;
           CREATE INDEX  PRODUCT_CAT_LEVEL_1_CD_L 
            ON martscr.FP_ALL_LVLS (PRODUCT_CAT_LEVEL_1_CD,LOAD_END_DTTM );
QUIT;
 


/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

