/****************************************************************************** 
 * Job:           ICAD_EXT                                  A5V75JN3.BN000022 * 
 * Description:   This job picks up data from INDIVIDUAL_CUSTOMER_ADDRESS     * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                INDIVIDUAL_CUSTOMER_ADDRESS -             A5V75JN3.BE000045 * 
 *                 DDS.INDIVIDUAL_CUSTOMER_ADDRESS                            * 
 * Target Table:  ICAD_EXT - martscr.ICAD_EXT               A5V75JN3.BE0000K0 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:39:33 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * ICAD_EXT                                                                   * 
 * Job Name: ICAD_EXTJob Desc Pre Process: NoneMain:Extract and load data     * 
 * from INDIVIDUAL_CUSTOMER_ADDRESS using a SQL join with table               * 
 * LOAD_CONTROL based on conditionLOAD_CONTROL.LOAD_FLG = CHECK_FLAG_TRUE     * 
 * andLOAD_CONTROL.RUN_STATUS = RUNNING_STATUS                                * 
 * andLOAD_CONTROL.LOAD_END_DTTM betweenVALID_FROM_DTTM and                   * 
 * VALID_TO_DTTMPost Process: Index is created                                * 
 * onICAD_EXT.CUSTOMER_RK,ICAD_EXT.LOAD_END_DTTMParameters: CHECK_FLAG_TRUE   * 
 * and RUNNING_STATUS are the user defined parameters. CHECK_FLAG_TRUE is     * 
 * set to 'Y' and RUNNING_STATUS is to 'Running' for each month of data       * 
 *  load.Developed by: sinahkReviewed by:Tested by:                           * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ICAD_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY0004OO * 
 *                                                                            * 
 * User Written:  Oracle Date Problem Fix                   A5V75JN3.AF000PW0 * 
 *                Oracle Date Problem Fix                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc contents data=dds.individual_customer_address out=_etlsEngine(keep=Engine) noprint;
run;

data _null_;
	set _etlsEngine;
	if _n_=1;
	  call symput('mEngine', kleft(kright(Engine)));
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Extracting and Loading of data as per the A5V75JN3.BO0006ZO * 
 *                 load period                                                * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Join with LOAD_CONTROL table and extract appropriate data   * 
 *                 based  onVALID_FROM_DTTM and VALID_TO_DTTM                 * 
 *                                                                            * 
 * Source Tables: LOAD_CONTROL - control.LOAD_CONTROL       A5V75JN3.BE0000I0 * 
 *                INDIVIDUAL_CUSTOMER_ADDRESS -             A5V75JN3.BE000045 * 
 *                 DDS.INDIVIDUAL_CUSTOMER_ADDRESS                            * 
 * Target Table:  SQL Target - martscr.ICAD_EXT             A5V75JN3.BP000672 * 
 *============================================================================*/ 

/* Access the data for Control  */ 
LIBNAME control BASE "Data/bisdata/control" ;
%rcSet(&syslibrc); 

/* Access the data for Detail Data Store  */ 
LIBNAME DDS BASE "Data/bisdata/dds" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete ICAD_EXT;
quit;

proc sql;
   create table martscr.ICAD_EXT as
      select
         LOAD_CONTROL.LOAD_END_DTTM length = 8
                                    format = NLDATM21.
                                    informat = NLDATM21.
                                    label = "Load End Datetime",
         INDIVIDUAL_CUSTOMER_ADDRESS.CUSTOMER_ADDRESS_RK length = 8
                                                         format = 12.
                                                         informat = 12.
                                                         label = "Customer Address Key",
         INDIVIDUAL_CUSTOMER_ADDRESS.CUSTOMER_ADDRESS_ID length = 32
                                                         label = "Customer Address ID",
         INDIVIDUAL_CUSTOMER_ADDRESS.CUSTOMER_RK length = 8
                                                 format = 12.
                                                 informat = 12.
                                                 label = "Customer Key",
         INDIVIDUAL_CUSTOMER_ADDRESS.ADDRESS_TYPE_CD length = 3
                                                     label = "Address Type Code",
         INDIVIDUAL_CUSTOMER_ADDRESS.ADDRESS_LINE_1_TXT length = 100
                                                        label = "Address Line 1",
         INDIVIDUAL_CUSTOMER_ADDRESS.ADDRESS_LINE_2_TXT length = 100
                                                        label = "Address Line 2",
         INDIVIDUAL_CUSTOMER_ADDRESS.ADDRESS_LINE_3_TXT length = 100
                                                        label = "Address Line 3",
         INDIVIDUAL_CUSTOMER_ADDRESS.ADDRESS_LINE_4_TXT length = 100
                                                        label = "Address Line 4",
         INDIVIDUAL_CUSTOMER_ADDRESS.STATE_REGION_CD as CUSTOMER_STATE_REGION_CD length = 4
                                                                                 label = "State Region Code",
         INDIVIDUAL_CUSTOMER_ADDRESS.CITY_NM as CUSTOMER_CITY_NM length = 100
                                                                 label = "City Name",
         INDIVIDUAL_CUSTOMER_ADDRESS.DISTRICT_NM length = 40
                                                 label = "District Name",
         INDIVIDUAL_CUSTOMER_ADDRESS.POSTAL_CD as CUSTOMER_POSTAL_CD length = 20
                                                                     label = "Postal Code",
         INDIVIDUAL_CUSTOMER_ADDRESS.COUNTRY_CD as CUSTOMER_COUNTRY_CD length = 3
                                                                       label = "Country Code",
         INDIVIDUAL_CUSTOMER_ADDRESS.NON_PHYSICAL_ADDRESS_FLG length = 1
                                                              label = "Non Physical Address Flag",
         INDIVIDUAL_CUSTOMER_ADDRESS.DELIVERY_POINT_SUFFIX_CD length = 3
                                                              label = "Delivery Point Suffix Code",
         INDIVIDUAL_CUSTOMER_ADDRESS.ADDRESS_QUALITY_CD length = 3
                                                        label = "Address Quality Code",
         INDIVIDUAL_CUSTOMER_ADDRESS.MAIL_ROUTE_NUM_TXT length = 20
                                                        label = "Mail Route Number",
         CASE symget('mEngine')
         	WHEN "ORACLE" THEN datepart(INDIVIDUAL_CUSTOMER_ADDRESS.EFFECTIVE_DT)
         	ELSE INDIVIDUAL_CUSTOMER_ADDRESS.EFFECTIVE_DT
         END as EFFECTIVE_DT length = 8
                             format = NLDATE10.
                             informat = NLDATE10.
                             label = "Effective Date"
      from
         control.LOAD_CONTROL, 
         DDS.INDIVIDUAL_CUSTOMER_ADDRESS
      where
         LOAD_CONTROL.LOAD_FLG IN (&CHECK_FLAG_TRUE)
         and LOAD_CONTROL.RUN_STATUS IN (&RUNNING_STATUS)
         and LOAD_CONTROL.LOAD_END_DTTM >= INDIVIDUAL_CUSTOMER_ADDRESS.VALID_FROM_DTTM
         and LOAD_CONTROL.LOAD_END_DTTM <= INDIVIDUAL_CUSTOMER_ADDRESS.VALID_TO_DTTM
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0006ZN * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.ICAD_EXT             A5V75JN3.BP000672 * 
 * Target Table:  ICAD_EXT - martscr.ICAD_EXT               A5V75JN3.BE0000K0 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY0004OP * 
 *                                                                            * 
 * User Written:  Index creation code on CUSTOMER_RK &      A5V75JN3.AF000PW1 * 
 *                 LOAD_END_DTTM column                                       * 
 *                Index creation code on CUSTOMER_RK & LOAD_END_DTTM column   * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on CUSTOMER_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
           CREATE INDEX CUSTOMER_RK_LOAD_END_DTTM
            ON martscr.ICAD_EXT(CUSTOMER_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

