/****************************************************************************** 
 * Job:           IO_ALL_LVLS                               A5V75JN3.BN00007H * 
 * Description:   This job loads the target table with data for all levels    * 
 *                 from table IOA_EXT.                                        * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  IOA_EXT - martscr.IOA_EXT                 A5V75JN3.BE0000K4 * 
 * Target Table:  IO_ALL_LVLS - martscr.IO_ALL_LVLS         A5V75JN3.BE0000Q5 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:40:34 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * IO_ALL_LVLS                                                                * 
 * Job Name: IO_ALL_LVLSJob Desc: This job loads the target table with data   * 
 * for all levelsPre Process: Creating format ot obtain org level             * 
 * rk.parameter One parameter is been used while creating formats in the      * 
 * where clause of the fmt_gen macro is IO_ASSOC_TYPEMain: Extracting data    * 
 * for all IO levela) INTERNAL_ORG_RK is assigned as INTERNAL_ORG_RK .And     * 
 * PARENT_INTERNAL_ORG_RK is ORG_LEVEL_1_RK where                             * 
 * INTERNAL_ORG_ASSOC_TYPE_CD IN (&IO_ASSOC_TYPE)b)ORG_LEVEL_1_RK is          * 
 * assigned as ORG_LEVEL_1_RKand ORG_LEVEL_2_RK is obtain by applying         * 
 * informat IO_LVL onORG_LEVEL_1_RKc) ORG_LEVEL_2_RK is assigned as           * 
 * ORG_LEVEL_2_RKand ORG_LEVEL_3_RK is obtain by applying informat IO_LVL     * 
 * onthe ORG_LEVEL_2_RKd) ORG_LEVEL_3_RK is assigned as ORG_LEVEL_3_RKand     * 
 * ORG_LEVEL_4_RK is obtain by applying informat IO_LVL onthe                 * 
 * ORG_LEVEL_3_RKe) ORG_LEVEL_4_RK is assigned as ORG_LEVEL_4_RK and          * 
 * ORG_LEVEL_5_RK is obtain by applying informat IO_LVL onthe                 * 
 * ORG_LEVEL_4_RK.f) Adjusting the values of columns                          * 
 * INTERNAL_ORG_RK,ORG_LEVEL_1_RK ,ORG_LEVEL_2_RK ,ORG_LEVEL_3_RK             * 
 * ,ORG_LEVEL_4_RK in the dataset "IO_ALL_LVLS" to support proper drilldown   * 
 * in reportingPost Process: creating index on INTERNAL_ORG_RK                * 
 * columnParameters: a) IO_ASSOC_TYPE: Parameter to specify which             * 
 * association to be selected while creating Internal Organization            * 
 *  DimensionDeveloped by: sinharReviewed by: sinpepTested by:                * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN00007H);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = IO_ALL_LVLS;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Adjusting the values of columns           A5V75JN3.BO0005QW * 
 * Transform:     User Written Code                                           * 
 * Description:   Adjusting the values of columns to support proper           * 
 *                 drilldown in reporting.                                    * 
 *                                                                            * 
 * Source Table:  IOA_EXT - martscr.IOA_EXT                 A5V75JN3.BE0000K4 * 
 * Target Table:  User Written Code Target -                A5V75JN3.BP0004U3 * 
 *                 martscr.IO_ALL_LVLS                                        * 
 *                                                                            * 
 * User Written:  Adjusting the values of columns           A5V75JN3.AF000N03 * 
 *                Adjusting the values of columns                             * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.IOA_EXT); 

%let transformID = %quote(A5V75JN3.BO0005QW); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.IO_ALL_LVLS); 

/*---- Start of User Written Code  ----*/ 

/* Start of CS4.3 HF2 */ 
/* This code has been modified as a part of CS4.3 HF2. 
The code modification is done for to take care of loading Internal Org dimension
even if the internal org association records i.e. the internal org hierarchy 
records are not present. */

options mlogic mprint;

%macro create_hier;
	proc sort data=martscr.io_ext out=martscr.io_ext1(Drop=
														SOURCE_SYSTEM_CD
														ORGANIZATION_DESC
														ORGANIZATION_TYPE_CD
														LEGAL_ENTITY_FLG
														LINE_OF_BUSINESS_NM
														MANAGING_EMPLOYEE_RK
														ADDRESS_LINE_1_TXT
														ADDRESS_LINE_2_TXT
														ADDRESS_LINE_3_TXT
														ADDRESS_LINE_4_TXT
														CITY_NM
														POSTAL_CD
														STATE_REGION_CD
														COUNTY_NM
														COUNTRY_CD
														BOOK_OF_RECORD_CURRENCY_CD
														REPORTING_CURRENCY_CD
														EXTERNAL_TRADER_FLG
														DIVISION_TYPE_CD
														EFFECTIVE_FROM_DTTM
														EFFECTIVE_TO_DTTM
														COST_CENTER_RK
														);
		 by INTERNAL_ORG_RK LOAD_END_DTTM;
		run;
		
		data martscr.io_ext1;
		   set martscr.io_ext1;
		   by INTERNAL_ORG_RK LOAD_END_DTTM;
		   retain N 1;
		   if first.INTERNAL_ORG_RK=1 then N=1;
		   else N+1;
		run;
		
		 
		
		data martscr.IO_ALL_LVLS(rename=(dt=LOAD_END_DTTM ));
		   if 0 then set martscr.io_ext1;
		
		   if _N_=1 then do;
		      declare hash h(dataset:"martscr.io_ext1",hashexp:16);
			  h.defineKey("INTERNAL_ORG_RK",'N');
			  h.definedata("ORGANIZATION_NM","INTERNAL_ORG_ID","LOAD_END_DTTM");
			  h.definedone();
			  call missing(INTERNAL_ORG_RK,ORGANIZATION_NM,INTERNAL_ORG_ID,N,LOAD_END_DTTM);
			end;
		
			set node_1;
		
			%do i=1 %to 5;
				 do N=1  to 1000;
		
						 INTERNAL_ORG_RK=node_%eval(&i);
			
		 		   rc=h.find();
				    if rc=0  then  
					do;
				       if LOAD_END_DTTM=dt  then  
					   do;
		/*		  		     node_%eval(&i)_NM=&req_col_nm.; */
		/*			        node_%eval(&i)nm=ORGANIZATION_NM*/
					   		ORG_LEVEL_%eval(&i)_NM=ORGANIZATION_NM;
							ORG_LEVEL_%eval(&i)_ID=INTERNAL_ORG_ID;
					   		
		 			   end;
				    end;
				   else  if rc ne 0  then
				   leave;
				end;
			 %end;
		 		
		/**/
			drop 
		   	N 
		INTERNAL_ORG_RK
		node_2
		node_3
		node_4
		node_5
		INTERNAL_ORG_ID
		ORGANIZATION_NM
		   	rc  
		LOAD_END_DTTM
			;
		run;
		 
		data martscr.io_ext1; 
		set martscr.io_ext1;
			drop n;
		run;
		
%mend;


/* Call the macro flatten to flatten the hierarchy */
data martscr.Ioa_ext1;
set martscr.Ioa_ext;
run;

%macro check_create;
/* This macro checks the records in IOA_EXT i.e. the Internal Org Hierarchy
records. If there are no records in this table, the macro creates only the structure.
Else it calls the flatten macro and creates the table and populates the hierarchy data */

proc sql;
select count(*) into :rec_cnt from martscr.Ioa_ext1;
quit;

%if &rec_cnt > 0 %then
%do;
		%flatten(
		library_nm=martscr,
		table_nm=Ioa_ext1,
		Parent_col_nm=PARENT_INTERNAL_ORG_RK,
		child_col_nm=INTERNAL_ORG_RK,
		filter=INTERNAL_ORG_ASSOC_TYPE_CD IN (&IO_ASSOC_TYPE),
		additional_col=INTERNAL_ORG_ASSOC_TYPE_CD
		);
		
		%create_hier;
		
		data martscr.IO_ALL_LVLS;
			rename node_1=INTERNAL_ORG_RK;
			set martscr.IO_ALL_LVLS;
		run;
%end;

%else
%do;
	proc sql;	
		create table MARTSCR.IO_ALL_LVLS
		  (
		   INTERNAL_ORG_RK num format=12. informat=12. label='Internal Organization Retained Key',
		   LOAD_END_DTTM num format=NLDATM21. informat=NLDATM21. label='Load End Datetime',
		   INTERNAL_ORG_ASSOC_TYPE_CD char(3) label='Internal Organization Association Type Code',
		   ORG_LEVEL_1_ID char(32) format=$32. informat=$32. label='_Id',
		   ORG_LEVEL_1_NM char(40) format=$40. informat=$40.,
		   ORG_LEVEL_2_ID char(32) format=$32. informat=$32. label='_Id',
		   ORG_LEVEL_2_NM char(40) format=$40. informat=$40.,
		   ORG_LEVEL_3_ID char(32) format=$32. informat=$32. label='_Id',
		   ORG_LEVEL_3_NM char(40) format=$40. informat=$40.,
		   ORG_LEVEL_4_ID char(32) format=$32. informat=$32. label='_Id',
		   ORG_LEVEL_4_NM char(40) format=$40. informat=$40.,
		   ORG_LEVEL_5_ID char(32) format=$32. informat=$32. label='_Id',
		   ORG_LEVEL_5_NM char(40) format=$40. informat=$40.
		  );
	quit;
%end;
%mend;
%check_create;
/* End of CS4.3 HF2 */

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005QV * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A5V75JN3.BP0004U3 * 
 *                 martscr.IO_ALL_LVLS                                        * 
 * Target Table:  IO_ALL_LVLS - martscr.IO_ALL_LVLS         A5V75JN3.BE0000Q5 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00043U * 
 *                                                                            * 
 * User Written:  creating  index INTERNAL_ORG_RK           A5V75JN3.AF000N05 * 
 *                creating  index INTERNAL_ORG_RK                             * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on INTERNAL_ORG_RK & LOAD_END_DTTM column */
PROC SQL NOPRINT;
           CREATE INDEX  INTERNAL_ORG_RK_LOAD_END_DTTM
            ON martscr.IO_ALL_LVLS (INTERNAL_ORG_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

