/****************************************************************************** 
 * Job:           MOD_VAR_GRP                               A5V75JN3.BN0000W2 * 
 * Description:   This job picks up data from VARIABLE_GROUPS_SCORE,          * 
 *                 ANALYTICAL_MODEL_DIM_EXT and SCORE_CARD_VARIABLE_DIM.      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: VARIABLE_GROUPS_MODEL -                   A5V75JN3.BE0000W5 * 
 *                 martscr.VARIABLE_GROUPS_MODEL                              * 
 *                SCORE_CARD_VARIABLE_DIM -                 A5V75JN3.BE0000WM * 
 *                 dim.SCORE_CARD_VARIABLE_DIM                                * 
 * Target Tables: MOD_VAR_GRP_EXP - facterr.MOD_VAR_GRP_EXP A5V75JN3.BE0000WC * 
 *                MOD_VAR_GRP - martscr.MOD_VAR_GRP         A5V75JN3.BE0000WB * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:44:57 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN0000W2);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = MOD_VAR_GRP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Lookup to obtain variable_sk              A5V75JN3.BO0005O1 * 
 * Transform:     Lookup                                                      * 
 * Description:   Lookup to obtain variable_sk by looking up on               * 
 *                 SCORE_CARD_VARIABLE_DIM                                    * 
 *                                                                            * 
 * Source Tables: VARIABLE_GROUPS_MODEL -                   A5V75JN3.BE0000W5 * 
 *                 martscr.VARIABLE_GROUPS_MODEL                              * 
 *                SCORE_CARD_VARIABLE_DIM -                 A5V75JN3.BE0000WM * 
 *                 dim.SCORE_CARD_VARIABLE_DIM                                * 
 * Target Tables: Exception WorkTable -                     A5V75JN3.BP0004SJ * 
 *                 facterr.MOD_VAR_GRP_EXP                                    * 
 *                Lookup Target - martscr.MOD_VAR_GRP       A5V75JN3.BP0004SK * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for Lookup Error Tables  */ 
LIBNAME facterr BASE "Data/bisdata/error" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005O1); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete MOD_VAR_GRP;
quit;

proc datasets lib = facterr nolist nowarn memtype = (data view);
   delete MOD_VAR_GRP_EXP;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.MOD_VAR_GRP
         (keep = MODEL_SK VARIABLE_SK VARIABLE_GROUP_NO VARIABLE_GROUP_LABEL 
                 SCORE_CARD_POINTS)
      facterr.MOD_VAR_GRP_EXP 
         (keep = etls_source_row etls_lookup_table etls_exception_cond 
                 etls_exception_action VARIABLE_GROUP_NO VARIABLE_GROUP_LABEL 
                 SCORE_CARD_POINTS MODEL_SK VARIABLE_NAME)
      ; 
   
   attrib MODEL_SK length=8
          VARIABLE_SK length=8 format=12. label="_RKorSK"
          VARIABLE_GROUP_NO length=8
          VARIABLE_GROUP_LABEL length=$100
          SCORE_CARD_POINTS length=8
          ; 
   
   length etls_lookup_table $41 etls_exception_cond etls_exception_action $32 
   VARIABLE_NAME $100 ; 
   
   retain missing0 0 ; 
   
   /* Assign variables used for error/exception handling  */ 
   etls_source_row      = _n_;
   request_write_target = 0; 
   request_write_error  = 0; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table dim.SCORE_CARD_VARIABLE_DIM */ 
      nlobs = .; 
      dsid = open("dim.SCORE_CARD_VARIABLE_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "dim.SCORE_CARD_VARIABLE_DIM", hashexp: exponent);
            h0.defineKey( "VARIABLE_NAME");
            h0.defineData( "VARIABLE_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.SCORE_CARD_VARIABLE_DIM";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " dim.SCORE_CARD_VARIABLE_DIM";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.SCORE_CARD_VARIABLE_DIM";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " dim.SCORE_CARD_VARIABLE_DIM";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.SCORE_CARD_VARIABLE_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.SCORE_CARD_VARIABLE_DIM";
         
         abort 3; 
      end; 
      
      call missing (VARIABLE_NAME, VARIABLE_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.VARIABLE_GROUPS_MODEL end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find();
   
   /* Examine success of lookups  */ 
   if (rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output martscr.MOD_VAR_GRP; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "dim.SCORE_CARD_VARIABLE_DIM"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output facterr.MOD_VAR_GRP_EXP; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005O0 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Lookup Target - martscr.MOD_VAR_GRP       A5V75JN3.BP0004SK * 
 * Target Table:  MOD_VAR_GRP - martscr.MOD_VAR_GRP         A5V75JN3.BE0000WB * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

/*============================================================================* 
 * Step:          Table Loader                              A5V75JN3.BO0005NZ * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Exception WorkTable -                     A5V75JN3.BP0004SJ * 
 *                 facterr.MOD_VAR_GRP_EXP                                    * 
 * Target Table:  MOD_VAR_GRP_EXP - facterr.MOD_VAR_GRP_EXP A5V75JN3.BE0000WC * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(facterr.MOD_VAR_GRP_EXP); 

%let transformID = %quote(A5V75JN3.BO0005NZ); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.MOD_VAR_GRP_EXP, DATA)) or 
            %sysfunc(exist(facterr.MOD_VAR_GRP_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.MOD_VAR_GRP_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(MOD_VAR_GRP_EXP);
   %let etls_lib   = %nrquote(Lookup Error Tables);
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(facterr.MOD_VAR_GRP_EXP, DATA)) or 
         %sysfunc(exist(facterr.MOD_VAR_GRP_EXP, VIEW))); 
   
   /* Check for and remove foreign keys before deleting table */ 
   %if &etls_tableExist %then 
   %do; /* table exists */
      %macro etls_CIContents(table=,workTableOut=);
         %put NOTE: Building table listing Constraints and Indexes for: &table;
         proc datasets lib=work nolist; delete &workTableOut; quit;
         proc contents data=&table noprint out2=&workTableOut; run;
         data &workTableOut;
            length name $60 type $20 icown idxUnique idxNoMiss $3 recreate $600;
            set &workTableOut;
            if ICOwn ne 'YES';
         run;
         %rcSet(&syserr); 
         
      %mend etls_CIContents;
      
      %etls_CIContents(table=facterr.MOD_VAR_GRP_EXP, workTableOut=etls_commands);
      
      data etls_commands; 
         set etls_commands(where=(upcase(type)="FOREIGN KEY")) end=eof; 
         command='ic delete '||trim(name)||';';
      run; 
      
      data _null_;
         set etls_commands(where=(1)) end=eof;
         if _n_=1 then 
            call execute('proc datasets nolist lib=facterr;modify MOD_VAR_GRP_EXP;');
         call execute(command);
         if eof then call execute('; quit;');
      run;
      %rcSet(&syserr); 
      
   %end; /* table exists */ 
   
   /*---- Drop a table  ----*/ 
   %put %str(NOTE: Dropping table ...);
   proc datasets lib = facterr nolist nodetails;
        delete MOD_VAR_GRP_EXP;
   quit;
   
   %rcSet(&syserr); 
   
   %let etls_tableExist = 0;
   
   /*---- Create a new table  ----*/ 
   data facterr.MOD_VAR_GRP_EXP
           (label = 'MOD_VAR_GRP_EXP');
      attrib etls_source_row length = 8
                label = 'The row number in the source table'; 
      attrib etls_lookup_table length = $41
                label = 'The name of the lookup table'; 
      attrib etls_exception_cond length = $32
                label = 'The name of the condition that caused this exception'; 
      attrib etls_exception_action length = $32
                label = 'The name of the action to take for this exception'; 
      attrib VARIABLE_GROUP_NO length = 8; 
      attrib VARIABLE_GROUP_LABEL length = $100; 
      attrib SCORE_CARD_POINTS length = 8; 
      attrib MODEL_SK length = 8 format = 12. informat = 12.
                label = 'Surrogate key for the analytical model dimension.'; 
      attrib VARIABLE_NAME length = $100; 
      stop;
   run;
   
   %rcSet(&syserr); 
   
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=facterr nolist;
      modify MOD_VAR_GRP_EXP;
         ic create not null (etls_source_row);
         ic create not null (etls_lookup_table);
         ic create not null (etls_exception_cond);
         ic create not null (etls_exception_action);
   quit;
   
   %rcSet(&syserr); 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   proc append base = facterr.MOD_VAR_GRP_EXP 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.MOD_VAR_GRP_EXP, DATA)) or 
            %sysfunc(exist(facterr.MOD_VAR_GRP_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.MOD_VAR_GRP_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

