/****************************************************************************** 
 * Job:           MOD_VAR_GRP_SCR                           A5V75JN3.BN0000W3 * 
 * Description:   This job picks up data from MOD_VAR_GRP and MOD_VAR_SCR.    * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: MOD_VAR_GRP - martscr.MOD_VAR_GRP         A5V75JN3.BE0000WB * 
 *                MOD_VAR_SCR - martscr.MOD_VAR_SCR         A5V75JN3.BE0000WE * 
 * Target Table:  MOD_VAR_GRP_SCR - martscr.MOD_VAR_GRP_SCR A5V75JN3.BE0000WD * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:44:58 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN0000W3);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = MOD_VAR_GRP_SCR;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain the average score and default   A5V75JN3.BO0005O3 * 
 *                 count of variables                                         * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   To obtain the average score and default count of variables  * 
 *                by joining MOD_VAR_GRP and MOD_VAR_SCR on MODEL_SK,         * 
 *                 VARIABLE_SK and VARIABLE_GROUP_NO.                         * 
 *                                                                            * 
 * Source Tables: MOD_VAR_GRP - martscr.MOD_VAR_GRP         A5V75JN3.BE0000WB * 
 *                MOD_VAR_SCR - martscr.MOD_VAR_SCR         A5V75JN3.BE0000WE * 
 * Target Table:  SQL Target - martscr.MOD_VAR_GRP_SCR      A5V75JN3.BP0004SL * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO0005O3); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete MOD_VAR_GRP_SCR;
quit;

proc sql;
   create table martscr.MOD_VAR_GRP_SCR as
      select
         MOD_VAR_GRP.MODEL_SK length = 8
                              format = 12.
                              informat = 12.
                              label = "Surrogate key for the analytical model dimension.",
         MOD_VAR_GRP.VARIABLE_SK length = 8
                                 format = 12.
                                 informat = 12.
                                 label = "_RKorSK",
         MOD_VAR_GRP.VARIABLE_GROUP_NO length = 8,
         MOD_VAR_GRP.VARIABLE_GROUP_LABEL length = 100,
         MOD_VAR_GRP.SCORE_CARD_POINTS length = 8,
         MOD_VAR_SCR.ACCOUNT_CNT length = 8,
         MOD_VAR_SCR.AVERAGE_SCORE length = 8,
         MOD_VAR_SCR.DEFAULT_CNT length = 8
      from
         martscr.MOD_VAR_GRP left join 
         martscr.MOD_VAR_SCR
            on
            (
               MOD_VAR_GRP.MODEL_SK = MOD_VAR_SCR.MODEL_SK
               and MOD_VAR_GRP.VARIABLE_SK = MOD_VAR_SCR.VARIABLE_SK
               and MOD_VAR_GRP.VARIABLE_GROUP_NO = MOD_VAR_SCR.VARIABLE_GROUP_NO
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005O2 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.MOD_VAR_GRP_SCR      A5V75JN3.BP0004SL * 
 * Target Table:  MOD_VAR_GRP_SCR - martscr.MOD_VAR_GRP_SCR A5V75JN3.BE0000WD * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

