/****************************************************************************** 
 * Job:           MOD_VAR_SCR                               A5V75JN3.BN0000W4 * 
 * Description:   This job picks up data from ACCT_MOD_VAR_SCR.               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  ACCT_MOD_VAR_SCR -                        A5V75JN3.BE0000W9 * 
 *                 martscr.ACCT_MOD_VAR_SCR                                   * 
 * Target Table:  MOD_VAR_SCR - martscr.MOD_VAR_SCR         A5V75JN3.BE0000WE * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:44:58 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN0000W4);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = MOD_VAR_SCR;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To compute the average score and default  A5V75JN3.BO0005O5 * 
 *                 count of variables                                         * 
 * Transform:     Extract                                                     * 
 * Description:   To compute the average score and default count of           * 
 *                variables from ACCT_MOD_VAR_SCR by grouping on MODEL_SK,    * 
 *                 VARIABLE_SK and VARIABLE_GROUP_NO                          * 
 *                                                                            * 
 * Source Table:  ACCT_MOD_VAR_SCR -                        A5V75JN3.BE0000W9 * 
 *                 martscr.ACCT_MOD_VAR_SCR                                   * 
 * Target Table:  Extract Target - martscr.MOD_VAR_SCR      A5V75JN3.BP0004SM * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.ACCT_MOD_VAR_SCR); 

%let transformID = %quote(A5V75JN3.BO0005O5); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete MOD_VAR_SCR;
quit;

proc sql; 
   create table martscr.MOD_VAR_SCR as 
      select MODEL_SK length = 8,
             VARIABLE_SK length = 8 label = '_RKorSK',
             VARIABLE_GROUP_NO length = 8,
             (AVG(SCORE_POINTS)) as AVERAGE_SCORE length = 8,
             (SUM(TGT_VAR)) as DEFAULT_CNT length = 8,
             (COUNT(ACCOUNT_RK)) as ACCOUNT_CNT length = 8
         from &SYSLAST
         group by MODEL_SK, VARIABLE_SK, VARIABLE_GROUP_NO; 
quit;

%let SYSLAST = martscr.MOD_VAR_SCR; 

%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005O4 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract Target - martscr.MOD_VAR_SCR      A5V75JN3.BP0004SM * 
 * Target Table:  MOD_VAR_SCR - martscr.MOD_VAR_SCR         A5V75JN3.BE0000WE * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
