/****************************************************************************** 
 * Job:           MasterLoopCreditScoringJob                A5V75JN3.BN0000RV * 
 * Description:                                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  PARAMETER_LIST_CREDIT_SCORING -           A5V75JN3.BE0000RT * 
 *                 control.PARAMETER_LIST_CREDIT_SCORING                      * 
 *                                                                            * 
 * Generated on:  Saturday, December 27, 2008 3:35:47 PM IST                  * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A5V75JN3.AY000400 * 
 *                                                                            * 
 * User Written:  Log the start of job                      A5V75JN3.AF000MI1 * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

 
%macro initial_verify;

/* If the MULTI_MONTH_LOAD parameter is set equal to the solution
 loop job will abort. This is because solution jobs can not be run 
 for multiple months load.*/

%if &MULTI_MONTH_LOAD. eq &CHECK_FLAG_TRUE. %then %do;
   %put &SOLUTION_ERROR;
   %abort ABEND;
%end;

/* If the earlier run of this job had some errors, this code updates the return_code to '.'.
This is done so that the erroneous jobs are run again. */
/* return_cd value in the &status_table is greater than 4 in case of errors. 
Customise this statement, if the even the warnings should not be allowed. */

proc sql;
		update &status_table.
		set return_cd = .
		where return_cd > 4;
quit;

%mend;
options symbolgen;

proc printto log='Data/bisdata/log/schedule_credit_scoring/MasterLoopCreditScoringJob.log';
run;

%let status_table=control.PARAMETER_LIST_CREDIT_SCORING;
%initial_verify;

options nosymbolgen;
proc printto ;
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          SQL Join                                  A5V75JN3.BO0005MA * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  PARAMETER_LIST_CREDIT_SCORING -           A5V75JN3.BE0000RT * 
 *                 control.PARAMETER_LIST_CREDIT_SCORING                      * 
 * Target Table:  SQL Target - work.W5D8EMYG                A5V75JN3.BP0004RB * 
 *============================================================================*/ 

/* Access the data for Control  */ 
LIBNAME control BASE "Data/bisdata/control" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(control.PARAMETER_LIST_CREDIT_SCORING); 

%let trans_rc = 0; 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5D8EMYG;
quit;

proc sql;
   create table work.W5D8EMYG as
      select distinct
         PARAMETER_LIST_CREDIT_SCORING.LEVEL_NO as master_level_no length = 8
      from
         control.PARAMETER_LIST_CREDIT_SCORING
      order by
         master_level_no
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Loop                                      A5V75JN3.BR00033W * 
 * Transform:     Loop                                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - work.W5D8EMYG                A5V75JN3.BP0004RB * 
 * Target Table:  Status Table - work.W5AR0VBB              A5V75JN3.BP0004RC * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(work.W5D8EMYG); 

%let trans_rc = 0; 

%macro etls_getHandle(statusTable=, handleVariable=, row=); 
   %let etls_dsid = %sysfunc(open(&statusTable)); 
   %if (&etls_dsid = 0) %then 
      %put %sysfunc(sysmsg()); 
   %else 
   %do; 
      %let rc = %sysfunc(fetchobs(&etls_dsid, &row)); 
      %if (&rc ne 0) %then 
         %put %sysfunc(sysmsg()); 
      %else 
      %do; 
         %let etls_varnum = %sysfunc(varnum(&etls_dsid,&handleVariable)); 
         %if (&etls_varnum > 0) %then 
            %sysfunc(getvarc(&etls_dsid,&etls_varnum)); 
         %else 
            %put %sysfunc(sysmsg()); 
      %end; 
      %let rc = %sysfunc(close(&etls_dsid)); 
   %end; 
%mend etls_getHandle; 

%macro etls_freeHandle(statusTable=, statusVariable=, handleVariable=, 
   handleName=, statusSetting="Finished", 
   endTimeVariable=endTime, startTimeVariable=startTime, signoff=1, 
   returnCodeVariable=, returnCodeMacroVariable=, setMainJobRC=1, 
   statusUnknownReturnCode=., startTimeMacroVariable=, endTimeMacroVariable= ); 

   %if ("&statusTable" ne "") %then 
   %do; 
      %local etls_rcMacroVarExisted; 
      %let etls_rcMacroVarExisted = 0; 
      %if ("&returnCodeMacroVariable" ne "") %then 
      %do; 
         proc sql noprint; 
            select '1' into: etls_rcMacroVarExisted from dictionary.macros 
            where name=upcase("&returnCodeMacroVariable"); 
         quit; 

         %rcSet(&sqlrc); 
         %if (&etls_rcMacroVarExisted = 0) %then 
         %do; 
            %put WARNING: Return code from inner job not found.  Setting status to Unknown.;
            %let &returnCodeMacroVariable=&statusUnknownReturnCode; 
         %end; 
         %if (&setMainJobRC eq 1) %then 
            %rcSet(&&&returnCodeMacroVariable); 
      %end; 
      %else 
      %do; 
         %let returnCodeMacroVariable=etls_rcmacvar; 
         %let &returnCodeMacroVariable=&statusUnknownReturnCode; 
      %end; 

      %local etls_startTimeMacroVarExisted; 
      %let etls_startTimeMacroVarExisted = 0; 
      %if ("&startTimeMacroVariable" ne "") %then 
      %do; 
         proc sql noprint; 
            select '1' into: etls_startTimeMacroVarExisted from dictionary.macros 
            where name=upcase("&startTimeMacroVariable"); 
         quit; 

         %rcSet(&sqlrc); 
         %if (&etls_startTimeMacroVarExisted = 0) %then 
         %do; 
            %put WARNING: Start time from inner job not found.  No value will be set.;
            %let &startTimeMacroVariable=; 
         %end; 
      %end; 

      %local etls_endTimeMacroVarExisted; 
      %let etls_endTimeMacroVarExisted = 0; 
      %if ("&endTimeMacroVariable" ne "") %then 
      %do; 
         proc sql noprint; 
            select '1' into: etls_endTimeMacroVarExisted from dictionary.macros 
            where name=upcase("&endTimeMacroVariable"); 
         quit; 

         %rcSet(&sqlrc); 
         %if (&etls_endTimeMacroVarExisted = 0) %then 
         %do; 
            %put WARNING: End time from inner job not found.  Setting end time to current time.;
            %let &endTimeMacroVariable=%sysfunc(datetime()); 
         %end; 
      %end; 

      data &statusTable; 
         modify &statusTable(where=(&handleVariable = &handleName)); 
         %if ("&startTimeMacroVariable" ne "") %then 
         %do; 
            &startTimeVariable = input(symget("&startTimeMacroVariable"),32.);; 
         %end; 
         %if ("&endTimeVariable" ne "") %then 
         %do; 
            %if ("&endTimeMacroVariable" ne "") %then 
            %do; 
               &endTimeVariable = input(symget("&endTimeMacroVariable"),32.);; 
            %end; 
            %else 
               &endTimeVariable = datetime();; 
         %end; 
         %if ("&returnCodeVariable" ne "") %then 
            &returnCodeVariable = input(symget("&returnCodeMacroVariable"),32.);; 
         %if ("&statusVariable" ne "") %then 
         %do; 
            if (symget("etls_rcMacroVarExisted") eq "0") then 
               &statusVariable = "Unknown Status"; 
            else
               &statusVariable = &statusSetting;
         %end;
         call symput('handle',&handleVariable); 
         replace; 
         stop; 
      run; 

      %rcSet(&syserr); 

      %if (&signoff eq 1) %then 
         %etls_signoff(handleName=&handle); 
   %end; 
%mend etls_freeHandle; 

%macro etls_createHandle(statusTable=, statusVariable=, 
   handleVariable=, handlePrefix=rmt, 
   workloadMacroVariable=, row=, machineVariable=, 
   statusSetting="Running", startTimeVariable=startTime, 
   signon=1, useGrid=1, log=, output=, gridRC=, cmacvar=etls_signonStatus, 
   additionalSignonOptions=, signonRetries= ); 

   %local remoteSessionId; 
   %let remoteSessionId = &handlePrefix.&row; 
   %let &cmacvar = 1; 
   %local etls_machineId; 
   %if (&signon eq 1) %then  
      %etls_signon(handleName=&remoteSessionId, useGrid=&useGrid, 
         machineIdMacroVariable=etls_machineId, workloadMacroVariable=&workloadMacroVariable, 
         log=&log, output=&output, cmacvar=&cmacvar, gridRC=&gridRC, 
         additionalSignonOptions=&additionalSignonOptions,signonRetries=&signonRetries); 
   %else %let &cmacvar=0; 

   data &statusTable; 
      retain ptr &row; 
      modify &statusTable point = ptr; 
      &handleVariable = "&remoteSessionId"; 
      %if (&signon eq 1) %then 
         &machineVariable = "&etls_machineId";; 
      %if (&&&cmacvar ne 0) %then 
      %do; 
         &statusVariable = "Failed Signon"; 
      %end; 
      %else 
         &statusVariable = &statusSetting;; 
      %if (&startTimeVariable ne ) %then 
         &startTimeVariable = datetime();; 
      replace; 
      stop; 
   run; 

   %rcSet(&syserr); 
%mend etls_createHandle; 

%macro etls_getParameterNames(parameterTable=, parameterVariableMacro=, startingColumnNumber=1);
   %let &parameterVariableMacro = ;
   %let dsid = %sysfunc(open(&parameterTable));
   %if (&dsid gt 0) %then 
   %do; 
      %do i=&startingColumnNumber %to %sysfunc(attrn(&dsid,nvars)); 
         %let &parameterVariableMacro = &&&parameterVariableMacro %sysfunc(varname(&dsid,&i)); 
      %end; 
      %let dsid = %sysfunc(close(&dsid)); 
   %end; 
   %else 
      %put %sysfunc(sysmsg()); 
   %rcSet(&syserr); 
%mend etls_getParameterNames; 

%macro etls_getParameters(parameterTable=, row=, startingColumnNumber=1 , handleName=); 
   data _null_; 
      length vname $256 vtype $1 value $3200; 
      dsid = open("&parameterTable"); 
      if (dsid > 0) then 
      do; 
         do _i = 1 to &row; 
            fetchrc = fetch(dsid); 
         end; 
         do _i=&startingColumnNumber to attrn(dsid,'nvars'); 
            vname = varname(dsid,_i); 
            vtype = vartype(dsid,_i); 
            if (fetchrc = 0) then 
            do; 
               if (vtype = 'C') then 
               do; 
                  value = getvarc(dsid,_i); 
                  value = tranwrd(value,"%","%%"); 
                  value = tranwrd(value,"(","%("); 
                  value = tranwrd(value,")","%)"); 
                  value = tranwrd(value,'"','%"'); 
               end; 
               else 
                  value = left(put(getvarn(dsid,_i),best32.)); 
            end; /* fetchrc = 0 */ 
            
            put ;
            if indexc(trimn(value),"+-*/<>=^~;, '()&%",'"')>0 then 
            do; 
               value='%str('||trim(value)||')'; 
               put "NOTE: Special characters encountered; References may require: %nrbquote(%)UNQUOTE(&" vname+(-1)').';
            end; 
            %if %str(&handlename) ne %str() %then 
            %do; 
               value = '%syslput '||trim(vname)||'= '||trim(value)||" / remote = &handleName;"; 
            %end; 
            %else 
            %do; 
               value = '%let '||trim(vname)||'= '||trim(value)||';'; 
            %end; 
            
            put "NOTE: Setting macro variable " vname "with statement:" value ;
            call execute(value); 
         end; /* do i= */ 
         dsid = close(dsid); 
      end; /* dsid > 0 */ 
      else 
      do; 
         put "ERROR" ": Parameter table, &parameterTable, could not be opened.";
         abort; 
      end; 
      stop; 
   run; 
   
   %rcSet(&syserr); 
%mend etls_getParameters; 

%macro etls_loopW5NHBHSH; 
   %local etls_filePrefix; 
   %let etls_filePrefix = ; 
   
   %macro etls_processToLoopW5NHBHSR(parameterTable=, row=, handleName=rmt);
      %local etls_parmvars; 
      %etls_getParameterNames(parameterTable=&parameterTable, 
         parameterVariableMacro=etls_parmvars, 
         startingColumnNumber=1); 
      %local &etls_parmvars; 
      %etls_getParameters(parameterTable=&parameterTable, row=&row, 
         startingColumnNumber=1); 
      %let etls_previousFilePrefix = &etls_filePrefix;
      %local etls_filePrefix; 
      %let etls_filePrefix = &etls_previousFilePrefix.&handleName; 
      %macro etls_jobW5NHBHT1; 
      
         /****************************************************************************** 
          * Job:           LoopCreditScoringJob                      A5V75JN3.BN0000RU * 
          * Description:                                                               * 
          *                                                                            * 
          * Repository:    Foundation                                A0000001.A5V75JN3 * 
          * Server:        SASMain                                   A5V75JN3.AT000001 * 
          *                                                                            * 
          * Source Table:  PARAMETER_LIST_CREDIT_SCORING -           A5V75JN3.BE0000RT * 
          *                 control.PARAMETER_LIST_CREDIT_SCORING                      * 
          *                                                                            * 
          * Generated on:  Saturday, December 27, 2008 3:35:47 PM IST                  * 
          * Generated by:  sasadm                                                      * 
          * Version:       9.1.20060626.51875                                          * 
          ******************************************************************************/ 
         
         /* Setup to capture return codes  */ 
         %global job_rc trans_rc sqlrc; 
         %let job_rc = 0;
         %let trans_rc = 0;
         %let sqlrc = 0;
         %global syserr; 
         
         %macro rcSet(error); 
            %if (&error gt &trans_rc) %then 
               %let trans_rc = &error;
            %if (&error gt &job_rc) %then 
               %let job_rc = &error;
         %mend rcSet; 
         
         %macro rcSetDS(error); 
            if &error gt input(symget('trans_rc'),12.) then 
               call symput('trans_rc',trim(left(put(&error,12.))));
            if &error gt input(symget('job_rc'),12.) then 
               call symput('job_rc',trim(left(put(&error,12.))));
         %mend rcSetDS; 
         
         %global etls_debug; 
         %macro etls_setDebug; 
            %if %str(&etls_debug) ne 0 %then 
               OPTIONS MPRINT%str(;); 
         %mend; 
         %etls_setDebug; 
         
         /*============================================================================* 
          * Step:          SAS Extract                               A5V75JN3.BO0005M8 * 
          * Transform:     Extract                                                     * 
          * Description:                                                               * 
          *                                                                            * 
          * Source Table:  PARAMETER_LIST_CREDIT_SCORING -           A5V75JN3.BE0000RT * 
          *                 control.PARAMETER_LIST_CREDIT_SCORING                      * 
          * Target Table:  Extract Target - work.W5DWKJ4G            A5V75JN3.BP0004R9 * 
          *============================================================================*/ 
         
         %let SYSLAST = %nrquote(control.PARAMETER_LIST_CREDIT_SCORING); 
         
         %let trans_rc = 0; 
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete W5DWKJ4G;
         quit;
         
         proc sql; 
            create table work.W5DWKJ4G as 
               select JOB_NM length = 40,
                      LEVEL_NO length = 8
                  from &SYSLAST
                     where LEVEL_NO = &master_LEVEL_NO & RETURN_CD is null; 
         quit;
         
         %let SYSLAST = work.W5DWKJ4G; 
         
         %rcSet(&sqlrc); 
         
         /*============================================================================* 
          * Step:          Loop                                      A5V75JN3.BR00033U * 
          * Transform:     Loop                                                        * 
          * Description:                                                               * 
          *                                                                            * 
          * Source Table:  Extract Target - work.W5DWKJ4G            A5V75JN3.BP0004R9 * 
          * Target Table:  Status Table - work.W5AR0VBB              A5V75JN3.BP0004RA * 
          *============================================================================*/ 
         
         %let SYSLAST = %nrquote(work.W5DWKJ4G); 
         
         %let trans_rc = 0; 
         
         %macro genSASCommand; 
            %local noobjserver; 
            %if "&sysscp"="OS" %then %let noobjserver=; 
            %else %if "&sysscp"="VMS_AXP" %then %let noobjserver=%quote(/noobjectserver); 
            %else %let noobjserver=%quote(-noobjectserver); 
            options sascmd = "!sascmd &noobjserver"; 
         %mend genSASCommand; 
         %genSASCommand; 
         
         %macro etls_tsLevel(macroName=, featureName=); 
            data _null_; 
               call symput("&macroName",tslvl("&featureName")); 
            run; 
         %mend etls_tsLevel; 
         
         %macro etls_signon(handleName=etlsRemote, cmacvar=etls_signonStatus, 
            gridRC=rc, useGrid=1, 
            machineIdMacroVariable=etls_machineId, workloadMacroVariable=, 
            log=, output=, additionalSignonOptions=, signonRetries=3); 
         
            %let etls_gridInstalled =;
            %etls_tsLevel(macroName=etls_gridInstalled, featureName=uwugrdsvc); 
         
            %if (&useGrid = 1) %then 
            %do; 
               %if ("&etls_gridInstalled" ne "") %then 
               %do; 
                  %if (&gridRC eq ) %then 
                     %let gridRC = &handleName.RC ; 
         
                  %global &gridRC;
                  %let workload = ; 
                  %if (&workloadMacroVariable ne ) %then 
                  %do; 
                     data _null_;
                        call symput('workload',';workload = '||symget("&workloadMacroVariable"));
                     run;
                  %end; 
                  %let &gridRC = %sysfunc(grdsvc_enable("&handleName","resource = SASMain &workload ")); 
               %end; 
               %else 
                  %put %str(NOTE: Grid service functions are not installed.);
            %end; 
         
            %local sleeptime sleepIncreaseAmount tryCount; 
            %let sleepIncreaseAmount=5; 
            %let sleeptime=5; 
            %let tryCount=1; 
            %let &cmacvar=1; 
         
            %do %until((&&&cmacvar ne 1) or (&tryCount gt %eval(&signonRetries+1))); 
               data _null_; 
               signon &handleName cmacvar=&cmacvar 
                  %if ("&log" ne "") %then 
                     log=&log; 
                  %if ("&output" ne "") %then 
                     output=&output; 
                  %if ("&additionalSignonOptions" ne "") %then 
                     &additionalSignonOptions; 
               ;run; 
         
               %if ("&machineIdMacroVariable" ne "") %then 
               %do; 
                  %if ("&etls_gridInstalled" ne "") %then 
                     %let &machineIdmacroVariable = %sysfunc(grdsvc_getname(&handleName)); 
                  %else 
                     %put %str(NOTE: Grid service functions are not installed.);
               %end; 
         
               %if "&&&cmacvar" eq "1" %then 
               %do; 
                  %if &tryCount lt %eval(&signonRetries+1) %then 
                  %do; 
                     %put NOTE: Signon attempt #&tryCount failed. Retrying in &sleeptime seconds.;
                     %let rc=%sysfunc(sleep(&sleeptime,1)); 
                  %end; 
                  %else %if &signonRetries gt 0 %then 
                     %put ERROR%QUOTE(:) Final signon attempt, #&tryCount, failed.;
         
                  %let sleeptime=%sysevalf(&sleeptime+&sleepIncreaseAmount,int); /* increase sleeptime by factor */ 
                  %let tryCount=%eval(&tryCount+1); 
               %end; 
            %end; 
            %rcSet(&syserr); 
         
         %mend etls_signon; 
         
         %macro etls_serverConnected(serverId=,macvarname=isConnected); 
            %let &macvarname=0; 
            %local search_str none_str savenotes; 
         
            /* setup information for listtask output */ 
            /* listtask output on OS/390 differs */ 
            %if %bquote(&sysscp) eq OS %then 
            %do; 
               %let search_str=Remote submit for; 
               %let token=5; 
            %end; 
            %else  
            %do; 
               %let search_str=--------------; 
               %let token=1; 
            %end; 
         
            /* Issue listtask within PROC PRINTTO - send output to file */ 
            filename __tmptxt TEMP; 
            %let savenotes=%sysfunc(getoption(notes)); 
            options nonotes; 
         
            proc printto log=__tmptxt new; 
            run; 
         
            options notes; 
            listtask; 
            proc printto; 
            run; 
         
            options nonotes; 
         
            /* read in the output from listtask */ 
            %let dsname=_null_; 
            data _null_(keep=Session); 
               length line $256 sessionId $60; 
               infile __tmptxt length=len; 
               input @1 line $varying. len; 
         
               if line=:'There are no' then 
                  stop; 
               /* look for the search string and scan for server name */ 
               if index(line,"&search_str") then  
               do; 
                  sessionId=scan(line,&token," "); 
                  sessionId=upcase(trim(left(tranwrd(sessionId,'"',' ')))); 
                  if sessionId=upcase(symget("serverId")) then 
                  do;  
                     call symput("&macvarname","1"); 
                     stop; 
                  end; 
               end; 
            run; 
            filename __tmptxt clear; 
            options &savenotes; 
         %mend etls_serverConnected; 
         
         %macro etls_signoff(handleName=rmt); 
            %local savemprint; 
            %let savemprint=%sysfunc(getoption(mprint)); 
            %put %str(NOTE: Testing connection with etls_serverConnected macro %(mprint off%).);
            options nomprint; 
            %local isConnected; 
            %etls_serverConnected(serverId=&handleName); 
            options &savemprint; 
            %if &isConnected %then 
               signoff &handleName ;; 
         %mend etls_signoff; 
         
         %macro etls_getHandle(statusTable=, handleVariable=, row=); 
            %let etls_dsid = %sysfunc(open(&statusTable)); 
            %if (&etls_dsid = 0) %then 
               %put %sysfunc(sysmsg()); 
            %else 
            %do; 
               %let rc = %sysfunc(fetchobs(&etls_dsid, &row)); 
               %if (&rc ne 0) %then 
                  %put %sysfunc(sysmsg()); 
               %else 
               %do; 
                  %let etls_varnum = %sysfunc(varnum(&etls_dsid,&handleVariable)); 
                  %if (&etls_varnum > 0) %then 
                     %sysfunc(getvarc(&etls_dsid,&etls_varnum)); 
                  %else 
                     %put %sysfunc(sysmsg()); 
               %end; 
               %let rc = %sysfunc(close(&etls_dsid)); 
            %end; 
         %mend etls_getHandle; 
         
         %macro etls_freeHandle(statusTable=, statusVariable=, handleVariable=, 
            handleName=, statusSetting="Finished", 
            endTimeVariable=endTime, startTimeVariable=startTime, signoff=1, 
            returnCodeVariable=, returnCodeMacroVariable=, setMainJobRC=1, 
            statusUnknownReturnCode=., startTimeMacroVariable=, endTimeMacroVariable= ); 
         
            %if ("&statusTable" ne "") %then 
            %do; 
               %local etls_rcMacroVarExisted; 
               %let etls_rcMacroVarExisted = 0; 
               %if ("&returnCodeMacroVariable" ne "") %then 
               %do; 
                  proc sql noprint; 
                     select '1' into: etls_rcMacroVarExisted from dictionary.macros 
                     where name=upcase("&returnCodeMacroVariable"); 
                  quit; 
         
                  %rcSet(&sqlrc); 
                  %if (&etls_rcMacroVarExisted = 0) %then 
                  %do; 
                     %put WARNING: Return code from inner job not found.  Setting status to Unknown.;
                     %let &returnCodeMacroVariable=&statusUnknownReturnCode; 
                  %end; 
                  %if (&setMainJobRC eq 1) %then 
                     %rcSet(&&&returnCodeMacroVariable); 
               %end; 
               %else 
               %do; 
                  %let returnCodeMacroVariable=etls_rcmacvar; 
                  %let &returnCodeMacroVariable=&statusUnknownReturnCode; 
               %end; 
         
               %local etls_startTimeMacroVarExisted; 
               %let etls_startTimeMacroVarExisted = 0; 
               %if ("&startTimeMacroVariable" ne "") %then 
               %do; 
                  proc sql noprint; 
                     select '1' into: etls_startTimeMacroVarExisted from dictionary.macros 
                     where name=upcase("&startTimeMacroVariable"); 
                  quit; 
         
                  %rcSet(&sqlrc); 
                  %if (&etls_startTimeMacroVarExisted = 0) %then 
                  %do; 
                     %put WARNING: Start time from inner job not found.  No value will be set.;
                     %let &startTimeMacroVariable=; 
                  %end; 
               %end; 
         
               %local etls_endTimeMacroVarExisted; 
               %let etls_endTimeMacroVarExisted = 0; 
               %if ("&endTimeMacroVariable" ne "") %then 
               %do; 
                  proc sql noprint; 
                     select '1' into: etls_endTimeMacroVarExisted from dictionary.macros 
                     where name=upcase("&endTimeMacroVariable"); 
                  quit; 
         
                  %rcSet(&sqlrc); 
                  %if (&etls_endTimeMacroVarExisted = 0) %then 
                  %do; 
                     %put WARNING: End time from inner job not found.  Setting end time to current time.;
                     %let &endTimeMacroVariable=%sysfunc(datetime()); 
                  %end; 
               %end; 
         
               data &statusTable; 
                  modify &statusTable(where=(&handleVariable = &handleName)); 
                  %if ("&startTimeMacroVariable" ne "") %then 
                  %do; 
                     &startTimeVariable = input(symget("&startTimeMacroVariable"),32.);; 
                  %end; 
                  %if ("&endTimeVariable" ne "") %then 
                  %do; 
                     %if ("&endTimeMacroVariable" ne "") %then 
                     %do; 
                        &endTimeVariable = input(symget("&endTimeMacroVariable"),32.);; 
                     %end; 
                     %else 
                        &endTimeVariable = datetime();; 
                  %end; 
                  %if ("&returnCodeVariable" ne "") %then 
                     &returnCodeVariable = input(symget("&returnCodeMacroVariable"),32.);; 
                  %if ("&statusVariable" ne "") %then 
                  %do; 
                     if (symget("etls_rcMacroVarExisted") eq "0") then 
                        &statusVariable = "Unknown Status"; 
                     else
                        &statusVariable = &statusSetting;
                  %end;
                  call symput('handle',&handleVariable); 
                  replace; 
                  stop; 
               run; 
         
               %rcSet(&syserr); 
         
               %if (&signoff eq 1) %then 
                  %etls_signoff(handleName=&handle); 
            %end; 
         %mend etls_freeHandle; 
         
         %macro etls_createHandle(statusTable=, statusVariable=, 
            handleVariable=, handlePrefix=rmt, 
            workloadMacroVariable=, row=, machineVariable=, 
            statusSetting="Running", startTimeVariable=startTime, 
            signon=1, useGrid=1, log=, output=, gridRC=, cmacvar=etls_signonStatus, 
            additionalSignonOptions=, signonRetries= ); 
         
            %local remoteSessionId; 
            %let remoteSessionId = &handlePrefix.&row; 
            %let &cmacvar = 1; 
            %local etls_machineId; 
            %if (&signon eq 1) %then  
               %etls_signon(handleName=&remoteSessionId, useGrid=&useGrid, 
                  machineIdMacroVariable=etls_machineId, workloadMacroVariable=&workloadMacroVariable, 
                  log=&log, output=&output, cmacvar=&cmacvar, gridRC=&gridRC, 
                  additionalSignonOptions=&additionalSignonOptions,signonRetries=&signonRetries); 
            %else %let &cmacvar=0; 
         
            data &statusTable; 
               retain ptr &row; 
               modify &statusTable point = ptr; 
               &handleVariable = "&remoteSessionId"; 
               %if (&signon eq 1) %then 
                  &machineVariable = "&etls_machineId";; 
               %if (&&&cmacvar ne 0) %then 
               %do; 
                  &statusVariable = "Failed Signon"; 
               %end; 
               %else 
                  &statusVariable = &statusSetting;; 
               %if (&startTimeVariable ne ) %then 
                  &startTimeVariable = datetime();; 
               replace; 
               stop; 
            run; 
         
            %rcSet(&syserr); 
         %mend etls_createHandle; 
         
         %macro etls_waitfor(statusTable=, statusVariable=, runningStatusSetting="Running", handleVariable=, 
            completeStatusSetting="Finished", endTimeVariable=endTime, 
            startTimeVariable=startTime, waitType=_ANY_, signoff=1, 
            returnCodeVariable=, returnCodeMacroVariable=, statusUnknownReturnCode=.); 
         
            proc sql noprint; 
               select count(*) into :etls_rows 
                  from &statusTable where &statusVariable = &runningStatusSetting; 
               %let etls_rows = &etls_rows; 
               %if (&etls_rows gt 0) %then 
               %do; 
                  select &handleVariable into :etlsHandles1 - :etlsHandles&etls_rows 
                     from &statusTable where &statusVariable = &runningStatusSetting; 
               %end; 
            quit; 
         
            %rcSet(&sqlrc); 
         
            %if (&etls_rows gt 0) %then 
            %do; 
               waitfor &waitType 
                  %do i=1 %to &etls_rows; 
                     &&etlsHandles&i 
                  %end; 
               ; 
            %end; 
         
            %local useDefaultRCMacVar; 
            %if ("&returnCodeMacroVariable" eq "") %then 
               %let useDefaultRCMacVar=Y; 
         
            %do i=1 %to &etls_rows; 
         
               %if ("&useDefaultRCMacVar"="Y") %then 
                  %let returnCodeMacroVariable=job_rc&&etlsHandles&i; 
         
               waitfor &&etlsHandles&i timeout=1; 
               %if (&SYSRC eq 0) or (&SYSRC eq -2) %then /* process complete  */ 
               %do; 
                  %etls_freeHandle(statusTable=&statusTable, statusVariable=&statusVariable,
                     handleVariable=&handleVariable, handleName="&&etlsHandles&i", 
                     statusSetting=&completeStatusSetting, endTimeVariable=&endTimeVariable, 
                     startTimeVariable=&startTimeVariable, signoff=&signoff, 
                     returnCodeVariable=&returnCodeVariable, returnCodeMacroVariable=&returnCodeMacroVariable, 
                     statusUnknownReturnCode=&statusUnknownReturnCode, 
                     startTimeMacroVariable=etls_startTime_&&etlsHandles&i., 
                     endTimeMacroVariable=etls_endTime_&&etlsHandles&i. ); 
                  %put NOTE: Process &&etlsHandles&i. has completed.;
               %end; 
               %else %if (&SYSRC ne -1) %then /* process status unknown  */ 
               %do; 
                  %etls_freeHandle(statusTable=&statusTable, statusVariable=&statusVariable,
                     handleVariable=&handleVariable, handleName="&&etlsHandles&i", 
                     statusSetting="Unknown Status", endTimeVariable=&endTimeVariable, 
                     startTimeVariable=&startTimeVariable, signoff=&signoff, 
                     returnCodeVariable=&returnCodeVariable, returnCodeMacroVariable=&returnCodeMacroVariable, 
                     statusUnknownReturnCode=&statusUnknownReturnCode, startTimeMacroVariable=etls_startTime_&&etlsHandles&i ); 
                  %put NOTE: Cannot retrieve status from process &&etlsHandles&i..;
               %end; 
            %end; 
         %mend etls_waitfor; 
         
         %macro etls_getProcessesRunning(statusTable=, statusVariable=, processCountMacro=, 
            statusSetting="Running"); 
         
            proc sql noprint; 
               select count(*) into: &processCountMacro 
                  from &statusTable where &statusVariable = &statusSetting; 
            quit; 
         
            %rcSet(&sqlrc); 
         %mend etls_getProcessesRunning; 
         
         %macro etls_getParameterNames(parameterTable=, parameterVariableMacro=, startingColumnNumber=1);
            %let &parameterVariableMacro = ;
            %let dsid = %sysfunc(open(&parameterTable));
            %if (&dsid gt 0) %then 
            %do; 
               %do i=&startingColumnNumber %to %sysfunc(attrn(&dsid,nvars)); 
                  %let &parameterVariableMacro = &&&parameterVariableMacro %sysfunc(varname(&dsid,&i)); 
               %end; 
               %let dsid = %sysfunc(close(&dsid)); 
            %end; 
            %else 
               %put %sysfunc(sysmsg()); 
            %rcSet(&syserr); 
         %mend etls_getParameterNames; 
         
         %macro etls_getParameters(parameterTable=, row=, startingColumnNumber=1 , handleName=); 
            data _null_; 
               length vname $256 vtype $1 value $3200; 
               dsid = open("&parameterTable"); 
               if (dsid > 0) then 
               do; 
                  do _i = 1 to &row; 
                     fetchrc = fetch(dsid); 
                  end; 
                  do _i=&startingColumnNumber to attrn(dsid,'nvars'); 
                     vname = varname(dsid,_i); 
                     vtype = vartype(dsid,_i); 
                     if (fetchrc = 0) then 
                     do; 
                        if (vtype = 'C') then 
                        do; 
                           value = getvarc(dsid,_i); 
                           value = tranwrd(value,"%","%%"); 
                           value = tranwrd(value,"(","%("); 
                           value = tranwrd(value,")","%)"); 
                           value = tranwrd(value,'"','%"'); 
                        end; 
                        else 
                           value = left(put(getvarn(dsid,_i),best32.)); 
                     end; /* fetchrc = 0 */ 
                     
                     put ;
                     if indexc(trimn(value),"+-*/<>=^~;, '()&%",'"')>0 then 
                     do; 
                        value='%str('||trim(value)||')'; 
                        put "NOTE: Special characters encountered; References may require: %nrbquote(%)UNQUOTE(&" vname+(-1)').';
                     end; 
                     %if %str(&handlename) ne %str() %then 
                     %do; 
                        value = '%syslput '||trim(vname)||'= '||trim(value)||" / remote = &handleName;"; 
                     %end; 
                     %else 
                     %do; 
                        value = '%let '||trim(vname)||'= '||trim(value)||';'; 
                     %end; 
                     
                     put "NOTE: Setting macro variable " vname "with statement:" value ;
                     call execute(value); 
                  end; /* do i= */ 
                  dsid = close(dsid); 
               end; /* dsid > 0 */ 
               else 
               do; 
                  put "ERROR" ": Parameter table, &parameterTable, could not be opened.";
                  abort; 
               end; 
               stop; 
            run; 
            
            %rcSet(&syserr); 
         %mend etls_getParameters; 
         
         %macro etls_loopW5NHBHSI; 
            %local etls_filePrefix; 
            %let etls_filePrefix = &etls_filePrefix.&handleName.-; 
            
            %macro etls_processToLoopW5NHBHSS(parameterTable=, row=, handleName=rmt);
               %etls_getParameters(parameterTable=&parameterTable, row=&row, 
                  startingColumnNumber=1, handleName=&handleName); 
               %let etls_previousFilePrefix = &etls_filePrefix;
               %local etls_filePrefix; 
               %let etls_filePrefix = &etls_previousFilePrefix.&handleName; 
               %syslput &etls_controlName = &row / remote = &handleName; 
               %syslput handleName = &handleName / remote = &handleName; 
               
               /* Setup to pass macros to remote session  */ 
               %syslput master_level_no = &master_level_no / remote = &handleName; 
               %syslput etls_filePrefix = &etls_filePrefix / remote = &handleName; 
               
               rsubmit &handleName wait = no sysrputsync = yes persist = no; 
               
                  %macro etls_jobW5NHBHT2; 
                  
                     %sysrput etls_startTime_&handleName = %sysfunc(datetime()); 
                     
                     /****************************************************************************** 
                      * Job:           ControlCreditScoringJob                   A5V75JN3.BN0000RT * 
                      * Description:                                                               * 
                      *                                                                            * 
                      * Repository:    Foundation                                A0000001.A5V75JN3 * 
                      * Server:        SASMain                                   A5V75JN3.AT000001 * 
                      *                                                                            * 
                      * Generated on:  Saturday, December 27, 2008 3:35:47 PM IST                  * 
                      * Generated by:  sasadm                                                      * 
                      * Version:       9.1.20060626.51875                                          * 
                      ******************************************************************************/ 
                     
                     /* Setup to capture return codes  */ 
                     %global job_rc trans_rc sqlrc; 
                     %let job_rc = 0;
                     %let trans_rc = 0;
                     %let sqlrc = 0;
                     %global syserr; 
                     
                     %macro rcSet(error); 
                        %if (&error gt &trans_rc) %then 
                           %let trans_rc = &error;
                        %if (&error gt &job_rc) %then 
                           %let job_rc = &error;
                     %mend rcSet; 
                     
                     %macro rcSetDS(error); 
                        if &error gt input(symget('trans_rc'),12.) then 
                           call symput('trans_rc',trim(left(put(&error,12.))));
                        if &error gt input(symget('job_rc'),12.) then 
                           call symput('job_rc',trim(left(put(&error,12.))));
                     %mend rcSetDS; 
                     
                     %global etls_debug; 
                     %macro etls_setDebug; 
                        %if %str(&etls_debug) ne 0 %then 
                           OPTIONS MPRINT%str(;); 
                     %mend; 
                     %etls_setDebug; 
                     
                     /*============================================================================* 
                      * Pre-Process code for the job                             A5V75JN3.AY0003ZT * 
                      *                                                                            * 
                      * User Written:  Predecessor process                       A5V75JN3.AF000MHW * 
                      *============================================================================*/ 
                     
                     /*---- Start of User Written Code  ----*/ 
                     
                     data _null_;                            
                     var_jb=kcompress("&job_nm",'.sas');                            
                     logfile="Data/bisdata/log/schedule_credit_scoring/"||var_jb;                 
                     call symput('job_logname',ktrim(logfile));                                     
                     run;                                                                          
                     filename joblog "&job_logname..log";                                          
                     %put NOTE: Redirecting log to &job_logname..log;                              
                     proc printto log=joblog;                                                  
                     run;                                                                          
                     %put &job_logname;
                     
                     /*---- End of User Written Code  ----*/ 
                     
                     %rcSet(&syserr); 
                     %rcSet(&sqlrc); 
                     
                     /*============================================================================* 
                      * Step:          User Written Code                         A5V75JN3.BO0005M6 * 
                      * Transform:     User Written Code                                           * 
                      * Description:                                                               * 
                      *                                                                            * 
                      * Target Table:  User Written Code Target - work.W5AREK3F  A5V75JN3.BP0004R8 * 
                      *                                                                            * 
                      * User Written:  CreateTable                               A5V75JN3.AF000MHR * 
                      *============================================================================*/ 
                     
                     %let trans_rc = 0; 
                     
                     %let _OUTPUT = %nrquote(work.W5AREK3F); 
                     
                     /*---- Start of User Written Code  ----*/ 
                     
                     
                     %put 'level_no=' &level_no;
                     %put 'master_level_no=' &master_level_no; 
                     
                     %if &level_no EQ &master_level_no  %then 
                     %do;
                     
                     /*%trylock(member=&status_table, timeout=100000);*/
                     /**/
                     /*proc sql;*/
                     /*select count(job_nm) into :job_count  */
                     /*from control.parameter_list_mod_abt*/
                     /*where  job_nm = "&job_nm" and level_no = &level_no and */
                     /*return_cd = .;*/
                     /*quit;*/
                     /**/
                     /*lock  &status_table clear;*/
                     /**/
                     /*%if &job_count = 1 %then*/
                     %include jobs (&job_nm) /LRECL= 1024;
                     %end;
                     
                     
                     /*---- End of User Written Code  ----*/ 
                     
                     %rcSet(&syserr); 
                     %rcSet(&sqlrc); 
                     
                     /*============================================================================* 
                      * Post-Process code for the job                            A5V75JN3.AY0003ZU * 
                      *                                                                            * 
                      * User Written:  Post process                              A5V75JN3.AF000MHX * 
                      *============================================================================*/ 
                     
                     /*---- Start of User Written Code  ----*/ 
                     
                     proc printto log=log;                                                     
                     run;
                     /*---- End of User Written Code  ----*/ 
                     
                     %rcSet(&syserr); 
                     %rcSet(&sqlrc); 
                     
                     %sysrput job_rc&handleName = &job_rc; 
                     %sysrput etls_endTime_&handleName = %sysfunc(datetime()); 
                     
                  %mend etls_jobW5NHBHT2; 
                  
                  %etls_jobW5NHBHT2; 
                  
               endrsubmit;
               
            %mend etls_processToLoopW5NHBHSS;
            
            %local etls_controlTable etls_statusTable etls_controlName 
               etls_processesRunning etls_maxProcesses etls_parameterTable 
               etls_additionalSignonOptions etls_signonRetries;
            %let etls_controlName = L98_; 
            %let etls_statusTable = work.W5AR0VBB; 
            %let etls_parameterTable = work.W5NHBHSJ; 
            %let etls_workload = ;
            %let etls_additionalSignonOptions = ;%let etls_statusTable = work.loop_job_status;;
            %let etls_signonRetries = 3;
            %let &etls_controlName = 0;
            %let etls_controlTable = work.W5DWKJ4G;
            
            %put %str(NOTE: Creating status table...);
            data &etls_statusTable 
               (keep = etls_handleName etls_machineId etls_startTime etls_endTime 
                       etls_status etls_jobRC
               );
               attrib etls_handleName length = $32
                         label = 'Name of handle to remote session'; 
               attrib etls_machineId length = $32
                         label = 'Name of machine executing the task'; 
               attrib etls_startTime length = 8 format = DATETIME. informat = DATETIME.
                         label = 'Start time of task'; 
               attrib etls_endTime length = 8 format = DATETIME. informat = DATETIME.
                         label = 'End time of task'; 
               attrib etls_status length = $32
                         label = 'Current status of task'; 
               attrib etls_jobRC length = 8
                         label = 'Return code of task'; 
               set &etls_controlTable;
            run;
            
            %rcSet(&syserr); 
            
            %put %str(NOTE: Creating parameter table...);
            proc sql; 
               create table &etls_parameterTable as 
                  select LEVEL_NO as level_no, 
                         JOB_NM as job_nm, 
                         symget("master_level_no") as master_level_no, 
                         "&status_table" as status_table 
                  from &etls_controlTable; 
            quit; 
            
            %rcSet(&sqlrc); 
            
            /* Get the number of times to iterate from the number of rows in the source  */ 
            /*  table                                                                    */ 
            proc sql noprint; 
               select count(*) into :&etls_controlName._max from &etls_statusTable;
               %let &etls_controlName._max = &&&etls_controlName._max;
            quit;
            
            %rcSet(&sqlrc); 
            
            %let etls_maxProcesses = 5; 
            
            %let etls_stopLoop = 0; 
            
            %if (&etls_maxProcesses > 0) %then 
            %do; 
               %do %until (&&&etls_controlName ge &&&etls_controlName._max
                  or &etls_stopLoop ne 0); 
               
                  %let etls_lastLoopPtr = &&&etls_controlName;
                  
                  %etls_getProcessesRunning(statusTable=&etls_statusTable, statusVariable=etls_status, 
                     processCountMacro=etls_processesRunning, statusSetting="Running");
                     
                  %do %while(&etls_processesRunning lt &&&etls_controlName._max 
                     and &etls_processesRunning lt &etls_maxProcesses 
                     and &&&etls_controlName lt &&&etls_controlName._max);
                     
                     %let &etls_controlName = %eval(&&&etls_controlName+1);
                     
                     %global etls_signonStatus; 
                     
                     %etls_createHandle(statusTable=&etls_statusTable, statusVariable=etls_status, 
                        handleVariable=etls_handleName, handlePrefix=&etls_controlName, 
                        row=&&&etls_controlName, machineVariable=etls_machineId, 
                        startTimeVariable=etls_startTime, cmacvar=etls_signonStatus, signon=1, useGrid=1, 
                        additionalSignonOptions=&etls_additionalSignonOptions, signonRetries=&etls_signonRetries);
                        
                     %etls_getProcessesRunning(statusTable=&etls_statusTable, statusVariable=etls_status, 
                        processCountMacro=etls_processesRunning, statusSetting="Running");
                        
                     %if &etls_processesRunning > 0 and &etls_signonStatus ne 1 %then 
                        %etls_processToLoopW5NHBHSS(parameterTable=&etls_parameterTable, row=&&&etls_controlName,
                           handleName=%etls_getHandle(statusTable=&etls_statusTable,
                           handleVariable=etls_handleName, row=&&&etls_controlName)); 
                     %else 
                     %do; /* if signon error, set iterator to max to force loop to stop. */ 
                        %let &etls_controlName = &&&etls_controlName._max; 
                        %put %str(ERROR%QUOTE(:) A parallel process did not start.  Exiting loop.);
                     %end; 
                  %end; 
                  
                  %etls_waitFor(statusTable=&etls_statusTable, statusVariable=etls_status, 
                     runningStatusSetting="Running", handleVariable=etls_handleName, 
                     completeStatusSetting="Finished", endTimeVariable=etls_endTime, 
                     startTimeVariable=etls_startTime, waitType=_ANY_, signoff=1, 
                     returnCodeVariable=etls_jobRC, 
                     statusUnknownReturnCode=.); 
                     
                  %if (&job_rc ge 5) %then 
                     %let etls_stopLoop = 1; 
                     
               %end; 
               
               %etls_waitFor(statusTable=&etls_statusTable, statusVariable=etls_status, 
                  runningStatusSetting="Running", handleVariable=etls_handleName, 
                  completeStatusSetting="Finished", endTimeVariable=etls_endTime, 
                  startTimeVariable=etls_startTime, waitType=_ALL_, signoff=1, 
                  returnCodeVariable=etls_jobRC, 
                  statusUnknownReturnCode=.); 
                  
            %end;
            
            proc datasets lib = work nolist nowarn memtype = (data view);
               delete W5NHBHSJ;
            quit;
            
         %mend etls_loopW5NHBHSI; 
         
         %etls_loopW5NHBHSI; 
         
         /*============================================================================* 
          * Step:          Loop End                                  A5V75JN3.BR00033T * 
          * Transform:     Loop End                                                    * 
          * Description:                                                               * 
          *============================================================================*/ 
         
      %mend etls_jobW5NHBHT1; 
      
      %etls_jobW5NHBHT1; 
      
      %let handleName = %etls_getHandle(statusTable=&etls_statusTable,
         handleVariable=etls_handleName, row=&&&etls_controlName);
         
      %let job_rc&handleName. = &job_rc; 
      
      %etls_freeHandle(statusTable=&etls_statusTable, statusVariable=etls_status, 
         handleVariable=etls_handleName, handleName="&handleName", 
         startTimeVariable=etls_startTime, endTimeVariable=etls_endTime, signoff=0, 
         returnCodeVariable=etls_jobRC, returnCodeMacroVariable=job_rc&handleName., setMainJobRc=1); 
         
   %mend etls_processToLoopW5NHBHSR;
   
   %local etls_controlTable etls_statusTable etls_controlName 
      etls_processesRunning etls_maxProcesses etls_parameterTable 
      etls_additionalSignonOptions etls_signonRetries;
   %let etls_controlName = L66_; 
   %let etls_statusTable = work.W5AR0VBB; 
   %let etls_parameterTable = work.W5NHBHST; 
   %let &etls_controlName = 0;
   %let etls_controlTable = work.W5D8EMYG;
   
   %put %str(NOTE: Creating status table...);
   data &etls_statusTable 
      (keep = etls_handleName etls_machineId etls_startTime etls_endTime 
              etls_status etls_jobRC
      );
      attrib etls_handleName length = $32
                label = 'Name of handle to remote session'; 
      attrib etls_machineId length = $32
                label = 'Name of machine executing the task'; 
      attrib etls_startTime length = 8 format = DATETIME. informat = DATETIME.
                label = 'Start time of task'; 
      attrib etls_endTime length = 8 format = DATETIME. informat = DATETIME.
                label = 'End time of task'; 
      attrib etls_status length = $32
                label = 'Current status of task'; 
      attrib etls_jobRC length = 8
                label = 'Return code of task'; 
      set &etls_controlTable;
   run;
   
   %rcSet(&syserr); 
   
   %put %str(NOTE: Creating parameter table...);
   proc sql; 
      create table &etls_parameterTable as 
         select master_level_no as master_level_no 
         from &etls_controlTable; 
   quit; 
   
   %rcSet(&sqlrc); 
   
   /* Get the number of times to iterate from the number of rows in the source  */ 
   /*  table                                                                    */ 
   proc sql noprint; 
      select count(*) into :&etls_controlName._max from &etls_statusTable;
      %let &etls_controlName._max = &&&etls_controlName._max;
   quit;
   
   %rcSet(&sqlrc); 
   
   %let etls_maxProcesses = 1; 
   
   %let etls_stopLoop = 0; 
   
   %if (&etls_maxProcesses > 0) %then 
   %do; 
      %do %until (&&&etls_controlName ge &&&etls_controlName._max
         or &etls_stopLoop ne 0); 
      
         %let etls_lastLoopPtr = &&&etls_controlName;
         
         %let etls_processesRunning = 0; 
         
         %do %while(&etls_processesRunning lt &&&etls_controlName._max 
            and &etls_processesRunning lt &etls_maxProcesses 
            and &&&etls_controlName lt &&&etls_controlName._max);
            
            %let &etls_controlName = %eval(&&&etls_controlName+1);
            
            %let job_rcLast=&job_rc; 
            
            %etls_createHandle(statusTable=&etls_statusTable, statusVariable=etls_status, 
               handleVariable=etls_handleName, handlePrefix=&etls_controlName, 
               row=&&&etls_controlName, machineVariable=etls_machineId, 
               startTimeVariable=etls_startTime, signon=0, useGrid=0);
               
            %let etls_processesRunning = 1; 
            %etls_processToLoopW5NHBHSR(parameterTable=&etls_parameterTable, row=&&&etls_controlName,
               handleName=%etls_getHandle(statusTable=&etls_statusTable,
               handleVariable=etls_handleName, row=&&&etls_controlName)); 
            
            /* Reset main Job_RC and Trans_RC to max return code of all iterations */ 
            %let job_rcThisIter=&job_rc; 
            %let job_rc=&job_rcLast; 
            %let trans_rc=&job_rcLast; 
            %rcSet(&job_rcThisIter); 
         %end; 
         
         %if (&job_rc ge 5) %then 
            %let etls_stopLoop = 1; 
            
      %end; 
      
   %end;
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete W5NHBHST;
   quit;
   
%mend etls_loopW5NHBHSH; 

%etls_loopW5NHBHSH; 

/*============================================================================* 
 * Step:          Loop End                                  A5V75JN3.BR00033V * 
 * Transform:     Loop End                                                    * 
 * Description:                                                               * 
 *============================================================================*/ 

/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY000401 * 
 *                                                                            * 
 * User Written:  Updating model input ABT status.          A5V75JN3.AF000MI2 * 
 *                This code updates the ABT status of a model to FINISH when  * 
 *                the development data for that model is loaded for first     * 
 *                 month.                                                     * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/* Start of CS4.3 HF2 */ 

*---------------------------------------------------------------------------------------*
* Code to update the the MODEL_INPUT table.                                             *
* If a model is already in MODEL_DEV_FACT then the status is set to FINISH - this will  *
* prevent the modelling sample from being scored again.                                 *
* Lookup the MODEL_SK  from ANALYTICAL_MODEL_DIM for the MODEL_NM.                      *
* If that Model_SK already exists in MODEL_DEV_FACT then set the status to FINISH       * 
*---------------------------------------------------------------------------------------*;

%macro upd_mdl_input;

	proc sql;
			update mdlmart.model_input
		   set status=&FINISHED_STATUS
		   where upcase(ABT_TYPE) IN (&CS_ABT_TYPE_MDL)
		   AND model_input.model_nm 
		   in (	select distinct(model_nm) from dim.analytical_model_dim
					where analytical_model_dim.model_sk 
				   in (select distinct(model_sk) from fact.model_dev_fact))
			;
	quit;

%mend;

%upd_mdl_input;
/* End of CS4.3 HF2 */
/* Start of CS4.3 HF2 */ 

*---------------------------------------------------------------------------------------*
* Code to update the the MODEL_INPUT table.                                             *
* If a model is already in MODEL_DEV_FACT then the status is set to FINISH - this will  *
* prevent the modelling sample from being scored again.                                 *
* Lookup the MODEL_SK  from ANALYTICAL_MODEL_DIM for the MODEL_NM.                      *
* If that Model_SK already exists in MODEL_DEV_FACT then set the status to FINISH       * 
*---------------------------------------------------------------------------------------*;

%macro upd_mdl_input_app;

	proc sql;
			update mdlmart.model_input
		   set status=&FINISHED_STATUS
		   where upcase(ABT_TYPE) IN (&CS_ABT_TYPE_MDL)
		   AND model_input.model_nm 
		   in (
					select distinct(model_nm) from dim.analytical_model_dim
				  	where analytical_model_dim.model_sk 
				   in (select distinct(model_sk) from fact.model_dev_appl_fact))
			;
	quit;
%mend;

%upd_mdl_input_app;
/* End of CS4.3 HF2 */
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

