/****************************************************************************** 
 * Job:           OTE_APPL_GOOD_BAD_ABT                     A5V75JN3.BN0002KQ * 
 * Description:   This job picks up data from ACCOUNT_DIM, APPL_BASIC_ABT     * 
 *                 and ACCOUNT_SNAPSHOT.                                      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: APPL_BASIC_ABT - abtagg.APPL_BASIC_ABT    A5V75JN3.BE0001QU * 
 *                ACCOUNT_DIM - dim.account_dim             A5V75JN3.BE0000LI * 
 *                ACCOUNT_SNAPSHOT - fact.ACCOUNT_SNAPSHOT  A5V75JN3.BE0000O2 * 
 *                APPL_REJ - abtscr.APPL_REJ                A5V75JN3.BE0004MP * 
 * Target Table:  OTE_APPL_GOOD_BAD_ABT -                   A5V75JN3.BE0002N5 * 
 *                 abtagg.OTE_APPL_GOOD_BAD_ABT                               * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 2:54:18 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = OTE_APPL_GOOD_BAD_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Get account keys for application outcome  A5V75JN3.BO0005LO * 
 *                 end date                                                   * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Get account keys for application outcome end date           * 
 *                                                                            * 
 * Source Tables: APPL_BASIC_ABT - abtagg.APPL_BASIC_ABT    A5V75JN3.BE0001QU * 
 *                ACCOUNT_DIM - dim.account_dim             A5V75JN3.BE0000LI * 
 * Target Table:  SQL Target - work.W5ER34W6                A5V75JN3.BP0004QX * 
 *============================================================================*/ 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5ER34W6;
quit;

proc sql;
   create table work.W5ER34W6 as
      select
         account_dim.ACCOUNT_SK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         APPL_BASIC_ABT.APPLICATION_RK length = 8
                                       format = 12.
                                       informat = 12.,
         (CASE WHEN account_dim.COLLECTIONS_STATUS_CD  IN (&COL_COLLECTION_STATUS) THEN 1 ELSE 0 END) as ACC_COLL_FLG length = 8
                                                                                                                      format = 12.
                                                                                                                      informat = 12.
                                                                                                                      label = "_CD",
         DATEPART(APPL_BASIC_ABT.OUTCOME_END_DTTM ) as APPL_OUTCOME_END_DT length = 8
                                                                           format = NLDATE10.
                                                                           informat = NLDATE10.,
         APPL_BASIC_ABT.CURR_TIME_SK length = 8
                                     format = 12.
                                     informat = 12.,
         APPL_BASIC_ABT.OTE_CURR_TIME_SK length = 8
                                         format = 12.
                                         informat = 12.
      from
         abtagg.APPL_BASIC_ABT, 
         dim.account_dim
      where
         APPL_BASIC_ABT.APPLICATION_RK = account_dim.APPLICATION_RK
         and account_dim.VALID_START_DTTM <= APPL_BASIC_ABT.OUTCOME_END_DTTM
         and account_dim.VALID_END_DTTM >= APPL_BASIC_ABT.OUTCOME_START_DTTM
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Actual Good Bad calculation               A5V75JN3.BO0005LQ * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Actual Good Bad calculation                                 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_SNAPSHOT - fact.ACCOUNT_SNAPSHOT  A5V75JN3.BE0000O2 * 
 *                SQL Target - work.W5ER34W6                A5V75JN3.BP0004QX * 
 * Target Table:  SQL Target - abtscr.OTE_APPL_GOOD_BAD_TMP A5V75JN3.BP0004QY * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete OTE_APPL_GOOD_BAD_TMP;
quit;

proc sql;
   create table abtscr.OTE_APPL_GOOD_BAD_TMP as
      select
         W5ER34W6.ACCOUNT_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "_RKorSK",
         W5ER34W6.APPLICATION_RK length = 8
                                 format = 12.
                                 informat = 12.,
         max(CASE WHEN ACCOUNT_SNAPSHOT.DAYS_PAYMENT_PAST_DUE_CNT  > &ACTUAL_DLQ_DAYS THEN 1 ELSE 0 END) as ACTUAL_GOOD_BAD length = 8
                                                                                                                            format = 12.
                                                                                                                            informat = 12.
                                                                                                                            label = "_RKorSK",
         max(W5ER34W6.ACC_COLL_FLG ) as ACC_COLL_FLG length = 8
                                                     format = 12.
                                                     informat = 12.
                                                     label = "_CD"
      from
         work.W5ER34W6, 
         fact.ACCOUNT_SNAPSHOT
      where
         W5ER34W6.ACCOUNT_SK = ACCOUNT_SNAPSHOT.ACCOUNT_SK
         and ACCOUNT_SNAPSHOT.TIME_SK >= W5ER34W6.CURR_TIME_SK
         and ACCOUNT_SNAPSHOT.TIME_SK <= W5ER34W6.OTE_CURR_TIME_SK
      group by
         W5ER34W6.ACCOUNT_RK, 
         W5ER34W6.APPLICATION_RK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Append                                    A5V75JN3.BO0005LP * 
 * Transform:     Append                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: SQL Target - abtscr.OTE_APPL_GOOD_BAD_TMP A5V75JN3.BP0004QY * 
 *                APPL_REJ - abtscr.APPL_REJ                A5V75JN3.BE0004MP * 
 * Target Table:  Append Table -                            A5V75JN3.BP0004QW * 
 *                 abtagg.OTE_APPL_GOOD_BAD_ABT                               * 
 *============================================================================*/ 

%let trans_rc = 0; 

proc datasets lib = abtagg nolist nowarn memtype = (data view);
   delete OTE_APPL_GOOD_BAD_ABT;
quit;

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5N8K59F;
quit;

data _null_; 
   put "NOTE: The following column(s) do not have a column mapping, so the"
        " value(s) will be set to missing: ACC_COLL_FLG";
run; 

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.W5N8K59F as 
      select ACCOUNT_RK length = 8 format = 12. informat = 12.,
             APPLICATION_RK length = 8,
             APPL_REJ_OUTCM_FLG as ACTUAL_GOOD_BAD length = 8 format = 12. informat = 12.,
             . as ACC_COLL_FLG length = 8 format = 12. informat = 12.
         from abtscr.APPL_REJ; 
quit;

%let SYSLAST = work.W5N8K59F; 

data abtagg.OTE_APPL_GOOD_BAD_ABT;
   set abtscr.OTE_APPL_GOOD_BAD_TMP
       work.W5N8K59F;
   keep ACCOUNT_RK APPLICATION_RK ACTUAL_GOOD_BAD ACC_COLL_FLG; 
run;

%rcSet(&syserr); 

/*---- Create the indexes for a table  ----*/ 
%put %str(NOTE: Creating indexes ...);
proc datasets lib = abtagg nolist; 
   modify OTE_APPL_GOOD_BAD_ABT; 
      index create APPLICATION_RK;
quit; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005LN * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Append Table -                            A5V75JN3.BP0004QW * 
 *                 abtagg.OTE_APPL_GOOD_BAD_ABT                               * 
 * Target Table:  OTE_APPL_GOOD_BAD_ABT -                   A5V75JN3.BE0002N5 * 
 *                 abtagg.OTE_APPL_GOOD_BAD_ABT                               * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
