/****************************************************************************** 
 * Job:           SCORE_CARD_DIM                            A5MS6GQF.BP000TCD * 
 * Description:   This job builds SCORE_CARD_DIM by picking up data from      * 
 *                 MOD_VAR_GRP_SCR.                                           * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5MS6GQF * 
 * Server:        SASMain                                   A5MS6GQF.AT000001 * 
 *                                                                            * 
 * Source Table:  MOD_VAR_GRP_SCR - martscr.MOD_VAR_GRP_SCR A5MS6GQF.BH0000UX * 
 * Target Table:  SCORE_CARD_DIM - dim.SCORE_CARD_DIM       A5MS6GQF.BH0000UZ * 
 *                                                                            * 
 * Generated on:  Tuesday, December 4, 2007 1:18:32 PM IST                    * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * SCORE_CARD_DIM                                                             * 
 * Job Name: SCORE_CARD_DIMJob Desc Pre Process: NoneMain: a) To obtain       * 
 * score_card_sk by using surrogate key generator for the data from           * 
 * MOD_VAR_GRP_SCR.b) Business keys are MODEL_SK, VARIABLE_SK and             * 
 * VARIABLE_GROUP_NO.Post Process: NoneParameters: NoneDeveloped by:          * 
 *  sinsyrReviewed by:Tested by:                                              * 
 ******************************************************************************/ 



%let jobID = %quote(A5MS6GQF.BP000TCD);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = SCORE_CARD_DIM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Surrogate Key Generator                   A5MS6GQF.BQ000VOQ * 
 * Transform:     Surrogate Key Generator                                     * 
 * Description:   To obtain score_card_sk by using surrogate key generator    * 
 *                 for the data from MOD_VAR_GRP_SCR.                         * 
 *                                                                            * 
 * Source Table:  MOD_VAR_GRP_SCR - martscr.MOD_VAR_GRP_SCR A5MS6GQF.BH0000UX * 
 * Target Table:  Surrogate Key Generator - work.W5EFLW4I   A5MS6GQF.BR000TCQ * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.MOD_VAR_GRP_SCR); 

%let transformID = %quote(A5MS6GQF.BQ000VOQ); 

%let trans_rc = 0; 

/* Target table/view(s)  */ 
%let _OUTPUT = %nrquote(work.W5EFLW4I); 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5EFLW4I;
quit;

/* Options  */ 
%let options = %nrquote();
%let targetTable = %nrquote(dim.SCORE_CARD_DIM);
%let updateSource = %nrquote(NO);
%let businessKey = MODEL_SK VARIABLE_SK VARIABLE_GROUP_NO;
%let surrogateKey = SCORE_CARD_SK;

/* List of target columns to keep  */ 
%let keep = MODEL_SK VARIABLE_SK VARIABLE_GROUP_NO VARIABLE_GROUP_LABEL 
        SCORE_CARD_POINTS ACCOUNT_CNT AVERAGE_SCORE DEFAULT_CNT SCORE_CARD_SK;

%macro createSurrogateKey;

 options mprint;

 %if (%nrquote(&options) ne) %then
 %do;
   options &options;
 %end; 

 /* make sure option values are not blank */ 
 %if (%nrquote(&targetTable) eq) %then 
 %do;
   %put ERROR: Missing Target Table Option;
   %let sysrc=8000;
   %goto out;
 %end;

 %if (%nrquote(&surrogateKey) eq) %then 
 %do;
   %put ERROR: Missing Surrogate Key Column Option;
   %let sysrc=8000;
   %goto out;
 %end;
 %else %if (%scan(&surrogateKey,2,%str( ) ) ne) %then
 %do;
   %put ;
   %put WARNING: Multiple Surrogate Key Columns defined, will use first column, %scan(&surrogateKey,1,%str( ));
   %put ;
   %let sysrc=4;
   %let surrogateKey=%scan(&surrogateKey,1,%str( ));
 %end;

 %if (%nrquote(&businessKey) eq) %then 
 %do;
   %put ERROR: Missing Business Key Column Option;
   %let sysrc=8000;
   %goto out;
 %end;

 %let tsyslast = &syslast;
 %let memtype=;

 /* determine member type of source table, can't sort Views */
 proc sql noprint;
   select upcase(memtype) into :memtype from dictionary.tables 
   where libname="%upcase(%scan(%sysfunc(dequote(&tsyslast)),1,.))" and 
         memname="%upcase(%scan(%sysfunc(dequote(&tsyslast)),2,.))";
 quit;

 %let updateSource = %upcase(%nrquote(&updateSource));
 %if (%nrquote(&memtype) eq DATA) and (%nrquote(&updateSource) eq Y or %nrquote(&updateSource) eq YES) %then
   %let updateSource = Y;
 %else
   %let updateSource = N;


 proc datasets lib = %scan(&_output,1) nolist nowarn memtype = (data view);
   delete %scan(&_output,2);
 quit;

 proc sort data = &tsyslast
 
 %if (&updateSource eq N) %then
 %do; /* %if - the source cannot be updated - save to a temp table */
   out = work.sortedSource
   %let tsyslast = work.sortedSource; 
 %end; /* %if - the source cannot be updated */ 
   ;
   by &businesskey;
 run;

 %if (%sysfunc(exist(&targetTable)) eq 1) %then 
 %do; /* %if - target table exists */

   %let maxkey=0;

   proc sql noprint;
     select compress(put(max(&surrogateKey), best32.)) into :maxKey 
     from %unquote(&targetTable);
   quit;

   %if (&maxkey eq .) %then 
     %let maxkey = 0;

   proc sort data=%unquote(&targetTable) out = work.targetSorted;
     by &businesskey;
   run;

   data &_output(drop = _newkey);
     merge work.targetsorted(in = inTarget)
     &tsyslast;
     by &businesskey;
     retain _newkey &maxkey;
     if not inTarget then
     do;
       _newkey + 1;
       &surrogatekey = _newkey;
     end;
   run;

   proc datasets lib = work nolist nowarn memtype=(data view);
     delete targetSorted;
   quit;
 
 %end; /* %if - target table exists */
 %else 
 %do; /* %else - target table does not exist */
 
   data &_output;
     set &tsyslast;
     &surrogateKey + 1;
   run;
 
 %end; /* %else - target table does not exist */

 %if (%nrquote(&updateSource) eq N) %then
 %do; /* %if - can't update the source table */

  proc datasets lib = work nolist;
    delete sortedSource;
  quit;

 %end; /* %if - can't update the source table */

 %out:
%mend;

%createSurrogateKey;

%rcSet(&syserr); 
%rcSet(&sysrc); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Table Loader                              A5MS6GQF.BQ000VOR * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Surrogate Key Generator - work.W5EFLW4I   A5MS6GQF.BR000TCQ * 
 * Target Table:  SCORE_CARD_DIM - dim.SCORE_CARD_DIM       A5MS6GQF.BH0000UZ * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(work.W5EFLW4I); 

%let transformID = %quote(A5MS6GQF.BQ000VOR); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(dim.SCORE_CARD_DIM, DATA)) or 
            %sysfunc(exist(dim.SCORE_CARD_DIM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = dim.SCORE_CARD_DIM out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(SCORE_CARD_DIM);
   %let etls_lib   = %nrquote(Dimensions);
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete mapped;
   quit;
   
   %put %str(NOTE: Mapping columns ...);
   proc sql; 
      create view work.mapped as 
         select VARIABLE_GROUP_NO length = 8,
                SCORE_CARD_SK length = 8 format = 12. informat = 12.,
                VARIABLE_GROUP_LABEL length = 100 format = $100. informat = $100.,
                SCORE_CARD_POINTS length = 8,
                ACCOUNT_CNT as NO_OF_ACCOUNTS length = 8,
                DEFAULT_CNT as NO_OF_DEFAULTS length = 8,
                VARIABLE_SK length = 8,
                AVERAGE_SCORE length = 8,
                MODEL_SK length = 8 format = 12. informat = 12.
            from &etls_lastTable; 
   quit;
   
   %let SYSLAST = work.mapped; 
   
   %let etls_lastTable = &SYSLAST; 
   %let SYSOPT = ; 
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(dim.SCORE_CARD_DIM, DATA)) or 
         %sysfunc(exist(dim.SCORE_CARD_DIM, VIEW))); 
   
   %let etls_hasUpdateIndex=0; 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data dim.SCORE_CARD_DIM
              (label = 'SCORE_CARD_DIM');
         attrib VARIABLE_GROUP_NO length = 8; 
         attrib SCORE_CARD_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib VARIABLE_GROUP_LABEL length = $100 format = $100. informat = $100.; 
         attrib SCORE_CARD_POINTS length = 8; 
         attrib NO_OF_ACCOUNTS length = 8; 
         attrib NO_OF_DEFAULTS length = 8; 
         attrib VARIABLE_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib AVERAGE_SCORE length = 8; 
         attrib MODEL_SK length = 8 format = 12. informat = 12.
                   label = 'Surrogate key for the analytical model dimension.'; 
         stop;
      run;
      
      %rcSet(&syserr); 
      
      /*---- Create the indexes for a table  ----*/ 
      %put %str(NOTE: Creating indexes ...);
      proc datasets lib = dim nolist; 
         modify SCORE_CARD_DIM; 
            index create SCORE_CARD_SK
               / unique;
      quit; 
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   /* Loader CI Selections: 'ASIS','ASIS','INIT','ASIS' */
   
   %let etls_targetHasRows = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(dim.SCORE_CARD_DIM, DATA)) or 
            %sysfunc(exist(dim.SCORE_CARD_DIM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         data _null_; 
            set dim.SCORE_CARD_DIM( obs=1 ); 
            call symput("etls_targetHasRows",'1'); 
         run; 
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   
   %if (&etls_targetHasRows) %then 
   %do;  /* if has rows */ 
      proc sql ; 
         /* create a temporary table of new records from the transaction table  */ 
         create table etls_newrecords as 
            select * 
               from &etls_lastTable as t 
                  where not exists 
                     (select * from dim.SCORE_CARD_DIM as m 
                                      where m.VARIABLE_GROUP_NO=t.VARIABLE_GROUP_NO and 
                                            m.VARIABLE_SK=t.VARIABLE_SK and 
                                            m.MODEL_SK=t.MODEL_SK)
         ; 
         
      quit;
      
      %let etls_lastTable = &SYSLAST;
      
      %let SYSOPT = ; 
      
      %rcSet(&sqlrc); 
      
   %end; /* if has rows */ 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   proc append base = dim.SCORE_CARD_DIM 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_newrecords;
   quit;
   
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete mapped;
   quit;
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(dim.SCORE_CARD_DIM, DATA)) or 
            %sysfunc(exist(dim.SCORE_CARD_DIM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = dim.SCORE_CARD_DIM out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

