/****************************************************************************** 
 * Job:           SCORE_CARD_PRE_FACT                       A5V75JN3.BN0000W7 * 
 * Description:   This job picks up data from FPA_ACCT_SCR, ACCOUNT_DIM_EXT,  * 
 *                ANALYTICAL_MODEL_DIM_EXT, FINANCIAL_PRODUCT_DIM_EXT,        * 
 *                 TIME_DIM_EXT and SCORE_CARD_VARIABLE_DIM.                  * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: FPA_ACCT_SCR - martscr.FPA_ACCT_SCR       A5V75JN3.BE0000WG * 
 *                ACCOUNT_DIM_EXT - martscr.ACCOUNT_DIM_EXT A5V75JN3.BE0000MG * 
 *                FINANCIAL_PRODUCT_DIM_EXT -               A5V75JN3.BE0000MR * 
 *                 martscr.FINANCIAL_PRODUCT_DIM_EXT                          * 
 *                TIME_DIM_EXT - martscr.TIME_DIM_EXT       A5V75JN3.BE0000N6 * 
 *                SCORE_CARD_VARIABLE_DIM -                 A5V75JN3.BE0000WM * 
 *                 dim.SCORE_CARD_VARIABLE_DIM                                * 
 *                TIME_DIM - dim.TIME_DIM                   A5V75JN3.BE0000LU * 
 * Target Tables: SCORE_CARD_PRE_FACT -                     A5V75JN3.BE0000WI * 
 *                 martscr.SCORE_CARD_PRE_FACT                                * 
 *                SCORE_CARD_PRE_FACT_EXP -                 A5V75JN3.BE0000WJ * 
 *                 facterr.SCORE_CARD_PRE_FACT_EXP                            * 
 *                                                                            * 
 * Generated on:  Wednesday, December 17, 2008 1:15:53 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

%let jobID = %quote(A5V75JN3.BN0000W7);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = SCORE_CARD_PRE_FACT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Lookup to obtain sk's                     A5V75JN3.BO00011C * 
 * Transform:     Lookup                                                      * 
 * Description:   Lookup done on ACCOUNT_DIM_EXT, ANALYTICAL_MODEL_DIM_EXT,   * 
 *                FINANCIAL_PRODUCT_DIM_EXT, TIME_DIM_EXT and                 * 
 *                 SCORE_CARD_VARIABLE_DIM to obtain the respective sk's.     * 
 *                                                                            * 
 * Source Tables: FPA_ACCT_SCR - martscr.FPA_ACCT_SCR       A5V75JN3.BE0000WG * 
 *                ACCOUNT_DIM_EXT - martscr.ACCOUNT_DIM_EXT A5V75JN3.BE0000MG * 
 *                FINANCIAL_PRODUCT_DIM_EXT -               A5V75JN3.BE0000MR * 
 *                 martscr.FINANCIAL_PRODUCT_DIM_EXT                          * 
 *                TIME_DIM_EXT - martscr.TIME_DIM_EXT       A5V75JN3.BE0000N6 * 
 *                SCORE_CARD_VARIABLE_DIM -                 A5V75JN3.BE0000WM * 
 *                 dim.SCORE_CARD_VARIABLE_DIM                                * 
 *                TIME_DIM - dim.TIME_DIM                   A5V75JN3.BE0000LU * 
 * Target Tables: Lookup Target -                           A5V75JN3.BP0000XF * 
 *                 martscr.SCORE_CARD_PRE_FACT                                * 
 *                Exception WorkTable -                     A5V75JN3.BP0000XG * 
 *                 work.SCORE_CARD_FACT_EXP2                                  * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A5V75JN3.BO00011C); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete SCORE_CARD_PRE_FACT;
quit;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete SCORE_CARD_FACT_EXP2;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.SCORE_CARD_PRE_FACT
         (keep = SCORE_TIME_SK TARGET_TIME_SK MODEL_SK ACCOUNT_SK PRODUCT_SK 
                 VARIABLE_SK VARIABLE_GROUP_NO)
      work.SCORE_CARD_FACT_EXP2 
         (keep = etls_source_row etls_lookup_table etls_exception_cond 
                 etls_exception_action PRODUCT_RK ACCOUNT_RK VARIABLE_GROUP_NO 
                 SCORE_POINTS SCORE_TIME_DT MODEL_SK TARGET_TIME_DT VARIABLE_NAME 
                 TARGET_PERIOD_MTHS_CNT)
      ; 
   
   attrib SCORE_TIME_SK length=8 label="TIME_SK"
          TARGET_TIME_SK length=8 format=12. label="_RKorSK"
          MODEL_SK length=8
          ACCOUNT_SK length=8
          PRODUCT_SK length=8
          VARIABLE_SK length=8 format=12. label="_RKorSK"
          VARIABLE_GROUP_NO length=8
          ; 
   
   length etls_lookup_table $41 etls_exception_cond etls_exception_action $32 
   ACCOUNT_RK 8 PRODUCT_RK 8 TIME_SK 8 CAL_MONTH_LAST_DT 8 VARIABLE_NAME $100 ; 
   
   retain missing0 0 missing1 0 missing2 0 missing3 0 missing4 0 ; 
   
   /* Assign variables used for error/exception handling  */ 
   etls_source_row      = _n_;
   request_write_target = 0; 
   request_write_error  = 0; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table martscr.ACCOUNT_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.ACCOUNT_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "martscr.ACCOUNT_DIM_EXT", hashexp: exponent);
            h0.defineKey( "ACCOUNT_RK");
            h0.defineData( "ACCOUNT_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.ACCOUNT_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.ACCOUNT_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.ACCOUNT_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.ACCOUNT_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.ACCOUNT_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.ACCOUNT_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table martscr.FINANCIAL_PRODUCT_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.FINANCIAL_PRODUCT_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "martscr.FINANCIAL_PRODUCT_DIM_EXT", hashexp: exponent);
            h1.defineKey( "PRODUCT_RK");
            h1.defineData( "PRODUCT_SK");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.FINANCIAL_PRODUCT_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.FINANCIAL_PRODUCT_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.FINANCIAL_PRODUCT_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.FINANCIAL_PRODUCT_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.FINANCIAL_PRODUCT_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.FINANCIAL_PRODUCT_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h2 from lookup table dim.TIME_DIM */ 
      nlobs = .; 
      dsid = open("dim.TIME_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h2(dataset: "dim.TIME_DIM", hashexp: exponent);
            h2.defineKey( "CAL_MONTH_LAST_DT");
            h2.defineData( "TIME_SK");
            h2.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h2.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.TIME_DIM";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " dim.TIME_DIM";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.TIME_DIM";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " dim.TIME_DIM";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: dim.TIME_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.TIME_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h3 from lookup table martscr.TIME_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.TIME_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h3(dataset: "martscr.TIME_DIM_EXT", hashexp: exponent);
            h3.defineKey( "CAL_MONTH_LAST_DT");
            h3.defineData( "TIME_SK");
            h3.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h3.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.TIME_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.TIME_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.TIME_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.TIME_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.TIME_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.TIME_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h4 from lookup table dim.SCORE_CARD_VARIABLE_DIM */ 
      nlobs = .; 
      dsid = open("dim.SCORE_CARD_VARIABLE_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h4(dataset: "dim.SCORE_CARD_VARIABLE_DIM", hashexp: exponent);
            h4.defineKey( "VARIABLE_NAME");
            h4.defineData( "VARIABLE_SK");
            h4.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h4.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.SCORE_CARD_VARIABLE_DIM";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " dim.SCORE_CARD_VARIABLE_DIM";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.SCORE_CARD_VARIABLE_DIM";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " dim.SCORE_CARD_VARIABLE_DIM";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.SCORE_CARD_VARIABLE_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.SCORE_CARD_VARIABLE_DIM";
         
         abort 3; 
      end; 
      
      call missing (ACCOUNT_RK, ACCOUNT_SK, PRODUCT_RK, PRODUCT_SK, 
                    CAL_MONTH_LAST_DT, TIME_SK, VARIABLE_NAME, VARIABLE_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.FPA_ACCT_SCR end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find();
   
   /* Is the current key value stored in hash h1?  */ 
   rc1 = h1.find();
   
   /* Is the current key value stored in hash h2?  */ 
   CAL_MONTH_LAST_DT = TARGET_TIME_DT;
   rc2 = h2.find();
   TARGET_TIME_SK = TIME_SK;
   
   /* Is the current key value stored in hash h3?  */ 
   CAL_MONTH_LAST_DT = SCORE_TIME_DT;
   rc3 = h3.find();
   SCORE_TIME_SK = TIME_SK;
   
   /* Is the current key value stored in hash h4?  */ 
   rc4 = h4.find();
   
   /* Examine success of lookups  */ 
   if (rc0=0 and rc1=0and rc2=0and rc3=0and rc4=0) then 
   do; 
      /* Write row to target  */ 
      output martscr.SCORE_CARD_PRE_FACT; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.ACCOUNT_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.SCORE_CARD_FACT_EXP2; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.FINANCIAL_PRODUCT_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.SCORE_CARD_FACT_EXP2; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc2 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "dim.TIME_DIM"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.SCORE_CARD_FACT_EXP2; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc3 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.TIME_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.SCORE_CARD_FACT_EXP2; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc4 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "dim.SCORE_CARD_VARIABLE_DIM"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.SCORE_CARD_FACT_EXP2; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Table Loader                              A5V75JN3.BO00011D * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Exception WorkTable -                     A5V75JN3.BP0000XG * 
 *                 work.SCORE_CARD_FACT_EXP2                                  * 
 * Target Table:  SCORE_CARD_PRE_FACT_EXP -                 A5V75JN3.BE0000WJ * 
 *                 facterr.SCORE_CARD_PRE_FACT_EXP                            * 
 *============================================================================*/ 

/* Access the data for Lookup Error Tables  */ 
LIBNAME facterr BASE "Data/bisdata/error" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(work.SCORE_CARD_FACT_EXP2); 

%let transformID = %quote(A5V75JN3.BO00011D); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.SCORE_CARD_PRE_FACT_EXP, DATA)) or 
            %sysfunc(exist(facterr.SCORE_CARD_PRE_FACT_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.SCORE_CARD_PRE_FACT_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(SCORE_CARD_PRE_FACT_EXP);
   %let etls_lib   = %nrquote(Lookup Error Tables);
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(facterr.SCORE_CARD_PRE_FACT_EXP, DATA)) or 
         %sysfunc(exist(facterr.SCORE_CARD_PRE_FACT_EXP, VIEW))); 
   
   /* Check for and remove foreign keys before deleting table */ 
   %if &etls_tableExist %then 
   %do; /* table exists */
      %macro etls_CIContents(table=,workTableOut=);
         %put NOTE: Building table listing Constraints and Indexes for: &table;
         proc datasets lib=work nolist; delete &workTableOut; quit;
         proc contents data=&table noprint out2=&workTableOut; run;
         data &workTableOut;
            length name $60 type $20 icown idxUnique idxNoMiss $3 recreate $600;
            set &workTableOut;
            if ICOwn ne 'YES';
         run;
         %rcSet(&syserr); 
         
      %mend etls_CIContents;
      
      %etls_CIContents(table=facterr.SCORE_CARD_PRE_FACT_EXP, workTableOut=etls_commands);
      
      data etls_commands; 
         set etls_commands(where=(upcase(type)="FOREIGN KEY")) end=eof; 
         command='ic delete '||trim(name)||';';
      run; 
      
      data _null_;
         set etls_commands(where=(1)) end=eof;
         if _n_=1 then 
            call execute('proc datasets nolist lib=facterr;modify SCORE_CARD_PRE_FACT_EXP;');
         call execute(command);
         if eof then call execute('; quit;');
      run;
      %rcSet(&syserr); 
      
   %end; /* table exists */ 
   
   /*---- Drop a table  ----*/ 
   %put %str(NOTE: Dropping table ...);
   proc datasets lib = facterr nolist nodetails;
        delete SCORE_CARD_PRE_FACT_EXP;
   quit;
   
   %rcSet(&syserr); 
   
   %let etls_tableExist = 0;
   
   /*---- Create a new table  ----*/ 
   data facterr.SCORE_CARD_PRE_FACT_EXP
           (label = 'SCORE_CARD_PRE_FACT_EXP');
      attrib etls_source_row length = 8
                label = 'The row number in the source table'; 
      attrib etls_lookup_table length = $41
                label = 'The name of the lookup table'; 
      attrib etls_exception_cond length = $32
                label = 'The name of the condition that caused this exception'; 
      attrib etls_exception_action length = $32
                label = 'The name of the action to take for this exception'; 
      attrib PRODUCT_RK length = 8 format = 12. informat = 12.
                label = 'Product Key'; 
      attrib ACCOUNT_RK length = 8; 
      attrib VARIABLE_GROUP_NO length = 8; 
      attrib SCORE_POINTS length = 8; 
      attrib SCORE_TIME_DT length = 8; 
      attrib MODEL_SK length = 8 format = 12. informat = 12.
                label = 'Surrogate key for the analytical model dimension.'; 
      attrib TARGET_TIME_DT length = 8; 
      attrib VARIABLE_NAME length = $100; 
      attrib TARGET_PERIOD_MTHS_CNT length = 8
                label = 'Analytical model is developed to predict the probability of an event within a specified period. This period is called the Target period. This field stores the number of months of this period.'; 
      stop;
   run;
   
   %rcSet(&syserr); 
   
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=facterr nolist;
      modify SCORE_CARD_PRE_FACT_EXP;
         ic create not null (etls_source_row);
         ic create not null (etls_lookup_table);
         ic create not null (etls_exception_cond);
         ic create not null (etls_exception_action);
         ic create not null (PRODUCT_RK);
   quit;
   
   %rcSet(&syserr); 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   proc append base = facterr.SCORE_CARD_PRE_FACT_EXP 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.SCORE_CARD_PRE_FACT_EXP, DATA)) or 
            %sysfunc(exist(facterr.SCORE_CARD_PRE_FACT_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.SCORE_CARD_PRE_FACT_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO00011B * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Lookup Target -                           A5V75JN3.BP0000XF * 
 *                 martscr.SCORE_CARD_PRE_FACT                                * 
 * Target Table:  SCORE_CARD_PRE_FACT -                     A5V75JN3.BE0000WI * 
 *                 martscr.SCORE_CARD_PRE_FACT                                * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

