/****************************************************************************** 
 * Job:           SCORE_CARD_VARIABLE_FACT_PDA_DEVN         A5V75JN3.BN0003V0 * 
 * Description:   This job populates SCORE_CARD_VARIABLE_FACT for the         * 
 *                 scoring sample for Application PD Models.                  * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Generated on:  Wednesday, December 17, 2008 12:00:06 PM IST                * 
 * Generated by:  D108INA4\sasadm                                             * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Create metadata macro variables */
%let IOMServer      = %nrquote(SASMain);
%let metaPort       = %nrquote(8561);
%let metaServer     = %nrquote(D108INA4.apac.sas.com);
%let metaRepository = %nrquote(Foundation);

/* Set metadata options */
options metaport       = &metaPort 
        metaserver     = "&metaServer" 
        metarepository = "&metaRepository";

%let jobID = %quote(A5V75JN3.BN0003V0);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = SCORE_CARD_VARIABLE_FACT_PDA_DEVN;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Load score_card_variable_fact for         A5V75JN3.BO0005OD * 
 *                 application PD Model                                       * 
 * Transform:     User Written Code                                           * 
 * Description:   Load score_card_variable_fact for application PD Model      * 
 *                                                                            * 
 * Target Table:  User Written Code Target - work.          A5V75JN3.BP0004SR * 
 *                                                                            * 
 * User Written:  Load score_card_variable_fact for         A5V75JN3.AF000MNR * 
 *                 application PD Model                                       * 
 *                Load score_card_variable_fact for application PD Model      * 
 *============================================================================*/ 

%let transformID = %quote(A5V75JN3.BO0005OD); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.A5V75JN3_BP0004SR); 

/*---- Start of User Written Code  ----*/ 

/* Start of CS4.3 HF2 */ 
/* This job is added as a part of CS4.3 HF2 for catering to 
application PD Model */

/* Load SCORE_CARD_VARIABLE_FACT for scoring sample for 
application PD Model */

%load_score_card_variable_fact(model_type=&PD_APP_MODEL,dev_flg=N);

/* End of CS4.3 HF2 */
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

