/****************************************************************************** 
 * Job:           TRG_SCR_TIME_ACT_KEY                      A5V75JN3.BN0000TK * 
 * Description:   This job picks up the data from  TRG_SCR_TIME_ACT_DIM and   * 
 *                 ACCOUNT_DIM_EXT.                                           * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_DIM_EXT - martscr.ACCOUNT_DIM_EXT A5V75JN3.BE0000MG * 
 *                TRG_SCR_TIME_ACT_DIM -                    A5V75JN3.BE0000TF * 
 *                 martscr.TRG_SCR_TIME_ACT_DIM                               * 
 * Target Table:  TRG_SCR_TIME_ACT_KEY -                    A5V75JN3.BE0000TG * 
 *                 martscr.TRG_SCR_TIME_ACT_KEY                               * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 3:02:43 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = TRG_SCR_TIME_ACT_KEY;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Finding all the account keys between      A5V75JN3.BO0005N4 * 
 *                 score and target time                                      * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Finding all the account keys between score and target time  * 
 *                by inner joining tableTRG_SCR_TIME_ACT_DIM  and             * 
 *                 ACCOUNT_DIM_EXT on account_rk.                             * 
 *                                                                            * 
 * Source Tables: ACCOUNT_DIM_EXT - martscr.ACCOUNT_DIM_EXT A5V75JN3.BE0000MG * 
 *                TRG_SCR_TIME_ACT_DIM -                    A5V75JN3.BE0000TF * 
 *                 martscr.TRG_SCR_TIME_ACT_DIM                               * 
 * Target Table:  SQL Target - martscr.TRG_SCR_TIME_ACT_KEY A5V75JN3.BP0004S1 * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete TRG_SCR_TIME_ACT_KEY;
quit;

proc sql;
   create table martscr.TRG_SCR_TIME_ACT_KEY as
      select
         ACCOUNT_DIM_EXT.ACCOUNT_SK as ACC_SNAP_ACCOUNT_SK length = 8
                                                           format = 12.
                                                           informat = 12.
                                                           label = "Account Key",
         TRG_SCR_TIME_ACT_DIM.ACCOUNT_SK length = 8
                                         format = 12.
                                         informat = 12.
                                         label = "Account Key",
         TRG_SCR_TIME_ACT_DIM.SCORE_TIME_MONTH_END_DT length = 8,
         TRG_SCR_TIME_ACT_DIM.TARGET_TIME_MONTH_END_DT length = 8,
         TRG_SCR_TIME_ACT_DIM.TARGET_TIME_SK length = 8
                                             format = 12.
                                             informat = 12.,
         TRG_SCR_TIME_ACT_DIM.MODEL_SK length = 8
                                       format = 12.
                                       informat = 12.
                                       label = "Surrogate key for the analytical model dimension.",
         TRG_SCR_TIME_ACT_DIM.INTERNAL_ORG_SK length = 8
                                              format = 12.
                                              informat = 12.
                                              label = "_RKorSK",
         TRG_SCR_TIME_ACT_DIM.SCORE_TIME_SK length = 8
                                            format = 12.
                                            informat = 12.
                                            label = "_RKorSK",
         TRG_SCR_TIME_ACT_DIM.PRODUCT_SK length = 8
                                         format = 12.
                                         informat = 12.
                                         label = "_RKorSK"
      from
         martscr.TRG_SCR_TIME_ACT_DIM, 
         martscr.ACCOUNT_DIM_EXT
      where
         TRG_SCR_TIME_ACT_DIM.ACCOUNT_RK = ACCOUNT_DIM_EXT.ACCOUNT_RK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy  Loader                             A5V75JN3.BO0005N3 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - martscr.TRG_SCR_TIME_ACT_KEY A5V75JN3.BP0004S1 * 
 * Target Table:  TRG_SCR_TIME_ACT_KEY -                    A5V75JN3.BE0000TG * 
 *                 martscr.TRG_SCR_TIME_ACT_KEY                               * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A5V75JN3.AY00041C * 
 *                                                                            * 
 * User Written:  Creating index on  ACCOUNT_SK  column     A5V75JN3.AF000ML5 * 
 *                Creating index on  ACCOUNT_SK  column                       * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on  ACCOUNT_SK  column */
PROC SQL NOPRINT;
           CREATE INDEX ACCOUNT_SK
            ON martscr.TRG_SCR_TIME_ACT_KEY(ACCOUNT_SK);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

