/****************************************************************************** 
 * Job:           VARIABLE_EXT                              A5V75JN3.BN0000WA * 
 * Description:   This job picks up data from VARIABLE_GROUPS_SCOREand        * 
 *                 extracts the distinct variable names.                      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A5V75JN3 * 
 * Server:        SASMain                                   A5V75JN3.AT000001 * 
 *                                                                            * 
 * Source Table:  VARIABLE_GROUPS_MODEL -                   A5V75JN3.BE0000W5 * 
 *                 martscr.VARIABLE_GROUPS_MODEL                              * 
 * Target Table:  VARIABLE_EXT - martscr.VARIABLE_EXT       A5V75JN3.BE0000WN * 
 *                                                                            * 
 * Generated on:  Wednesday, December 10, 2008 3:03:38 PM IST                 * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A5V75JN3.BN0000WA);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = VARIABLE_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain distinct variable names         A5V75JN3.BO0005OC * 
 * Transform:     Extract                                                     * 
 * Description:   To obtain distinct variable names                           * 
 *                                                                            * 
 * Source Table:  VARIABLE_GROUPS_MODEL -                   A5V75JN3.BE0000W5 * 
 *                 martscr.VARIABLE_GROUPS_MODEL                              * 
 * Target Table:  Extract distinct variables for the model  A5V75JN3.BP0004SQ * 
 *                 - martscr.VARIABLE_EXT                                     * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.VARIABLE_GROUPS_MODEL); 

%let transformID = %quote(A5V75JN3.BO0005OC); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete VARIABLE_EXT;
quit;

proc sql; 
   create table martscr.VARIABLE_EXT as 
      select distinct VARIABLE_NAME length = 100
         from &SYSLAST; 
quit;

%let SYSLAST = martscr.VARIABLE_EXT; 

%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A5V75JN3.BO0005OB * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract distinct variables for the model  A5V75JN3.BP0004SQ * 
 *                 - martscr.VARIABLE_EXT                                     * 
 * Target Table:  VARIABLE_EXT - martscr.VARIABLE_EXT       A5V75JN3.BE0000WN * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

