/**********************************************************************************************
       Module: feed_measure
     Function: This macro gives the overview of table MODEL_MEASURE_FACT.

      Authors:  BIS Team
         Date:  05 April 2006
          SAS:  9.1
    Called-by:	All report screens. 

        Calls:  NA

Datasets used:  No input datasets required for processing of the macro.
 
        Logic:  This macro accepts a distinct list of measure names and returns
                Measure values and boundries this measures

				
   Parameters: 
		INPUT: 
				in_filter 		 		:	where clause .
				out_lib_nm				:	where the dataset will be created.
				in_table_nm				:	Distinct list of measure names
				out_table_nm_measure	:	Measure values and boundries for the measure names 
                                            supplied in the "in_table_nm" macro parameter


**********************************************************************************************/
%macro feed_measure(in_filter=, out_lib_nm=, in_table_nm=, out_table_nm_measure=);
/*CS4.3 HF2 */
/*Measure code is added that need to be used for using by statment in stored process for 
  joining the dataset to get the actual and modeling value.*/
proc sql;
create table &out_lib_nm..&out_table_nm_measure. AS 
SELECT ANALYTICAL_MODEL_DIM.MODEL_TYPE_CD, 
	ANALYTICAL_MODEL_DIM.MODEL_PRODUCT_TYPE_CD, 
	MEASURE_DIM.measure_cd,
	MEASURE_DIM.MEASURE_NM, MEASURE_DIM.SEQ_NO, MEASURE_DIM.BOUND_RED, 
	MEASURE_DIM.LEVEL_DESC, MEASURE_DIM.BOUND_GREEN, 
	MEASURE_DIM.PROGRAM_NM, MODEL_MEASURE_FACT.SCORE_TIME_SK, 
	MODEL_MEASURE_FACT.MEASURE_SK, MODEL_MEASURE_FACT.MEASURE_VALUE, 
	MODEL_MEASURE_FACT.MODEL_SK, MODEL_MEASURE_FACT.DEV_FLG,
	TIME_DIM.CAL_MONTH_LAST_DT AS CAL_MON_LAST_DT 
FROM FACT.MODEL_MEASURE_FACT 	
	INNER JOIN DIM.MEASURE_DIM 
	ON (MODEL_MEASURE_FACT.MEASURE_SK = MEASURE_DIM.MEASURE_SK)  	
	INNER JOIN DIM.ANALYTICAL_MODEL_DIM 
	ON (MODEL_MEASURE_FACT.MODEL_SK = ANALYTICAL_MODEL_DIM.MODEL_SK)  
	INNER JOIN DIM.TIME_DIM 
	ON (MODEL_MEASURE_FACT.SCORE_TIME_SK = TIME_DIM.TIME_SK) 
	INNER JOIN &out_lib_nm..&in_table_nm
	ON (&in_table_nm..MEASURE_NM = MEASURE_DIM.MEASURE_NM)
	&in_filter 

		 ; 
quit;

%mend feed_measure;
