%global abtvars modsk modstr;
/* Loading macro aliases for the rest of the stored processes */
%select_abt_vars_screen_links;

/* Alias for the back-end library */
%let lib=analytic;

/* Setting output library based on the debug flag */
%let out_lib=;
%debug_lib_path;

%macro save_abt_details;
		%let error_code1=NONE;

		/*Proc printto will redirect the log to the directory
		"Data/bisdata/error". */
		%global log_name;
		data _NULL_;
		name=put(time(),mmss8.1);
		name1=kscan(name,1,":.");
		name2=kscan(name,2,":.");
		name3=kscan(name,3,":."); 
		name4=ktrim(kleft(name1))||ktrim(kleft(name2))||ktrim(kleft(name3));
		call symput('log_name',"Data/bisdata/log/scr_abt_master."||ktrim(kleft(name4))||".log");
		run;

		%put NOTE: Sending log messages to :&log_name;

		proc printto log="&log_name";
		quit;
		
			%let cnt=0;
			%let max_abt_no=0;
			proc sql noprint;
				select count(*) into :cnt
				from &lib..scr_abt_master
				where scr_abt_nm=kcompress("&save_scr_abt_name");
			
				select max(scr_a_no) into :max_abt_no
				from &lib..scr_abt_master;
			quit;

			%let cnt=&cnt;
			%let max_abt_no=&max_abt_no;

			%let no_records=0;
			proc sql noprint;
				select count(*) into :no_records
				from &lib..scr_abt_x_model
				where scr_a_no=&save_scr_abt_key;
			quit;
			%let no_records=&no_records;

			%let no_varrecords=0;
			proc sql noprint;
				select count(*) into :no_varrecords
				from &lib..scr_abt_x_var
				where scr_a_no=&save_scr_abt_key;
			quit;

			%let no_varrecords = &no_varrecords;			

		%if %str(&cnt) eq %str(0) %then %do;
			%if %str(&max_abt_no) eq %str(.) %then %let abt_key=1;
			%else %let abt_key=%eval(&max_abt_no+1);
			
			proc sql noprint;
				insert into &lib..scr_abt_master
				(SCR_A_NO, SCR_ABT_NM, SCR_ABT_TABLE_NM, SCR_ABT_DESC, SCR_L_NO, ABT_PHY_TABLE_NM) 
				VALUES(&abt_key, "&save_scr_abt_name", "&save_scr_abt_table_name", "&save_scr_abt_desc",
				&save_scr_level_key, "");
			quit;
			%if &sqlrc = 8 %then
			%do;
				%let error_code1 = ERROR;
			%end;					
			
			proc sort data=dim.analytical_model_dim out=work.model_srt;
				by model_sk;
			quit;

			data &out_lib..model_selection(keep=scr_a_no model_sk is_selected_flg);
				length scr_a_no 8.;
				length model_sk 8.;
				length is_selected_flg $1.;
				retain cnt 1;
				set work.model_srt(keep=model_sk deployment_status_cd
					where=(deployment_status_cd not in ("&EXP_MODEL_DEPLOYMENT")));
				scr_a_no = &abt_key;
				if indexw("&modsk",model_sk)>0 then is_selected_flg = "Y";
				else is_selected_flg = "N";
			run;

			proc sql noprint;
				select l_no into :cust_lvl 
				from &lib..abt_level
				where level_desc like '%Customer%';

				create table &out_lib..var_cat as
				select distinct Var_master.var_category, strip(var_sub_category) as var_sub_category, 
				strip(var_group) as var_group, v_no, strip(var_short_nm) as var_short_nm, 
				strip(var_desc) as var_desc
				from &lib..Var_master
				where l_no = &save_scr_level_key or l_no = &cust_lvl
				order by var_category, var_sub_category, var_group;
			quit;

			/* Sort it. */
			proc sort data=&out_lib..var_cat out=&out_lib..var_cat;
				by v_no;
			quit;

			data &out_lib..var_selection(keep=scr_a_no v_no is_selected_flg);
				length scr_a_no 8.;
				length v_no 8.;
				length is_selected_flg $1.;
				retain cnt 1;
				set &out_lib..var_cat(keep=v_no);
				scr_a_no = &abt_key;
				if indexw("&abtvars", v_no)>0 then do;
					is_selected_flg = "Y";
					output;
				end;
			run;
		%end;
		%else %if %str(&cnt) ne %str(0) and (%str(&save_scr_abt_key) ne %str(.) or
			%str(&save_scr_abt_key) ne %str()) %then %do;
			proc sql;
			update &lib..scr_abt_master set
				scr_abt_desc="&save_scr_abt_desc"					
			where scr_a_no=&save_scr_abt_key and scr_abt_nm="&save_scr_abt_name";
			quit;
			%if &sqlrc = 8 %then
			%do;
			%let error_code1 = ERROR;
			%end;
		%end;		

		/*Proc printto will reset the log redirection */
		proc printto;
		quit; 

		%put NOTE: Resetting log to _webout;
		/*End of proc printto */

		data _null_;
			file _webout &webout_options;
			put '<html>';
			put '<body>';
			put '<form name="form1" action="/SASStoredProcess/do" method="post">';
			put '<input type="hidden" name="_program" value="">';
			put '<script language="JavaScript" type="text/JavaScript"> ';
			put '<!-- ';
		
		%if %str(&error_code1) eq %str(ERROR) %then %do;
			put '	alert("' @ ;
			put "%sysfunc(sasmsg(smd_ds.bismsg,abt.scr_tmplt_stp4_alert1.1, noquote))"@;
			put '")';
		%end;
		run;

		%let error_code2=NONE;

		/*Proc printto will redirect the log to the directory
		"Data/bisdata/error". */
		%global log_name;
		data _NULL_;
		name=put(time(),mmss8.1);
		name1=kscan(name,1,":.");
		name2=kscan(name,2,":.");
		name3=kscan(name,3,":."); 
		name4=ktrim(kleft(name1))||ktrim(kleft(name2))||ktrim(kleft(name3));
		call symput('log_name',"Data/bisdata/log/scr_abt_link."||ktrim(kleft(name4))||".log");
		run;

		%put NOTE: Sending log messages to :&log_name;

		proc printto log="&log_name";
		quit;		

		/* If it is a new ABT definition, insert it into the table */
		%if %str(&no_records) eq %str(0) %then %do;
			proc append data=&out_lib..model_selection base=&lib..scr_abt_x_model force;
			quit;
		%end;
		%else %if %str(&no_records) ne %str(0) and (%str(&save_scr_abt_key) ne %str(.) or
			%str(&save_scr_abt_key) ne %str()) %then %do;
			proc sort data=&lib..scr_abt_x_model out=work.scr_abt_x_model_srt;
				by scr_a_no model_sk;
			quit;

			proc sort data=dim.analytical_model_dim out=work.model_srt;
				by model_sk;
			quit;

			data &out_lib..model_selection(keep=scr_a_no model_sk is_selected_flg);
				length scr_a_no 8.;
				length model_sk 8.;
				length is_selected_flg $1.;
				retain cnt 1;
				set work.model_srt(keep=model_sk deployment_status_cd
					where=(deployment_status_cd not in ("&EXP_MODEL_DEPLOYMENT")));
				scr_a_no = &save_scr_abt_key;
				if indexw("&modsk",model_sk)>0 then is_selected_flg = "Y";
				else is_selected_flg = "N";
			run;

			proc sort data=&out_lib..model_selection out=work.model_selection_srt;
				by scr_a_no model_sk;
			quit;

			data &lib..scr_abt_x_model;
				merge work.scr_abt_x_model_srt(in=A) work.model_selection_srt(in=B);
				by scr_a_no model_sk;
			run;

			proc sql noprint;
				select l_no into :cust_lvl 
				from &lib..abt_level
				where level_desc like '%Customer%';

				create table &out_lib..var_cat as
				select distinct Var_master.var_category, strip(var_sub_category) as var_sub_category, 
				strip(var_group) as var_group, v_no, strip(var_short_nm) as var_short_nm, 
				strip(var_desc) as var_desc
				from &lib..Var_master
				where l_no = &save_scr_level_key or l_no = &cust_lvl
				order by var_category, var_sub_category, var_group;
			quit;

			/* Sort it. */
			proc sort data=&out_lib..var_cat out=&out_lib..var_cat;
				by v_no;
			quit;

			data &out_lib..var_selection(keep=scr_a_no v_no is_selected_flg);
				length scr_a_no 8.;
				length v_no 8.;
				length is_selected_flg $1.;
				retain cnt 1;
				set &out_lib..var_cat(keep=v_no);
				scr_a_no = &save_scr_abt_key;
				if indexw("&abtvars", v_no)>0 then do;
					is_selected_flg = "Y";
					output;
				end;
			run;	
		%end;

		/*Proc printto will reset the log redirection */
		proc printto;
		quit; 

		%put NOTE: Resetting log to _webout;
		/*End of proc printto */

		/* Show the relevant messages on the screen */
		data _null_;
			file _webout &webout_options;
		%if %str(&error_code2) eq %str(ERROR) %then %do;
			put '	alert("' @ ;
			put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_savefailed.1, noquote))"@;
			put "&log_name"@;
			put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_frfurtherdtls.1, noquote))"@;
			put '")';
		%end;
		run;

		%let error_code3=NONE;

		/*Proc printto will redirect the log to the directory
		"Data/bisdata/error". */
		%global log_name;
		data _NULL_;
		name=put(time(),mmss8.1);
		name1=kscan(name,1,":.");
		name2=kscan(name,2,":.");
		name3=kscan(name,3,":."); 
		name4=ktrim(kleft(name1))||ktrim(kleft(name2))||ktrim(kleft(name3));
		call symput('log_name',"Data/bisdata/log/abt_scr."||ktrim(kleft(name4))||".log");
		run;

		%put NOTE: Sending log messages to :&log_name;

		proc printto log="&log_name";
		quit;		

		/* If it is a new ABT definition, append it to the table */
		%if %str(&no_varrecords) eq %str(0) %then %do;
			proc append data=&out_lib..var_selection base=&lib..scr_abt_x_var force;
			quit;
		%end;
		/* If it is an existing ABT definition, merge the records with the table */
		%else %if %str(&no_varrecords) ne %str(0) and (%str(&save_scr_abt_key) ne %str(.) or
			%str(&save_scr_abt_key) ne %str()) %then %do;
			proc sort data=&lib..scr_abt_x_var out=work.scr_abt_x_var_srt;
				by scr_a_no v_no;
			quit;

			proc sort data=&out_lib..var_selection out=work.var_selection_srt;
				by scr_a_no v_no;
			quit;

			data &lib..scr_abt_x_var;
				merge work.scr_abt_x_var_srt(in=A) work.var_selection_srt(in=B);
				by scr_a_no v_no; /* removed the if B; statement for CS 4.3 HF2*/
			run;		
		%end;

		/*Proc printto will reset the log redirection */
		proc printto;
		quit; 

		%put NOTE: Resetting log to _webout;
		/*End of proc printto */

		/* Show the relevant messages on the screen */
		data _null_;
			file _webout &webout_options;
		%if %str(&error_code3) eq %str(ERROR) %then %do;
			put '	alert("' @ ;
			put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_abtvarselntsaved.1, noquote))"@;
			put "&log_name"@;
			put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_frfurtherdtls.1, noquote))"@;
			put '")';
		%end;
		%else %do;
			put '	alert("' @ ;
			put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_abtvarselsaved.1, noquote))"@;
			put '");';			
		%end;
			put "form1._program.value=&SCR_TEMPLATE_LIST;";
			put 'form1.submit();';			
			put '//-->';
			put	'</script> ';
			put '</body>';
			put '</html>';			
		run;
%mend save_abt_details;
%save_abt_details;
