 /**
 * <p>Title: ColumnsPanel</p>
 * <p>Description: Class populates tree of available objects for export.</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */
 package com.sas.metadata.imp;

import java.awt.Component;
import java.awt.Cursor;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.SystemColor;
import java.io.File;
import java.io.FilenameFilter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.TreeSet;
import java.util.Vector;

import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JTree;
import javax.swing.ListCellRenderer;
import javax.swing.event.TreeExpansionEvent;
import javax.swing.event.TreeExpansionListener;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;

import com.sas.metadata.CMetadata;
import com.sas.metadata.MdException;
import com.sas.metadata.MdObjectStore;
import com.sas.plugins.PluginResourceBundle;
import com.sas.swing.visuals.dualselector.DualSelectorInterface;
import com.sas.swing.visuals.dualselector.JTreeDualSelectorAdapter;
import com.sas.swing.visuals.dualselector.TreeListSelector;
import com.sas.workspace.MessageUtil;
import com.sas.workspace.OpRequestUI;
import com.sas.workspace.WAComboBox;
import com.sas.workspace.WAPanel;
import com.sas.workspace.WAWizardDialog;
import com.sas.workspace.WAdminResource;
import com.sas.workspace.Workspace;

public class ColumnsPanel extends WAPanel
{
	
	private String path;
	
	protected void setVariables(String p_path,String p_reposid){
		path=p_path;
		m_reposId = p_reposid;
	}
	
	
    private class cPhysicalTableComparator implements Comparator    {
        public int compare(Object obj, Object obj1) {
        	String physicaltable = (String)obj;
            String physicaltable1 = (String)obj1;
            return physicaltable.compareToIgnoreCase(physicaltable1);
        }

        private cPhysicalTableComparator()
        {        	 
        }
    }

    class cTreeListSelector extends TreeListSelector {
	    public synchronized void transferItems(DualSelectorInterface dualselectorinterface, DualSelectorInterface dualselectorinterface1)
        {
	      	 
	      	Vector vector = new Vector();
            int i = -1;
            if(dualselectorinterface == super.sourceAdapter)
                i = super.getTargetMaximumCount();
            int j = dualselectorinterface.getSelectedCount();
            int k = dualselectorinterface.getLastSelectedIndex();
            java.util.List list;
            if(j > 0)
                list = dualselectorinterface.getSelectedItems();
            else
                list = null;
            if(list != null)
                synchronized(dualselectorinterface){
                    synchronized(dualselectorinterface1) {
                        int l = list.size() + dualselectorinterface1.getCount();
                        if(i == -1 || l <= i)
                        {
                            if(!super.copyModeEnabled || super.copyModeEnabled && dualselectorinterface == super.targetAdapter)
                                dualselectorinterface.removeItems(list);
                            if(!super.copyModeDuplicatesAllowed)
                            {
                                for(int i1 = 0; i1 < list.size(); i1++)
                                {
                                    DefaultMutableTreeNode defaultmutabletreenode = (DefaultMutableTreeNode)((TreePath)list.get(i1)).getLastPathComponent();
                                    if(defaultmutabletreenode.getUserObject() instanceof String)
                                    {
                                        String cmetadata = (String)defaultmutabletreenode.getUserObject();
                                        String s1 = cmetadata;//.getName();
                                        if(_DupFoundInSelectedItems(list, s1, i1))
                                            list.remove(i1--);
                                        else if (cmetadata
												.equalsIgnoreCase("Cubes")
												|| cmetadata
														.equalsIgnoreCase("Groups")
												|| cmetadata
														.equalsIgnoreCase("Jobs")
												|| cmetadata
														.equalsIgnoreCase("Libraries")
												|| cmetadata
														.equalsIgnoreCase("Prototypes")
												|| cmetadata
														.equalsIgnoreCase("Tables")
												|| cmetadata
														.equalsIgnoreCase("InfoMaps")
												|| cmetadata
														.equalsIgnoreCase("ExternalTables")
												|| cmetadata
														.equalsIgnoreCase("Portlets")
                                        		|| cmetadata
														.equalsIgnoreCase("StoredProcesses")
												|| cmetadata
														.equalsIgnoreCase("MiningModels"))
											list.remove(i1--);
                                    } else
                                    {
                                        list.remove(i1--);
                                    }
                                }

                                java.util.List list1 = dualselectorinterface1.getAllItems();
                                int k1 = list1.size();
                                int l1 = list.size();
                                for(int i2 = l1 - 1; i2 >= 0; i2--)
                                {
                                    DefaultMutableTreeNode defaultmutabletreenode1 = (DefaultMutableTreeNode)((TreePath)list.get(i2)).getLastPathComponent();
                                    String column1 = (String)defaultmutabletreenode1.getUserObject();
                                    String s2 = column1;//.getName();
                                    for(int j2 = 0; j2 <= k1 - 1; j2++)
                                    {
                                        if(list.get(i2).equals(list1.get(j2)))
                                        {
                                            list.remove(i2);
                                            break;
                                        }
                                        if(!(dualselectorinterface1.getComponent() instanceof JList))
                                            continue;
                                        DefaultMutableTreeNode defaultmutabletreenode2 = (DefaultMutableTreeNode)((TreePath)list1.get(j2)).getLastPathComponent();
                                        if(!(defaultmutabletreenode2.getUserObject() instanceof String))
                                            continue;
                                        String column2 = (String)defaultmutabletreenode2.getUserObject();
                                        String s3 = column2;//.getName();
                                        if(!s2.equalsIgnoreCase(s3))
                                            continue;
                                        vector.addElement(s2);
                                        list.remove(i2);
                                        break;
                                    }

                                }

                            }
                            if(vector.size() > 0)
                            {
                                if(dualselectorinterface instanceof JTreeDualSelectorAdapter)
                                {
                                    String s = ColumnsPanel.m_bundle.getString("ColumnsPanel.DuplicateColumns.Removed.Header.txt");
                                    MessageUtil.displayListMessage(s, vector);
                                }
                                vector.clear();
                            }
                            if(list.size() > 0 && (super.copyModeEnabled && dualselectorinterface == sourceAdapter || !super.copyModeEnabled))
                                dualselectorinterface1.addItems(list);
                            if(!super.copyModeEnabled)
                                k = (k - j) + 1;
                            int j1 = dualselectorinterface.getCount();
                            if(k >= j1)
                                k = j1 - 1;
                            dualselectorinterface.setSelectedIndex(k);
                        }
                    }
                }
        }

        private boolean _DupFoundInSelectedItems(java.util.List list, String s, int i)
        {
        	
            if(s.trim().length() == 0)
                return false;
            for(int j = i; j < list.size(); j++)
            {
                DefaultMutableTreeNode defaultmutabletreenode = (DefaultMutableTreeNode)((TreePath)list.get(j)).getLastPathComponent();
                if(defaultmutabletreenode.getUserObject() instanceof String)
                {
                	String column = (String)defaultmutabletreenode.getUserObject();
                    String s1 = column;//.getName();
                    if(s1.compareToIgnoreCase(s) == 0 && j != i)
                        return true;
                }
            }

            return false;
        }

        JDialog m_dialog;

        cTreeListSelector()
        {
            m_dialog = null;
        }
    }

    public class cSelectionListener
        implements TreeSelectionListener
    {

        public void valueChanged(TreeSelectionEvent treeselectionevent)
        {
        	
        	DefaultMutableTreeNode defaultmutabletreenode = (DefaultMutableTreeNode)treeselectionevent.getPath().getLastPathComponent();
            String cmetadata = (String)defaultmutabletreenode.getUserObject();
            if(cmetadata != null)
                
               if(cmetadata.compareTo("Tables") == 0 
                	|| cmetadata.compareTo("Cubes") == 0
                	|| cmetadata.compareTo("Libraries") == 0
                	|| cmetadata.compareTo("Groups") == 0
                	|| cmetadata.compareTo("Prototypes") == 0
                	|| cmetadata.compareTo("InfoMaps") == 0
                	|| cmetadata.compareTo("ExternalTables") == 0
                	|| cmetadata.compareTo("Portlets") == 0
                	|| cmetadata.compareTo("StoredProcesses") == 0
                	|| cmetadata.compareTo("MiningModels") == 0
                	|| cmetadata.compareTo("Jobs") == 0)
                {
                    if(defaultmutabletreenode.getChildCount() <= 0)
                    {
                        String s = ColumnsPanel.m_bundle.getString("ColumnsPanel.BuildColumnInfoProgressIndicator.Message.txt");
                        String s1 = ColumnsPanel.m_bundle.getString("ColumnsPanel.BuildColumnInfoProgressIndicator.Title.txt");
                        String s2 = ColumnsPanel.m_bundle.getString("ColumnsPanel.BuildColumnInfoProgressIndicator.Description.txt");
                        OpRequestUI oprequestui = new OpRequestUI(m_workspace, s, s1, s2);
                        oprequestui.setDelayBeforeProgressCancelDialog(200);
                        oprequestui.execute(new cRunnable(cmetadata, defaultmutabletreenode));
                    } else
                    if(treeselectionevent.getPaths().length > 1)
                        _removeTableNode(treeselectionevent);
                } else
                if(!m_ResetSelection)
                    _removeTableNode(treeselectionevent);
        }

        private void _removeTableNode(TreeSelectionEvent treeselectionevent)
        {
            TreePath atreepath[] = treeselectionevent.getPaths();
            int i = atreepath.length;
            TreePath atreepath2[] = new TreePath[i];
            int k = 0;
            boolean flag = false;
            for(int l = 0; l < i; l++)
            {
                String cmetadata = (String)((DefaultMutableTreeNode)atreepath[l].getLastPathComponent()).getUserObject();
                if(cmetadata.compareTo("Tables") == 0 || cmetadata.compareTo("Cubes") == 0|| cmetadata.compareTo("Jobs") == 0|| cmetadata.compareTo("Groups") == 0||  cmetadata.compareTo("InfoMaps") == 0||  cmetadata.compareTo("Portlets") == 0||  cmetadata.compareTo("StoredProcesses") == 0||  cmetadata.compareTo("MiningModels") == 0||cmetadata.compareTo("Prototypes") == 0||cmetadata.compareTo("ExternalTables") == 0|| cmetadata.compareTo("Libraries") == 0)
                    atreepath2[k++] = atreepath[l];
                else
                    flag = true;
            }

            if(k > 0 && flag)
            {
                JTree jtree = (JTree)treeselectionevent.getSource();
                TreePath atreepath3[] = jtree.getSelectionPaths();
                int i1 = atreepath3.length;
                int j = 0;
                TreePath atreepath1[] = new TreePath[i1];
                for(int j1 = 0; j1 < i1; j1++)
                {
                    boolean flag1 = false;
                    for(int k1 = 0; k1 < k; k1++)
                        if(atreepath2[k1].equals(atreepath3[j1]))
                            flag1 = true;

                    if(!flag1)
                        atreepath1[j++] = atreepath3[j1];
                }

                m_ResetSelection = true;
                jtree.setSelectionPaths(atreepath1);
                m_ResetSelection = false;
            }
        }

        boolean m_ResetSelection;

        public cSelectionListener()
        {
            m_ResetSelection = false;
        }
    }

    /**
	 * Inner listener class 
	 * Listens the tree expansion node  
	 * Implements TreeExpansionListener
	 */
    public class cExpansionListener
        implements TreeExpansionListener
    {

    	/**
    	 * @param TreeExpansionEvent 
    	 * accepts event and expand the tree node   
    	 * @return void
    	 */
    	public void treeExpanded(TreeExpansionEvent treeexpansionevent)
        {
            DefaultMutableTreeNode defaultmutabletreenode = (DefaultMutableTreeNode)treeexpansionevent.getPath().getLastPathComponent();
            String cmetadata = (String)defaultmutabletreenode.getUserObject();
            if(cmetadata.compareTo("Tables") == 0 
                	|| cmetadata.compareTo("Cubes") == 0
                	|| cmetadata.compareTo("Libraries") == 0
                	|| cmetadata.compareTo("Groups") == 0
                	|| cmetadata.compareTo("Prototypes") == 0
                	|| cmetadata.compareTo("InfoMaps") == 0
                	|| cmetadata.compareTo("Portlets") == 0
                	|| cmetadata.compareTo("StoredProcesses") == 0
                	|| cmetadata.compareTo("ExternalTables") == 0
                	|| cmetadata.compareTo("MiningModels") == 0
                	|| cmetadata.compareTo("Jobs") == 0)
                {
            if(cmetadata != null && (cmetadata instanceof String) && defaultmutabletreenode.getChildCount() <= 0)
            {
                String s = ColumnsPanel.m_bundle.getString("ColumnsPanel.BuildColumnInfoProgressIndicator.Message.txt");
                String s1 = ColumnsPanel.m_bundle.getString("ColumnsPanel.BuildColumnInfoProgressIndicator.Title.txt");
                String s2 = ColumnsPanel.m_bundle.getString("ColumnsPanel.BuildColumnInfoProgressIndicator.Description.txt");
                OpRequestUI oprequestui = new OpRequestUI(m_workspace, s, s1, s2);
                oprequestui.setDelayBeforeProgressCancelDialog(200);
                oprequestui.execute(new cRunnable(cmetadata, defaultmutabletreenode));
            }
        }
        }

    	/**
    	 * @param TreeExpansionEvent 
    	 * accepts event and collapse the tree node   
    	 * @return void
    	 */
        public void treeCollapsed(TreeExpansionEvent treeexpansionevent)
        {
        }

        /**
    	 * @param no parameter  
    	 * Constructor    
    	 * @return void
    	 */
        public cExpansionListener()
        {
        }
    }

    /**
	 * Inner renderer class 
	 * Renders the item for target list box  
	 * Implements ListCellRenderer
	 */
    public class TargetListCellRenderer
        implements ListCellRenderer
    {

    	/**
    	 * @param JList, Object, int, boolean, boolean
    	 * @return java.awt.Compenent 
    	 */
    	public Component getListCellRendererComponent(JList jlist, Object obj, int i, boolean flag, boolean flag1)
        {
        	
        	JLabel jlabel = new JLabel();
            if(obj instanceof TreePath)
            {
                TreePath treepath = (TreePath)obj;
                
                String column = (String)((DefaultMutableTreeNode)treepath.getLastPathComponent()).getUserObject();
                TreeNode TNPar = (TreeNode)((DefaultMutableTreeNode)treepath.getLastPathComponent()).getParent();

                column = column.substring(column.indexOf("#")+1); //*********
                
                jlabel.setText(column);//.getName());

                String s = TNPar.toString();//.getCMetadataType();
                
                if(s.compareTo("Cubes") == 0)
                    jlabel.setIcon(m_CubeIcon);
                else if(s.compareTo("Tables") == 0)
                    jlabel.setIcon(m_PhysicalTableIcon);
                else if(s.compareTo("Jobs") == 0)
                	jlabel.setIcon(m_JobIcon);
                else if(s.compareTo("Prototypes") == 0)
                	jlabel.setIcon(m_PrototypeIcon);
                else if(s.compareTo("Libraries") == 0)
                	jlabel.setIcon(m_LibIcon);
                else if(s.compareTo("Groups") == 0)
                	jlabel.setIcon(m_GrpIcon);
                else if(s.compareTo("InfoMaps") == 0)
                	jlabel.setIcon(m_MapIcon);
                else if(s.compareTo("Portlets") == 0)
                	jlabel.setIcon(m_ReportIcon);
                else if(s.compareTo("StoredProcesses") == 0)
                	jlabel.setIcon(m_ProcessIcon);
                else if(s.compareTo("ExternalTables") == 0)
                	jlabel.setIcon(m_ExternalTableIcon);
                else if(s.compareTo("MiningModels") == 0)
                	jlabel.setIcon(m_MinerIcon);
            }
            jlabel.setOpaque(true);
            if(flag)
            {
                jlabel.setBackground(SystemColor.textHighlight);
                jlabel.setForeground(SystemColor.textHighlightText);
            } else
            {
                jlabel.setBackground(SystemColor.window);
                jlabel.setForeground(SystemColor.textText);
            }
            return jlabel;
        }

        public TargetListCellRenderer()
        {
        }
    }

    /**
	 * Inner renderer class 
	 * Renders the item for target list box  
	 * extends ListCellRenderer
	 */
    public class SourceTreeCellRenderer extends DefaultTreeCellRenderer
    {
    	public Component getTreeCellRendererComponent(JTree jtree, Object obj, boolean flag, boolean flag1, boolean flag2, int i, boolean flag3)
        {
            JLabel jlabel = new JLabel();
            
            if(obj instanceof DefaultMutableTreeNode)
            {
                DefaultMutableTreeNode defaultmutabletreenode = (DefaultMutableTreeNode)obj;
                String strObj = (String)defaultmutabletreenode.getUserObject();
     
                if(strObj != null) {
                	String s = strObj.substring(strObj.indexOf("#")+1); // *******
                	
                	jlabel.setText(s);
                	
                	if(s.compareTo("Cubes") == 0)
                	{
                		jlabel.setIcon(m_CubeIcon);
                	} else if(s.compareTo("Tables") == 0)
                	{
                		jlabel.setIcon(m_PhysicalTableIcon);
                	} else if (s.compareTo("Jobs") == 0) {
                		jlabel.setIcon(m_JobIcon);
                	} else if (s.compareTo("Prototypes") == 0) {
                		jlabel.setIcon(m_PrototypeIcon);
                	} else if (s.compareTo("Libraries") == 0) {
                		jlabel.setIcon(m_LibIcon);
                	} else if (s.compareTo("InfoMaps") == 0) {
                		jlabel.setIcon(m_MapIcon);
                	}else if (s.compareTo("Portlets") == 0) {
                		jlabel.setIcon(m_ReportIcon);
                	}else if (s.compareTo("StoredProcesses") == 0) {
                		jlabel.setIcon(m_ProcessIcon);
                	}else if (s.compareTo("ExternalTables") == 0) {
                		jlabel.setIcon(m_ExternalTableIcon);
                	}else if(s.compareTo("Objects") == 0 ){
                		jlabel.setIcon(m_ObjectIcon);
                	}else if (s.compareTo("MiningModels") == 0) {
                		jlabel.setIcon(m_MinerIcon);
                	}else if (s.compareTo("Groups") == 0) {
                		jlabel.setIcon(m_GrpIcon);
                	} else {
                		// Set the icon
                		TreeNode parent = defaultmutabletreenode.getParent();
                		if (parent != null) {
                			s = parent.toString();
                			if (s.compareTo("Cubes") == 0) {
                				jlabel.setIcon(m_CubeIcon);
                			} else if (s.compareTo("Tables") == 0) {
                				jlabel.setIcon(m_PhysicalTableIcon);
                			} else if (s.compareTo("Jobs") == 0) {
                				jlabel.setIcon(m_JobIcon);
                			} else if (s.compareTo("Prototypes") == 0) {
                				jlabel.setIcon(m_PrototypeIcon);
                			}else if(s.compareTo("Objects") == 0 ){
                				jlabel.setIcon(m_ObjectIcon);
                			} else if (s.compareTo("Libraries") == 0) {
                				jlabel.setIcon(m_LibIcon);
                			} else if (s.compareTo("InfoMaps") == 0) {
                				jlabel.setIcon(m_MapIcon);
                			} else if (s.compareTo("Portlets") == 0) {
                				jlabel.setIcon(m_ReportIcon);
                			}else if (s.compareTo("StoredProcesses") == 0) {
                				jlabel.setIcon(m_ProcessIcon);
                			}else if (s.compareTo("ExternalTables") == 0) {
                				jlabel.setIcon(m_ExternalTableIcon);
                			}else if (s.compareTo("MiningModels") == 0) {
                				jlabel.setIcon(m_MinerIcon);
                			}else if (s.compareTo("Groups") == 0) {
                				jlabel.setIcon(m_GrpIcon);
                			}
                		}
                	}
                } else {
					jlabel.setText(defaultmutabletreenode.toString());
					jlabel.setIcon(m_EnvironmentIcon);
				}
            }
            jlabel.setOpaque(true);
            setOpenIcon(m_EnvironmentIcon);
            if(flag)
            {
                jlabel.setBackground(SystemColor.textHighlight);
                jlabel.setForeground(SystemColor.textHighlightText);
            } else
            {
                jlabel.setBackground(SystemColor.window);
                jlabel.setForeground(SystemColor.textText);
            }
            return jlabel;
        }

        public SourceTreeCellRenderer()
        {
        }
    }

    protected class cRunnable
        implements Runnable
    {

        public void run()
        {
                m_columnsSelector.setCursor(Cursor.getPredefinedCursor(3));
                /**
                 * getDirObjList method fetches all files from directory 
                 * supplied in the parameter
                 * @param m_physicalTableTrial: Directory Name e.g. Cubes, Tables 
                 * Name is exactly same as the actual physical directory supplied
                 * @param path: Supplied path where the solution exists
                 * */
                List associationlist = getDirObjList(m_physicalTableTrial,path);
                
                TreeSet treeset1 = new TreeSet(new cPhysicalTableComparator());
                treeset1.addAll(((java.util.Collection) (associationlist)));
                Iterator iterator = treeset1.iterator(); 
                
                if(associationlist.size() > 0)
                {
                	while(iterator.hasNext())
                    {
                		String s = (String)iterator.next();
                		s = cUtilityClass.resolveName(s);
                        DefaultMutableTreeNode defaultmutabletreenode = new DefaultMutableTreeNode(s);
                        m_oAvailableTreeModel.insertNodeInto(defaultmutabletreenode, m_treeNode, m_treeNode.getChildCount());
                        defaultmutabletreenode.setAllowsChildren(false);
                    }

                }
                m_oAvailableTreeModel.reload(m_treeNode);
                m_columnsSelector.setCursor(Cursor.getDefaultCursor());
        }

        /**
		 * @param tableTrial
		 * @param path
		 * @return
		 */
		private List getDirObjList(String tableTrial, String path) {
			
			File SolutionDir = new File(path);
			
			File typeDir;
			List finalObjects = new Vector();
			String[] SolutionSubDir = SolutionDir.list();
			
			String[] finalObjectsList;
			
			for(int i=0;i<SolutionSubDir.length;i++){
					
				typeDir = new File(path+"\\"+SolutionSubDir[i]);
				if(typeDir.isDirectory()){
					if(tableTrial.equalsIgnoreCase(SolutionSubDir[i])){
							finalObjectsList = typeDir.list(new DirFilter(".xml"));
							for(int k=0;k<finalObjectsList.length;k++){
								finalObjects.add(SolutionSubDir[i]+"#"+finalObjectsList[k]);//********
							}
						}
				 }
			}
		setLength(tableTrial,finalObjects.size());	
		return finalObjects;
			
		}
		/*
		 * Class to filter xml or sas files from the given path 
		 * [Added on 21st Dec]
		 */
		class DirFilter implements FilenameFilter{
			String afn;
			DirFilter(String afn) { 
				this.afn = afn; 
			}
			public boolean accept(File dir, String name) {
				// Strip path information:
				String f = new File(name).getName();
				return ((f.indexOf(afn) != -1) || (f.indexOf(".sas") != -1));
			}
		} 

			
		private void setLength(String Name,int i)
		{			
			if("Cubes".equalsIgnoreCase(Name))
			{
				iCube = i;
			}
			else if("Groups".equalsIgnoreCase(Name)){
				iGrp = i;				
			}
			else if("Jobs".equalsIgnoreCase(Name))
			{
				iJob = i;
			}
			else if("Libraries".equalsIgnoreCase(Name)){
				iLib = i;	
			}
			else if("Prototypes".equalsIgnoreCase(Name)){
				iUWC = i;
			}
			else if("Tables".equalsIgnoreCase(Name)){
				iPT = i;				
			}else if("InfoMaps".equalsIgnoreCase(Name)){
				iMap = i;				
			}else if("Portlets".equalsIgnoreCase(Name)){
				iPortlets = i;				
			}else if("StoredProcesses".equalsIgnoreCase(Name)){
				iProc = i;				
			}else if("MiningModels".equalsIgnoreCase(Name)){
				iModels = i;				
			}else if("ExternalTables".equalsIgnoreCase(Name)){
				iExternalTables = i;				
			}
			
		}// end of setLength
		
		CMetadata m_physicalTable;
        String m_physicalTableTrial ;
        DefaultMutableTreeNode m_treeNode;

        cRunnable(String cmetadata, DefaultMutableTreeNode defaultmutabletreenode)
        {
            m_physicalTableTrial = cmetadata;
            m_treeNode = defaultmutabletreenode;
        }
    }


    public ColumnsPanel()
    {
        m_workspace = Workspace.getWorkspace();
        bundle = new PluginResourceBundle( ColumnsPanel.class );
        m_parent = null;
        m_store = null;
        m_repos = null;
        m_reposId = null;
        m_columns = new Vector(0);
        m_sourceTables = new Vector(0);
        selectedJobs = new Vector();
        selectedPrototypes = new Vector();
        selectedCubes= new Vector();
        selectedMaps = new Vector();
        selectedPortlets = new Vector();
        selectedProcesses = new Vector();
        selectedExternalTables= new Vector();
        selectedModels = new Vector();
        selectedTables= new Vector();
        selectedTrees= new Vector();
        selectedLibs= new Vector();       
        
        m_CubeIcon = bundle.getImageIcon("Common.Cube.image");
        m_LibIcon = bundle.getImageIcon("Common.Lib.image" );
        m_GrpIcon = bundle.getImageIcon("Common.Grp.image" );
        m_JobIcon = bundle.getImageIcon("Common.Job.image" );
        m_PrototypeIcon = bundle.getImageIcon("UserCode.image" );
        m_ObjectIcon = bundle.getImageIcon("ObjectIcon.image" );
        m_MapIcon = bundle.getImageIcon("Common.Map.image" );
        m_ReportIcon = bundle.getImageIcon("Common.Report.image" );
        m_ProcessIcon = bundle.getImageIcon("Common.Process.image" );
        m_ExternalTableIcon = bundle.getImageIcon("Common.ExternalProcess.image" );
        m_MinerIcon= bundle.getImageIcon("Common.Model.image" );
        m_PhysicalTableIcon = bundle.getImageIcon("Common.PhysicalTable.image" );
        m_EnvironmentIcon = bundle.getImageIcon("Common.Environment.image");
        _initialize();
    }


    public void saveSettingsAndCleanUp()
    {
        m_columnsSelector.removeAll();
        m_workspace = null;
        m_parent = null;
        m_store = null;
        m_repos = null;
        m_reposId = null;
        m_sourceTables = null;
        m_columnsSelector = null;
        m_oAvailableTreeModel = null;
        m_oSelectedListModel = null;
    }

    public void setRepository(CMetadata cmetadata)
    {
    	m_repos = cmetadata;
    }

    public void setStore(MdObjectStore mdobjectstore)
    {
        m_store = mdobjectstore;
    }

    public boolean doDataExchange(boolean flag)
        throws MdException
    {
    	
            _setWizardDataVars();
            if(!flag)
            {
                m_oAvailableTreeModel.setRoot(new DefaultMutableTreeNode("Objects"));
                DefaultMutableTreeNode defaultmutabletreenode = (DefaultMutableTreeNode)m_oAvailableTreeModel.getRoot();
                defaultmutabletreenode.setAllowsChildren(true);
                Object obj = new Vector(0);
                obj = ObjTypesImport();
                TreeSet treeset = new TreeSet(new cPhysicalTableComparator());
                treeset.addAll(((java.util.Collection) (obj)));
                DefaultMutableTreeNode defaultmutabletreenode1;
                for(Iterator iterator = treeset.iterator(); iterator.hasNext(); m_oAvailableTreeModel.insertNodeInto(defaultmutabletreenode1, defaultmutabletreenode, defaultmutabletreenode.getChildCount()))
                {
                    String physicaltable = (String)iterator.next();
                    defaultmutabletreenode1 = new DefaultMutableTreeNode(physicaltable);
                    defaultmutabletreenode1.setAllowsChildren(true);
                }

                m_oAvailableTreeModel.reload();
                return true;
            } else
            {
                return true;
            }
       
       
    }

    /**
	 * @return
	 */
	private List ObjTypesImport() {
		
		List Obj = new Vector();
		//String[] strObjTypes = {"Cubes","Jobs","Tables","Libraries","Groups","Prototypes","InfoMaps","StoredProcesses","MiningModels","Reports"};
		//String[] strObjTypes = {"Cubes","Jobs","Tables","Libraries","Groups","Prototypes","InfoMaps","StoredProcesses","MiningModels", "Portlets"};
		String[] strObjTypes = {"Cubes","Jobs","Tables","Libraries","Groups","Prototypes","InfoMaps","StoredProcesses","MiningModels","ExternalTables"};
		for(int t=0;t<strObjTypes.length;t++){
			Obj.add(strObjTypes[t]);
		}
		return Obj;
	}


	public Vector getColumns()
    {
    	return m_columns;
    }

    public Vector getSourceTables()
    {
        return m_sourceTables;
    }

    public java.util.List getSelectedTables()
    {
        int i = m_cmbTargetTables.getSelectedIndex();
        if(i == 0)
        {
            return m_lTargetTables;
        } else
        {
            ArrayList arraylist = new ArrayList(1);
            arraylist.add(m_lTargetTables.get(i - 1));
            return arraylist;
        }
    }

    public boolean validateData()
    {
    	
    	//for(Iterator iterator = m_columns.iterator(); iterator.hasNext(); ((Column)iterator.next()).delete());
        //m_columns.removeAllElements();
        selectedCubes.removeAllElements();
        selectedJobs.removeAllElements();
        selectedPrototypes.removeAllElements();
        selectedTables.removeAllElements();
        selectedMaps.removeAllElements();
        selectedPortlets.removeAllElements();
        selectedProcesses.removeAllElements();
        selectedExternalTables.removeAllElements();
        selectedModels.removeAllElements();
        selectedTrees.removeAllElements();
        selectedLibs.removeAllElements();
        //m_sourceTables.removeAllElements();
        
        
        for(int k =0;k<m_oSelectedListModel.size();k++){
        	
        	TreePath treepath = (TreePath)m_oSelectedListModel.elementAt(k);
        	//CMetadata column = (CMetadata)((DefaultMutableTreeNode)treepath.getLastPathComponent()).getUserObject();
        	String column = (String)((DefaultMutableTreeNode)treepath.getLastPathComponent()).getUserObject();
        	TreeNode TNParent = (TreeNode)((DefaultMutableTreeNode)treepath.getLastPathComponent()).getParent();
            String type = TNParent.toString();//column.getCMetadataType();
            column =  column.substring(column.indexOf("#")+1); //********
            column = cUtilityClass.UnresolveName(column);
           
            if(type.equalsIgnoreCase("Cubes")){
            	selectedCubes.add(column);
            } if(type.equalsIgnoreCase("Jobs")){
            	selectedJobs.add(column);	
            }if(type.equalsIgnoreCase("Prototypes")){
            	selectedPrototypes.add(column);	
            } if(type.equalsIgnoreCase("Tables")){
            	selectedTables.add(column);
            }if(type.equalsIgnoreCase("InfoMaps")){
            	selectedMaps.add(column);	
            }if(type.equalsIgnoreCase("Portlets")){
            	selectedPortlets.add(column);	
            }if(type.equalsIgnoreCase("StoredProcesses")){
            	selectedProcesses.add(column);	
            	            	
            }if(type.equalsIgnoreCase("ExternalTables")){
            	selectedExternalTables.add(column);	
            }if(type.equalsIgnoreCase("MiningModels")){
            	selectedModels.add(column);	
            } if(type.equalsIgnoreCase("Libraries")){
            	selectedLibs.add(column);
            } if(type.equalsIgnoreCase("Groups")){
            	selectedTrees.add(column);
            }
           
        }
        
        return true;
    }

    public List getSelCubes(){
    return selectedCubes;
    }
    
    public List getSelJobs(){
        return selectedJobs;
    }
    public List getSelMaps(){
        return selectedMaps;
    }
    public List getSelPortlets(){
        return selectedPortlets;
    }
    public List getSelProcesses(){
        return selectedProcesses;
    }
    public List getSelExternalTables(){
        return selectedExternalTables;
    }
    
    public List getSelModels(){
        return selectedModels;
    }
    
    public List getSelPrototypes(){
        return selectedPrototypes;
    }
    public List getSelTables(){
        return selectedTables;
    }
    
    public List getSelLibs(){
        return selectedLibs;
    }
    public List getSelTrees(){
        return selectedTrees;
    }
    private void _initialize()
    {
      
        m_columnsSelector = new cTreeListSelector();
        m_oAvailableTreeModel = new DefaultTreeModel(new DefaultMutableTreeNode());
        m_oAvailableTreeModel.setAsksAllowsChildren(true);
        m_oSelectedListModel = new DefaultListModel();
        m_columnsSelector.setModel(m_oAvailableTreeModel);
        //m_columnsSelector.setSourceLabel(m_bundle.getString("ColumnsPanel.AvailableColumns.txt"));
        m_columnsSelector.setSourceLabel("Available Objects");
        ((JLabel)m_columnsSelector.getSourceLabelComponent()).setDisplayedMnemonic(m_bundle.getString("ColumnsPanel.AvailableColumns.mnem").charAt(0));
        m_columnsSelector.setSourceCellRenderer(new SourceTreeCellRenderer());
        m_columnsSelector.setTargetModel(m_oSelectedListModel);
        m_columnsSelector.setTargetLabel("Selected Objects");
        ((JLabel)m_columnsSelector.getTargetLabelComponent()).setDisplayedMnemonic(m_bundle.getString("ColumnsPanel.SelectedColumns.mnem").charAt(0));
        m_columnsSelector.setTargetCellRenderer(new TargetListCellRenderer());
        m_columnsSelector.setTransferAllControlsVisible(false);
        m_columnsSelector.setDragAndDropEnabled(false);
        m_columnsSelector.setTargetControlsVisible(true);
        m_columnsSelector.setCopyModeEnabled(true);
        m_columnsSelector.setCopyModeDuplicatesAllowed(false);
        m_columnsSelector.setParentNodesMoveable(false);
        JTree jtree = (JTree)m_columnsSelector.getSourceComponent();
        jtree.addTreeExpansionListener(new cExpansionListener());
        jtree.addTreeSelectionListener(new cSelectionListener());
        setLayout(new GridBagLayout());
        if(m_bMultiTables)
        {
            add(m_lblTargetTables, new GridBagConstraints(0, 0, 1, 1, 0.0D, 0.0D, 17, 0, new Insets(0, 0, 0, 0), 0, 0));
            add(m_cmbTargetTables, new GridBagConstraints(1, 0, 1, 1, 1.0D, 0.0D, 17, 2, new Insets(0, 10, 0, 0), 0, 0));
            add(m_columnsSelector, new GridBagConstraints(0, 1, 2, 1, 1.0D, 1.0D, 18, 1, new Insets(10, 0, 0, 0), 0, 0));
        } else
        {
            add(m_columnsSelector, new GridBagConstraints(0, 0, 1, 1, 1.0D, 1.0D, 18, 1, new Insets(0, 0, 0, 0), 0, 0));
        }
    }

    private void _setWizardDataVars()
    {
        if(m_parent == null)
        {
            java.awt.Container container = getTopLevelAncestor();
            if(container instanceof WAWizardDialog)
            {
                m_parent = (WAWizardDialog)getTopLevelAncestor();
                m_store = (MdObjectStore)m_parent.getWizardData("OBJECTSTORE");
                m_repos = (CMetadata)m_parent.getWizardData("REPOSITORY");
            }
        }
    }

    static Class _mthclass$(String s)
    {
        try
        {
            return Class.forName(s);
        }
        catch(ClassNotFoundException classnotfoundexception)
        {
            throw new NoClassDefFoundError(classnotfoundexception.getMessage());
        }
    }

    static WAdminResource m_bundle;
    private Workspace m_workspace;
    private WAWizardDialog m_parent;
    private MdObjectStore m_store;
    private CMetadata m_repos;
    private String m_reposId;
    protected boolean m_bMultiTables;
    protected java.util.List m_lTargetTables;
    protected JLabel m_lblTargetTables;
    protected WAComboBox m_cmbTargetTables;
    private Vector m_columns;
    private Vector m_sourceTables;
    protected TreeListSelector m_columnsSelector;
    protected DefaultTreeModel m_oAvailableTreeModel;
    protected DefaultListModel m_oSelectedListModel;
    private final ImageIcon m_PhysicalTableIcon;
    private final ImageIcon m_JobIcon;
    private final ImageIcon m_PrototypeIcon;
    private final ImageIcon m_CubeIcon;
    private final ImageIcon m_LibIcon;
    private final ImageIcon m_GrpIcon;
    private final ImageIcon m_EnvironmentIcon;
    private final ImageIcon m_MapIcon;
    private final ImageIcon m_ObjectIcon;
    private final ImageIcon m_ReportIcon;
    private final ImageIcon m_ProcessIcon;
    private final ImageIcon m_ExternalTableIcon;
    private final ImageIcon m_MinerIcon;
    private static PluginResourceBundle bundle ;
    private Vector selectedJobs;
    private Vector selectedPrototypes;
    private Vector selectedCubes;
    private Vector selectedTables;
    private Vector selectedTrees;
    private Vector selectedMaps;
    private Vector selectedPortlets;
    private Vector selectedProcesses;
    private Vector selectedExternalTables;
    private Vector selectedModels;
    private Vector selectedLibs;
    int iCube = 0;
    int iJob = 0;
    int iPT = 0;
    int iUWC = 0;
    int iLib = 0;
    int iMap = 0;
    int iPortlets = 0;
    int iProc = 0;
    int iModels = 0;
    int iExternalTables = 0;
    int iGrp = 0;    
    
    
     
    static 
    {
        m_bundle = new WAdminResource(ColumnsPanel.class);
        
    }
}