/**
 * <p>Title: ComboBoxList</p>
 * <p>Description: Class associates check box with list items</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */
package com.sas.metadata.imp;

import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Vector;

import javax.swing.JCheckBox;
import javax.swing.JList;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;



public class ComboBoxList extends JList {
  protected static Border noFocusBorder =
                                new EmptyBorder(1, 1, 1, 1);
  public ComboBoxList() {
    setCellRenderer(new CellRenderer());

    addMouseListener(new MouseAdapter()
       {
          public void mousePressed(MouseEvent e)
          {
             int index = locationToIndex(e.getPoint());

             if (index != -1) {
                JCheckBox checkbox = (JCheckBox)
                            getModel().getElementAt(index);
                checkbox.setSelected(
                                   !checkbox.isSelected());
                repaint();
             }
          }
       }
    );

    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
  }
  protected class CellRenderer implements ListCellRenderer
  {
     public Component getListCellRendererComponent(
                   JList list, Object value, int index,
                   boolean isSelected, boolean cellHasFocus)
     {
        JCheckBox checkbox = (JCheckBox) value;
        checkbox.setBackground(isSelected ?
                getSelectionBackground() : getBackground());
        checkbox.setForeground(isSelected ?
                getSelectionForeground() : getForeground());
        checkbox.setEnabled(isEnabled());
        checkbox.setFont(getFont());
        checkbox.setFocusPainted(false);
        checkbox.setBorderPainted(true);
        checkbox.setBorder(isSelected ?
         UIManager.getBorder("List.focusCellHighlightBorder") : noFocusBorder);
        return checkbox;
     }
  }

  public String[] getCheckedItems()
  {
    Vector v = new Vector();
    for(int i=0; i < getModel().getSize(); i++)
    {
      JCheckBox checkbox = (JCheckBox)
                  getModel().getElementAt(i);
      if(checkbox.isSelected())
      {
        v.addElement(checkbox.getText());
      }
    }
    return (String[])v.toArray(new String[0]);
  }
}
