 /**
 * <p>Title: ComparePanel</p>
 * <p>Description: Panel class for comparision page</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */
 

package com.sas.metadata.imp;


import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.util.HashMap;
import java.util.List;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;

import com.sas.metadata.Job;
import com.sas.metadata.MdException;
import com.sas.metadata.MdObjectStore;
import com.sas.metadata.PhysicalTable;
import com.sas.wadmin.visuals.WAPFDEditorOMAView;
import com.sas.workspace.WAPanel;
import com.sas.workspace.WASplittablePropertyFrame;
import com.sas.workspace.WAWizardDialog;
import com.sas.workspace.WAdminResource;
import com.sas.workspace.WsAbstractAction;
import com.sas.workspace.WsViewFactory;

/**
 * @author sinajs
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class ComparePanel  extends WAPanel{
	 /** Property bundle */
	   //private static PluginResourceBundle bundle = new PluginResourceBundle( ComparePanel.class );

	   private WAWizardDialog m_parent = null;
	   String fullReposid;
	   MdObjectStore m_store ;
	   HashMap hmTableMap;
	   HashMap hmCubeMap;
	   HashMap hmExternalTableMap;
	   HashMap hmMetaTablesFile;
	   String m_path;
	   WAdminResource m_bundle ;
	
	   /** Boolean to turn on a border around this panel */
	   protected boolean             m_fBorder=false;

	   
	   
   //Tabbed pane and layouts 
	JTabbedPane jTabbedPane1 = new JTabbedPane();

	//Controls on pane 1
	
	CheckBoxList lstTabNew = new CheckBoxList();
	//CheckBoxList lstTabExisting = new CheckBoxList();
	
	 JTable table = new JTable() {
		public void tableChanged(TableModelEvent e) {
			super.tableChanged(e);
			repaint();
		}
	};
	
	// Page 2
	CheckBoxList lstJobNew = new CheckBoxList();
	JTable tblJobExisting = new JTable(){
		public void tableChanged(TableModelEvent e) {
			super.tableChanged(e);
			repaint();
		}
	};
//	CheckBoxList lstJobExisting = new CheckBoxList();

	// Page 3
	CheckBoxList lstCubeNew = new CheckBoxList();
	CheckBoxList lstCubeExisting = new CheckBoxList();
	
	// Page 4
	CheckBoxList lstLibNew = new CheckBoxList();
	CheckBoxList lstLibExisting = new CheckBoxList();
	
	// Page 5
	CheckBoxList lstPrototypeNew = new CheckBoxList();
	CheckBoxList lstPrototypeExisting = new CheckBoxList();
	
	CheckBoxList lstMapNew = new CheckBoxList();
	CheckBoxList lstMapExisting = new CheckBoxList();

	CheckBoxList lstPortletNew = new CheckBoxList();
	CheckBoxList lstPortletExisting = new CheckBoxList();
	
	CheckBoxList lstProcessNew = new CheckBoxList();
	CheckBoxList lstProcessExisting = new CheckBoxList();

	CheckBoxList lstModelNew = new CheckBoxList();
	CheckBoxList lstModelExisting = new CheckBoxList();
    
	CheckBoxList lstExternalTableNew = new CheckBoxList();
	CheckBoxList lstExternalTableExisting = new CheckBoxList();
	
	
	/**
	 * Constructs a ComparePanel
	 * @param fBorder - create a border around this panel (true) or not (false)
	 * @param WAdminResource - Pickup the original resource of import wizard
	 * @return Nothing
	 */

	public ComparePanel(boolean fBorder, WAdminResource bundle )
	   {
	      super();
	      m_fBorder = fBorder;
	      m_bundle = bundle; 
	      initialize();
	      layoutWidgets();
	   }

	protected void topuptable(){
		
		try{
			
			TableColumn tc1 = table.getColumn("Decision");
			TableColumn tc2 = table.getColumn("TableName");
			JTableHeader anHeader = table.getTableHeader();

			tc1.setPreferredWidth(80);
			tc2.setPreferredWidth(230);
			String[] s = {"NoAction", "Import", "Add XML Colmn", "OverWrite","Del Meta Colmn","Update","Add XML Del Meta","Update Table","Update All"};
		if(tc1 != null )
		tc1.setCellRenderer(new ComboBoxItemRenderer(s));
		tc1.setWidth(0);
		table.setRowHeight(24);
		
		table.getColumn("Decision").setCellEditor(new ComboBoxEditor(s));
		}catch(Exception e){
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		}
	}
	
	protected void topupJobTable(){
		
		try{
			
			TableColumn tc1 = tblJobExisting.getColumn("Decision");
			TableColumn tc2 = tblJobExisting.getColumn("JobName");
			JTableHeader anHeader = tblJobExisting.getTableHeader();

			tc1.setPreferredWidth(80);
			tc2.setPreferredWidth(230);
			String[] s = {"NoAction", "Import", "OverWrite","Update"};
		if(tc1 != null )
		tc1.setCellRenderer(new ComboBoxItemRenderer(s));
		tc1.setWidth(0);
		tblJobExisting.setRowHeight(24);
		
		tblJobExisting.getColumn("Decision").setCellEditor(new ComboBoxEditor(s));
		}catch(Exception e){
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		}
	}
	
	   /**
	    * Initialization routine.  Creates and initializes all of the widgets
	    * on the panel.
	    */
	   public void initialize()
	   {      
	      super.initialize();
	   }//end public void initialize()
	   
	   protected void setModel(DefaultTableModel m){
	   	table.setModel(m);
	   }
	   protected void setJobModel(DefaultTableModel m){
		   tblJobExisting.setModel(m);
	   }
	   /**
	    * Validate the data on the panel.
	    */
	   public boolean validateData()
	   {      
	      return true;
	   }//end public boolean validateData()
	 
	   /**
	    * Just like in a property tab, this method is called before the panel 
	    * is made visible to do the model/view data exchange.
	    * @param saveToModel true - move widget values to model values;
	    *                    false - move model values to widgets values
	    */
	   public boolean doDataExchange(boolean bSaveToModel) throws MdException
	   {		 
	   	if (m_parent == null) {
			m_parent = (WAWizardDialog) this.getTopLevelAncestor();
		}
	   	      return true;
	   }//end public boolean doDataExchange(boolean bsaveToModel) throws MdException
	   
	   
	   /**
	    * Arrange the widgets in displayed panel.
	    *
	    */
	   public void layoutWidgets()
	   {
		   	WAPanel myPanel = new WAPanel();
		   	
		   	myPanel.setLayout(new GridLayout(1,2));
		    myPanel.add( jTabbedPane1 );
		    add( myPanel, null );
		 
		    InitializeTablePage();
		    InitializeJobPage();
		    InitializeCubePage();
		    InitializeLibPage();
		    InitializePrototypePage();
		    InitializeMapPage();
		    InitializeProcessPage();
		    InitializeModelPage();
		    InitializeExternalTablePage();
		    //InitializePortletPage();


	   }//end public void layoutWidgets()
	   
	   private void InitializeTablePage(){

	    JButton butImpact = new JButton();
	    butImpact.setText("Impact analysis");
		butImpact.addActionListener(new cImpactAction());
		
	    JButton butReverse = new JButton();
	    butReverse.setText("Reverse impact analysis");
		butReverse.addActionListener(new cReverseImpactAction());
		
		JButton butTabDiff = new JButton();
		butTabDiff.setText("Table difference");
		butTabDiff.addActionListener(new cTableDiffAction());
		
		
		
		WAPanel TabPanel = new WAPanel();

		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		JScrollPane scrollNewTable = new JScrollPane(lstTabNew);
		scrollNewTable.setPreferredSize(new Dimension(250, 140));
		
		// ******* WORKING ON JTABLE INSIDE *******//
		
		table.setAutoResizeMode(0);
		JScrollPane scrollExistTable = new JScrollPane(table);
		scrollExistTable.setPreferredSize(new Dimension(250, 210));
		
		WAPanel newTab = new WAPanel();
		WAPanel existTab = new WAPanel();
		newTab.setLayout(new BorderLayout());
		existTab.setLayout(new BorderLayout());
		newTab.add(new JLabel("New Tables"), BorderLayout.PAGE_START);
		newTab.add(scrollNewTable, BorderLayout.CENTER);
		existTab.add(new JLabel("Existing Tables"), BorderLayout.PAGE_START);
		existTab.add(scrollExistTable, BorderLayout.CENTER);
		TabPanel.add(newTab);
		TabPanel.add(existTab);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		ButtonBox.add(butImpact);
		ButtonBox.add(butReverse);
		ButtonBox.add(butTabDiff);
		
		
		//ButtonBox.add(butMinimize);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Tables", centerPanel);


	   }
    
	   private void InitializeJobPage(){

	    JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		butView.setText("View Existing Job");
		butView.addActionListener(new cViewJob());
		
				
		JScrollPane scrollNewJob = new JScrollPane(lstJobNew);
		scrollNewJob.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistJob = new JScrollPane(tblJobExisting);
		scrollExistJob.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newJob = new WAPanel();
		WAPanel existJob = new WAPanel();
		
		newJob.setLayout(new BorderLayout());
		existJob.setLayout(new BorderLayout());
		
		newJob.add(new JLabel("New Jobs"), BorderLayout.PAGE_START);
		newJob.add(scrollNewJob, BorderLayout.CENTER);
		
		existJob.add(new JLabel("Existing Jobs"), BorderLayout.PAGE_START);
		existJob.add(scrollExistJob, BorderLayout.CENTER);
		
		TabPanel.add(newJob);
		
		TabPanel.add(existJob);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Jobs", centerPanel);


	   }

	   private void InitializeCubePage(){

//	    JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
//		butView.setText("View Existing Cube Property");
//		butView.addActionListener(new cViewCubeProperty());
		
		
		
		JScrollPane scrollNewCube = new JScrollPane(lstCubeNew);
		scrollNewCube.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistCube = new JScrollPane(lstCubeExisting);
		scrollExistCube.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newCube = new WAPanel();
		WAPanel existCube = new WAPanel();
		
		newCube.setLayout(new BorderLayout());
		existCube.setLayout(new BorderLayout());
		
		newCube.add(new JLabel("New Cubes"), BorderLayout.PAGE_START);
		newCube.add(scrollNewCube, BorderLayout.CENTER);
		
		existCube.add(new JLabel("Existing Cubes"), BorderLayout.PAGE_START);
		existCube.add(scrollExistCube, BorderLayout.CENTER);
		
		TabPanel.add(newCube);
		
		TabPanel.add(existCube);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
//		ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Cubes", centerPanel);


	   }
	   
	   private void InitializeExternalTablePage(){

//		    JButton butView = new JButton();
			
			WAPanel TabPanel = new WAPanel();
			
			TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
			TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
			TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
			
//			butView.setText("View Existing Cube Property");
//			butView.addActionListener(new cViewCubeProperty());
			
			
			
			JScrollPane scrollNewExternalTable = new JScrollPane(lstExternalTableNew);
			scrollNewExternalTable.setPreferredSize(new Dimension(250, 175));
			
			JScrollPane scrollExistExternalTable = new JScrollPane(lstExternalTableExisting);
			scrollExistExternalTable.setPreferredSize(new Dimension(250, 175));
			
			WAPanel newExternalTable = new WAPanel();
			WAPanel existExternalTable = new WAPanel();
			
			newExternalTable.setLayout(new BorderLayout());
			existExternalTable.setLayout(new BorderLayout());
			
			newExternalTable.add(new JLabel("New ExternalTables"), BorderLayout.PAGE_START);
			newExternalTable.add(scrollNewExternalTable, BorderLayout.CENTER);
			
			existExternalTable.add(new JLabel("Existing ExternalTables"), BorderLayout.PAGE_START);
			existExternalTable.add(scrollExistExternalTable, BorderLayout.CENTER);
			
			TabPanel.add(newExternalTable);
			
			TabPanel.add(existExternalTable);
			Box ButtonBox = Box.createHorizontalBox();
			ButtonBox.add(Box.createHorizontalStrut(10));
//			ButtonBox.add(butView);
			WAPanel centerPanel = new WAPanel();
			centerPanel.setLayout(new BorderLayout(10, 10));
			centerPanel.add(TabPanel, BorderLayout.CENTER);
			centerPanel.add(ButtonBox, BorderLayout.SOUTH);
			jTabbedPane1.addTab("ExternalTable", centerPanel);

		   }
	   
	   private void InitializeLibPage(){

	    //JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		//butView.setText("View Lib Property");
		//butView.addActionListener(new cViewLibProp());
		
		
		
		JScrollPane scrollNewLib = new JScrollPane(lstLibNew);
		scrollNewLib.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistLib = new JScrollPane(lstLibExisting);
		scrollExistLib.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newLib = new WAPanel();
		WAPanel existLib = new WAPanel();
		
		newLib.setLayout(new BorderLayout());
		existLib.setLayout(new BorderLayout());
		
		newLib.add(new JLabel("New Library"), BorderLayout.PAGE_START);
		newLib.add(scrollNewLib, BorderLayout.CENTER);
		
		existLib.add(new JLabel("Existing Library"), BorderLayout.PAGE_START);
		existLib.add(scrollExistLib, BorderLayout.CENTER);
		
		TabPanel.add(newLib);
		
		TabPanel.add(existLib);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		//ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Library", centerPanel);


	   }
	   
	   private void InitializePrototypePage(){

	    //JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		//butView.setText("View Prototype Property");
		//butView.addActionListener(new cViewProtoProp());
		
		JScrollPane scrollNewLib = new JScrollPane(lstPrototypeNew);
		scrollNewLib.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistLib = new JScrollPane(lstPrototypeExisting);
		scrollExistLib.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newLib = new WAPanel();
		WAPanel existLib = new WAPanel();
		
		newLib.setLayout(new BorderLayout());
		existLib.setLayout(new BorderLayout());
		
		newLib.add(new JLabel("New Prototype"), BorderLayout.PAGE_START);
		newLib.add(scrollNewLib, BorderLayout.CENTER);
		
		existLib.add(new JLabel("Existing Prototype"), BorderLayout.PAGE_START);
		existLib.add(scrollExistLib, BorderLayout.CENTER);
		
		TabPanel.add(newLib);
		
		TabPanel.add(existLib);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		//ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Prototype", centerPanel);


	   }
	   
	   private void InitializeMapPage(){

	    //JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		//butView.setText("View Prototype Property");
		//butView.addActionListener(new cViewProtoProp());
		
		JScrollPane scrollNewMap = new JScrollPane(lstMapNew);
		scrollNewMap.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistMap = new JScrollPane(lstMapExisting);
		scrollExistMap.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newMap = new WAPanel();
		WAPanel existMap = new WAPanel();
		
		newMap.setLayout(new BorderLayout());
		existMap.setLayout(new BorderLayout());
		
		newMap.add(new JLabel("New InfoMaps"), BorderLayout.PAGE_START);
		newMap.add(scrollNewMap, BorderLayout.CENTER);
		
		existMap.add(new JLabel("Existing InfoMaps"), BorderLayout.PAGE_START);
		existMap.add(scrollExistMap, BorderLayout.CENTER);
		
		TabPanel.add(newMap);
		
		TabPanel.add(existMap);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		//ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("InfoMaps", centerPanel);


	   }
	   
	   
	   private void InitializePortletPage(){

	    //JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		//butView.setText("View Prototype Property");
		//butView.addActionListener(new cViewProtoProp());
		
		JScrollPane scrollNewPortlet = new JScrollPane(lstPortletNew);
		scrollNewPortlet.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistPortlet = new JScrollPane(lstPortletExisting);
		scrollExistPortlet.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newPortlet = new WAPanel();
		WAPanel existPortlet = new WAPanel();
		
		newPortlet.setLayout(new BorderLayout());
		existPortlet.setLayout(new BorderLayout());
		
		newPortlet.add(new JLabel("New Portlets"), BorderLayout.PAGE_START);
		newPortlet.add(scrollNewPortlet, BorderLayout.CENTER);
		
		existPortlet.add(new JLabel("Existing Portlets"), BorderLayout.PAGE_START);
		existPortlet.add(scrollExistPortlet, BorderLayout.CENTER);
		
		TabPanel.add(newPortlet);
		
		TabPanel.add(existPortlet);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		//ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Portlets", centerPanel);


	   }
	   private void InitializeModelPage(){

	    //JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		//butView.setText("View Prototype Property");
		//butView.addActionListener(new cViewProtoProp());
		
		JScrollPane scrollNewModel = new JScrollPane(lstModelNew);
		scrollNewModel.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistModel = new JScrollPane(lstModelExisting);
		scrollExistModel.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newModel = new WAPanel();
		WAPanel existModel = new WAPanel();
		
		newModel.setLayout(new BorderLayout());
		existModel.setLayout(new BorderLayout());
		
		newModel.add(new JLabel("New Models"), BorderLayout.PAGE_START);
		newModel.add(scrollNewModel, BorderLayout.CENTER);
		
		existModel.add(new JLabel("Existing Models"), BorderLayout.PAGE_START);
		existModel.add(scrollExistModel, BorderLayout.CENTER);
		
		TabPanel.add(newModel);
		
		TabPanel.add(existModel);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		//ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Mining Models", centerPanel);


	   }
	   
	   
	   private void InitializeProcessPage(){

	    //JButton butView = new JButton();
		
		WAPanel TabPanel = new WAPanel();
		
		TabPanel.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		TabPanel.setLayout(new GridLayout(1, 2, 5, 5));
		TabPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		
		//butView.setText("View Prototype Property");
		//butView.addActionListener(new cViewProtoProp());
		
		JScrollPane scrollNewProcess = new JScrollPane(lstProcessNew);
		scrollNewProcess.setPreferredSize(new Dimension(250, 175));
		
		JScrollPane scrollExistProcess = new JScrollPane(lstProcessExisting);
		scrollExistProcess.setPreferredSize(new Dimension(250, 175));
		
		WAPanel newProcess = new WAPanel();
		WAPanel existProcess = new WAPanel();
		
		newProcess.setLayout(new BorderLayout());
		existProcess.setLayout(new BorderLayout());
		
		newProcess.add(new JLabel("New Stored Processes"), BorderLayout.PAGE_START);
		newProcess.add(scrollNewProcess, BorderLayout.CENTER);
		
		existProcess.add(new JLabel("Existing Stored Processes"), BorderLayout.PAGE_START);
		existProcess.add(scrollExistProcess, BorderLayout.CENTER);
		
		TabPanel.add(newProcess);
		
		TabPanel.add(existProcess);
		Box ButtonBox = Box.createHorizontalBox();
		ButtonBox.add(Box.createHorizontalStrut(10));
		//ButtonBox.add(butView);
		WAPanel centerPanel = new WAPanel();
		centerPanel.setLayout(new BorderLayout(10, 10));
		centerPanel.add(TabPanel, BorderLayout.CENTER);
		centerPanel.add(ButtonBox, BorderLayout.SOUTH);
		jTabbedPane1.addTab("Stored Proc", centerPanel);


	   }
	   protected void setTableMap(HashMap hmTableMap1){
	   	hmTableMap = new HashMap();
	   	hmTableMap =hmTableMap1; 
	   }
	   protected void setTableMapFile(HashMap hmTableMap2){
	   	hmMetaTablesFile = new HashMap();
	   	hmMetaTablesFile =hmTableMap2; 
	   }
	   
	   
	   protected void setCubeMap(HashMap hmCubeMap1){
	   	hmCubeMap = new HashMap();
	   	hmCubeMap =hmCubeMap1; 
	   }
	   protected void setExternalTableMap(HashMap hmExternalTableMap1){
		   	hmExternalTableMap = new HashMap();
		   	hmExternalTableMap =hmExternalTableMap1; 
	}
	   
	   
	   
	   
	   protected void setPath(String path){
	   	m_path = path; 
	   }
	   
	   
	   protected class cImpactAction extends WsAbstractAction
	   {
		    public void actionPerformed(ActionEvent actionevent)
		    {
		    	//a.b("---IN ACTION 1");
		    	int iRows[] = table.getSelectedRows();
		    	boolean flag = false;
		    	if(iRows.length > 0)
		    	{
		            m_parent.setCursor(Cursor.getPredefinedCursor(3));
			    	DefaultTableModel dtm = (DefaultTableModel)table.getModel();
			        for(int i=0;i<iRows.length;i++){
			        	String s = (String)dtm.getValueAt(iRows[i],1);
			        	int iDot = s.indexOf(".");
				    	if(iDot != -1){
				    		String libName = s.substring(0,iDot);
				    		String TableName = s.substring(iDot+1);
				    		List allTable =  cUtilityClass.TableExist(libName,TableName,fullReposid);
							PhysicalTable physicaltable = (PhysicalTable)allTable.get(0);
							cUtilityClass.showTableImpactAnalysis2(true,physicaltable);
				    	}
			        }
		            m_parent.setCursor(null);
		    	}
		    	else
		    	{
		    		a.warning("Please select the existing table to see impact analysis");
		    	}
		    }
		    public cImpactAction()
		    {
		        super();
		       // //a.b("---IMPACT1111");
		    }
		}


	   
	   protected class cReverseImpactAction extends WsAbstractAction{

	    public void actionPerformed(ActionEvent actionevent)
	    {
	    	int iRows[] = table.getSelectedRows();
	    	if(iRows.length > 0)
	    	{
	            m_parent.setCursor(Cursor.getPredefinedCursor(3));
		    	DefaultTableModel dtm = (DefaultTableModel)table.getModel();
		        for(int i=0;i<iRows.length;i++){
		        	String s = (String)dtm.getValueAt(iRows[i],1);
	
		        	int iDot = s.indexOf(".");
			    	if(iDot != -1){
			    		String libName = s.substring(0,iDot);
			    		String TableName = s.substring(iDot+1);
			    		List allTable =  cUtilityClass.TableExist(libName,TableName,fullReposid);

			    		PhysicalTable physicaltable = (PhysicalTable)allTable.get(0);
						cUtilityClass.showTableImpactAnalysis2(false,physicaltable);
			    	}
		            ////a.b("DONE");
		        }
	            m_parent.setCursor(null);
	    	}
	    	else
	    	{
	    		a.warning("Please select the existing table to see reverse impact analysis");
	    	}
	    }
	    public cReverseImpactAction()
	    {
	        super();
	    }
	}

	   
	   protected class cViewJob extends WsAbstractAction{

	    public void actionPerformed(ActionEvent actionevent)
	    {
	    	int iRows[] = tblJobExisting.getSelectedRows();
	    	if(iRows.length > 0)
	    	{
	            m_parent.setCursor(Cursor.getPredefinedCursor(3));
	            DefaultTableModel dtm = (DefaultTableModel)tblJobExisting.getModel();
		    	for(int u = 0;u < iRows.length; u++){
		    		String s = (String)dtm.getValueAt(iRows[u],1);
		       		Job j = getJob(s); 
		    		WAPFDEditorOMAView a = new WAPFDEditorOMAView(j);
		    		WASplittablePropertyFrame xx = new WASplittablePropertyFrame(j, "");
		        	WsViewFactory.attachViewToFrame(j, a, xx);
		    	}
	            m_parent.setCursor(null);
	    	}
	    	else
	    	{
	    		a.warning("Please select the existing job");
	    	}
	    }
	    public cViewJob()
	    {
	        super();
	    }
	}

	   protected class cViewCubeProperty extends WsAbstractAction{

	    public void actionPerformed(ActionEvent actionevent)
	    {
	    	int iRows[] = table.getSelectedRows();
	    	if(iRows.length > 0)
	    	{
	            m_parent.setCursor(Cursor.getPredefinedCursor(3));
		    	//WAPFDEditorOMAView a = new WAPFDEditorOMAView(Job); 
		    	a.warning("View Cube Property Clicked");
	            m_parent.setCursor(null);
	    	}
	    	else
	    	{
	    		a.warning("Please select the existing cube");
	    	}
	    }
	    public cViewCubeProperty()
	    {
	        super();
	    }
	}


	   protected class cTableDiffAction extends WsAbstractAction
		{
		    public void actionPerformed(ActionEvent actionevent)
		    {
		    		int iRows[] = table.getSelectedRows();
		    		if(iRows.length > 0)
		    		{
		                m_parent.setCursor(Cursor.getPredefinedCursor(3));
			    		DefaultTableModel dtm = (DefaultTableModel)table.getModel();
	                    String []arrTables = new String[iRows.length];
	                    for(int nIndex=0; nIndex < iRows.length; nIndex++){
	                    	arrTables[nIndex] = (String)dtm.getValueAt(iRows[nIndex],1);
		                    	   }
	                    
						TabDiffDlg dlg = new TabDiffDlg(arrTables,hmTableMap,hmMetaTablesFile,m_path, m_bundle);
			    		
			    		dlg.setModal(false);
			    		dlg.setSize(900,250);
			    		Dimension screensize = Toolkit.getDefaultToolkit().getScreenSize();
			    		Dimension dlgsize = dlg.getSize();
			    		dlg.setLocation((screensize.width - dlgsize .width) / 2, (screensize.height - dlgsize .height) / 2);
			            m_parent.setCursor(null);
			    		dlg.show();
		    		}
		    		else
		    		{
		    			a.warning("Please select existing table to see the difference");
		    		}
		    }
		    public cTableDiffAction()
		    {
		        super();
		    }
		}
		
	   protected class cViewLibProp extends WsAbstractAction
		{
		    public void actionPerformed(ActionEvent actionevent)
		    {
		    	a.warning("View Lib Property Under Construction");
		    }
		    public cViewLibProp()
		    {
		        super();
		    }
		}
		
	   protected class cViewProtoProp extends WsAbstractAction
		{
		    public void actionPerformed(ActionEvent actionevent)
		    {
		    	a.warning("View Prototype Property Under Construction");
		    }
		    public cViewProtoProp()
		    {
		        super();
		    }
		}

	   private Job getJob(String JobName) {
    	
		String XMLSelect = "";
		Job cm = null;
		
		JobName = cUtilityClass.resolveName(JobName);
				
		if (JobName != null ) 
		{
			XMLSelect = "<XMLSelect search=\"Job[@Name='" + JobName+ "']\"/>";
		}
			List JobList = cUtilityClass.getObjects(XMLSelect,"Job",fullReposid);
			if(JobList.size() >0)
			{
				cm = (Job)JobList.get(0);
			}				
		return cm;
	}// end of function 

	   protected JTable getScrollTable(){
	   	return table;
	   }
	   
	   protected JTable getJobTable(){
		   	return tblJobExisting;
		   }

	   protected void setReposId(String p_ReposId){
	   	fullReposid = p_ReposId;
	   
	   }
		
}
