/**
 * <p>Title: CompareTab</p>
 * <p>Description: Class that adds functionalities to the compare tab page in wizard</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */

package com.sas.metadata.imp;

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import com.sas.meta.SASOMI.IOMI;
import com.sas.metadata.AssociationList;
import com.sas.metadata.CMetadata;
import com.sas.metadata.ClassifierMap;
import com.sas.metadata.Column;
import com.sas.metadata.Cube;
import com.sas.metadata.ExternalTable;
import com.sas.metadata.Job;
import com.sas.metadata.MdException;
import com.sas.metadata.MdObjectFactory;
import com.sas.metadata.MdObjectStore;
import com.sas.metadata.MetadataUtil;
import com.sas.metadata.MetadataWorkspace;
import com.sas.metadata.MiningResult;
import com.sas.metadata.OLAPSchema;
import com.sas.metadata.PhysicalTable;
import com.sas.metadata.Prototype;
import com.sas.metadata.Transformation;
import com.sas.metadata.Tree;
import com.sas.metadata.imp.a;
import com.sas.metadata.imp.cProcessTree;
import com.sas.metadata.imp.cUtilityClass;
import com.sas.plugins.PluginResourceBundle;
import com.sas.workspace.OpRequestUI;
import com.sas.workspace.ReposDependencyObject;
import com.sas.workspace.Repository;
import com.sas.workspace.RepositoryUtil;
import com.sas.workspace.WAWizardDialog;
import com.sas.workspace.WAdminResource;
import com.sas.workspace.Workspace;
import com.sas.workspace.WsDescriptionWizardTab;


/**
 * @author Ajit Singh
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class CompareTab extends WsDescriptionWizardTab 
{
	private static PluginResourceBundle bundle = new PluginResourceBundle(CompareTab.class);

	private WAWizardDialog m_parent = null;
	protected ComparePanel myPanel;
	private Workspace m_workspace = Workspace.getWorkspace();
	String popLibNote = ""; 

	String fullReposid;
	String solutionPath;
	HashMap hmMetaTables= new HashMap();
	HashMap hmMetaCubes= new HashMap();
	HashMap hmMetaLibs= new HashMap();
	HashMap hmMetaProtos= new HashMap();
	HashMap hmMetaMaps= new HashMap();
	HashMap hmMetaPortlets= new HashMap();
	HashMap hmMetaProcesses= new HashMap();
	HashMap hmMetaModels= new HashMap();
	HashMap hmMetaExternalTables= new HashMap();

	HashMap hmMetaTablesFile= new HashMap();
	HashMap hmMetaJobFile= new HashMap();
	HashMap hmMetaCubeFile= new HashMap();
	HashMap hmMetaLibFile= new HashMap();
	HashMap hmMetaPrototypeFile= new HashMap();
	HashMap hmMetaMapFile= new HashMap();
	HashMap hmMetaPortletFile= new HashMap();
	HashMap hmMetaProcessFile= new HashMap();
	HashMap hmMetaModelFile= new HashMap();
	HashMap hmMetaExternalTableFile = new HashMap();

	HashMap hmColumnList= new HashMap();
	HashMap hmAddXMLColumnData = new HashMap();
	HashMap hmUpdateXMLColumnData = new HashMap();
	HashMap hmAppendXMLColumnData = new HashMap();
	HashMap hmUpdateXMLTableData = new HashMap();

	List libsToImport_V = new Vector();
	List tablesToImport_V= new Vector();
	List cubesToImport_V= new Vector();
	List jobsToImport_V= new Vector();
	List prototypesToImport_V= new Vector();
	List mapsToImport_V= new Vector();
	List PortletsToImport_V= new Vector();
	List processesToImport_V= new Vector();
	List modelsToImport_V= new Vector();
	List externalTablesToImport_V= new Vector();

	List treesToImport= new Vector();
	List libsToImport = new Vector();
	List tablesToImport= new Vector();
	List cubesToImport= new Vector();
	List jobsToImport= new Vector();
	List prototypesToImport= new Vector();
	List mapsToImport= new Vector();
	List PortletsToImport= new Vector();
	List processesToImport= new Vector();
	List modelsToImport= new Vector();
	List externalTablesToImport= new Vector();

	List tablesToShow= new Vector();
	List jobsToShow= new Vector();

	List tablesToDelete= new Vector();
	HashMap hmJobsToUpdate= new HashMap();
	List objsToDelete= new Vector();
	List lstColumnToDelete= new Vector();


	public CompareTab(WAdminResource bundle) 
	{
		super();
		setHelpTopic("selecttablesbyapplicationareawindow");
		m_bundle = bundle;
		myPanel = new ComparePanel(true,m_bundle);
		initialize();

	}

	public void initialize() 
	{
		this.setLayout(new GridBagLayout());
		myPanel.setBounds(new Rectangle(0,0,800,600));
		this.add(myPanel, new GridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
				GridBagConstraints.NORTHWEST, GridBagConstraints.BOTH,
				new Insets(0, 0, 0, 0), 0, 0));
	}
	/**
	 * Transfer data to and from the model.
	 * bSaveToModel True if transfering from view to model, false if 
	 * vice versa
	 */
	public boolean doDataExchange(boolean bSaveToModel)
	throws com.sas.metadata.MdException {
		myPanel.doDataExchange(true);
		if (m_parent == null) {
			m_parent = (WAWizardDialog) this.getTopLevelAncestor();
		}
		if (bSaveToModel == true) {
			String strLog = "Import started by user '" + cUtilityClass.getOMRValue ("Username") + "' in repository '" + m_parent.getWizardData("fullreposname") + "("+ fullReposid +")'";
			cUtilityClass.WriteLog(strLog);
			String s = m_bundle.getString("ImportInfoProgressIndicator.Message.txt");
			String s1 = m_bundle.getString("ImportInfoProgressIndicator.Title.txt");
			String s2 = m_bundle.getString("ImportInfoProgressIndicator.Description.txt");
			OpRequestUI oprequestui = new OpRequestUI(m_workspace, s, s1, s2);
			oprequestui.setDelayBeforeProgressCancelDialog(200);
			oprequestui.execute(new cRunnable(oprequestui));
			cUtilityClass.WriteLog("Import finished\n\n\n\n");
			a.plainMsg("Import Log created at \n" + System.getProperty("user.home")+"\\SASMetadataImport");

		}else{

			m_parent.setCursor(Cursor.getPredefinedCursor(3));
			libsToImport_V = (List)m_parent.getWizardData("libstoimport");
			tablesToImport_V = (List)m_parent.getWizardData("tablestoimport");
			cubesToImport_V = (List)m_parent.getWizardData("cubestoimport");
			jobsToImport_V = (List)m_parent.getWizardData("jobstoimport");
			mapsToImport_V = (List)m_parent.getWizardData("mapstoimport");
			PortletsToImport_V = (List)m_parent.getWizardData("portlettoimport");
			processesToImport_V = (List)m_parent.getWizardData("processestoimport");
			modelsToImport_V = (List)m_parent.getWizardData("modelstoimport");
			externalTablesToImport_V = (List)m_parent.getWizardData("externaltablestoimport");
			prototypesToImport_V = (List)m_parent.getWizardData("prototypestoimport");

			treesToImport = (List)m_parent.getWizardData("treestoimport");

			fullReposid = (String)m_parent.getWizardData("fullreposid");
			solutionPath = (String)m_parent.getWizardData("SOLUTIONPATH");

			PopulateTableTabPage(tablesToImport_V);
			PopulateJobTabPage(jobsToImport_V);
			PopulateCubeTabPage(cubesToImport_V);
			PopulateLibTabPage(libsToImport_V);

			PopulatePrototypeTabPage(prototypesToImport_V);
			PopulateMapTabPage(mapsToImport_V);
			PopulatePortletTabPage(PortletsToImport_V);
			PopulateProcessTabPage(processesToImport_V);
			PopulateModelTabPage(modelsToImport_V);
			PopulateExternalTableTabPage(externalTablesToImport_V);

			m_parent.setCursor(null);
		}
		return true;
	}//end public boolean doDataExchange( boolean bSaveToModel ) throws    com.sas.metadata.MdException



	protected class cRunnable  implements Runnable	{

		public void run()
		{
			oprequestui.setMessagePreferredSize(new Dimension(260,24));
			oprequestui.setDelayBeforeProgressCancelDialog(50);
//			Dimension dim = oprequestui.getMessagePreferredSize();
			int iNum = getSum();
			String olapSchema = "";
			oprequestui.setMessage("Gather Information...");
			if(cubesToImport.size()>0){
				List schemaList = cUtilityClass.getOlapSchemas(fullReposid);
				try {
					OLAPSchema  olapSchemaObj = (OLAPSchema)schemaList.get(0);
					olapSchema = olapSchemaObj.getName() ;
				}catch (Exception e){
					a.error(e.getMessage ());
					e.printStackTrace(System.err);
					return;
				}


			}
			IO.write_meta_metadata(solutionPath,fullReposid,(String)m_parent.getWizardData("fullreposname"),oprequestui);

			oprequestui.setMessage("Importing Group...");
			if(treesToImport.size()>0){iNum = IO.import_groups(treesToImport,oprequestui, iNum);}
			treesToImport.clear();

			oprequestui.setMessage("Importing Libraries...");
			if(libsToImport.size()>0){iNum = IO.import_Library(libsToImport,oprequestui,foundationId,iNum);}
			libsToImport.clear();

			oprequestui.setMessage("Importing Tables...");
			if(tablesToImport.size()>0){iNum = IO.import_Tables(tablesToImport,oprequestui,iNum);}
			tablesToImport.clear();

			oprequestui.setMessage("Adding XML Columns...");
			if(!hmAddXMLColumnData.isEmpty()){
				IO.setTableMap(hmMetaTables);
				iNum = IO.add_XML_Column(hmAddXMLColumnData, "Append",oprequestui,iNum);
				hmAddXMLColumnData.clear();
			}

			oprequestui.setMessage("Updating column attribute...");
			if(!hmUpdateXMLColumnData.isEmpty())
			{		  	
				IO.setTableMap(hmMetaTables);
				iNum = IO.Update_XML_Columns_in_Meta(hmUpdateXMLColumnData,oprequestui,iNum);
				hmUpdateXMLColumnData.clear();
			}

			oprequestui.setMessage("Append XML Columns...");
			if(!hmAppendXMLColumnData.isEmpty()){
				IO.setTableMap(hmMetaTables);
				iNum = IO.add_XML_Column(hmAppendXMLColumnData, "Append",oprequestui,iNum);
				hmAppendXMLColumnData.clear();
			}

			oprequestui.setMessage("Updating Table...");
			if(!hmUpdateXMLTableData.isEmpty()){
				IO.setTableMap(hmMetaTables);

				iNum = IO.Update_Table_in_Meta(hmUpdateXMLTableData,oprequestui,iNum,(String)m_parent.getWizardData("Foundation"));
				hmUpdateXMLTableData.clear();
			}		  

			oprequestui.setMessage("Deleting Tables...");
			if(tablesToDelete.size()>0){
				iNum = IO.delete_Tables(tablesToDelete,oprequestui,iNum);
			}
			tablesToDelete.clear();

			oprequestui.setMessage("Deleting job contents...");
			if(hmJobsToUpdate.size()>0){iNum = IO.delete_JobContents(hmJobsToUpdate,oprequestui,iNum);}

			oprequestui.setMessage("Deleting Other Objects...");
			if(objsToDelete.size()>0){iNum = IO.delete_OtherObjects(objsToDelete,oprequestui,iNum);}
			objsToDelete.clear();


			oprequestui.setMessage("Importing prototypes...");
			if(prototypesToImport.size()>0){iNum = IO.import_Prototypes(prototypesToImport,oprequestui,iNum);}
			prototypesToImport.clear();


			oprequestui.setMessage("Importing Mining Models ...");
			if(modelsToImport.size()>0){iNum = IO.import_Models(modelsToImport,oprequestui,iNum );}
			modelsToImport.clear();

			oprequestui.setMessage("Importing External Tables...");
			if(externalTablesToImport.size()>0){iNum = IO.import_ExternalTables(externalTablesToImport,oprequestui,iNum);}
			externalTablesToImport.clear();

			oprequestui.setMessage("Importing Jobs...");
			if(jobsToImport.size()>0){iNum = IO.import_Jobs(jobsToImport,hmJobsToUpdate,oprequestui,iNum);}
			jobsToImport.clear();

			oprequestui.setMessage("Deleting Columns...");
			if(lstColumnToDelete.size()>0){iNum = IO.delete_Columns(lstColumnToDelete,oprequestui,iNum );}
			lstColumnToDelete.clear();

			oprequestui.setMessage("Importing Cubes...");
			if(cubesToImport.size()>0){iNum = IO.import_Cube(cubesToImport,oprequestui,olapSchema,iNum );}
			cubesToImport.clear();

			oprequestui.setMessage("Importing InfoMaps...");
			if(mapsToImport.size()>0){iNum = IO.import_Map(mapsToImport,oprequestui,iNum );}
			mapsToImport.clear();

			/* oprequestui.setMessage("Importing Portlets...");
		  if(PortletsToImport.size()>0){iNum = IO.import_Portlets(PortletsToImport,oprequestui,iNum );}
		  PortletsToImport.clear();
			 */
			oprequestui.setMessage("Importing Stored Processes...");
			if(processesToImport.size()>0){iNum = IO.import_Process(processesToImport,oprequestui,iNum );}
			processesToImport.clear();

			IO.cleanMaps();

			IO = null;
		}

		cRunnable(OpRequestUI oprequestui1)
		{
			IO = new import_Objects();
			oprequestui = oprequestui1;
			/*foundationId = (String)m_parent.getWizardData("Foundation");*/
			foundationId = fullReposid;
		}

		// Summing up the total number of objects to show remaining objects in process bar
		private int getSum(){
			return treesToImport.size()+libsToImport.size()+tablesToImport.size()+hmAddXMLColumnData.size()+hmUpdateXMLColumnData.size()+hmAppendXMLColumnData.size()+hmUpdateXMLTableData.size()+tablesToDelete.size()+hmJobsToUpdate.size()+objsToDelete.size()+prototypesToImport.size()+modelsToImport.size()+externalTablesToImport.size()+jobsToImport.size()+lstColumnToDelete.size()+cubesToImport.size()+mapsToImport.size()+processesToImport.size();
		}
		OpRequestUI oprequestui;
		String foundationId ;
	}

	private void PopulateTableTabPage(List xmlTableList)
	{
		DefaultTableModel model = new DefaultTableModel();
		Vector v = new Vector();
		List lstNewTables= new Vector(); 
		List lstExistingTables= new Vector();
		model.addColumn("Decision");
		model.addColumn("TableName");

		for(int iTable=0;iTable<xmlTableList.size();iTable++)
		{	    	
			String strTable = (String)xmlTableList.get(iTable);
			v= new Vector();
			List PhysicalTableList = new Vector(); 

			int i = strTable.indexOf(".");
			int j=0;
			if(i == -1){
				a.warning("Use Latest Export Utility");
				break;
			}
			j = strTable.indexOf(".xml");	
			String libName = strTable.substring(0,i); 
			String TableName = strTable.substring(i+1,j);
			String XMLSelect = "";


			TableName = cUtilityClass.MoreResolveTexttoHash(TableName);
			libName = cUtilityClass.MoreResolveTexttoHash(libName);

			//Check if the table exists in the repository
			PhysicalTableList  = cUtilityClass.TableExist(libName,TableName,fullReposid); 

			libName = cUtilityClass.changeReferenceTo(libName);
			TableName = cUtilityClass.changeReferenceTo(TableName);

			// If table exists add it to Existing tables panel 
			if(PhysicalTableList.size() >0)
			{    		
				PhysicalTable cm = (PhysicalTable) PhysicalTableList.get(0);
				JCheckBox cTemp1 = new JCheckBox(libName+"."+TableName);
				lstExistingTables.add(cTemp1);
				v.add("NoAction");
				v.add(libName+"."+TableName);
				model.addRow(v);
				hmMetaTables.put(libName+"."+TableName,cm);	
			}
			// else add to new tables panel
			else{
				//a.b("New Table ");
				JCheckBox cTemp2 = new JCheckBox(libName+"."+TableName,true);
				lstNewTables.add(cTemp2);	
			}

			hmMetaTablesFile.put(libName+"."+TableName,strTable);
		}// Enf of For loop

		myPanel.lstTabNew.setListData(lstNewTables.toArray());
		myPanel.setModel(model);
		myPanel.topuptable();	
		myPanel.setTableMap(hmMetaTables);
		myPanel.setReposId(fullReposid);
		myPanel.setTableMapFile(hmMetaTablesFile); 
		myPanel.setPath(solutionPath);
	}

	private void PopulateJobTabPage(List xmlJobList){
		List lstNewJobs= new Vector(); 
		List lstExistingJobs= new Vector();
		String fullJobName = "";
		String JobName = ""; 
		DefaultTableModel model = new DefaultTableModel();
		Vector v;
		model.addColumn("Decision");
		model.addColumn("JobName");

		for(int iTable=0;iTable<xmlJobList.size();iTable++){
			fullJobName = (String)xmlJobList.get(iTable);
			JobName = ""; 

			int j = fullJobName.indexOf(".xml");
			if( j != -1 ){
				JobName = fullJobName.substring(0,j);	
			}
			String newJobName = cUtilityClass.MoreResolveTexttoHash(JobName);
			String XMLSelect = "<XMLSelect search=\"Job[@Name='" + newJobName+ "']\"/>";

			List JobList = cUtilityClass.getObjects(XMLSelect, "Job",fullReposid);

			JobName = cUtilityClass.resolveName(JobName);

			if(JobList.size() >0){
				Job cm = (Job) JobList.get(0);
				JCheckBox cTemp1 = new JCheckBox(JobName);
				lstExistingJobs.add(cTemp1);
				v = new Vector();
				v.add("NoAction");
				v.add(JobName);
				model.addRow(v);
				hmMetaTables.put(JobName,cm);	
			}else{
				JCheckBox cTemp2 = new JCheckBox(JobName,true);
				lstNewJobs.add(cTemp2);	
			}
			hmMetaTablesFile.put(JobName,fullJobName);
		}// End of For loop

		myPanel.lstJobNew.setListData(lstNewJobs.toArray());
		myPanel.setJobModel(model);
		myPanel.topupJobTable();
//		myPanel.lstJobExisting.setListData(lstExistingJobs.toArray());

	}

	private void PopulatePrototypeTabPage(List xmlTableList){

		List lstNewPrototypes= new Vector(); 
		List lstExistingPrototypes= new Vector();
		String ProtoName="";
		String fullProtoName="";

		for(int iTable=0;iTable<xmlTableList.size();iTable++){
			fullProtoName = (String)xmlTableList.get(iTable);

			int j = fullProtoName.indexOf(".xml");
			if( j != -1 ){
				ProtoName = fullProtoName.substring(0,j);	
			}

			String newProtoName = cUtilityClass.MoreResolveTexttoHash(ProtoName);
			String XMLSelect = "<XMLSelect search=\"Prototype[@Name='" + newProtoName + "']\"/>";

			List ProtoList = cUtilityClass.getObjects(XMLSelect, "Prototype",fullReposid);

			ProtoName = cUtilityClass.resolveName(ProtoName);
			if(ProtoList.size() >0){
				Prototype cm = (Prototype)ProtoList.get(0);
				JCheckBox cTemp1 = new JCheckBox(ProtoName);
				lstExistingPrototypes.add(cTemp1);
				hmMetaProtos.put(ProtoName,cm);	
			}else{
				JCheckBox cTemp2 = new JCheckBox(ProtoName,true);
				lstNewPrototypes.add(cTemp2);	
			}
			hmMetaPrototypeFile.put(ProtoName,fullProtoName);
		}// Enf of For loop

		myPanel.lstPrototypeNew.setListData(lstNewPrototypes.toArray());
		myPanel.lstPrototypeExisting.setListData(lstExistingPrototypes.toArray());

	}   

	private void PopulateCubeTabPage(List xmlCubeList ){

		List lstNewCubes= new Vector(); 
		List lstExistingCubes= new Vector();
		String fullCubeName = ""; 
		String CubeName ="";

		for(int iTable=0;iTable<xmlCubeList.size();iTable++){
			fullCubeName = (String)xmlCubeList.get(iTable);
			//a.b("Table in folder:\n  " + strTable);

			int j = fullCubeName.indexOf(".sas");
			if( j != -1 ){
				CubeName = fullCubeName.substring(0,j);	
			}

			//String CubeName = strTable.substring(0,strTable.indexOf("@"));

			//String XMLSelect = "<XMLSelect search=\"Cube[@Name='" + CubeName+ "']\"/>";
			String newCubeName = cUtilityClass.MoreResolveTexttoHash(CubeName);
			String XMLSelect = "<XMLSelect search=\"Cube[@Name='" + newCubeName + "']\"/>";
			List CubeList = cUtilityClass.getObjects(XMLSelect, "Cube",fullReposid);
			CubeName = cUtilityClass.resolveName(CubeName);		
			if(CubeList.size() >0){
				//a.b("Table Exist   ");
				Cube cm = (Cube) CubeList.get(0);
				JCheckBox cTemp1 = new JCheckBox(CubeName);
				lstExistingCubes.add(cTemp1);
				hmMetaCubes.put(CubeName,cm);
			}else{
				//a.b("New Table ");
				JCheckBox cTemp2 = new JCheckBox(CubeName,true);
				lstNewCubes.add(cTemp2);	
			}

			hmMetaCubeFile.put(CubeName,fullCubeName);
		}// Enf of For loop

		myPanel.lstCubeNew.setListData(lstNewCubes.toArray());
		myPanel.lstCubeExisting.setListData(lstExistingCubes.toArray());
		myPanel.setCubeMap(hmMetaCubes);
	}

	private void PopulateExternalTableTabPage(List xmlExternalTableList ){

		List lstNewExternalTables= new Vector(); 
		List lstExistingExternalTables= new Vector();
		String fullExternalTableName = ""; 
		String ExternalTableName ="";

		for(int iTable=0;iTable<xmlExternalTableList.size();iTable++){
			fullExternalTableName = (String)xmlExternalTableList.get(iTable);
			int j = fullExternalTableName.indexOf(".xml");
			if( j != -1 ){
				ExternalTableName = fullExternalTableName.substring(0,j);	
			}
			String newExternalTableName = cUtilityClass.MoreResolveTexttoHash(ExternalTableName);
			String XMLSelect = "<XMLSelect search=\"ExternalTable[@Name='" + newExternalTableName + "']\"/>";
			List ExternalTableList = cUtilityClass.getObjects(XMLSelect, "ExternalTable",fullReposid);
			ExternalTableName = cUtilityClass.resolveName(ExternalTableName);		
			if(ExternalTableList.size() >0){
				ExternalTable cm = (ExternalTable) ExternalTableList.get(0);
				JCheckBox cTemp1 = new JCheckBox(ExternalTableName);
				lstExistingExternalTables.add(cTemp1);
				hmMetaExternalTables.put(ExternalTableName,cm);
			}else{
				JCheckBox cTemp2 = new JCheckBox(ExternalTableName,true);
				lstNewExternalTables.add(cTemp2);	
			}

			hmMetaExternalTableFile.put(ExternalTableName,fullExternalTableName);
		}// Enf of For loop

		myPanel.lstExternalTableNew.setListData(lstNewExternalTables.toArray());
		myPanel.lstExternalTableExisting.setListData(lstExistingExternalTables.toArray());
		myPanel.setExternalTableMap(hmMetaExternalTables);
	}

	private void PopulateLibTabPage(List xmlLibList){

		List lstNewLibs= new Vector(); 
		List lstExistingLibs= new Vector(); 

		for(int iTable=0;iTable<xmlLibList.size();iTable++){
			String fullLibName = (String)xmlLibList.get(iTable);
			String LibName = "";

			int j = fullLibName.indexOf(".xml");
			if( j != -1 ){
				LibName = fullLibName.substring(0,j);	
			}

			String newLibName = cUtilityClass.MoreResolveTexttoHash(LibName);
			String XMLSelect = "<XMLSelect search=\"SASLibrary[@Name='" + newLibName + "']\"/>";

			List LibList = cUtilityClass.getObjects(XMLSelect, "SASLibrary", fullReposid);

			LibName = cUtilityClass.resolveName(LibName);	
			if(LibList.size() >0){
				//a.b("Found Lib Going to Caste: " );
				CMetadata  cm = (CMetadata)LibList.get(0);
				//a.b("Casted: " );
				JCheckBox cTemp1 = new JCheckBox(LibName);
				lstExistingLibs.add(cTemp1);
				hmMetaLibs.put(LibName,cm);
			}else{
				JCheckBox cTemp2 = new JCheckBox(LibName,true);
				lstNewLibs.add(cTemp2);	
			}

			hmMetaLibFile.put(LibName,fullLibName);
		}// Enf of For loop
		myPanel.lstLibNew.setListData(lstNewLibs.toArray());
		myPanel.lstLibExisting.setListData(lstExistingLibs.toArray());
	}

	private void PopulateProcessTabPage(List xmlProcessList){
		//a.b("1");
		List lstNewProcesses= new Vector(); 
		List lstExistingProcesses= new Vector();
		String ProcessName="";
		String fullProcessName="";

		for(int iPro=0;iPro<xmlProcessList.size();iPro++){
			fullProcessName = (String)xmlProcessList.get(iPro);
			int j = fullProcessName.indexOf(".xml");
			if( j != -1 ){
				ProcessName = fullProcessName.substring(0,j);	
			}
			int t = ProcessName.indexOf("==");
			ProcessName = ProcessName.substring(0,t);
			ProcessName = cUtilityClass.MoreResolveTexttoHash(ProcessName);
			String XMLSelect = "<XMLSelect search=\"ClassifierMap[@Name='"+ProcessName+"' and @TransformRole='StoredProcess']\"/>"; 
			List ProcessList = cUtilityClass.getObjects(XMLSelect, "ClassifierMap",fullReposid);

			if(chkExistence(cUtilityClass.resolveName(fullProcessName),ProcessList,"ClassifierMap")){

				ClassifierMap cm = (ClassifierMap)ProcessList.get(0);
				JCheckBox cTemp1 = new JCheckBox(fullProcessName.substring(0,fullProcessName.indexOf(".xml")));
				lstExistingProcesses.add(cTemp1);
				if( j != -1 )
					ProcessName = fullProcessName.substring(0,j);
				hmMetaProcesses.put(fullProcessName.substring(0,fullProcessName.indexOf(".xml")),cm);

			}else{
				JCheckBox cTemp2 = new JCheckBox(ProcessName,true);
//				JCheckBox cTemp2 = new JCheckBox(fullProcessName.substring(0,fullProcessName.indexOf(".xml")),true);
				lstNewProcesses.add(cTemp2);
			} 				
			hmMetaProcessFile.put(ProcessName,fullProcessName);
		}// Enf of For loop
		myPanel.lstProcessNew.setListData(lstNewProcesses.toArray());
		myPanel.lstProcessExisting.setListData(lstExistingProcesses.toArray());

	}

	private void PopulateMapTabPage(List xmlMapList)
	{
		try
		{
			List lstNewMaps= new Vector(); 
			List lstExistingMaps= new Vector();
			String MapName="";
			String fullMapName="";

			for(int iTable=0;iTable<xmlMapList.size();iTable++)
			{
				fullMapName = (String)xmlMapList.get(iTable);

				int j = fullMapName.indexOf(".xml");
				if( j != -1 )
					MapName = fullMapName.substring(0,j);	

				int t = MapName.indexOf("==");
				if(t == -1)
				{
					a.errorMessage("Name of information map is invalid: " + fullMapName, "Exception");
					cUtilityClass.WriteLog("Name of information map is invalid: " + fullMapName);
					continue;
				}
				MapName = MapName.substring(0,t);
				String newMapName = cUtilityClass.MoreResolveTexttoHash(MapName);
				String XMLSelect = "<XMLSelect search=\"Transformation[@Name='"+newMapName+"' and (@TransformRole='InformationMap')]\"/>";
				XMLSelect += "<Templates><Transformation Name=\"\" TransformRole=\"\"/></Templates>";
				List MapList = cUtilityClass.getObjects(XMLSelect, "Transformation",fullReposid);
				MapName = cUtilityClass.resolveName(MapName);

				if(chkExistence(fullMapName,MapList,"Transformation"))
				{
					Transformation cm = (Transformation)MapList.get(0);
					JCheckBox cTemp1 = new JCheckBox(fullMapName.substring(0,fullMapName.indexOf(".xml")));
					lstExistingMaps.add(cTemp1);
					hmMetaMaps.put(MapName,cm);
				}
				else
				{
					JCheckBox cTemp2 = new JCheckBox(MapName,true);
//					JCheckBox cTemp2 = new JCheckBox(fullMapName.substring(0,fullMapName.indexOf(".xml")),true);
					lstNewMaps.add(cTemp2);
				}
				hmMetaMapFile.put(MapName,fullMapName);
			}// Enf of For loop

			myPanel.lstMapNew.setListData(lstNewMaps.toArray());
			myPanel.lstMapExisting.setListData(lstExistingMaps.toArray());
		}
		catch(Exception e)
		{
			a.errorMessage(e.getMessage(), "General Exception");
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("General Exception in PopulateMapTabPage: " + e.getMessage());
		}
	}

	private void PopulatePortletTabPage(List xmlPortletList){

		/*
	    DefaultTableModel model = new DefaultTableModel();
	    Vector v = new Vector();
	    List lstNewPortlets= new Vector(); 
	    List lstExistingTables= new Vector();
	    model.addColumn("Portal");
		model.addColumn("Portlet");
	    // //a.b("HELLO " + xmlTableList.size());
	    for(int iPortal=0;iPortal<xmlPortletList.size();iPortal++){
	    	String strPortal = (String)xmlPortletList.get(iPortal);
	    	 v= new Vector();
	    	 List PortletsList = new Vector(); 

		 * Code for the existing and new Portlet goes here


	    }// Enf of For loop

	    myPanel.lstPortletNew.setListData(lstNewPortlets.toArray());
	    myPanel.setModel(model);
	    myPanel.topupPortlet();	
		myPanel.setTableMap(hmMetaTables);
	    myPanel.setReposId(fullReposid);
	    myPanel.setTableMapFile(hmMetaTablesFile); 
	    myPanel.setPath(solutionPath);*/
	}
	protected static List  getObjects(String XMLSelect, String ObjectType, String fullReposid){
		List Objects=null;
		try {
			Objects = MetadataUtil.getMetadataObjectsSubset(
					MdObjectFactory.createObjectStore(),fullReposid, ObjectType,
					MetadataUtil.OMI_XMLSELECT,
					XMLSelect);
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("Failed: " + e.getMessage());
		}catch (Exception e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("Failed: " + e.getMessage());
		}
		return Objects;

	}


	private boolean chkExistence(String fullItemName, List ItemList, String type){
		boolean x = false;
		List SameProcsList = new Vector();
		for(int chkItem=0;chkItem<ItemList.size();chkItem++){
			CMetadata cmProc = (CMetadata)ItemList.get(chkItem);
			try {
				if("ClassifierMap".equalsIgnoreCase(type)){
					MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
					CMetadata cmetadata = MetadataUtil.getMetadataAllDepths(
							mdobjectstore, type,cmProc.getFQID(), 
							new ArrayList(), 
							new ArrayList(), 
							"<Templates><ClassifierMap><Trees/></ClassifierMap><Tree/></Templates>", 
							MetadataUtil.OMI_TEMPLATE|
							MetadataUtil.OMI_ALL_SIMPLE);
					ClassifierMap clMap = (ClassifierMap)cmetadata;
					AssociationList alTrees = clMap.getTrees();
					if(alTrees.size()>0){
						Tree ReportTree = (Tree)alTrees.get(0);
						String strTree = cProcessTree.processMapTree(ReportTree,"itsTheEnd");
						SameProcsList.add(cmProc.getName().toLowerCase()+"=="+strTree.toLowerCase()+".xml");
					}	
				}else if("Transformation".equalsIgnoreCase(type)){
					String TransRole = "";
					Map map = cmProc.getAttrs();
					Set mySet = map.keySet(); 
					Iterator outerIter = mySet.iterator();
					while(outerIter.hasNext()){ 
						String Attrs = (String)outerIter.next();
						if("TransformRole".equalsIgnoreCase(Attrs))
							TransRole = (String)map.get(Attrs);
					}
					if("InformationMap".equalsIgnoreCase(TransRole)){
						AssociationList asTrees = cmProc.getAssociatedObjects("Trees");
						Tree ReportTree = (Tree)asTrees.get(0);
						String strTree = cProcessTree.processMapTree(ReportTree,"ReportStudio");
						SameProcsList.add(cmProc.getName().toLowerCase()+"=="+strTree.toLowerCase()+".xml");
					}

				}// end of else if

			} catch (MdException e) {
				e.printStackTrace(System.err);
				a.error(e.getMessage());
			}catch (Exception e) {
				e.printStackTrace(System.err);
				a.error(e.getMessage());
			}  
		}

		for(int q=0;q<SameProcsList.size();q++){
			String s = (String)SameProcsList.get(q);
			if(s.equalsIgnoreCase(fullItemName.toLowerCase())){
				x=true;
				break;
			}
		}
		//a.b("final:  "+ x);
		return x;
	}


	private void PopulateModelTabPage(List xmlModelList){
		List lstNewModels= new Vector(); 
		List lstExistingModels= new Vector();
		String ModelName="";
		String fullModelName="";

		for(int iPro=0;iPro<xmlModelList.size();iPro++){
			fullModelName = (String)xmlModelList.get(iPro);

			int j = fullModelName.indexOf(".xml");
			if( j != -1 ){
				ModelName = fullModelName.substring(0,j);	
			}

			String XMLSelect = "<XMLSelect search=\"MiningResult[@Name='"+ModelName+"']\"/>"; 

			List ModelList = cUtilityClass.getObjects(XMLSelect, "MiningResult",fullReposid);
			ModelName = cUtilityClass.resolveName(ModelName);
			if(ModelList.size() >0){
				MiningResult cm = (MiningResult)ModelList.get(0);
				JCheckBox cTemp1 = new JCheckBox(ModelName);
				lstExistingModels.add(cTemp1);
				hmMetaModels.put(ModelName,cm);	
			}else{
				JCheckBox cTemp2 = new JCheckBox(ModelName,true);
				lstNewModels.add(cTemp2);	
			}
			hmMetaModelFile.put(ModelName,fullModelName);
		}// Enf of For loop

		myPanel.lstModelNew.setListData(lstNewModels.toArray());
		myPanel.lstModelExisting.setListData(lstExistingModels.toArray());

	}
	/**
	 * Validate data entered into panel.
	 * return boolean to determine if there is validate data in the panel or not
	 */
	public boolean validateData() {

		// Clear collection to have fresh collection
		libsToImport.clear();
		tablesToImport.clear();
		cubesToImport.clear();
		jobsToImport.clear();
		prototypesToImport.clear();
		mapsToImport.clear();
		PortletsToImport.clear();
		processesToImport.clear();
		externalTablesToImport.clear();
		modelsToImport.clear();
		tablesToShow.clear();
		jobsToShow.clear();
		/**
		 * CollectNewImport() : Method collect data for actual import from the selected list where the object is checked
		 * Also it collects objects which are to be imported and already exists in Metadata, For its deletion
		 * 
		 * */
		CollectNewImport();

		if(!checkLib(libsToImport)){
			a.errorMessage(popLibNote,"Library can not be Imported");
			return false;
		}
		if(!checkTable(tablesToImport,libsToImport)){
			a.errorMessage(popLibNote + " \nOr not present in the import list of Library. ","Table Can not be imported");
			return false;
		}
		if(cubesToImport.size()>0){

			List schemaList = cUtilityClass.getOlapSchemas(fullReposid);
			if (schemaList.size() <= 0 || schemaList==null){
				a.errorMessage("For importing Cube Required OLAP Schema is not present in the environment","Cube Can not be imported");	
				return false;
			}

		}	
		return myPanel.validateData();
	}//end public boolean validateData()


	private boolean checkTable(List TToImport,List LToImport){
		boolean retVal = true;
		for(int j=0;j<TToImport.size();j++)
		{
			String FullTName = (String)TToImport.get(j); 
			int dot = FullTName.indexOf(".");
			String LName =  FullTName.substring(0,dot);
			String TName =  FullTName.substring(dot+1);

			if(!"NoLibrary".equalsIgnoreCase(LName)){
				if(LToImport.contains (cUtilityClass.changeReferenceTo(LName+".xml"))||checkExistence("SASLibrary",cUtilityClass.MoreResolveTexttoHash(LName), "")){
					retVal = true;
				}else{
					retVal = false;
					break;	
				}	
			}else{
				retVal = true;
			}
		}
		return retVal;
	}



	private boolean checkLib(List LToImport){
		boolean retVal = true;
		for(int j=0;j<LToImport.size();j++){
			String FullFilePath = solutionPath +"\\Libraries\\"+ (String)LToImport.get(j);
			//a.b("FileName: "+FullFilePath);
			Document doc = cUtilityClass.getDocumentObjFromFile(FullFilePath);
			NodeList nlSASLibrary = doc.getElementsByTagName("SASLibrary");
			Node nSASLibrary = nlSASLibrary.item(0);
			NamedNodeMap nnmSASLibrary = nSASLibrary.getAttributes();
			Node libNameNode = nnmSASLibrary.getNamedItem("Name");
			String libName = libNameNode.getNodeValue(); 
			Node nEngine = nnmSASLibrary.getNamedItem("Engine");
			//a.b("Engine: "+nEngine.getNodeValue());
			String engine = nEngine.getNodeValue();
			if(!("BASE".equalsIgnoreCase(engine)||"V7".equalsIgnoreCase(engine)||
					"V701".equalsIgnoreCase(engine) ||
					"V8".equalsIgnoreCase(engine) ||
					"V9".equalsIgnoreCase(engine) ||
					"SPDE".equalsIgnoreCase(engine)||
					"LIST".equalsIgnoreCase(engine))
			){
				String val = getReqObject("Login",doc);
				if(!"".equalsIgnoreCase(val)){
					retVal = checkExistence("Login",val, libName);
				}
				if(retVal){
					val = getReqObject("SASClientConnection",doc);
					retVal = checkExistence("SASClientConnection",val, libName);
					//a.b("if Login Exists then : " + val + " " + retVal);
				}
				if(retVal){
					val = getReqObject("DatabaseSchema",doc);
					retVal = checkExistence("DatabaseSchema",val, libName);	
					//a.b("if ClientConnection Exists then : " + val + " " + retVal);
				}
			}
		}
		//a.b("Finally: retVal: " + retVal);
		return retVal;
	}



	private boolean checkExistence(String type, String Name, String libName){
		boolean retVal = false;
		String XMLSelect = "";
		String person = "";
		String auth = "";

		if("Login".equalsIgnoreCase(type)){
			int k = Name.indexOf("/");
			person = Name.substring(0,k);
			auth = Name.substring(k+1);
			XMLSelect ="<XMLSelect search=\"Login[Domain/AuthenticationDomain[@Name='"+auth+"']]\"/><Templates><Login><AssociatedIdentity/></Login><Person/></Templates>";
		}else{
			Name = cUtilityClass.MoreResolveTexttoHash(cUtilityClass.UnresolveName(Name));
			XMLSelect = "<XMLSelect search=\""+type+"[@Name='" + Name+ "']\"/>";
		}

		IOMI connection = getIOMIConnection ();			
		String reposType = RepositoryUtil.getRepositoryType(connection, fullReposid);
		List ListObjects = null;
		if ("DatabaseSchema".equalsIgnoreCase(type) || !("CUSTOM".equalsIgnoreCase(reposType)) ||
				"SASLibrary".equalsIgnoreCase(type)){
			ListObjects = cUtilityClass.getObjects(XMLSelect, type, fullReposid);
		}else if ("CUSTOM".equalsIgnoreCase(reposType)){
			String reposId = getFoundationReposId(fullReposid, connection);
			ListObjects = cUtilityClass.getObjects(XMLSelect, type, reposId);
		}

		if(ListObjects.size() > 0){
			if("Login".equalsIgnoreCase(type)){
				for(int q=0;q<ListObjects.size();q++)
				{	    				
					CMetadata cm = (CMetadata)ListObjects.get(q);
					String s = cm.getName();
					int i1= s.indexOf(".");
					int i2= s.lastIndexOf(".");
					String s2 = s.substring(i1+1,i2);
					if(person.equalsIgnoreCase(s2))
					{
						retVal = true;
						break;
					}
					cm.dispose();
				}
				if (retVal==false){
					a.error(person+  " not found in Environment.\n Create before importing '" + libName + "' Non SAS library.");
				}

			}
			retVal = true;
		}else{
			if ("".equalsIgnoreCase(libName)){
				popLibNote = type + " '" + cUtilityClass.changeReferenceTo(Name) + "' not present in Environment\n";
			}else{
				popLibNote = type + " '" + cUtilityClass.changeReferenceTo(Name) + "' not present in Environment\n" +
				"This is required to import '" + libName + "' Library";
			}
		}
		//a.b("End of the Check");	
		return retVal;
	}


	public static IOMI getIOMIConnection (){
		IOMI connection = null;
		String OMRUserid = cUtilityClass.getOMRValue("Username");
		String OMRPassword = cUtilityClass.getOMRValue("Password");
		String OMRHost = cUtilityClass.getOMRValue("Hostname");
		String OMRPort = cUtilityClass.getOMRValue("Port");

		MetadataWorkspace workspace = MetadataWorkspace.getWorkspace();
		try {
			connection = workspace.makeOMRConnection(OMRHost, OMRPort, OMRUserid, OMRPassword);
		} catch (Exception e) {
			a.error("Error while getting the Connection Parameter");
			e.printStackTrace(System.err);
		}
		return connection;
	}

	public static String getFoundationReposId(String reposId, IOMI connection){
		try {
			Vector reposDependent = RepositoryUtil.getRepositoryDependencies(connection, reposId, RepositoryUtil.DEPENDENCY_USES);
			for (int i=0; i<reposDependent.size(); i++){
				ReposDependencyObject baseRepository = (ReposDependencyObject)reposDependent.get(i);
				Repository baseRepos =  baseRepository.getRepository();
				String reposType = baseRepos.getName();
				if ("Foundation".equalsIgnoreCase(reposType)){
					return RepositoryUtil.getReposIdForName(connection, baseRepos.getName());
				}
			}		

		} catch (Exception e) {
			a.error ("Error while reading the dependant repository of the Custom Repository \n" + e.getMessage());
			e.printStackTrace(System.err);
		}
		return null;
	}

	private String getReqObject(String type, Document doc){
		String retVal = "";
		NodeList nlLogin = doc.getElementsByTagName(type);
		if(nlLogin.item(0) != null){
			Node nLogin = nlLogin.item(0);
			NamedNodeMap nnmLogin = nLogin.getAttributes();
			Node nObjRef = nnmLogin.getNamedItem("ObjRef");
			retVal =nObjRef.getNodeValue(); 
		}
		return retVal;
	}

	/**
	 * Prepare collection for Import
	 * 
	 * */

	private void CollectNewImport(){

		JTable table = myPanel.getScrollTable();
		DefaultTableModel dtm = (DefaultTableModel)table.getModel();

		String[] NewTabs = myPanel.lstTabNew.getCheckedItems();

		//List ExistTabs = getNotCheckedExistTables(table,dtm);
		String[] NewJobs = myPanel.lstJobNew.getCheckedItems();
		String[] NewCubes = myPanel.lstCubeNew.getCheckedItems();
		String[] NewPrototypes = myPanel.lstPrototypeNew.getCheckedItems();
		String[] NewLibs = myPanel.lstLibNew.getCheckedItems();
		String[] NewMaps = myPanel.lstMapNew.getCheckedItems();
		String[] NewPortlets = myPanel.lstPortletNew.getCheckedItems();
		String[] NewProcesses = myPanel.lstProcessNew.getCheckedItems();
		String[] NewModels = myPanel.lstModelNew.getCheckedItems();
		String[] NewExternalTables = myPanel.lstExternalTableNew.getCheckedItems();

//		String[] CHKExistJobs = myPanel.lstJobExisting.getCheckedItems();
		String[] CHKExistCubes = myPanel.lstCubeExisting.getCheckedItems();
		String[] CHKExistLibs = myPanel.lstLibExisting.getCheckedItems();
		String[] CHKExistPrototypes = myPanel.lstPrototypeExisting.getCheckedItems();
		String[] CHKExistMaps = myPanel.lstMapExisting.getCheckedItems();
		String[] CHKExistPortlets = myPanel.lstPortletExisting.getCheckedItems();
		String[] CHKExistProcesses = myPanel.lstProcessExisting.getCheckedItems();
		String[] CHKExistModels = myPanel.lstModelExisting.getCheckedItems();
		String[] CHKExistExternalTables = myPanel.lstExternalTableExisting.getCheckedItems();

		getNewImportValues(NewTabs, "NT");
		getNewImportValues(NewJobs, "NJ");
		getNewImportValues(NewCubes, "NC");
		getNewImportValues(NewLibs, "NL");
		getNewImportValues(NewPrototypes, "NP");
		getNewImportValues(NewMaps, "NM");
		getNewImportValues(NewProcesses, "NPR");
		getNewImportValues(NewModels, "NEM");
		getNewImportValues(NewPortlets, "NPR");
		getNewImportValues(NewExternalTables, "NET");

//		getNewImportValues(CHKExistJobs, "EJ");
		getNewImportValues(CHKExistCubes, "EC");
		getNewImportValues(CHKExistLibs, "EL");
		getNewImportValues(CHKExistPrototypes, "EP");
		getNewImportValues(CHKExistMaps, "EM");
		getNewImportValues(CHKExistProcesses, "EPR");
		getNewImportValues(CHKExistModels, "EEM");
		getNewImportValues(CHKExistPortlets, "EPR");
		getNewImportValues(CHKExistExternalTables, "EET");

		getNewImportExistTabWithChoice(table,dtm);
		table = myPanel.getJobTable();
		dtm = (DefaultTableModel)table.getModel();
		getNewImportExistJobWithChoice(dtm);

//		getObjectstoDelete(CHKExistJobs,"EJ");
		getObjectstoDelete(CHKExistCubes,"EC");
		getObjectstoDelete(CHKExistLibs,"EL");
		getObjectstoDelete(CHKExistPrototypes,"EP");
		getObjectstoDelete(CHKExistMaps,"EM");
		getObjectstoDelete(CHKExistProcesses,"EPR");
		getObjectstoDelete(CHKExistModels,"EEM");
		getObjectstoDelete(CHKExistPortlets,"EPR");
		getObjectstoDelete(CHKExistExternalTables,"EET");


	}// end of CollectNewImport


	private void getObjectstoDelete(String[] str, String type){
		//a.b("in getObjectstoDelete");
		if("EJ".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				Job temp = (Job)hmMetaTables.get(sTemp);
				objsToDelete.add(temp.getId()+"#Job#"+temp.getName());
			}	
		}else if("EC".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				Cube temp = (Cube)hmMetaCubes.get(sTemp);
				objsToDelete.add(temp.getId()+"#Cube#"+temp.getName());
			}	
		}else if("EL".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				//a.b("String Name : "+sTemp);
				CMetadata temp = (CMetadata)hmMetaLibs.get(sTemp);
				//a.b("Library Name : "+temp.getName());
				objsToDelete.add(temp.getId()+"#SASLibrary#"+temp.getName());						
			}	
		}else if("EP".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				Prototype temp = (Prototype)hmMetaProtos.get(sTemp);
				objsToDelete.add(temp.getId()+"#Prototype#"+temp.getName());					
			}	
		}else if("EM".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				Transformation temp = (Transformation)hmMetaMaps.get(sTemp);
				objsToDelete.add(temp.getId()+"#Transformation#"+temp.getName());					
			}	
		}else if("EPR".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];

				ClassifierMap temp = (ClassifierMap)hmMetaProcesses.get(sTemp);
				objsToDelete.add(temp.getId()+"#ClassifierMap#"+temp.getName());					
			}	
		}else if("EEM".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				MiningResult temp = (MiningResult)hmMetaModels.get(sTemp);
				objsToDelete.add(temp.getId()+"#MiningResult#"+temp.getName());
			}	
		}else if("ER".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				Transformation temp = (Transformation)hmMetaPortlets.get(sTemp);
				objsToDelete.add(temp.getId()+"#Transformation#"+temp.getName());
			}	
		}else if("EET".equalsIgnoreCase(type)){
			for(int i=0;i<str.length;i++){
				String sTemp = str[i];
				ExternalTable temp = (ExternalTable)hmMetaExternalTables.get(sTemp);
				objsToDelete.add(temp.getId()+"#ExternalTable#"+temp.getName());
			}	
		}				
	}

	/**
	 * Method to get all the details about existing table according to the decision taken on table 
	 * @param table: populated table which is all the information 
	 * @param DefaultDataModel: populated table which is all the information
	 * */

	private void getNewImportExistTabWithChoice(JTable table, DefaultTableModel dtm){

		//a.b("in getNewImportExistTabWithChoice");
		List lstExistTables = new Vector();
		tablesToDelete = new Vector();
		String Decision = "";
		String tableName = "";
		String XMLfilePath = "";
		String sTableFileName  = "";
		PhysicalTable pt = null;

		// iTable will store the array of selected row
		int[] iTables = table.getSelectedRows();
		//hmTableChoiceMap will have  libname.TableName and decision
		HashMap hmTableChoiceMap = getTablesChoice(dtm);

		Set TableSet= hmTableChoiceMap.keySet(); 
		Iterator TableIter = TableSet.iterator();
		//iterating hmTableChoiceMap map
		while(TableIter.hasNext()){ 
			tableName = (String)TableIter.next();
			Decision = (String)hmTableChoiceMap.get(tableName);
			HashMap hmMetaColumns = new HashMap(); 
			HashMap hmXMLColumns = new HashMap();	
			HashMap hmXMLTablesInfo = new HashMap();
			//a.b("Decition = " + Decision + "\nTable = " + tableName);
			sTableFileName  = (String)hmMetaTablesFile.get(tableName);
			pt = (PhysicalTable)hmMetaTables.get(tableName);
			XMLfilePath = solutionPath+"\\Tables\\"+sTableFileName;
			// got physcialTable object and the xml file to get both the information for prepa of update data

			if("OverWrite".equalsIgnoreCase(Decision)){
				pt = (PhysicalTable)hmMetaTables.get(tableName);
				tablesToDelete.add(pt.getId());
				tablesToImport.add(sTableFileName);
				tablesToShow.add(sTableFileName+"#"+Decision);				
			}else if ("NoAction".equalsIgnoreCase(Decision)){
				tablesToShow.add(sTableFileName+"#"+Decision);
			}else if ("Import".equalsIgnoreCase(Decision)){
				tablesToImport.add(sTableFileName);
				tablesToShow.add(sTableFileName+"#"+Decision);
			}else{
				// Just to prepare the base for next three actions
				Document doc = cUtilityClass.getDocumentObjFromFile(XMLfilePath);
				NodeList nlPhysicalTable = doc.getElementsByTagName("PhysicalTable");
				NodeList nlColumn = doc.getElementsByTagName("Column");
				NodeList nlProperty = doc.getElementsByTagName("Property");
				NodeList nlPropertyType = doc.getElementsByTagName("PropertyType");
				hmMetaColumns = getTableColumns(pt); // has ColumnName and Id
				hmXMLColumns = getXMLColumnData(nlColumn);// has columnName(lowercase) with HashMap of other column info
				hmXMLTablesInfo = getXMLTableDataInfo(nlProperty);// Has tableName(LowerCase) with HashMap of 
			}

			if(Decision.equalsIgnoreCase("Add XML Colmn")){
				HashMap hmXmlAdditionalColumns = getXMLTBRData(hmMetaColumns,hmXMLColumns);
				hmAddXMLColumnData.put(tableName,hmXmlAdditionalColumns);
				tablesToShow.add(sTableFileName+"#Adding Additional XML Columns");
			}else if(Decision.equalsIgnoreCase("Del Meta Colmn")){
				getMetaTBRData(hmMetaColumns,hmXMLColumns);
				tablesToShow.add(sTableFileName+"#Delete Additional Meta Columns");
			}else if(Decision.equalsIgnoreCase("Update")){
				// temp has existing column map of id with hashMap of xml attribute values
				HashMap temp = getUPDTBRData(hmMetaColumns,hmXMLColumns);
				hmUpdateXMLColumnData.put(tableName,temp);
				HashMap hmAdditionalXmlColData = getXMLTBRData(hmMetaColumns,hmXMLColumns);
				hmAppendXMLColumnData.put(tableName,hmAdditionalXmlColData);
				tablesToShow.add(sTableFileName+"#Updating Column Attribute");
			}else if(Decision.equalsIgnoreCase("Add XML Del Meta")){
				// to add additional columns
				HashMap hmXmlAdditionalColumns = getXMLTBRData(hmMetaColumns,hmXMLColumns);	
				hmAddXMLColumnData.put(tableName,hmXmlAdditionalColumns);
				// to update existing columns
				getMetaTBRData(hmMetaColumns,hmXMLColumns);
				// to show in the finish string
				tablesToShow.add(sTableFileName+"#Add XMl, Delete Meta Cols ");
			}else if(Decision.equalsIgnoreCase("Update Table")){
				// to add additional columns
				hmUpdateXMLTableData.put(tableName,hmXMLTablesInfo);
				// to show in the finish string
				tablesToShow.add(sTableFileName+"#Updating table Attribute ");
			}else if(Decision.equalsIgnoreCase("Update All")){
				// to add additional columns

				HashMap temp = getUPDTBRData(hmMetaColumns,hmXMLColumns);
				hmUpdateXMLColumnData.put(tableName,temp);
				HashMap hmAdditionalXmlColData = getXMLTBRData(hmMetaColumns,hmXMLColumns);
				hmAppendXMLColumnData.put(tableName,hmAdditionalXmlColData);
				hmUpdateXMLTableData.put(tableName,hmXMLTablesInfo);
				// to show in the finish string
				tablesToShow.add(sTableFileName+"#Updating All ");
			}
		}// End of While loop
	}// end of getNewImportExistTabWithChoice

	// Function read the choices done by user and fill the hashmaps
	private void getNewImportExistJobWithChoice(DefaultTableModel dtm)
	{
		try
		{
			String Decision = "";
			String JobName = "";
			String XMLfilePath = "";
			String sJobFileName  = "";
			Job objJob = null;

			//hmTableChoiceMap will have  JobName and decision
			HashMap hmJobChoiceMap = getTablesChoice(dtm);

			Set TableSet= hmJobChoiceMap.keySet(); 
			Iterator TableIter = TableSet.iterator();

			//iterating hmTableChoiceMap map
			while(TableIter.hasNext())
			{
				JobName = (String)TableIter.next();
				Decision = (String)hmJobChoiceMap.get(JobName);
				HashMap hmMetaColumns = new HashMap();
				HashMap hmXMLColumns = new HashMap();
				HashMap hmXMLTablesInfo = new HashMap();
				//a.b("Decition = " + Decision + "\nTable = " + tableName);
				sJobFileName  = (String)hmMetaTablesFile.get(JobName);
				objJob = (Job)hmMetaTables.get(JobName);
				XMLfilePath = solutionPath + "\\Jobs\\" + sJobFileName;

				// Got the Job object and the xml file to get both the information for prepa of update data
				if("OverWrite".equalsIgnoreCase(Decision))
				{
					objsToDelete.add(objJob.getId()+"#Job#"+objJob.getName());
					jobsToImport.add(sJobFileName);
					jobsToShow.add(sJobFileName+"#"+Decision);
				}
				else if ("NoAction".equalsIgnoreCase(Decision))
				{
					jobsToShow.add(sJobFileName+"#"+Decision);
				}
				else if ("Import".equalsIgnoreCase(Decision))
				{
					jobsToImport.add(sJobFileName);
					jobsToShow.add(sJobFileName+"#"+Decision);
				}
				else if ("Update".equalsIgnoreCase(Decision))
				{
					jobsToImport.add(sJobFileName);
					hmJobsToUpdate.put(sJobFileName, objJob.getId()+"#"+objJob.getName());
					jobsToShow.add(sJobFileName+"#"+Decision);
				}
			}// End of While loop
		}
		catch(Exception e)
		{
			a.error("Error: " + e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("Error: " + e.getMessage());
		}
	}// end of getNewImportExistJobWithChoice


	/*Method to return a Map of Table name pre fixed with library name and
	 * decision taken on that table
	 * */
	private HashMap getTablesChoice(DefaultTableModel dtm){
		int i = dtm.getRowCount();
		HashMap hmTableChoiceMap = new HashMap();
		for(int j=0;j<i;j++)
		{			
			String s = (String)dtm.getValueAt(j,0);
			hmTableChoiceMap.put((String)dtm.getValueAt(j,1),s);	
		}
		return hmTableChoiceMap;
	}

	/**
	 * Comparing two HashMap collection and finding out columns which are to be updated
	 * Finally preparing collection of all column property with column id as unique key
	 **/
	private HashMap getUPDTBRData(HashMap hmMetaColumns,HashMap hmXMLColumns){
		HashMap hmUpdateXMLData = new HashMap();
		Set outerSet= hmXMLColumns.keySet(); 
		Iterator outerIter = outerSet.iterator();
		int i=1; 
		while(outerIter.hasNext()){ 
			String columnName = (String)outerIter.next();
			if(hmMetaColumns.containsKey(columnName.toLowerCase())){
				String id = (String)hmMetaColumns.get(columnName.toLowerCase());
				hmUpdateXMLData.put(id,(HashMap)hmXMLColumns.get(columnName.toLowerCase()));
			}
		}
		return hmUpdateXMLData;
	}//getUPDTBRData

	/**
	 *Iterating xmlColumns collection and finally achieving HahsMap collection of 
	 * columns which are not present in Metadata 
	 * 
	 * */
	private HashMap getXMLTBRData(HashMap hmMetaColumns,HashMap hmXMLColumns){
		HashMap hmXmlColumnsClone = (HashMap)hmXMLColumns.clone();	
		Set outerSet= hmXMLColumns.keySet(); 
		Iterator outerIter = outerSet.iterator();
		while(outerIter.hasNext()){ 
			String ColumnName = (String)outerIter.next();
			if(hmMetaColumns.containsKey(ColumnName.toLowerCase())){
				hmXmlColumnsClone.remove(ColumnName.toLowerCase());
			}
		}
		//a.b("Size of EXTRA XML: "+hmXmlTableData.size());
		// remove columns from XML Column list which are in Metadata
		return hmXmlColumnsClone;

	}// end of getXMLTBRData

	/**
	 * Comparing two HahsMap collection and getting intersection for 
	 * deleting columns which are not present in xml collection
	 * Finally taking those columns id into a global delete list of columns
	 * */
	private void getMetaTBRData(HashMap hmMetaColumns,HashMap hmXMLColumns){
		Set outerSet= hmMetaColumns.keySet(); 
		Iterator outerIter = outerSet.iterator();
		int i=1; 
		while(outerIter.hasNext()){ 
			String tableName = (String)outerIter.next();
			if(!hmXMLColumns.containsKey(tableName.toLowerCase())){
				lstColumnToDelete.add((String)hmMetaColumns.get(tableName.toLowerCase()));
			}
		}
	}// end of 

	// return Map of SAScolumnName(LowerCase) with Map of columnData
	private HashMap getXMLColumnData(NodeList nlColumn){
		HashMap hmXMLColumnData = new HashMap(); 
		for(int iColumn=0;iColumn<nlColumn.getLength();iColumn++){
			Node nColumn = nlColumn.item(iColumn);
			if(nColumn.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nColumn)){
				NamedNodeMap nnmAttr = nColumn.getAttributes(); 
				Node nId = nnmAttr.getNamedItem("Id");
				Node nName = nnmAttr.getNamedItem("Name");
				Node nColumnName = nnmAttr.getNamedItem("ColumnName");
				Node nSASColumnName = nnmAttr.getNamedItem("SASColumnName");
				String ColumnName = nSASColumnName.getNodeValue();
				Node nType = nnmAttr.getNamedItem("SASColumnType");
				Node nLength = nnmAttr.getNamedItem("SASColumnLength");
				Node nFormat = nnmAttr.getNamedItem("SASFormat");
				Node nInFormat = nnmAttr.getNamedItem("SASInformat");
				Node nColDesc = nnmAttr.getNamedItem("Desc");
				Node nIsNullable = nnmAttr.getNamedItem("IsNullable");

				HashMap hmDataMap = new HashMap();
				hmDataMap.put("Name",nName.getNodeValue());
				hmDataMap.put("ColumnName",nColumnName.getNodeValue());
				hmDataMap.put("SASColumnName",nSASColumnName.getNodeValue());
				hmDataMap.put("ColumnLength",nLength.getNodeValue());
				hmDataMap.put("ColumnType",nType.getNodeValue());
				hmDataMap.put("Format",nFormat.getNodeValue());
				hmDataMap.put("Informat",nInFormat.getNodeValue());
				hmDataMap.put("Desc",nColDesc.getNodeValue());
				hmDataMap.put("IsNullable",nIsNullable.getNodeValue());
				hmXMLColumnData.put(ColumnName.toLowerCase(),hmDataMap);
			}
		}
		return hmXMLColumnData;
	}// end of getXMLColumnData


//	return  Map of TableAttributeData for a single table

	private HashMap getXMLTableDataInfo(NodeList nlProperty){

		HashMap hmXMLPTNameIdmap = new HashMap();

		for(int iPT=0;iPT<nlProperty.getLength();iPT++){
			Node nProperty = nlProperty.item(iPT);
			if(nProperty.getNodeType()==Node.ELEMENT_NODE){

				if(checkNodeType(nProperty)){
					NamedNodeMap nnmAttr = nProperty.getAttributes(); 
					Node nPTName = nnmAttr.getNamedItem("PropertyName");
					Node nDefaultValue = nnmAttr.getNamedItem("DefaultValue");
					hmXMLPTNameIdmap.put(nPTName.getNodeValue(),nDefaultValue.getNodeValue());
				}
			}
		}
		return hmXMLPTNameIdmap;
	}// end of getXMLColumnData

	private Node getFullNode(NodeList nlColumn, String id){
		Node nColumn = null;
		for(int iColumn=0;iColumn<nlColumn.getLength();iColumn++){
			nColumn = nlColumn.item(iColumn);
			if(nColumn.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nColumn)){
				if(nColumn.hasAttributes()){
					NamedNodeMap nnmAttr = nColumn.getAttributes(); 
					Node nId = nnmAttr.getNamedItem("Id");
					if(id.equalsIgnoreCase(nId.getNodeValue()))
						break;
				}
			}
		}

		return nColumn;
	}

	// return Map of SASColumnName()Lower case with its Id 
	private HashMap getTableColumns(CMetadata cm){
		//a.b("in metad   getTableColumns ");
		HashMap hmMetaColumnData = new HashMap();
		MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
		CMetadata cmetadata = MdObjectFactory.createComplexMetadataObject(mdobjectstore, cm);
		AssociationList alColList=null;
		List alList=new Vector();

		int j = 0x8018c;

		try {
			cmetadata = MetadataUtil.getMetadataAllDepths(cmetadata, new ArrayList(), new ArrayList(), "<Templates><PhysicalTable><Columns/></PhysicalTable><Column Id=\"\" Name=\"\" /></Templates>", j);
		} catch (MdException e) {
			// TODO Auto-generated catch block
			e.printStackTrace(System.err);
		}

		PhysicalTable pt = (PhysicalTable)cmetadata;
		//a.b("Fully loaded CM casted into Physical Table :" );

		try {
			alColList = pt.getColumns();
		} catch (MdException e2) {
			// TODO Auto-generated catch block
			e2.printStackTrace(System.err);
		}

		for(int h=0;h<alColList.size();h++){
			Column c = (Column)alColList.get(h);
			hmMetaColumnData.put(c.getSASColumnName().toLowerCase(),c.getId());
		}
		//store disposed - 4th sept 2007 -prachi
		mdobjectstore.dispose();
		return hmMetaColumnData;
	}



	private boolean checkNodeType(Node nCheckNode){
		boolean retVal = false;
		NodeList n = nCheckNode.getChildNodes();
		if(n.getLength() > 0)
			retVal = true;
		return retVal;
	}

	private List getNotCheckedExistTables(JTable table, DefaultTableModel dtm){
		List ExistTabs = new Vector();
		int[] iSelExistTable = table.getSelectedRows();
		int iTotalExistTable = table.getRowCount();
		for(int i=0;i<iTotalExistTable;i++){
			String s = (String)dtm.getValueAt(i,1);
			ExistTabs.add(s);
		}
		for(int i=0;i<iSelExistTable.length;i++){
			String s = (String)dtm.getValueAt(i,1);
			ExistTabs.remove(s);
		}
		return ExistTabs; 
	}

	private void getNewImportValues(String[] allObj, String Type){
		String s = "";

		if("NT".equalsIgnoreCase(Type) || "ET".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaTablesFile.get(allObj[i]); 
				tablesToImport.add(s);
			}
		}

		if("NJ".equalsIgnoreCase(Type) || "EJ".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaTablesFile.get(allObj[i]);
				jobsToImport.add(s);
				jobsToShow.add(s);
			}
		}
		if("NC".equalsIgnoreCase(Type) || "EC".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaCubeFile.get(allObj[i]);
				cubesToImport.add(s);
			}
		}
		if("NL".equalsIgnoreCase(Type) || "EL".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaLibFile.get(allObj[i]);
				if (s.indexOf("&amp;") != -1){
					s = cUtilityClass.replaceAnd(s);
				}
				libsToImport.add(s);
			}
		}if("NP".equalsIgnoreCase(Type) || "EP".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaPrototypeFile.get(allObj[i]);
				prototypesToImport.add(s);
			}
		}if("NM".equalsIgnoreCase(Type) || "EM".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaMapFile.get(allObj[i]);
				mapsToImport.add(s);
			}
		}if("NR".equalsIgnoreCase(Type) || "ER".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaPortletFile.get(allObj[i]);
				PortletsToImport.add(s);
			}
		}

		if("NPR".equalsIgnoreCase(Type) || "EPR".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaProcessFile.get(allObj[i]);
				processesToImport.add(s);

			}
		}if("NEM".equalsIgnoreCase(Type) || "EEM".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaModelFile.get(allObj[i]);
				modelsToImport.add(s);
			}
		}if("NET".equalsIgnoreCase(Type) || "EET".equalsIgnoreCase(Type)){
			for(int i=0;i<allObj.length;i++){
				s = (String)hmMetaExternalTableFile.get(allObj[i]);
				externalTablesToImport.add(s);
			}
		}

	}// end of getNewImportValues


	/**
	 * Run when the Next button is selected.
	 */
	public void onNext() {
		super.onNext();
	}//end public void onNext()
	/**
	 * Run when the back button is selected.
	 */
	public void onBack() {
		super.onBack();
	}//end public void onBack()
	/**
	 * Create the finish string that shows up in WAWizardFinish
	 */
	public String createFinishString()
	{	

		String str = getStringAllObjcts();
		return str;
	}//end public String createFinishString()

//	creates single Finish String 
	public String getStringAllObjcts(){ 
		String[] strObjTypes = {"Cube","Job","PhysicalTable","Groups","SASLibrary","Prototype", "Transformation", "ClassifierMap","MiningResult","Portlets","ExternalTable"};
		StringBuffer sbFinish = new StringBuffer("\nSelected Components\n\n");

		for(int t=0;t<strObjTypes.length;t++){
			if(strObjTypes[t].equalsIgnoreCase("Cube")){
				if(cubesToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],cubesToImport,cubesToImport_V.size()));
				}
			}	

			if(strObjTypes[t].equalsIgnoreCase("Job")){
				if(jobsToImport.size()>0 || jobsToShow.size()>0){
					if(jobsToImport.size() == jobsToShow.size()){
						sbFinish.append(appendIntoFinish(strObjTypes[t],jobsToImport,jobsToImport.size()));
					}else{
						sbFinish.append("\n"+strObjTypes[t] + "'s\n");
						sbFinish.append("Total "+strObjTypes[t]+"'s are "+ jobsToImport.size() +" and You have Selected :" + jobsToImport.size()+" "+strObjTypes[t]+"\n");
						for(int y=0;y<jobsToShow.size();y++){
							String s = (String)jobsToShow.get(y);
							int i = s.indexOf("#");
							if(i != -1)
								sbFinish.append("     "+cUtilityClass.resolveName(s.substring(0,i)) + " For "+ s.substring(i+1) + "\n" );
							else
								sbFinish.append("     "+cUtilityClass.resolveName(s) + "\n" );
						}
					}
				}
			}
			
			if(strObjTypes[t].equalsIgnoreCase("PhysicalTable")){
				if(tablesToImport.size()>0 || tablesToShow.size()>0){
					if(tablesToImport.size() == tablesToImport_V.size()){
						sbFinish.append(appendIntoFinish(strObjTypes[t],tablesToImport,tablesToImport_V.size()));
					}else{
						sbFinish.append("\n"+strObjTypes[t] + "'s\n");
						sbFinish.append("Total "+strObjTypes[t]+"'s are "+ tablesToImport_V.size() +" and You have Selected :" + tablesToImport.size()+" "+strObjTypes[t]+"\n");
						for(int y=0;y<tablesToShow.size();y++){
							String s = (String)tablesToShow.get(y);
							int i = s.indexOf("#");
							String decision = s.substring(i+1);
							sbFinish.append("     "+cUtilityClass.resolveName(s.substring(0,i)) + " For "+ decision + "\n" );
						}
					}
				}		
			}
			if(strObjTypes[t].equalsIgnoreCase("Groups")){
				if(treesToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],treesToImport,treesToImport.size()));
				}	
			}
			if(strObjTypes[t].equalsIgnoreCase("SASLibrary")){
				if(libsToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],libsToImport,libsToImport_V.size()));
				}	
			}
			if(strObjTypes[t].equalsIgnoreCase("Prototype")){
				if(prototypesToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],prototypesToImport,prototypesToImport_V.size()));
				}	
			}if(strObjTypes[t].equalsIgnoreCase("Transformation")){
				if(mapsToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],mapsToImport,mapsToImport_V.size()));
				}	
			}if(strObjTypes[t].equalsIgnoreCase("Portlets")){
				if(PortletsToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],PortletsToImport,PortletsToImport_V.size()));
				}	
			}if(strObjTypes[t].equalsIgnoreCase("ClassifierMap")){
				if(processesToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],processesToImport,processesToImport_V.size()));
				}	
			}if(strObjTypes[t].equalsIgnoreCase("MiningResult")){
				if(modelsToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],modelsToImport,modelsToImport_V.size()));
				}	
			}if(strObjTypes[t].equalsIgnoreCase("ExternalTable")){
				if(externalTablesToImport.size()>0){
					sbFinish.append(appendIntoFinish(strObjTypes[t],externalTablesToImport,externalTablesToImport_V.size()));
				}	
			}
		}// end of FOR
		return sbFinish.toString();
	}

	private String appendIntoFinish(String type, List x1, int number){
		StringBuffer sbFinish = new StringBuffer(500);
		sbFinish.append("\n"+type + "'s\n");
		sbFinish.append("Total "+type+"'s are "+ number +" and You have Selected :" + x1.size()+" "+type+"\n");
		for(int l=0;l<x1.size();l++){
			String finalObj = (String)x1.get(l);
			sbFinish.append("     " + cUtilityClass.resolveName(finalObj) + "\n");
		}			
		return sbFinish.toString();
	}

	import_Objects IO;
	private static WAdminResource m_bundle;

}
