/*
* Created on Nov 30, 2004
* Ajit Singh
* */

package com.sas.metadata.imp;


import java.awt.Cursor;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import com.sas.metadata.MdException;
import com.sas.workspace.MessageUtil;
import com.sas.workspace.WAWizardDialog;
import com.sas.workspace.WAdminResource;
import com.sas.workspace.Workspace;
import com.sas.workspace.WsDescriptionWizardTab;



public class ObjChooseTab extends WsDescriptionWizardTab 
{	

    public ObjChooseTab()
    {   	
        super(m_bundle.getString("ObjChooseTab.Top.txt"));
        
        m_parent = null;
        setHelpTopic("tgtdesign_table_source_cols");
        FinishString = "";
      //  mdobjectstore = MdObjectFactory.createObjectStore();
        _initialize();
    }

    public void saveSettingsAndCleanUp()
    {
    	
        m_columnsPanel.saveSettingsAndCleanUp();
        m_parent = null;
        m_columnsPanel = null;
    	FinishString=null;
        reposid = null;
     //   mdobjectstore = null;
    }

    public boolean doDataExchange(boolean flag)
        throws MdException
    {    	
        boolean flag1 = false;
        if(m_parent == null)
        m_parent = (WAWizardDialog)getTopLevelAncestor();
        
        if(!flag)
        {
        	m_path = (String)m_parent.getWizardData("SOLUTIONPATH");
        	reposid = (String)m_parent.getWizardData("fullreposid");
            if(m_columnsPanel.doDataExchange(false)){
            	m_columnsPanel.setVariables(m_path,reposid);
            	flag1 = true;
            }
            else{
            MessageUtil.displayMessage(m_bundle.getString("TDColumnsTab.Error.CreatingTree.txt"), 0);
            }
            
        }
    	
        return flag1;
    }
    
    public boolean validateData()
    {    
    	
    	boolean flag = false;
        flag = m_columnsPanel.validateData();
        // Adding collection to wizard data
    	m_parent.addWizardData("treestoimport",m_columnsPanel.getSelTrees());
    	m_parent.addWizardData("libstoimport",m_columnsPanel.getSelLibs());
    	m_parent.addWizardData("tablestoimport",m_columnsPanel.getSelTables());
    	m_parent.addWizardData("cubestoimport",m_columnsPanel.getSelCubes());
    	m_parent.addWizardData("prototypestoimport",m_columnsPanel.getSelPrototypes());
    	m_parent.addWizardData("mapstoimport",m_columnsPanel.getSelMaps());
    	m_parent.addWizardData("portlettoimport",m_columnsPanel.getSelPortlets());
    	m_parent.addWizardData("processestoimport",m_columnsPanel.getSelProcesses());
    	m_parent.addWizardData("modelstoimport",m_columnsPanel.getSelModels());
    	m_parent.addWizardData("jobstoimport",m_columnsPanel.getSelJobs());
    	m_parent.addWizardData("externaltablestoimport",m_columnsPanel.getSelExternalTables());
    //	m_parent.addWizardData("OBJECTSTORE",mdobjectstore); 
    	
    	return flag;
    }

  
    /**
     * Create the finish string that shows up in WAWizardFinish
     */
    public String createFinishString()
    {	
    	
    return "";
    }//end public String createFinishString()
  		
    public void onNext()
    {
    	super.onNext(); 
    }

    public void onBack()
    {
        super.onBack();
        m_parent.setCursor(Cursor.getPredefinedCursor(3));
        m_parent.removeWizardData("treestoimport");
       	m_parent.removeWizardData("libstoimport");
       	m_parent.removeWizardData("tablestoimport");
       	m_parent.removeWizardData("cubestoimport");
       	m_parent.removeWizardData("jobstoimport");
       	m_parent.removeWizardData("prototypestoimport");
       	m_parent.removeWizardData("mapstoimport");
    	m_parent.removeWizardData("portlettoimport");
       	m_parent.removeWizardData("modelstoimport");
       	m_parent.removeWizardData("processestoimport");
       	m_parent.removeWizardData("externaltablestoimport");
        
       	 // commentd - 19th sept 2007 -Prachi
       	//	m_parent.removeWizardData("OBJECTSTORE");
       	// check whether the path is changed or not then clear
       	m_columnsPanel.m_oSelectedListModel.clear();       	
        m_parent.setCursor(null);
        
    }
 
   
    private void _initialize()
    {
    	 
        m_columnsPanel = new ColumnsPanel();
        setLayout(new GridBagLayout());
        add(m_columnsPanel, new GridBagConstraints(0, 0, 3, 3, 1.0D, 1.0D, 18, 1, new Insets(0, 0, 0, 0), 0, 0));
    }

    

    private static WAdminResource m_bundle;
    private WAWizardDialog m_parent;
    private ColumnsPanel m_columnsPanel;
    private Workspace m_workspace = Workspace.getWorkspace();
	protected String FinishString ;
	protected String m_path;
	protected String reposid; 

	//protected MdObjectStore mdobjectstore;

    static 
    {
    	m_bundle = new WAdminResource(ObjChooseTab.class);
    }
}