/**
 * <p>Title: ComparePanel</p>
 * <p>Description: Panel class for comparision page</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */
package com.sas.metadata.imp;

// Import statements
import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.sas.metadata.AssociationList;
import com.sas.metadata.CMetadata;
import com.sas.metadata.Column;
import com.sas.metadata.MdException;
import com.sas.metadata.MdObjectFactory;
import com.sas.metadata.MdObjectStore;
import com.sas.metadata.MetadataUtil;
import com.sas.metadata.PhysicalTable;
import com.sas.workspace.WAPanel;
import com.sas.workspace.WAdminResource;
import com.sas.workspace.WsAbstractAction;

// Class start
public class TabDiffDlg extends JDialog
{
	JPanel contentPane;
	  
	String []m_arrTableNames;	// Stores the names of selected tables
	String m_Path;				// Path of folder having XML files
	HashMap m_hmTableMap;		// Map of table name vs reference to physical table object
	HashMap m_hmMetaTablesFile;	// Map of tbale name vs XML file name containing the table
	HashMap m_hmXMLColumnData;
	HashMap m_hmMetaColumnData;
	HashMap m_hmCommonColumnDataFinal;
	HashMap m_hmColums = new HashMap();;
	HashMap m_tableModelCollection;
	
	protected static WAdminResource m_bundle;	// Reference to resources like icons
	
	List lstcommonColumns = new Vector();
	List lstXMLColumnName = new Vector();
	List lstMetaColumnName = new Vector();
	JTabbedPane TableDiffTablPan ;
	List lstFinalCommon = new Vector();	// List of column names common in XML & meta data
	List lstFinalXML = new Vector();	// List of column names present only in XML
	List lstFinalMETA = new Vector();	// List of column names present only in meta data
	
	// Default Constructor
	public TabDiffDlg()
	{
		this(null, "", false);
	}
	// Unused Constructor
	public TabDiffDlg(Frame frame, String title, boolean modal)
	{
		super(frame, title, modal);
	}

	// Useful Constructor
	public TabDiffDlg(String []vTableNames, HashMap hmTableMap, HashMap hmMetaTablesFile, String path, WAdminResource bundle)
	{
		// Assign function arguments to member variables 
		// to make them accessible from everywhere
	  	m_arrTableNames = vTableNames;
	  	m_Path = path + "\\Tables";	// All table xml files will be present in subfolder "Table"
	  	m_hmTableMap = hmTableMap;
	  	m_hmMetaTablesFile = hmMetaTablesFile;
	  	m_bundle = bundle;
	  	m_tableModelCollection = new HashMap();
	  	try
		{
	  		//a.b(m_TableName +"   \n"+ m_Path +"   \n hello "+ hmTableMap.size() +"   \n hi "+ hmMetaTablesFile.size());
	  		jbInit();
	  		pack();
		}
	  	catch(Exception ex)
		{
	  		a.error (ex.getMessage());
			ex.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: "+ex.getMessage());
		}
	}

	// Function to create & initialize all the components in this dialog
	private void jbInit() throws Exception
	{
		// Create a tab pane to show each table in separate tab
		TableDiffTablPan = new JTabbedPane();
	
		
		// Set a FOR loop to add one tab for each table
		for(int nTableIndex=0; nTableIndex < m_arrTableNames.length; nTableIndex++)
		{
			String strTableName = m_arrTableNames[nTableIndex];

			// Clear the previous lists
			lstXMLColumnName.clear();
			lstMetaColumnName.clear();
			lstcommonColumns.clear();
			lstFinalCommon.clear();
			lstFinalXML.clear();
			lstFinalMETA.clear();
	
			// Instantiate the model
			DefaultTableModel model = new DefaultTableModel()
			{
		        // This method returns the Class object of the first
		        // cell in specified column in the table model.
		        // Unless this method is overridden, all values are
		        // assumed to be the type Object.
		        public Class getColumnClass(int columnIndex)
		        {
		            Object o = getValueAt(0, columnIndex);
		            if (o == null) {
		                return Object.class;
		            } else {
		                return o.getClass();
		            }
		        }
		    };
		    
			// Fill the columns of table in model
			model.addColumn("Icon");
			model.addColumn("Column Name");
			model.addColumn("Xml - Column Type");
			model.addColumn("Xml - Length");
			model.addColumn("XML - Format");
			model.addColumn("XML - InFormat");
			model.addColumn("XML - Column Desc");
			model.addColumn("Meta - Column Type");
			model.addColumn("Meta - Length");
			model.addColumn("Meta - Format");
			model.addColumn("Meta - InFormat");
			model.addColumn("Meta - Column Desc");
			model.addColumn("Difference In");
    
			// Get the rows of table from metadata objects
			getColumn(strTableName);

			// fill all the rows in model from lists
			for(int iCol=0; iCol < lstFinalCommon.size(); iCol++)
				model.addRow((Vector)lstFinalCommon.get(iCol));
			for(int iCol=0; iCol < lstFinalXML.size(); iCol++)
				model.addRow((Vector)lstFinalXML.get(iCol));
			
			for(int iCol=0; iCol < lstFinalMETA.size(); iCol++)
				model.addRow((Vector)lstFinalMETA.get(iCol));

			// Create a table object
			//JTable jTable = new JTable(model);
			// Insert new table in panel & create a tab for this panel
			addTabPages(TableDiffTablPan,strTableName,model);
		}

		// Set the window title & layout of main panel
		this.setTitle("Comparison Between New Table(s) with Existing Table(s)");

		// Add a panel at the bottom to show close button & a note
		JPanel ButtonBox = new JPanel();
		JButton butClose = new JButton();
		butClose.setText("Close Window");
		butClose.addActionListener(new cCloseWindow());
		JButton butImpact = new JButton();
		butImpact.setText("Impact Analysis");
		butImpact.addActionListener(new cImpactWindow());
		JButton butRImpact = new JButton();
		butRImpact.setText("Reverse Impact Analysis");
		butRImpact.addActionListener(new cRImpactWindow());
		ButtonBox.add(butClose,BorderLayout.PAGE_START);
		ButtonBox.add(butImpact);
		ButtonBox.add(butRImpact);
		ButtonBox.add(new JLabel("Availability of Column: Yellow Icon - Both, Green Icon -  Media, Blue Icon - Metadata"), BorderLayout.PAGE_START);

		// Add all the panels to frame
		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(new BorderLayout());
		contentPane.add(TableDiffTablPan, BorderLayout.CENTER);
		contentPane.add(ButtonBox, BorderLayout.SOUTH);
	}
  
	// This function creates a panel for given table & creates tab for this panel in tabbed pane
	private void addTabPages(JTabbedPane TableDiffTablPan, String strTabName,DefaultTableModel model1)
	{
		WAPanel pagePanel = new WAPanel();
		///
		DefaultTableModel model2 = model1;
		JTable jt = new JTable(model2);
		jt.setName(strTabName);
		///
		pagePanel.setLayout(new BorderLayout());
		//jTable.setAutoResizeMode(0);
		//jTable.setName("TABLE:"+strTabName);
		//JScrollPane jsp = new JScrollPane(jTable);
		JScrollPane jsp = new JScrollPane(jt);
		jsp.setName(strTabName);
		m_tableModelCollection.put(strTabName,jt);
		/*jsp.add(jTable);*/
		//pagePanel.add(new JScrollPane(jTable));
		pagePanel.add(jsp);
		pagePanel.setName(strTabName);
		TableDiffTablPan.add(strTabName, pagePanel);
	}

	// This function reads data from repository & fills it into vector to display in table
	private void getColumn(String strTableName)
	{
    	//a.b("in getColumn");
		
		// Get the XML fileaname for selected table
		String filePath = m_Path + "\\" + (String)m_hmMetaTablesFile.get(strTableName);

		//a.b("FILEPATH: " +filePath);

		// Creating document builder factory for XML reading
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder;
		Document doc = null;
		try
		{
			//a.b("Creating new document builder");
			// Create a new document to read XML file
			docBuilder = docBuilderFactory.newDocumentBuilder();
			
			//a.b("Parsing XML document");
			doc = docBuilder.parse(new File(filePath));
			 
			//a.b("Get the table,column & library elements" );
			NodeList nlPhysicalTable = doc.getElementsByTagName("PhysicalTable");
			NodeList nlColumn = doc.getElementsByTagName("Column");
			NodeList nlSASLibrary = doc.getElementsByTagName("SASLibrary");
			
			//a.b("Create hash maps");
			m_hmXMLColumnData = new HashMap();
			m_hmMetaColumnData = new HashMap();
			
			//a.b("Get required columns references like $36");
			//List lstRequiredColumns = getRequiredColumns(nlPhysicalTable);
			//a.b("Get column collection by using references like $36");
			//hmXMLColumnData = getColumnCollection(nlColumn,lstRequiredColumns);
			//getColumnCollection(nlColumn,lstRequiredColumns);
			getColumnCollection(nlColumn);
			//a.b("XML COLLECTION done: " + m_hmXMLColumnData.size()	+"  "+	lstXMLColumnName.size());
			//a.b("1");
			
			PhysicalTable pt = (PhysicalTable)m_hmTableMap.get(strTableName);
			//a.b("1.5");
			m_hmMetaColumnData = getTableColumns((CMetadata)pt,strTableName);
			//a.b("META COLLECTION done: " + m_hmXMLColumnData.size()	+"  "+	lstXMLColumnName.size());
			//a.b("2");

			for(int iCommon=0;iCommon<lstcommonColumns.size();iCommon++)
			{
				String temp = (String)lstcommonColumns.get(iCommon);
				Vector singleCol = pushCommonValues(temp,m_hmCommonColumnDataFinal);
				lstFinalCommon.add(singleCol);
			}
			//a.b("for 111111111 complete ");
			for(int iXML=0;iXML < lstXMLColumnName.size();iXML++)
			{
				String temp = (String)lstXMLColumnName.get(iXML);
				Vector singleCol = pushXMLValues(temp,m_hmXMLColumnData);
				lstFinalXML.add(singleCol);
			}
			//a.b("for 222222222 complete ");
			for(int iMeta=0;iMeta < lstMetaColumnName.size();iMeta++)
			{
				String temp = (String)lstMetaColumnName.get(iMeta);
				Vector singleCol = pushMetaValues(temp,m_hmMetaColumnData);
				lstFinalMETA.add(singleCol);
			}
			//a.b(" for 222222222 complete META Columns done");
		}
		catch (SAXParseException err)
		{
			a.errorMessage(err.getMessage(),"SAXParseException");
			err.printStackTrace(System.err);
		}
		catch (SAXException e)
		{
			a.errorMessage(e.getMessage(),"SAXException");
			e.printStackTrace(System.err);
		}
		catch (Throwable t)
		{
			a.errorMessage(t.getMessage(),"Exception");
			t.printStackTrace(System.err);
		}
	}

	private Vector pushCommonValues(String Tablename , HashMap CollectionData)
	{
		Vector v = new Vector();
		HashMap temp2 = (HashMap)CollectionData.get(Tablename);
//		if(temp2 == null)
			//a.b(Tablename);
		
		v.add((ImageIcon)temp2.get("Icon"));
		//v.add("Both");
		v.add((String)temp2.get("ColumnName"));
		v.add((String)temp2.get("XMLColumnType"));
		v.add((String)temp2.get("XMLColumnLength"));
		v.add((String)temp2.get("XMLFormat"));
		v.add((String)temp2.get("XMLInFormat"));
		v.add((String)temp2.get("XMLDesc"));
		v.add((String)temp2.get("MetaColumnType"));
		v.add((String)temp2.get("MetaColumnLength"));
		v.add((String)temp2.get("MetaFormat"));
		v.add((String)temp2.get("MetaInFormat"));
		v.add((String)temp2.get("MetaDesc"));
		v.add((String)temp2.get("Difference"));
		
		return v;
	}
	
	private Vector pushMetaValues(String Tablename , HashMap CollectionData)
	{
		Vector v = new Vector();
		HashMap temp2 = (HashMap)CollectionData.get(Tablename);
		v.add((ImageIcon)temp2.get("Icon"));
		//v.add("Meta");
		v.add((String)temp2.get("ColumnName"));
		v.add(" ");
		v.add(" ");
		v.add(" ");
		v.add(" ");
		v.add(" ");
		v.add((String)temp2.get("ColumnType"));
		v.add((String)temp2.get("ColumnLength"));
		v.add((String)temp2.get("Format"));
		v.add((String)temp2.get("InFormat"));
		v.add((String)temp2.get("Desc"));
		return v;
	}
	
	private Vector pushXMLValues(String Tablename , HashMap CollectionData)
	{
		Vector v = new Vector();
		HashMap temp2 = (HashMap)CollectionData.get(Tablename);
		v.add((ImageIcon)temp2.get("Icon"));
		//v.add("XML");
		v.add((String)temp2.get("ColumnName"));
		v.add((String)temp2.get("ColumnType"));
		v.add((String)temp2.get("ColumnLength"));
		v.add((String)temp2.get("Format"));
		v.add((String)temp2.get("InFormat"));
		v.add((String)temp2.get("Desc"));
		return v;
	}

	// This function returns list of column ids
    private List getRequiredColumns(NodeList nlPhysicalTables)
    {
    	//a.b("in getRequiredColumns");
    	List lstRequiredColumns = new Vector();
    	for(int iColumns=0;iColumns < nlPhysicalTables.getLength();iColumns++)
    	{
    		Node nColumns = nlPhysicalTables.item(iColumns);
    		if(nColumns.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nColumns))
    		{
    			NodeList nlPTChildNode = nColumns.getChildNodes();
    			for(int iCN=0;iCN<nlPTChildNode.getLength();iCN++)
    			{
    				Node nPTCN = nlPTChildNode.item(iCN);
    				//a.b("Node Value : "+nPTCN.getNodeName());
    				if("Columns".equalsIgnoreCase(nPTCN.getNodeName()))
    				{
        				NodeList nlCol = nPTCN.getChildNodes();
        				//a.b("Got Columns TAG : " + nlCol.getLength());
        				for(int j=0; j < nlCol.getLength(); j++)
        				{
        					Node nCol = nlCol.item(j);
        					if(nCol.getNodeType()==Node.ELEMENT_NODE && !checkNodeType(nCol))
        					{
        						NamedNodeMap nnm = nCol.getAttributes();
        						Node nObjRef = nnm.getNamedItem("ObjRef");
        						//a.b("ObjRef Values : " + nObjRef.getNodeValue());
        						lstRequiredColumns.add(nObjRef.getNodeValue());
        					}
        				}
        			}
    			}
    		}
    	}
    	return lstRequiredColumns;
    }
    
    // Function fills the has map with column names vs column objects for given IDs
	private void getColumnCollection(NodeList nlColumn)
	{
    	//a.b("IN getColumnCollection");
		ImageIcon GreenIcon = m_bundle.getImageIcon("green-ball.image");//("green-ball.gif","a pretty but meaningless splat");

		for(int iColumn=0;iColumn<nlColumn.getLength();iColumn++)
		{
			Node nColumn = nlColumn.item(iColumn);
			//a.b("NODE NAME : "+ nColumn.getNodeName());
			if(nColumn.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nColumn))
			{
				//a.b("NODE PERFECT ");
				if(nColumn.hasAttributes())
				{
					NamedNodeMap nnmAttr = nColumn.getAttributes();
					Node nId = nnmAttr.getNamedItem("Id");
						//a.b("NODE IS IN REQUIRED LIST ");
						Node nName = nnmAttr.getNamedItem("Name");
						Node nType = nnmAttr.getNamedItem("SASColumnType");
						Node nLength = nnmAttr.getNamedItem("SASColumnLength");
						Node nFormat = nnmAttr.getNamedItem("SASFormat");
						Node nInFormat = nnmAttr.getNamedItem("SASInformat");
						Node nColDesc = nnmAttr.getNamedItem("Desc");
						String ColumnName = nName.getNodeValue();
						HashMap hmDataMap = new HashMap();
						hmDataMap.put("Icon",GreenIcon);
						//hmDataMap.put("Icon","XML");
						hmDataMap.put("ColumnName",ColumnName);
						hmDataMap.put("ColumnLength",nLength.getNodeValue());
						hmDataMap.put("ColumnType",nType.getNodeValue());
						hmDataMap.put("Format",nFormat.getNodeValue());
						hmDataMap.put("Informat",nInFormat.getNodeValue());
						hmDataMap.put("Desc",nColDesc.getNodeValue());
						//a.b("XML:    "+ColumnName +"  "+ nLength.getNodeValue()+"  "+ nType.getNodeValue());
						m_hmXMLColumnData.put(ColumnName.toLowerCase(),hmDataMap);
						lstXMLColumnName.add(ColumnName.toLowerCase());
				}
			}
    	}	
    //return hmXMLColumnData;
    }

	// Get the table columns from given table
	private HashMap getTableColumns(CMetadata cm,String strTableName)
	{
		//a.b("in metad   getTableColumns ");
		HashMap hmMetaColumnData = new HashMap();
		MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
		CMetadata cmetadata = MdObjectFactory.createComplexMetadataObject(mdobjectstore, cm);
		AssociationList alColList=null;
		AssociationList alLibList=null;
		int j = 0x8018c;

		try {
			cmetadata = MetadataUtil.getMetadataAllDepths(cmetadata, new ArrayList(), new ArrayList(), "<Templates><PhysicalTable><Columns/></PhysicalTable><Column Id=\"\" Name=\"\" /></Templates>", j);
		} catch (MdException e) {
			// TODO Auto-generated catch block
			e.printStackTrace(System.err);
		}
		//a.b("000000000" );
		PhysicalTable pt = (PhysicalTable)cmetadata;
		//a.b("Fully loaded CM casted into Physical Table :" );
		
		try
		{
			alColList = pt.getColumns();
		}
		catch (MdException e2)
		{
			// TODO Auto-generated catch block
			e2.printStackTrace(System.err);
		}
		
		m_hmCommonColumnDataFinal = new HashMap();
		
		
		for(int q=0;q<alColList.size();q++)
		{
			Column cl = (Column)alColList.get(q);
			//a.b("For ww : " + cl.getName());
			
			String colName = cl.getName();
			String strFullColName = strTableName+"#"+colName;
			m_hmColums.put(strFullColName.toLowerCase(),cl);	
			ImageIcon BlueIcon = m_bundle.getImageIcon("blue-ball.image");//,"a pretty but meaningless splat");
	    	ImageIcon YellowIcon = m_bundle.getImageIcon("yellow-ball.image");//,"a pretty but meaningless splat");
	        
			if(lstXMLColumnName.contains(colName.toLowerCase()))
			{
				HashMap hmCommonColumnData = new HashMap();
				//a.b("Got Column in XML Collection so throw into common: ");
				HashMap hmTemp =  (HashMap)m_hmXMLColumnData.get(colName.toLowerCase());
				//a.b("Values :" + (String)hmTemp.get("ColumnName") +"  "+ (String)hmTemp.get("ColumnType") +"  "+ (String)hmTemp.get("ColumnLength"));
				hmCommonColumnData.put("Icon",YellowIcon);
				//hmCommonColumnData.put("Icon","Both");
				hmCommonColumnData.put("ColumnName",cl.getName());
				
				hmCommonColumnData.put("XMLColumnType",(String)hmTemp.get("ColumnType"));
				hmCommonColumnData.put("XMLColumnLength",(String)hmTemp.get("ColumnLength"));
				hmCommonColumnData.put("XMLFormat",(String)hmTemp.get("Format"));
				hmCommonColumnData.put("XMLInformat",(String)hmTemp.get("Informat"));
				hmCommonColumnData.put("XMLDesc",(String)hmTemp.get("Desc"));
				
				m_hmXMLColumnData.remove(cl.getName().toLowerCase());
				lstXMLColumnName.remove(cl.getName().toLowerCase());
				hmCommonColumnData.put("MetaColumnType",""+cl.getSASColumnType());
				hmCommonColumnData.put("MetaColumnLength",""+cl.getSASColumnLength());
				hmCommonColumnData.put("MetaFormat",""+cl.getSASFormat());
				hmCommonColumnData.put("MetaInformat",""+cl.getSASInformat());
				hmCommonColumnData.put("MetaDesc",""+cl.getDesc());
				hmCommonColumnData.put("ColumnId",""+cl.getId());
				StringBuffer sb = new StringBuffer();
				
				if(!cl.getSASColumnType().equalsIgnoreCase((String)hmTemp.get("ColumnType")))
				{
					sb.append(", ");
					sb.append("ColumnType");
					
				}
				String s = cl.getSASColumnLength()+"";
				if(!s.equalsIgnoreCase((String)hmTemp.get("ColumnLength")))
				{
					sb.append(", ");
					sb.append("ColumnLength");
					
				}
				if(!cl.getSASFormat().equalsIgnoreCase((String)hmTemp.get("Format")))
				{
					sb.append(", ");
					sb.append("Format");
				}
				//a.b(cl.getSASInformat()+ "    " +(String)hmTemp.get("Informat"));
				if(!cl.getSASInformat().equalsIgnoreCase((String)hmTemp.get("Informat")))
				{
					sb.append(", ");
					sb.append("InFormat");
				}
				if(!cl.getDesc().equalsIgnoreCase((String)hmTemp.get("Desc")))
				{
					sb.append(", ");
					sb.append("Description");
				}
				if(sb.length()>0){hmCommonColumnData.put("Difference",sb.toString().substring(2));}else{hmCommonColumnData.put("Difference",sb.toString());}
				
				//a.b("BOTH : " + (String)hmTemp.get("ColumnName") + "\n"+(String)hmTemp.get("ColumnType")+"\n"+(String)hmTemp.get("ColumnLength")+"\n"+cl.getSASColumnType()+"\n"+cl.getSASColumnLength());
				m_hmCommonColumnDataFinal.put(cl.getName().toLowerCase(),hmCommonColumnData);
				lstcommonColumns.add(cl.getName().toLowerCase());
			}
			else
			{
				//a.b("FOUND COL IS IN META ONLY");
				HashMap hmMetaColumnMetaInfo = new HashMap();
				hmMetaColumnMetaInfo.put("Icon",BlueIcon);
				//hmMetaColumnMetaInfo.put("Icon","Meta");
				hmMetaColumnMetaInfo.put("ColumnName",cl.getName());
				hmMetaColumnMetaInfo.put("ColumnType",""+cl.getSASColumnType());
				hmMetaColumnMetaInfo.put("ColumnLength",""+cl.getSASColumnLength());
				hmMetaColumnMetaInfo.put("Format",""+cl.getSASFormat());
				hmMetaColumnMetaInfo.put("InFormat",""+cl.getSASInformat());
				hmMetaColumnMetaInfo.put("Desc",""+cl.getDesc());
				hmMetaColumnMetaInfo.put("ColumnId",""+cl.getId());

				hmMetaColumnData.put(cl.getName().toLowerCase(),hmMetaColumnMetaInfo);
				lstMetaColumnName.add(cl.getName().toLowerCase());
			}
		}
		
		alColList.clear();
		return hmMetaColumnData;
	}
    
    private boolean checkNodeType(Node nCheckNode)
    {
		boolean retVal = false;
		//a.b("Node name " + nCheckNode.getNodeValue());
		NodeList n = nCheckNode.getChildNodes();
		//a.b("Node Childes number  " + n.getLength());
		if(n.getLength() > 0)
			retVal = true;
		return retVal;
	}

	protected class cCloseWindow extends WsAbstractAction
	{
		public void actionPerformed(ActionEvent actionevent)
		{
			m_hmTableMap = null;		// Map of table name vs reference to physical table object
			m_hmMetaTablesFile = null;	// Map of tbale name vs XML file name containing the table
			m_hmXMLColumnData= null;
			m_hmMetaColumnData= null;
			m_hmCommonColumnDataFinal= null;
			m_hmColums =  null;
			m_tableModelCollection= null;
			
			hide();
		}
		public cCloseWindow()
		{
			super();
		}
	}

	protected class cImpactWindow extends WsAbstractAction
	{
		public void actionPerformed(ActionEvent actionevent)
		{
			int i = TableDiffTablPan.getSelectedIndex();
			WAPanel jp = (WAPanel)TableDiffTablPan.getComponent(i);
			JScrollPane jsp =  (JScrollPane)jp.getComponent(0);
			String tableName = jsp.getName();
			
			JTable jt = (JTable)m_tableModelCollection.get(tableName);
			int[] p = jt.getSelectedRows();
			DefaultTableModel dtm = (DefaultTableModel)jt.getModel();
			if(p.length != 0){
				//TableImpactAnalysisOMAView tableimpactanalysisomaview1;
				for(int q=0;q<p.length;q++){
					String s = tableName +"#"+(String)dtm.getValueAt(p[q],1);
					if(m_hmColums.containsKey(s.toLowerCase())){
						Column cl = (Column)m_hmColums.get(s.toLowerCase());
						//a.b("Calling show impact");
						cUtilityClass.showColumnImpactAnalysis(true,cl);
					}
				}
			}else{
				a.warning("Please Select a column to get Impact");
			}
		}
		
		public cImpactWindow()
		{
			super();
		}
	}
	
	protected class cRImpactWindow extends WsAbstractAction
	{
		public void actionPerformed(ActionEvent actionevent)
		{
			int i = TableDiffTablPan.getSelectedIndex();
			WAPanel jp = (WAPanel)TableDiffTablPan.getComponent(i);
			JScrollPane jsp =  (JScrollPane)jp.getComponent(0);
			String tableName = jsp.getName();
			
			JTable jt = (JTable)m_tableModelCollection.get(tableName);
			int[] p = jt.getSelectedRows();
			DefaultTableModel dtm = (DefaultTableModel)jt.getModel();
			if(p.length != 0){
				//TableImpactAnalysisOMAView tableimpactanalysisomaview1;
				for(int q=0;q<p.length;q++){
					String s = tableName +"#"+(String)dtm.getValueAt(p[q],1);
					if(m_hmColums.containsKey(s.toLowerCase())){
						Column cl = (Column)m_hmColums.get(s.toLowerCase());
						cUtilityClass.showColumnImpactAnalysis(false,cl);
					}
				}
			}else{
				a.warning("Please Select a column to get Impact");
			}
		}
		
		
		public cRImpactWindow()
		{
			super();
		}
	}
	
	protected void cleanUp()
	{
		contentPane = null;
		m_arrTableNames = null;
		m_Path = null;
		m_hmTableMap = null;
		m_hmMetaTablesFile= null;
		m_hmXMLColumnData= null;
		m_hmMetaColumnData= null;
		m_hmCommonColumnDataFinal= null;
		m_bundle= null;
		lstXMLColumnName = null;
		lstMetaColumnName = null;
		lstcommonColumns = null;
		lstFinalCommon = null;
		lstFinalXML = null;
		lstFinalMETA = null;
	}
}
