/**
 * <p>Title: cUtilityClass</p>
 * <p>Description: Class contains commonly used methods</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */

package com.sas.metadata.imp;

import java.awt.Cursor;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TimeZone;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.sas.metadata.AssociationList;
import com.sas.metadata.CMetadata;
import com.sas.metadata.Column;
import com.sas.metadata.DatabaseSchema;
import com.sas.metadata.MdException;
import com.sas.metadata.MdObjectFactory;
import com.sas.metadata.MdObjectStore;
import com.sas.metadata.MdStoreUtil;
import com.sas.metadata.MetadataUtil;
import com.sas.metadata.MetadataWorkspace;
import com.sas.metadata.PhysicalTable;
import com.sas.metadata.SASLibrary;
import com.sas.wadmin.visuals.ImpactAnalysisOMAView;
import com.sas.workspace.WASplittablePropertyFrame;
import com.sas.workspace.Workspace;
import com.sas.workspace.WsViewFactory;



/**
 * @author sinajs
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class cUtilityClass {

	private static String m_strImpDir;
	private static HashMap hmLibraryStore = new HashMap();

	protected static String getOMRValue(String type){
		MetadataWorkspace metadataworkspace = MetadataWorkspace.getWorkspace();
		Map map = metadataworkspace.getCredentialMap();
		Set set = map.keySet();
		String value = "";
		if (set.size() > 0 && set.contains("Username")
				&& set.contains("Password") && set.contains("Hostname")
				&& set.contains("Port"))
		value = (String) map.get(type);
		return value;
	}

	public static void CopyFolder(String sourceFolder, String destFolder) {
		File srcFolder = new File(sourceFolder);
		File dstFolder = new File(destFolder);
		if (!dstFolder.exists())
			dstFolder.mkdir();
		File[] srcFiles = srcFolder.listFiles();
		for (int nFile = 0; nFile < srcFiles.length; nFile++) {
			String dstFileName = destFolder + "\\" + srcFiles[nFile].getName();
			File dstFile = new File(dstFileName);
			try {
				CopyFile(srcFiles[nFile], dstFile);
			} catch (IOException e) {
				a.error (e.getMessage());
				e.printStackTrace(System.err);
				WriteLog("ERROR: "+e.getMessage());
			}catch(Exception e){
				a.error (e.getMessage());
				e.printStackTrace(System.err);
				WriteLog("ERROR: "+e.getMessage());
			}
		}
	}
	public static void CopyFile(File srcFile, File dstFile) throws IOException {
		FileInputStream in = new FileInputStream(srcFile);
		FileOutputStream out = new FileOutputStream(dstFile);
		int c;
		while ((c = in.read()) != -1)
			out.write(c);
		in.close();
		out.close();
	}



	protected static Document getDocumentObjFromFile(String fileName){
		Document doc = null;
		try{
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
			doc = docBuilder.parse(new File(fileName));
		}catch (SAXParseException err) {
			a.error (err.getMessage());
			err.printStackTrace(System.err);
			WriteLog("Failed: " + err.getMessage());
		}catch (SAXException e) {
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("Failed: " + e.getMessage());
		}catch (Throwable t) {
			a.error (t.getMessage());
			t.printStackTrace(System.err);
			WriteLog("Failed: " + t.getMessage());
		}
		return doc;
	}

	  protected static String resolveName1(String strName){
	  	String newString = new String(strName);
	  	String returnString = "";
	  	StringBuffer sb = new StringBuffer(50);
	   	if(newString.indexOf("&") != -1 ){
	   		for(int i=0;i<newString.length();i++){
	   			if(newString.charAt(i) == '&'){
	   				sb.append("&amp;");
	   			}else{
	   				sb.append(newString.charAt(i));
	   			}
	   		}
	   		returnString = sb.toString();
	   	}else{
	   		returnString = strName;
	   	}

	   	return returnString ;
	   }


		protected static String resolveName(String str) 
		{
			//a.error("CutilityClass: Resoves string "+str);
			
			String saXMLEquivalent[] = {"&sol;","&apos;","&lt;","&gt;","&quot;","&amp;","&colon;","&quest;","&verbar;","&ast;",
										"&Agrave;","&Aacute;","&Acirc;","&Atilde;","&Auml;","&Aring;","&AElig;","&Ccedil;",
										"&Egrave;","&Eacute;","&Ecirc;","&Euml;","&Igrave;","&Iacute;","&Icirc;","&Iuml;",
										"&ETH;","&Ntilde;","&Ograve;","&Oacute;","&Ocirc;","&Otilde;","&Ouml;","&times;","&Oslash;",
										"&Ugrave;","&Uacute;","&Ucirc;","&Uuml;","&Yacute;","&THORN;","&szlig;",
										"&agrave;","&aacute;","&acirc;","&atilde;","&auml;","&aring;","&aelig;","&ccedil;",
										"&egrave;","&eacute;","&ecirc;","&euml;","&igrave;","&iacute;","&icirc;","&iuml;","&eth;",
										"&ntilde;","&ograve;","&oacute;","&ocirc;","&otilde;","&ouml;","&divide;","&oslash;",
										"&ugrave;","&uacute;","&ucirc;","&uuml;","&yacute;","&thorn;","&yuml;"};
			
			String saSpecialChars[] = {"/","\'","<",">","\"","&",":","?","|","*",
										"","","","","","","","",
										"","","","","","","","", 
										"","","","","","","","","", 
										"","","","","","","",
										"","","","","","","","", 
										"","","","","","","","","", 
										"","","","","","","","", 
										"","","","","","",""};

		 
		    String sFind="";
		    String sReplace="";
		    boolean bFound;
		    int iPos = -1;
		    int i = 0;

		    while (i < saXMLEquivalent.length) {
		        String newStr = "";
		            sFind = saXMLEquivalent[i];
		            sReplace = saSpecialChars[i];
		        do {
		            iPos = str.indexOf(sFind, ++iPos);
		            if (iPos > -1) {
		                newStr = newStr + str.substring(0, iPos) + sReplace + str.substring(iPos+sFind.length(),str.length());
		                str = newStr;
		                newStr = "";
		                bFound = true;
		            } else {
		                bFound = false;
		            }
		        } while ( bFound );
		        i++;
		    }
		    return(str);
		}
		
		protected static String  replaceAnd (String str){	
			return str.replaceAll("&amp;", "&");		
		}

		public static String changeReferenceTo (String str){
			
			String saXMLEquivalent[] = {"&#47;","&#39;","&#60;","&#62;","&#34;","&#38;","&#58;","&#63;","&#42;","&#124;",
										"&#192;","&#193;","&#194;","&#195;","&#196;","&#197;","&#198;","&#199;",
										"&#200;","&#201;","&#202;","&#203;","&#204;","&#205;","&#206;","&#207;",
										"&#208;","&#209;","&#210;","&#211;","&#212;","&#213;","&#214;","&#215;","&#216;",
										"&#217;","&#218;","&#219;","&#220;","&#221;","&#222;","&#223;",
										"&#224;","&#225;","&#226;","&#227;","&#228;","&#229;","&#230;","&#231;",
										"&#232;","&#233;","&#234;","&#235;","&#236;","&#237;","&#238;","&#239;","&#240;",
										"&#241;","&#242;","&#243;","&#244;","&#245;","&#246;","&#247;","&#248;",
										"&#249;","&#250;","&#251;","&#252;","&#253;","&#254;","&#255;"};
			
			String saSpecialChars[] = {"/","\'","<",">","\"","&",":","?","*","|",
										"","","","","","","","",
										"","","","","","","","", 
										"","","","","","","","","", 
										"","","","","","","",
										"","","","","","","","", 
										"","","","","","","","","", 
										"","","","","","","","", 
										"","","","","","",""};	
			
			
			String sFind="";
			String sReplace="";
			boolean bFound;
			int iPos = -1;
			int i = 0;
			
			while (i < saXMLEquivalent.length) {
				String newStr = "";
				sFind = saXMLEquivalent[i];
				sReplace = saSpecialChars[i];
				do {
					iPos = str.indexOf(sFind, ++iPos);
					if (iPos > -1) {
						newStr = newStr + str.substring(0, iPos) + sReplace + str.substring(iPos+sFind.length(),str.length());
						str = newStr;
						newStr = "";
						bFound = true;
					} else {
						bFound = false;
					}
				} while ( bFound );
				i++;
			}
			return(str);
			
			
		}
		protected static String MoreResolveTexttoHash(String str) {
		    String saXMLEquivalent[] = {"&sol;","&ast;","&quot;","&amp;","&colon;","&lt;","&gt;","&quest;","&verbar;","&apos;","&szlig;",
		    							"&Agrave;","&Aacute;","&Acirc;","&Atilde;","&Auml;","&Aring;","&AElig;","&Ccedil;",
		    							"&Egrave;","&Eacute;","&Ecirc;","&Euml;","&Igrave;","&Iacute;","&Icirc;","&Iuml;",
		    							"&ETH;","&Ntilde;","&Ograve;","&Oacute;","&Ocirc;","&Otilde;","&Ouml;","&times;","&Oslash;",
		    							"&Ugrave;","&Uacute;","&Ucirc;","&Uuml;","&Yacute;","&THORN;",
		    							"&agrave;","&aacute;","&acirc;","&atilde;","&auml;","&aring;","&aelig;","&ccedil;",
		    							"&egrave;","&eacute;","&ecirc;","&euml;","&igrave;","&iacute;","&icirc;","&iuml;","&eth;",
		    							"&ntilde;","&ograve;","&oacute;","&ocirc;","&otilde;","&ouml;","&divide;","&oslash;",
		    							"&ugrave;","&uacute;","&ucirc;","&uuml;","&yacute;","&thorn;","&yuml;"};
			
		    String saSpecialChars[] = {"&#47;","&#42;","&#34;","&#38;","&#58;","&#60;","&#62;","&#63;","&#124;","&#39;","&#223;",
										"&#192;","&#193;","&#194;","&#195;","&#196;","&#197;","&#198;","&#199;",
										"&#200;","&#201;","&#202;","&#203;","&#204;","&#205;","&#206;","&#207;",
										"&#208;","&#209;","&#210;","&#211;","&#212;","&#213;","&#214;","&#215;","&#216;",
										"&#217;","&#218;","&#219;","&#220;","&#221;","&#222;",
										"&#224;","&#225;","&#226;","&#227;","&#228;","&#229;","&#230;","&#231;",
										"&#232;","&#233;","&#234;","&#235;","&#236;","&#237;","&#238;","&#239;","&#240;",
										"&#241;","&#242;","&#243;","&#244;","&#245;","&#246;","&#247;","&#248;",
										"&#249;","&#250;","&#251;","&#252;","&#253;","&#254;","&#255;"};
		    String sFind="";
		    String sReplace="";
		    boolean bFound;
		    int iPos = -1;
		    int i = 0;

		    while (i < saXMLEquivalent.length) {
		        String newStr = "";
		            sFind = saXMLEquivalent[i];
		            sReplace = saSpecialChars[i];
		        do {
		            iPos = str.indexOf(sFind, ++iPos);
		            if (iPos > -1) {
		                newStr = newStr + str.substring(0, iPos) + sReplace + str.substring(iPos+sFind.length(),str.length());
		                str = newStr;
		                newStr = "";
		                bFound = true;
		            } else {
		                bFound = false;
		            }
		        } while ( bFound );
		        i++;
		    }
		    return(str);
		}
		
		protected static final String UnresolveName(String s){
			   StringBuffer sb = new StringBuffer();
			   int n = s.length();
			   for (int i = 0; i < n; i++) {
			      char c = s.charAt(i);
			      switch (c) {
			         case '<': sb.append("&lt;"); break;
			         case '>': sb.append("&gt;"); break;
			         case '"': sb.append("&quot;"); break;
			         case ':': sb.append("&colon;");break;
			         case '?': sb.append("&quest;");break;
			         case '|': sb.append("&verbar;");break;
			         case '\'': sb.append("&apos;");break;
			         case '/': sb.append("&sol;");break;
			         case '*': sb.append("&ast;");break;
			         //Removed the commented part of the code
			         case '': sb.append("&Agrave;");break;
			         case '': sb.append("&Aacute;");break;
			         case '': sb.append("&Acirc;");break;
			         case '': sb.append("&Atilde;");break;
			         case '': sb.append("&Auml;");break;
			         case '': sb.append("&Aring;");break;
			         case '': sb.append("&AElig;");break;
			         case '': sb.append("&Ccedil;");break;
			         case '': sb.append("&Egrave;");break;
			         case '': sb.append("&Eacute;");break;
			         case '': sb.append("&Ecirc;");break;
			         case '': sb.append("&Euml;");break;
			         case '': sb.append("&Igrave;");break;
			         case '': sb.append("&Iacute;");break;
			         case '': sb.append("&Icirc;");break;
			         case '': sb.append("&Iuml;");break;						
			         case '': sb.append("&ETH;");break;
			         case '': sb.append("&Ntilde;");break;
			         case '': sb.append("&Ograve;");break;
			         case '': sb.append("&Oacute;");break;
			         case '': sb.append("&Ocirc;");break;
			         case '': sb.append("&Otilde;");break;
			         case '': sb.append("&Ouml;");break;
			         case '': sb.append("&times;");break;
			         case '': sb.append("&Oslash;");break;
			         case '': sb.append("&Ugrave;");break;
			         case '': sb.append("&Uacute;");break;
			         case '': sb.append("&Ucirc;");break;
			         case '': sb.append("&Uuml;");break;
			         case '': sb.append("&Yacute;");break;
			         case '': sb.append("&THORN;");break;
			         case '': sb.append("&szlig;");break;
			         case '': sb.append("&agrave;");break;
			         case '': sb.append("&aacute;");break;
			         case '': sb.append("&acirc;");break;
			         case '': sb.append("&atilde;");break;
			         case '': sb.append("&auml;");break;
			         case '': sb.append("&aring;");break;
			         case '': sb.append("&aelig;");break;
			         case '': sb.append("&ccedil;");break;
			         case '': sb.append("&egrave;");break;
			         case '': sb.append("&eacute;");break;
			         case '': sb.append("&ecirc;");break;
			         case '': sb.append("&euml;");break;
			         case '': sb.append("&igrave;");break;
			         case '': sb.append("&iacute;");break;
			         case '': sb.append("&icirc;");break;
			         case '': sb.append("&iuml;");break;						
			         case '': sb.append("&eth;");break;
			         case '': sb.append("&ntilde;");break;
			         case '': sb.append("&ograve;");break;
			         case '': sb.append("&oacute;");break;
			         case '': sb.append("&ocirc;");break;
			         case '': sb.append("&otilde;");break;
			         case '': sb.append("&ouml;");break;
			         case '': sb.append("&divide;");break;
			         case '': sb.append("&oslash;");break;
			         case '': sb.append("&ugrave;");break;
			         case '': sb.append("&uacute;");break;
			         case '': sb.append("&ucirc;");break;
			         case '': sb.append("&uuml;");break;
			         case '': sb.append("&yacute;");break;
			         case '': sb.append("&thorn;");break;
			         case '': sb.append("&yuml;");break;
			         
			         case '': sb.append("&reg;");break;
			         case '': sb.append("&copy;");break;
			         case '': sb.append("&euro;"); break;
			         case '&': sb.append("&amp;"); break;
			         default:  sb.append(c); break;
			      }
			   }
			   return sb.toString();
			}
		
	  
	  protected static List  getObjects(String XMLSelect, String ObjectType, String fullReposid){
	   	List Objects=null;
		try {
			   MdObjectStore myStore =MdObjectFactory.createObjectStore();

			    Objects = MetadataUtil.getMetadataObjectsSubset(
					myStore,fullReposid, ObjectType,
					MetadataUtil.OMI_XMLSELECT
					|MetadataUtil.OMI_GET_METADATA
					|MetadataUtil.OMI_TEMPLATE,
					XMLSelect);			
			// can not dispose store -- returns null job for view existing job- Prachi 
			//myStore.dispose();
		} catch (MdException e) {
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("Failed: " + e.getMessage());
		}catch (Exception e) {
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("Failed: " + e.getMessage());
		}	
		return Objects;
	   }

	  protected static HashMap getLibList(List libList){
		HashMap newLIbList = new HashMap();
		 for(int i=0;i<libList.size();i++){
	    		CMetadata cm = (CMetadata)libList.get(i);
	    		newLIbList.put(cm.getName(),cm);
	    }
	    return newLIbList;
	  }

////	  Method Returs list of existing Table 0 if no table present there in the environment
//		protected static List TableExist(String newlibName,String newTableName,String fullReposid){
//			String XMLSelect = "";
//			List PhysicalTableList = new Vector();
//			MdObjectStore myStore =MdObjectFactory.createObjectStore();
//			
//			String libXMLSelect = "<XMLSelect search=\"SASLibrary[@Name='" + newlibName+ "']\"/>";
//	    	List LibList = getObjects(libXMLSelect, "SASLibrary",fullReposid);
//	     
//	    	HashMap LibList1 = getLibList(LibList);
//	    	
//			if ((newlibName == null) || ("NoLibrary".equalsIgnoreCase(newlibName))) 
//			{
//				XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='" + newTableName
//						+ "']\"/>";
//				PhysicalTableList = getObjects(XMLSelect, "PhysicalTable",fullReposid);
//			}
//			else if(LibList1.containsKey(newlibName))
//			{				
//				CMetadata cmLibrary = (CMetadata)LibList1.get(newlibName);
//				SASLibrary sl;
//				
//				if (hmLibraryStore.containsKey(newlibName) ) 
//				{
//					sl = (SASLibrary) hmLibraryStore.get(newlibName);
//				}
//				else
//				{
//					sl = getSolidLibrary(cmLibrary,myStore);
//					hmLibraryStore.put(newlibName, sl);
//				}
//				String sEngine = sl.getEngine();
//				if("BASE".equalsIgnoreCase(sEngine)||"V7".equalsIgnoreCase(sEngine)||
//						"V701".equalsIgnoreCase(sEngine) ||
//						"V8".equalsIgnoreCase(sEngine) ||
//						"V9".equalsIgnoreCase(sEngine) ||
//						"SPDE".equalsIgnoreCase(sEngine)||
//					"LIST".equalsIgnoreCase(sEngine))
//				{
//					XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='" + newTableName
//					+ "'][TablePackage/SASLibrary[@Name='" + newlibName
//					+ "']]\"/>";
//					
//				}else{
//					try {
//						AssociationList al = sl.getUsingPackages();						
//						DatabaseSchema ds = (DatabaseSchema)al.get(0);						
//						XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='" + newTableName
//						+ "']/TablePackage/DatabaseSchema[@Name='" + ds.getName()+ "']]\"/>";
//					} catch (MdException e) {
//						a.error (e.getMessage());
//						e.printStackTrace(System.err);
//					}
//				}
//				PhysicalTableList = getObjects(XMLSelect, "PhysicalTable",fullReposid);
//				cmLibrary.dispose();
//				sl.dispose();
//			}
//			//myStore.dispose();
//			return PhysicalTableList;
//		}// End of TableExist Class
	 

	  protected static List TableExist(String newlibName,String newTableName,String fullReposid){
			String XMLSelect = "";
			List PhysicalTableList = new Vector();
		
			MdObjectStore myStore =MdObjectFactory.createObjectStore();
			
			String libXMLSelect = "<XMLSelect search=\"SASLibrary[@Name='" + newlibName+ "']\"/>";
	    	List LibList = getObjects(libXMLSelect, "SASLibrary",fullReposid);
	     
	    	HashMap LibList1 = getLibList(LibList);

			if ((newlibName == null) || ("NoLibrary".equalsIgnoreCase(newlibName))) {
				XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='" + newTableName
						+ "']\"/>";
				PhysicalTableList = getObjects(XMLSelect, "PhysicalTable",fullReposid);
			}else if(LibList1.containsKey(newlibName)){
				//a.b("1: ");
				CMetadata cm = (CMetadata)LibList1.get(newlibName);			
				SASLibrary sl = getSolidLibrary(cm,myStore);				
				String sEngine = sl.getEngine();
				if("BASE".equalsIgnoreCase(sEngine)||"V7".equalsIgnoreCase(sEngine)||
						"V701".equalsIgnoreCase(sEngine) ||
						"V8".equalsIgnoreCase(sEngine) ||
						"V9".equalsIgnoreCase(sEngine) ||
						"SPDE".equalsIgnoreCase(sEngine)||
					"LIST".equalsIgnoreCase(sEngine))
				{
					XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='" + newTableName
					+ "']/TablePackage/SASLibrary[@Name='" + newlibName
					+ "']]\"/>";
				}else{
					try {
						AssociationList al = sl.getUsingPackages();
						//a.b("Used BY number: " + al.size());
						DatabaseSchema ds = (DatabaseSchema)al.get(0);
						//a.b("Used BY DS: " + ds.getName());
						XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='" + newTableName
						+ "']/TablePackage/DatabaseSchema[@Name='" + ds.getName()+ "']]\"/>";
					} catch (MdException e) {
						a.error (e.getMessage());
						e.printStackTrace();
					}
				}
				PhysicalTableList = getObjects(XMLSelect, "PhysicalTable",fullReposid);
			}
			myStore.dispose();
			return PhysicalTableList;
		}// End of TableExist Class

		private static SASLibrary getSolidLibrary (CMetadata cm,MdObjectStore myStore){
	    	try {
				 cm = MetadataUtil.getMetadataAllDepths(MdObjectFactory.createObjectStore(),"SASLibrary", cm.getFQID(),
				  new ArrayList(),
				  new ArrayList(),
				  "<Templates><SASLibrary Id=\"\" Name=\"\" Engine=\"\"><UsingPackages/></SASLibrary><DatabaseSchema><UsedByPackages/></DatabaseSchema></Templates>",
				  MetadataUtil.OMI_ALL |
				  MetadataUtil.OMI_SUCCINCT |
				  MetadataUtil.OMI_TEMPLATE |
				  MetadataUtil.OMI_INCLUDE_SUBTYPES |
				  MetadataUtil.OMI_ALL_SIMPLE );
			} catch (MdException e) {
				a.error (e.getMessage());
				e.printStackTrace(System.err);
			}
	    	return (SASLibrary)cm;
	    }

	  protected static List ObjectList(String XMLSelect, String objType, String fullReposid){
		  
    	List objList=null;
		try {
			       objList = MetadataUtil.getMetadataObjectsSubset(
					MdObjectFactory.createObjectStore(),fullReposid, objType,
					MetadataUtil.OMI_ALL | MetadataUtil.OMI_XMLSELECT,
					XMLSelect);
		} catch (MdException e) {
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("Failed: " + e.getMessage());
		} catch(Exception e){
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("ERROR: "+e.getMessage());
		}
		
		return objList ;
    }

	  protected  static String From(String filename) throws IOException {
		   String lineSep = System.getProperty("line.separator");
		   BufferedReader br = new BufferedReader(new FileReader(filename));
		   String nextLine = "";
		   StringBuffer sb = new StringBuffer();
		   while ((nextLine = br.readLine()) != null) {
		     sb.append(nextLine);
		     sb.append(lineSep);
		   }
		   return sb.toString();
		}


	  private static void MakeDirectory() {
		String strUserDir = System.getProperty("user.home");
		m_strImpDir = strUserDir + "\\SASMetadataImport";
		File impdir = new File(m_strImpDir);
		if (!impdir.exists())
			impdir.mkdir();
	}

	public static void WriteLog(String strToWrite) {
		// Make sure directory exists
		MakeDirectory();
		Calendar cal = Calendar.getInstance(TimeZone.getDefault());
		String DATE_FORMAT = "ddMMyy";
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				DATE_FORMAT);
		sdf.setTimeZone(TimeZone.getDefault());
		String strFileName = m_strImpDir + "\\ImportLog_" + sdf.format(cal.getTime())
				+ ".txt";
//		java.text.SimpleDateFormat timeFormat = new java.text.SimpleDateFormat(
//				"hh:mm:ss:SS ");
		
		java.text.SimpleDateFormat timeFormat = new java.text.SimpleDateFormat(
		"hh:mm ");
		strToWrite = timeFormat.format(cal.getTime()) + strToWrite;
		try {
			FileWriter out = new FileWriter(strFileName, true);
			out.write("\n");
			out.write(strToWrite);
			out.flush();
			out.close();
		} catch (IOException e) {
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("ERROR: "+e.getMessage());
		}catch(Exception e){
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("ERROR: "+e.getMessage());
		}
	}

	public static void toWrite(String strToWrite, boolean Exists){
		Calendar cal = Calendar.getInstance(TimeZone.getDefault());
	    String DATE_FORMAT =  "ddMMyy";
	    java.text.SimpleDateFormat sdf =
	          new java.text.SimpleDateFormat(DATE_FORMAT);
	    sdf.setTimeZone(TimeZone.getDefault());
		File nf = new File("C:\\");
		String s ="";
		if(Exists)
			s = "\\Exists_import_log_" + sdf.format(cal.getTime());
		else
			s = "\\NotExist_import_log_" + sdf.format(cal.getTime());
		try {
			FileWriter out = new FileWriter(nf.getAbsolutePath()+s +".txt", true);
			out.write("\n");
			out.write(strToWrite);
			out.flush();
		    out.close();
		} catch (IOException e) {
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("ERROR: "+e.getMessage());
		}catch(Exception e){
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("ERROR: "+e.getMessage());
		}
	}

	public static void LibWrite(String path,String strToWrite){
		Calendar cal = Calendar.getInstance(TimeZone.getDefault());
	    String DATE_FORMAT = "ddMMyyHH";
	    java.text.SimpleDateFormat sdf =
	          new java.text.SimpleDateFormat(DATE_FORMAT);
	    sdf.setTimeZone(TimeZone.getDefault());
		File nf = new File(path);
		File finalpath = nf.getParentFile();
		try {
			FileWriter out = new FileWriter(path+"\\"+sdf.format(cal.getTime())+"LibInfo.txt", true);
			out.write("\n");
			out.write(strToWrite);
			out.flush();
		    out.close();
		} catch (IOException e) {
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("ERROR: "+e.getMessage());
		}catch(Exception e){
			a.error (e.getMessage());
			e.printStackTrace(System.err);
			WriteLog("ERROR: "+e.getMessage());
		}
	}

protected static void showColumnImpactAnalysis(boolean flag, Column column)
    {
	   Workspace.getWorkspace().setCursor(Cursor.getPredefinedCursor(3));
        try
        {
                ImpactAnalysisOMAView impactanalysisomaview = findImpactAnalysisView(column, flag);
                if(impactanalysisomaview != null)
                {
                    WsViewFactory.showExistingView(impactanalysisomaview);
                } else
                {
                    MdObjectFactory mdobjectfactory = Workspace.getWorkspace().getMdObjectFactory();
                    MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
                    Column column1 = (Column)MdObjectFactory.createComplexMetadataObject(mdobjectstore, column);
                    MdStoreUtil.copyObjectAttributes(column, column1);
                    ImpactAnalysisOMAView impactanalysisomaview1 = new ImpactAnalysisOMAView(column1, flag);
                    WsViewFactory.attachViewToFrame(column1, impactanalysisomaview1, new WASplittablePropertyFrame(column1, ""));
                }
        }
        finally
        {
            Workspace.getWorkspace().setCursor(Cursor.getPredefinedCursor(0));
        }
    }

	private static ImpactAnalysisOMAView findImpactAnalysisView(Column column, boolean flag)
    {
	        ArrayList arraylist = column.getViewList();
     
        int i = arraylist.size();
     
        for(int j = 0; j < i; j++)
            if(arraylist.get(j).getClass().equals(ImpactAnalysisOMAView.class))
            {     
            	ImpactAnalysisOMAView impactanalysisomaview = (ImpactAnalysisOMAView)arraylist.get(j);
                if(impactanalysisomaview.isForward() == flag)
                    return impactanalysisomaview;
            }else {
                }

        return null;
    }

	public static void showTableImpactAnalysis2(boolean flag, PhysicalTable physicaltable1)
    {
	    Workspace.getWorkspace().setCursor(Cursor.getPredefinedCursor(3));
        PhysicalTable physicaltable;
        ImpactAnalysisOMAView impactanalysisomaview1;
        try
        {
            MdObjectFactory mdobjectfactory = Workspace.getWorkspace().getMdObjectFactory();
            MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
            physicaltable = (PhysicalTable)MdObjectFactory.createComplexMetadataObject(mdobjectstore, physicaltable1);
            ImpactAnalysisOMAView impactanalysisomaview = findImpactAnalysisView(physicaltable, flag);
            if(impactanalysisomaview != null)
            {
                physicaltable.getObjectStore().dispose();
                WsViewFactory.showExistingView(impactanalysisomaview);
                return;
            }
        }
        finally
        {
            Workspace.getWorkspace().setCursor(Cursor.getPredefinedCursor(0));
        }
        impactanalysisomaview1 = new ImpactAnalysisOMAView(physicaltable, flag);
        WsViewFactory.attachViewToFrame(physicaltable, impactanalysisomaview1, new WASplittablePropertyFrame(physicaltable, ""));
    }

    private static ImpactAnalysisOMAView findImpactAnalysisView(PhysicalTable physicaltable, boolean flag)
    {
        java.util.ArrayList arraylist = physicaltable.getViewList();
        int i = arraylist.size();
        for(int j = 0; j < i; j++)
            if(arraylist.get(j).getClass().equals(com.sas.wadmin.visuals.ImpactAnalysisOMAView.class))
            {
                ImpactAnalysisOMAView impactanalysisomaview = (ImpactAnalysisOMAView)arraylist.get(j);
                if(impactanalysisomaview.isForward() == flag)
                    return impactanalysisomaview;
            }
        return null;
    }

    public static List getOlapSchemas (String reposId){
		List schemaList = ObjectList("", "OlapSchema", reposId);
		if (schemaList == null || schemaList.size() <= 0  ){
			a.errorMessage("No Olap Schema present in the selected repository", "Cube can not be imported");
		}
		
		return schemaList;
	}
}
