/*
 * Created on Nov 9, 2005
 * Ajit Singh
 * Class has functions which returns importable string
 */
package com.sas.metadata.imp;


import java.io.File;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.sas.metadata.AssociationList;
import com.sas.metadata.CMetadata;
import com.sas.metadata.Group;
import com.sas.metadata.MdException;
import com.sas.metadata.MdObjectFactory;
import com.sas.metadata.MdObjectStore;
import com.sas.metadata.MetadataUtil;
import com.sas.metadata.Person;
import com.sas.metadata.PropertyType;
import com.sas.metadata.Transformation;
import com.sas.metadata.Tree;
import com.sas.workspace.OpRequestUI;
import com.sas.workspace.Workspace;


/**
 * @author sinajs
 *
 * Cleans up import string for Information Map and Stored Process
 * 
 */
public class cleanString {
	
	protected static String ReportMapId;
	
	protected static HashMap checkPerson;
	
	/**
	 * @param String,String,String
	 * @return java.lang.String
	 * Preapre Tree Structure to import Information Map, This Function checks presence of 
	 * Tree and condionally it replaces the Name with Tree id or crteates the tree 
	 * with its Parent and other required component 
	 */
	protected static String cleanMapString(String ProcString,String reposid,String type){
		String retString="";
		String baseTree = "";
		if("Map".equalsIgnoreCase(type))
			baseTree="maps";
		else if("Report".equalsIgnoreCase(type))
			baseTree="reports==shared";
		
		int startTag = ProcString.indexOf("<Trees><Tree ObjRef=\"")+"<Trees><Tree ObjRef=\"".length();
		int endTag = ProcString.indexOf("\"/>",startTag );
		String mapTreeName = ProcString.substring(startTag,endTag);
		if(baseTree.equalsIgnoreCase(mapTreeName.toLowerCase())){
			retString = ProcString.substring(0,startTag)+ReportMapId+ProcString.substring(endTag);
		}else{
			HashMap hmTreeMap = cProcessTree.getInfoMapsTree(reposid,type);
			if(hmTreeMap.containsKey(mapTreeName.toLowerCase())){
				Tree mapTree = (Tree)hmTreeMap.get(mapTreeName.toLowerCase());
				retString = ProcString.substring(0,startTag)+mapTree.getId()+ProcString.substring(endTag);
			}else{
				String TempMapTreeName = mapTreeName;
				int iSeparators = TempMapTreeName.indexOf("==");
				StringBuffer sb = new StringBuffer(100);
				int counter = 0;
				while(iSeparators != -1){
					counter++;
					String nextTree = TempMapTreeName.substring(0,iSeparators);
					TempMapTreeName = TempMapTreeName.substring(iSeparators+2);
					if(hmTreeMap.containsKey(TempMapTreeName.toLowerCase())){
						Tree mapTree = (Tree)hmTreeMap.get(TempMapTreeName.toLowerCase());
						sb.append(createTreeScript(nextTree,"$"+nextTree+"=="+TempMapTreeName,mapTree.getId(),type,counter));
						break;
					}else{
						sb.append(createTreeScript(nextTree,"$"+nextTree+"=="+TempMapTreeName,"$"+TempMapTreeName,type,counter));
					}
					iSeparators = TempMapTreeName.indexOf("==");
				}//end of while
				
				retString = ProcString.substring(0,startTag)+"$"+mapTreeName+ProcString.substring(endTag);
				int nMetaStartTag = retString.indexOf("</Metadata>");
				retString = retString.substring(0,nMetaStartTag)+sb.toString()+retString.substring(nMetaStartTag);
			}
		}// End of Top Else
		
		return retString;
	}
	

	/*protected static String replaceMapNameWithId(String ProcString, String reposid,String call){
		String StrFullMapName ="";
		String retVal = "";
		if("import".equalsIgnoreCase(call)){
			StrFullMapName = getMidString(ProcString,"Foundation/Transformation;id=","&lt;","bluff");	
		}else if("check".equalsIgnoreCase(call)){
			StrFullMapName =ProcString;	
		}
		
		int iLast = StrFullMapName.lastIndexOf("==");
		String TreeName = StrFullMapName.substring(0,iLast);
		String StrMapName = StrFullMapName.substring(iLast+2);
		HashMap hmTreeMap = cProcessTree.getInfoMapsTree(reposid,"Map");
		if(hmTreeMap.containsKey(TreeName.toLowerCase())){
			Tree tr = (Tree)hmTreeMap.get(TreeName.toLowerCase());
			try {
				AssociationList alMem = tr.getAssociatedObjects("Members");
				for(int t=0;t<alMem.size();t++){
					Transformation trans = (Transformation)alMem.get(t);
					if(StrMapName.equalsIgnoreCase(trans.getName())){
						if("import".equalsIgnoreCase(call)){
							int one = ProcString.indexOf(StrFullMapName);
							retVal = ProcString.substring(0,one)+trans.getId()+ProcString.substring(one+StrFullMapName.length());
							break;
						}
					}else{
						retVal = "false";
					}
				}
			} catch (MdException e) {
				a.error("Importing Report: " + e.getMessage());
				e.printStackTrace();
			} catch (Exception e) {
				a.error(e.getMessage());
				e.printStackTrace();
			}
		}else {
			retVal = "false";
		}
	return retVal;
	}*/

	/**
	 * @param String,String,String,String,int
	 * @return java.lang.String
	 * Prepare Tree Script For Information Map and Stored Proc
	 */
	private static String createTreeScript(String Name,String Id, String ParentId,String type, int counter){
		String retVal = "";
		if("Map".equalsIgnoreCase(type)){
			retVal = "<Tree Name=\""+Name.toUpperCase()+"\" TreeType=\"BIP Folder\" Id=\""+Id+"\" ><ParentTree><Tree ObjRef=\""+ParentId+"\" /></ParentTree></Tree>" ;
		}else if("Report".equalsIgnoreCase(type)){
			retVal = "<Tree Name=\""+Name+"\" Id=\""+Id+"\" TreeType=\"BIP Folder\" ><ParentTree><Tree ObjRef=\""+ParentId+"\" /></ParentTree>" +
						"<Timestamps>" +
						"<Timestamp ObjRef=\"$Creation Date"+counter+"\"/>" +
						"<Timestamp ObjRef=\"$Modified Date"+counter+"\"/></Timestamps>" +
						"</Tree>" + 
						"<Timestamp Id=\"$Creation Date"+counter+"\" Name=\"Creation Date\" TimestampRole=\"Creation Date\">" +
						"<Objects><Tree ObjRef=\""+Id+"\" /></Objects></Timestamp>" +
						"<Timestamp Id=\"$Modified Date"+counter+"\" Name=\"Modified Date\" TimestampRole=\"Modified Date\">" +
						"<Objects><Tree ObjRef =\""+Id+"\"/></Objects></Timestamp>";

		}
		return retVal;
	}// end of createTreeScript
	
	/**
	 * @param String,String
	 * @return boolean
	 * Get Tree structure of Report and Information Map from Metadata server  
	 */
	protected static boolean getMapTreeID(String reposid,String type){
		MdObjectStore myStore = MdObjectFactory.createObjectStore();
		String XMLSelect = ""; 
			if("Map".equalsIgnoreCase(type))
				XMLSelect = "<XMLSelect Search=\"Tree[@Name='Maps'][ParentTree/Tree[@Name='ReportStudio']]\"/>";
			else
				XMLSelect = "<XMLSelect search=\"Tree[@Name='Reports']\"/>";
			
		List Objects = null;
		Tree cm =null;
		boolean retFlag = false;
		try {
			Objects = (MetadataUtil.getMetadataObjectsSubset(myStore, reposid,
					"Tree", MetadataUtil.OMI_TEMPLATE |MetadataUtil.OMI_XMLSELECT
							| MetadataUtil.OMI_GET_METADATA, XMLSelect));
			if(Objects.size()>0){
				for(int j=0;j<Objects.size();j++){
					cm = (Tree)Objects.get(j);
					if(verifyParentTree(cm,type)){
						ReportMapId = cm.getId();
						retFlag = true;
						break;
					}
				}
			}
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		}
		
		return retFlag;
	}
	
	/**
	 * @param Com.sas.Tree,String
	 * @return boolean
	 * Check for the parent tree as "ReportStudio", "Shared", "Map", "Report"   
	 */
	private static boolean verifyParentTree(Tree cm,String type){
		boolean Varflag=false;
		Tree tr2 = null;
		try{
			tr2 = cm.getParentTree();
			
			if("ReportStudio".equalsIgnoreCase(tr2.getName()) && "Map".equalsIgnoreCase(type))
				Varflag = true;
			else if("Shared".equalsIgnoreCase(tr2.getName()) && "Report".equalsIgnoreCase(type))
				Varflag = true;
			
		}catch(MdException e){
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		}
		return Varflag;
	}	
	
	/**
	 * @param String, String
	 * @return String
	 * Preapre Tree Structure to import Stored Process, This Function checks presence of 
	 * Tree and conditionally it replaces the Name with Tree id or crteates the tree 
	 * with its Parent and other required component   
	 */
	protected static String cleanProcessString(String ProcString,String reposid){

		int startTag = ProcString.indexOf("<Trees><Tree ObjRef=\"")+"<Trees><Tree ObjRef=\"".length();
		int endTag = ProcString.indexOf("\"/>",startTag );
		String processTreeName = ProcString.substring(startTag,endTag);
		String componentId = getComponentId(reposid);
		HashMap hmProcessTreeMap = getProcessTreeMap(reposid);
		if(hmProcessTreeMap.containsKey(processTreeName.toLowerCase())){
			Tree tr = (Tree)hmProcessTreeMap.get(processTreeName.toLowerCase());
			ProcString = ProcString.substring(0,startTag)+tr.getId()+ProcString.substring(endTag);
		}else{
			String TempMapTreeName = processTreeName;
			int iSeparators = TempMapTreeName.indexOf("==");
			StringBuffer sb = new StringBuffer(100);
			if(iSeparators == -1){
			 sb.append("<Tree Name=\""+TempMapTreeName+"\" TreeType=\"BIP Folder\" Id=\"$"+TempMapTreeName+"\" ><SoftwareComponents><SoftwareComponent ObjRef=\""+componentId+"\"/></SoftwareComponents></Tree>");
			}
			while(iSeparators != -1){
				String nextTree = TempMapTreeName.substring(0,iSeparators);
				TempMapTreeName = TempMapTreeName.substring(iSeparators+2);
				if(hmProcessTreeMap.containsKey(TempMapTreeName.toLowerCase())){
					Tree mapTree = (Tree)hmProcessTreeMap.get(TempMapTreeName.toLowerCase());
					sb.append(createProcessTreeScript(nextTree,"$"+nextTree+"=="+TempMapTreeName,mapTree.getId()));
					break;
				}else{
					sb.append(createProcessTreeScript(nextTree,"$"+nextTree+"=="+TempMapTreeName,"$"+TempMapTreeName));
				}
				iSeparators = TempMapTreeName.indexOf("==");
				if(iSeparators == -1){
				 sb.append("<Tree Name=\""+TempMapTreeName+"\" TreeType=\"BIP Folder\" Id=\"$"+TempMapTreeName+"\" ><SoftwareComponents><SoftwareComponent ObjRef=\""+componentId+"\"/></SoftwareComponents></Tree>");
				}
			}//end of while
			ProcString = ProcString.substring(0,startTag)+"$"+processTreeName+ProcString.substring(endTag);
			int nMetaStartTag = ProcString.indexOf("</Metadata>");
			ProcString = ProcString.substring(0,nMetaStartTag)+sb.toString()+ProcString.substring(nMetaStartTag);
		}
		return ProcString;
	}
	

	private static String createProcessTreeScript(String Name,String Id, String ParentId){
		return "<Tree Name=\""+Name+"\" TreeType=\"BIP Folder\" Id=\""+Id+"\" ><ParentTree><Tree ObjRef=\""+ParentId+"\" /></ParentTree></Tree>";
	}// end of createTreeScript
	 
	/**
	 * @param String
	 * @return String
	 * Returns Id of SoftwareComponent from Metadata server   
	 */
	private static String getComponentId(String reposid){
		String retVal = "";
		String XMLSelect = "<XMLSelect search=\"SoftwareComponent[@Name='BIP Service']\"/>";
		List objs = cProcessTree.getTreeInfoObjects("SoftwareComponent", reposid,XMLSelect);
		if(objs.size()>0){
			CMetadata cm = (CMetadata)objs.get(0);
			retVal = cm.getId();
		}else{
		a.error("SoftwareComponent BIP Service is not defined in the Environment");	
		}
		
		return retVal;
	}
	
	
	/**
	 * @param String, String,OpRequestUI ,String 
	 * @return String
	 * Cleans up Directory Tag of Stored Process. This function checks 
	 * whether the directory is present in the Metadata server or not, If
	 * It is present then it cleans up the required code from XML String, If 
	 * the Directory is not present in the environment then it replaces Server 
	 * context only
	 */
	public static String cleanProcessDirectory(String filePath,String reposid,OpRequestUI oprequestui,String contextFQ){
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder;
		Document doc = null;
		oprequestui.setMessage("Parsing xml file...");
		List lstNodeDel2= new Vector();
		String retString = "";
		try{
			docBuilder = docBuilderFactory.newDocumentBuilder();
			doc = docBuilder.parse(new File(filePath));
			oprequestui.setMessage("Collecting info from file...");
			retString = getStringFromDocument(doc);
			NodeList nlDirectory = doc.getElementsByTagName("Directory");
			NodeList nlProperty = doc.getElementsByTagName("Property");
			NodeList nlPropertyType = doc.getElementsByTagName("PropertyType");
			
			String Dirid = "Hello";
			String sPropertyId = ""; 
			String sPropertyTypeId= "";
			Node nDir = null;
			for(int iDir=0;iDir<nlDirectory.getLength();iDir++){
				nDir = nlDirectory.item(iDir);
				if(nDir.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nDir)){
					if(nDir.hasAttributes()){
						NamedNodeMap nnmAttr = nDir.getAttributes();
						Node nName = nnmAttr.getNamedItem("DirectoryName");
						Node nId = nnmAttr.getNamedItem("Id");
						String sDirId = nId.getNodeValue().toLowerCase();
						String sDirName = nName.getNodeValue().toLowerCase();
						Dirid = getDirId(sDirName,reposid);
						break;
					}
				}
			}// End of for of nlDirectory
			
			if(!"Hello".equalsIgnoreCase(Dirid)){
				lstNodeDel2.add(nDir);
				NodeList nlDirChild = nDir.getChildNodes();
				for(int iDirChi=0;iDirChi<nlDirChild.getLength();iDirChi++){
					Node nDirChi = nlDirChild.item(iDirChi);
					if(nDir.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nDir)){
						if("Properties".equalsIgnoreCase(nDirChi.getNodeName())){
							NodeList nlChiChiNode = nDirChi.getChildNodes();
							for(int x=0;x<nlChiChiNode.getLength();x++){
								Node nProperty = nlChiChiNode.item(x);
									if(nProperty.getNodeType()==Node.ELEMENT_NODE && !checkNodeType(nProperty)){
										NamedNodeMap nnmProperty = nProperty.getAttributes();
										Node nPropertyObjRef = nnmProperty.getNamedItem("ObjRef");
										sPropertyId = nPropertyObjRef.getNodeValue().toLowerCase();
										break;
								}
							}
						}	
					}
				}// End of Property node browse
				
				// collect PropertyType Id
				for(int iProp=0;iProp<nlProperty.getLength();iProp++){
					Node nPT = nlProperty.item(iProp);
					if(nPT.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nPT)){
						NamedNodeMap nnmProperty2 = nPT.getAttributes();
						Node nPropertyId = nnmProperty2.getNamedItem("Id");
						if(sPropertyId.equalsIgnoreCase(nPropertyId.getNodeValue())){
							lstNodeDel2.add(nPT);
							NodeList nlType = nPT.getChildNodes();
							for(int iType=0;iType<nlType.getLength();iType++){
								Node nTypeChi = nlType.item(iType);
								if(nTypeChi.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nTypeChi)){
									if("OwningType".equalsIgnoreCase(nTypeChi.getNodeName())){
										NodeList nlTypeChiNode = nTypeChi.getChildNodes();
										for(int t=0;t<nlTypeChiNode.getLength();t++){
											Node nPropertyType = nlTypeChiNode.item(t);
											if(nPropertyType.getNodeType()==Node.ELEMENT_NODE && !checkNodeType(nPropertyType)){
											if("PropertyType".equalsIgnoreCase(nPropertyType.getNodeName())){
												NamedNodeMap nnmPropertyType = nPropertyType.getAttributes();
												nPropertyType = nnmPropertyType.getNamedItem("ObjRef");
												sPropertyTypeId = nPropertyType.getNodeValue().toLowerCase();
												iProp = nlProperty.getLength();
												iType=nlType.getLength(); 
												break;
											}
											}
										}
									
									}
								}
							}
						}
					}
				}// End of PropertyType Id

				//Collect PropertyType Node in Delete List 
				for(int q=0;q<nlPropertyType.getLength();q++){
					Node nPropertyType2 = nlPropertyType.item(q);
					if(nPropertyType2.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nPropertyType2)){
						NamedNodeMap nnmtypes = nPropertyType2.getAttributes();
						Node nTypeId = nnmtypes.getNamedItem("Id");
						if(sPropertyTypeId.equalsIgnoreCase(nTypeId.getNodeValue())){
							lstNodeDel2.add(nPropertyType2);
						}
					}
				}// Object Property Type Collected
				
				removeNodes(lstNodeDel2);
				lstNodeDel2.clear();
				//	Replace Directory ObjRef
				
				retString = getStringFromDocument(doc);
				
				 int treeTag = retString.indexOf("<Directory ObjRef=\"$");
					if(treeTag != -1){
						while(treeTag != -1){
							retString = ReplaceDir(retString,Dirid);
							treeTag = retString.indexOf("<Directory ObjRef=\"$");
						}
					}
				
			}else{
				int startTag2 = retString.indexOf("<ServerContext ObjRef=\"$") + "<ServerContext ObjRef=\"$".length() ;
				int endTag2 = retString.indexOf("\"/>",startTag2 );
				retString = retString.substring(0,startTag2-1)+contextFQ +retString.substring(endTag2);
			}
			
			int startTag3 = retString.indexOf("<Reposid>") + "<Reposid>".length() ;
			int endTag3 = retString.indexOf("</",startTag3 );
			retString = retString.substring(0,startTag3)+reposid +retString.substring(endTag3);
		}catch (SAXParseException err) {
			a.error(err.toString());
			err.printStackTrace(System.err);
		}catch (SAXException e) {
			a.error(e.toString());
			e.printStackTrace(System.err);
		}catch (Throwable t) {
			a.error (t.toString());
			t.printStackTrace(System.err);
		}		
		doc.normalize();
		
		return retString;
	}
	
	
	/**
	 * @param String, String
	 * @return String
	 * IF Directory is present in the environment, 
	 * This code returns its Metadata Id 
	 */
	private static String getDirId(String directoryName, String reposid){
		
		String XMLSelect = "<XMLSelect search=\"Directory[@DirectoryName='"+directoryName+"']\"/>";
		List objs2 = cProcessTree.getTreeInfoObjects("Directory", reposid,XMLSelect);
		String retVal = "Hello";
		if(objs2.size()>0){
			CMetadata cm = (CMetadata)objs2.get(0);
			retVal = cm.getId();
		}
		return retVal;
	}
	
	
	/**
	 * @param String, String,String, String
	 * @return String
	 * Replaces LogicalServer from the XML String
	 * of Stored Proc 
	 */
	protected static String cleanOtherThings(String ProcString,String reposid, String strContextName,String Name){
		String logicalServerName = getMidString(ProcString,"<ComputeLocations><LogicalServer ObjRef=\"","\"/>",Name);
		String Temp = logicalServerName.substring(logicalServerName.indexOf("-")+1);
		logicalServerName = strContextName + " - "+Temp.trim();
		String XMLSelect = "<XMLSelect search=\"LogicalServer[@Name='"+logicalServerName+"']\"/>";
		
		List objs = cProcessTree.getTreeInfoObjects("LogicalServer", reposid,XMLSelect);
		if(objs.size()>0){
			CMetadata cm = (CMetadata)objs.get(0);
			ProcString = getReplacedString(ProcString,logicalServerName,cm.getId());
		}else{
			a.error(logicalServerName + " Not Defined for Stored Process ");
		return null;
		}
	return ProcString;
	}
		
	
	/*protected static String getGenericStringId(String ProcString,String reposid, String contextFQ){
			
		int zeroTag = ProcString.indexOf("<PropertyType SQLType=\"")+"<PropertyType SQLType=\"".length();
		int begin = ProcString.indexOf("Name=\"",zeroTag)+"Name=\"".length();
		
		int end = ProcString.indexOf("\" ",begin);
		String PropertyTypeName = ProcString.substring(begin,end);
		String XMLSelect = "<XMLSelect search=\"PropertyType[@Name='"+PropertyTypeName+"']\"/>";
		List objs3 = cProcessTree.getTreeInfoObjects("PropertyType", reposid,XMLSelect);
		String PropertyTypeId = "";
		if(objs3.size()>0){
			for(int t=0;t<objs3.size();t++){
				PropertyType myType = (PropertyType)MdObjectFactory.createComplexMetadataObject(MdObjectFactory.createObjectStore(),(PropertyType)objs3.get(t));
					try {
						myType = (PropertyType)MetadataUtil.getMetadataAllDepths(myType,
								new ArrayList(),
								new ArrayList(),
								"<Templates><PropertyType><Groups/></PropertyType><Group/></Templates>",
								MetadataUtil.OMI_ALL_SIMPLE|MetadataUtil.OMI_SUCCINCT|MetadataUtil.OMI_TEMPLATE);
						AssociationList alGrps = myType.getGroups();
						if(alGrps.size() > 0 ){
							Group grp = (Group)alGrps.get(0);
							if("Entity Property Types".equalsIgnoreCase(grp.getName())){
								PropertyTypeId = myType.getId();
								break;
							}
						}
					} catch (MdException e) {
						a.errorMessage("Error in export of InfoMaps", e.getMessage());
						cUtilityClass.WriteLog("ERROR: in export of InfoMaps" + e.getMessage());
					}catch (Exception e) {
						a.errorMessage("Error in export of InfoMaps", e.getMessage());
						cUtilityClass.WriteLog("ERROR: in export of InfoMaps" + e.getMessage());
					}
			}
		}// end of if 
		
		return PropertyTypeId;
	}
*/
	/**
	 * @param String, String
	 * @return String
	 * Replaces Directory Tag from XML String
	 * of Stored Proc 
	 */
	private static String ReplaceDir(String ProcString, String Id){
		
		int startTag = ProcString.indexOf("<Directory ObjRef=\"$")+"<Directory ObjRef=\"$".length();
		int endTag = ProcString.indexOf("\"/>",startTag );
		ProcString=ProcString.substring(0,startTag-1)+Id+ProcString.substring(endTag);
		int i = ProcString.indexOf("<Directory DirectoryName=\"");
		if(i != -1)
		ProcString = getDeletedString(ProcString, "<Directory DirectoryName=\"", "</Directory>");
		
		return ProcString;
	} 
	
	
/*	private static String ReplaceGenericString(String ProcString, String Id,String GSId){
		
		int startTag = ProcString.indexOf("<PropertyType ObjRef=\""+GSId)+"<PropertyType ObjRef=\"".length()+GSId.length();
		int endTag = ProcString.indexOf("\"/>",startTag-1 );
		String SearchId= ProcString.substring(startTag-GSId.length(), endTag);
		if(startTag != -1){
			while(startTag != -1){
				if(GSId.equalsIgnoreCase(SearchId)){
					ProcString=ProcString.substring(0,startTag-GSId.length())+Id+ProcString.substring(endTag);	
				}		
				startTag = ProcString.indexOf("<PropertyType ObjRef=\"$"+GSId);
			}
		}
		return ProcString;
	}
*/	
	
/*	private static String deleteGenericString(String ProcString, String Id,String GSId){
		
		int ZeroTag = ProcString.indexOf("<PropertyType SQLType=\"12\" Desc=\"");
		
		if(ZeroTag!= -1){
			while(ZeroTag != -1){
				int StartTag = ProcString.indexOf("Id=\"",ZeroTag)+"Id=\"".length();
				int EndTag = ProcString.indexOf(">",StartTag);
				int LastTag = ProcString.indexOf("</PropertyType>")+"</PropertyType>".length();
				String id = ProcString.substring(StartTag,EndTag-1);
				if(GSId.equalsIgnoreCase(id)){
					ProcString = ProcString.substring(0,ZeroTag)+ProcString.substring(LastTag);
					break;
				}		
				ZeroTag = ProcString.indexOf("<PropertyType SQLType=\"12\" Desc=\"");
			}
		}
		return ProcString;
	}
*/	
	/**
	 * @param String, String, String
	 * @return String
	 * Return Middle part of the string identified by supplied parameters
	 */
	private static String getReplacedString(String procString, String oldString, String NewString){
		int startTag = procString.indexOf(oldString);
		int endTag = procString.indexOf("\"/>",startTag );
		if(startTag==-1)
		{
			cUtilityClass.WriteLog("Please check ServerContext Name and logicalServerName");
		    a.error("Check the logicalServerName");
		}
		return procString.substring(0,startTag)+NewString+procString.substring(endTag);
	}
	
	/**
	 * @param String, String, String
	 * @return String
	 * Delete Portion of String identified by supplied parameters 
	 */
	private static String getDeletedString(String procString, String delBegin, String delEnd){
		int DelstartTag = procString.indexOf(delBegin);
		int DelendTag = procString.indexOf(delEnd,DelstartTag )+delEnd.length(); 
		return procString.substring(0,DelstartTag)+procString.substring(DelendTag);
	}
	
	
	/**
	 * @param String, String, String
	 * @return String
	 * Returns Portion of String identified by supplied parameters 
	 */
	private static String getMidString(String main, String start, String end,String Name){
		int startTag = main.indexOf(start)+start.length();
		String s = "";
		if(startTag != -1){
			int endTag = main.indexOf(end,startTag);
			s = main.substring(startTag,endTag);
		}else{
			a.error("Problem in " + Name + " Stored Process Definition ");	
		}
		
		return s;
	}
	
	
	/*protected static String cleanParties(String filePath, String reposid){
		
		checkPerson = new HashMap(); 
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder;
		Document doc = null;
		try{
		docBuilder = docBuilderFactory.newDocumentBuilder();
		doc = docBuilder.parse(new File(filePath));

		NodeList nlPerson = doc.getElementsByTagName("Person");
		NodeList nlTransformation = doc.getElementsByTagName("Transformation");
		NodeList nlRespParty = doc.getElementsByTagName("ResponsibleParty");
		
		String PersonName = getObjectsName(nlPerson);
		String TransformName = getObjectsName(nlTransformation);
		String PartyName = getObjectsName(nlRespParty);

		List toDelete = new Vector();
		String partyString = checkForParty(PartyName,PersonName, reposid);
		
		if(!"".equalsIgnoreCase(partyString)){
			changeTheNode(nlRespParty,partyString, toDelete);
			for(int i=0;i< nlPerson.getLength();i++)   {
			Node perNode  = (Node)nlPerson.item(i);
				if(perNode.getNodeType()==Node.ELEMENT_NODE && checkNodeType(perNode)){
					toDelete.add(perNode);
				}				
			}
		}else{
			String personId = checkForPerson(PersonName, reposid);
			if(!"".equalsIgnoreCase(personId)){
				changeTheNode(nlPerson,personId,toDelete);
			}else{
				a.error("Person " + PersonName + " does not exist in environment ");
			}
		}
		
		removeNodes(toDelete);
		
	}catch (SAXParseException err) {
		a.error(err.getMessage());
		err.printStackTrace ();
	}catch (SAXException e) {
		a.error(e.getMessage());
		e.printStackTrace ();
	}catch (Throwable t) {
		a.error(t.getMessage());
		t.printStackTrace ();
	}
		doc.normalize();
		return getStringFromDocument(doc);
 }
*/
	
	/**
	 * @param java.util.List
	 * Removes node from DOM Objects   
	 */
	private static void removeNodes(List lstNodeDel){
		if(lstNodeDel.size()>0){
			for(int idel=0;idel<lstNodeDel.size();idel++){
				Node n = (Node)lstNodeDel.get(idel);
				//NodeList slChi = n.getChildNodes();
				if(n!= null && n.getParentNode() != null){
					n.getParentNode().removeChild(n);
				}
			  }
		   }	
		}
	
/*	private static void changeTheNode(NodeList nlToChange, String toReplace, List toDelete){
		for(int y=0;y<nlToChange.getLength();y++){
			Node perNode  = (Node)nlToChange.item(y);
			if(perNode.getNodeType()==Node.ELEMENT_NODE && checkNodeType(perNode)){
				if(perNode!= null && perNode.getParentNode() != null){
					toDelete.add(perNode);
				}
			}else if(perNode.getNodeType()==Node.ELEMENT_NODE && !checkNodeType(perNode)){
				NamedNodeMap nnmPer = perNode.getAttributes();
				Node nObjRefPer = nnmPer.getNamedItem("ObjRef");
				nObjRefPer.setNodeValue(toReplace);
			}
		}	
	}*/
	
	/*private static String checkForParty(String partyRole, String Person, String reposid){
	String partyId = "";
	List Objs = getObjects("<XMLSelect search=\"ResponsibleParty[@Name='Author' and @Role='Owner']\"/><Templates><ResponsibleParty><Persons/></ResponsibleParty><Person/></Templates>","ResponsibleParty",reposid);
	if(Objs.size()>0){
		for(int i=0;i<Objs.size();i++){
			CMetadata cm  = (CMetadata)Objs.get(i);
			try {
				AssociationList alPersons = cm.getAssociatedObjects("Persons");
				if(alPersons.size() > 0){
				Person per=(Person)alPersons.get(0);
				if(Person.equalsIgnoreCase(per.getName())){
					partyId = cm.getId();
					break;
				}
			}
								
			} catch (MdException e) {
				a.error("Error In importing Report");
				e.printStackTrace();
			}
		}
	}
	return partyId;
	}*/
	
	/**
	 * @param String, String, String
	 * @return java.util.List 
	 * Return Collection of metadata object of supplied type   
	 */
//	protected static List  getObjects(String XMLSelect, String ObjectType, String fullReposid){
//	   	List Objects=null;
//		try {
//			Objects = MetadataUtil.getMetadataObjectsSubset(
//					MdObjectFactory.createObjectStore(),fullReposid, ObjectType,
//					MetadataUtil.OMI_XMLSELECT
//					|MetadataUtil.OMI_GET_METADATA
//					|MetadataUtil.OMI_TEMPLATE,
//					XMLSelect);
//		} catch (MdException e) {
//			a.error(e.getMessage());
//			e.printStackTrace(System.err);
//			cUtilityClass.WriteLog("Failed: " + e.getMessage());
//		}catch (Exception e) {
//			a.error(e.getMessage());
//			e.printStackTrace(System.err);
//			cUtilityClass.WriteLog("Failed: " + e.getMessage());
//		}
//		return Objects;
//	  	
//	   }
	/*private static String checkForPerson(String Person, String reposid){
		String PersonId = "";
		List Objs = getObjects("<XMLSelect search=\"Person[@Name='"+Person+"']\"/>","Person",reposid);
		if(Objs.size()>0){
			for(int i=0;i<Objs.size();i++){
				CMetadata cm  = (CMetadata)Objs.get(i);
				PersonId = cm.getId();
			}
		}
		return PersonId;
		}*/
	
	/*private static String getObjectsName(NodeList nlList){
		Node nPersonName =null;
		String retVal = "";
		for(int iPerson=0;iPerson<nlList.getLength();iPerson++){
			Node nList = (Node)nlList.item(iPerson);
			if(nList.getNodeType()==Node.ELEMENT_NODE && checkNodeType(nList)){
				NamedNodeMap nnmPerson = nList.getAttributes();
				nPersonName = nnmPerson.getNamedItem("Name");
				retVal =nPersonName.getNodeValue(); 
			}
		}
		return retVal;
	}*/	
	
	/**
	 * @param String
	 * @return java.util.hashMap
	 * Return Collection of Tree of where Stored process are kept   
	 */	
	private static HashMap getProcessTreeMap(String reposid){
		HashMap hmNewMap = new HashMap();
		String XMLSelect = "<XMLSelect search=\"Tree[@TreeType='BIP Folder']\"/>";
		List objs = cProcessTree.getTreeInfoObjects("Tree", reposid,XMLSelect);
		Tree tr;
		for (int l = 0; l < objs.size(); l++) {
			tr = (Tree) objs.get(l);
			String s1 = cProcessTree.processMapTree(tr,"itsTheEnd");
			hmNewMap.put(s1.toLowerCase(),tr);
		}		
	return hmNewMap;
	}
	
	/**
	 * @param Document
	 * @return java.lang.String
	 * Return String from Document(DOM) Object   
	 */
	public static String getStringFromDocument(Document doc)
	{
	    try
	    {

	       DOMSource domSource = new DOMSource(doc);
	       StringWriter writer = new StringWriter();
	       StreamResult result = new StreamResult(writer);
	       TransformerFactory tf = TransformerFactory.newInstance();
	       Transformer transformer = tf.newTransformer();
	       transformer.transform(domSource, result);
	       return writer.toString();
	    }
	    catch(TransformerException ex)
	    {
	    	a.error(ex.getMessage());
			ex.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: "+ex.getMessage());
			return null;
	    }
	} 
	
	/**
	 * @param Node
	 * @return boolean
	 * Check Node type, Whether its has children or not. Returns
	 * false if it doesn't have children   
	 */
	private static boolean checkNodeType(Node nCheckNode){
		boolean retVal = false;
		//a.b("Node name " + nCheckNode.getNodeValue());
		NodeList n = nCheckNode.getChildNodes();
		//a.b("Node Childes number  " + n.getLength());
		if(n.getLength() > 0)
			retVal = true;
	return retVal;
	}
	
}// end of the class 
