/**
 * Title:		importWizard
 * Description:	Implements a basic Shortcut Interface
 * Copyright:    Copyright (c) 2006 by SAS Institute Pune, India
 * Company:      SAS Global Services, Pune 
 */


package com.sas.metadata.imp;

import javax.swing.Icon;
import javax.swing.JMenuItem;

import com.sas.wadmin.plugins.ShortcutInterface;
import com.sas.workspace.WAdminResource;

/**
 * 
 * Shortcut Interface is used to write the Plug in for 
 * SAS ETL Studio 
 */


public class importWizard implements ShortcutInterface {

    public importWizard()
    {
    }

    public void initPlugin()
    {
    }

    public String getName()
    {
        return bundle.getString("ComponentImport.menu.txt");
    }

    public String getDescription()
    {
        return bundle.getString("ComponentImport.description.txt");
    }

    public Icon getIcon()
    {
        return bundle.getImageIcon("Conversion.Image.image");
    }

    public void dispose()
    {
    }

    protected WAdminResource getBundle()
    {
        return bundle;
    }

    public void onSelected()
    {
    	ImportWizardFile file = new ImportWizardFile(bundle);
    	
    	file.setModal(false);
    	file.show(true);
    	//new trialRadioClass().show();
    	
    }

    public Icon getLargeIcon()
    {
        return bundle.getImageIcon("Conversion.ImageBig.image");
    }

    public JMenuItem getMenuItem()
    {
        JMenuItem menuItem = new JMenuItem(bundle.getString("ComponentImport.menu.txt"));
        menuItem.setIcon(getIcon());
        return menuItem;
    }

    public int getLocations()
    {
        return 4;
    }

    private static WAdminResource bundle;

    static 
    {
        bundle = new WAdminResource(com.sas.metadata.imp.importWizard.class);
    }
}