/** 
 * <p>Title: import_Objects</p>
 * <p>Description: Class that adds / update metadata objects </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */

package com.sas.metadata.imp;

//import java.io.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.sas.meta.SASOMI.IOMI;
import com.sas.metadata.AssociationList;
import com.sas.metadata.CMetadata;
import com.sas.metadata.Column;
import com.sas.metadata.DatabaseSchema;
import com.sas.metadata.Directory;
import com.sas.metadata.Group;
import com.sas.metadata.Job;
import com.sas.metadata.MdException;
import com.sas.metadata.MdModelUtil;
import com.sas.metadata.MdObjectFactory;
import com.sas.metadata.MdObjectStore;
import com.sas.metadata.MetadataUtil;
import com.sas.metadata.MetadataWorkspace;
import com.sas.metadata.PhysicalTable;
import com.sas.metadata.Property;
import com.sas.metadata.PropertyType;
import com.sas.metadata.Prototype;
import com.sas.metadata.SASLibrary;
import com.sas.metadata.ServerContext;
import com.sas.metadata.Tree;
import com.sas.util.Strings;
import com.sas.workspace.AppServer;
import com.sas.workspace.AppServerException;
import com.sas.workspace.OpRequestUI;
import com.sas.workspace.ReposDependencyObject;
import com.sas.workspace.Repository;
import com.sas.workspace.RepositoryUtil;
import com.sas.workspace.WAWizardDialog;
import com.sas.workspace.WAdminResource;
import com.sas.workspace.Workspace;


/**
 * @author Ajit Singh
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class import_Objects{
	
	HashMap hmTableMap;
	String strReposName;
	static boolean m_bDIStudioFlag = false;

	// creating maps to put object info
	public import_Objects(){		
		
		hmTreeInfo = new HashMap();
		hmGroupInfo = new HashMap();
		hmMetadataObjects = new HashMap();
		hmLibInfo = new HashMap();
		
		hmLibMetaInfo = new HashMap();
		hmSchemaInfo = new HashMap();
		hmSchemaMetaInfo = new HashMap();
		hmTableIdentity = new HashMap();
		
		hmTableMap= new HashMap();
		hmColumnsWithKeys = new HashMap();
		hmPropertyNodes = new HashMap();
	}
	
	/**
	 * p_path        - Path of solution directory sclected by user. 
	 * p_reposId	 - Repository Id. 
	 * reposName	 - Name of selected Repository.
	 * oprequestui   - to display messages on importwizard tab while importing library.  
	 */
	
	protected void write_meta_metadata(String p_path,String p_reposId, String reposName,OpRequestUI oprequestui) {
		
		oprequestui.setMessage("Gathering Metadata Info..."); //$NON-NLS-1$
		mdobjectstore = MdObjectFactory.createObjectStore();
		strReposName = reposName;
		path = p_path; 
		File SolutionDir = new File(path); 
		String[] sAllFiles = SolutionDir.list();
		reposid = p_reposId;
		as = m_workspace.makeAppServer(false);
		sc = as.getServerContext();
		oprequestui.setMessage("Setting Path..."); //$NON-NLS-1$
		for (int i = 0; i < sAllFiles.length; i++) {
			hmMetadataObjects.put(sAllFiles[i], path + "\\" + sAllFiles[i]);	// Path to XML files is put in a hashmap
		}		
	}// end of write_meta_metadata
	
	/**
	 * treesToImport - List of trees to import.
	 * oprequestui   - to display messages on importwizard tab while importing library.  
	 * iNum			 - this contains total number of objects selected for import.
	 */
	
	public int import_groups(List treesToImport,OpRequestUI oprequestui,int iNum){
		
		String path = (String) hmMetadataObjects.get("Groups");
		getGroup(reposid);
		getTree(reposid);

		StringBuffer sb1 = new StringBuffer(150+treesToImport.size()*250);
		oprequestui.setMessage("Bundling Trees...");
		sb1.append("<AddMetadata><Metadata>");

		String parentGroupID;
		
		parentGroupID = getGroupID("Data Integration Studio Groups"	.toLowerCase()); //$NON-NLS-1$
		if(parentGroupID == null)
			parentGroupID = getGroupID("ETL Studio Groups".toLowerCase());

		cUtilityClass.WriteLog("\n\n\nFollowing custom folders have been created\n\n\n");
		cUtilityClass.WriteLog("=============================================\n\n");

		cUtilityClass.WriteLog("Importing Groups....\n=============================================\n");

		for (int u = 0; u < treesToImport.size(); u++) {
			try {

				StringBuffer sb = new StringBuffer(500);
				String trGrp = (String)treesToImport.get(u);
				String newStr = path + "\\" + trGrp;

				// newStr contains the xml for group to be imported

				if (newStr.indexOf("&amp;") != -1){
					newStr = cUtilityClass.replaceAnd(newStr);
				}
				// This will repalce etlstudio custum tree with DI studio custum tree
				String s = From(newStr);
				
				int firstIndex = s.indexOf("Id=\"$")+5; //$NON-NLS-1$
				int LastIndex = s.indexOf("\" >",firstIndex);

 //$NON-NLS-1$
				String fullName = s.substring(firstIndex, LastIndex);
			    // Received full name of tree
  
				oprequestui.setMessage("Checking for tree " + trGrp + "...");
				 //$NON-NLS-1$
				if(!hmTreeInfo.containsKey(fullName.toLowerCase())){
					cUtilityClass.WriteLog("Import of group " + fullName.toUpperCase() + " Started ");
					sb.append(s);
					oprequestui.setMessage("Remaining " + iNum-- + ": Writing "
							+ trGrp + "...");
					int startParentObjRef = sb.indexOf("<Tree ObjRef=\"$") + 15;
					int endParentObjRef = sb.indexOf("\"", startParentObjRef);

					String parentTreeName = sb.substring(startParentObjRef,
							endParentObjRef);
					// Received parent tree name
					if (parentTreeName.indexOf("&amp;") != -1) {
						parentTreeName = parentTreeName.replaceAll("&amp;", "&");
					}

					if (hmTreeInfo.containsKey(parentTreeName.toLowerCase()))
					{
						String parentTreeID = getTreeID(parentTreeName.toLowerCase());

						sb.replace(startParentObjRef - 1, endParentObjRef,
								parentTreeID);
					}
					int startObjRef = sb.indexOf("<Group ObjRef=\"$");
					if (startObjRef != -1)
					{
						startObjRef += 15;
						int endObjRef = sb.indexOf("\"", startObjRef);
						sb.replace(startObjRef, endObjRef, parentGroupID);
					}
					sb1.append(sb.toString());

					cUtilityClass.WriteLog(fullName.toUpperCase() + " Created ");

				} else {
					cUtilityClass.WriteLog(fullName.toUpperCase()
							+ " Group Already Exists");
				}
			} catch (IOException e) {
				a.error(e.getMessage());
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("IO ERROR: " + e.getMessage());
			} catch (Exception e) {
				a.error(e.getMessage());
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("ERROR: " + e.getMessage());
			}
		}
		sb1.append("</Metadata><Reposid>"+ reposid+ "</Reposid><ns>SAS</ns><flags>268435456</flags><options/></AddMetadata>");
		oprequestui.setMessage("Writing all Trees into Repository...");
	
		import_object(sb1.toString());
		return iNum;
	}// end of import Group
	
	/**
	 * libsToImport - List of libraries to import.
	 * oprequestui  - to display messages on importwizard tab while importing library. 
	 * foundationId	- Repository Id of selected repository. 
	 * iNum			- this contains total number of objects selected for import.
	 */

	public int import_Library(List libsToImport, OpRequestUI oprequestui,
			String foundationId, int iNum) {
		try {
			cUtilityClass.WriteLog("Importing Libraries....\n=============================================\n");
			oprequestui.setMessage("Gather info for library import...");
			getTree(reposid);   // Populates -- hmTreeInfo (Key=TreeName, Value=Id)  Should this function be multiple times from various import routines?? may be not...
			getLibs(reposid);   // 	Populates hmLibInfo(Libname, Id),  hmLibMetaInfo (name, LibObject)


			String path = (String) hmMetadataObjects.get("Libraries");	// Path to the XML Files
			for (int u = 0; u < libsToImport.size(); u++) {	// Read xml files one by one
				StringBuffer sb = new StringBuffer(1000);
				String sLibName = (String) libsToImport.get(u);	// Please use sLibName in place of test!!
				cUtilityClass.WriteLog("Import of Library " + sLibName.toUpperCase() + " Started ");
				cUtilityClass.WriteLog("   " + sLibName);
				oprequestui.setMessage("Importing " + sLibName + " Library...");

				String newStr = path + "\\" + sLibName;
				if (newStr.indexOf("&amp;") != -1) {
					newStr = cUtilityClass.replaceAnd(newStr);
				}

				// From is a function which reads File (Supplied as parameter)
				// and returns a String sb == contents of the entire file.
				sb.append(From(newStr));
				
				// check if Tree is specified for the Library 
				int startParentObjRef = sb.indexOf("<Tree ObjRef=\"$");

				if (startParentObjRef != -1) {
					// Tree is specified for the library -- get its name
					startParentObjRef = startParentObjRef
							+ "<Tree ObjRef=\"$".length();
					int endParentObjRef = sb.indexOf("\"", startParentObjRef);
					String parentTreeName = sb.substring(startParentObjRef,
							endParentObjRef);

					if (hmTreeInfo.containsKey(parentTreeName.toLowerCase())) {
						// Tree found in our collection, take its ID and replace in ObjRef
						String parentTreeID = getTreeID(parentTreeName
								.toLowerCase());
						sb.replace(startParentObjRef - 1, endParentObjRef,
								parentTreeID);
					} else {
						a.errorMessage("Required Tree '" + parentTreeName
								+ "' is missing in the enviornment",
								"Can not import the library");
						return iNum;
					}
				}

				String finalStr = null;
				finalStr = sb.toString();
				
				// Check for Server Context in the Library
				int startObjRef = sb.indexOf("<ServerContext ObjRef=\"$");
				
				if (startObjRef != -1) {
					String contextFQ = sc.getFQID();	//sc == server context -- derived from application server
					// Server Context found in the Library XML
					startObjRef = startObjRef
							+ "<ServerContext ObjRef=\"$".length();
					int endObjRef = sb.indexOf("$\" />", startObjRef);
					//Replace that Servercontext with ServerContext for repos we are importing into
					finalStr = sb.substring(0, startObjRef - 1) + contextFQ
							+ sb.substring(endObjRef + 1);
				}

				int zeroPoint = finalStr.indexOf("<SASLibrary Name=\"");
				int startEngine = finalStr.indexOf("Engine=\"", zeroPoint)
						+ "Engine=\"".length();
				int endEngine = finalStr.indexOf("\"", startEngine);
				String engine = finalStr.substring(startEngine, endEngine);

				// Check for the Engine of library
				// if it is Non SAS it prepares scripts for Required objects
				// like SASClientConnection, Prototype, Login, Databaseschema
				// if it is a SAS Library then Accordingly the scripts is
				// prepared
				if (!("BASE".equalsIgnoreCase(engine)
						|| "V7".equalsIgnoreCase(engine)
						|| "V701".equalsIgnoreCase(engine)
						|| "V8".equalsIgnoreCase(engine)
						|| "V9".equalsIgnoreCase(engine)
						|| "SPDE".equalsIgnoreCase(engine) || "LIST"
						.equalsIgnoreCase(engine))) {
					finalStr = prepareIDSet("<Login ObjRef=\"", "\" />",
							finalStr, foundationId, "Login");
					finalStr = prepareIDSet("<SASClientConnection ObjRef=\"",
							"\" />", finalStr, foundationId,
							"SASClientConnection");
					finalStr = prepareIDSet("<Prototype ObjRef=\"", "\" />",
							finalStr, foundationId, "Prototype");
					finalStr = prepareIDSet("<DatabaseSchema ObjRef=\"",
							"\" />", finalStr, foundationId, "DatabaseSchema");
				}

				// Add actual ReposID into final xml string to be thrown at doRequest
				int startReposTag = finalStr.indexOf("<Reposid>")
						+ "<Reposid>".length();
				int endReposTag = finalStr.indexOf("</Reposid>", startObjRef);

				finalStr = finalStr.substring(0, startReposTag) + reposid
						+ finalStr.substring(endReposTag);
				oprequestui.setMessage("Remaining: " + iNum-- + ": Library - "
						+ sLibName + " ...");		// test is name of library please use sLibName

				// skip the tag of encoding while throwing the xml to doRequest so begin from <AddMetadata> tag
				finalStr = finalStr
						.substring(finalStr.indexOf("<AddMetadata>"));
				// Final Import of the object
				import_object(finalStr, sLibName); // test is name of library please use sLibName
			}
		} catch (IOException e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
			oprequestui.setMessage("Writing log for error ");
			cUtilityClass.WriteLog("Failed: " + e.getMessage());
		} catch (Exception e1) {
			a.error(e1.getMessage());
			oprequestui.setMessage("Writing log for error ");
			cUtilityClass.WriteLog("Failed: " + e1.getMessage());
			e1.printStackTrace(System.err);
		}
		return iNum;
	}

	// Method which searches for variable and replaced by Metadata variable.
	private String prepareIDSet(String From, String To, String main,
			String FID, String ObjectToGet) {
		String retId = null;
		int startLogin = main.indexOf(From);
		String retVal = main;

		if (startLogin != -1) {
			startLogin = startLogin + From.length();
			int endLogin = main.indexOf(To, startLogin);
			String objectValue = main.substring(startLogin, endLogin);

			String XMLSelect = "";
			String person = "";
			String auth = "";
			// Preparing XMLSelect String for Login/AuthenticationDomain in IF()
			// check
			if ("Login".equalsIgnoreCase(ObjectToGet)) {
				int k = objectValue.indexOf("/");
				person = objectValue.substring(0, k);
				auth = objectValue.substring(k + 1);
				XMLSelect = "<XMLSelect search=\"Login[Domain/AuthenticationDomain[@Name='"
						+ auth
						+ "']]\"/><Templates><Login><AssociatedIdentity/></Login><Person/></Templates>";
			} else {
				// Preparing XMLSelect String for SASClientConnection,
				// DatabaseSchema, Prototype in else() check
				XMLSelect = "<XMLSelect search=\"" + ObjectToGet + "[@Name='"
						+ objectValue + "']\"/>";
			}
			IOMI connection = getIOMIConnection();
			String reposType = RepositoryUtil.getRepositoryType(connection, FID);
			List Objects = null;
			// Gets the object based on repository
			if ("DatabaseSchema".equalsIgnoreCase(ObjectToGet)
					|| !("CUSTOM".equalsIgnoreCase(reposType))) {
				Objects = cUtilityClass.getObjects(XMLSelect, ObjectToGet, FID);
			} else if ("CUSTOM".equalsIgnoreCase(reposType)) {
				String reposId = getFoundationReposId(FID, connection);
				Objects = cUtilityClass.getObjects(XMLSelect, ObjectToGet,
						reposId);
			}
			if (Objects.size() != 0) {
				if ("Login".equalsIgnoreCase(ObjectToGet)) {
					for (int q = 0; q < Objects.size(); q++) {
						CMetadata cm = (CMetadata) Objects.get(q);
						String s = cm.getName();
						String s4 = cm.getId();
						int i1 = s.indexOf(".");
						int i2 = s.lastIndexOf(".");
						String s2 = s.substring(i1 + 1, i2);
						if (person.equalsIgnoreCase(s2)) {
							retId = cm.getId();
							break;
						}
					}
					if (retId == null) {
						a.error(person+ " not found in Environment.\n Create before importing the Non SAS library.");
					}
				} else {
					CMetadata cm = (CMetadata) Objects.get(0);
					retId = cm.getId();
				}
			} else {
				a.error(objectValue
								+ " For "
								+ ObjectToGet
								+ "not found in Environment.\n Create before importing the Non SAS library.");
			}
			retVal = main.substring(0, startLogin - 1) + "\"" + retId + "\""
					+ main.substring(endLogin + 1);
		}
		return retVal;
	}
	
	/**
	 * This method provide connection to metadata sever on which we are importing objects.  
	 */
	public static IOMI getIOMIConnection() {
		IOMI connection = null;
		String OMRUserid = cUtilityClass.getOMRValue("Username");
		String OMRPassword = cUtilityClass.getOMRValue("Password");
		String OMRHost = cUtilityClass.getOMRValue("Hostname");
		String OMRPort = cUtilityClass.getOMRValue("Port");

		MetadataWorkspace workspace = MetadataWorkspace.getWorkspace();
		try {
			connection = workspace.makeOMRConnection(OMRHost, OMRPort,
					OMRUserid, OMRPassword);
		} catch (Exception e) {
			a.error("Error while getting the Connection Parameter");
			e.printStackTrace(System.err);
		}
		return connection;
	}
	
	/**
	 * Method which returns repository Id of foundation repository. 
	 */
	
	public static String getFoundationReposId(String reposId, IOMI connection) {
		try {
			Vector reposDependent = RepositoryUtil.getRepositoryDependencies(
					connection, reposId, RepositoryUtil.DEPENDENCY_USES);
			for (int i = 0; i < reposDependent.size(); i++) {
				ReposDependencyObject baseRepository = (ReposDependencyObject) reposDependent
						.get(i);
				Repository baseRepos = baseRepository.getRepository();
				String reposType = baseRepos.getName();
				if ("Foundation".equalsIgnoreCase(reposType)) {
					return RepositoryUtil.getReposIdForName(connection,
							baseRepos.getName());
				}
			}

		} catch (Exception e) {
			a.error("Error while reading the dependant repository of the Custom Repository \n"
							+ e.getMessage());
			e.printStackTrace(System.err);
		}
		return null;
	}
	
	public int import_Tables(List tablesToImport, OpRequestUI oprequestui,
			int iNum)
	{
		cUtilityClass.WriteLog("Importing Physical Tables....\n=============================================\n");
		oprequestui.setMessage("Gather info for Table import");
		getLibs(reposid);
		getTree(reposid);
		String t = "";

		for (int u = 0; u < tablesToImport.size(); u++) {
			try {
				t = (String) tablesToImport.get(u);
				cUtilityClass.WriteLog("Import of Table " + t.toUpperCase() + " Started ");
				oprequestui.setMessage("Importing " + t + " Table");
				iNum = Import_Single_Table(t, iNum);
				oprequestui.setMessage("Remaining: " + iNum-- + ": Table - "
						+ t);
			} catch (Exception e) {
				a.error(e.getMessage());
				cUtilityClass.WriteLog("Failed: " + t + " : " + e.getMessage());
				e.printStackTrace(System.err);
			}
			hmXmlIdMetaId.clear();
		}
		return iNum;
	}// end of import tables

	/**
	 * t 			  - List of tables to import.
	 * oprequestui    - to display messages on importwizard tab while importing library.  
	 * iNum			  - this contains total number of objects selected for import.
	 */

	private int Import_Single_Table(String t, int iNum)
	{
		String path = (String) hmMetadataObjects.get("Tables");
		String ProcString = "";
		String sLibname = "";
		String LibId = "";
		String TablePath = path + "\\" + t;

		if (t.indexOf("&amp;") != -1) {
			t = cUtilityClass.replaceAnd(t);
		}
		
		try {
			ProcString = From(path + "\\" + t);
		} catch (IOException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		}
		
		int nodes=getTreeNodes(TablePath, t);
		if(nodes>1){
			ProcString = ProcessTableString(TablePath, t);
			}
			else{
		
		//Old logic of table import		
		int startParentObjRef = ProcString.indexOf("<Tree ObjRef=\"$");
		if (startParentObjRef != -1) {
			startParentObjRef += 15;
			int endParentObjRef = ProcString.indexOf("\"", startParentObjRef);
			String parentTreeName = ProcString.substring(startParentObjRef,
					endParentObjRef);

			parentTreeName = cUtilityClass.changeReferenceTo(parentTreeName);

			if (hmTreeInfo.containsKey(parentTreeName.toLowerCase())) {
				String parentTreeID = getTreeID(parentTreeName.toLowerCase());
				ProcString = ProcString.substring(0, startParentObjRef - 1)
						+ parentTreeID + ProcString.substring(endParentObjRef);

			} else {
				a.error("While importing Table " + t + " \nRequired Tree \" "
						+ parentTreeName
						+ " \" is not present in the environment");
			}
		}
		
	}
		
		//To support grouping of table & column notes
	//	ProcString = ProcessTableString( TablePath, t);

		if (ProcString.indexOf("ReposID") == -1) {
			a.error("The format of the export file for Information Map '"
					+ t.substring(0, t.lastIndexOf(".xml"))
					+ "' is not supported");
			return iNum;
		}
		ProcString = ProcString.replaceAll("ReposID", reposid);

		int iLibStart = ProcString.indexOf("<TablePackage>")
		+ "<TablePackage>".length();
		int iLibEnd = ProcString.indexOf("</TablePackage>", iLibStart);
		String replaceTablePackage = "";
		int iSASBegin = ProcString.indexOf("___", iLibStart); 

		if (iSASBegin != -1) {

			int iSASEnd = ProcString.indexOf("###", iSASBegin); // Changed on 27
			// Dec 05
			sLibname = ProcString.substring(iSASBegin + 3, iSASEnd);
			sLibname = cUtilityClass.MoreResolveTexttoHash(sLibname);
			/*
			 * Searching For engine type of library Based on Engine type Changes
			 * for Database schema or SAS Library would be made in the script
			 */

			String engineType = getLibEngine(sLibname);

			if ("S".equalsIgnoreCase(engineType))
			{
				LibId = getLibID(sLibname);

				LibId = getLibID(cUtilityClass.changeReferenceTo(sLibname));
				replaceTablePackage = "<SASLibrary ObjRef=\"" + LibId + "\"/>";
			} else {
				LibId = getSchemaID(sLibname);
				replaceTablePackage = "<DatabaseSchema ObjRef=\"" + LibId
				+ "\"/>";
			}
			// Prepare complete String for Table import
			ProcString = ProcString.substring(0, iLibStart)
			+ replaceTablePackage + ProcString.substring(iLibEnd);
		}
		ProcString = ProcString.substring(ProcString.indexOf("<AddMetadata>"));

		// Final Import of Table Object
		import_object(ProcString, t);
		return iNum;
	}
	
	public int getTreeNodes(String tablePath, String t)
	{DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
	//DocumentBuilder is used obtain a Document from XML.
	DocumentBuilder docBuilder;
	Document doc = null;
	int len=0;
	try {		
		docBuilder = docBuilderFactory.newDocumentBuilder();
		doc = docBuilder.parse(new File(tablePath));
		NodeList nlTree = doc.getElementsByTagName("Tree");	
		len= nlTree.getLength();
	}
	 catch (Exception e) {
			a.error(t.toString());
			cUtilityClass.WriteLog("General ERROR in ProcessString: "
					+ e.getMessage());
			e.printStackTrace(System.err);
		}
	 return len;
	}
	
	
	/**
	 * tablePath	  - Path of the directory containg 
	 * t			  - Table name  
	 * The table import logic from text best parsing is changed to dom parser based parsin.
	 * this change is made to support grouping of notes.
	 */
	private String ProcessTableString(String tablePath, String t) {
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		//DocumentBuilder is used obtain a Document from XML.
		DocumentBuilder docBuilder;
		Document doc = null;

		try {
			docBuilder = docBuilderFactory.newDocumentBuilder();
			doc = docBuilder.parse(new File(tablePath));

			NodeList nlTree = doc.getElementsByTagName("Tree");
			ProcessXMLTree(nlTree, lstNodeDel);
			processTreeNode(nlTree);
			removeNodes(lstNodeDel);
			lstNodeDel.clear();
			doc.normalize();
			replaceObjRefValues(nlTree);
		} catch (SAXParseException err) {
			a.error(err.toString());
			cUtilityClass.WriteLog("SAX Parse ERROR in ProcessString: "
					+ err.getMessage());
			err.printStackTrace(System.err);
		} catch (SAXException e) {
			a.error(e.toString());
			cUtilityClass.WriteLog("SAX ERROR in ProcessString: "
					+ e.getMessage());
			e.printStackTrace(System.err);
		} catch (Exception e) {
			a.error(t.toString());
			cUtilityClass.WriteLog("General ERROR in ProcessString: "
					+ e.getMessage());
			e.printStackTrace(System.err);
		}
		doc.normalize();

		return getStringFromDocument(doc);
	}

	private void processTreeNode(NodeList nlTree) {
		Node nTree= null;
		Node nTreeId = null;
		for(int nlTreecnt = 0; nlTreecnt < nlTree.getLength();nlTreecnt++){

			nTree = nlTree.item(nlTreecnt);

			if (nTree.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nTree))
			{				
				lstNodeDel.add(nTree);

				if (nTree.hasAttributes()) 
				{					
					NamedNodeMap nnmAttr = nTree.getAttributes();
					nTreeId = nnmAttr.getNamedItem("Id"); // id from xml file (ex: Id="$264")

					String sTreeId = nTreeId.getNodeValue().toLowerCase(); // $264
					String objString = getJobTree(sTreeId);
					String strmetadataid = (String) hmTreeInfo.get(objString.toLowerCase());
					hmXmlIdMetaId.put(sTreeId,strmetadataid);
				}				
			}				 

		}
	}

	/**
	 * @param libName -
	 *            Name of the Library of which Engine is to be found Returns the
	 *            type of the engine
	 */
	private String getLibEngine(String libName){
		String retVal = "";
		String libEngine = null;
		SASLibrary slibrary = null;
		//String libName1 = cUtilityClass.MoreResolveTexttoHash(libName);
		
		MdObjectStore myStore = MdObjectFactory.createObjectStore();
		try
		{
			String sOptions = "<XMLSelect Search=\"@Name='" + libName + "'\"/>" +
			"<Templates><SASLibrary Id=\"\" Name=\"\" Engine=\"\"><UsingPackages/></SASLibrary></Templates>";
			try {
				List libraries = MetadataUtil.getMetadataObjectsSubset(myStore, reposid, "SASLibrary", 
						MetadataUtil.OMI_XMLSELECT|
						MetadataUtil.OMI_TEMPLATE|
						MetadataUtil.OMI_GET_METADATA,
						sOptions);
				if(libraries.size() > 0)
					slibrary = (SASLibrary)libraries.get(0);
				else
					a.error("Library not found: " + libName);
				libEngine = slibrary.getEngine();
			} catch (MdException e) {
				a.error("Failed while fetching Engine for Library '" + cUtilityClass.changeReferenceTo(libName) + "'\n" + e.getMessage());
				e.printStackTrace();
			}
			
			
			if("BASE".equalsIgnoreCase(libEngine)||"V7".equalsIgnoreCase(libEngine)||
					"V701".equalsIgnoreCase(libEngine) ||
					"V8".equalsIgnoreCase(libEngine) ||
					"V9".equalsIgnoreCase(libEngine)||
					"SPDE".equalsIgnoreCase(libEngine)){
				retVal="S";
			}else {
				try {
					AssociationList libPackage = slibrary .getAssociatedObjects("UsingPackages");
					if(libPackage.size()>0){
						if(libPackage.size() > 0)
						{
							DatabaseSchema schema = (DatabaseSchema)libPackage.get(0);
							retVal="D###___Schema: " + schema.getName() ;	
						}
						else
							a.error("No database schema found for non-SAS library: " + libName);
					}else{
						a.error("There is no schema attached with library : " +libName);
					}
					
				} catch (MdException e) {
					a.error ("Error while getting the Database Schema for Lib: " + slibrary.getName() + "\n" + e.getMessage());
					e.printStackTrace();
				}
			}
		}
		catch(Exception e)
		{
			a.error(e.getMessage());
			cUtilityClass.WriteLog("Error occurred in getLibEngine: " + e.getMessage());
		}
		myStore.dispose();
		return retVal;
	}
	
	
	/**
	 * Return Database schema ID for supplied Library Name
	 */
	private String getSchemaID(String LibName) {
		String retVal = "";

		String newLibName = cUtilityClass.changeReferenceTo(LibName.toLowerCase());
		if (hmLibMetaInfo.containsKey(newLibName)) {
			SASLibrary slSchema = (SASLibrary) hmLibMetaInfo.get(newLibName);
			retVal = getSchemaDetail(slSchema);
		}
		return retVal;
	}

	/**
	 * Return Database schema Name for supplied Library Name
	 */
	private String getSchemaName(String LibName) {
		String retVal = "";

		String newLibName = cUtilityClass.changeReferenceTo(LibName
				.toLowerCase());
		if (hmLibMetaInfo.containsKey(newLibName)) {
			SASLibrary slSchema = (SASLibrary) hmLibMetaInfo.get(newLibName);
			retVal = getSchemaDetailName(slSchema);
		}
		return retVal;
	}

	/**
	 * Return Database schema ID for supplied CMetadata Object
	 */
	private String getSchemaDetail(CMetadata sl) {
		CMetadata cmSL = null;
		DatabaseSchema ds = null;
		String retval = "";
		
		try {
			MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
			mdobjectstore.setIsObjectCopiedFromParentOnCreation(false);
			sl = MdObjectFactory.createComplexMetadataObject(mdobjectstore, sl);
			cmSL = MetadataUtil.getMetadataAllDepths(mdobjectstore,	"SASLibrary",sl.getFQID(),
							new ArrayList(),new ArrayList(),"<SASLibrary><UsingPackages/></SASLibrary><DatabaseSchema/>",
							MetadataUtil.OMI_ALL | MetadataUtil.OMI_SUCCINCT
									| MetadataUtil.OMI_INCLUDE_SUBTYPES
									| MetadataUtil.OMI_ALL_SIMPLE);
			SASLibrary sl2 = (SASLibrary) cmSL;
			
			//A List of the packages that use this library
			AssociationList dsList = sl2.getUsingPackages();
			if (dsList.size() > 0)
			{
				ds = (DatabaseSchema) dsList.get(0);
			}

			retval = ds.getId();
			//returns Id of First DatabaseSchema
			mdobjectstore.dispose();
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: " + e.getMessage());

		} catch (Exception e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: " + e.getMessage());
		}
		return retval;
	}

	/**
	 * Return Database schema Name for supplied CMetadata Object
	 */
	private String getSchemaDetailName(CMetadata sl) {
		CMetadata cmSL = null;
		DatabaseSchema ds = null;
		String retval = "";
		try {
			MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
			mdobjectstore.setIsObjectCopiedFromParentOnCreation(false);
			sl = MdObjectFactory.createComplexMetadataObject(mdobjectstore, sl);
			cmSL = MetadataUtil.getMetadataAllDepths(
							mdobjectstore,
							"SASLibrary",
							sl.getFQID(),
							new ArrayList(),
							new ArrayList(),
							"<SASLibrary><UsingPackages/></SASLibrary><DatabaseSchema/>",
							MetadataUtil.OMI_ALL | MetadataUtil.OMI_SUCCINCT
									| MetadataUtil.OMI_INCLUDE_SUBTYPES
									| MetadataUtil.OMI_ALL_SIMPLE);
			SASLibrary sl2 = (SASLibrary) cmSL;
			AssociationList dsList = sl2.getUsingPackages();
			if (dsList.size() > 0) {
				ds = (DatabaseSchema) dsList.get(0);
			}
			retval = ds.getName();
			mdobjectstore.dispose();
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: " + e.getMessage());

		} catch (Exception e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: " + e.getMessage());
		}
		return retval;
	}

	protected void setTableMap(HashMap hmMap) {
		hmTableMap = hmMap;
	}

	protected int add_XML_Column(HashMap hmUpdateColumnData, String type,
			OpRequestUI oprequestui, int iNum) {

		oprequestui.setMessage("Gather Info...");
		cUtilityClass.WriteLog("Addition of extra Columns From Media....\n=============================================\n");
		Set outerSet = hmUpdateColumnData.keySet();
		Iterator outerIter = outerSet.iterator();
		int i = 1;
		oprequestui.setMessage("Gather Info...");
		// a.b("Size of Map " + hmUpdateColumnData.size());
		while (outerIter.hasNext()) {
			// Supplied HashMap is a collction of Tablename as unique key with
			// columns Data in HashMap
			// Getting value(HashMap) of TableName from Supplied HashMap
			String TableName = (String) outerIter.next();
			oprequestui.setMessage("Remaining: " + iNum--
					+ ":Adding XML Cols to " + TableName + "...");
			// Getting Physical Table object (For Metadata ID) from separate(Not
			// Supplied as parameter) HashMap
			PhysicalTable pt = (PhysicalTable) hmTableMap.get(TableName);
			// Gettting HashMap of columns Data
			HashMap hmColumnData = (HashMap) hmUpdateColumnData.get(TableName);
			if (!hmColumnData.isEmpty()) {
				Set innerSet = hmColumnData.keySet();
				Iterator innerIter = innerSet.iterator();
				int j = 1;
				StringBuffer sb = new StringBuffer(500);
				sb.append("<UpdateMetadata><Metadata>\n<PhysicalTable id=\"");
				sb.append(pt.getId() + "\"><Columns Function=\"Append\" >");
				cUtilityClass.WriteLog("    " + i + " Table Name " + TableName
						+ " Id: " + pt.getId());
				while (innerIter.hasNext()) {
					String strColKey = (String) innerIter.next();
					oprequestui.setMessage("Adding column  " + strColKey
							+ "...");
					HashMap hmColumnAttr = (HashMap) hmColumnData
							.get(strColKey);
					String Name = (String) hmColumnAttr.get("Name");
					String ColumnName = (String) hmColumnAttr.get("ColumnName");
					String SASColumnName = (String) hmColumnAttr
							.get("SASColumnName");
					String Desc = (String) hmColumnAttr.get("Desc");
					String ColumnType = (String) hmColumnAttr.get("ColumnType");
					String ColumnLength = (String) hmColumnAttr
							.get("ColumnLength");
					String Format = (String) hmColumnAttr.get("Format");
					String InFormat = (String) hmColumnAttr.get("Informat");
					String IsNullable = (String) hmColumnAttr.get("IsNullable");

					sb.append("<Column id=\"\" Name=\"" + Name
							+ "\" ColumnName=\"" + ColumnName + "\"");
					sb.append(" SASColumnName=\"" + SASColumnName
							+ "\" Desc=\"" + Desc + "\" SASColumnType=\""
							+ ColumnType + "\"");
					sb.append(" SASColumnLength=\"" + ColumnLength + "\"");
					sb.append(" SASFormat=\"" + Format + "\"");
					sb.append(" SASInFormat=\"" + InFormat + "\"");
					sb.append(" IsNullable=\"" + IsNullable + "\"");
					sb.append("/>");

				cUtilityClass.WriteLog("       " + j + " ColumnName: "+ SASColumnName);
					oprequestui.setMessage("Updating metadata for  "+ TableName + "...");
					j++;
				}
				sb.append("</Columns></PhysicalTable></Metadata><NS>SAS</NS><Flags>268435456</Flags><Options/></UpdateMetadata>");
				oprequestui.setMessage("Updating Metadata...");
				import_object(sb.toString());
			}
			i++;
		}
		return iNum;
	}// end of addition

	protected int Update_XML_Columns_in_Meta(HashMap hmUpdateColumnData,
			OpRequestUI oprequestui, int iNum) {

		cUtilityClass.WriteLog("Updation of Table ....\n=============================================\n");
		oprequestui.setMessage("Gather Info...");
		Set outerSet = hmUpdateColumnData.keySet();
		Iterator outerIter = outerSet.iterator();
		int i = 1;

		while (outerIter.hasNext()) {
			// Supplied HashMap is a collction of Tablename as unique key with
			// columns Data in HashMap
			// Getting value(HashMap) of TableName from Supplied HashMap
			String TableName = (String) outerIter.next();
			oprequestui.setMessage("Remaining: " + iNum-- + ":Updating table "
					+ TableName + "...");
			// GEtting PhysicalTable Metadata Object later used in Getting
			// Metadata Id
			PhysicalTable pt = (PhysicalTable) hmTableMap.get(TableName);
			HashMap hmColumnData = (HashMap) hmUpdateColumnData.get(TableName);
			if (!hmColumnData.isEmpty()) {
				Set innerSet = hmColumnData.keySet();
				Iterator innerIter = innerSet.iterator();
				int j = 1;
				StringBuffer sb = new StringBuffer(500);
				sb.append("<UpdateMetadata><Metadata>");
				cUtilityClass.WriteLog("    " + i + " Table Name " + TableName
						+ " Id: " + pt.getId());
				while (innerIter.hasNext()) {
					String ColumnId = (String) innerIter.next();
					oprequestui
							.setMessage("Update column  " + ColumnId + "...");
					HashMap hmColumnAttr = (HashMap) hmColumnData.get(ColumnId);
					sb.append("<Column id=\"" + ColumnId.toUpperCase() + "\"");
					String desc = (String) hmColumnAttr.get("Desc");
					sb.append(" Desc=\"" + desc + "\"");
					String sct = (String) hmColumnAttr.get("ColumnType");
					sb.append(" SASColumnType=\"" + sct + "\"");
					String len = (String) hmColumnAttr.get("ColumnLength");
					sb.append(" ColumnLength=\"" + len + "\"");
					sb.append(" SASColumnLength=\"" + len + "\"");
					String format = (String) hmColumnAttr.get("Format");
					sb.append(" SASFormat=\"" + format + "\"");
					String Informat = (String) hmColumnAttr.get("Informat");
					sb.append(" SASInformat=\"" + Informat + "\"");
					String isNull = (String) hmColumnAttr.get("IsNullable");
					sb.append(" IsNullable=\"" + isNull + "\"");
					sb.append(" />");
					cUtilityClass.WriteLog("            " + j
							+ " Updated Column Id : " + ColumnId.toUpperCase());
					cUtilityClass.WriteLog(" New Description: "+ desc);
					cUtilityClass.WriteLog("New SASColumnType: "+ sct);
					cUtilityClass.WriteLog(" New ColumnLength: "
									+ len);
					cUtilityClass.WriteLog(" New SASFormat: "+ format);
					cUtilityClass.WriteLog(" New SASInFormat: "	+ Informat);
					if ("1".equalsIgnoreCase(isNull))
						isNull = "Yes";
					else
						isNull = "No";
					cUtilityClass.WriteLog(" New IsNullable: "+ isNull);
					oprequestui.setMessage("Updating metadata for  "+ TableName + "...");
					j++;
				}
				sb.append("</Metadata><Flags>268435456</Flags><ns>SAS</ns><Options/></UpdateMetadata>");
				import_object(sb.toString());
			}
			i++;
		}
		return iNum;
	}// end of Update

	protected int Update_Table_in_Meta(HashMap hmUpdateTableData,
			OpRequestUI oprequestui, int iNum, String foundationId) {
				cUtilityClass.WriteLog("Updation of Tables ....\n=============================================\n");
		oprequestui.setMessage("Gather Info...");
		Set outerSet = hmUpdateTableData.keySet();
		Iterator outerIter = outerSet.iterator();
		int i = 1;
			while (outerIter.hasNext()) {
			String TableName = (String) outerIter.next();
					oprequestui.setMessage("Remaining: " + iNum-- + ":Updating table "
					+ TableName + "...");
			PhysicalTable pt = (PhysicalTable) hmTableMap.get(TableName);
			// hmOneTableData(main collection) is a collection of Property with
			// its value.
			// Properties like Compressed, Encrypted, Additionla Option
			HashMap hmOneTableData = (HashMap) hmUpdateTableData.get(TableName);
			if (!hmOneTableData.isEmpty()) {
				String xSelect = "<XMLSelect search=\"Prototype[@Name='Options SASTable Prototype']\"/>";
				// Preparing Map from Metadata server for Prototypes Properties
				// e.g. Compressed, Encrypted, Additional Options
				HashMap hmPropertyType = getTypeId(foundationId, xSelect,
						"Prototype");
				// Preparing set for iteration of Tables property
				Set innerSet = hmOneTableData.keySet();
				Iterator innerIter = innerSet.iterator();
				int j = 1;
				StringBuffer sb = new StringBuffer(500);
				sb.append("<UpdateMetadata><Metadata><PhysicalTable id=\""
						+ pt.getId() + "\"><Properties>");
				cUtilityClass.WriteLog("    " + i + " Table Name " + TableName
						+ " Id: " + pt.getId());
				int i2 = 1;
				while (innerIter.hasNext()) {
					// Getting Property type from main collection
					String propType = (String) innerIter.next();
					// Following If else construct prepares scripts for various
					// prototype options
					if ("compress".equalsIgnoreCase(propType)) {
						String value = (String) hmOneTableData.get(propType);
						String idCompressType = (String) hmPropertyType
								.get("Compressed");
						sb.append(getCompressedString(pt.getId(),
								idCompressType, "$" + i2, value));
						cUtilityClass.WriteLog(" Compression YES for : "+ TableName);
					}else if ("encrypt".equalsIgnoreCase(propType)){
						String idEncryptType = (String)hmPropertyType.get("Encrypted");
						cUtilityClass.WriteLog(" Encrypt YES for : "  + TableName);
						sb.append(getEncryptedString(pt.getId(), idEncryptType,
								"$" + i2));
					} else if ("AdditionalOptions".equalsIgnoreCase(propType)) {
						String addOption = (String) hmOneTableData
								.get(propType);
						String idAdditionOption = (String) hmPropertyType
								.get("Additional Options");
						cUtilityClass
								.WriteLog(" Additional Options has been changed for Table :  "
										+ TableName);
						sb.append(getOptionsString(pt.getId(),
								idAdditionOption, "$" + i2, addOption));
					}
					oprequestui.setMessage("Updating metadata for  "
							+ TableName + "...");
					j++;
					i2++;
				}
				sb.append("</Properties></PhysicalTable></Metadata><Flags>268435456</Flags><ns>SAS</ns><Options/></UpdateMetadata>");
				import_object(sb.toString());
			}
			i++;
		}
		return iNum;
	}// end of Updat

	private String getCompressedString(String TableId, String typeId,
			String i2, String value) {

		StringBuffer sbTemp = new StringBuffer(100);
		sbTemp.append("<Property IsExpert=\"0\" Desc=\"\" Delimiter=\"=\" IsUpdateable=\"0\" IsRequired=\"0\" IsVisible=\"0\" Name=\"Compressed\" PropertyName=\"compress\" LockedBy=\"\" UseValueOnly=\"0\" IsLinked=\"0\" DefaultValue=\""
						+ value
						+ "\" PropertyRole=\"\" Id=\""
						+ i2
						+ "\" ><AssociatedObject><PhysicalTable ObjRef=\""
						+ TableId
						+ "\"/></AssociatedObject><OwningType><PropertyType ObjRef=\""
						+ typeId + "\"/></OwningType></Property>");
		return sbTemp.toString();
	}

	private String getEncryptedString(String TableId, String typeId, String i2) {
		StringBuffer sbTemp = new StringBuffer(100);
		sbTemp.append("<Property IsExpert=\"0\" Desc=\"\" Delimiter=\"=\" IsUpdateable=\"0\" IsRequired=\"0\" IsVisible=\"0\" Name=\"Encrypted\" PropertyName=\"encrypt\" LockedBy=\"\" UseValueOnly=\"0\" IsLinked=\"0\" DefaultValue=\"YES\" PropertyRole=\"\" Id=\""
						+ i2
						+ "\" ><AssociatedObject><PhysicalTable ObjRef=\""
						+ TableId
						+ "\"/></AssociatedObject><OwningType><PropertyType ObjRef=\""
						+ typeId + "\"/></OwningType></Property>");
		return sbTemp.toString();

	}

	private String getOptionsString(String TableId, String typeId, String i2,
			String addOptioin) {
		StringBuffer sbTemp = new StringBuffer(100);
		sbTemp.append("<Property IsExpert=\"0\" Desc=\"\" Delimiter=\"\" IsUpdateable=\"0\" IsRequired=\"0\" IsVisible=\"0\" Name=\"Additional Options\" PropertyName=\"AdditionalOptions\" LockedBy=\"\" UseValueOnly=\"1\" IsLinked=\"0\" DefaultValue=\""
						+ addOptioin
						+ "\" PropertyRole=\"\" Id=\""
						+ i2
						+ "\" ><AssociatedObject><PhysicalTable ObjRef=\""
						+ TableId
						+ "\"/></AssociatedObject><OwningType><PropertyType ObjRef=\""
						+ typeId + "\"/></OwningType></Property>");
		return sbTemp.toString();
	}

	private HashMap getTypeId(String foundationId, String XMLSelect,
			String ObjectType) {
		HashMap hmPropTypemap = new HashMap();
		List Objects = objectList(foundationId, XMLSelect, ObjectType);
		if (Objects.size() > 0) {
			CMetadata cmPropPrototype = (CMetadata) Objects.get(0);
			Prototype proto = getRealPrototype(cmPropPrototype);
			try {
				AssociationList alProtoProperties = proto.getProperties();
				for (int y = 0; y < alProtoProperties.size(); y++) {
					Property eachProperty = (Property) alProtoProperties.get(y);
					PropertyType ptProperty = eachProperty.getOwningType();
					hmPropTypemap.put(eachProperty.getName(), ptProperty
							.getId());
				}
			} catch (MdException e) {
				a.error(e.getMessage());
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("ERROR: " + e.getMessage());
			} catch (Exception e) {
				a.error(e.getMessage());
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("ERROR: " + e.getMessage());
			}
		}
		return hmPropTypemap;
	}

	private List objectList(String foundationId, String XMLSelect,
			String ObjectType) 
	{
		List Objects = null;
		try {
			Objects = MetadataUtil.getMetadataObjects(foundationId, ObjectType,
					MetadataUtil.OMI_GET_METADATA | MetadataUtil.OMI_ALL_SIMPLE
							| MetadataUtil.OMI_XMLSELECT
							| MetadataUtil.OMI_TEMPLATE, XMLSelect);

		} catch (MdException e) {
			e.printStackTrace(System.err);
		}

		return Objects;
	}

	private Prototype getRealPrototype(CMetadata proto) {
		CMetadata cm = null;
		try {
			MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
			mdobjectstore.setIsObjectCopiedFromParentOnCreation(false);
			proto = MdObjectFactory.createComplexMetadataObject(mdobjectstore,
					proto);

			cm = MetadataUtil.getMetadataAllDepths(proto,
							new ArrayList(),
							new ArrayList(),
							"<Prototype><Properties/></Prototype><AssociatedObject/><OwningType><PropertyType/></OwningType>",
							0x8018c);
			// store disposed - 3sept2007 - Prachi 
			mdobjectstore.dispose();
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: " + e.getMessage());

		} catch (Exception e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: " + e.getMessage());
		}
		return (Prototype) cm;
	}

	protected int delete_Tables(List tablesToDelete, OpRequestUI oprequestui,
			int iNum) {
		StringBuffer sb = new StringBuffer(200);
		cUtilityClass.WriteLog("Deletion of Table ....\n=============================================\n");
		oprequestui.setMessage("Gather Info...");
		sb.append("<DeleteMetadata><Metadata>");
		for (int i = 0; i < tablesToDelete.size(); i++) {
			String strTemp = (String) tablesToDelete.get(i);
			oprequestui.setMessage("Remaining: " + iNum-- + ": Deleting "
					+ strTemp + "...");
			sb.append("<PhysicalTable id=\"" + strTemp + "\"/>");
			cUtilityClass.WriteLog("            " + i + " Deleted Id "
					+ strTemp);
		}
		sb.append("</Metadata><NS>SAS</NS><Flags>268436480</Flags><Options/></DeleteMetadata>");
		oprequestui.setMessage("Updating Metadata...");
		import_object(sb.toString());
		return iNum;
	}// end of function

	protected int delete_OtherObjects(List objsToDelete,
			OpRequestUI oprequestui, int iNum) {
		StringBuffer sb = new StringBuffer(200);
		oprequestui.setMessage("Gather Info...");
		cUtilityClass
				.WriteLog("Deletion of Other Existing Objects....\n=============================================\n");
		sb.append("<DeleteMetadata><Metadata>");
		String strDelid = "";
		for (int i = 0; i < objsToDelete.size(); i++) {
			strDelid = (String) objsToDelete.get(i);
			oprequestui.setMessage("Remaining: " + iNum--
					+ ": Deleting Object " + strDelid + "...");
			int j = strDelid.indexOf("#");
			int z = strDelid.lastIndexOf("#");
			sb.append("<");
			sb.append(strDelid.substring(j + 1, z));
			String strObtherObj = strDelid.substring(0, j);
			sb.append(" id=\"" + strObtherObj + "\"/>");
			cUtilityClass.WriteLog("            " + i + " Deleted Object's Id "
					+ strObtherObj + " Name: " + strDelid.substring(z + 1));
		}
		sb
				.append("</Metadata><NS>SAS</NS><Flags>268436480</Flags><Options/></DeleteMetadata>");
		oprequestui.setMessage("Updating Metadata...");

		import_object(sb.toString());
		return iNum;
	}

	protected int delete_JobContents(HashMap jobsToUpdate,
			OpRequestUI oprequestui, int iNum) {
		try {
			oprequestui.setMessage("Gather Info...");
			cUtilityClass
					.WriteLog("Deletion of Existing Job Contents....\n=============================================\n");
			String strJobId = "", strJobName = "";
			Object[] arrJobs = jobsToUpdate.keySet().toArray();
			for (int i = 0; i < arrJobs.length; i++) {
				String strJobDetails = (String) jobsToUpdate.get(arrJobs[i]);
				strJobId = strJobDetails.substring(0, strJobDetails
						.indexOf("#"));
				strJobName = strJobDetails
						.substring(strJobDetails.indexOf("#") + 1);
				oprequestui.setMessage("Remaining: " + iNum--
						+ ": Deleting Object " + strJobName + "...");
				MdObjectStore myStore = MdObjectFactory.createObjectStore();
				String strXMLSelect = "<XMLSelect Search=\"@Id='"
						+ strJobId
						+ "'\"/><Templates><Job><JobActivities/></Job></Templates>";
				List lstJobs = (MetadataUtil.getMetadataObjectsSubset(myStore,
						reposid, "Job", MetadataUtil.OMI_TEMPLATE
								| MetadataUtil.OMI_GET_METADATA
								| MetadataUtil.OMI_XMLSELECT, strXMLSelect));
				if (lstJobs.size() <= 0)
					return iNum;
				Job job = (Job) lstJobs.get(0);
				List lstActs = job.getJobActivities();
				for (int iAct = 0; iAct < lstActs.size(); iAct++) {
					CMetadata act = (CMetadata) lstActs.get(iAct);

					StringBuffer sb = new StringBuffer(200);
					sb.append("<DeleteMetadata><Metadata>");
					sb.append("<TransformationActivity id=\"" + act.getId()
							+ "\"/>");
					sb
							.append("</Metadata><NS>SAS</NS><Flags>268436480</Flags><Options/></DeleteMetadata>");
					import_object(sb.toString());
					cUtilityClass.WriteLog("            " + i
							+ " Deleted contents of job " + strJobName);
				}
				myStore.dispose();
			}
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("MdException occurred while deleting job: "
					+ e.getMessage());
		} catch (Exception e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass
					.WriteLog("General Exception occurred while deleting job: "
							+ e.getMessage());
		}
		return iNum;
	}

	protected int delete_Columns(List columnsToDelete, OpRequestUI oprequestui,
			int iNum) {
		oprequestui.setMessage("Gather Info...");
		StringBuffer sb = new StringBuffer(200);
		cUtilityClass
				.WriteLog("Deletion of Columns....\n=============================================\n");
		sb.append("<DeleteMetadata><Metadata>");
		for (int i = 0; i < columnsToDelete.size(); i++) {
			String strDelCol = (String) columnsToDelete.get(i);
			oprequestui.setMessage("Remaining: " + iNum--
					+ ": Deleting Column " + strDelCol + "...");

			sb.append("<Column id=\"" + strDelCol + "\"/>");
			cUtilityClass.WriteLog("            " + i + " Deleted Column's Id "
					+ strDelCol);
		}
		sb
				.append("</Metadata><NS>SAS</NS><Flags>268436480</Flags><Options/></DeleteMetadata>");
		oprequestui.setMessage("Updating Metadata...");
		import_object(sb.toString());
		return iNum;
	}

	protected int import_Cube(List cubesToImport, OpRequestUI oprequestui,
			String olapSchema, int iNum) {
		oprequestui.setMessage("Gather Info...");
		String path = (String) hmMetadataObjects.get("Cubes");
		cUtilityClass.WriteLog("Importing Cubes ....\n=============================================\n");
		String srcCode = "";
		as = m_workspace.makeAppServer(false);
	
		List CubesInMetadata = getObjectsInMetadata("Cube");
		for (int u = 0; u < cubesToImport.size(); u++) {
			String test = (String) cubesToImport.get(u);
			if (test.indexOf("&amp;") != -1) {
				test = cUtilityClass.replaceAnd(test);
			}
			try {
				srcCode = From(path + "\\" + test);
				cUtilityClass.WriteLog("Import of Cube " + test.toUpperCase() + " Started ");
				oprequestui.setMessage("Importing Cube " + test + "...");
				srcCode = cleanCubeString(srcCode, oprequestui, olapSchema);
				if (srcCode == null) {
					return 0;
				}
				oprequestui.setMessage("Remaining: " + iNum--
						+ ": Creating Cube " + test + "...");
				as.submitSrc(srcCode);
				cUtilityClass.WriteLog(test + " Created ");
			} catch (IOException e) {
				a.errorMessage(e.getMessage(), "ERROR In Cube Creation");
				e.printStackTrace(System.err);
				oprequestui.setMessage("Writing Log...");
				cUtilityClass.WriteLog("ERROR: " + test + " In Cube Creation "
						+ e.getMessage());
			} catch (AppServerException e) {
				a.errorMessage(e.getMessage(), "App Server Error");
				e.printStackTrace(System.err);
				oprequestui.setMessage("Writing Log...");
				cUtilityClass.WriteLog("Cube '" + test + "' Failed\n"
						+ as.getLog());
			} catch (Exception e) {
				a.errorMessage(e.getMessage(), "ERROR In Cube Creation");
				e.printStackTrace(System.err);
				oprequestui.setMessage("Writing Log...");
				cUtilityClass.WriteLog("ERROR: " + test + " In Cube Creation "
						+ e.getMessage());
			}
		}
		return iNum;
	}

	/**
	 * This function replaces Values of the following parameters from the
	 * exported cube file UserName, Password, HostName, Port, Repository and
	 * Olap_Schema Server Name
	 */

		public String cleanCubeString(String srcString1, OpRequestUI oprequestui,
			String olapSchema) {
		oprequestui.setMessage("Gather parameters...");

		String libStatements = replaceLibNameStatements(srcString1);

		if (libStatements == null || "".equalsIgnoreCase(libStatements)) {
			return null;
		}

		int procIndex = srcString1.indexOf("PROC OLAP");
		String srcString = replaceLibref(srcString1.substring(procIndex));
		srcString = libStatements + "\n" + srcString;

		String OMRUserid = cUtilityClass.getOMRValue("Username");
		String OMRPassword = cUtilityClass.getOMRValue("Password");
		String OMRHost = cUtilityClass.getOMRValue("Hostname");
		String OMRPort = cUtilityClass.getOMRValue("Port");

		int nCtxStart = srcString.indexOf("olap_schema=") + 13;
		int nCtxEnd = srcString.indexOf("\";", nCtxStart);

		srcString = srcString.substring(0, nCtxStart) + olapSchema
				+ srcString.substring(nCtxEnd);

		int nHostStart = srcString.indexOf("host=") + 6;
		int nHostEnd = srcString.indexOf("\"", nHostStart);

		srcString = srcString.substring(0, nHostStart) + OMRHost
				+ srcString.substring(nHostEnd);

		int nPortStart = srcString.indexOf("port=") + 5;
		int nPortEnd = srcString.indexOf(" ", nPortStart);
		oprequestui.setMessage("Clean String...");
		srcString = srcString.substring(0, nPortStart) + OMRPort
				+ srcString.substring(nPortEnd);
		int nUserIdStart = srcString.indexOf("userid=") + 8;
		int nUserIdEnd = srcString.indexOf("\"", nUserIdStart);
		srcString = srcString.substring(0, nUserIdStart) + OMRUserid
				+ srcString.substring(nUserIdEnd);
		int nPasswdStart = srcString.indexOf("pw=") + 4;
		int nPasswdEnd = srcString.indexOf("\"", nPasswdStart);
		srcString = srcString.substring(0, nPasswdStart) + OMRPassword
				+ srcString.substring(nPasswdEnd);

		int nReposStart = srcString.indexOf("repository=") + 12;
		int nReposEnd = srcString.indexOf("\"", nReposStart);
		srcString = srcString.substring(0, nReposStart) + strReposName
				+ srcString.substring(nReposEnd);

		oprequestui.setMessage("Clean String done...");
		return srcString;
	}

	private String replaceLibNameStatements(String srcString) {
		String retVal1 = "";

		HashMap libStmt = getLibMap(srcString);

		if (libStmt == null) {
			return null;
		}
		Set libraries = libStmt.keySet();
		Object[] libArray = libraries.toArray();
		for (int loop = 0; loop < libraries.size(); loop++) {
			String lib = (String) libArray[loop];

			if (libStmt.containsKey(lib)) {
				String retVal = (String) libStmt.get(lib);
				retVal1 = retVal1 + retVal + "\n";
			}
		}
		return retVal1;
	}

	private HashMap getLibMap(String srcString) {
		int firstIndex;
		int nextIndex;
		int sLibrefIndex;
		int eLibrefIndex;

		hmLibref = new HashMap();
		HashMap hmLibStatement = new HashMap();
		String libName;
		String libref;
		sLibrefIndex = srcString.indexOf("LIBNAME ");

		while (true) {
			if (sLibrefIndex == -1)
				break;
			sLibrefIndex = sLibrefIndex + "LIBNAME ".length();
			eLibrefIndex = srcString.indexOf(" ", sLibrefIndex);
			libref = srcString.substring(sLibrefIndex, eLibrefIndex);

			firstIndex = srcString.indexOf("/*Library: ", sLibrefIndex);
			if (firstIndex == -1) {
				a.errorMessage(
						"Exported Cube is missing the required information",
						"Cube can not be imported");
				return null;
			}
			firstIndex = firstIndex + "/*Library: ".length();
			nextIndex = srcString.indexOf("*/", firstIndex);
			libName = srcString.substring(firstIndex, nextIndex);
			String libnameStmt = getLibNameStatement(libName);
			if (libnameStmt != null) {
				hmLibStatement.put(libName, libnameStmt);
				int metaLibref = libnameStmt.indexOf("LIBNAME ")
						+ "LIBNAME ".length();
				int metaLibref2 = libnameStmt.indexOf(" ", metaLibref);
				String metaLibrefStr = libnameStmt.substring(metaLibref,
						metaLibref2);
				hmLibref.put(libref, metaLibrefStr);
			} else
				return null;
			sLibrefIndex = srcString.indexOf("LIBNAME ", nextIndex);
		}
		return hmLibStatement;
	}

	private String getLibNameStatement(String libName) {
		SASLibrary slibrary = null;
		String libStatement = null;
		String libName1 = cUtilityClass.MoreResolveTexttoHash(libName);
		MdObjectStore myStore = MdObjectFactory.createObjectStore();
		String sOptions = "<XMLSelect Search=\"@Name='"
				+ libName1
				+ "'\"/>"
				+ "<Templates><SASLibrary><UsingPackages/></SASLibrary><Directory Id=\"\" Name=\"\" DirectoryName=\"\"/></Templates>";
		try {
			List libraries = MetadataUtil.getMetadataObjectsSubset(myStore,
					reposid, "SASLibrary", MetadataUtil.OMI_XMLSELECT
							| MetadataUtil.OMI_TEMPLATE | MetadataUtil.OMI_ALL
							| MetadataUtil.OMI_ALL_SIMPLE, sOptions);

			if (libraries.size() <= 0) {
				a.error("Library '" + libName
						+ "' Not present in the environment");
				return null;
			}
			slibrary = (SASLibrary) libraries.get(0);
			if (slibrary.getIsPreassigned() == 0) {
				boolean flag1 = Workspace.getWorkspace().getAppDefaultsFile()
						.getPropertyBoolean("Workspace.EncodePasswords", true);

				libStatement = MdModelUtil.accessPath(slibrary, flag1); // Generates
				// LIBNAME statement for SASLibrary
			} else {
				AssociationList pkgList = slibrary.getUsingPackages();
				Directory libDir = (Directory) pkgList.get(0);
    			libStatement = "LIBNAME " + slibrary.getLibref() + " \""
						+ libDir.getDirectoryName() + "\";";
			}

			return libStatement;
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		} catch (Exception e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		}
		myStore.dispose();
		return null;
	}

	private String replaceLibref(String srcString) {
		Set librefs = hmLibref.keySet();
		Object[] librefArray = librefs.toArray();
		StringBuffer sb = new StringBuffer(srcString);
		for (int i = 0; i < librefArray.length; i++) {
			String libref = (String) librefArray[i];
			if (hmLibref.containsKey(libref)) {
				String retVal = (String) hmLibref.get(libref);
				String aa = libref + ".";
				String bb = retVal + ".";
				int iAA = srcString.indexOf(aa);
				int search = 0;
				if (iAA != -1) {
					while (search != -1) {
						sb.replace(iAA, iAA + aa.length(), bb);
						iAA = srcString.indexOf(aa, iAA + 1);
						search = iAA;
					}
				}
			}
		}
		return sb.toString();
	}

	public int import_Prototypes(List PrototypesToImport,
			OpRequestUI oprequestui, int iNum) {
		getTree(reposid); // received trees
		String path = (String) hmMetadataObjects.get("Prototypes");
		cUtilityClass
		.WriteLog("Importing Prototypes....\n=============================================\n");
		String ProcString = "";

		for (int u = 0; u < PrototypesToImport.size(); u++) {
			String test = (String) PrototypesToImport.get(u);
			cUtilityClass.WriteLog("Import of Prototype " + test.toUpperCase() + " Started ");
			
			if (test.indexOf("&amp;") != -1) {
				test = cUtilityClass.replaceAnd(test);
			}
			oprequestui.setMessage("Remaining: " + iNum-- + ": importing "
					+ test);
			try {
				ProcString = From(path + "\\" + test);
				if (ProcString.indexOf("_ReposID_") == -1) {
					a.error("The format of the export file for Prototype '"
							+ test.substring(0, test.lastIndexOf(".xml"))
							+ "' is not supported");
					return iNum;
				}
				String ProtoTypepath = path + "\\" + test;

				ProcString = ProcessTableString(ProtoTypepath, test);

				ProcString = ProcString.replaceAll("_ReposID_", reposid);
				ProcString = ProcString.substring(ProcString
						.indexOf("<AddMetadata>"));
				import_object(ProcString, test);
			} catch (IOException e) {
				e.printStackTrace(System.err);
			}
			hmXmlIdMetaId.clear();
		}
		return iNum;
	}// end of import prototype
	public int import_ExternalTables(List ExternalTablesToImport,
			OpRequestUI oprequestui, int iNum) {
		String path = (String) hmMetadataObjects.get("ExternalTables");
		cUtilityClass
				.WriteLog("Importing ExternalTables....\n=============================================\n");
		getTree(reposid);
		String ProcString = "";
		for (int u = 0; u < ExternalTablesToImport.size(); u++) {
			String test = (String) ExternalTablesToImport.get(u);
			cUtilityClass.WriteLog("Import of ExternalTable " + test.toUpperCase() + " Started ");
			
			if (test.indexOf("&amp;") != -1) {
				test = cUtilityClass.replaceAnd(test);
			}
			oprequestui.setMessage("Remaining: " + iNum-- + ": importing "
					+ test);
			try {
				ProcString = From(path + "\\" + test);

				if (ProcString.indexOf("_ReposID_") == -1) {
					a.error("The format of the export file for Prototype '"
							+ test.substring(0, test.lastIndexOf(".xml"))
							+ "' is not supported");
					return iNum;
				}
				ProcString = ProcString.replaceAll("_ReposID_", reposid);

				int startParentObjRef = ProcString.indexOf("<Tree ObjRef=\"$");
				if (startParentObjRef != -1) {
					startParentObjRef += 15;
					int endParentObjRef = ProcString.indexOf("\"",
							startParentObjRef);
					String parentTreeName = ProcString.substring(
							startParentObjRef, endParentObjRef);
					parentTreeName = cUtilityClass.changeReferenceTo(parentTreeName);
					// parentTreeName=cUtilityClass.resolveName(parentTreeName);
					if (hmTreeInfo.containsKey(parentTreeName.toLowerCase())) {
						String parentTreeID = getTreeID(parentTreeName
								.toLowerCase());
						ProcString = ProcString.substring(0,
								startParentObjRef - 1)
								+ parentTreeID
								+ ProcString.substring(endParentObjRef);
					} else {
						a.error("While importing Table " + test
								+ " \nRequired Tree \" " + parentTreeName
								+ " \" is not present in the environment");
					}
				}

				ProcString = ProcString.substring(ProcString
						.indexOf("<AddMetadata>"));
				String contextFQ = sc.getFQID(); //sc == server context -- derived from application server
				int contextStart = ProcString.indexOf("$SASMain$");
				int contextEnd = contextStart + "$SASMain$".length();
				ProcString = ProcString.substring(0, contextStart) + contextFQ
						+ ProcString.substring(contextEnd);
				import_object(ProcString, test);
			} catch (IOException e) {
				e.printStackTrace(System.err);
				a.error(e.getMessage());
			} catch (Exception e) {
				e.printStackTrace(System.err);
				a.error(e.getMessage());
			}

		}
		return iNum;
	}// end of import prototype

	public int import_Map(List MapsToImport, OpRequestUI oprequestui, int iNum) {
		String path = (String) hmMetadataObjects.get("InfoMaps");
		cUtilityClass.WriteLog("Importing InfoMaps....\n=============================================\n");
		String ProcString = "";
		getLibs(reposid);
		if (cleanString.getMapTreeID(reposid, "Map"))
		{
			for (int u = 0; u < MapsToImport.size(); u++) {
				String test = (String) MapsToImport.get(u);
				cUtilityClass.WriteLog("Import of InfoMap " + test.toUpperCase() + " Started ");
				
				if (test.indexOf("&amp;") != -1) {
					test = cUtilityClass.replaceAnd(test);
				}
				oprequestui.setMessage("Remaining: " + iNum-- + ": importing "+ test);
				try {					
					ProcString = From(path + "\\" + test);
					if (ProcString.indexOf("_ReposID_") == -1) {
						a.error("The format of the export file for Information Map '"
										+ test.substring(0, test
												.lastIndexOf(".xml"))
										+ "' is not supported");
						return iNum;
					}

					Document doc = returnDocument(path + "\\" + test);

					doc = processInfoMapCubes(doc);
					doc = processInfoMapTables(doc);
					doc.normalize();
					ProcString = processInfoMapSchema(getStringFromDocument(doc));

					if (ProcString != null) {
						ProcString = ProcString.replaceAll("_ReposID_", reposid);
						ProcString = cleanString.cleanMapString(ProcString,
								reposid, "Map");
						ProcString = cleanTreeDescString(ProcString);
						ProcString = ProcString.substring(ProcString
								.indexOf("<AddMetadata>"));
						
						import_object(ProcString, test);
					}
				} catch (IOException e) {
					e.printStackTrace(System.err);
				}
			}
		} else {
			a.error("Information Map Studio not installed or Content server is not Configured");
			cUtilityClass.WriteLog("Failed to import Info Maps becuase Information Map Studio not installed or Content server is not Configured");
		}
		return iNum;
	}// end of import Maps

	private String processInfoMapSchema(String ProcString) {

		int iSASLibStartZero = 0;
		int iSASSchemaEnd = 0;
		int cnt = 9999;
		iSASLibStartZero = ProcString
				.indexOf("&lt;ReposSASLibrary prid=&quot;");
		while (iSASLibStartZero != -1) {
			iSASLibStartZero = ProcString.indexOf(
					"&lt;ReposSASLibrary prid=&quot;", iSASSchemaEnd)
					+ "&lt;ReposSASLibrary prid=&quot;".length();
			iSASSchemaEnd = iSASLibStartZero + 1;
			int iSASLibStart = ProcString.indexOf("label=&quot;",
					iSASLibStartZero)
					+ "label=&quot;".length();
			int iSASLibEnd = ProcString.indexOf("&quot; desc=&quot;",
					iSASLibStart);

			String MapLibname = ProcString.substring(iSASLibStart, iSASLibEnd);
			String engineType = getLibEngine(MapLibname);

			if ("S".equalsIgnoreCase(engineType)) {
				int iSASSchemaStartZero = ProcString.indexOf(
						"&lt;ReposDatabaseSchema prid=&quot;", iSASLibEnd);
				if (iSASSchemaStartZero != -1) { // From NON SAS to SAS
					// Open the SAS library tag
					int endToDeleteIndex = ProcString
							.indexOf("omrType=&quot;SASLibrary&quot;/&gt;")
							+ "omrType=&quot;SASLibrary&quot;".length();
					ProcString = ProcString.substring(0, endToDeleteIndex)
							+ ProcString.substring(endToDeleteIndex + 1);

					// Remove the database schema tag
					endToDeleteIndex = ProcString
							.indexOf("omrType=&quot;DatabaseSchema&quot;&gt;")
							+ "omrType=&quot;DatabaseSchema&quot;&gt;".length();
					ProcString = ProcString.substring(0,
							iSASSchemaStartZero - 1)
							+ ProcString.substring(endToDeleteIndex);

					// Replace the end of database schema tag with end og
					// library tag
					int schemaEndTagindex = ProcString
							.indexOf("&lt;/ReposDatabaseSchema&gt;",
									iSASSchemaStartZero);
					String strFirstPart = ProcString.substring(0,
							schemaEndTagindex);
					String strSecondPart = ProcString
							.substring(schemaEndTagindex
									+ "&lt;/ReposDatabaseSchema&gt;".length());
					ProcString = strFirstPart + "&lt;/ReposSASLibrary&gt;"
							+ strSecondPart;
				}
			} else {
				int iSASSchemaStartZero = ProcString.indexOf(
						"&lt;ReposDatabaseSchema prid=&quot;", iSASLibEnd);
				String MapSchemaname = getSchemaName(MapLibname);
				if (iSASSchemaStartZero != -1) {
					int iSASSchemaStart = ProcString.indexOf("label=&quot;",
							iSASSchemaStartZero)
							+ "label=&quot;".length();
					iSASSchemaEnd = ProcString.indexOf("&quot; desc=&quot;",
							iSASSchemaStart);
					ProcString = ProcString.substring(0, iSASSchemaStart)
							+ MapSchemaname
							+ ProcString.substring(iSASSchemaEnd);
				} else // From SAS to NON SAS
				{
					// Close the SAS library tag
					int endToAddIndex = ProcString
							.indexOf("omrType=&quot;SASLibrary&quot;&gt;")
							+ "omrType=&quot;SASLibrary&quot;".length();
					ProcString = ProcString.substring(0, endToAddIndex) + "/"
							+ ProcString.substring(endToAddIndex);

					// Create a database schema TAG
					String create = "&lt;ReposDatabaseSchema prid=&quot;XR"
							+ cnt--
							+ "&quot; label=&quot;"
							+ MapSchemaname
							+ "&quot; desc=&quot;&quot; omrType=&quot;DatabaseSchema&quot;&gt;";

					int nextIndex = ProcString.indexOf(
							"omrType=&quot;SASLibrary&quot;/&gt;",
							iSASLibStartZero);
					ProcString = ProcString.substring(0, nextIndex) + create
							+ ProcString.substring(nextIndex);

					// Replace the end of library schema tag with end of
					// database tag
					int libEndTagindex = ProcString.indexOf(
							"&lt;/ReposSASLibrary&gt;", iSASSchemaStartZero);
					String strFirstPart = ProcString.substring(0,
							libEndTagindex);
					String strSecondPart = ProcString.substring(libEndTagindex
							+ "&lt;/ReposSASLibrary&gt;".length());
					ProcString = strFirstPart + "&lt;/ReposDatabaseSchema&gt;"
							+ strSecondPart;
				}
			}
			iSASLibStartZero = ProcString.indexOf(
					"&lt;ReposSASLibrary prid=&quot;", iSASSchemaEnd);
		}
		return ProcString;
	}

	private Document returnDocument(String filePath) {
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder;
		Document doc = null;
		try {
			docBuilder = docBuilderFactory.newDocumentBuilder();
			doc = docBuilder.parse(new File(filePath));
		} catch (ParserConfigurationException e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
		} catch (SAXException e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
		} catch (IOException e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
		} catch (Exception e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
		}
		return doc;
	}

	private Document processInfoMapCubes(Document doc) {

		try {
			List delCubeCollection = new Vector();
			Node nCube = null;
			Node nCubeName = null;
			Node nCubeId = null;
			HashMap hmCubeNameID = new HashMap();

			NodeList nlCube = doc.getElementsByTagName("Cube");
			if (nlCube.getLength() == 0) {
				// a.b(" Size of Cube: "+nlCube.getLength());
				return doc;
			}

			for (int iLib = 0; iLib < nlCube.getLength(); iLib++) {
				nCube = nlCube.item(iLib);
				if (nCube.getNodeType() == Node.ELEMENT_NODE
						&& checkNodeType(nCube)) {

					if (nCube.hasAttributes()) {
						NamedNodeMap nnmAttr = nCube.getAttributes();
						nCubeName = nnmAttr.getNamedItem("Name");
						nCubeId = nnmAttr.getNamedItem("Id");
						String sLibId = nCubeId.getNodeValue().toLowerCase();
						String sLibName = nCubeName.getNodeValue()
								.toLowerCase();
						hmCubeNameID.put(sLibId.trim(), sLibName.trim());
						delCubeCollection.add(nCube);
					}
				}
			}
			doc.normalize();
			doc = replaceMapObjRefValues(doc, hmCubeNameID, "Cube");
			removeNodes(delCubeCollection);
			doc.normalize();
		} catch (Exception e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
		}
		return doc;
	}

	private Document processInfoMapTables(Document doc) {
		Node nPT = null;
		Node nPTName = null;
		Node nPTId = null;
		HashMap hmPTNameID = new HashMap();
		List delCollection = new Vector();
		NodeList nlPT = doc.getElementsByTagName("PhysicalTable");
		if (nlPT.getLength() == 0)
			return doc;
		for (int iPT = 0; iPT < nlPT.getLength(); iPT++) {
			nPT = nlPT.item(iPT);
			if (nPT.getNodeType() == Node.ELEMENT_NODE && checkNodeType(nPT)) {
				if (nPT.hasAttributes()) {
					NamedNodeMap nnmAttr = nPT.getAttributes();
					nPTName = nnmAttr.getNamedItem("Name");
					nPTId = nnmAttr.getNamedItem("Id");
					String sPTId = nPTId.getNodeValue().toLowerCase();
					String sPTName = nPTName.getNodeValue().toLowerCase();
					hmPTNameID.put(sPTId.trim(), sPTName.trim());
					delCollection.add(nPT);
				}
			}
		}

		doc = replaceMapObjRefValues(doc, hmPTNameID, "PhysicalTable");
		removeNodes(delCollection);
		doc.normalize();
		String s3 = getStringFromDocument(doc);
		return doc;
	}

	private Document replaceMapObjRefValues(Document doc, HashMap hmPTNameID,
			String type) {
		NodeList nlToRemove = doc.getElementsByTagName(type);
		for (int l = 0; l < nlToRemove.getLength(); l++) {
			Node nm = nlToRemove.item(l);
			if (nm.hasAttributes() && !checkNodeType(nm)) {
				NamedNodeMap nAtt = nm.getAttributes();
				Node ne = nAtt.getNamedItem("ObjRef");
				String value = ne.getNodeValue().toLowerCase().trim();
				String ObjName = (String) hmPTNameID.get(value);

				String XMLSelect = "<XMLSelect Search=\"@Name='" + ObjName
						+ "'\"/>";
				List lPTs = new Vector();
				try {
					lPTs = MetadataUtil.getMetadataObjects(reposid, type,
							MetadataUtil.OMI_XMLSELECT, XMLSelect);
				} catch (MdException e) {
					e.printStackTrace(System.err);
				}
				if (lPTs.size() == 0) {
					a.error(type + "'" + ObjName
							+ "' is not present in the enviornment\n"
							+ "This is required to import the Map");
					return null;
				}
				CMetadata cm = (CMetadata) lPTs.get(0);
				ne.setNodeValue(cm.getFQID());
			}
		}
		return doc;
	}

	//refered never
	public int import_Portlets(List PortletsToImport, OpRequestUI oprequestui,
			int iNum) {
		// to add code for importing Portlet
		return iNum;
	}// end of import Portlets

	public int import_Process(List ProcessessToImport, OpRequestUI oprequestui,
			int iNum) {
		String path = (String) hmMetadataObjects.get("StoredProcesses");
		cUtilityClass.WriteLog("Importing Stored Processes....\n=============================================\n");
		String ProcString = "";
		sc = as.getServerContext();
		String contextFQ = sc.getFQID(); //sc == server context -- derived from application server
		String strName = sc.getName();  
		for (int u = 0; u < ProcessessToImport.size(); u++) {
			String test = (String) ProcessessToImport.get(u);
			cUtilityClass.WriteLog("Import of StoredProcess " + test.toUpperCase() + " Started ");
			
			if (test.indexOf("&amp;") != -1) {
				test = cUtilityClass.replaceAnd(test);
			}
			oprequestui.setMessage("Remaining: " + iNum-- + ": importing "
					+ test);
			try {
				ProcString = From(path + "\\" + test);
				if (ProcString.indexOf("_ReposID_") == -1) {
					a
							.error("The format of the export file for Stored Process '"
									+ test.substring(0, test
											.lastIndexOf(".xml"))
									+ "' is not supported");
					return iNum;
				}
				ProcString = ProcString.replaceAll("_ReposID_", reposid);
				/**
				 * Function call to check whether the Directory object is
				 * present in the Environment If Directory object is present
				 * then Deletes the Directory Tag and its Associated TAG from
				 * the XML file
				 */
				ProcString = cleanString.cleanProcessDirectory(path + "\\"
						+ test, reposid, oprequestui, contextFQ);
				/**
				 * Function call to check whether the Tree is present in the
				 * environment If the same tree object is present then attach
				 * this tree object to the stored process TAG else create the
				 * lower most tree and check for second level Tree object in
				 * Metadata server Method scans chain of tree object up to the
				 * top Node Accordingly it creates the tree of replace the tree
				 */
				ProcString = cleanString.cleanProcessString(ProcString, reposid);
				/**
				 * Function call to check whether the logical stored process
				 * server is present or not if it is present then it attaches
				 * with ClassifierMap else prompt that the server is not present
				 */
				ProcString = cleanString.cleanOtherThings(ProcString, reposid,
						strName, test);
				if (ProcString != null) {
					ProcString = ProcString.substring(ProcString
							.indexOf("<AddMetadata>"));
					import_object(ProcString, test);
				} else {
					cUtilityClass.WriteLog("Failed to import stored process '"
							+ test + "'\n");
				}
			} catch (IOException e) {
				e.printStackTrace(System.err);
			}
		}
		return iNum;
	}// end of import prototype

	private String cleanTreeDescString(String ProcString) {
		int DelstartTag = ProcString.indexOf("<Tree Desc=\"");
		if (DelstartTag != -1) {
			int DelendTag = ProcString.indexOf("</Tree>", DelstartTag)
					+ "</Tree>".length();
			ProcString = ProcString.substring(0, DelstartTag)
					+ ProcString.substring(DelendTag);
		}
		return ProcString;
	}

	public int import_Models(List ModelsToImport, OpRequestUI oprequestui,
			int iNum) {
		String path = (String) hmMetadataObjects.get("MiningModels");
		cUtilityClass.WriteLog("Importing Mining Models....\n=============================================\n");
		String ProcString = "";
		modelString prepareString = null;
		for (int u = 0; u < ModelsToImport.size(); u++) {

			prepareString = new modelString(reposid);
						
			String test = (String) ModelsToImport.get(u);
			cUtilityClass.WriteLog("Import of Mining Model " + test.toUpperCase() + " Started ");
			
			if (test.indexOf("&amp;") != -1) {
				test = cUtilityClass.replaceAnd(test);
			}
			oprequestui.setMessage("Remaining: " + iNum-- + ": importing "
					+ test);
			ProcString = prepareString.cleanModelString(path + "\\" + test,
					test, reposid, oprequestui);
			
					ProcString = ProcString.replaceAll("_ReposID_", reposid);
			ProcString = cleanTreeDescString(ProcString);
			ProcString = ProcString.substring(ProcString
					.indexOf("<AddMetadata>"));
	
			import_object(ProcString, test);
			prepareString.cleanUp();
		}
		return iNum;
	}// end of import Model

	public int import_Jobs(List jobsToImport, HashMap jobsToUpdate,
			OpRequestUI oprequestui, int iNum) {
		oprequestui.setMessage("Gather info about Metadata...");
		cUtilityClass.WriteLog("Importing Jobs....\n=============================================\n");
//		cleanMaps();
		getTree(reposid); // received trees
		getLibs(reposid); // received libraries
		getSchema(reposid);
		// created map hmSchemaInfo (databaseschema name,Id) and hmSchemaMetaInfo(databaseschema name,object)
		 
		String path = (String) hmMetadataObjects.get("Jobs"); // path to xml file 
		String ProcString = "";
		String sLibname = "";
		String LibId = "";
		
		for (int u = 0; u < jobsToImport.size(); u++)
		{
		//	cUtilityClass.WriteLog("Iteration no" + u);
			
			//Old logic of Job import		
			//JobInitTree = "NOTREE";
			String sJobName = (String) jobsToImport.get(u); // get job from the selcted jobs list
			cUtilityClass.WriteLog("Import of Job " + sJobName.toUpperCase() + " Started ");
			oprequestui.setMessage("Importing Job " + sJobName);
			try {
				   String newStr = path + "\\" + sJobName; // get the Job xml from solutionn folder
                    // replace &				
				   if (newStr.indexOf("&amp;") != -1) {
					newStr = cUtilityClass.replaceAnd(newStr);
				}				   
                    //From is a function which reads File (Supplied as parameter)
					// and returns a String sb == contents of the entire file. 
				ProcString = From(newStr);

				//check for repository id
				if (ProcString.indexOf("_ReposID_") == -1) 
				{
					a.error("The format of the export file for Job '"
							+ sJobName.substring(0, sJobName.lastIndexOf(".xml"))
							+ "' is not supported");
					return iNum;
				}
				
				// check if the job is to be Updated
				boolean bUpdate = false;
				if (jobsToUpdate.containsKey(sJobName))
					bUpdate = true;
				
				ProcString = ProcessString(newStr, sJobName, oprequestui, bUpdate);

				int nStart = ProcString.indexOf("<AddMetadata>");
				if (nStart != -1) {
					ProcString = ProcString.substring(nStart);
				}			
				ProcString = ProcString.replaceAll("_ReposID_", reposid);
			
				//Commnet this Start For job Note
				//Old logic of Job import
				/*oprequestui.setMessage("Replacing Custom Tree Chain");
				if (!"NOTREE".equalsIgnoreCase(JobInitTree))
				{
					String MetaTreeId = (String) hmXmlIdMetaId.get(JobInitTree
							.toLowerCase().trim());
					if (MetaTreeId.length() < 17) 
					{
						String strReqTree = (String) hmTreeIdName
								.get(JobInitTree);
						a.error("Tree not found: " + strReqTree
								+ "\nCannot import job: " + sJobName);
						cUtilityClass.WriteLog("Tree not found: " + strReqTree
								+ "\nCannot import job: " + sJobName);
						continue;
					}
					int iTree = ProcString.indexOf("<Trees/>");
					if (iTree != -1)
						ProcString = ProcString.substring(0, iTree)
								+ "<Trees><Tree ObjRef=\"" + MetaTreeId
								+ "\"/></Trees>"
								+ ProcString.substring(iTree + 8);
				}*/
				//Commnet this End For job Note
				
				oprequestui.setMessage("Prepared for Import");
				oprequestui.setMessage("Remaining " + iNum-- + ": Writing Job "
						+ sJobName + "...");
				Document outDoc = import_object(ProcString, sJobName);
				
				UpdateColumnSequence(outDoc);

			} catch (IOException e) {
				a.error(e.getMessage());
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("IO ERROR in import_jobs: "
						+ e.getMessage());
			} catch (Exception e) {
				a.error(e.getMessage());
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("General ERROR in import_jobs: "
						+ e.getMessage());
			}
			 cleanMaps();
		}
		return iNum;
	}// end of import Jobs

	// Function to correct the column sequence
	public void UpdateColumnSequence(Document outDoc) {
		try {
		
			HashMap hmColumnOrder = new HashMap();
			NodeList nlColumns = outDoc.getElementsByTagName("Column");
			if (nlColumns == null)
				return;

			// Get all column tags
			for (int iNode = 0; iNode < nlColumns.getLength(); iNode++) {
				Node nColumn = nlColumns.item(iNode);
				if (nColumn == null)
					continue;
				// Filter column tags to keep object reference tags
				if (!checkNodeType(nColumn)) {
					// Get the association tag
					Node nAssoc = nColumn.getParentNode();
					if (nAssoc == null)
						continue;
					// Get the parent object tag
					Node nParent = nAssoc.getParentNode();
					if (nParent == null)
						continue;
					if (!nParent.hasAttributes())
						continue;
					// Prepare key to add entry in hashmap
					
					String strKey = nParent.getNodeName();
					
					strKey += "|$|";
					NamedNodeMap nAtt = nParent.getAttributes();
					if (nAtt == null)
						continue;
					Node nParentId = nAtt.getNamedItem("Id");
					if (nParentId == null)
						continue;
					
					strKey += nParentId.getNodeValue();
					strKey += "|$|";
					strKey += nAssoc.getNodeName();
					// Check if key exists
					
					if (!hmColumnOrder.containsKey(strKey)){
						// Add new parent object in the hashmap
						Vector vColumns = new Vector();
						vColumns.addElement(nColumn.toString());
						hmColumnOrder.put(strKey, vColumns);
						
					} else {
						// Add column in the existing parent object
						Vector vColumns = (Vector) hmColumnOrder.get(strKey);
						
						if (vColumns != null)
							vColumns.addElement(nColumn.toString());
					}
				}
			}

			// Prepare OMI commands to update the sequence
			Object[] arrParents = hmColumnOrder.keySet().toArray();
			if (arrParents == null)
				return;

			for (int iParent = 0; iParent < arrParents.length; iParent++) {
				String strKey = (String) arrParents[iParent];
				String[] arrKey = Strings.split(strKey, "", "|$|", "");
				if (arrKey.length < 3)
					continue;
				String strInputXML = "<UpdateMetadata><Metadata><";
				strInputXML += arrKey[0];
				strInputXML += " Id=\"";
				strInputXML += arrKey[1];
				strInputXML += "\"><";
				strInputXML += arrKey[2];
				strInputXML += " Function=\"Replace\">";
				Vector vColumns = (Vector) hmColumnOrder.get(strKey);
				if (vColumns == null)
					continue;
				// Skip those objects where only one column is associated (No
				// need to change the sequence)
				if (vColumns.size() < 2)
					continue;
				for (int iCol = 0; iCol < vColumns.size(); iCol++) {
					String strColTag = (String) vColumns.get(iCol);
					strInputXML += strColTag;
				}
				strInputXML += "</";
				strInputXML += arrKey[2];
				strInputXML += "></";
				strInputXML += arrKey[0];
				strInputXML += "></Metadata><NS>SAS</NS><Flags>268435456</Flags><Options/></UpdateMetadata>";
				// Fire prepared command
				import_object(strInputXML);
			}
		} catch (Exception e) {
			e.printStackTrace(System.err);
			cUtilityClass
					.WriteLog("Error occurred while updating column sequence: "
							+ e.getMessage());
		}
	}
	
	private List getObjectsInMetadata(String ObjType) {
		List x = getInfoObjects(ObjType, reposid);
		List y = new Vector();
		for (int i = 0; i < x.size(); i++) 
		{
			CMetadata j = (CMetadata) x.get(i);
			y.add(j.getName());
		}
		return y;
	}
	
      protected void cleanMaps() {

		hmXmlTableLibMapInfo.clear();
	    hmXmlTableInfo.clear();
		hmXmlLibInfo.clear();

		hmXmlAllColInfo.clear();
		hmXmlAllTableInfo.clear();
		hmXmlIdMetaId.clear();
		hmTreeIdName.clear();
		hmTreeIdParId.clear();
	}

	/**
	 * Function return importable job String
	 */
	public String ProcessString(String filePath, String jobName,
			OpRequestUI oprequestui, boolean bUpdate)
	{

		//Defines a factory API that enables applications to obtain a parser 
		//that produces DOM object trees from XML documents
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		
		//DocumentBuilder is used obtain a Document from XML.
		DocumentBuilder docBuilder;

		Document doc = null;
		oprequestui.setMessage("Parsing xml file...");

		try {
			docBuilder = docBuilderFactory.newDocumentBuilder();
			//create a documnet 
			doc = docBuilder.parse(new File(filePath));
			oprequestui.setMessage("Collecting info from file...");
			
			// creates nodelist from document contents having tagName Job
			NodeList nlJob = doc.getElementsByTagName("Job");

			// Following if construct is for checking whether the job has
			// calling called relationship 
			// If that relation persist then We need to clean complete xml file
			// cUtilityJob.returnCleanJob function return a clean document
			// object which can be further processed as a normal job import
			// cUtilityJob.checkJob(nlJob) function checks for presence of job
			// tags in xml file
			// if there are more than one job tag, It means it has calling and
			// called job relationship
			
			if (cUtilityJob.checkJob(nlJob)) {
				doc = cUtilityJob.returnCleanJob(doc, jobName, reposid);
				nlJob = doc.getElementsByTagName("Job");
			}

			NodeList nlPhysicalTable = doc.getElementsByTagName("PhysicalTable");
			NodeList nlColumn = doc.getElementsByTagName("Column");
			NodeList nlSASLibrary = doc.getElementsByTagName("SASLibrary");
			NodeList nlDatabaseSchema = doc.getElementsByTagName("DatabaseSchema");
			NodeList nlTree = doc.getElementsByTagName("Tree");
			NodeList nlGroup = doc.getElementsByTagName("Group");
			NodeList nlContext = doc.getElementsByTagName("ServerContext");
			NodeList nlComponent = doc.getElementsByTagName("SoftwareComponent");
			NodeList nlUniqueKey = doc.getElementsByTagName("UniqueKey");
			NodeList nlFile = doc.getElementsByTagName("File");
			NodeList nlExternalTable = doc.getElementsByTagName("ExternalTable");
			NodeList nlForeignKey = doc.getElementsByTagName("ForeignKey");
			NodeList nlMiningResult = doc.getElementsByTagName("MiningResult");
			NodeList nlKeys = doc.getElementsByTagName("Key");
			NodeList nlPropertySets = doc.getElementsByTagName("PropertySet");
			NodeList nlProperty = doc.getElementsByTagName("Property");
			NodeList nlPropertyType = doc.getElementsByTagName("PropertyType");

			//To support job notes grouping
			ProcessXMLTree(nlTree, lstNodeDel);
			processTreeNode(nlTree);
			
			oprequestui.setMessage("Processing Dependent Libraries...");
			ProcessLibrary(nlSASLibrary, lstNodeDel);
			oprequestui.setMessage("Processing Dependent Schemas...");
			ProcessSchema(nlDatabaseSchema, lstNodeDel);
			oprequestui.setMessage("Processing Dependent Ext Tables...");
			ProcessExternalTable(nlExternalTable, nlFile, lstNodeDel);
			oprequestui.setMessage("Processing Dependent Mining Models...");
			ProcessModel(nlMiningResult, lstNodeDel);
			oprequestui.setMessage("Processing Dependent PhysicalTables...");
			ProcessTables(nlPhysicalTable, lstNodeDel);
           	oprequestui.setMessage("Processing Dependent Columns...");
			ProcessColumns(nlColumn, nlPhysicalTable, nlSASLibrary, lstNodeDel);
			oprequestui.setMessage("Processing Job...");
			ProcessJob(nlJob, bUpdate);
			FillNodesInHashMap(nlPropertySets);
			FillNodesInHashMap(nlProperty);
			FillNodesInHashMap(nlPropertyType);

			oprequestui.setMessage("Collection for Deletion...");
			
			//For job Note
			CollectOtherDeltree(nlTree, lstNodeDel);
			
			//CollectOtherDel(nlTree, lstNodeDel);
			CollectOtherDel(nlContext, lstNodeDel);
			CollectOtherDel(nlGroup, lstNodeDel);
			CollectOtherDel(nlComponent, lstNodeDel);
			CollectOtherDel(nlUniqueKey, lstNodeDel);
			CollectOtherDel(nlForeignKey, lstNodeDel);
		
			
			//Commnet this start For job Note
			//Old logic of Job import
		/*	oprequestui.setMessage("Replacing Custom Tree...");
	
			if (nlTree.getLength() != 0)
			{
				if (!"NOTREE".equalsIgnoreCase(JobInitTree)) {
					ProcessXMLTree(nlTree, lstNodeDel);
					String s = getJobTree(JobInitTree).toLowerCase();
					String s1 = getTreeID(s).trim();
					hmXmlIdMetaId.put(JobInitTree.toLowerCase().trim(), s1);
				}
			}*/
			//Commnet this End For job Note
						
			oprequestui.setMessage("Query Metadata...");
			fetchMetadataInfo(jobName, oprequestui);
			ProcessKeys(nlKeys, lstNodeDel);
			oprequestui.setMessage("Deleting unused objects...");
			removeNodes(lstNodeDel);
			lstNodeDel.clear();
			oprequestui.setMessage("Normalize XML...");
			doc.normalize();

			if (bUpdate) {
				if ((nlJob != null) && (nlJob.getLength() > 0)) {
					oprequestui.setMessage("Replacing Job IDs...");
					replaceObjRefValues(nlJob);
				}
			}

			if ((nlPhysicalTable != null) && (nlPhysicalTable.getLength() > 0)) {
				oprequestui.setMessage("Replacing Physical Table IDs...");
				replaceObjRefValues(nlPhysicalTable);
			}

			if ((nlExternalTable != null) && (nlExternalTable.getLength() > 0))
			{
				oprequestui.setMessage("Replacing External Table IDs...");
				replaceObjRefValues(nlExternalTable);
			}

			if ((nlMiningResult != null) && (nlMiningResult.getLength() > 0)) {
				oprequestui.setMessage("Replacing Mining Result IDs...");
				replaceObjRefValues(nlMiningResult);
			}
	
			if ((nlColumn != null) && (nlColumn.getLength() > 0)) {
				oprequestui.setMessage("Replacing Columns IDs...");
				replaceObjRefValues(nlColumn);				
			}

			if ((nlTree != null) && (nlTree.getLength() > 0)) {
				oprequestui.setMessage("Replacing Custom Tree IDs...");
				replaceObjRefValues(nlTree);
			}

			if ((nlSASLibrary != null) && (nlSASLibrary.getLength() > 0)) {
				oprequestui.setMessage("Replacing SASLibraries IDs...");
				replaceObjRefValues(nlSASLibrary);
			}

			if ((nlDatabaseSchema != null)
					&& (nlDatabaseSchema.getLength() > 0)) {
				oprequestui.setMessage("Replacing Database Schema IDs...");
				replaceObjRefValues(nlDatabaseSchema);
			}

			oprequestui.setMessage("Normalize xml");
						
		} catch (SAXParseException err) {
			a.error(err.toString());
			cUtilityClass.WriteLog("SAX Parse ERROR in ProcessString: "
					+ err.getMessage());
			err.printStackTrace(System.err);
		} catch (SAXException e) {
			a.error(e.toString());
			cUtilityClass.WriteLog("SAX ERROR in ProcessString: "
					+ e.getMessage());
			e.printStackTrace(System.err);
		} catch (Exception t) {
			a.error(t.toString());
			cUtilityClass.WriteLog("General ERROR in ProcessString: "
					+ t.getMessage());
			t.printStackTrace(System.err);
		}
		doc.normalize();
	
		return getStringFromDocument(doc);
	}

	private void replaceObjRefValues(NodeList nlToRemove) 
	{
		for (int l = 0; l < nlToRemove.getLength(); l++) {
			Node nm = nlToRemove.item(l);
			if (nm.hasAttributes() && !checkNodeType(nm))
			{
				NamedNodeMap nAtt = nm.getAttributes();
				Node ne = nAtt.getNamedItem("ObjRef");
				String value = ne.getNodeValue().toLowerCase().trim();
				if (hmXmlIdMetaId.containsKey(value)) {
					String metadId = (String) hmXmlIdMetaId.get(value);
					ne.setNodeValue(metadId);
				}
			}
		}
	}
	
	// method to convert Document to String
	public String getStringFromDocument(Document doc) {
		try {
			DOMSource domSource = new DOMSource(doc);
			StringWriter writer = new StringWriter();
			StreamResult result = new StreamResult(writer);
			TransformerFactory tf = TransformerFactory.newInstance();
			Transformer transformer = tf.newTransformer();
			transformer.transform(domSource, result);
			return writer.toString();
		} catch (TransformerException ex) {
			a.error(ex.getMessage());
			ex.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: " + ex.getMessage());
		} catch (Exception e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("General ERROR in getStringFromDocument: "
					+ e.getMessage());
		}
		return null;
	}

	private void removeNodes(List lstNodeDel) {

		if (lstNodeDel.size() > 0) {
			for (int idel = 0; idel < lstNodeDel.size(); idel++) {
				Node n = (Node) lstNodeDel.get(idel);
				NodeList slChi = n.getChildNodes();

				if (n != null && n.getParentNode() != null) {
					n.getParentNode().removeChild(n);

				}
			}
		}
	}

	 /** ProcessLibrary - It creates two collection hmXmlLibInfo - Maps xml Id
	 * and Name of the Library hmXmlIdMetaId - Maps xml Id and Metadata Id of
	 * the object
	 */

	private void ProcessLibrary(NodeList nlSASLibrary, List lstNodeDel) 
	{  
		Node nName = null;
		Node nId = null;
		Node nLib = null;
		hmXmlLibInfo = new HashMap();
		//hmXmlIdMetaId = new HashMap();

		for (int iLib = 0; iLib < nlSASLibrary.getLength(); iLib++) {
			nLib = nlSASLibrary.item(iLib);
			if (nLib.getNodeType() == Node.ELEMENT_NODE && checkNodeType(nLib)) {
				lstNodeDel.add(nLib);
				if (nLib.hasAttributes()) {
					// get all the attributes of a library nlib
					NamedNodeMap nnmAttr = nLib.getAttributes();
					// get name and id 
					nName = nnmAttr.getNamedItem("Name");
					nId = nnmAttr.getNamedItem("Id");
					String sLibId = nId.getNodeValue().toLowerCase();
					String sLibName = nName.getNodeValue().toLowerCase();
					// populate map with name and id of library from xml
					hmXmlLibInfo.put(sLibId.trim(), sLibName.trim());
                  //populate map with name and id of library hmLibInfo (id of library for foundation repository)
					hmXmlIdMetaId.put(sLibId.trim(), getLibID(sLibName));
				}
			}
		}
	}

	private void ProcessModel(NodeList nlModel, List lstNodeDel) {
		Node nName = null;
		Node nId = null;

		Node nModel = null;
		int n = 0;
		
		for (int iModel = 0; iModel < nlModel.getLength(); iModel++) {
			nModel = nlModel.item(iModel);
			
			if (nModel.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nModel)) {
				lstNodeDel.add(nModel);
				if (nModel.hasAttributes()) {
					NamedNodeMap nnmAttr = nModel.getAttributes();
					nName = nnmAttr.getNamedItem("Name");
					List objs = cProcessTree.getTreeInfoObjects("MiningResult",
							reposid, "<XMLSelect search=\"MiningResult[@Name='"
									+ nName.getNodeValue() + "']\"/>");
					String modelid = "";
					if (objs.size() > 0) {
						CMetadata cm3 = (CMetadata) objs.get(0);
						modelid = cm3.getId();
						nId = nnmAttr.getNamedItem("Id");
						String sModelId = nId.getNodeValue().toLowerCase();
						hmXmlIdMetaId.put(sModelId.trim(), modelid);
					} else {
						lstNodeDel.remove(nModel);
					}
				}
			}
		}
	}

	private void ProcessSchema(NodeList nlSchema, List lstNodeDel) {
		Node nName = null;
		Node nId = null;
		Node nSchema = null;
		String libName = "";

		for (int iLib = 0; iLib < nlSchema.getLength(); iLib++) {
			nSchema = nlSchema.item(iLib);
			if (nSchema.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nSchema)) {
				lstNodeDel.add(nSchema);
				// a.b("ToDelete Size After Schema : "+lstNodeDel.size());
				NodeList nlSchemaChild = nSchema.getChildNodes();
				for (int l = 0; l < nlSchemaChild.getLength(); l++) {
					Node nSchemaChild = nlSchemaChild.item(l);
					if (nSchemaChild.getNodeType() == Node.ELEMENT_NODE
							&& "UsedByPackages".equalsIgnoreCase(nSchemaChild
									.getNodeName())) {
						NodeList nlSchemaPkgChilds = nSchemaChild
								.getChildNodes();
						for (int ipkg = 0; ipkg < nlSchemaPkgChilds.getLength(); ipkg++) {
							Node nPkg = nlSchemaPkgChilds.item(ipkg);
							if (nPkg.getNodeType() == Node.ELEMENT_NODE
									&& "SASLibrary".equalsIgnoreCase(nPkg
											.getNodeName())
									&& nPkg.hasAttributes()) {
								NamedNodeMap nnmPkgAttr = nPkg.getAttributes();
								Node refNode = nnmPkgAttr
										.getNamedItem("ObjRef");
								String libId = refNode.getNodeValue();
								if (hmXmlLibInfo.containsKey(libId.trim())) {
									libName = (String) hmXmlLibInfo.get(libId
											.trim());
									// a.b("Library Name: " + libName);

								}
							}
						}
					}
				}

				if (nSchema.hasAttributes()) {
					NamedNodeMap nnmAttr = nSchema.getAttributes();
					nName = nnmAttr.getNamedItem("Name");
					nId = nnmAttr.getNamedItem("Id");
					String sSchemaId = nId.getNodeValue().toLowerCase();
					String sSchemaName = nName.getNodeValue().toLowerCase();
					hmXmlLibInfo.put(sSchemaId.trim(), libName);
					hmXmlIdMetaId.put(sSchemaId.trim(),
							getSchemaMetaID(sSchemaName));
				}
			}
		}
	}

	/**
	 * Remove the key nodes if the keys are already created
	 * @param nlKeys - list of key nodes
	 * @param lstNodeDel - list containing the nodes to be deleted
	 */
	private void ProcessKeys(NodeList nlKeys, List lstNodeDel)
	{
		Node nKey = null;

		for (int iKey = 0; iKey < nlKeys.getLength(); iKey++)
		{
			nKey = nlKeys.item(iKey);
			if (nKey.getNodeType() == Node.ELEMENT_NODE && checkNodeType(nKey))
			{
				NodeList nlKeyChildren = nKey.getChildNodes();
				for(int iKeyChild=0; iKeyChild < nlKeyChildren.getLength(); iKeyChild++)
				{
					Node nKeyChild = nlKeyChildren.item(iKeyChild);
					if (nKeyChild.getNodeType() == Node.ELEMENT_NODE &&
							"KeyedColumns".equalsIgnoreCase(nKeyChild.getNodeName()))
					{
						NodeList nlColumns = nKeyChild.getChildNodes();
						for(int iCol=0; iCol < nlColumns.getLength(); iCol++)
						{
							Node nColumn = nlColumns.item(iCol);
							NamedNodeMap nnmColumnAttr = nColumn.getAttributes();
							Node refNode = nnmColumnAttr.getNamedItem("ObjRef");
							String strColId = refNode.getNodeValue();
							// if keyed column is present in hmColumnWithKeys
							if (hmColumnsWithKeys.containsKey(strColId.trim()))
							{
								// add this key to delete list
								lstNodeDel.add(nKey);
								// add the associted propertysets to delete list
								RemovePropertySets(nKey, lstNodeDel);
							}
						}
					}
				}
			}
		}
	}

	/**
	 * Removes the property sets associated with given key
	 * @param nKey - key node being deleted
	 * @param lstNodeDel - list containing the nodes to be deleted
	 */
	private void RemovePropertySets(Node nKey, List lstNodeDel)
	{
		if (nKey.getNodeType() == Node.ELEMENT_NODE && checkNodeType(nKey))
		{
			NodeList nlKeyChildren = nKey.getChildNodes();
			for(int iKeyChild=0; iKeyChild < nlKeyChildren.getLength(); iKeyChild++)
			{
				Node nKeyChild = nlKeyChildren.item(iKeyChild);
				if (nKeyChild.getNodeType() == Node.ELEMENT_NODE &&
						"PropertySets".equalsIgnoreCase(nKeyChild.getNodeName()))
				{
					NodeList nlPropertySets = nKeyChild.getChildNodes();
					for(int iPS=0; iPS < nlPropertySets.getLength(); iPS++)
					{
						Node nPropertySet = nlPropertySets.item(iPS);
						NamedNodeMap nnmPSAttr = nPropertySet.getAttributes();
						Node refNode = nnmPSAttr.getNamedItem("ObjRef");
						String strPSId = refNode.getNodeValue();
						// Get all the propertyset nodes
						if(hmPropertyNodes.containsKey(strPSId.toLowerCase().trim()))
						{
							Node nPSNode = (Node)hmPropertyNodes.get(strPSId.toLowerCase().trim());
							lstNodeDel.add(nPSNode);
							RemoveProperties(nPSNode, lstNodeDel);
						}
					}
				}
			}
		}
	}
	
	/**
	 * Removes the properties associated with given PropertySet
	 * @param nKey - key node being deleted
	 * @param lstNodeDel - list containing the nodes to be deleted
	 */
	private void RemoveProperties(Node nPropertySet, List lstNodeDel)
	{
		if (nPropertySet.getNodeType() == Node.ELEMENT_NODE && checkNodeType(nPropertySet))
		{
			NodeList nlPSChildren = nPropertySet.getChildNodes();
			for(int iPSChild=0; iPSChild < nlPSChildren.getLength(); iPSChild++)
			{
				Node nPSChild = nlPSChildren.item(iPSChild);
				if (nPSChild.getNodeType() == Node.ELEMENT_NODE &&
						"SetProperties".equalsIgnoreCase(nPSChild.getNodeName()))
				{
					NodeList nlProperties = nPSChild.getChildNodes();
					for(int iProp=0; iProp < nlProperties.getLength(); iProp++)
					{
						Node nProperty = nlProperties.item(iProp);
						NamedNodeMap nnmAttr = nProperty.getAttributes();
						Node refNode = nnmAttr.getNamedItem("ObjRef");
						String strId = refNode.getNodeValue();
						// Get all the propertyset nodes
						if(hmPropertyNodes.containsKey(strId.toLowerCase().trim()))
						{
							Node nPropertyNode = (Node)hmPropertyNodes.get(strId.toLowerCase().trim());
							lstNodeDel.add(nPropertyNode);
							RemovePropertyTypes(nPropertyNode, lstNodeDel);
						}
					}
				}
			}
		}
	}
	
	/**
	 * Removes the properties associated with given PropertySet
	 * @param nKey - key node being deleted
	 * @param lstNodeDel - list containing the nodes to be deleted
	 */
	private void RemovePropertyTypes(Node nProperty, List lstNodeDel)
	{
		if (nProperty.getNodeType() == Node.ELEMENT_NODE && checkNodeType(nProperty))
		{
			NodeList nlPropChildren = nProperty.getChildNodes();
			for(int iPropChild=0; iPropChild < nlPropChildren.getLength(); iPropChild++)
			{
				Node nChild = nlPropChildren.item(iPropChild);
				if (nChild.getNodeType() == Node.ELEMENT_NODE &&
						"OwningType".equalsIgnoreCase(nChild.getNodeName()))
				{
					NodeList nlPropertyTypes = nChild.getChildNodes();
					for(int iPropType=0; iPropType < nlPropertyTypes.getLength(); iPropType++)
					{
						Node nPropertyType = nlPropertyTypes.item(iPropType);
						NamedNodeMap nnmAttr = nPropertyType.getAttributes();
						Node refNode = nnmAttr.getNamedItem("ObjRef");
						String strId = refNode.getNodeValue();
						// Get all the propertyset nodes
						if(hmPropertyNodes.containsKey(strId.toLowerCase().trim()))
						{
							Node nPropertyTypeNode = (Node)hmPropertyNodes.get(strId.toLowerCase().trim());
							lstNodeDel.add(nPropertyTypeNode);
						}
					}
				}
			}
		}
	}
	
	private void CollectOtherDeltree(NodeList nlTree, List lstNodeDel) {
		Node nT = null;
		// int n=0;
		for (int iT = 0; iT < nlTree.getLength(); iT++) {
			nT = nlTree.item(iT);
			if ("Tree".equalsIgnoreCase(nT.getNodeName())
					&& nT.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nT)) {
				lstNodeDel.add(nT);
			}
		}
		// a.b("Total Lib: " +n);
	}
	
	private void CollectOtherDel(NodeList nlTree, List lstNodeDel) {
		Node nT = null;
		// int n=0;
		for (int iT = 0; iT < nlTree.getLength(); iT++) {
			nT = nlTree.item(iT);
			if ("Tree".equalsIgnoreCase(nT.getNodeName())
					&& nT.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nT)) {
				lstNodeDel.add(nT);
			} else if (nT.getNodeType() == Node.ELEMENT_NODE) {
				lstNodeDel.add(nT);
			}
		}
		// a.b("Total Lib: " +n);
	}

	private void ProcessTables(NodeList nlPhysicalTable, List lstNodeDel) {
		Node nTable = null;
		Node nName1 = null;
		Node nId = null;
		Node nName2 = null;
		Node nId2 = null;
		hmXmlTableInfo = new HashMap();
		hmXmlTableLibMapInfo = new HashMap();
		hmXmlAllTableInfo = new HashMap();
		lstTableList = new Vector();
				
		try {			
			
			for (int iLib = 0; iLib < nlPhysicalTable.getLength(); iLib++) 
			{
			    // get the table from nodelist
				nTable = nlPhysicalTable.item(iLib);
				
				//If the table is element node  and it has childs put the node to hashMap
				 if (nTable.getNodeType() == Node.ELEMENT_NODE
						&& checkNodeType(nTable))
					{				
					lstNodeDel.add(nTable);
										
					if (nTable.hasAttributes()) 
					{					
						NamedNodeMap nnmAttr = nTable.getAttributes();
						nName1 = nnmAttr.getNamedItem("Name"); // table name (ex :Name="ACCOUNT_DIM")
						nId = nnmAttr.getNamedItem("Id"); // id from xml file (ex: Id="$264")
										
						String sTableId = nId.getNodeValue().toLowerCase(); // $264
						String sTableName = nName1.getNodeValue().toLowerCase(); // ACCOUNT_DIM
										
						// Table ID and TAble NAme 
						hmXmlTableInfo.put(sTableId.trim(), sTableName.trim());
					
						lstTableList.add(sTableId.trim());
						
						// get the Id of Library ex: for this table $201
						
						String LibId = getTableLibIdName(nTable).toLowerCase();
						
						// put TableID and Library ID in a map
						hmXmlTableLibMapInfo.put(sTableId.trim(), LibId.trim());
						
						// get the name of the Library from map ex: Dimensions
						
						String LibNm = (String) hmXmlLibInfo.get(LibId.trim());
						
						// put  TableName/LibName and ID in the map
						hmXmlAllTableInfo.put(sTableName.trim() + "/"
								+ LibNm.trim(), sTableId.trim());
					}				
				}				 
			}
		} catch (Exception e) {
			a.errorMessage(e.getMessage(), "General Error");
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("Exception occurred in ProcessTables: "
					+ e.getMessage());
		}
	}

	private void ProcessExternalTable(NodeList nlExternalTable,
			NodeList nlFile, List lstNodeDel) {
		Node nExternalTable = null;
		Node nName1 = null;
		Node nId = null;
		for (int iLib = 0; iLib < nlExternalTable.getLength(); iLib++) {
			nExternalTable = nlExternalTable.item(iLib);
			
			// checkNodeType(nTable));
			if (nExternalTable.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nExternalTable)) {
				if (nExternalTable.hasAttributes()) {
					NamedNodeMap nnmAttr = nExternalTable.getAttributes();
					nName1 = nnmAttr.getNamedItem("Name");
					nId = nnmAttr.getNamedItem("Id");
					String sExternalTableId = nId.getNodeValue().toLowerCase();
					String sExternalTableName = nName1.getNodeValue()
							.toLowerCase();
					String strExternalTableId = "NOID";
					strExternalTableId = isExternalTableExists(sExternalTableName);
					if (!"NOID".equalsIgnoreCase(strExternalTableId)) {
						lstNodeDel.add(nExternalTable);
						Node nFile = getReleventFileNode(nlFile,
								sExternalTableId);
						lstNodeDel.add(nFile);
						hmXmlIdMetaId.put(sExternalTableId.toLowerCase(),
								strExternalTableId);
					}
				}
			}
		}
	}

	private Node getReleventFileNode(NodeList nlFile, String sExternalTableId) {
		Node nFile = null;
		for (int iFile = 0; iFile < nlFile.getLength(); iFile++) {
			nFile = nlFile.item(iFile);
			if (nFile.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nFile)) {
				NodeList nlFileChilds = nFile.getChildNodes();
				for (int iFile1 = 0; iFile1 < nlFileChilds.getLength(); iFile1++) {
					Node nFileChilds = nlFileChilds.item(iFile1);
					if ("AssociatedExternalTable".equalsIgnoreCase(nFileChilds
							.getNodeName())) {
						NodeList nlMoreChilds = nFileChilds.getChildNodes();
						for (int iFile2 = 0; iFile2 < nlMoreChilds.getLength(); iFile2++) {
							Node nMoreChilds = nlMoreChilds.item(iFile2);
							if ("ExternalTable".equalsIgnoreCase(nMoreChilds
									.getNodeName())) {
								NamedNodeMap nnmFileNodes = nMoreChilds
										.getAttributes();
								Node nObjRef = nnmFileNodes
										.getNamedItem("ObjRef");
								if (sExternalTableId.equalsIgnoreCase(nObjRef
										.getNodeValue())) {
									iFile1 = nlFileChilds.getLength() + 1;
									iFile = nlFile.getLength() + 1;
									break;
								}
							}
						}
					}
				}
			}
		}
		return nFile;
	}

	private String isExternalTableExists(String fileName) {
		String XMLSelect = "<XMLSelect search=\"ExternalTable[@Name='"
				+ fileName + "']\"/>";
		String retVal = "NOID";
		try {
			List FileList = MetadataUtil.getMetadataObjects(reposid,
					"ExternalTable", MetadataUtil.OMI_ALL
							| MetadataUtil.OMI_XMLSELECT, XMLSelect);
			if (FileList.size() > 0) {
				CMetadata cmID = (CMetadata) FileList.get(0);
				retVal = cmID.getId();
			}
		} catch (MdException e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
		}
		return retVal;
	}

	private void ProcessColumns(NodeList nlColumn, NodeList nlPhysicalTable,
			NodeList nlSASLibrary, List lstNodeDel)
	{
		Node nName = null;
		Node nId = null;
		hmXmlAllColInfo = new HashMap();
		String ColName = "";
		String ColId = "";
		String TabName = "";
		String TabId = "";
		String LibName = "";
		String LibId = "";
		
		for (int iColumn = 0; iColumn < nlColumn.getLength(); iColumn++) 
		{
			Node nColumn = nlColumn.item(iColumn);
			// get first column	and get its ID and Name		
			if (nColumn.getNodeType() == Node.ELEMENT_NODE
					&& checkNodeType(nColumn) && checkTableType(nColumn)) {
				
				lstNodeDel.add(nColumn);
				if (nColumn.hasAttributes())
				{
					NamedNodeMap nnmAttr = nColumn.getAttributes();
					nName = nnmAttr.getNamedItem("Name");
					nId = nnmAttr.getNamedItem("Id");
					ColName = nName.getNodeValue().toLowerCase().trim();
					ColId = nId.getNodeValue().toLowerCase().trim();
				}
				NodeList nlColumnChildNode = nColumn.getChildNodes();
				
				for (int l = 0; l < nlColumnChildNode.getLength(); l++) 
					{
					  Node nColumnChildNode = nlColumnChildNode.item(l);
					  if (nColumnChildNode.getNodeType() == Node.ELEMENT_NODE)
					  			
					  {
						if ("Table".equalsIgnoreCase(nColumnChildNode
								.getNodeName())) 
						{  // get Table
							NodeList nlPhysicalTableNode = nColumnChildNode
									.getChildNodes();
							// for each table get the Table name 
							for (int b = 0; b < nlPhysicalTableNode.getLength(); b++) {
								Node n = nlPhysicalTableNode.item(b);
								Node n1 = null;
								if (n.getNodeType() == Node.ELEMENT_NODE) {
									if ("PhysicalTable".equalsIgnoreCase(n
											.getNodeName())) {
										if (n.hasAttributes()) {
											NamedNodeMap nnm = n.getAttributes();
											n1 = nnm.getNamedItem("ObjRef");
											
											TabId = n1.getNodeValue().toLowerCase();
											TabName = (String) hmXmlTableInfo.get(TabId.trim());
											LibId = (String) hmXmlTableLibMapInfo.get(TabId.trim());
											LibName = (String) hmXmlLibInfo.get(LibId.trim());

											// put columnName/tableName/LibraryName
											hmXmlAllColInfo.put(ColName.trim()
													+ "/" + TabName.trim()
													+ "/" + LibName.trim(),
													ColId.trim());
										}
									}
								}
							}
						}// enf of IF for tabled as child node
					}

				}// end of Tablechild node for loop
			}// check type of node
			
		}
		
	}

	/**
	 * Returns Library's XML id to which the table is pointing, and also
	 * attaches 'S' or 'D' to the Lib Id depending on type of the Librar
	 * 
	 * @param nTable
	 * @return
	 */

	private String getTableLibIdName(Node nTable) 
	{
		String id = "";
	
		NodeList nlTableChild = nTable.getChildNodes();
		for (int l = 0; l < nlTableChild.getLength(); l++) 
		{
			Node nTableChild = nlTableChild.item(l);
			// go to "TablePackage" node --refernce to Library exists in PhysicalTabls node TablePackage  
			if (nTableChild.getNodeType() == Node.ELEMENT_NODE&& "TablePackage".equalsIgnoreCase(nTableChild.getNodeName())) {
				// get the SASLibrary
				Node nPkg = nTableChild.getFirstChild();
				// get the objectRefernce to library
				if (nPkg.getNodeType() == Node.ELEMENT_NODE
						&& nPkg.hasAttributes()) 
				{
					NamedNodeMap nnmPkgAttr = nPkg.getAttributes();
					Node RetNode = nnmPkgAttr.getNamedItem("ObjRef");
					id = RetNode.getNodeValue(); 
					break;
				}
			}
		}
		return id;
	}

	/**
	 * Returns True if the Node is ParentNode, i.e. if the node has at least one
	 * Child, false otherwise...
	 */

	private boolean checkNodeType(Node nCheckNode) {
		// boolean retVal = false;
		// NodeList n = nCheckNode.getChildNodes();
		// if(n.getLength() > 0)
		// retVal = true;

		return nCheckNode.hasChildNodes();
	}

	private void ProcessJob(NodeList nlJobs, boolean bUpdate) {

		for (int iJob = 0; iJob < nlJobs.getLength(); iJob++) {
			Node nJobs = nlJobs.item(iJob);
			
			if (nJobs.getNodeType() == Node.ELEMENT_NODE & checkNodeType(nJobs))
			{
				// if bUpdate is true if the job is in the list of jobsToUpdate
				if (bUpdate) 
				{
					// Check if job exists and get the metadata id
					NamedNodeMap nnmAttr = nJobs.getAttributes();
					Node nName1 = nnmAttr.getNamedItem("Name");
					Node nId = nnmAttr.getNamedItem("Id");
					String xmlJobId = nId.getNodeValue().toLowerCase();
					String strXMLSelect = "<XMLSelect Search=\"@Name='"
							+ nName1.getNodeValue() + "'\"/>";
					List lstJobs = cUtilityClass.getObjects(strXMLSelect,
							"Job", reposid);
					if (lstJobs.size() > 0) {
						String mdJobId = ((CMetadata) lstJobs.get(0)).getId();
						hmXmlIdMetaId.put(xmlJobId, mdJobId);
						lstNodeDel.add(nJobs);
					}
				}

				NodeList nlJobChilds = nJobs.getChildNodes();
				
				for (int l = 0; l < nlJobChilds.getLength(); l++) 
				{
					Node nJobChilds = nlJobChilds.item(l);
					if (nJobChilds.getNodeType() == Node.ELEMENT_NODE) {
						if ("Trees".equalsIgnoreCase(nJobChilds.getNodeName())) {
							Node n = nJobChilds.getFirstChild();
							if (n != null) {
								if (n.hasAttributes()) {
									NamedNodeMap nnmPhyTablesAttr = n
											.getAttributes();
									Node nTabAttrValue = nnmPhyTablesAttr
											.getNamedItem("ObjRef");
									JobInitTree = nTabAttrValue.getNodeValue();
									break;
									// a.b("in proc job tree ObjRef "
									// +JobInitTree);
								}// end of attribute check
							}
						}// enf of IF for tabled as child node
					}
				}
			}
		}
	}

	/**
	 * Fill the hashmaps with node id and nodes
	 * @param nlNodeList
	 */
	private void FillNodesInHashMap(NodeList nlNodeList)
	{
		for(int iNode=0; iNode < nlNodeList.getLength(); iNode++)
		{
			Node nNode = nlNodeList.item(iNode);
			if ((nNode.getNodeType() == Node.ELEMENT_NODE) && checkNodeType(nNode))
			{
				NamedNodeMap nnmAttr = nNode.getAttributes();
				Node nAttrValue = nnmAttr.getNamedItem("Id");
				if(nAttrValue != null)
				{
					String strId = nAttrValue.getNodeValue();
					hmPropertyNodes.put(strId.toLowerCase().trim(), nNode);
				}
			}
		}
	}

	private void ProcessXMLTree(NodeList nlTrees, List lstNodeDel) {
		hmTreeIdName = new HashMap();
		hmTreeIdParId = new HashMap();

		for (int iTree = 0; iTree < nlTrees.getLength(); iTree++) {
			Node nTreeNode = nlTrees.item(iTree);
			Node nName = null;
			Node nId = null;
			
			if ((nTreeNode.getNodeType() == Node.ELEMENT_NODE)
					&& checkNodeType(nTreeNode)) {
				lstNodeDel.add(nTreeNode);
			
				if (nTreeNode.hasAttributes()) {
					NamedNodeMap nnmAttr = nTreeNode.getAttributes();
					nName = nnmAttr.getNamedItem("Name");
					nId = nnmAttr.getNamedItem("Id");
					hmTreeIdName.put(nId.getNodeValue(), nName.getNodeValue());
			
				}
				if (!nName.getNodeValue().equalsIgnoreCase("ETL Studio Custom Tree")
						&& !nName.getNodeValue().equalsIgnoreCase("SAS Data Integration Studio Custom Tree")) 
				{
					NodeList nlTreeChiNode = nTreeNode.getChildNodes();
					for (int l = 0; l < nlTreeChiNode.getLength(); l++) {
						Node nTreeChiNode = nlTreeChiNode.item(l);
						
						if ("ParentTree".equalsIgnoreCase(nTreeChiNode
								.getNodeName())) {
						
							NodeList nl = nTreeChiNode.getChildNodes();
							for (int w = 0; w < nl.getLength(); w++) {
								Node nParNode = nl.item(w);
								if (nParNode != null) {
									if ("Tree".equalsIgnoreCase(nParNode
											.getNodeName())) {
									
										if (nParNode.hasAttributes()) {
											NamedNodeMap nnmTreeChiAttr = nParNode
													.getAttributes();
											Node nParentTree = nnmTreeChiAttr
													.getNamedItem("ObjRef");
									
											hmTreeIdParId.put(nId
													.getNodeValue(),
													nParentTree.getNodeValue());
											break;
										}// end of attribute check
									}
								}
							}
						}// enf of IF for tabled as child node
					}// end of Librarychild node for loop
				} else {
					hmTreeIdParId.put(nId.getNodeValue(), "X");
				}
				// treecnt++;

			}// check of type of Node e.g ELEMENT_NODE

		}// All Tree one by One (One Finish)
	}

	private boolean checkTableType(Node nColumn) {
		boolean retVal = false;
		
		NodeList nlColumnsChild = nColumn.getChildNodes();
		for (int l = 0; l < nlColumnsChild.getLength(); l++) {
			Node nChiNode = nlColumnsChild.item(l);
			if ("Table".equalsIgnoreCase(nChiNode.getNodeName())) {
				Node n = nChiNode.getFirstChild();
				// a.b("inside checkTable "+ n.getNodeName());
				if ("PhysicalTable".equalsIgnoreCase(n.getNodeName())) {
					retVal = true;
					break;
				}
			}// enf of IF for tabled as child node
		}// end of Tablechild node for loop
		return retVal;
	}

	/**
	 * Return Complete Tree structure, delimited by "==" upto top most parent
	 * 
	 */

	private String getJobTree(String InitialTree) {

		boolean flag = true;
		String baseName = "";
		String parentId = "";
		String RequiredTree = InitialTree;

		StringBuffer sbTree = new StringBuffer(500);
		while (flag) {
			baseName = (String) hmTreeIdName.get(RequiredTree);
			parentId = (String) hmTreeIdParId.get(RequiredTree);
			if (baseName == null || parentId == null)
				break;

			if (m_bDIStudioFlag	&& baseName.equalsIgnoreCase("etl studio custom tree"))
				baseName = "sas data integration studio custom tree";
			if (!m_bDIStudioFlag && baseName.equalsIgnoreCase("sas data integration studio custom tree"))
				baseName = "etl studio custom tree";

			sbTree.append(baseName);

			if ("X".equalsIgnoreCase(parentId))
			{		
				break;
			} else {
				RequiredTree = parentId;
			}
			baseName = (String) hmTreeIdName.get(RequiredTree);

			sbTree.append("==");
			
		}// end of while
	
		return sbTree.toString();// finally assigning new tree value
	}

	private void fetchMetadataInfo(String jobName, OpRequestUI oprequestui) 
	{
		for (int tbl = 0; tbl < lstTableList.size(); tbl++) 
		{
			try {
				String Tableid = (String) lstTableList.get(tbl);
				String TableName = (String) hmXmlTableInfo.get(Tableid);
				String LibId = (String) hmXmlTableLibMapInfo.get(Tableid);
				String LibName = (String) hmXmlLibInfo.get(LibId);

				String XMLSelect = "";
				String newLibName = cUtilityClass.MoreResolveTexttoHash(cUtilityClass
								.UnresolveName(LibName));
				String newTableName = cUtilityClass	.MoreResolveTexttoHash(cUtilityClass
								.UnresolveName(TableName));
				/*
				 * 22Aug2007 -- Prachi & Anil -- If table exists in
				 * hmXmlIdMetaId then no need to find anything more, eventhe
				 * column collection would exist!
				 */
				String sTableFullName = TableName + "/"+ cUtilityClass.changeReferenceTo(newLibName);
//				if (hmXmlAllTableInfo.containsKey(sTableFullName.toLowerCase().trim()))
//				{
//					String s = (String) hmXmlAllTableInfo.get(sTableFullName
//							.toLowerCase().trim());
//					if (hmXmlIdMetaId.containsValue(s.toLowerCase().trim()))
//						return;
//				}

				/*
				 * 22Aug2007 -- Prachi & Anil -- change Ends
				 */
				
				oprequestui.setMessage("Preparing Query for PhysicalTable");
				String libEngine = getLibEngine(newLibName);
				
				if ((LibName == null) || ("".equalsIgnoreCase(LibName))) 
				{
					XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='"
							+ newTableName + "']\"/>";
				} else {
					if ("S".equalsIgnoreCase(libEngine)) 
					{
						XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='"
								+ newTableName
								+ "'][TablePackage/SASLibrary[@Name='"
								+ newLibName + "']]\"/>";
					} else {
						int schemaStart = libEngine.indexOf("###___Schema: ")
								+ "###___Schema: ".length();
						String targetSchema = libEngine.substring(schemaStart);
						XMLSelect = "<XMLSelect search=\"PhysicalTable[@Name='"
								+ newTableName
								+ "']/TablePackage/DatabaseSchema[@Name='"
								+ targetSchema + "']]\"/>";
					}
				}
				oprequestui.setMessage("Fetching PhysicalTable Information");
				
				try {
					   List PhysicalTableList = MetadataUtil.getMetadataObjects(
							reposid, "PhysicalTable", MetadataUtil.OMI_ALL
									| MetadataUtil.OMI_XMLSELECT
									| MetadataUtil.OMI_GET_METADATA, XMLSelect);
										  
					   if (PhysicalTableList.size() > 0) 
					   {						
						CMetadata Table = (CMetadata) PhysicalTableList.get(0);
						sTableFullName = TableName + "/"+ cUtilityClass.changeReferenceTo(newLibName);
						
						if (hmXmlAllTableInfo.containsKey(sTableFullName.toLowerCase().trim()))
						{					
							String s = (String) hmXmlAllTableInfo.get(sTableFullName.toLowerCase().trim());
							hmXmlIdMetaId.put(s.toLowerCase().trim(), Table.getId().trim());
						}
						oprequestui.setMessage("Getting Columns Information");
					        getTableColumns(Table, LibName, oprequestui);

					} /* Table found in getMetadataObjects() */
					else {
						a.error("Table: '"+ TableName+ "' does not exists in the \nenvironment for '"
										+ jobName + "' Job");
						cUtilityClass.WriteLog("ERROR: For Job " + jobName
								+ ",   " + TableName + " is required");
					}
					PhysicalTableList.clear();
				} catch (MdException e) {
					cUtilityClass.WriteLog("ERROR: For Job " + jobName + ",   "
							+ TableName + " is required");
					e.printStackTrace(System.err);
					a.error("For Job " + jobName + ",   " + TableName
							+ " is required\n" + e.getMessage());
				} catch (Exception e) {
					cUtilityClass.WriteLog("ERROR: For Job " + jobName + ",   "
							+ TableName + " is required");
					a.error("For Job " + jobName + ",   " + TableName
							+ " is required\n" + e.getMessage());
					e.printStackTrace(System.err);
				}
			  }
			catch (Exception e) {
				a.error(e.getMessage());
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("ERROR occurred while fetching metadata info for job "
								+ jobName + ": " + e.getMessage());
			}
		}		
	}

	private void getTableColumns(CMetadata cmTable, String LibName,
			OpRequestUI oprequestui) 
	{		
		MdObjectStore mdobjectstore = MdObjectFactory.createObjectStore();
				
		CMetadata cmetadata = MdObjectFactory.createComplexMetadataObject(
				mdobjectstore, cmTable);		
				
		AssociationList alColList = null;
		//int j = 0x8018c;
		//String template = "<Templates><PhysicalTable><Columns/></PhysicalTable><Column Id=\"\" Name=\"\" /></Templates>";
		oprequestui.setMessage("Top Up Table Object");
		
		// commented on 30Aug 2007 - Prachi
		
//		try {
//			cmetadata = MetadataUtil.getMetadataAllDepths(cmetadata,
//					new ArrayList(), new ArrayList(), template, j);
//		} catch (MdException e) {
//			cUtilityClass.WriteLog("ERROR: " + e.getMessage());
//			a.error(e.getMessage());
//			e.printStackTrace(System.err);
//		} catch (Exception e) {
//			cUtilityClass.WriteLog("ERROR: " + e.getMessage());
//			a.error(e.getMessage());
//			e.printStackTrace(System.err);
//		}

        PhysicalTable pt = (PhysicalTable) cmetadata;
     			
		try {alColList = pt.getColumns();
		} catch (MdException e2) {
			e2.printStackTrace(System.err);
		} catch (Exception e) {
			e.printStackTrace(System.err);
			a.error(e.getMessage());
		}
		
		oprequestui.setMessage("Iterating COlumn for XML Metadata collection");
		for (int q = 0; q < alColList.size(); q++) 
		{
			Column cl = (Column) alColList.get(q);			
			
			String ColumnFullName = cl.getName() + "/" + cmTable.getName() + "/" + LibName;
				
			if (hmXmlAllColInfo.containsKey(ColumnFullName.toLowerCase().trim())) 
			{
				// Get The column's XML id
				String s = (String) hmXmlAllColInfo.get(ColumnFullName.toLowerCase().trim());
				//Key=xml Id and Value=Metadata ID
				hmXmlIdMetaId.put(s.toLowerCase().trim(), cl.getId().trim());
				
				// Check if keys are already imported
				try {
					AssociationList alKeys = cl.getKeys();
					boolean bKeysPresent = false;
					for(int iKey=0; iKey < alKeys.size(); iKey++)
					{
						CMetadata cmKey = (CMetadata)alKeys.get(iKey);
						if("Key".equalsIgnoreCase(cmKey.getCMetadataType())
								|| "Key".equalsIgnoreCase(cmKey.getCMetadataType()))
						{
							bKeysPresent = true;
							break;
						}
					}
					if(bKeysPresent)
						hmColumnsWithKeys.put(s.toLowerCase().trim(),cl.getId());
				} catch (MdException e) {
					e.printStackTrace(System.err);
					a.error(e.getMessage());
				}
			}
		}
		alColList.clear();
		//Store disposed
	   mdobjectstore.dispose();		
	}// End of getTableColumns Method

	public void getLibs(String reposID) {
		try {
			hmLibInfo.clear();
			hmLibMetaInfo.clear();
			AssociationList packages = null;

			List SASLibraries = getInfoObjects("SASLibrary", reposID);

			if (SASLibraries.size() != 0) {
				for (int k = 0; k < SASLibraries.size(); k++) 
				{
					SASLibrary sl = (SASLibrary) SASLibraries.get(k);
					
					if ((sl != null)&&(!(hmLibInfo.containsKey(sl.getName().toLowerCase())))) {
						hmLibInfo.put(sl.getName().toLowerCase(), sl.getFQID());
						// Libraries in foundation which we had imported , and its FQID
						hmLibMetaInfo.put(sl.getName().toLowerCase(), sl);
						//put the name of library and library object
					}
				}
			}
		
		} catch (Exception e) {
			a.error("Error in getLibs: " + e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("Error in getLibs: " + e.getMessage());
		}
	}// End of getLibs

	public void getSchema(String reposID) {
		hmSchemaInfo.clear();
		hmSchemaMetaInfo.clear();
		List Schemas = getInfoObjects("DatabaseSchema", reposID);
		if (Schemas.size() != 0) {
			for (int k = 0; k < Schemas.size(); k++) {
				DatabaseSchema ds = (DatabaseSchema) Schemas.get(k);
				if (ds != null) {
					hmSchemaInfo.put(ds.getName().toLowerCase(), ds.getFQID());
					hmSchemaMetaInfo.put(ds.getName().toLowerCase(), ds);
				}
			}
		}
	}// End of getSchema

	private String getLibID(String libName) {
		String s = (String) hmLibInfo.get(libName.toLowerCase());
		return s;
	}

	private String getSchemaMetaID(String schemaName) {
		return (String) hmSchemaInfo.get(schemaName.toLowerCase());
	}

	/**
	 * return Metadata id for a tree(Tree chain up to top most tree delimited by
	 * "==")
	 */

	private String getTreeID(String TreeName)
	{
		String s = "";
		if (hmTreeInfo.containsKey(TreeName.toLowerCase())) {
			s = (String) hmTreeInfo.get(TreeName.toLowerCase());
		}
		return s;
	}

	private void getTree(String reposid) {
		try {
						
			hmTreeInfo.clear();
			String xmlSelect = "<XMLSelect search=\"Tree[Groups/Group[@Name='"
					+ "ETL Studio Groups' or @Name='Data Integration Studio Groups']]\"/>";
						
			List objs = cProcessTree.getTreeInfoObjects("Tree", reposid, "");
			
			Tree tr;						
			
			for (int l = 0; l < objs.size(); l++) 
			{
				tr = (Tree) objs.get(l);
				
				String s1 = cProcessTree.processTree(tr);
				
				
				if (s1.equalsIgnoreCase("SAS Data Integration Studio Custom Tree"))
					m_bDIStudioFlag = true;
				if ((s1 != null))
				{
					if (!hmTreeInfo.containsKey(s1.toLowerCase()))
					{
						hmTreeInfo.put(s1.toLowerCase(), tr.getFQID());
						String s2 = s1+ "==sas data integration studio custom tree";
						hmTreeInfo.put(s2.toLowerCase(), tr.getFQID());
						s2 = s1 + "==etl studio custom tree";
						hmTreeInfo.put(s2.toLowerCase(), tr.getFQID());
					}
				}
			
			}
		} catch (Exception e) {
			a.error("Error in getTree: " + e.getMessage());
			e.printStackTrace(System.err);
			
		}
	}// End of getTree

	private String getGroupID(String GroupName) {
		return (String) hmGroupInfo.get(GroupName.toLowerCase());
	}

	private void getGroup(String reposid) {
		hmGroupInfo.clear();
		List objs = getInfoObjects("Group", reposid);
		Group gr;
		for (int l = 0;l<objs.size();l++){
			gr = (Group)objs.get(l);
			if (gr.getName().equalsIgnoreCase("ETL Studio Groups")
					|| gr.getName().equalsIgnoreCase(
							"Data Integration Studio Groups")) {
				hmGroupInfo.put(gr.getName().toLowerCase(),gr.getFQID());
				break;
			}
		}//end for 
	}// end of method getGroup 
	
	
	public List getInfoObjects(String objTypes, String reposid) {
		MdObjectStore myStore = MdObjectFactory.createObjectStore();
		String XMLSelete = " ";

		if("Prototype".equalsIgnoreCase(objTypes)){ //$NON-NLS-1$
			XMLSelete = "<XMLSelect search=\"Prototype[@MetadataType='TransformationStep2']\"/><Templates><Prototype search=\"@TransformRole=''\"/></Templates>";
		}
		if ("SASLibrary".equalsIgnoreCase(objTypes)){
			XMLSelete = "<Templates><SASLibrary Id=\"\" Name=\"\" Engine=\"\"><UsingPackages/></SASLibrary></Templates>";
		}

		List Objects = null;
		try {
			Objects = (MetadataUtil.getMetadataObjectsSubset(myStore, reposid,
					objTypes, MetadataUtil.OMI_TEMPLATE
							| MetadataUtil.OMI_GET_METADATA
							| MetadataUtil.OMI_XMLSELECT, XMLSelete));
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
		}
		
		return Objects;
	}

	protected static String From(String filename) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(new FileReader(filename));
		String nextLine = "";
		StringBuffer sb = new StringBuffer();
		while ((nextLine = br.readLine()) != null) {
			sb.append(nextLine);
			sb.append(lineSep);
		}
		br.close();

		String s = sb.toString();
		if (m_bDIStudioFlag) {
			s = s.replaceAll("etl studio custom tree",
					"sas data integration studio custom tree");
			s = s.replaceAll("etl studio groups",
					"data integration studio groups");
			s = s.replaceAll("TreeType=\"Custom\"", "TreeType=\"BIP Folder\"");
			s = s.replaceAll("TreeType=\"SourceTables\"",
					"TreeType=\"BIP Folder\"");
			s = s.replaceAll("TreeType=\"DataMarts\"",
					"TreeType=\"BIP Folder\"");
			s = s.replaceAll("TreeType=\"Jobs\"", "TreeType=\"BIP Folder\"");
			s = s.replaceAll("TreeType=\"Documents\"",
					"TreeType=\"BIP Folder\"");
			s = s.replaceAll("TreeType=\"ExternalFiles\"",
					"TreeType=\"BIP Folder\"");
			s = s.replaceAll("TreeType=\"Notes\"", "TreeType=\"BIP Folder\"");

		} else {
			s = s.replaceAll("sas data integration studio custom tree",
					"etl studio custom tree");
			s = s.replaceAll("SAS Data Integration Studio Custom Tree",
					"ETL Studio Custom Tree");
			s = s.replaceAll("data integration studio groups",
					"etl studio groups");
			s = s.replaceAll("Data Integration Studio Groups",
					"ETL Studio Groups");
		}

		return s;
	}
	
	private Document import_object(String ProcString, String Name) {
		try {
			Document outDoc = MetadataUtil.DoRequest(ProcString);
			cUtilityClass.WriteLog(Name.toUpperCase() + " Created ");
			return outDoc;
		} catch (MdException e1) {
			a.error(e1.getMessage());
			cUtilityClass.WriteLog("MdException in import_object: "
					+ e1.getMessage());
			e1.printStackTrace(System.err);
		} catch (Exception e) {
			a.error (e.getMessage());
			cUtilityClass.WriteLog("Failed: " + e.getMessage());
			e.printStackTrace(System.err);
		}
		return null;
	}// End of import_object
	
	private void import_object(String ProcString) {
		try {
			MetadataUtil.DoRequest(ProcString);
		} catch (MdException e1) {
			a.error(e1.getMessage());
			cUtilityClass.WriteLog(e1.getMessage());
			e1.printStackTrace(System.err);
		} catch (Exception e) {
			a.error (e.getMessage());
			cUtilityClass.WriteLog("Failed: " + e.getMessage());
			e.printStackTrace(System.err);
		}
	}// End of import_object
	
	private static WAdminResource m_bundle;
	private WAWizardDialog m_parent;
	private ColumnsPanel m_columnsPanel;
	private PhysicalTable m_table;
	private Workspace m_workspace = Workspace.getWorkspace();
	
	
	
	HashMap hmXmlTableLibMapInfo;
	static HashMap hmXmlTableInfo;
	HashMap hmXmlLibInfo;
	
	HashMap hmXmlAllColInfo;
	HashMap hmXmlAllTableInfo;
	HashMap hmXmlIdMetaId = new HashMap();
	
	HashMap hmTreeIdName ;
	HashMap hmTreeIdParId;
	
	HashMap hmLibref;
	
	protected HashMap hmGroupInfo;

	protected String m_Path = "";
	protected String FinishString;

	protected String path;
	protected String reposid; 
	
	protected HashMap hmMetadataObjects;

	// Hashmaps containing IDs and/or objects from metadata
	protected HashMap hmTreeInfo; // (Key=TreeName, Value=Id)
	protected HashMap hmLibInfo; 	 // (Key=Libname, Value=Metadata Id)
	protected HashMap hmLibMetaInfo; // (Key=Libname, Value=LibraryObject)
	
	protected HashMap hmSchemaInfo;     // (Key=SchemaName, Value=Metadata Id)
	protected HashMap hmSchemaMetaInfo; // (Key=SchemaName, Value=SchemaObject)
	
	protected HashMap hmColumnsWithKeys;	// Key=XML Id, value=metadata id
	protected HashMap hmPropertyNodes;	// Key=XML Id, value=XML Node

	
	private HashMap hmLibraryEngine = new HashMap();
	protected HashMap hmTableIdentity;

	protected AppServer as;
	protected ServerContext sc;
	protected MdObjectStore mdobjectstore;
	
	static 
	{
		m_bundle = new WAdminResource(ObjChooseTab.class);
	}

	List lstNodeDel = new Vector();

	String JobInitTree;

	List lstTableList;
	
}// End of Class 
